#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 509
#define LARGE_STATE_COUNT 94
#define SYMBOL_COUNT 246
#define ALIAS_COUNT 1
#define TOKEN_COUNT 108
#define EXTERNAL_TOKEN_COUNT 7
#define FIELD_COUNT 9
#define MAX_ALIAS_SEQUENCE_LENGTH 6
#define PRODUCTION_ID_COUNT 22

enum {
  anon_sym_DQUOTE = 1,
  aux_sym_legacy_quoted_stmt_token1 = 2,
  anon_sym_TILDE = 3,
  sym_grep_specifier_identifier = 4,
  aux_sym_grep_specifier_token1 = 5,
  anon_sym_PIPE = 6,
  anon_sym_PIPEH = 7,
  anon_sym_AT_AT_DOT = 8,
  anon_sym_AT_AT_EQ = 9,
  anon_sym_AT_AT_AT_EQ = 10,
  anon_sym_AT_AT = 11,
  anon_sym_AT_ATc_COLON = 12,
  anon_sym_AT_AT_ATc_COLON = 13,
  anon_sym_AT_ATC = 14,
  anon_sym_COLON = 15,
  anon_sym_AT_ATdbt = 16,
  anon_sym_AT_ATdbta = 17,
  anon_sym_AT_ATdbtb = 18,
  anon_sym_AT_ATdbts = 19,
  anon_sym_AT_ATt = 20,
  anon_sym_AT_ATb = 21,
  anon_sym_AT_ATi = 22,
  anon_sym_AT_ATii = 23,
  anon_sym_AT_ATiS = 24,
  anon_sym_AT_ATiSS = 25,
  anon_sym_AT_ATis = 26,
  anon_sym_AT_ATiz = 27,
  anon_sym_AT_ATf = 28,
  anon_sym_AT_ATF = 29,
  anon_sym_AT_ATom = 30,
  anon_sym_AT_ATdm = 31,
  anon_sym_AT_ATr = 32,
  anon_sym_AT_ATs_COLON = 33,
  anon_sym_AT = 34,
  anon_sym_AT_BANG = 35,
  anon_sym_AT_LPAREN = 36,
  anon_sym_RPAREN = 37,
  anon_sym_ATa_COLON = 38,
  anon_sym_ATb_COLON = 39,
  anon_sym_ATB_COLON = 40,
  anon_sym_ATe_COLON = 41,
  anon_sym_ATF_COLON = 42,
  anon_sym_ATi_COLON = 43,
  anon_sym_ATk_COLON = 44,
  anon_sym_ATo_COLON = 45,
  anon_sym_ATr_COLON = 46,
  anon_sym_ATf_COLON = 47,
  anon_sym_ATs_COLON = 48,
  anon_sym_ATv_COLON = 49,
  anon_sym_ATx_COLON = 50,
  anon_sym_0 = 51,
  aux_sym_number_stmt_token1 = 52,
  aux_sym__search_stmt_token1 = 53,
  anon_sym_DOT = 54,
  aux_sym__interpret_stmt_token1 = 55,
  aux_sym__interpret_stmt_token2 = 56,
  aux_sym__interpret_stmt_token3 = 57,
  anon_sym_DOT_LPAREN = 58,
  anon_sym_PIPE_DOT = 59,
  anon_sym_DOT_SLASH = 60,
  anon_sym_pfo = 61,
  anon_sym_Cf = 62,
  sym_pf_dot_cmd_identifier = 63,
  sym_pf_dot_full_cmd_identifier = 64,
  aux_sym_pf_cmd_token1 = 65,
  anon_sym_EQ = 66,
  aux_sym__pf_dot_arg_identifier_token1 = 67,
  anon_sym_DOLLAR = 68,
  anon_sym_LPAREN = 69,
  aux_sym_pf_arg_identifier_token1 = 70,
  anon_sym_PERCENT = 71,
  anon_sym_env = 72,
  anon_sym_DOT_DOT_DOT = 73,
  sym_system_identifier = 74,
  sym_question_mark_identifier = 75,
  sym_pointer_identifier = 76,
  sym_macro_identifier = 77,
  anon_sym_SEMI = 78,
  anon_sym_GT = 79,
  anon_sym_GT_GT = 80,
  sym_html_redirect_operator = 81,
  sym_html_append_operator = 82,
  anon_sym_COMMA = 83,
  aux_sym_tmp_eval_arg_token1 = 84,
  sym__eq_sep_key_identifier = 85,
  aux_sym_arg_identifier_token1 = 86,
  aux_sym_spec_arg_identifier_token1 = 87,
  aux_sym_double_quoted_arg_token1 = 88,
  aux_sym_double_quoted_arg_token2 = 89,
  aux_sym_double_quoted_arg_token3 = 90,
  anon_sym_SQUOTE = 91,
  aux_sym_single_quoted_arg_token1 = 92,
  aux_sym_single_quoted_arg_token2 = 93,
  anon_sym_DOLLAR_LPAREN = 94,
  anon_sym_BQUOTE = 95,
  aux_sym__dec_number_token1 = 96,
  aux_sym__dec_number_token2 = 97,
  sym__comment = 98,
  anon_sym_LF = 99,
  anon_sym_CR = 100,
  sym__cmd_identifier = 101,
  sym__help_stmt = 102,
  sym_file_descriptor = 103,
  sym__eq_sep_concat = 104,
  sym__concat = 105,
  sym__concat_pf_dot = 106,
  sym__spec_sep = 107,
  sym_statements = 108,
  sym__statements_singleline = 109,
  sym__statement = 110,
  sym_legacy_quoted_stmt = 111,
  sym__simple_stmt = 112,
  sym__tmp_stmt = 113,
  sym__iter_stmt = 114,
  sym__pipe_stmt = 115,
  sym_grep_stmt = 116,
  sym_grep_specifier = 117,
  sym_html_disable_stmt = 118,
  sym_html_enable_stmt = 119,
  sym_pipe_stmt = 120,
  sym_iter_file_lines_stmt = 121,
  sym_iter_offsets_stmt = 122,
  sym_iter_offsetssizes_stmt = 123,
  sym_iter_hit_stmt = 124,
  sym_iter_interpret_stmt = 125,
  sym_iter_interpret_offsetssizes_stmt = 126,
  sym_iter_comment_stmt = 127,
  sym_iter_dbta_stmt = 128,
  sym_iter_dbtb_stmt = 129,
  sym_iter_dbts_stmt = 130,
  sym_iter_threads_stmt = 131,
  sym_iter_bbs_stmt = 132,
  sym_iter_instrs_stmt = 133,
  sym_iter_import_stmt = 134,
  sym_iter_sections_stmt = 135,
  sym_iter_segments_stmt = 136,
  sym_iter_symbol_stmt = 137,
  sym_iter_string_stmt = 138,
  sym_iter_flags_stmt = 139,
  sym_iter_function_stmt = 140,
  sym_iter_iomap_stmt = 141,
  sym_iter_dbgmap_stmt = 142,
  sym_iter_register_stmt = 143,
  sym_iter_step_stmt = 144,
  sym_tmp_seek_stmt = 145,
  sym_tmp_blksz_stmt = 146,
  sym_tmp_fromto_stmt = 147,
  sym_tmp_arch_stmt = 148,
  sym_tmp_bits_stmt = 149,
  sym_tmp_nthi_stmt = 150,
  sym_tmp_eval_stmt = 151,
  sym_tmp_fs_stmt = 152,
  sym_tmp_reli_stmt = 153,
  sym_tmp_kuery_stmt = 154,
  sym_tmp_fd_stmt = 155,
  sym_tmp_reg_stmt = 156,
  sym_tmp_file_stmt = 157,
  sym_tmp_string_stmt = 158,
  sym_tmp_value_stmt = 159,
  sym_tmp_hex_stmt = 160,
  sym_number_stmt = 161,
  sym_help_stmt = 162,
  sym_arged_stmt = 163,
  sym__simple_arged_stmt_question = 164,
  sym__simple_arged_stmt = 165,
  sym__search_stmt = 166,
  sym__math_arged_stmt = 167,
  sym__pointer_arged_stmt = 168,
  sym__macro_arged_stmt = 169,
  sym__system_stmt = 170,
  sym__interpret_stmt = 171,
  sym__interpret_search_identifier = 172,
  sym__pf_arged_stmt = 173,
  sym__pf_stmts = 174,
  sym_Cf_cmd = 175,
  sym__Cf_args = 176,
  sym_pf_new_cmd = 177,
  sym_pf_dot_cmd = 178,
  sym_pf_cmd = 179,
  sym_pf_new_args = 180,
  sym_pf_dot_cmd_args = 181,
  sym__pf_dot_arg_identifier = 182,
  sym__pf_arg_parentheses = 183,
  sym_pf_arg_identifier = 184,
  sym__pf_arg = 185,
  sym__pf_dot_arg = 186,
  sym_pf_concatenation = 187,
  sym_pf_dot_concatenation = 188,
  sym_pf_arg = 189,
  sym_pf_dot_arg = 190,
  sym_pf_args = 191,
  sym_pf_dot_args = 192,
  sym__env_stmt = 193,
  sym__env_stmt_identifier = 194,
  sym__last_stmt = 195,
  sym_last_stmt_identifier = 196,
  sym_repeat_stmt = 197,
  sym_eq_sep_args = 198,
  sym_macro_call_content = 199,
  sym_macro_call_full_content = 200,
  sym_macro_content = 201,
  sym_macro_args = 202,
  sym_redirect_stmt = 203,
  sym__redirect_operator = 204,
  sym_fdn_redirect_operator = 205,
  sym_fdn_append_operator = 206,
  sym__arg_with_paren = 207,
  sym__arg = 208,
  sym_arg = 209,
  sym_args = 210,
  sym_tmp_eval_args = 211,
  sym_tmp_eval_arg = 212,
  sym__eq_sep_key_single = 213,
  sym__eq_sep_key_concatenation = 214,
  sym__eq_sep_key = 215,
  sym__eq_sep_val_concatenation = 216,
  sym__eq_sep_val = 217,
  sym_arg_identifier = 218,
  sym_spec_arg_identifier = 219,
  sym_double_quoted_arg = 220,
  sym_single_quoted_arg = 221,
  sym_cmd_substitution_arg = 222,
  sym_concatenation = 223,
  sym__dec_number = 224,
  sym_specifiers = 225,
  sym_cmd_identifier = 226,
  aux_sym_statements_repeat1 = 227,
  aux_sym_statements_repeat2 = 228,
  aux_sym__statements_singleline_repeat1 = 229,
  aux_sym__statements_singleline_repeat2 = 230,
  aux_sym_grep_specifier_repeat1 = 231,
  aux_sym_pf_concatenation_repeat1 = 232,
  aux_sym_pf_dot_concatenation_repeat1 = 233,
  aux_sym_pf_args_repeat1 = 234,
  aux_sym_pf_dot_args_repeat1 = 235,
  aux_sym_macro_content_repeat1 = 236,
  aux_sym_args_repeat1 = 237,
  aux_sym_tmp_eval_args_repeat1 = 238,
  aux_sym_tmp_eval_arg_repeat1 = 239,
  aux_sym__eq_sep_key_concatenation_repeat1 = 240,
  aux_sym__eq_sep_val_concatenation_repeat1 = 241,
  aux_sym_double_quoted_arg_repeat1 = 242,
  aux_sym_single_quoted_arg_repeat1 = 243,
  aux_sym_concatenation_repeat1 = 244,
  aux_sym_specifiers_repeat1 = 245,
  alias_sym_number = 246,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_legacy_quoted_stmt_token1] = "legacy_quoted_stmt_token1",
  [anon_sym_TILDE] = "~",
  [sym_grep_specifier_identifier] = "grep_specifier_identifier",
  [aux_sym_grep_specifier_token1] = "grep_specifier_identifier",
  [anon_sym_PIPE] = "|",
  [anon_sym_PIPEH] = "|H",
  [anon_sym_AT_AT_DOT] = "@@.",
  [anon_sym_AT_AT_EQ] = "@@=",
  [anon_sym_AT_AT_AT_EQ] = "@@@=",
  [anon_sym_AT_AT] = "@@",
  [anon_sym_AT_ATc_COLON] = "@@c:",
  [anon_sym_AT_AT_ATc_COLON] = "@@@c:",
  [anon_sym_AT_ATC] = "@@C",
  [anon_sym_COLON] = ":",
  [anon_sym_AT_ATdbt] = "@@dbt",
  [anon_sym_AT_ATdbta] = "@@dbta",
  [anon_sym_AT_ATdbtb] = "@@dbtb",
  [anon_sym_AT_ATdbts] = "@@dbts",
  [anon_sym_AT_ATt] = "@@t",
  [anon_sym_AT_ATb] = "@@b",
  [anon_sym_AT_ATi] = "@@i",
  [anon_sym_AT_ATii] = "@@ii",
  [anon_sym_AT_ATiS] = "@@iS",
  [anon_sym_AT_ATiSS] = "@@iSS",
  [anon_sym_AT_ATis] = "@@is",
  [anon_sym_AT_ATiz] = "@@iz",
  [anon_sym_AT_ATf] = "@@f",
  [anon_sym_AT_ATF] = "@@F",
  [anon_sym_AT_ATom] = "@@om",
  [anon_sym_AT_ATdm] = "@@dm",
  [anon_sym_AT_ATr] = "@@r",
  [anon_sym_AT_ATs_COLON] = "@@s:",
  [anon_sym_AT] = "@",
  [anon_sym_AT_BANG] = "@!",
  [anon_sym_AT_LPAREN] = "@(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_ATa_COLON] = "@a:",
  [anon_sym_ATb_COLON] = "@b:",
  [anon_sym_ATB_COLON] = "@B:",
  [anon_sym_ATe_COLON] = "@e:",
  [anon_sym_ATF_COLON] = "@F:",
  [anon_sym_ATi_COLON] = "@i:",
  [anon_sym_ATk_COLON] = "@k:",
  [anon_sym_ATo_COLON] = "@o:",
  [anon_sym_ATr_COLON] = "@r:",
  [anon_sym_ATf_COLON] = "@f:",
  [anon_sym_ATs_COLON] = "@s:",
  [anon_sym_ATv_COLON] = "@v:",
  [anon_sym_ATx_COLON] = "@x:",
  [anon_sym_0] = "0",
  [aux_sym_number_stmt_token1] = "number_stmt_token1",
  [aux_sym__search_stmt_token1] = "cmd_identifier",
  [anon_sym_DOT] = ".",
  [aux_sym__interpret_stmt_token1] = "cmd_identifier",
  [aux_sym__interpret_stmt_token2] = "_interpret_stmt_token2",
  [aux_sym__interpret_stmt_token3] = "cmd_identifier",
  [anon_sym_DOT_LPAREN] = "cmd_identifier",
  [anon_sym_PIPE_DOT] = "|.",
  [anon_sym_DOT_SLASH] = "./",
  [anon_sym_pfo] = "cmd_identifier",
  [anon_sym_Cf] = "cmd_identifier",
  [sym_pf_dot_cmd_identifier] = "cmd_identifier",
  [sym_pf_dot_full_cmd_identifier] = "cmd_identifier",
  [aux_sym_pf_cmd_token1] = "cmd_identifier",
  [anon_sym_EQ] = "=",
  [aux_sym__pf_dot_arg_identifier_token1] = "_pf_dot_arg_identifier_token1",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_LPAREN] = "(",
  [aux_sym_pf_arg_identifier_token1] = "pf_arg_identifier_token1",
  [anon_sym_PERCENT] = "%",
  [anon_sym_env] = "env",
  [anon_sym_DOT_DOT_DOT] = "...",
  [sym_system_identifier] = "system_identifier",
  [sym_question_mark_identifier] = "cmd_identifier",
  [sym_pointer_identifier] = "cmd_identifier",
  [sym_macro_identifier] = "cmd_identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [sym_html_redirect_operator] = "html_redirect_operator",
  [sym_html_append_operator] = "html_append_operator",
  [anon_sym_COMMA] = ",",
  [aux_sym_tmp_eval_arg_token1] = "tmp_eval_arg_token1",
  [sym__eq_sep_key_identifier] = "arg_identifier",
  [aux_sym_arg_identifier_token1] = "arg_identifier_token1",
  [aux_sym_spec_arg_identifier_token1] = "spec_arg_identifier_token1",
  [aux_sym_double_quoted_arg_token1] = "double_quoted_arg_token1",
  [aux_sym_double_quoted_arg_token2] = "double_quoted_arg_token2",
  [aux_sym_double_quoted_arg_token3] = "double_quoted_arg_token3",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_single_quoted_arg_token1] = "single_quoted_arg_token1",
  [aux_sym_single_quoted_arg_token2] = "single_quoted_arg_token2",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [aux_sym__dec_number_token1] = "_dec_number_token1",
  [aux_sym__dec_number_token2] = "_dec_number_token2",
  [sym__comment] = "_comment",
  [anon_sym_LF] = "\n",
  [anon_sym_CR] = "\r",
  [sym__cmd_identifier] = "_cmd_identifier",
  [sym__help_stmt] = "cmd_identifier",
  [sym_file_descriptor] = "file_descriptor",
  [sym__eq_sep_concat] = "_eq_sep_concat",
  [sym__concat] = "_concat",
  [sym__concat_pf_dot] = "_concat_pf_dot",
  [sym__spec_sep] = "_spec_sep",
  [sym_statements] = "statements",
  [sym__statements_singleline] = "_statements_singleline",
  [sym__statement] = "_statement",
  [sym_legacy_quoted_stmt] = "legacy_quoted_stmt",
  [sym__simple_stmt] = "_simple_stmt",
  [sym__tmp_stmt] = "_tmp_stmt",
  [sym__iter_stmt] = "_iter_stmt",
  [sym__pipe_stmt] = "_pipe_stmt",
  [sym_grep_stmt] = "grep_stmt",
  [sym_grep_specifier] = "grep_specifier",
  [sym_html_disable_stmt] = "html_disable_stmt",
  [sym_html_enable_stmt] = "html_enable_stmt",
  [sym_pipe_stmt] = "pipe_stmt",
  [sym_iter_file_lines_stmt] = "iter_file_lines_stmt",
  [sym_iter_offsets_stmt] = "iter_offsets_stmt",
  [sym_iter_offsetssizes_stmt] = "iter_offsetssizes_stmt",
  [sym_iter_hit_stmt] = "iter_hit_stmt",
  [sym_iter_interpret_stmt] = "iter_interpret_stmt",
  [sym_iter_interpret_offsetssizes_stmt] = "iter_interpret_offsetssizes_stmt",
  [sym_iter_comment_stmt] = "iter_comment_stmt",
  [sym_iter_dbta_stmt] = "iter_dbta_stmt",
  [sym_iter_dbtb_stmt] = "iter_dbtb_stmt",
  [sym_iter_dbts_stmt] = "iter_dbts_stmt",
  [sym_iter_threads_stmt] = "iter_threads_stmt",
  [sym_iter_bbs_stmt] = "iter_bbs_stmt",
  [sym_iter_instrs_stmt] = "iter_instrs_stmt",
  [sym_iter_import_stmt] = "iter_import_stmt",
  [sym_iter_sections_stmt] = "iter_sections_stmt",
  [sym_iter_segments_stmt] = "iter_segments_stmt",
  [sym_iter_symbol_stmt] = "iter_symbol_stmt",
  [sym_iter_string_stmt] = "iter_string_stmt",
  [sym_iter_flags_stmt] = "iter_flags_stmt",
  [sym_iter_function_stmt] = "iter_function_stmt",
  [sym_iter_iomap_stmt] = "iter_iomap_stmt",
  [sym_iter_dbgmap_stmt] = "iter_dbgmap_stmt",
  [sym_iter_register_stmt] = "iter_register_stmt",
  [sym_iter_step_stmt] = "iter_step_stmt",
  [sym_tmp_seek_stmt] = "tmp_seek_stmt",
  [sym_tmp_blksz_stmt] = "tmp_blksz_stmt",
  [sym_tmp_fromto_stmt] = "tmp_fromto_stmt",
  [sym_tmp_arch_stmt] = "tmp_arch_stmt",
  [sym_tmp_bits_stmt] = "tmp_bits_stmt",
  [sym_tmp_nthi_stmt] = "tmp_nthi_stmt",
  [sym_tmp_eval_stmt] = "tmp_eval_stmt",
  [sym_tmp_fs_stmt] = "tmp_fs_stmt",
  [sym_tmp_reli_stmt] = "tmp_reli_stmt",
  [sym_tmp_kuery_stmt] = "tmp_kuery_stmt",
  [sym_tmp_fd_stmt] = "tmp_fd_stmt",
  [sym_tmp_reg_stmt] = "tmp_reg_stmt",
  [sym_tmp_file_stmt] = "tmp_file_stmt",
  [sym_tmp_string_stmt] = "tmp_string_stmt",
  [sym_tmp_value_stmt] = "tmp_value_stmt",
  [sym_tmp_hex_stmt] = "tmp_hex_stmt",
  [sym_number_stmt] = "number_stmt",
  [sym_help_stmt] = "help_stmt",
  [sym_arged_stmt] = "arged_stmt",
  [sym__simple_arged_stmt_question] = "_simple_arged_stmt_question",
  [sym__simple_arged_stmt] = "_simple_arged_stmt",
  [sym__search_stmt] = "arged_stmt",
  [sym__math_arged_stmt] = "_math_arged_stmt",
  [sym__pointer_arged_stmt] = "_pointer_arged_stmt",
  [sym__macro_arged_stmt] = "_macro_arged_stmt",
  [sym__system_stmt] = "_system_stmt",
  [sym__interpret_stmt] = "_interpret_stmt",
  [sym__interpret_search_identifier] = "cmd_identifier",
  [sym__pf_arged_stmt] = "_pf_arged_stmt",
  [sym__pf_stmts] = "_pf_stmts",
  [sym_Cf_cmd] = "arged_stmt",
  [sym__Cf_args] = "args",
  [sym_pf_new_cmd] = "arged_stmt",
  [sym_pf_dot_cmd] = "arged_stmt",
  [sym_pf_cmd] = "arged_stmt",
  [sym_pf_new_args] = "pf_new_args",
  [sym_pf_dot_cmd_args] = "pf_dot_cmd_args",
  [sym__pf_dot_arg_identifier] = "pf_arg_identifier",
  [sym__pf_arg_parentheses] = "_pf_arg_parentheses",
  [sym_pf_arg_identifier] = "pf_arg_identifier",
  [sym__pf_arg] = "_pf_arg",
  [sym__pf_dot_arg] = "_pf_dot_arg",
  [sym_pf_concatenation] = "pf_concatenation",
  [sym_pf_dot_concatenation] = "pf_concatenation",
  [sym_pf_arg] = "pf_arg",
  [sym_pf_dot_arg] = "pf_arg",
  [sym_pf_args] = "pf_args",
  [sym_pf_dot_args] = "pf_args",
  [sym__env_stmt] = "_env_stmt",
  [sym__env_stmt_identifier] = "cmd_identifier",
  [sym__last_stmt] = "_last_stmt",
  [sym_last_stmt_identifier] = "cmd_identifier",
  [sym_repeat_stmt] = "repeat_stmt",
  [sym_eq_sep_args] = "args",
  [sym_macro_call_content] = "macro_call_content",
  [sym_macro_call_full_content] = "macro_call_full_content",
  [sym_macro_content] = "macro_content",
  [sym_macro_args] = "macro_args",
  [sym_redirect_stmt] = "redirect_stmt",
  [sym__redirect_operator] = "_redirect_operator",
  [sym_fdn_redirect_operator] = "fdn_redirect_operator",
  [sym_fdn_append_operator] = "fdn_append_operator",
  [sym__arg_with_paren] = "args",
  [sym__arg] = "_arg",
  [sym_arg] = "arg",
  [sym_args] = "args",
  [sym_tmp_eval_args] = "tmp_eval_args",
  [sym_tmp_eval_arg] = "tmp_eval_arg",
  [sym__eq_sep_key_single] = "_eq_sep_key_single",
  [sym__eq_sep_key_concatenation] = "concatenation",
  [sym__eq_sep_key] = "arg",
  [sym__eq_sep_val_concatenation] = "concatenation",
  [sym__eq_sep_val] = "arg",
  [sym_arg_identifier] = "arg_identifier",
  [sym_spec_arg_identifier] = "arg_identifier",
  [sym_double_quoted_arg] = "double_quoted_arg",
  [sym_single_quoted_arg] = "single_quoted_arg",
  [sym_cmd_substitution_arg] = "cmd_substitution_arg",
  [sym_concatenation] = "concatenation",
  [sym__dec_number] = "_dec_number",
  [sym_specifiers] = "specifiers",
  [sym_cmd_identifier] = "cmd_identifier",
  [aux_sym_statements_repeat1] = "statements_repeat1",
  [aux_sym_statements_repeat2] = "statements_repeat2",
  [aux_sym__statements_singleline_repeat1] = "_statements_singleline_repeat1",
  [aux_sym__statements_singleline_repeat2] = "_statements_singleline_repeat2",
  [aux_sym_grep_specifier_repeat1] = "grep_specifier_repeat1",
  [aux_sym_pf_concatenation_repeat1] = "pf_concatenation_repeat1",
  [aux_sym_pf_dot_concatenation_repeat1] = "pf_dot_concatenation_repeat1",
  [aux_sym_pf_args_repeat1] = "pf_args_repeat1",
  [aux_sym_pf_dot_args_repeat1] = "pf_dot_args_repeat1",
  [aux_sym_macro_content_repeat1] = "macro_content_repeat1",
  [aux_sym_args_repeat1] = "args_repeat1",
  [aux_sym_tmp_eval_args_repeat1] = "tmp_eval_args_repeat1",
  [aux_sym_tmp_eval_arg_repeat1] = "tmp_eval_arg_repeat1",
  [aux_sym__eq_sep_key_concatenation_repeat1] = "_eq_sep_key_concatenation_repeat1",
  [aux_sym__eq_sep_val_concatenation_repeat1] = "_eq_sep_val_concatenation_repeat1",
  [aux_sym_double_quoted_arg_repeat1] = "double_quoted_arg_repeat1",
  [aux_sym_single_quoted_arg_repeat1] = "single_quoted_arg_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_specifiers_repeat1] = "specifiers_repeat1",
  [alias_sym_number] = "number",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_legacy_quoted_stmt_token1] = aux_sym_legacy_quoted_stmt_token1,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [sym_grep_specifier_identifier] = sym_grep_specifier_identifier,
  [aux_sym_grep_specifier_token1] = sym_grep_specifier_identifier,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PIPEH] = anon_sym_PIPEH,
  [anon_sym_AT_AT_DOT] = anon_sym_AT_AT_DOT,
  [anon_sym_AT_AT_EQ] = anon_sym_AT_AT_EQ,
  [anon_sym_AT_AT_AT_EQ] = anon_sym_AT_AT_AT_EQ,
  [anon_sym_AT_AT] = anon_sym_AT_AT,
  [anon_sym_AT_ATc_COLON] = anon_sym_AT_ATc_COLON,
  [anon_sym_AT_AT_ATc_COLON] = anon_sym_AT_AT_ATc_COLON,
  [anon_sym_AT_ATC] = anon_sym_AT_ATC,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_AT_ATdbt] = anon_sym_AT_ATdbt,
  [anon_sym_AT_ATdbta] = anon_sym_AT_ATdbta,
  [anon_sym_AT_ATdbtb] = anon_sym_AT_ATdbtb,
  [anon_sym_AT_ATdbts] = anon_sym_AT_ATdbts,
  [anon_sym_AT_ATt] = anon_sym_AT_ATt,
  [anon_sym_AT_ATb] = anon_sym_AT_ATb,
  [anon_sym_AT_ATi] = anon_sym_AT_ATi,
  [anon_sym_AT_ATii] = anon_sym_AT_ATii,
  [anon_sym_AT_ATiS] = anon_sym_AT_ATiS,
  [anon_sym_AT_ATiSS] = anon_sym_AT_ATiSS,
  [anon_sym_AT_ATis] = anon_sym_AT_ATis,
  [anon_sym_AT_ATiz] = anon_sym_AT_ATiz,
  [anon_sym_AT_ATf] = anon_sym_AT_ATf,
  [anon_sym_AT_ATF] = anon_sym_AT_ATF,
  [anon_sym_AT_ATom] = anon_sym_AT_ATom,
  [anon_sym_AT_ATdm] = anon_sym_AT_ATdm,
  [anon_sym_AT_ATr] = anon_sym_AT_ATr,
  [anon_sym_AT_ATs_COLON] = anon_sym_AT_ATs_COLON,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_AT_BANG] = anon_sym_AT_BANG,
  [anon_sym_AT_LPAREN] = anon_sym_AT_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_ATa_COLON] = anon_sym_ATa_COLON,
  [anon_sym_ATb_COLON] = anon_sym_ATb_COLON,
  [anon_sym_ATB_COLON] = anon_sym_ATB_COLON,
  [anon_sym_ATe_COLON] = anon_sym_ATe_COLON,
  [anon_sym_ATF_COLON] = anon_sym_ATF_COLON,
  [anon_sym_ATi_COLON] = anon_sym_ATi_COLON,
  [anon_sym_ATk_COLON] = anon_sym_ATk_COLON,
  [anon_sym_ATo_COLON] = anon_sym_ATo_COLON,
  [anon_sym_ATr_COLON] = anon_sym_ATr_COLON,
  [anon_sym_ATf_COLON] = anon_sym_ATf_COLON,
  [anon_sym_ATs_COLON] = anon_sym_ATs_COLON,
  [anon_sym_ATv_COLON] = anon_sym_ATv_COLON,
  [anon_sym_ATx_COLON] = anon_sym_ATx_COLON,
  [anon_sym_0] = anon_sym_0,
  [aux_sym_number_stmt_token1] = aux_sym_number_stmt_token1,
  [aux_sym__search_stmt_token1] = sym_cmd_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [aux_sym__interpret_stmt_token1] = sym_cmd_identifier,
  [aux_sym__interpret_stmt_token2] = aux_sym__interpret_stmt_token2,
  [aux_sym__interpret_stmt_token3] = sym_cmd_identifier,
  [anon_sym_DOT_LPAREN] = sym_cmd_identifier,
  [anon_sym_PIPE_DOT] = anon_sym_PIPE_DOT,
  [anon_sym_DOT_SLASH] = anon_sym_DOT_SLASH,
  [anon_sym_pfo] = sym_cmd_identifier,
  [anon_sym_Cf] = sym_cmd_identifier,
  [sym_pf_dot_cmd_identifier] = sym_cmd_identifier,
  [sym_pf_dot_full_cmd_identifier] = sym_cmd_identifier,
  [aux_sym_pf_cmd_token1] = sym_cmd_identifier,
  [anon_sym_EQ] = anon_sym_EQ,
  [aux_sym__pf_dot_arg_identifier_token1] = aux_sym__pf_dot_arg_identifier_token1,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [aux_sym_pf_arg_identifier_token1] = aux_sym_pf_arg_identifier_token1,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_env] = anon_sym_env,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [sym_system_identifier] = sym_system_identifier,
  [sym_question_mark_identifier] = sym_cmd_identifier,
  [sym_pointer_identifier] = sym_cmd_identifier,
  [sym_macro_identifier] = sym_cmd_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [sym_html_redirect_operator] = sym_html_redirect_operator,
  [sym_html_append_operator] = sym_html_append_operator,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [aux_sym_tmp_eval_arg_token1] = aux_sym_tmp_eval_arg_token1,
  [sym__eq_sep_key_identifier] = sym_arg_identifier,
  [aux_sym_arg_identifier_token1] = aux_sym_arg_identifier_token1,
  [aux_sym_spec_arg_identifier_token1] = aux_sym_spec_arg_identifier_token1,
  [aux_sym_double_quoted_arg_token1] = aux_sym_double_quoted_arg_token1,
  [aux_sym_double_quoted_arg_token2] = aux_sym_double_quoted_arg_token2,
  [aux_sym_double_quoted_arg_token3] = aux_sym_double_quoted_arg_token3,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_single_quoted_arg_token1] = aux_sym_single_quoted_arg_token1,
  [aux_sym_single_quoted_arg_token2] = aux_sym_single_quoted_arg_token2,
  [anon_sym_DOLLAR_LPAREN] = anon_sym_DOLLAR_LPAREN,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [aux_sym__dec_number_token1] = aux_sym__dec_number_token1,
  [aux_sym__dec_number_token2] = aux_sym__dec_number_token2,
  [sym__comment] = sym__comment,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_CR] = anon_sym_CR,
  [sym__cmd_identifier] = sym__cmd_identifier,
  [sym__help_stmt] = sym_cmd_identifier,
  [sym_file_descriptor] = sym_file_descriptor,
  [sym__eq_sep_concat] = sym__eq_sep_concat,
  [sym__concat] = sym__concat,
  [sym__concat_pf_dot] = sym__concat_pf_dot,
  [sym__spec_sep] = sym__spec_sep,
  [sym_statements] = sym_statements,
  [sym__statements_singleline] = sym__statements_singleline,
  [sym__statement] = sym__statement,
  [sym_legacy_quoted_stmt] = sym_legacy_quoted_stmt,
  [sym__simple_stmt] = sym__simple_stmt,
  [sym__tmp_stmt] = sym__tmp_stmt,
  [sym__iter_stmt] = sym__iter_stmt,
  [sym__pipe_stmt] = sym__pipe_stmt,
  [sym_grep_stmt] = sym_grep_stmt,
  [sym_grep_specifier] = sym_grep_specifier,
  [sym_html_disable_stmt] = sym_html_disable_stmt,
  [sym_html_enable_stmt] = sym_html_enable_stmt,
  [sym_pipe_stmt] = sym_pipe_stmt,
  [sym_iter_file_lines_stmt] = sym_iter_file_lines_stmt,
  [sym_iter_offsets_stmt] = sym_iter_offsets_stmt,
  [sym_iter_offsetssizes_stmt] = sym_iter_offsetssizes_stmt,
  [sym_iter_hit_stmt] = sym_iter_hit_stmt,
  [sym_iter_interpret_stmt] = sym_iter_interpret_stmt,
  [sym_iter_interpret_offsetssizes_stmt] = sym_iter_interpret_offsetssizes_stmt,
  [sym_iter_comment_stmt] = sym_iter_comment_stmt,
  [sym_iter_dbta_stmt] = sym_iter_dbta_stmt,
  [sym_iter_dbtb_stmt] = sym_iter_dbtb_stmt,
  [sym_iter_dbts_stmt] = sym_iter_dbts_stmt,
  [sym_iter_threads_stmt] = sym_iter_threads_stmt,
  [sym_iter_bbs_stmt] = sym_iter_bbs_stmt,
  [sym_iter_instrs_stmt] = sym_iter_instrs_stmt,
  [sym_iter_import_stmt] = sym_iter_import_stmt,
  [sym_iter_sections_stmt] = sym_iter_sections_stmt,
  [sym_iter_segments_stmt] = sym_iter_segments_stmt,
  [sym_iter_symbol_stmt] = sym_iter_symbol_stmt,
  [sym_iter_string_stmt] = sym_iter_string_stmt,
  [sym_iter_flags_stmt] = sym_iter_flags_stmt,
  [sym_iter_function_stmt] = sym_iter_function_stmt,
  [sym_iter_iomap_stmt] = sym_iter_iomap_stmt,
  [sym_iter_dbgmap_stmt] = sym_iter_dbgmap_stmt,
  [sym_iter_register_stmt] = sym_iter_register_stmt,
  [sym_iter_step_stmt] = sym_iter_step_stmt,
  [sym_tmp_seek_stmt] = sym_tmp_seek_stmt,
  [sym_tmp_blksz_stmt] = sym_tmp_blksz_stmt,
  [sym_tmp_fromto_stmt] = sym_tmp_fromto_stmt,
  [sym_tmp_arch_stmt] = sym_tmp_arch_stmt,
  [sym_tmp_bits_stmt] = sym_tmp_bits_stmt,
  [sym_tmp_nthi_stmt] = sym_tmp_nthi_stmt,
  [sym_tmp_eval_stmt] = sym_tmp_eval_stmt,
  [sym_tmp_fs_stmt] = sym_tmp_fs_stmt,
  [sym_tmp_reli_stmt] = sym_tmp_reli_stmt,
  [sym_tmp_kuery_stmt] = sym_tmp_kuery_stmt,
  [sym_tmp_fd_stmt] = sym_tmp_fd_stmt,
  [sym_tmp_reg_stmt] = sym_tmp_reg_stmt,
  [sym_tmp_file_stmt] = sym_tmp_file_stmt,
  [sym_tmp_string_stmt] = sym_tmp_string_stmt,
  [sym_tmp_value_stmt] = sym_tmp_value_stmt,
  [sym_tmp_hex_stmt] = sym_tmp_hex_stmt,
  [sym_number_stmt] = sym_number_stmt,
  [sym_help_stmt] = sym_help_stmt,
  [sym_arged_stmt] = sym_arged_stmt,
  [sym__simple_arged_stmt_question] = sym__simple_arged_stmt_question,
  [sym__simple_arged_stmt] = sym__simple_arged_stmt,
  [sym__search_stmt] = sym_arged_stmt,
  [sym__math_arged_stmt] = sym__math_arged_stmt,
  [sym__pointer_arged_stmt] = sym__pointer_arged_stmt,
  [sym__macro_arged_stmt] = sym__macro_arged_stmt,
  [sym__system_stmt] = sym__system_stmt,
  [sym__interpret_stmt] = sym__interpret_stmt,
  [sym__interpret_search_identifier] = sym_cmd_identifier,
  [sym__pf_arged_stmt] = sym__pf_arged_stmt,
  [sym__pf_stmts] = sym__pf_stmts,
  [sym_Cf_cmd] = sym_arged_stmt,
  [sym__Cf_args] = sym_args,
  [sym_pf_new_cmd] = sym_arged_stmt,
  [sym_pf_dot_cmd] = sym_arged_stmt,
  [sym_pf_cmd] = sym_arged_stmt,
  [sym_pf_new_args] = sym_pf_new_args,
  [sym_pf_dot_cmd_args] = sym_pf_dot_cmd_args,
  [sym__pf_dot_arg_identifier] = sym_pf_arg_identifier,
  [sym__pf_arg_parentheses] = sym__pf_arg_parentheses,
  [sym_pf_arg_identifier] = sym_pf_arg_identifier,
  [sym__pf_arg] = sym__pf_arg,
  [sym__pf_dot_arg] = sym__pf_dot_arg,
  [sym_pf_concatenation] = sym_pf_concatenation,
  [sym_pf_dot_concatenation] = sym_pf_concatenation,
  [sym_pf_arg] = sym_pf_arg,
  [sym_pf_dot_arg] = sym_pf_arg,
  [sym_pf_args] = sym_pf_args,
  [sym_pf_dot_args] = sym_pf_args,
  [sym__env_stmt] = sym__env_stmt,
  [sym__env_stmt_identifier] = sym_cmd_identifier,
  [sym__last_stmt] = sym__last_stmt,
  [sym_last_stmt_identifier] = sym_cmd_identifier,
  [sym_repeat_stmt] = sym_repeat_stmt,
  [sym_eq_sep_args] = sym_args,
  [sym_macro_call_content] = sym_macro_call_content,
  [sym_macro_call_full_content] = sym_macro_call_full_content,
  [sym_macro_content] = sym_macro_content,
  [sym_macro_args] = sym_macro_args,
  [sym_redirect_stmt] = sym_redirect_stmt,
  [sym__redirect_operator] = sym__redirect_operator,
  [sym_fdn_redirect_operator] = sym_fdn_redirect_operator,
  [sym_fdn_append_operator] = sym_fdn_append_operator,
  [sym__arg_with_paren] = sym_args,
  [sym__arg] = sym__arg,
  [sym_arg] = sym_arg,
  [sym_args] = sym_args,
  [sym_tmp_eval_args] = sym_tmp_eval_args,
  [sym_tmp_eval_arg] = sym_tmp_eval_arg,
  [sym__eq_sep_key_single] = sym__eq_sep_key_single,
  [sym__eq_sep_key_concatenation] = sym_concatenation,
  [sym__eq_sep_key] = sym_arg,
  [sym__eq_sep_val_concatenation] = sym_concatenation,
  [sym__eq_sep_val] = sym_arg,
  [sym_arg_identifier] = sym_arg_identifier,
  [sym_spec_arg_identifier] = sym_arg_identifier,
  [sym_double_quoted_arg] = sym_double_quoted_arg,
  [sym_single_quoted_arg] = sym_single_quoted_arg,
  [sym_cmd_substitution_arg] = sym_cmd_substitution_arg,
  [sym_concatenation] = sym_concatenation,
  [sym__dec_number] = sym__dec_number,
  [sym_specifiers] = sym_specifiers,
  [sym_cmd_identifier] = sym_cmd_identifier,
  [aux_sym_statements_repeat1] = aux_sym_statements_repeat1,
  [aux_sym_statements_repeat2] = aux_sym_statements_repeat2,
  [aux_sym__statements_singleline_repeat1] = aux_sym__statements_singleline_repeat1,
  [aux_sym__statements_singleline_repeat2] = aux_sym__statements_singleline_repeat2,
  [aux_sym_grep_specifier_repeat1] = aux_sym_grep_specifier_repeat1,
  [aux_sym_pf_concatenation_repeat1] = aux_sym_pf_concatenation_repeat1,
  [aux_sym_pf_dot_concatenation_repeat1] = aux_sym_pf_dot_concatenation_repeat1,
  [aux_sym_pf_args_repeat1] = aux_sym_pf_args_repeat1,
  [aux_sym_pf_dot_args_repeat1] = aux_sym_pf_dot_args_repeat1,
  [aux_sym_macro_content_repeat1] = aux_sym_macro_content_repeat1,
  [aux_sym_args_repeat1] = aux_sym_args_repeat1,
  [aux_sym_tmp_eval_args_repeat1] = aux_sym_tmp_eval_args_repeat1,
  [aux_sym_tmp_eval_arg_repeat1] = aux_sym_tmp_eval_arg_repeat1,
  [aux_sym__eq_sep_key_concatenation_repeat1] = aux_sym__eq_sep_key_concatenation_repeat1,
  [aux_sym__eq_sep_val_concatenation_repeat1] = aux_sym__eq_sep_val_concatenation_repeat1,
  [aux_sym_double_quoted_arg_repeat1] = aux_sym_double_quoted_arg_repeat1,
  [aux_sym_single_quoted_arg_repeat1] = aux_sym_single_quoted_arg_repeat1,
  [aux_sym_concatenation_repeat1] = aux_sym_concatenation_repeat1,
  [aux_sym_specifiers_repeat1] = aux_sym_specifiers_repeat1,
  [alias_sym_number] = alias_sym_number,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_legacy_quoted_stmt_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [sym_grep_specifier_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_grep_specifier_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPEH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATc_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_ATc_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATC] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbta] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbtb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATii] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATiS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATiSS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATis] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATiz] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATs_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATa_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATb_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATB_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATe_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATF_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATi_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATk_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATo_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATr_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATf_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATs_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATv_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATx_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_number_stmt_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__search_stmt_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__interpret_stmt_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__interpret_stmt_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__interpret_stmt_token3] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_LPAREN] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pfo] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_Cf] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_cmd_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_full_cmd_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_pf_cmd_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__pf_dot_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_pf_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_env] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_system_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_question_mark_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_html_redirect_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_html_append_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_tmp_eval_arg_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__eq_sep_key_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_spec_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_single_quoted_arg_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_single_quoted_arg_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__dec_number_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__dec_number_token2] = {
    .visible = false,
    .named = false,
  },
  [sym__comment] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CR] = {
    .visible = true,
    .named = false,
  },
  [sym__cmd_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__help_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_concat] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym__concat_pf_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__spec_sep] = {
    .visible = false,
    .named = true,
  },
  [sym_statements] = {
    .visible = true,
    .named = true,
  },
  [sym__statements_singleline] = {
    .visible = false,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_legacy_quoted_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__tmp_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__iter_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__pipe_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym_grep_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_grep_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_html_disable_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_html_enable_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_pipe_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_file_lines_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_offsets_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_offsetssizes_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_hit_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_interpret_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_interpret_offsetssizes_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_comment_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbta_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbtb_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbts_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_threads_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_bbs_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_instrs_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_import_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_sections_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_segments_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_symbol_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_string_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_flags_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_function_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_iomap_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbgmap_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_register_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_step_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_seek_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_blksz_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_fromto_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_arch_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_bits_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_nthi_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_eval_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_fs_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_reli_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_kuery_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_fd_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_reg_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_file_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_string_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_value_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_hex_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_number_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_help_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_arged_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_arged_stmt_question] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__search_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__math_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__pointer_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__macro_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__system_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__interpret_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__interpret_search_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__pf_stmts] = {
    .visible = false,
    .named = true,
  },
  [sym_Cf_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym__Cf_args] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_new_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_new_args] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_cmd_args] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_dot_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_arg_parentheses] = {
    .visible = false,
    .named = true,
  },
  [sym_pf_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_arg] = {
    .visible = false,
    .named = true,
  },
  [sym__pf_dot_arg] = {
    .visible = false,
    .named = true,
  },
  [sym_pf_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_args] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_args] = {
    .visible = true,
    .named = true,
  },
  [sym__env_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__env_stmt_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__last_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym_last_stmt_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_eq_sep_args] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_call_content] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_call_full_content] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_content] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_args] = {
    .visible = true,
    .named = true,
  },
  [sym_redirect_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__redirect_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_fdn_redirect_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_fdn_append_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__arg_with_paren] = {
    .visible = true,
    .named = true,
  },
  [sym__arg] = {
    .visible = false,
    .named = true,
  },
  [sym_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_args] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_eval_args] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_eval_arg] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_key_single] = {
    .visible = false,
    .named = true,
  },
  [sym__eq_sep_key_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_key] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_val_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_val] = {
    .visible = true,
    .named = true,
  },
  [sym_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_spec_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_double_quoted_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_single_quoted_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_cmd_substitution_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__dec_number] = {
    .visible = false,
    .named = true,
  },
  [sym_specifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_cmd_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_statements_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statements_singleline_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statements_singleline_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_grep_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_dot_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_dot_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_macro_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tmp_eval_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tmp_eval_arg_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__eq_sep_key_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__eq_sep_val_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_single_quoted_arg_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_number] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_arg = 1,
  field_args = 2,
  field_command = 3,
  field_extra = 4,
  field_id = 5,
  field_name = 6,
  field_redirect_operator = 7,
  field_specifier = 8,
  field_string = 9,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_arg] = "arg",
  [field_args] = "args",
  [field_command] = "command",
  [field_extra] = "extra",
  [field_id] = "id",
  [field_name] = "name",
  [field_redirect_operator] = "redirect_operator",
  [field_specifier] = "specifier",
  [field_string] = "string",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 2},
  [8] = {.index = 7, .length = 2},
  [9] = {.index = 7, .length = 2},
  [10] = {.index = 9, .length = 2},
  [11] = {.index = 11, .length = 2},
  [12] = {.index = 13, .length = 1},
  [13] = {.index = 14, .length = 2},
  [14] = {.index = 14, .length = 2},
  [15] = {.index = 16, .length = 1},
  [16] = {.index = 17, .length = 2},
  [17] = {.index = 19, .length = 3},
  [20] = {.index = 22, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_id, 0},
  [1] =
    {field_command, 0},
  [2] =
    {field_args, 0, .inherited = true},
    {field_command, 0, .inherited = true},
  [4] =
    {field_command, 0, .inherited = true},
  [5] =
    {field_extra, 1},
    {field_id, 0},
  [7] =
    {field_args, 1},
    {field_command, 0},
  [9] =
    {field_args, 0},
    {field_command, 1},
  [11] =
    {field_arg, 0},
    {field_command, 1},
  [13] =
    {field_string, 1},
  [14] =
    {field_args, 2},
    {field_command, 0},
  [16] =
    {field_name, 0},
  [17] =
    {field_command, 0},
    {field_specifier, 2},
  [19] =
    {field_arg, 2},
    {field_command, 0},
    {field_redirect_operator, 1},
  [22] =
    {field_args, 3, .inherited = true},
    {field_command, 3, .inherited = true},
};

static TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [3] = {
    [0] = sym_cmd_identifier,
  },
  [7] = {
    [0] = sym_arg_identifier,
  },
  [9] = {
    [0] = sym_cmd_identifier,
  },
  [11] = {
    [0] = alias_sym_number,
  },
  [13] = {
    [0] = sym_cmd_identifier,
  },
  [18] = {
    [0] = sym_arg_identifier,
    [2] = sym_arg_identifier,
  },
  [19] = {
    [0] = sym_pf_arg_identifier,
    [2] = sym_pf_arg_identifier,
  },
  [21] = {
    [1] = sym_pf_arg_identifier,
  },
};

static uint16_t ts_non_terminal_alias_map[] = {
  sym__dec_number, 2,
    sym__dec_number,
    alias_sym_number,
  0,
};

static inline bool sym_grep_specifier_identifier_character_set_1(int32_t c) {
  return (c < '('
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || c == '#'))
    : (c <= '(' || (c < '`'
      ? (c < '>'
        ? c == ';'
        : c <= '>')
      : (c <= '`' || c == '|'))));
}

static inline bool sym_grep_specifier_identifier_character_set_2(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '('
        ? c == '#'
        : c <= ')')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || c == '|'))));
}

static inline bool sym_grep_specifier_identifier_character_set_3(int32_t c) {
  return (c < '('
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || c == '#'))
    : (c <= ')' || (c < '`'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '`' || c == '|'))));
}

static inline bool aux_sym__pf_dot_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ';' || (c < '|'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : c <= '@')
      : (c <= '|' || c == '~'))));
}

static inline bool aux_sym__pf_dot_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < '.'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= '.' || (c < '`'
      ? (c < '='
        ? c == ';'
        : (c <= '>' || c == '@'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym__pf_dot_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < ';'
    ? (c < '\''
      ? (c < '"'
        ? c == '\t'
        : c <= '#')
      : (c <= ')' || c == '.'))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : c <= '@')
      : (c <= '`' || (c >= '|' && c <= '~')))));
}

static inline bool aux_sym_pf_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '\''
        ? c == '"'
        : c <= '\'')))
    : (c <= ';' || (c < '|'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '|' || c == '~'))));
}

static inline bool aux_sym_pf_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_pf_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < '\''
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '"'
        ? c == ' '
        : c <= '#')))
    : (c <= ')' || (c < '`'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_tmp_eval_arg_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '"'
      ? (c < '\n'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= '$' || (c < ','
        ? (c >= '\'' && c <= ')')
        : c <= ',')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool sym__eq_sep_key_identifier_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < ','
        ? (c >= '(' && c <= ')')
        : c <= ',')))
    : (c <= ';' || (c < '\\'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : c <= '@')
      : (c <= '\\' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool sym__eq_sep_key_identifier_character_set_2(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : (c <= ')' || c == ','))))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool sym__eq_sep_key_identifier_character_set_3(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : (c <= ')' || c == ','))))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '='
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ',' || (c < '`'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ',' || (c < '`'
      ? (c < '>'
        ? c == ';'
        : (c <= '>' || c == '@'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_4(int32_t c) {
  return (c < ';'
    ? (c < '\''
      ? (c < '"'
        ? c == '\t'
        : c <= '#')
      : (c <= ')' || c == ','))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c >= '|' && c <= '~')))));
}

static inline bool aux_sym_spec_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ':'
    ? (c < '"'
      ? (c < '\n'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= '"' || (c < ','
        ? (c >= '\'' && c <= ')')
        : c <= ',')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_spec_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ',' || (c < '`'
      ? (c < '>'
        ? (c >= ':' && c <= ';')
        : (c <= '>' || c == '@'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_spec_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < ':'
    ? (c < '\''
      ? (c < '"'
        ? c == '\t'
        : c <= '#')
      : (c <= ')' || c == ','))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c >= '|' && c <= '~')))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(222);
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '$') ADVANCE(164);
      if (lookahead == '%') ADVANCE(171);
      if (lookahead == '\'') ADVANCE(208);
      if (lookahead == '(') ADVANCE(165);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == '*') ADVANCE(176);
      if (lookahead == ',') ADVANCE(184);
      if (lookahead == '.') ADVANCE(140);
      if (lookahead == '/') ADVANCE(137);
      if (lookahead == '0') ADVANCE(133);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '=') ADVANCE(154);
      if (lookahead == '>') ADVANCE(180);
      if (lookahead == '?') ADVANCE(175);
      if (lookahead == '@') ADVANCE(116);
      if (lookahead == 'H') ADVANCE(186);
      if (lookahead == '\\') ADVANCE(207);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(0)
      if (lookahead != 0) ADVANCE(185);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '$') ADVANCE(14);
      if (lookahead == '%') ADVANCE(187);
      if (lookahead == '\'') ADVANCE(208);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(1)
      if (!sym__eq_sep_key_identifier_character_set_1(lookahead)) ADVANCE(191);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(201);
      if (lookahead == '$') ADVANCE(205);
      if (lookahead == '\\') ADVANCE(207);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(203);
      END_STATE();
    case 3:
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\\') ADVANCE(84);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(80);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '>' &&
          lookahead != '@' &&
          lookahead != '|') ADVANCE(82);
      END_STATE();
    case 4:
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '$') ADVANCE(163);
      if (lookahead == '\\') ADVANCE(62);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(4)
      if (!aux_sym_spec_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(199);
      END_STATE();
    case 5:
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '$') ADVANCE(161);
      if (lookahead == '(') ADVANCE(165);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(5)
      if (!aux_sym_pf_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(169);
      END_STATE();
    case 6:
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '.') ADVANCE(138);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(6)
      if (!aux_sym__pf_dot_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(158);
      END_STATE();
    case 7:
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(7)
      if (!aux_sym_tmp_eval_arg_token1_character_set_1(lookahead)) ADVANCE(185);
      END_STATE();
    case 8:
      if (lookahead == '#') ADVANCE(209);
      if (lookahead == '\'') ADVANCE(208);
      if (lookahead == '\\') ADVANCE(213);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(210);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(211);
      END_STATE();
    case 9:
      if (lookahead == '#') ADVANCE(218);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(76);
      END_STATE();
    case 10:
      if (lookahead == '$') ADVANCE(196);
      if (lookahead == '{') ADVANCE(54);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(193);
      END_STATE();
    case 11:
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '{') ADVANCE(55);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(169);
      END_STATE();
    case 12:
      if (lookahead == '$') ADVANCE(157);
      if (lookahead == '{') ADVANCE(57);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(158);
      END_STATE();
    case 13:
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '{') ADVANCE(58);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(199);
      END_STATE();
    case 14:
      if (lookahead == '(') ADVANCE(214);
      if (lookahead == '{') ADVANCE(56);
      if (lookahead != 0) ADVANCE(191);
      END_STATE();
    case 15:
      if (lookahead == '.') ADVANCE(151);
      END_STATE();
    case 16:
      if (lookahead == ':') ADVANCE(122);
      END_STATE();
    case 17:
      if (lookahead == ':') ADVANCE(124);
      END_STATE();
    case 18:
      if (lookahead == ':') ADVANCE(120);
      END_STATE();
    case 19:
      if (lookahead == ':') ADVANCE(121);
      END_STATE();
    case 20:
      if (lookahead == ':') ADVANCE(123);
      END_STATE();
    case 21:
      if (lookahead == ':') ADVANCE(129);
      END_STATE();
    case 22:
      if (lookahead == ':') ADVANCE(125);
      END_STATE();
    case 23:
      if (lookahead == ':') ADVANCE(126);
      END_STATE();
    case 24:
      if (lookahead == ':') ADVANCE(127);
      END_STATE();
    case 25:
      if (lookahead == ':') ADVANCE(128);
      END_STATE();
    case 26:
      if (lookahead == ':') ADVANCE(130);
      END_STATE();
    case 27:
      if (lookahead == ':') ADVANCE(131);
      END_STATE();
    case 28:
      if (lookahead == ':') ADVANCE(132);
      END_STATE();
    case 29:
      if (lookahead == ':') ADVANCE(94);
      END_STATE();
    case 30:
      if (lookahead == ':') ADVANCE(115);
      END_STATE();
    case 31:
      if (lookahead == ':') ADVANCE(95);
      END_STATE();
    case 32:
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == 'c') ADVANCE(31);
      END_STATE();
    case 33:
      if (lookahead == '>') ADVANCE(182);
      END_STATE();
    case 34:
      if (lookahead == 'b') ADVANCE(39);
      if (lookahead == 'm') ADVANCE(113);
      END_STATE();
    case 35:
      if (lookahead == 'f') ADVANCE(149);
      END_STATE();
    case 36:
      if (lookahead == 'f') ADVANCE(152);
      END_STATE();
    case 37:
      if (lookahead == 'm') ADVANCE(112);
      END_STATE();
    case 38:
      if (lookahead == 'n') ADVANCE(40);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 40:
      if (lookahead == 'v') ADVANCE(172);
      END_STATE();
    case 41:
      if (lookahead == '{') ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '(') ADVANCE(191);
      END_STATE();
    case 42:
      if (lookahead == '}') ADVANCE(193);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(42);
      END_STATE();
    case 43:
      if (lookahead == '}') ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(43);
      END_STATE();
    case 44:
      if (lookahead == '}') ADVANCE(191);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == '}') ADVANCE(158);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(45);
      END_STATE();
    case 46:
      if (lookahead == '}') ADVANCE(199);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(46);
      END_STATE();
    case 47:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(135);
      END_STATE();
    case 48:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(193);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(194);
      END_STATE();
    case 49:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(170);
      END_STATE();
    case 50:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(158);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(159);
      END_STATE();
    case 51:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(199);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(200);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(136);
      END_STATE();
    case 53:
      if (!sym_grep_specifier_identifier_character_set_1(lookahead)) ADVANCE(82);
      END_STATE();
    case 54:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(42);
      END_STATE();
    case 55:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(43);
      END_STATE();
    case 56:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(44);
      END_STATE();
    case 57:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(45);
      END_STATE();
    case 58:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(46);
      END_STATE();
    case 59:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(193);
      END_STATE();
    case 60:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(169);
      END_STATE();
    case 61:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(158);
      END_STATE();
    case 62:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(199);
      END_STATE();
    case 63:
      if (lookahead != 0) ADVANCE(76);
      END_STATE();
    case 64:
      if (eof) ADVANCE(73);
      if (lookahead == '\t') SKIP(64)
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(222);
      if (lookahead == ' ') ADVANCE(143);
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '>') ADVANCE(180);
      if (lookahead == '@') ADVANCE(116);
      if (lookahead == 'H') ADVANCE(33);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      END_STATE();
    case 65:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(222);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '%') ADVANCE(171);
      if (lookahead == '(') ADVANCE(178);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == '*') ADVANCE(176);
      if (lookahead == '.') ADVANCE(139);
      if (lookahead == '/') ADVANCE(137);
      if (lookahead == '0') ADVANCE(134);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '=') ADVANCE(154);
      if (lookahead == '>') ADVANCE(180);
      if (lookahead == '?') ADVANCE(175);
      if (lookahead == '@') ADVANCE(116);
      if (lookahead == 'C') ADVANCE(35);
      if (lookahead == 'H') ADVANCE(33);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == 'e') ADVANCE(38);
      if (lookahead == 'p') ADVANCE(36);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(65)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(216);
      END_STATE();
    case 66:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(222);
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '$') ADVANCE(160);
      if (lookahead == '\'') ADVANCE(208);
      if (lookahead == '(') ADVANCE(165);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ',') ADVANCE(184);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '>') ADVANCE(180);
      if (lookahead == '@') ADVANCE(116);
      if (lookahead == 'H') ADVANCE(192);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(66)
      if (lookahead != 0) ADVANCE(193);
      END_STATE();
    case 67:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(222);
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '$') ADVANCE(160);
      if (lookahead == '\'') ADVANCE(208);
      if (lookahead == '(') ADVANCE(165);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ',') ADVANCE(184);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(67)
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '@' &&
          lookahead != '|' &&
          lookahead != '~') ADVANCE(193);
      END_STATE();
    case 68:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(222);
      if (lookahead == '"') ADVANCE(74);
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '$') ADVANCE(14);
      if (lookahead == '%') ADVANCE(187);
      if (lookahead == '\'') ADVANCE(208);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '>') ADVANCE(180);
      if (lookahead == '@') ADVANCE(116);
      if (lookahead == 'H') ADVANCE(188);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(68)
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ',' &&
          lookahead != '=' &&
          lookahead != '\\') ADVANCE(191);
      END_STATE();
    case 69:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(222);
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '>') ADVANCE(180);
      if (lookahead == '@') ADVANCE(116);
      if (lookahead == 'H') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(84);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(79);
      if (lookahead != 0 &&
          lookahead != '(') ADVANCE(82);
      END_STATE();
    case 70:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(222);
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '$') ADVANCE(161);
      if (lookahead == '(') ADVANCE(165);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(180);
      if (lookahead == '@') ADVANCE(116);
      if (lookahead == 'H') ADVANCE(168);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(70)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'') ADVANCE(169);
      END_STATE();
    case 71:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(222);
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == '$') ADVANCE(161);
      if (lookahead == '(') ADVANCE(165);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '>') ADVANCE(180);
      if (lookahead == '@') ADVANCE(116);
      if (lookahead == 'H') ADVANCE(168);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(71)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'') ADVANCE(169);
      END_STATE();
    case 72:
      if (eof) ADVANCE(73);
      if (lookahead == '\n') ADVANCE(221);
      if (lookahead == '\r') ADVANCE(222);
      if (lookahead == '#') ADVANCE(219);
      if (lookahead == ')') ADVANCE(119);
      if (lookahead == ',') ADVANCE(184);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '>') ADVANCE(180);
      if (lookahead == '@') ADVANCE(116);
      if (lookahead == 'H') ADVANCE(186);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(72)
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '\'' &&
          lookahead != '(' &&
          lookahead != '\\') ADVANCE(185);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym_legacy_quoted_stmt_token1);
      if (lookahead == '#') ADVANCE(218);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym_legacy_quoted_stmt_token1);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '\\') ADVANCE(84);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(82);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == 'H') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(84);
      if (lookahead == '~') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(79);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(82);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\\') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(80);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(82);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '>') ADVANCE(182);
      if (lookahead == '\\') ADVANCE(84);
      if (!sym_grep_specifier_identifier_character_set_3(lookahead)) ADVANCE(82);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '\\') ADVANCE(84);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(82);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(83);
      if (lookahead == '\\') ADVANCE(84);
      if (lookahead == ')' ||
          lookahead == '@') ADVANCE(82);
      if (!sym_grep_specifier_identifier_character_set_1(lookahead)) ADVANCE(82);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(83);
      if (lookahead == '\\') ADVANCE(84);
      if (lookahead == '\r' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '>' ||
          lookahead == '@' ||
          lookahead == '`' ||
          lookahead == '|') ADVANCE(82);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(82);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(84);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(82);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_grep_specifier_token1);
      if (lookahead == '$') ADVANCE(85);
      if (lookahead == '(') ADVANCE(214);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '#' &&
          lookahead != ';' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '|') ADVANCE(82);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(aux_sym_grep_specifier_token1);
      if (lookahead == '$') ADVANCE(85);
      if (!sym_grep_specifier_identifier_character_set_1(lookahead)) ADVANCE(82);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '.') ADVANCE(146);
      if (lookahead == 'H') ADVANCE(89);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PIPEH);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_AT_AT_DOT);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_AT_AT_EQ);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_AT_AT_AT_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_AT_AT);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '=') ADVANCE(91);
      if (lookahead == '@') ADVANCE(32);
      if (lookahead == 'C') ADVANCE(96);
      if (lookahead == 'F') ADVANCE(111);
      if (lookahead == 'b') ADVANCE(103);
      if (lookahead == 'c') ADVANCE(29);
      if (lookahead == 'd') ADVANCE(34);
      if (lookahead == 'f') ADVANCE(110);
      if (lookahead == 'i') ADVANCE(104);
      if (lookahead == 'o') ADVANCE(37);
      if (lookahead == 'r') ADVANCE(114);
      if (lookahead == 's') ADVANCE(30);
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_AT_ATc_COLON);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_AT_AT_ATc_COLON);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_AT_ATC);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_AT_ATdbt);
      if (lookahead == 'a') ADVANCE(99);
      if (lookahead == 'b') ADVANCE(100);
      if (lookahead == 's') ADVANCE(101);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_AT_ATdbta);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_AT_ATdbtb);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_AT_ATdbts);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_AT_ATt);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_AT_ATb);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_AT_ATi);
      if (lookahead == 'S') ADVANCE(106);
      if (lookahead == 'i') ADVANCE(105);
      if (lookahead == 's') ADVANCE(108);
      if (lookahead == 'z') ADVANCE(109);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_AT_ATii);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_AT_ATiS);
      if (lookahead == 'S') ADVANCE(107);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_AT_ATiSS);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_AT_ATis);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_AT_ATiz);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_AT_ATf);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_AT_ATF);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_AT_ATom);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_AT_ATdm);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_AT_ATr);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_AT_ATs_COLON);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '!') ADVANCE(117);
      if (lookahead == '(') ADVANCE(118);
      if (lookahead == '@') ADVANCE(93);
      if (lookahead == 'B') ADVANCE(16);
      if (lookahead == 'F') ADVANCE(17);
      if (lookahead == 'a') ADVANCE(18);
      if (lookahead == 'b') ADVANCE(19);
      if (lookahead == 'e') ADVANCE(20);
      if (lookahead == 'f') ADVANCE(21);
      if (lookahead == 'i') ADVANCE(22);
      if (lookahead == 'k') ADVANCE(23);
      if (lookahead == 'o') ADVANCE(24);
      if (lookahead == 'r') ADVANCE(25);
      if (lookahead == 's') ADVANCE(26);
      if (lookahead == 'v') ADVANCE(27);
      if (lookahead == 'x') ADVANCE(28);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AT_BANG);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_AT_LPAREN);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_ATa_COLON);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_ATb_COLON);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_ATB_COLON);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_ATe_COLON);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_ATF_COLON);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_ATi_COLON);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_ATk_COLON);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_ATo_COLON);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_ATr_COLON);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_ATf_COLON);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_ATs_COLON);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_ATv_COLON);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_ATx_COLON);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_0);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == 'b') ADVANCE(47);
      if (lookahead == 'x') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(217);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym_number_stmt_token1);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(135);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym_number_stmt_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym__search_stmt_token1);
      if (lookahead == '!' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('/' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(137);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == ' ') ADVANCE(144);
      if (lookahead == '(') ADVANCE(145);
      if (lookahead == '.') ADVANCE(141);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == ':') ADVANCE(142);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '(') ADVANCE(145);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token1);
      if (lookahead == '.') ADVANCE(173);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == ':') ADVANCE(142);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token1);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == '.' ||
          lookahead == ':') ADVANCE(142);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token2);
      if (lookahead == ' ') ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token3);
      if (lookahead == ' ') ADVANCE(144);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DOT_LPAREN);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_PIPE_DOT);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_DOT_SLASH);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_pfo);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_Cf);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_pf_dot_cmd_identifier);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_pf_dot_full_cmd_identifier);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_pf_cmd_token1);
      if (lookahead == '.') ADVANCE(150);
      if (lookahead == 'o') ADVANCE(148);
      if (lookahead == 'v') ADVANCE(15);
      if (lookahead == '*' ||
          lookahead == 'c' ||
          lookahead == 'j' ||
          lookahead == 'q' ||
          lookahead == 's') ADVANCE(153);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_pf_cmd_token1);
      if (lookahead == '.') ADVANCE(151);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '$') ADVANCE(11);
      if (lookahead == '\\') ADVANCE(60);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(169);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(156);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '{') ADVANCE(159);
      if (lookahead == '.' ||
          lookahead == '=') ADVANCE(158);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(158);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(156);
      if (lookahead == '\\') ADVANCE(61);
      if (!aux_sym__pf_dot_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(12);
      if (lookahead == '\\') ADVANCE(61);
      if (!aux_sym__pf_dot_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(158);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(12);
      if (lookahead == '\\') ADVANCE(50);
      if (lookahead == '}') ADVANCE(158);
      if (aux_sym__pf_dot_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(159);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(196);
      if (lookahead == '(') ADVANCE(214);
      if (lookahead == '{') ADVANCE(54);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(193);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '(') ADVANCE(214);
      if (lookahead == '{') ADVANCE(55);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(169);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(157);
      if (lookahead == '(') ADVANCE(214);
      if (lookahead == '{') ADVANCE(57);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(158);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '{') ADVANCE(58);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(199);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(') ADVANCE(214);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(166);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '{') ADVANCE(170);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(169);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(166);
      if (lookahead == '\\') ADVANCE(60);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(169);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(11);
      if (lookahead == '>') ADVANCE(182);
      if (lookahead == '\\') ADVANCE(60);
      if (!aux_sym_pf_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(169);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(11);
      if (lookahead == '\\') ADVANCE(60);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(11);
      if (lookahead == '\\') ADVANCE(49);
      if (lookahead == '}') ADVANCE(169);
      if (lookahead == '\t' ||
          lookahead == '"' ||
          lookahead == '#' ||
          ('\'' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '>' ||
          lookahead == '@' ||
          lookahead == '`' ||
          ('|' <= lookahead && lookahead <= '~')) ADVANCE(43);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(170);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_env);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == '.' ||
          lookahead == ':') ADVANCE(142);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_system_identifier);
      if (('!' <= lookahead && lookahead <= '=')) ADVANCE(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_question_mark_identifier);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_pointer_identifier);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_macro_identifier);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_macro_identifier);
      if (lookahead == '*' ||
          lookahead == '-') ADVANCE(177);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '>') ADVANCE(181);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_html_redirect_operator);
      if (lookahead == '>') ADVANCE(183);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_html_append_operator);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(aux_sym_tmp_eval_arg_token1);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(aux_sym_tmp_eval_arg_token1);
      if (lookahead == '>') ADVANCE(182);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(41);
      if (lookahead == '%') ADVANCE(187);
      if (lookahead == '5') ADVANCE(189);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(191);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(41);
      if (lookahead == '%') ADVANCE(187);
      if (lookahead == '>') ADVANCE(182);
      if (!sym__eq_sep_key_identifier_character_set_3(lookahead)) ADVANCE(191);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(41);
      if (lookahead == '%') ADVANCE(187);
      if (lookahead == 'C') ADVANCE(190);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(191);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(41);
      if (lookahead == '%') ADVANCE(187);
      if (lookahead == 's') ADVANCE(191);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(41);
      if (lookahead == '%') ADVANCE(187);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(191);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(10);
      if (lookahead == '>') ADVANCE(182);
      if (lookahead == '\\') ADVANCE(59);
      if (!aux_sym_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(193);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(10);
      if (lookahead == '\\') ADVANCE(59);
      if (!aux_sym_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(193);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(10);
      if (lookahead == '\\') ADVANCE(48);
      if (lookahead == '}') ADVANCE(193);
      if (aux_sym_arg_identifier_token1_character_set_4(lookahead)) ADVANCE(42);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(195);
      if (lookahead == ',') ADVANCE(193);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '{') ADVANCE(194);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(193);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(195);
      if (lookahead == '\\') ADVANCE(59);
      if (!aux_sym_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(193);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(aux_sym_spec_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(197);
      if (lookahead == '\\') ADVANCE(62);
      if (lookahead == '{') ADVANCE(200);
      if (lookahead == ',' ||
          lookahead == ':') ADVANCE(199);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(199);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(aux_sym_spec_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(197);
      if (lookahead == '\\') ADVANCE(62);
      if (!aux_sym_spec_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(199);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(aux_sym_spec_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(62);
      if (!aux_sym_spec_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(199);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(aux_sym_spec_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(51);
      if (lookahead == '}') ADVANCE(199);
      if (aux_sym_spec_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(200);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token1);
      if (lookahead == '\r') ADVANCE(203);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(201);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token1);
      if (lookahead == '#') ADVANCE(201);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(203);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(203);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token2);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token2);
      if (lookahead == '(') ADVANCE(214);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(204);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token3);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token3);
      if (lookahead == '\n' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '\\' ||
          lookahead == '`') ADVANCE(206);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token1);
      if (lookahead == '\r') ADVANCE(211);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(209);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token1);
      if (lookahead == '#') ADVANCE(209);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(210);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(211);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(211);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token2);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token2);
      if (lookahead == '\n' ||
          lookahead == '\'' ||
          lookahead == '\\') ADVANCE(212);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(aux_sym__dec_number_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(216);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(aux_sym__dec_number_token2);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(217);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead == '"') ADVANCE(219);
      if (lookahead == '\\') ADVANCE(220);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(218);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(219);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(218);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_CR);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 65, .external_lex_state = 2},
  [2] = {.lex_state = 65, .external_lex_state = 3},
  [3] = {.lex_state = 65, .external_lex_state = 3},
  [4] = {.lex_state = 65, .external_lex_state = 3},
  [5] = {.lex_state = 65, .external_lex_state = 3},
  [6] = {.lex_state = 65, .external_lex_state = 2},
  [7] = {.lex_state = 65, .external_lex_state = 2},
  [8] = {.lex_state = 65, .external_lex_state = 2},
  [9] = {.lex_state = 65, .external_lex_state = 2},
  [10] = {.lex_state = 65, .external_lex_state = 2},
  [11] = {.lex_state = 65, .external_lex_state = 2},
  [12] = {.lex_state = 65, .external_lex_state = 2},
  [13] = {.lex_state = 65, .external_lex_state = 2},
  [14] = {.lex_state = 65, .external_lex_state = 2},
  [15] = {.lex_state = 65, .external_lex_state = 2},
  [16] = {.lex_state = 65, .external_lex_state = 2},
  [17] = {.lex_state = 65, .external_lex_state = 2},
  [18] = {.lex_state = 65, .external_lex_state = 2},
  [19] = {.lex_state = 65, .external_lex_state = 2},
  [20] = {.lex_state = 65, .external_lex_state = 2},
  [21] = {.lex_state = 65, .external_lex_state = 2},
  [22] = {.lex_state = 65, .external_lex_state = 2},
  [23] = {.lex_state = 65, .external_lex_state = 2},
  [24] = {.lex_state = 65, .external_lex_state = 2},
  [25] = {.lex_state = 65, .external_lex_state = 2},
  [26] = {.lex_state = 65, .external_lex_state = 2},
  [27] = {.lex_state = 65, .external_lex_state = 2},
  [28] = {.lex_state = 65, .external_lex_state = 2},
  [29] = {.lex_state = 65, .external_lex_state = 2},
  [30] = {.lex_state = 65, .external_lex_state = 2},
  [31] = {.lex_state = 65, .external_lex_state = 2},
  [32] = {.lex_state = 65, .external_lex_state = 2},
  [33] = {.lex_state = 65, .external_lex_state = 2},
  [34] = {.lex_state = 65, .external_lex_state = 2},
  [35] = {.lex_state = 65, .external_lex_state = 2},
  [36] = {.lex_state = 65, .external_lex_state = 2},
  [37] = {.lex_state = 65, .external_lex_state = 2},
  [38] = {.lex_state = 65, .external_lex_state = 2},
  [39] = {.lex_state = 65, .external_lex_state = 2},
  [40] = {.lex_state = 65, .external_lex_state = 2},
  [41] = {.lex_state = 65, .external_lex_state = 2},
  [42] = {.lex_state = 65, .external_lex_state = 2},
  [43] = {.lex_state = 65, .external_lex_state = 3},
  [44] = {.lex_state = 66, .external_lex_state = 4},
  [45] = {.lex_state = 66, .external_lex_state = 4},
  [46] = {.lex_state = 66, .external_lex_state = 4},
  [47] = {.lex_state = 66, .external_lex_state = 4},
  [48] = {.lex_state = 66, .external_lex_state = 4},
  [49] = {.lex_state = 66, .external_lex_state = 4},
  [50] = {.lex_state = 66, .external_lex_state = 4},
  [51] = {.lex_state = 66, .external_lex_state = 4},
  [52] = {.lex_state = 66, .external_lex_state = 4},
  [53] = {.lex_state = 66, .external_lex_state = 4},
  [54] = {.lex_state = 66, .external_lex_state = 4},
  [55] = {.lex_state = 66, .external_lex_state = 4},
  [56] = {.lex_state = 66, .external_lex_state = 4},
  [57] = {.lex_state = 66, .external_lex_state = 4},
  [58] = {.lex_state = 70, .external_lex_state = 5},
  [59] = {.lex_state = 66, .external_lex_state = 4},
  [60] = {.lex_state = 66, .external_lex_state = 4},
  [61] = {.lex_state = 66, .external_lex_state = 4},
  [62] = {.lex_state = 66, .external_lex_state = 4},
  [63] = {.lex_state = 66, .external_lex_state = 4},
  [64] = {.lex_state = 66, .external_lex_state = 4},
  [65] = {.lex_state = 66, .external_lex_state = 4},
  [66] = {.lex_state = 66, .external_lex_state = 4},
  [67] = {.lex_state = 66, .external_lex_state = 4},
  [68] = {.lex_state = 66, .external_lex_state = 4},
  [69] = {.lex_state = 66, .external_lex_state = 4},
  [70] = {.lex_state = 66, .external_lex_state = 4},
  [71] = {.lex_state = 66, .external_lex_state = 4},
  [72] = {.lex_state = 71, .external_lex_state = 4},
  [73] = {.lex_state = 70, .external_lex_state = 5},
  [74] = {.lex_state = 68, .external_lex_state = 4},
  [75] = {.lex_state = 71, .external_lex_state = 4},
  [76] = {.lex_state = 66, .external_lex_state = 6},
  [77] = {.lex_state = 66, .external_lex_state = 7},
  [78] = {.lex_state = 66, .external_lex_state = 7},
  [79] = {.lex_state = 66, .external_lex_state = 6},
  [80] = {.lex_state = 66, .external_lex_state = 7},
  [81] = {.lex_state = 66, .external_lex_state = 6},
  [82] = {.lex_state = 66, .external_lex_state = 7},
  [83] = {.lex_state = 66, .external_lex_state = 7},
  [84] = {.lex_state = 66, .external_lex_state = 7},
  [85] = {.lex_state = 66, .external_lex_state = 7},
  [86] = {.lex_state = 66, .external_lex_state = 7},
  [87] = {.lex_state = 66, .external_lex_state = 7},
  [88] = {.lex_state = 66, .external_lex_state = 7},
  [89] = {.lex_state = 66, .external_lex_state = 7},
  [90] = {.lex_state = 66, .external_lex_state = 6},
  [91] = {.lex_state = 66, .external_lex_state = 6},
  [92] = {.lex_state = 66, .external_lex_state = 7},
  [93] = {.lex_state = 66, .external_lex_state = 7},
  [94] = {.lex_state = 71, .external_lex_state = 4},
  [95] = {.lex_state = 70, .external_lex_state = 5},
  [96] = {.lex_state = 66, .external_lex_state = 4},
  [97] = {.lex_state = 70, .external_lex_state = 5},
  [98] = {.lex_state = 66, .external_lex_state = 4},
  [99] = {.lex_state = 70, .external_lex_state = 5},
  [100] = {.lex_state = 68, .external_lex_state = 4},
  [101] = {.lex_state = 71, .external_lex_state = 7},
  [102] = {.lex_state = 70, .external_lex_state = 5},
  [103] = {.lex_state = 70, .external_lex_state = 5},
  [104] = {.lex_state = 70, .external_lex_state = 5},
  [105] = {.lex_state = 70, .external_lex_state = 5},
  [106] = {.lex_state = 70, .external_lex_state = 5},
  [107] = {.lex_state = 71, .external_lex_state = 7},
  [108] = {.lex_state = 71, .external_lex_state = 7},
  [109] = {.lex_state = 71, .external_lex_state = 7},
  [110] = {.lex_state = 71, .external_lex_state = 7},
  [111] = {.lex_state = 71, .external_lex_state = 7},
  [112] = {.lex_state = 71, .external_lex_state = 7},
  [113] = {.lex_state = 71, .external_lex_state = 7},
  [114] = {.lex_state = 69, .external_lex_state = 4},
  [115] = {.lex_state = 71, .external_lex_state = 4},
  [116] = {.lex_state = 68, .external_lex_state = 4},
  [117] = {.lex_state = 69, .external_lex_state = 4},
  [118] = {.lex_state = 0, .external_lex_state = 8},
  [119] = {.lex_state = 65, .external_lex_state = 5},
  [120] = {.lex_state = 0, .external_lex_state = 8},
  [121] = {.lex_state = 65, .external_lex_state = 5},
  [122] = {.lex_state = 65, .external_lex_state = 9},
  [123] = {.lex_state = 65, .external_lex_state = 5},
  [124] = {.lex_state = 0, .external_lex_state = 8},
  [125] = {.lex_state = 65, .external_lex_state = 9},
  [126] = {.lex_state = 72, .external_lex_state = 4},
  [127] = {.lex_state = 72, .external_lex_state = 4},
  [128] = {.lex_state = 65, .external_lex_state = 5},
  [129] = {.lex_state = 65, .external_lex_state = 5},
  [130] = {.lex_state = 65, .external_lex_state = 9},
  [131] = {.lex_state = 65, .external_lex_state = 5},
  [132] = {.lex_state = 0, .external_lex_state = 8},
  [133] = {.lex_state = 0, .external_lex_state = 4},
  [134] = {.lex_state = 65, .external_lex_state = 5},
  [135] = {.lex_state = 0, .external_lex_state = 4},
  [136] = {.lex_state = 0, .external_lex_state = 8},
  [137] = {.lex_state = 65, .external_lex_state = 9},
  [138] = {.lex_state = 0, .external_lex_state = 4},
  [139] = {.lex_state = 0, .external_lex_state = 9},
  [140] = {.lex_state = 65, .external_lex_state = 9},
  [141] = {.lex_state = 0, .external_lex_state = 4},
  [142] = {.lex_state = 65, .external_lex_state = 5},
  [143] = {.lex_state = 0, .external_lex_state = 8},
  [144] = {.lex_state = 0, .external_lex_state = 8},
  [145] = {.lex_state = 65, .external_lex_state = 9},
  [146] = {.lex_state = 65, .external_lex_state = 5},
  [147] = {.lex_state = 65, .external_lex_state = 9},
  [148] = {.lex_state = 65, .external_lex_state = 5},
  [149] = {.lex_state = 65, .external_lex_state = 9},
  [150] = {.lex_state = 69, .external_lex_state = 4},
  [151] = {.lex_state = 0, .external_lex_state = 8},
  [152] = {.lex_state = 0, .external_lex_state = 8},
  [153] = {.lex_state = 0, .external_lex_state = 8},
  [154] = {.lex_state = 0, .external_lex_state = 8},
  [155] = {.lex_state = 0, .external_lex_state = 8},
  [156] = {.lex_state = 0, .external_lex_state = 9},
  [157] = {.lex_state = 65, .external_lex_state = 9},
  [158] = {.lex_state = 0, .external_lex_state = 8},
  [159] = {.lex_state = 65, .external_lex_state = 5},
  [160] = {.lex_state = 69, .external_lex_state = 4},
  [161] = {.lex_state = 69, .external_lex_state = 4},
  [162] = {.lex_state = 65, .external_lex_state = 9},
  [163] = {.lex_state = 69, .external_lex_state = 4},
  [164] = {.lex_state = 65, .external_lex_state = 5},
  [165] = {.lex_state = 0, .external_lex_state = 8},
  [166] = {.lex_state = 69, .external_lex_state = 4},
  [167] = {.lex_state = 65, .external_lex_state = 4},
  [168] = {.lex_state = 65, .external_lex_state = 4},
  [169] = {.lex_state = 65, .external_lex_state = 4},
  [170] = {.lex_state = 0, .external_lex_state = 9},
  [171] = {.lex_state = 0, .external_lex_state = 4},
  [172] = {.lex_state = 0, .external_lex_state = 4},
  [173] = {.lex_state = 0, .external_lex_state = 4},
  [174] = {.lex_state = 0, .external_lex_state = 4},
  [175] = {.lex_state = 0, .external_lex_state = 9},
  [176] = {.lex_state = 0, .external_lex_state = 4},
  [177] = {.lex_state = 65, .external_lex_state = 4},
  [178] = {.lex_state = 0, .external_lex_state = 4},
  [179] = {.lex_state = 65, .external_lex_state = 4},
  [180] = {.lex_state = 0, .external_lex_state = 4},
  [181] = {.lex_state = 0, .external_lex_state = 4},
  [182] = {.lex_state = 0, .external_lex_state = 4},
  [183] = {.lex_state = 69, .external_lex_state = 4},
  [184] = {.lex_state = 0, .external_lex_state = 4},
  [185] = {.lex_state = 0, .external_lex_state = 4},
  [186] = {.lex_state = 0, .external_lex_state = 4},
  [187] = {.lex_state = 0, .external_lex_state = 4},
  [188] = {.lex_state = 0, .external_lex_state = 4},
  [189] = {.lex_state = 0, .external_lex_state = 4},
  [190] = {.lex_state = 0, .external_lex_state = 4},
  [191] = {.lex_state = 0, .external_lex_state = 4},
  [192] = {.lex_state = 65, .external_lex_state = 4},
  [193] = {.lex_state = 64, .external_lex_state = 4},
  [194] = {.lex_state = 69, .external_lex_state = 4},
  [195] = {.lex_state = 0, .external_lex_state = 4},
  [196] = {.lex_state = 0, .external_lex_state = 4},
  [197] = {.lex_state = 0, .external_lex_state = 4},
  [198] = {.lex_state = 0, .external_lex_state = 4},
  [199] = {.lex_state = 0, .external_lex_state = 4},
  [200] = {.lex_state = 0, .external_lex_state = 4},
  [201] = {.lex_state = 0, .external_lex_state = 4},
  [202] = {.lex_state = 0, .external_lex_state = 4},
  [203] = {.lex_state = 0, .external_lex_state = 4},
  [204] = {.lex_state = 0, .external_lex_state = 4},
  [205] = {.lex_state = 0, .external_lex_state = 4},
  [206] = {.lex_state = 0, .external_lex_state = 4},
  [207] = {.lex_state = 0, .external_lex_state = 4},
  [208] = {.lex_state = 0, .external_lex_state = 4},
  [209] = {.lex_state = 0, .external_lex_state = 4},
  [210] = {.lex_state = 0, .external_lex_state = 5},
  [211] = {.lex_state = 0, .external_lex_state = 4},
  [212] = {.lex_state = 0, .external_lex_state = 4},
  [213] = {.lex_state = 0, .external_lex_state = 4},
  [214] = {.lex_state = 0, .external_lex_state = 4},
  [215] = {.lex_state = 0, .external_lex_state = 4},
  [216] = {.lex_state = 0, .external_lex_state = 4},
  [217] = {.lex_state = 0, .external_lex_state = 4},
  [218] = {.lex_state = 0, .external_lex_state = 4},
  [219] = {.lex_state = 0, .external_lex_state = 4},
  [220] = {.lex_state = 0, .external_lex_state = 4},
  [221] = {.lex_state = 0, .external_lex_state = 4},
  [222] = {.lex_state = 0, .external_lex_state = 4},
  [223] = {.lex_state = 0, .external_lex_state = 4},
  [224] = {.lex_state = 0, .external_lex_state = 4},
  [225] = {.lex_state = 0, .external_lex_state = 4},
  [226] = {.lex_state = 0, .external_lex_state = 4},
  [227] = {.lex_state = 0, .external_lex_state = 4},
  [228] = {.lex_state = 0, .external_lex_state = 4},
  [229] = {.lex_state = 0, .external_lex_state = 4},
  [230] = {.lex_state = 0, .external_lex_state = 4},
  [231] = {.lex_state = 0, .external_lex_state = 4},
  [232] = {.lex_state = 0, .external_lex_state = 4},
  [233] = {.lex_state = 0, .external_lex_state = 4},
  [234] = {.lex_state = 0, .external_lex_state = 4},
  [235] = {.lex_state = 0, .external_lex_state = 4},
  [236] = {.lex_state = 0, .external_lex_state = 4},
  [237] = {.lex_state = 0, .external_lex_state = 4},
  [238] = {.lex_state = 0, .external_lex_state = 4},
  [239] = {.lex_state = 0, .external_lex_state = 4},
  [240] = {.lex_state = 0, .external_lex_state = 4},
  [241] = {.lex_state = 0, .external_lex_state = 4},
  [242] = {.lex_state = 0, .external_lex_state = 4},
  [243] = {.lex_state = 0, .external_lex_state = 4},
  [244] = {.lex_state = 0, .external_lex_state = 4},
  [245] = {.lex_state = 0, .external_lex_state = 4},
  [246] = {.lex_state = 0, .external_lex_state = 4},
  [247] = {.lex_state = 0, .external_lex_state = 4},
  [248] = {.lex_state = 0, .external_lex_state = 4},
  [249] = {.lex_state = 0, .external_lex_state = 4},
  [250] = {.lex_state = 0, .external_lex_state = 4},
  [251] = {.lex_state = 0, .external_lex_state = 4},
  [252] = {.lex_state = 0, .external_lex_state = 4},
  [253] = {.lex_state = 0, .external_lex_state = 4},
  [254] = {.lex_state = 0, .external_lex_state = 4},
  [255] = {.lex_state = 0, .external_lex_state = 4},
  [256] = {.lex_state = 0, .external_lex_state = 4},
  [257] = {.lex_state = 0, .external_lex_state = 4},
  [258] = {.lex_state = 0, .external_lex_state = 4},
  [259] = {.lex_state = 0, .external_lex_state = 4},
  [260] = {.lex_state = 0, .external_lex_state = 4},
  [261] = {.lex_state = 0, .external_lex_state = 4},
  [262] = {.lex_state = 0, .external_lex_state = 4},
  [263] = {.lex_state = 0, .external_lex_state = 4},
  [264] = {.lex_state = 0, .external_lex_state = 4},
  [265] = {.lex_state = 0, .external_lex_state = 4},
  [266] = {.lex_state = 0, .external_lex_state = 4},
  [267] = {.lex_state = 0, .external_lex_state = 4},
  [268] = {.lex_state = 0, .external_lex_state = 4},
  [269] = {.lex_state = 0, .external_lex_state = 4},
  [270] = {.lex_state = 0, .external_lex_state = 4},
  [271] = {.lex_state = 0, .external_lex_state = 4},
  [272] = {.lex_state = 0, .external_lex_state = 4},
  [273] = {.lex_state = 0, .external_lex_state = 4},
  [274] = {.lex_state = 65, .external_lex_state = 4},
  [275] = {.lex_state = 64, .external_lex_state = 4},
  [276] = {.lex_state = 0, .external_lex_state = 5},
  [277] = {.lex_state = 0, .external_lex_state = 4},
  [278] = {.lex_state = 0, .external_lex_state = 4},
  [279] = {.lex_state = 65, .external_lex_state = 2},
  [280] = {.lex_state = 65, .external_lex_state = 2},
  [281] = {.lex_state = 67},
  [282] = {.lex_state = 67},
  [283] = {.lex_state = 67},
  [284] = {.lex_state = 67},
  [285] = {.lex_state = 67},
  [286] = {.lex_state = 67},
  [287] = {.lex_state = 67},
  [288] = {.lex_state = 67},
  [289] = {.lex_state = 67},
  [290] = {.lex_state = 67},
  [291] = {.lex_state = 67},
  [292] = {.lex_state = 67},
  [293] = {.lex_state = 67},
  [294] = {.lex_state = 67},
  [295] = {.lex_state = 67},
  [296] = {.lex_state = 67},
  [297] = {.lex_state = 67},
  [298] = {.lex_state = 67},
  [299] = {.lex_state = 67},
  [300] = {.lex_state = 67},
  [301] = {.lex_state = 67},
  [302] = {.lex_state = 67},
  [303] = {.lex_state = 67},
  [304] = {.lex_state = 67},
  [305] = {.lex_state = 67},
  [306] = {.lex_state = 67},
  [307] = {.lex_state = 67},
  [308] = {.lex_state = 67},
  [309] = {.lex_state = 67},
  [310] = {.lex_state = 67},
  [311] = {.lex_state = 67},
  [312] = {.lex_state = 67},
  [313] = {.lex_state = 67},
  [314] = {.lex_state = 67},
  [315] = {.lex_state = 67},
  [316] = {.lex_state = 67},
  [317] = {.lex_state = 67},
  [318] = {.lex_state = 67},
  [319] = {.lex_state = 67},
  [320] = {.lex_state = 67},
  [321] = {.lex_state = 67},
  [322] = {.lex_state = 67},
  [323] = {.lex_state = 67},
  [324] = {.lex_state = 67, .external_lex_state = 10},
  [325] = {.lex_state = 67, .external_lex_state = 10},
  [326] = {.lex_state = 67, .external_lex_state = 10},
  [327] = {.lex_state = 67, .external_lex_state = 10},
  [328] = {.lex_state = 67, .external_lex_state = 10},
  [329] = {.lex_state = 67, .external_lex_state = 10},
  [330] = {.lex_state = 67},
  [331] = {.lex_state = 67},
  [332] = {.lex_state = 67},
  [333] = {.lex_state = 67, .external_lex_state = 10},
  [334] = {.lex_state = 67, .external_lex_state = 10},
  [335] = {.lex_state = 67},
  [336] = {.lex_state = 67, .external_lex_state = 10},
  [337] = {.lex_state = 67, .external_lex_state = 10},
  [338] = {.lex_state = 67},
  [339] = {.lex_state = 67, .external_lex_state = 10},
  [340] = {.lex_state = 67, .external_lex_state = 10},
  [341] = {.lex_state = 67, .external_lex_state = 10},
  [342] = {.lex_state = 5},
  [343] = {.lex_state = 5},
  [344] = {.lex_state = 5},
  [345] = {.lex_state = 5},
  [346] = {.lex_state = 5},
  [347] = {.lex_state = 5},
  [348] = {.lex_state = 5},
  [349] = {.lex_state = 5},
  [350] = {.lex_state = 5},
  [351] = {.lex_state = 67},
  [352] = {.lex_state = 5},
  [353] = {.lex_state = 1},
  [354] = {.lex_state = 6},
  [355] = {.lex_state = 6},
  [356] = {.lex_state = 6},
  [357] = {.lex_state = 6},
  [358] = {.lex_state = 5},
  [359] = {.lex_state = 5},
  [360] = {.lex_state = 1},
  [361] = {.lex_state = 6},
  [362] = {.lex_state = 2},
  [363] = {.lex_state = 2},
  [364] = {.lex_state = 2},
  [365] = {.lex_state = 2},
  [366] = {.lex_state = 2},
  [367] = {.lex_state = 2},
  [368] = {.lex_state = 2},
  [369] = {.lex_state = 67},
  [370] = {.lex_state = 67},
  [371] = {.lex_state = 67},
  [372] = {.lex_state = 2},
  [373] = {.lex_state = 5, .external_lex_state = 10},
  [374] = {.lex_state = 2},
  [375] = {.lex_state = 2},
  [376] = {.lex_state = 5, .external_lex_state = 10},
  [377] = {.lex_state = 67},
  [378] = {.lex_state = 2},
  [379] = {.lex_state = 5, .external_lex_state = 10},
  [380] = {.lex_state = 2},
  [381] = {.lex_state = 2},
  [382] = {.lex_state = 67},
  [383] = {.lex_state = 5, .external_lex_state = 10},
  [384] = {.lex_state = 5, .external_lex_state = 10},
  [385] = {.lex_state = 5, .external_lex_state = 10},
  [386] = {.lex_state = 5, .external_lex_state = 10},
  [387] = {.lex_state = 5, .external_lex_state = 10},
  [388] = {.lex_state = 6},
  [389] = {.lex_state = 6},
  [390] = {.lex_state = 5, .external_lex_state = 10},
  [391] = {.lex_state = 5, .external_lex_state = 10},
  [392] = {.lex_state = 3},
  [393] = {.lex_state = 3},
  [394] = {.lex_state = 5, .external_lex_state = 10},
  [395] = {.lex_state = 3},
  [396] = {.lex_state = 5, .external_lex_state = 10},
  [397] = {.lex_state = 5, .external_lex_state = 10},
  [398] = {.lex_state = 0},
  [399] = {.lex_state = 5},
  [400] = {.lex_state = 5, .external_lex_state = 10},
  [401] = {.lex_state = 5, .external_lex_state = 10},
  [402] = {.lex_state = 2},
  [403] = {.lex_state = 5, .external_lex_state = 10},
  [404] = {.lex_state = 2},
  [405] = {.lex_state = 5, .external_lex_state = 10},
  [406] = {.lex_state = 5, .external_lex_state = 10},
  [407] = {.lex_state = 5, .external_lex_state = 10},
  [408] = {.lex_state = 0},
  [409] = {.lex_state = 0},
  [410] = {.lex_state = 0},
  [411] = {.lex_state = 0},
  [412] = {.lex_state = 0},
  [413] = {.lex_state = 5},
  [414] = {.lex_state = 8},
  [415] = {.lex_state = 8},
  [416] = {.lex_state = 0},
  [417] = {.lex_state = 8},
  [418] = {.lex_state = 8},
  [419] = {.lex_state = 8},
  [420] = {.lex_state = 8},
  [421] = {.lex_state = 8},
  [422] = {.lex_state = 8},
  [423] = {.lex_state = 8},
  [424] = {.lex_state = 8},
  [425] = {.lex_state = 7},
  [426] = {.lex_state = 8},
  [427] = {.lex_state = 8},
  [428] = {.lex_state = 8},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 0},
  [431] = {.lex_state = 0},
  [432] = {.lex_state = 0, .external_lex_state = 11},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 0, .external_lex_state = 11},
  [435] = {.lex_state = 0},
  [436] = {.lex_state = 4},
  [437] = {.lex_state = 0},
  [438] = {.lex_state = 0},
  [439] = {.lex_state = 0},
  [440] = {.lex_state = 0},
  [441] = {.lex_state = 7},
  [442] = {.lex_state = 0},
  [443] = {.lex_state = 0},
  [444] = {.lex_state = 0},
  [445] = {.lex_state = 0},
  [446] = {.lex_state = 0},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 0},
  [449] = {.lex_state = 0, .external_lex_state = 12},
  [450] = {.lex_state = 0, .external_lex_state = 11},
  [451] = {.lex_state = 65},
  [452] = {.lex_state = 0, .external_lex_state = 11},
  [453] = {.lex_state = 0, .external_lex_state = 11},
  [454] = {.lex_state = 0, .external_lex_state = 11},
  [455] = {.lex_state = 65},
  [456] = {.lex_state = 0, .external_lex_state = 11},
  [457] = {.lex_state = 0, .external_lex_state = 11},
  [458] = {.lex_state = 0},
  [459] = {.lex_state = 0, .external_lex_state = 11},
  [460] = {.lex_state = 0},
  [461] = {.lex_state = 0, .external_lex_state = 11},
  [462] = {.lex_state = 0, .external_lex_state = 11},
  [463] = {.lex_state = 0},
  [464] = {.lex_state = 0, .external_lex_state = 11},
  [465] = {.lex_state = 0},
  [466] = {.lex_state = 0},
  [467] = {.lex_state = 0},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 0},
  [470] = {.lex_state = 0},
  [471] = {.lex_state = 0},
  [472] = {.lex_state = 0},
  [473] = {.lex_state = 0},
  [474] = {.lex_state = 0},
  [475] = {.lex_state = 0},
  [476] = {.lex_state = 0, .external_lex_state = 12},
  [477] = {.lex_state = 0},
  [478] = {.lex_state = 0},
  [479] = {.lex_state = 0},
  [480] = {.lex_state = 0, .external_lex_state = 10},
  [481] = {.lex_state = 0, .external_lex_state = 13},
  [482] = {.lex_state = 0, .external_lex_state = 10},
  [483] = {.lex_state = 0},
  [484] = {.lex_state = 0},
  [485] = {.lex_state = 0},
  [486] = {.lex_state = 0},
  [487] = {.lex_state = 0},
  [488] = {.lex_state = 9},
  [489] = {.lex_state = 0},
  [490] = {.lex_state = 0},
  [491] = {.lex_state = 0},
  [492] = {.lex_state = 6},
  [493] = {.lex_state = 0},
  [494] = {.lex_state = 0},
  [495] = {.lex_state = 0},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 0},
  [498] = {.lex_state = 0},
  [499] = {.lex_state = 0},
  [500] = {.lex_state = 0, .external_lex_state = 13},
  [501] = {.lex_state = 0},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 0},
  [504] = {.lex_state = 0},
  [505] = {.lex_state = 0, .external_lex_state = 10},
  [506] = {.lex_state = 0},
  [507] = {.lex_state = 0},
  [508] = {.lex_state = 0, .external_lex_state = 13},
};

enum {
  ts_external_token__cmd_identifier = 0,
  ts_external_token__help_stmt = 1,
  ts_external_token_file_descriptor = 2,
  ts_external_token__eq_sep_concat = 3,
  ts_external_token__concat = 4,
  ts_external_token__concat_pf_dot = 5,
  ts_external_token__spec_sep = 6,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__cmd_identifier] = sym__cmd_identifier,
  [ts_external_token__help_stmt] = sym__help_stmt,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__eq_sep_concat] = sym__eq_sep_concat,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token__concat_pf_dot] = sym__concat_pf_dot,
  [ts_external_token__spec_sep] = sym__spec_sep,
};

static bool ts_external_scanner_states[14][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__cmd_identifier] = true,
    [ts_external_token__help_stmt] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__eq_sep_concat] = true,
    [ts_external_token__concat] = true,
    [ts_external_token__concat_pf_dot] = true,
    [ts_external_token__spec_sep] = true,
  },
  [2] = {
    [ts_external_token__cmd_identifier] = true,
    [ts_external_token__help_stmt] = true,
  },
  [3] = {
    [ts_external_token__cmd_identifier] = true,
    [ts_external_token__help_stmt] = true,
    [ts_external_token_file_descriptor] = true,
  },
  [4] = {
    [ts_external_token_file_descriptor] = true,
  },
  [5] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat_pf_dot] = true,
  },
  [6] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__spec_sep] = true,
  },
  [7] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [8] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__eq_sep_concat] = true,
    [ts_external_token__concat] = true,
  },
  [9] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__eq_sep_concat] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
  },
  [11] = {
    [ts_external_token__eq_sep_concat] = true,
    [ts_external_token__concat] = true,
  },
  [12] = {
    [ts_external_token__eq_sep_concat] = true,
  },
  [13] = {
    [ts_external_token__concat_pf_dot] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PIPEH] = ACTIONS(1),
    [anon_sym_AT_AT_DOT] = ACTIONS(1),
    [anon_sym_AT_AT_EQ] = ACTIONS(1),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(1),
    [anon_sym_AT_AT] = ACTIONS(1),
    [anon_sym_AT_ATc_COLON] = ACTIONS(1),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(1),
    [anon_sym_AT_ATC] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_AT_ATdbt] = ACTIONS(1),
    [anon_sym_AT_ATdbta] = ACTIONS(1),
    [anon_sym_AT_ATdbtb] = ACTIONS(1),
    [anon_sym_AT_ATdbts] = ACTIONS(1),
    [anon_sym_AT_ATt] = ACTIONS(1),
    [anon_sym_AT_ATb] = ACTIONS(1),
    [anon_sym_AT_ATi] = ACTIONS(1),
    [anon_sym_AT_ATii] = ACTIONS(1),
    [anon_sym_AT_ATiS] = ACTIONS(1),
    [anon_sym_AT_ATiSS] = ACTIONS(1),
    [anon_sym_AT_ATis] = ACTIONS(1),
    [anon_sym_AT_ATiz] = ACTIONS(1),
    [anon_sym_AT_ATf] = ACTIONS(1),
    [anon_sym_AT_ATF] = ACTIONS(1),
    [anon_sym_AT_ATom] = ACTIONS(1),
    [anon_sym_AT_ATdm] = ACTIONS(1),
    [anon_sym_AT_ATr] = ACTIONS(1),
    [anon_sym_AT_ATs_COLON] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_AT_BANG] = ACTIONS(1),
    [anon_sym_AT_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_ATa_COLON] = ACTIONS(1),
    [anon_sym_ATb_COLON] = ACTIONS(1),
    [anon_sym_ATB_COLON] = ACTIONS(1),
    [anon_sym_ATe_COLON] = ACTIONS(1),
    [anon_sym_ATF_COLON] = ACTIONS(1),
    [anon_sym_ATi_COLON] = ACTIONS(1),
    [anon_sym_ATk_COLON] = ACTIONS(1),
    [anon_sym_ATo_COLON] = ACTIONS(1),
    [anon_sym_ATr_COLON] = ACTIONS(1),
    [anon_sym_ATf_COLON] = ACTIONS(1),
    [anon_sym_ATs_COLON] = ACTIONS(1),
    [anon_sym_ATv_COLON] = ACTIONS(1),
    [anon_sym_ATx_COLON] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [aux_sym__search_stmt_token1] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_LPAREN] = ACTIONS(1),
    [anon_sym_PIPE_DOT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [sym_question_mark_identifier] = ACTIONS(1),
    [sym_pointer_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [sym_html_redirect_operator] = ACTIONS(1),
    [sym_html_append_operator] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [aux_sym_tmp_eval_arg_token1] = ACTIONS(1),
    [aux_sym_double_quoted_arg_token3] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1),
    [anon_sym_CR] = ACTIONS(1),
    [sym__cmd_identifier] = ACTIONS(1),
    [sym__help_stmt] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__eq_sep_concat] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym__concat_pf_dot] = ACTIONS(1),
    [sym__spec_sep] = ACTIONS(1),
  },
  [1] = {
    [sym_statements] = STATE(496),
    [sym__statement] = STATE(410),
    [sym_legacy_quoted_stmt] = STATE(180),
    [sym__simple_stmt] = STATE(180),
    [sym__tmp_stmt] = STATE(180),
    [sym__iter_stmt] = STATE(180),
    [sym__pipe_stmt] = STATE(180),
    [sym_grep_stmt] = STATE(180),
    [sym_html_disable_stmt] = STATE(180),
    [sym_html_enable_stmt] = STATE(180),
    [sym_pipe_stmt] = STATE(180),
    [sym_iter_file_lines_stmt] = STATE(180),
    [sym_iter_offsets_stmt] = STATE(180),
    [sym_iter_offsetssizes_stmt] = STATE(180),
    [sym_iter_hit_stmt] = STATE(180),
    [sym_iter_interpret_stmt] = STATE(180),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(180),
    [sym_iter_comment_stmt] = STATE(180),
    [sym_iter_dbta_stmt] = STATE(180),
    [sym_iter_dbtb_stmt] = STATE(180),
    [sym_iter_dbts_stmt] = STATE(180),
    [sym_iter_threads_stmt] = STATE(180),
    [sym_iter_bbs_stmt] = STATE(180),
    [sym_iter_instrs_stmt] = STATE(180),
    [sym_iter_import_stmt] = STATE(180),
    [sym_iter_sections_stmt] = STATE(180),
    [sym_iter_segments_stmt] = STATE(180),
    [sym_iter_symbol_stmt] = STATE(180),
    [sym_iter_string_stmt] = STATE(180),
    [sym_iter_flags_stmt] = STATE(180),
    [sym_iter_function_stmt] = STATE(180),
    [sym_iter_iomap_stmt] = STATE(180),
    [sym_iter_dbgmap_stmt] = STATE(180),
    [sym_iter_register_stmt] = STATE(180),
    [sym_iter_step_stmt] = STATE(180),
    [sym_tmp_seek_stmt] = STATE(180),
    [sym_tmp_blksz_stmt] = STATE(180),
    [sym_tmp_fromto_stmt] = STATE(180),
    [sym_tmp_arch_stmt] = STATE(180),
    [sym_tmp_bits_stmt] = STATE(180),
    [sym_tmp_nthi_stmt] = STATE(180),
    [sym_tmp_eval_stmt] = STATE(180),
    [sym_tmp_fs_stmt] = STATE(180),
    [sym_tmp_reli_stmt] = STATE(180),
    [sym_tmp_kuery_stmt] = STATE(180),
    [sym_tmp_fd_stmt] = STATE(180),
    [sym_tmp_reg_stmt] = STATE(180),
    [sym_tmp_file_stmt] = STATE(180),
    [sym_tmp_string_stmt] = STATE(180),
    [sym_tmp_value_stmt] = STATE(180),
    [sym_tmp_hex_stmt] = STATE(180),
    [sym_number_stmt] = STATE(180),
    [sym_help_stmt] = STATE(180),
    [sym_arged_stmt] = STATE(180),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(180),
    [sym_Cf_cmd] = STATE(180),
    [sym_pf_new_cmd] = STATE(180),
    [sym_pf_dot_cmd] = STATE(180),
    [sym_pf_cmd] = STATE(180),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(180),
    [sym_redirect_stmt] = STATE(410),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym_statements_repeat1] = STATE(6),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(45),
    [anon_sym_CR] = ACTIONS(45),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [2] = {
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_number_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(269),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [ts_builtin_sym_end] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_PIPEH] = ACTIONS(55),
    [anon_sym_AT_AT_DOT] = ACTIONS(55),
    [anon_sym_AT_AT_EQ] = ACTIONS(55),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(55),
    [anon_sym_AT_AT] = ACTIONS(57),
    [anon_sym_AT_ATc_COLON] = ACTIONS(55),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(55),
    [anon_sym_AT_ATC] = ACTIONS(55),
    [anon_sym_AT_ATdbt] = ACTIONS(57),
    [anon_sym_AT_ATdbta] = ACTIONS(55),
    [anon_sym_AT_ATdbtb] = ACTIONS(55),
    [anon_sym_AT_ATdbts] = ACTIONS(55),
    [anon_sym_AT_ATt] = ACTIONS(55),
    [anon_sym_AT_ATb] = ACTIONS(55),
    [anon_sym_AT_ATi] = ACTIONS(57),
    [anon_sym_AT_ATii] = ACTIONS(55),
    [anon_sym_AT_ATiS] = ACTIONS(57),
    [anon_sym_AT_ATiSS] = ACTIONS(55),
    [anon_sym_AT_ATis] = ACTIONS(55),
    [anon_sym_AT_ATiz] = ACTIONS(55),
    [anon_sym_AT_ATf] = ACTIONS(55),
    [anon_sym_AT_ATF] = ACTIONS(55),
    [anon_sym_AT_ATom] = ACTIONS(55),
    [anon_sym_AT_ATdm] = ACTIONS(55),
    [anon_sym_AT_ATr] = ACTIONS(55),
    [anon_sym_AT_ATs_COLON] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_AT_BANG] = ACTIONS(55),
    [anon_sym_AT_LPAREN] = ACTIONS(55),
    [anon_sym_RPAREN] = ACTIONS(55),
    [anon_sym_ATa_COLON] = ACTIONS(55),
    [anon_sym_ATb_COLON] = ACTIONS(55),
    [anon_sym_ATB_COLON] = ACTIONS(55),
    [anon_sym_ATe_COLON] = ACTIONS(55),
    [anon_sym_ATF_COLON] = ACTIONS(55),
    [anon_sym_ATi_COLON] = ACTIONS(55),
    [anon_sym_ATk_COLON] = ACTIONS(55),
    [anon_sym_ATo_COLON] = ACTIONS(55),
    [anon_sym_ATr_COLON] = ACTIONS(55),
    [anon_sym_ATf_COLON] = ACTIONS(55),
    [anon_sym_ATs_COLON] = ACTIONS(55),
    [anon_sym_ATv_COLON] = ACTIONS(55),
    [anon_sym_ATx_COLON] = ACTIONS(55),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_PIPE_DOT] = ACTIONS(55),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(55),
    [anon_sym_GT] = ACTIONS(57),
    [anon_sym_GT_GT] = ACTIONS(55),
    [sym_html_redirect_operator] = ACTIONS(57),
    [sym_html_append_operator] = ACTIONS(55),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(55),
    [anon_sym_CR] = ACTIONS(55),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
    [sym_file_descriptor] = ACTIONS(55),
  },
  [3] = {
    [sym_legacy_quoted_stmt] = STATE(202),
    [sym__simple_stmt] = STATE(202),
    [sym__tmp_stmt] = STATE(202),
    [sym__iter_stmt] = STATE(202),
    [sym__pipe_stmt] = STATE(202),
    [sym_grep_stmt] = STATE(202),
    [sym_html_disable_stmt] = STATE(202),
    [sym_html_enable_stmt] = STATE(202),
    [sym_pipe_stmt] = STATE(202),
    [sym_iter_file_lines_stmt] = STATE(202),
    [sym_iter_offsets_stmt] = STATE(202),
    [sym_iter_offsetssizes_stmt] = STATE(202),
    [sym_iter_hit_stmt] = STATE(202),
    [sym_iter_interpret_stmt] = STATE(202),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(202),
    [sym_iter_comment_stmt] = STATE(202),
    [sym_iter_dbta_stmt] = STATE(202),
    [sym_iter_dbtb_stmt] = STATE(202),
    [sym_iter_dbts_stmt] = STATE(202),
    [sym_iter_threads_stmt] = STATE(202),
    [sym_iter_bbs_stmt] = STATE(202),
    [sym_iter_instrs_stmt] = STATE(202),
    [sym_iter_import_stmt] = STATE(202),
    [sym_iter_sections_stmt] = STATE(202),
    [sym_iter_segments_stmt] = STATE(202),
    [sym_iter_symbol_stmt] = STATE(202),
    [sym_iter_string_stmt] = STATE(202),
    [sym_iter_flags_stmt] = STATE(202),
    [sym_iter_function_stmt] = STATE(202),
    [sym_iter_iomap_stmt] = STATE(202),
    [sym_iter_dbgmap_stmt] = STATE(202),
    [sym_iter_register_stmt] = STATE(202),
    [sym_iter_step_stmt] = STATE(202),
    [sym_tmp_seek_stmt] = STATE(202),
    [sym_tmp_blksz_stmt] = STATE(202),
    [sym_tmp_fromto_stmt] = STATE(202),
    [sym_tmp_arch_stmt] = STATE(202),
    [sym_tmp_bits_stmt] = STATE(202),
    [sym_tmp_nthi_stmt] = STATE(202),
    [sym_tmp_eval_stmt] = STATE(202),
    [sym_tmp_fs_stmt] = STATE(202),
    [sym_tmp_reli_stmt] = STATE(202),
    [sym_tmp_kuery_stmt] = STATE(202),
    [sym_tmp_fd_stmt] = STATE(202),
    [sym_tmp_reg_stmt] = STATE(202),
    [sym_tmp_file_stmt] = STATE(202),
    [sym_tmp_string_stmt] = STATE(202),
    [sym_tmp_value_stmt] = STATE(202),
    [sym_tmp_hex_stmt] = STATE(202),
    [sym_number_stmt] = STATE(202),
    [sym_help_stmt] = STATE(202),
    [sym_arged_stmt] = STATE(202),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(202),
    [sym_Cf_cmd] = STATE(202),
    [sym_pf_new_cmd] = STATE(202),
    [sym_pf_dot_cmd] = STATE(202),
    [sym_pf_cmd] = STATE(202),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(202),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [ts_builtin_sym_end] = ACTIONS(59),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PIPE] = ACTIONS(61),
    [anon_sym_PIPEH] = ACTIONS(59),
    [anon_sym_AT_AT_DOT] = ACTIONS(59),
    [anon_sym_AT_AT_EQ] = ACTIONS(59),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(59),
    [anon_sym_AT_AT] = ACTIONS(61),
    [anon_sym_AT_ATc_COLON] = ACTIONS(59),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(59),
    [anon_sym_AT_ATC] = ACTIONS(59),
    [anon_sym_AT_ATdbt] = ACTIONS(61),
    [anon_sym_AT_ATdbta] = ACTIONS(59),
    [anon_sym_AT_ATdbtb] = ACTIONS(59),
    [anon_sym_AT_ATdbts] = ACTIONS(59),
    [anon_sym_AT_ATt] = ACTIONS(59),
    [anon_sym_AT_ATb] = ACTIONS(59),
    [anon_sym_AT_ATi] = ACTIONS(61),
    [anon_sym_AT_ATii] = ACTIONS(59),
    [anon_sym_AT_ATiS] = ACTIONS(61),
    [anon_sym_AT_ATiSS] = ACTIONS(59),
    [anon_sym_AT_ATis] = ACTIONS(59),
    [anon_sym_AT_ATiz] = ACTIONS(59),
    [anon_sym_AT_ATf] = ACTIONS(59),
    [anon_sym_AT_ATF] = ACTIONS(59),
    [anon_sym_AT_ATom] = ACTIONS(59),
    [anon_sym_AT_ATdm] = ACTIONS(59),
    [anon_sym_AT_ATr] = ACTIONS(59),
    [anon_sym_AT_ATs_COLON] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_AT_BANG] = ACTIONS(59),
    [anon_sym_AT_LPAREN] = ACTIONS(59),
    [anon_sym_RPAREN] = ACTIONS(59),
    [anon_sym_ATa_COLON] = ACTIONS(59),
    [anon_sym_ATb_COLON] = ACTIONS(59),
    [anon_sym_ATB_COLON] = ACTIONS(59),
    [anon_sym_ATe_COLON] = ACTIONS(59),
    [anon_sym_ATF_COLON] = ACTIONS(59),
    [anon_sym_ATi_COLON] = ACTIONS(59),
    [anon_sym_ATk_COLON] = ACTIONS(59),
    [anon_sym_ATo_COLON] = ACTIONS(59),
    [anon_sym_ATr_COLON] = ACTIONS(59),
    [anon_sym_ATf_COLON] = ACTIONS(59),
    [anon_sym_ATs_COLON] = ACTIONS(59),
    [anon_sym_ATv_COLON] = ACTIONS(59),
    [anon_sym_ATx_COLON] = ACTIONS(59),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_PIPE_DOT] = ACTIONS(59),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_GT] = ACTIONS(59),
    [sym_html_redirect_operator] = ACTIONS(61),
    [sym_html_append_operator] = ACTIONS(59),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(59),
    [anon_sym_CR] = ACTIONS(59),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
    [sym_file_descriptor] = ACTIONS(59),
  },
  [4] = {
    [sym_legacy_quoted_stmt] = STATE(269),
    [sym__simple_stmt] = STATE(269),
    [sym__tmp_stmt] = STATE(269),
    [sym__iter_stmt] = STATE(269),
    [sym__pipe_stmt] = STATE(269),
    [sym_grep_stmt] = STATE(269),
    [sym_html_disable_stmt] = STATE(269),
    [sym_html_enable_stmt] = STATE(269),
    [sym_pipe_stmt] = STATE(269),
    [sym_iter_file_lines_stmt] = STATE(269),
    [sym_iter_offsets_stmt] = STATE(269),
    [sym_iter_offsetssizes_stmt] = STATE(269),
    [sym_iter_hit_stmt] = STATE(269),
    [sym_iter_interpret_stmt] = STATE(269),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(269),
    [sym_iter_comment_stmt] = STATE(269),
    [sym_iter_dbta_stmt] = STATE(269),
    [sym_iter_dbtb_stmt] = STATE(269),
    [sym_iter_dbts_stmt] = STATE(269),
    [sym_iter_threads_stmt] = STATE(269),
    [sym_iter_bbs_stmt] = STATE(269),
    [sym_iter_instrs_stmt] = STATE(269),
    [sym_iter_import_stmt] = STATE(269),
    [sym_iter_sections_stmt] = STATE(269),
    [sym_iter_segments_stmt] = STATE(269),
    [sym_iter_symbol_stmt] = STATE(269),
    [sym_iter_string_stmt] = STATE(269),
    [sym_iter_flags_stmt] = STATE(269),
    [sym_iter_function_stmt] = STATE(269),
    [sym_iter_iomap_stmt] = STATE(269),
    [sym_iter_dbgmap_stmt] = STATE(269),
    [sym_iter_register_stmt] = STATE(269),
    [sym_iter_step_stmt] = STATE(269),
    [sym_tmp_seek_stmt] = STATE(269),
    [sym_tmp_blksz_stmt] = STATE(269),
    [sym_tmp_fromto_stmt] = STATE(269),
    [sym_tmp_arch_stmt] = STATE(269),
    [sym_tmp_bits_stmt] = STATE(269),
    [sym_tmp_nthi_stmt] = STATE(269),
    [sym_tmp_eval_stmt] = STATE(269),
    [sym_tmp_fs_stmt] = STATE(269),
    [sym_tmp_reli_stmt] = STATE(269),
    [sym_tmp_kuery_stmt] = STATE(269),
    [sym_tmp_fd_stmt] = STATE(269),
    [sym_tmp_reg_stmt] = STATE(269),
    [sym_tmp_file_stmt] = STATE(269),
    [sym_tmp_string_stmt] = STATE(269),
    [sym_tmp_value_stmt] = STATE(269),
    [sym_tmp_hex_stmt] = STATE(269),
    [sym_number_stmt] = STATE(269),
    [sym_help_stmt] = STATE(269),
    [sym_arged_stmt] = STATE(269),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(269),
    [sym_Cf_cmd] = STATE(269),
    [sym_pf_new_cmd] = STATE(269),
    [sym_pf_dot_cmd] = STATE(269),
    [sym_pf_cmd] = STATE(269),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(269),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_PIPEH] = ACTIONS(55),
    [anon_sym_AT_AT_DOT] = ACTIONS(55),
    [anon_sym_AT_AT_EQ] = ACTIONS(55),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(55),
    [anon_sym_AT_AT] = ACTIONS(57),
    [anon_sym_AT_ATc_COLON] = ACTIONS(55),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(55),
    [anon_sym_AT_ATC] = ACTIONS(55),
    [anon_sym_AT_ATdbt] = ACTIONS(57),
    [anon_sym_AT_ATdbta] = ACTIONS(55),
    [anon_sym_AT_ATdbtb] = ACTIONS(55),
    [anon_sym_AT_ATdbts] = ACTIONS(55),
    [anon_sym_AT_ATt] = ACTIONS(55),
    [anon_sym_AT_ATb] = ACTIONS(55),
    [anon_sym_AT_ATi] = ACTIONS(57),
    [anon_sym_AT_ATii] = ACTIONS(55),
    [anon_sym_AT_ATiS] = ACTIONS(57),
    [anon_sym_AT_ATiSS] = ACTIONS(55),
    [anon_sym_AT_ATis] = ACTIONS(55),
    [anon_sym_AT_ATiz] = ACTIONS(55),
    [anon_sym_AT_ATf] = ACTIONS(55),
    [anon_sym_AT_ATF] = ACTIONS(55),
    [anon_sym_AT_ATom] = ACTIONS(55),
    [anon_sym_AT_ATdm] = ACTIONS(55),
    [anon_sym_AT_ATr] = ACTIONS(55),
    [anon_sym_AT_ATs_COLON] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_AT_BANG] = ACTIONS(55),
    [anon_sym_AT_LPAREN] = ACTIONS(55),
    [anon_sym_ATa_COLON] = ACTIONS(55),
    [anon_sym_ATb_COLON] = ACTIONS(55),
    [anon_sym_ATB_COLON] = ACTIONS(55),
    [anon_sym_ATe_COLON] = ACTIONS(55),
    [anon_sym_ATF_COLON] = ACTIONS(55),
    [anon_sym_ATi_COLON] = ACTIONS(55),
    [anon_sym_ATk_COLON] = ACTIONS(55),
    [anon_sym_ATo_COLON] = ACTIONS(55),
    [anon_sym_ATr_COLON] = ACTIONS(55),
    [anon_sym_ATf_COLON] = ACTIONS(55),
    [anon_sym_ATs_COLON] = ACTIONS(55),
    [anon_sym_ATv_COLON] = ACTIONS(55),
    [anon_sym_ATx_COLON] = ACTIONS(55),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_PIPE_DOT] = ACTIONS(55),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(55),
    [anon_sym_GT] = ACTIONS(57),
    [anon_sym_GT_GT] = ACTIONS(55),
    [sym_html_redirect_operator] = ACTIONS(57),
    [sym_html_append_operator] = ACTIONS(55),
    [anon_sym_BQUOTE] = ACTIONS(55),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
    [sym_file_descriptor] = ACTIONS(55),
  },
  [5] = {
    [sym_legacy_quoted_stmt] = STATE(202),
    [sym__simple_stmt] = STATE(202),
    [sym__tmp_stmt] = STATE(202),
    [sym__iter_stmt] = STATE(202),
    [sym__pipe_stmt] = STATE(202),
    [sym_grep_stmt] = STATE(202),
    [sym_html_disable_stmt] = STATE(202),
    [sym_html_enable_stmt] = STATE(202),
    [sym_pipe_stmt] = STATE(202),
    [sym_iter_file_lines_stmt] = STATE(202),
    [sym_iter_offsets_stmt] = STATE(202),
    [sym_iter_offsetssizes_stmt] = STATE(202),
    [sym_iter_hit_stmt] = STATE(202),
    [sym_iter_interpret_stmt] = STATE(202),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(202),
    [sym_iter_comment_stmt] = STATE(202),
    [sym_iter_dbta_stmt] = STATE(202),
    [sym_iter_dbtb_stmt] = STATE(202),
    [sym_iter_dbts_stmt] = STATE(202),
    [sym_iter_threads_stmt] = STATE(202),
    [sym_iter_bbs_stmt] = STATE(202),
    [sym_iter_instrs_stmt] = STATE(202),
    [sym_iter_import_stmt] = STATE(202),
    [sym_iter_sections_stmt] = STATE(202),
    [sym_iter_segments_stmt] = STATE(202),
    [sym_iter_symbol_stmt] = STATE(202),
    [sym_iter_string_stmt] = STATE(202),
    [sym_iter_flags_stmt] = STATE(202),
    [sym_iter_function_stmt] = STATE(202),
    [sym_iter_iomap_stmt] = STATE(202),
    [sym_iter_dbgmap_stmt] = STATE(202),
    [sym_iter_register_stmt] = STATE(202),
    [sym_iter_step_stmt] = STATE(202),
    [sym_tmp_seek_stmt] = STATE(202),
    [sym_tmp_blksz_stmt] = STATE(202),
    [sym_tmp_fromto_stmt] = STATE(202),
    [sym_tmp_arch_stmt] = STATE(202),
    [sym_tmp_bits_stmt] = STATE(202),
    [sym_tmp_nthi_stmt] = STATE(202),
    [sym_tmp_eval_stmt] = STATE(202),
    [sym_tmp_fs_stmt] = STATE(202),
    [sym_tmp_reli_stmt] = STATE(202),
    [sym_tmp_kuery_stmt] = STATE(202),
    [sym_tmp_fd_stmt] = STATE(202),
    [sym_tmp_reg_stmt] = STATE(202),
    [sym_tmp_file_stmt] = STATE(202),
    [sym_tmp_string_stmt] = STATE(202),
    [sym_tmp_value_stmt] = STATE(202),
    [sym_tmp_hex_stmt] = STATE(202),
    [sym_number_stmt] = STATE(202),
    [sym_help_stmt] = STATE(202),
    [sym_arged_stmt] = STATE(202),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(202),
    [sym_Cf_cmd] = STATE(202),
    [sym_pf_new_cmd] = STATE(202),
    [sym_pf_dot_cmd] = STATE(202),
    [sym_pf_cmd] = STATE(202),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(202),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PIPE] = ACTIONS(61),
    [anon_sym_PIPEH] = ACTIONS(59),
    [anon_sym_AT_AT_DOT] = ACTIONS(59),
    [anon_sym_AT_AT_EQ] = ACTIONS(59),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(59),
    [anon_sym_AT_AT] = ACTIONS(61),
    [anon_sym_AT_ATc_COLON] = ACTIONS(59),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(59),
    [anon_sym_AT_ATC] = ACTIONS(59),
    [anon_sym_AT_ATdbt] = ACTIONS(61),
    [anon_sym_AT_ATdbta] = ACTIONS(59),
    [anon_sym_AT_ATdbtb] = ACTIONS(59),
    [anon_sym_AT_ATdbts] = ACTIONS(59),
    [anon_sym_AT_ATt] = ACTIONS(59),
    [anon_sym_AT_ATb] = ACTIONS(59),
    [anon_sym_AT_ATi] = ACTIONS(61),
    [anon_sym_AT_ATii] = ACTIONS(59),
    [anon_sym_AT_ATiS] = ACTIONS(61),
    [anon_sym_AT_ATiSS] = ACTIONS(59),
    [anon_sym_AT_ATis] = ACTIONS(59),
    [anon_sym_AT_ATiz] = ACTIONS(59),
    [anon_sym_AT_ATf] = ACTIONS(59),
    [anon_sym_AT_ATF] = ACTIONS(59),
    [anon_sym_AT_ATom] = ACTIONS(59),
    [anon_sym_AT_ATdm] = ACTIONS(59),
    [anon_sym_AT_ATr] = ACTIONS(59),
    [anon_sym_AT_ATs_COLON] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_AT_BANG] = ACTIONS(59),
    [anon_sym_AT_LPAREN] = ACTIONS(59),
    [anon_sym_ATa_COLON] = ACTIONS(59),
    [anon_sym_ATb_COLON] = ACTIONS(59),
    [anon_sym_ATB_COLON] = ACTIONS(59),
    [anon_sym_ATe_COLON] = ACTIONS(59),
    [anon_sym_ATF_COLON] = ACTIONS(59),
    [anon_sym_ATi_COLON] = ACTIONS(59),
    [anon_sym_ATk_COLON] = ACTIONS(59),
    [anon_sym_ATo_COLON] = ACTIONS(59),
    [anon_sym_ATr_COLON] = ACTIONS(59),
    [anon_sym_ATf_COLON] = ACTIONS(59),
    [anon_sym_ATs_COLON] = ACTIONS(59),
    [anon_sym_ATv_COLON] = ACTIONS(59),
    [anon_sym_ATx_COLON] = ACTIONS(59),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_PIPE_DOT] = ACTIONS(59),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_GT] = ACTIONS(59),
    [sym_html_redirect_operator] = ACTIONS(61),
    [sym_html_append_operator] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(59),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
    [sym_file_descriptor] = ACTIONS(59),
  },
  [6] = {
    [sym__statement] = STATE(411),
    [sym_legacy_quoted_stmt] = STATE(180),
    [sym__simple_stmt] = STATE(180),
    [sym__tmp_stmt] = STATE(180),
    [sym__iter_stmt] = STATE(180),
    [sym__pipe_stmt] = STATE(180),
    [sym_grep_stmt] = STATE(180),
    [sym_html_disable_stmt] = STATE(180),
    [sym_html_enable_stmt] = STATE(180),
    [sym_pipe_stmt] = STATE(180),
    [sym_iter_file_lines_stmt] = STATE(180),
    [sym_iter_offsets_stmt] = STATE(180),
    [sym_iter_offsetssizes_stmt] = STATE(180),
    [sym_iter_hit_stmt] = STATE(180),
    [sym_iter_interpret_stmt] = STATE(180),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(180),
    [sym_iter_comment_stmt] = STATE(180),
    [sym_iter_dbta_stmt] = STATE(180),
    [sym_iter_dbtb_stmt] = STATE(180),
    [sym_iter_dbts_stmt] = STATE(180),
    [sym_iter_threads_stmt] = STATE(180),
    [sym_iter_bbs_stmt] = STATE(180),
    [sym_iter_instrs_stmt] = STATE(180),
    [sym_iter_import_stmt] = STATE(180),
    [sym_iter_sections_stmt] = STATE(180),
    [sym_iter_segments_stmt] = STATE(180),
    [sym_iter_symbol_stmt] = STATE(180),
    [sym_iter_string_stmt] = STATE(180),
    [sym_iter_flags_stmt] = STATE(180),
    [sym_iter_function_stmt] = STATE(180),
    [sym_iter_iomap_stmt] = STATE(180),
    [sym_iter_dbgmap_stmt] = STATE(180),
    [sym_iter_register_stmt] = STATE(180),
    [sym_iter_step_stmt] = STATE(180),
    [sym_tmp_seek_stmt] = STATE(180),
    [sym_tmp_blksz_stmt] = STATE(180),
    [sym_tmp_fromto_stmt] = STATE(180),
    [sym_tmp_arch_stmt] = STATE(180),
    [sym_tmp_bits_stmt] = STATE(180),
    [sym_tmp_nthi_stmt] = STATE(180),
    [sym_tmp_eval_stmt] = STATE(180),
    [sym_tmp_fs_stmt] = STATE(180),
    [sym_tmp_reli_stmt] = STATE(180),
    [sym_tmp_kuery_stmt] = STATE(180),
    [sym_tmp_fd_stmt] = STATE(180),
    [sym_tmp_reg_stmt] = STATE(180),
    [sym_tmp_file_stmt] = STATE(180),
    [sym_tmp_string_stmt] = STATE(180),
    [sym_tmp_value_stmt] = STATE(180),
    [sym_tmp_hex_stmt] = STATE(180),
    [sym_number_stmt] = STATE(180),
    [sym_help_stmt] = STATE(180),
    [sym_arged_stmt] = STATE(180),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(180),
    [sym_Cf_cmd] = STATE(180),
    [sym_pf_new_cmd] = STATE(180),
    [sym_pf_dot_cmd] = STATE(180),
    [sym_pf_cmd] = STATE(180),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(180),
    [sym_redirect_stmt] = STATE(411),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym_statements_repeat1] = STATE(279),
    [ts_builtin_sym_end] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(89),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(89),
    [anon_sym_CR] = ACTIONS(89),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [7] = {
    [sym__statement] = STATE(416),
    [sym_legacy_quoted_stmt] = STATE(180),
    [sym__simple_stmt] = STATE(180),
    [sym__tmp_stmt] = STATE(180),
    [sym__iter_stmt] = STATE(180),
    [sym__pipe_stmt] = STATE(180),
    [sym_grep_stmt] = STATE(180),
    [sym_html_disable_stmt] = STATE(180),
    [sym_html_enable_stmt] = STATE(180),
    [sym_pipe_stmt] = STATE(180),
    [sym_iter_file_lines_stmt] = STATE(180),
    [sym_iter_offsets_stmt] = STATE(180),
    [sym_iter_offsetssizes_stmt] = STATE(180),
    [sym_iter_hit_stmt] = STATE(180),
    [sym_iter_interpret_stmt] = STATE(180),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(180),
    [sym_iter_comment_stmt] = STATE(180),
    [sym_iter_dbta_stmt] = STATE(180),
    [sym_iter_dbtb_stmt] = STATE(180),
    [sym_iter_dbts_stmt] = STATE(180),
    [sym_iter_threads_stmt] = STATE(180),
    [sym_iter_bbs_stmt] = STATE(180),
    [sym_iter_instrs_stmt] = STATE(180),
    [sym_iter_import_stmt] = STATE(180),
    [sym_iter_sections_stmt] = STATE(180),
    [sym_iter_segments_stmt] = STATE(180),
    [sym_iter_symbol_stmt] = STATE(180),
    [sym_iter_string_stmt] = STATE(180),
    [sym_iter_flags_stmt] = STATE(180),
    [sym_iter_function_stmt] = STATE(180),
    [sym_iter_iomap_stmt] = STATE(180),
    [sym_iter_dbgmap_stmt] = STATE(180),
    [sym_iter_register_stmt] = STATE(180),
    [sym_iter_step_stmt] = STATE(180),
    [sym_tmp_seek_stmt] = STATE(180),
    [sym_tmp_blksz_stmt] = STATE(180),
    [sym_tmp_fromto_stmt] = STATE(180),
    [sym_tmp_arch_stmt] = STATE(180),
    [sym_tmp_bits_stmt] = STATE(180),
    [sym_tmp_nthi_stmt] = STATE(180),
    [sym_tmp_eval_stmt] = STATE(180),
    [sym_tmp_fs_stmt] = STATE(180),
    [sym_tmp_reli_stmt] = STATE(180),
    [sym_tmp_kuery_stmt] = STATE(180),
    [sym_tmp_fd_stmt] = STATE(180),
    [sym_tmp_reg_stmt] = STATE(180),
    [sym_tmp_file_stmt] = STATE(180),
    [sym_tmp_string_stmt] = STATE(180),
    [sym_tmp_value_stmt] = STATE(180),
    [sym_tmp_hex_stmt] = STATE(180),
    [sym_number_stmt] = STATE(180),
    [sym_help_stmt] = STATE(180),
    [sym_arged_stmt] = STATE(180),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(180),
    [sym_Cf_cmd] = STATE(180),
    [sym_pf_new_cmd] = STATE(180),
    [sym_pf_dot_cmd] = STATE(180),
    [sym_pf_cmd] = STATE(180),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(180),
    [sym_redirect_stmt] = STATE(416),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [ts_builtin_sym_end] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(91),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(91),
    [anon_sym_CR] = ACTIONS(91),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [8] = {
    [sym__statements_singleline] = STATE(499),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [9] = {
    [sym__statements_singleline] = STATE(497),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym__statements_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(95),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [10] = {
    [sym__statements_singleline] = STATE(507),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [11] = {
    [sym__statements_singleline] = STATE(472),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym__statements_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(95),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [12] = {
    [sym__statements_singleline] = STATE(471),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [13] = {
    [sym__statements_singleline] = STATE(470),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym__statements_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(95),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [14] = {
    [sym__statements_singleline] = STATE(475),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [15] = {
    [sym__statements_singleline] = STATE(469),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [16] = {
    [sym__statements_singleline] = STATE(465),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym__statements_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(95),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [17] = {
    [sym__statements_singleline] = STATE(468),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [18] = {
    [sym__statements_singleline] = STATE(474),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym__statements_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(95),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [19] = {
    [sym__statements_singleline] = STATE(467),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym__statements_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(95),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [20] = {
    [sym__statements_singleline] = STATE(502),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym__statements_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(95),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [21] = {
    [sym__statements_singleline] = STATE(486),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [22] = {
    [sym__statements_singleline] = STATE(473),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [23] = {
    [sym__statements_singleline] = STATE(477),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym__statements_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(95),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [24] = {
    [sym__statements_singleline] = STATE(478),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [25] = {
    [sym__statements_singleline] = STATE(494),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym__statements_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(95),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [26] = {
    [sym__statements_singleline] = STATE(479),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym__statements_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(95),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [27] = {
    [sym__statements_singleline] = STATE(483),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [28] = {
    [sym__statements_singleline] = STATE(484),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym__statements_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(95),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [29] = {
    [sym__statements_singleline] = STATE(489),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [30] = {
    [sym__statements_singleline] = STATE(490),
    [sym__statement] = STATE(430),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(430),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym__statements_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(95),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [31] = {
    [sym__statements_singleline] = STATE(493),
    [sym__statement] = STATE(440),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(440),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [32] = {
    [sym__statement] = STATE(439),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(439),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [33] = {
    [sym__statement] = STATE(444),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(444),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [aux_sym__statements_singleline_repeat1] = STATE(280),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [34] = {
    [sym__statement] = STATE(439),
    [sym_legacy_quoted_stmt] = STATE(271),
    [sym__simple_stmt] = STATE(271),
    [sym__tmp_stmt] = STATE(271),
    [sym__iter_stmt] = STATE(271),
    [sym__pipe_stmt] = STATE(271),
    [sym_grep_stmt] = STATE(271),
    [sym_html_disable_stmt] = STATE(271),
    [sym_html_enable_stmt] = STATE(271),
    [sym_pipe_stmt] = STATE(271),
    [sym_iter_file_lines_stmt] = STATE(271),
    [sym_iter_offsets_stmt] = STATE(271),
    [sym_iter_offsetssizes_stmt] = STATE(271),
    [sym_iter_hit_stmt] = STATE(271),
    [sym_iter_interpret_stmt] = STATE(271),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(271),
    [sym_iter_comment_stmt] = STATE(271),
    [sym_iter_dbta_stmt] = STATE(271),
    [sym_iter_dbtb_stmt] = STATE(271),
    [sym_iter_dbts_stmt] = STATE(271),
    [sym_iter_threads_stmt] = STATE(271),
    [sym_iter_bbs_stmt] = STATE(271),
    [sym_iter_instrs_stmt] = STATE(271),
    [sym_iter_import_stmt] = STATE(271),
    [sym_iter_sections_stmt] = STATE(271),
    [sym_iter_segments_stmt] = STATE(271),
    [sym_iter_symbol_stmt] = STATE(271),
    [sym_iter_string_stmt] = STATE(271),
    [sym_iter_flags_stmt] = STATE(271),
    [sym_iter_function_stmt] = STATE(271),
    [sym_iter_iomap_stmt] = STATE(271),
    [sym_iter_dbgmap_stmt] = STATE(271),
    [sym_iter_register_stmt] = STATE(271),
    [sym_iter_step_stmt] = STATE(271),
    [sym_tmp_seek_stmt] = STATE(271),
    [sym_tmp_blksz_stmt] = STATE(271),
    [sym_tmp_fromto_stmt] = STATE(271),
    [sym_tmp_arch_stmt] = STATE(271),
    [sym_tmp_bits_stmt] = STATE(271),
    [sym_tmp_nthi_stmt] = STATE(271),
    [sym_tmp_eval_stmt] = STATE(271),
    [sym_tmp_fs_stmt] = STATE(271),
    [sym_tmp_reli_stmt] = STATE(271),
    [sym_tmp_kuery_stmt] = STATE(271),
    [sym_tmp_fd_stmt] = STATE(271),
    [sym_tmp_reg_stmt] = STATE(271),
    [sym_tmp_file_stmt] = STATE(271),
    [sym_tmp_string_stmt] = STATE(271),
    [sym_tmp_value_stmt] = STATE(271),
    [sym_tmp_hex_stmt] = STATE(271),
    [sym_number_stmt] = STATE(271),
    [sym_help_stmt] = STATE(271),
    [sym_arged_stmt] = STATE(271),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(271),
    [sym_redirect_stmt] = STATE(439),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_BQUOTE] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [35] = {
    [sym__statement] = STATE(447),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(447),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [aux_sym__statements_singleline_repeat1] = STATE(280),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [36] = {
    [sym__statement] = STATE(443),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(443),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [37] = {
    [sym__statement] = STATE(463),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(463),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [38] = {
    [sym__statement] = STATE(433),
    [sym_legacy_quoted_stmt] = STATE(270),
    [sym__simple_stmt] = STATE(270),
    [sym__tmp_stmt] = STATE(270),
    [sym__iter_stmt] = STATE(270),
    [sym__pipe_stmt] = STATE(270),
    [sym_grep_stmt] = STATE(270),
    [sym_html_disable_stmt] = STATE(270),
    [sym_html_enable_stmt] = STATE(270),
    [sym_pipe_stmt] = STATE(270),
    [sym_iter_file_lines_stmt] = STATE(270),
    [sym_iter_offsets_stmt] = STATE(270),
    [sym_iter_offsetssizes_stmt] = STATE(270),
    [sym_iter_hit_stmt] = STATE(270),
    [sym_iter_interpret_stmt] = STATE(270),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(270),
    [sym_iter_comment_stmt] = STATE(270),
    [sym_iter_dbta_stmt] = STATE(270),
    [sym_iter_dbtb_stmt] = STATE(270),
    [sym_iter_dbts_stmt] = STATE(270),
    [sym_iter_threads_stmt] = STATE(270),
    [sym_iter_bbs_stmt] = STATE(270),
    [sym_iter_instrs_stmt] = STATE(270),
    [sym_iter_import_stmt] = STATE(270),
    [sym_iter_sections_stmt] = STATE(270),
    [sym_iter_segments_stmt] = STATE(270),
    [sym_iter_symbol_stmt] = STATE(270),
    [sym_iter_string_stmt] = STATE(270),
    [sym_iter_flags_stmt] = STATE(270),
    [sym_iter_function_stmt] = STATE(270),
    [sym_iter_iomap_stmt] = STATE(270),
    [sym_iter_dbgmap_stmt] = STATE(270),
    [sym_iter_register_stmt] = STATE(270),
    [sym_iter_step_stmt] = STATE(270),
    [sym_tmp_seek_stmt] = STATE(270),
    [sym_tmp_blksz_stmt] = STATE(270),
    [sym_tmp_fromto_stmt] = STATE(270),
    [sym_tmp_arch_stmt] = STATE(270),
    [sym_tmp_bits_stmt] = STATE(270),
    [sym_tmp_nthi_stmt] = STATE(270),
    [sym_tmp_eval_stmt] = STATE(270),
    [sym_tmp_fs_stmt] = STATE(270),
    [sym_tmp_reli_stmt] = STATE(270),
    [sym_tmp_kuery_stmt] = STATE(270),
    [sym_tmp_fd_stmt] = STATE(270),
    [sym_tmp_reg_stmt] = STATE(270),
    [sym_tmp_file_stmt] = STATE(270),
    [sym_tmp_string_stmt] = STATE(270),
    [sym_tmp_value_stmt] = STATE(270),
    [sym_tmp_hex_stmt] = STATE(270),
    [sym_number_stmt] = STATE(270),
    [sym_help_stmt] = STATE(270),
    [sym_arged_stmt] = STATE(270),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(270),
    [sym_Cf_cmd] = STATE(270),
    [sym_pf_new_cmd] = STATE(270),
    [sym_pf_dot_cmd] = STATE(270),
    [sym_pf_cmd] = STATE(270),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(270),
    [sym_redirect_stmt] = STATE(433),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [39] = {
    [sym_legacy_quoted_stmt] = STATE(277),
    [sym__simple_stmt] = STATE(277),
    [sym__tmp_stmt] = STATE(277),
    [sym__iter_stmt] = STATE(277),
    [sym__pipe_stmt] = STATE(277),
    [sym_grep_stmt] = STATE(277),
    [sym_html_disable_stmt] = STATE(277),
    [sym_html_enable_stmt] = STATE(277),
    [sym_pipe_stmt] = STATE(277),
    [sym_iter_file_lines_stmt] = STATE(277),
    [sym_iter_offsets_stmt] = STATE(277),
    [sym_iter_offsetssizes_stmt] = STATE(277),
    [sym_iter_hit_stmt] = STATE(277),
    [sym_iter_interpret_stmt] = STATE(277),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(277),
    [sym_iter_comment_stmt] = STATE(277),
    [sym_iter_dbta_stmt] = STATE(277),
    [sym_iter_dbtb_stmt] = STATE(277),
    [sym_iter_dbts_stmt] = STATE(277),
    [sym_iter_threads_stmt] = STATE(277),
    [sym_iter_bbs_stmt] = STATE(277),
    [sym_iter_instrs_stmt] = STATE(277),
    [sym_iter_import_stmt] = STATE(277),
    [sym_iter_sections_stmt] = STATE(277),
    [sym_iter_segments_stmt] = STATE(277),
    [sym_iter_symbol_stmt] = STATE(277),
    [sym_iter_string_stmt] = STATE(277),
    [sym_iter_flags_stmt] = STATE(277),
    [sym_iter_function_stmt] = STATE(277),
    [sym_iter_iomap_stmt] = STATE(277),
    [sym_iter_dbgmap_stmt] = STATE(277),
    [sym_iter_register_stmt] = STATE(277),
    [sym_iter_step_stmt] = STATE(277),
    [sym_tmp_seek_stmt] = STATE(277),
    [sym_tmp_blksz_stmt] = STATE(277),
    [sym_tmp_fromto_stmt] = STATE(277),
    [sym_tmp_arch_stmt] = STATE(277),
    [sym_tmp_bits_stmt] = STATE(277),
    [sym_tmp_nthi_stmt] = STATE(277),
    [sym_tmp_eval_stmt] = STATE(277),
    [sym_tmp_fs_stmt] = STATE(277),
    [sym_tmp_reli_stmt] = STATE(277),
    [sym_tmp_kuery_stmt] = STATE(277),
    [sym_tmp_fd_stmt] = STATE(277),
    [sym_tmp_reg_stmt] = STATE(277),
    [sym_tmp_file_stmt] = STATE(277),
    [sym_tmp_string_stmt] = STATE(277),
    [sym_tmp_value_stmt] = STATE(277),
    [sym_tmp_hex_stmt] = STATE(277),
    [sym_number_stmt] = STATE(277),
    [sym_help_stmt] = STATE(277),
    [sym_arged_stmt] = STATE(277),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(277),
    [sym_Cf_cmd] = STATE(277),
    [sym_pf_new_cmd] = STATE(277),
    [sym_pf_dot_cmd] = STATE(277),
    [sym_pf_cmd] = STATE(277),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(277),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [40] = {
    [sym_legacy_quoted_stmt] = STATE(272),
    [sym__simple_stmt] = STATE(272),
    [sym__tmp_stmt] = STATE(272),
    [sym__iter_stmt] = STATE(272),
    [sym__pipe_stmt] = STATE(272),
    [sym_grep_stmt] = STATE(272),
    [sym_html_disable_stmt] = STATE(272),
    [sym_html_enable_stmt] = STATE(272),
    [sym_pipe_stmt] = STATE(272),
    [sym_iter_file_lines_stmt] = STATE(272),
    [sym_iter_offsets_stmt] = STATE(272),
    [sym_iter_offsetssizes_stmt] = STATE(272),
    [sym_iter_hit_stmt] = STATE(272),
    [sym_iter_interpret_stmt] = STATE(272),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(272),
    [sym_iter_comment_stmt] = STATE(272),
    [sym_iter_dbta_stmt] = STATE(272),
    [sym_iter_dbtb_stmt] = STATE(272),
    [sym_iter_dbts_stmt] = STATE(272),
    [sym_iter_threads_stmt] = STATE(272),
    [sym_iter_bbs_stmt] = STATE(272),
    [sym_iter_instrs_stmt] = STATE(272),
    [sym_iter_import_stmt] = STATE(272),
    [sym_iter_sections_stmt] = STATE(272),
    [sym_iter_segments_stmt] = STATE(272),
    [sym_iter_symbol_stmt] = STATE(272),
    [sym_iter_string_stmt] = STATE(272),
    [sym_iter_flags_stmt] = STATE(272),
    [sym_iter_function_stmt] = STATE(272),
    [sym_iter_iomap_stmt] = STATE(272),
    [sym_iter_dbgmap_stmt] = STATE(272),
    [sym_iter_register_stmt] = STATE(272),
    [sym_iter_step_stmt] = STATE(272),
    [sym_tmp_seek_stmt] = STATE(272),
    [sym_tmp_blksz_stmt] = STATE(272),
    [sym_tmp_fromto_stmt] = STATE(272),
    [sym_tmp_arch_stmt] = STATE(272),
    [sym_tmp_bits_stmt] = STATE(272),
    [sym_tmp_nthi_stmt] = STATE(272),
    [sym_tmp_eval_stmt] = STATE(272),
    [sym_tmp_fs_stmt] = STATE(272),
    [sym_tmp_reli_stmt] = STATE(272),
    [sym_tmp_kuery_stmt] = STATE(272),
    [sym_tmp_fd_stmt] = STATE(272),
    [sym_tmp_reg_stmt] = STATE(272),
    [sym_tmp_file_stmt] = STATE(272),
    [sym_tmp_string_stmt] = STATE(272),
    [sym_tmp_value_stmt] = STATE(272),
    [sym_tmp_hex_stmt] = STATE(272),
    [sym_number_stmt] = STATE(272),
    [sym_help_stmt] = STATE(272),
    [sym_arged_stmt] = STATE(272),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(272),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [41] = {
    [sym_legacy_quoted_stmt] = STATE(278),
    [sym__simple_stmt] = STATE(278),
    [sym__tmp_stmt] = STATE(278),
    [sym__iter_stmt] = STATE(278),
    [sym__pipe_stmt] = STATE(278),
    [sym_grep_stmt] = STATE(278),
    [sym_html_disable_stmt] = STATE(278),
    [sym_html_enable_stmt] = STATE(278),
    [sym_pipe_stmt] = STATE(278),
    [sym_iter_file_lines_stmt] = STATE(278),
    [sym_iter_offsets_stmt] = STATE(278),
    [sym_iter_offsetssizes_stmt] = STATE(278),
    [sym_iter_hit_stmt] = STATE(278),
    [sym_iter_interpret_stmt] = STATE(278),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(278),
    [sym_iter_comment_stmt] = STATE(278),
    [sym_iter_dbta_stmt] = STATE(278),
    [sym_iter_dbtb_stmt] = STATE(278),
    [sym_iter_dbts_stmt] = STATE(278),
    [sym_iter_threads_stmt] = STATE(278),
    [sym_iter_bbs_stmt] = STATE(278),
    [sym_iter_instrs_stmt] = STATE(278),
    [sym_iter_import_stmt] = STATE(278),
    [sym_iter_sections_stmt] = STATE(278),
    [sym_iter_segments_stmt] = STATE(278),
    [sym_iter_symbol_stmt] = STATE(278),
    [sym_iter_string_stmt] = STATE(278),
    [sym_iter_flags_stmt] = STATE(278),
    [sym_iter_function_stmt] = STATE(278),
    [sym_iter_iomap_stmt] = STATE(278),
    [sym_iter_dbgmap_stmt] = STATE(278),
    [sym_iter_register_stmt] = STATE(278),
    [sym_iter_step_stmt] = STATE(278),
    [sym_tmp_seek_stmt] = STATE(278),
    [sym_tmp_blksz_stmt] = STATE(278),
    [sym_tmp_fromto_stmt] = STATE(278),
    [sym_tmp_arch_stmt] = STATE(278),
    [sym_tmp_bits_stmt] = STATE(278),
    [sym_tmp_nthi_stmt] = STATE(278),
    [sym_tmp_eval_stmt] = STATE(278),
    [sym_tmp_fs_stmt] = STATE(278),
    [sym_tmp_reli_stmt] = STATE(278),
    [sym_tmp_kuery_stmt] = STATE(278),
    [sym_tmp_fd_stmt] = STATE(278),
    [sym_tmp_reg_stmt] = STATE(278),
    [sym_tmp_file_stmt] = STATE(278),
    [sym_tmp_string_stmt] = STATE(278),
    [sym_tmp_value_stmt] = STATE(278),
    [sym_tmp_hex_stmt] = STATE(278),
    [sym_number_stmt] = STATE(278),
    [sym_help_stmt] = STATE(278),
    [sym_arged_stmt] = STATE(278),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(289),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(278),
    [sym_Cf_cmd] = STATE(278),
    [sym_pf_new_cmd] = STATE(278),
    [sym_pf_dot_cmd] = STATE(278),
    [sym_pf_cmd] = STATE(278),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(100),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(278),
    [sym__dec_number] = STATE(4),
    [sym_cmd_identifier] = STATE(64),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(63),
    [aux_sym__interpret_stmt_token1] = ACTIONS(65),
    [aux_sym__interpret_stmt_token3] = ACTIONS(67),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(69),
    [anon_sym_Cf] = ACTIONS(71),
    [sym_pf_dot_cmd_identifier] = ACTIONS(73),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(75),
    [aux_sym_pf_cmd_token1] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(81),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(83),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(85),
  },
  [42] = {
    [sym_legacy_quoted_stmt] = STATE(273),
    [sym__simple_stmt] = STATE(273),
    [sym__tmp_stmt] = STATE(273),
    [sym__iter_stmt] = STATE(273),
    [sym__pipe_stmt] = STATE(273),
    [sym_grep_stmt] = STATE(273),
    [sym_html_disable_stmt] = STATE(273),
    [sym_html_enable_stmt] = STATE(273),
    [sym_pipe_stmt] = STATE(273),
    [sym_iter_file_lines_stmt] = STATE(273),
    [sym_iter_offsets_stmt] = STATE(273),
    [sym_iter_offsetssizes_stmt] = STATE(273),
    [sym_iter_hit_stmt] = STATE(273),
    [sym_iter_interpret_stmt] = STATE(273),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(273),
    [sym_iter_comment_stmt] = STATE(273),
    [sym_iter_dbta_stmt] = STATE(273),
    [sym_iter_dbtb_stmt] = STATE(273),
    [sym_iter_dbts_stmt] = STATE(273),
    [sym_iter_threads_stmt] = STATE(273),
    [sym_iter_bbs_stmt] = STATE(273),
    [sym_iter_instrs_stmt] = STATE(273),
    [sym_iter_import_stmt] = STATE(273),
    [sym_iter_sections_stmt] = STATE(273),
    [sym_iter_segments_stmt] = STATE(273),
    [sym_iter_symbol_stmt] = STATE(273),
    [sym_iter_string_stmt] = STATE(273),
    [sym_iter_flags_stmt] = STATE(273),
    [sym_iter_function_stmt] = STATE(273),
    [sym_iter_iomap_stmt] = STATE(273),
    [sym_iter_dbgmap_stmt] = STATE(273),
    [sym_iter_register_stmt] = STATE(273),
    [sym_iter_step_stmt] = STATE(273),
    [sym_tmp_seek_stmt] = STATE(273),
    [sym_tmp_blksz_stmt] = STATE(273),
    [sym_tmp_fromto_stmt] = STATE(273),
    [sym_tmp_arch_stmt] = STATE(273),
    [sym_tmp_bits_stmt] = STATE(273),
    [sym_tmp_nthi_stmt] = STATE(273),
    [sym_tmp_eval_stmt] = STATE(273),
    [sym_tmp_fs_stmt] = STATE(273),
    [sym_tmp_reli_stmt] = STATE(273),
    [sym_tmp_kuery_stmt] = STATE(273),
    [sym_tmp_fd_stmt] = STATE(273),
    [sym_tmp_reg_stmt] = STATE(273),
    [sym_tmp_file_stmt] = STATE(273),
    [sym_tmp_string_stmt] = STATE(273),
    [sym_tmp_value_stmt] = STATE(273),
    [sym_tmp_hex_stmt] = STATE(273),
    [sym_number_stmt] = STATE(273),
    [sym_help_stmt] = STATE(273),
    [sym_arged_stmt] = STATE(273),
    [sym__simple_arged_stmt_question] = STATE(236),
    [sym__simple_arged_stmt] = STATE(237),
    [sym__math_arged_stmt] = STATE(238),
    [sym__pointer_arged_stmt] = STATE(241),
    [sym__macro_arged_stmt] = STATE(248),
    [sym__system_stmt] = STATE(255),
    [sym__interpret_stmt] = STATE(257),
    [sym__interpret_search_identifier] = STATE(307),
    [sym__pf_arged_stmt] = STATE(263),
    [sym__pf_stmts] = STATE(273),
    [sym_Cf_cmd] = STATE(273),
    [sym_pf_new_cmd] = STATE(273),
    [sym_pf_dot_cmd] = STATE(273),
    [sym_pf_cmd] = STATE(273),
    [sym__env_stmt] = STATE(182),
    [sym__env_stmt_identifier] = STATE(74),
    [sym__last_stmt] = STATE(201),
    [sym_last_stmt_identifier] = STATE(197),
    [sym_repeat_stmt] = STATE(273),
    [sym__dec_number] = STATE(2),
    [sym_cmd_identifier] = STATE(50),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_stmt_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_stmt_token1] = ACTIONS(15),
    [aux_sym__interpret_stmt_token3] = ACTIONS(17),
    [anon_sym_DOT_LPAREN] = ACTIONS(19),
    [anon_sym_DOT_SLASH] = ACTIONS(21),
    [anon_sym_pfo] = ACTIONS(23),
    [anon_sym_Cf] = ACTIONS(25),
    [sym_pf_dot_cmd_identifier] = ACTIONS(27),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(29),
    [aux_sym_pf_cmd_token1] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_env] = ACTIONS(33),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(35),
    [sym_system_identifier] = ACTIONS(37),
    [sym_question_mark_identifier] = ACTIONS(39),
    [sym_pointer_identifier] = ACTIONS(41),
    [sym_macro_identifier] = ACTIONS(43),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [43] = {
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_PIPEH] = ACTIONS(101),
    [anon_sym_AT_AT_DOT] = ACTIONS(101),
    [anon_sym_AT_AT_EQ] = ACTIONS(101),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(101),
    [anon_sym_AT_AT] = ACTIONS(103),
    [anon_sym_AT_ATc_COLON] = ACTIONS(101),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(101),
    [anon_sym_AT_ATC] = ACTIONS(101),
    [anon_sym_AT_ATdbt] = ACTIONS(103),
    [anon_sym_AT_ATdbta] = ACTIONS(101),
    [anon_sym_AT_ATdbtb] = ACTIONS(101),
    [anon_sym_AT_ATdbts] = ACTIONS(101),
    [anon_sym_AT_ATt] = ACTIONS(101),
    [anon_sym_AT_ATb] = ACTIONS(101),
    [anon_sym_AT_ATi] = ACTIONS(103),
    [anon_sym_AT_ATii] = ACTIONS(101),
    [anon_sym_AT_ATiS] = ACTIONS(103),
    [anon_sym_AT_ATiSS] = ACTIONS(101),
    [anon_sym_AT_ATis] = ACTIONS(101),
    [anon_sym_AT_ATiz] = ACTIONS(101),
    [anon_sym_AT_ATf] = ACTIONS(101),
    [anon_sym_AT_ATF] = ACTIONS(101),
    [anon_sym_AT_ATom] = ACTIONS(101),
    [anon_sym_AT_ATdm] = ACTIONS(101),
    [anon_sym_AT_ATr] = ACTIONS(101),
    [anon_sym_AT_ATs_COLON] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_AT_BANG] = ACTIONS(101),
    [anon_sym_AT_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_ATa_COLON] = ACTIONS(101),
    [anon_sym_ATb_COLON] = ACTIONS(101),
    [anon_sym_ATB_COLON] = ACTIONS(101),
    [anon_sym_ATe_COLON] = ACTIONS(101),
    [anon_sym_ATF_COLON] = ACTIONS(101),
    [anon_sym_ATi_COLON] = ACTIONS(101),
    [anon_sym_ATk_COLON] = ACTIONS(101),
    [anon_sym_ATo_COLON] = ACTIONS(101),
    [anon_sym_ATr_COLON] = ACTIONS(101),
    [anon_sym_ATf_COLON] = ACTIONS(101),
    [anon_sym_ATs_COLON] = ACTIONS(101),
    [anon_sym_ATv_COLON] = ACTIONS(101),
    [anon_sym_ATx_COLON] = ACTIONS(101),
    [anon_sym_0] = ACTIONS(103),
    [aux_sym_number_stmt_token1] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [aux_sym__interpret_stmt_token1] = ACTIONS(103),
    [aux_sym__interpret_stmt_token3] = ACTIONS(101),
    [anon_sym_DOT_LPAREN] = ACTIONS(101),
    [anon_sym_PIPE_DOT] = ACTIONS(101),
    [anon_sym_DOT_SLASH] = ACTIONS(101),
    [anon_sym_pfo] = ACTIONS(101),
    [anon_sym_Cf] = ACTIONS(101),
    [sym_pf_dot_cmd_identifier] = ACTIONS(101),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(101),
    [aux_sym_pf_cmd_token1] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(101),
    [anon_sym_env] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [sym_system_identifier] = ACTIONS(101),
    [sym_question_mark_identifier] = ACTIONS(101),
    [sym_pointer_identifier] = ACTIONS(101),
    [sym_macro_identifier] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(101),
    [sym_html_redirect_operator] = ACTIONS(103),
    [sym_html_append_operator] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [aux_sym__dec_number_token1] = ACTIONS(101),
    [aux_sym__dec_number_token2] = ACTIONS(103),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(101),
    [anon_sym_CR] = ACTIONS(101),
    [sym__cmd_identifier] = ACTIONS(101),
    [sym__help_stmt] = ACTIONS(101),
    [sym_file_descriptor] = ACTIONS(101),
  },
  [44] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(57),
    [sym_args] = STATE(185),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(57),
    [ts_builtin_sym_end] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_PIPEH] = ACTIONS(105),
    [anon_sym_AT_AT_DOT] = ACTIONS(105),
    [anon_sym_AT_AT_EQ] = ACTIONS(105),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(105),
    [anon_sym_AT_AT] = ACTIONS(109),
    [anon_sym_AT_ATc_COLON] = ACTIONS(105),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(105),
    [anon_sym_AT_ATC] = ACTIONS(105),
    [anon_sym_AT_ATdbt] = ACTIONS(109),
    [anon_sym_AT_ATdbta] = ACTIONS(105),
    [anon_sym_AT_ATdbtb] = ACTIONS(105),
    [anon_sym_AT_ATdbts] = ACTIONS(105),
    [anon_sym_AT_ATt] = ACTIONS(105),
    [anon_sym_AT_ATb] = ACTIONS(105),
    [anon_sym_AT_ATi] = ACTIONS(109),
    [anon_sym_AT_ATii] = ACTIONS(105),
    [anon_sym_AT_ATiS] = ACTIONS(109),
    [anon_sym_AT_ATiSS] = ACTIONS(105),
    [anon_sym_AT_ATis] = ACTIONS(105),
    [anon_sym_AT_ATiz] = ACTIONS(105),
    [anon_sym_AT_ATf] = ACTIONS(105),
    [anon_sym_AT_ATF] = ACTIONS(105),
    [anon_sym_AT_ATom] = ACTIONS(105),
    [anon_sym_AT_ATdm] = ACTIONS(105),
    [anon_sym_AT_ATr] = ACTIONS(105),
    [anon_sym_AT_ATs_COLON] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(109),
    [anon_sym_AT_BANG] = ACTIONS(105),
    [anon_sym_AT_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(105),
    [anon_sym_ATa_COLON] = ACTIONS(105),
    [anon_sym_ATb_COLON] = ACTIONS(105),
    [anon_sym_ATB_COLON] = ACTIONS(105),
    [anon_sym_ATe_COLON] = ACTIONS(105),
    [anon_sym_ATF_COLON] = ACTIONS(105),
    [anon_sym_ATi_COLON] = ACTIONS(105),
    [anon_sym_ATk_COLON] = ACTIONS(105),
    [anon_sym_ATo_COLON] = ACTIONS(105),
    [anon_sym_ATr_COLON] = ACTIONS(105),
    [anon_sym_ATf_COLON] = ACTIONS(105),
    [anon_sym_ATs_COLON] = ACTIONS(105),
    [anon_sym_ATv_COLON] = ACTIONS(105),
    [anon_sym_ATx_COLON] = ACTIONS(105),
    [anon_sym_PIPE_DOT] = ACTIONS(105),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(105),
    [sym_html_redirect_operator] = ACTIONS(109),
    [sym_html_append_operator] = ACTIONS(105),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(121),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(105),
    [anon_sym_CR] = ACTIONS(105),
    [sym_file_descriptor] = ACTIONS(105),
  },
  [45] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(57),
    [sym_args] = STATE(200),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(57),
    [ts_builtin_sym_end] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_PIPEH] = ACTIONS(105),
    [anon_sym_AT_AT_DOT] = ACTIONS(105),
    [anon_sym_AT_AT_EQ] = ACTIONS(105),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(105),
    [anon_sym_AT_AT] = ACTIONS(109),
    [anon_sym_AT_ATc_COLON] = ACTIONS(105),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(105),
    [anon_sym_AT_ATC] = ACTIONS(105),
    [anon_sym_AT_ATdbt] = ACTIONS(109),
    [anon_sym_AT_ATdbta] = ACTIONS(105),
    [anon_sym_AT_ATdbtb] = ACTIONS(105),
    [anon_sym_AT_ATdbts] = ACTIONS(105),
    [anon_sym_AT_ATt] = ACTIONS(105),
    [anon_sym_AT_ATb] = ACTIONS(105),
    [anon_sym_AT_ATi] = ACTIONS(109),
    [anon_sym_AT_ATii] = ACTIONS(105),
    [anon_sym_AT_ATiS] = ACTIONS(109),
    [anon_sym_AT_ATiSS] = ACTIONS(105),
    [anon_sym_AT_ATis] = ACTIONS(105),
    [anon_sym_AT_ATiz] = ACTIONS(105),
    [anon_sym_AT_ATf] = ACTIONS(105),
    [anon_sym_AT_ATF] = ACTIONS(105),
    [anon_sym_AT_ATom] = ACTIONS(105),
    [anon_sym_AT_ATdm] = ACTIONS(105),
    [anon_sym_AT_ATr] = ACTIONS(105),
    [anon_sym_AT_ATs_COLON] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(109),
    [anon_sym_AT_BANG] = ACTIONS(105),
    [anon_sym_AT_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(105),
    [anon_sym_ATa_COLON] = ACTIONS(105),
    [anon_sym_ATb_COLON] = ACTIONS(105),
    [anon_sym_ATB_COLON] = ACTIONS(105),
    [anon_sym_ATe_COLON] = ACTIONS(105),
    [anon_sym_ATF_COLON] = ACTIONS(105),
    [anon_sym_ATi_COLON] = ACTIONS(105),
    [anon_sym_ATk_COLON] = ACTIONS(105),
    [anon_sym_ATo_COLON] = ACTIONS(105),
    [anon_sym_ATr_COLON] = ACTIONS(105),
    [anon_sym_ATf_COLON] = ACTIONS(105),
    [anon_sym_ATs_COLON] = ACTIONS(105),
    [anon_sym_ATv_COLON] = ACTIONS(105),
    [anon_sym_ATx_COLON] = ACTIONS(105),
    [anon_sym_PIPE_DOT] = ACTIONS(105),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(105),
    [sym_html_redirect_operator] = ACTIONS(109),
    [sym_html_append_operator] = ACTIONS(105),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(121),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(105),
    [anon_sym_CR] = ACTIONS(105),
    [sym_file_descriptor] = ACTIONS(105),
  },
  [46] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(57),
    [sym_args] = STATE(203),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(57),
    [ts_builtin_sym_end] = ACTIONS(123),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(125),
    [anon_sym_PIPEH] = ACTIONS(123),
    [anon_sym_AT_AT_DOT] = ACTIONS(123),
    [anon_sym_AT_AT_EQ] = ACTIONS(123),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(123),
    [anon_sym_AT_AT] = ACTIONS(125),
    [anon_sym_AT_ATc_COLON] = ACTIONS(123),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(123),
    [anon_sym_AT_ATC] = ACTIONS(123),
    [anon_sym_AT_ATdbt] = ACTIONS(125),
    [anon_sym_AT_ATdbta] = ACTIONS(123),
    [anon_sym_AT_ATdbtb] = ACTIONS(123),
    [anon_sym_AT_ATdbts] = ACTIONS(123),
    [anon_sym_AT_ATt] = ACTIONS(123),
    [anon_sym_AT_ATb] = ACTIONS(123),
    [anon_sym_AT_ATi] = ACTIONS(125),
    [anon_sym_AT_ATii] = ACTIONS(123),
    [anon_sym_AT_ATiS] = ACTIONS(125),
    [anon_sym_AT_ATiSS] = ACTIONS(123),
    [anon_sym_AT_ATis] = ACTIONS(123),
    [anon_sym_AT_ATiz] = ACTIONS(123),
    [anon_sym_AT_ATf] = ACTIONS(123),
    [anon_sym_AT_ATF] = ACTIONS(123),
    [anon_sym_AT_ATom] = ACTIONS(123),
    [anon_sym_AT_ATdm] = ACTIONS(123),
    [anon_sym_AT_ATr] = ACTIONS(123),
    [anon_sym_AT_ATs_COLON] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(125),
    [anon_sym_AT_BANG] = ACTIONS(123),
    [anon_sym_AT_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_ATa_COLON] = ACTIONS(123),
    [anon_sym_ATb_COLON] = ACTIONS(123),
    [anon_sym_ATB_COLON] = ACTIONS(123),
    [anon_sym_ATe_COLON] = ACTIONS(123),
    [anon_sym_ATF_COLON] = ACTIONS(123),
    [anon_sym_ATi_COLON] = ACTIONS(123),
    [anon_sym_ATk_COLON] = ACTIONS(123),
    [anon_sym_ATo_COLON] = ACTIONS(123),
    [anon_sym_ATr_COLON] = ACTIONS(123),
    [anon_sym_ATf_COLON] = ACTIONS(123),
    [anon_sym_ATs_COLON] = ACTIONS(123),
    [anon_sym_ATv_COLON] = ACTIONS(123),
    [anon_sym_ATx_COLON] = ACTIONS(123),
    [anon_sym_PIPE_DOT] = ACTIONS(123),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_GT_GT] = ACTIONS(123),
    [sym_html_redirect_operator] = ACTIONS(125),
    [sym_html_append_operator] = ACTIONS(123),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(121),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(123),
    [anon_sym_CR] = ACTIONS(123),
    [sym_file_descriptor] = ACTIONS(123),
  },
  [47] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(57),
    [sym_args] = STATE(206),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(57),
    [ts_builtin_sym_end] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_PIPEH] = ACTIONS(127),
    [anon_sym_AT_AT_DOT] = ACTIONS(127),
    [anon_sym_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT] = ACTIONS(129),
    [anon_sym_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_ATC] = ACTIONS(127),
    [anon_sym_AT_ATdbt] = ACTIONS(129),
    [anon_sym_AT_ATdbta] = ACTIONS(127),
    [anon_sym_AT_ATdbtb] = ACTIONS(127),
    [anon_sym_AT_ATdbts] = ACTIONS(127),
    [anon_sym_AT_ATt] = ACTIONS(127),
    [anon_sym_AT_ATb] = ACTIONS(127),
    [anon_sym_AT_ATi] = ACTIONS(129),
    [anon_sym_AT_ATii] = ACTIONS(127),
    [anon_sym_AT_ATiS] = ACTIONS(129),
    [anon_sym_AT_ATiSS] = ACTIONS(127),
    [anon_sym_AT_ATis] = ACTIONS(127),
    [anon_sym_AT_ATiz] = ACTIONS(127),
    [anon_sym_AT_ATf] = ACTIONS(127),
    [anon_sym_AT_ATF] = ACTIONS(127),
    [anon_sym_AT_ATom] = ACTIONS(127),
    [anon_sym_AT_ATdm] = ACTIONS(127),
    [anon_sym_AT_ATr] = ACTIONS(127),
    [anon_sym_AT_ATs_COLON] = ACTIONS(127),
    [anon_sym_AT] = ACTIONS(129),
    [anon_sym_AT_BANG] = ACTIONS(127),
    [anon_sym_AT_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(127),
    [anon_sym_ATa_COLON] = ACTIONS(127),
    [anon_sym_ATb_COLON] = ACTIONS(127),
    [anon_sym_ATB_COLON] = ACTIONS(127),
    [anon_sym_ATe_COLON] = ACTIONS(127),
    [anon_sym_ATF_COLON] = ACTIONS(127),
    [anon_sym_ATi_COLON] = ACTIONS(127),
    [anon_sym_ATk_COLON] = ACTIONS(127),
    [anon_sym_ATo_COLON] = ACTIONS(127),
    [anon_sym_ATr_COLON] = ACTIONS(127),
    [anon_sym_ATf_COLON] = ACTIONS(127),
    [anon_sym_ATs_COLON] = ACTIONS(127),
    [anon_sym_ATv_COLON] = ACTIONS(127),
    [anon_sym_ATx_COLON] = ACTIONS(127),
    [anon_sym_PIPE_DOT] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(127),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(127),
    [sym_html_redirect_operator] = ACTIONS(129),
    [sym_html_append_operator] = ACTIONS(127),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(121),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(127),
    [anon_sym_CR] = ACTIONS(127),
    [sym_file_descriptor] = ACTIONS(127),
  },
  [48] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(57),
    [sym_args] = STATE(267),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(57),
    [ts_builtin_sym_end] = ACTIONS(131),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_PIPEH] = ACTIONS(131),
    [anon_sym_AT_AT_DOT] = ACTIONS(131),
    [anon_sym_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT] = ACTIONS(133),
    [anon_sym_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_ATC] = ACTIONS(131),
    [anon_sym_AT_ATdbt] = ACTIONS(133),
    [anon_sym_AT_ATdbta] = ACTIONS(131),
    [anon_sym_AT_ATdbtb] = ACTIONS(131),
    [anon_sym_AT_ATdbts] = ACTIONS(131),
    [anon_sym_AT_ATt] = ACTIONS(131),
    [anon_sym_AT_ATb] = ACTIONS(131),
    [anon_sym_AT_ATi] = ACTIONS(133),
    [anon_sym_AT_ATii] = ACTIONS(131),
    [anon_sym_AT_ATiS] = ACTIONS(133),
    [anon_sym_AT_ATiSS] = ACTIONS(131),
    [anon_sym_AT_ATis] = ACTIONS(131),
    [anon_sym_AT_ATiz] = ACTIONS(131),
    [anon_sym_AT_ATf] = ACTIONS(131),
    [anon_sym_AT_ATF] = ACTIONS(131),
    [anon_sym_AT_ATom] = ACTIONS(131),
    [anon_sym_AT_ATdm] = ACTIONS(131),
    [anon_sym_AT_ATr] = ACTIONS(131),
    [anon_sym_AT_ATs_COLON] = ACTIONS(131),
    [anon_sym_AT] = ACTIONS(133),
    [anon_sym_AT_BANG] = ACTIONS(131),
    [anon_sym_AT_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_ATa_COLON] = ACTIONS(131),
    [anon_sym_ATb_COLON] = ACTIONS(131),
    [anon_sym_ATB_COLON] = ACTIONS(131),
    [anon_sym_ATe_COLON] = ACTIONS(131),
    [anon_sym_ATF_COLON] = ACTIONS(131),
    [anon_sym_ATi_COLON] = ACTIONS(131),
    [anon_sym_ATk_COLON] = ACTIONS(131),
    [anon_sym_ATo_COLON] = ACTIONS(131),
    [anon_sym_ATr_COLON] = ACTIONS(131),
    [anon_sym_ATf_COLON] = ACTIONS(131),
    [anon_sym_ATs_COLON] = ACTIONS(131),
    [anon_sym_ATv_COLON] = ACTIONS(131),
    [anon_sym_ATx_COLON] = ACTIONS(131),
    [anon_sym_PIPE_DOT] = ACTIONS(131),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(131),
    [sym_html_redirect_operator] = ACTIONS(133),
    [sym_html_append_operator] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(121),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(131),
    [anon_sym_CR] = ACTIONS(131),
    [sym_file_descriptor] = ACTIONS(131),
  },
  [49] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(57),
    [sym_args] = STATE(209),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(57),
    [ts_builtin_sym_end] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_PIPEH] = ACTIONS(135),
    [anon_sym_AT_AT_DOT] = ACTIONS(135),
    [anon_sym_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT] = ACTIONS(137),
    [anon_sym_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_ATC] = ACTIONS(135),
    [anon_sym_AT_ATdbt] = ACTIONS(137),
    [anon_sym_AT_ATdbta] = ACTIONS(135),
    [anon_sym_AT_ATdbtb] = ACTIONS(135),
    [anon_sym_AT_ATdbts] = ACTIONS(135),
    [anon_sym_AT_ATt] = ACTIONS(135),
    [anon_sym_AT_ATb] = ACTIONS(135),
    [anon_sym_AT_ATi] = ACTIONS(137),
    [anon_sym_AT_ATii] = ACTIONS(135),
    [anon_sym_AT_ATiS] = ACTIONS(137),
    [anon_sym_AT_ATiSS] = ACTIONS(135),
    [anon_sym_AT_ATis] = ACTIONS(135),
    [anon_sym_AT_ATiz] = ACTIONS(135),
    [anon_sym_AT_ATf] = ACTIONS(135),
    [anon_sym_AT_ATF] = ACTIONS(135),
    [anon_sym_AT_ATom] = ACTIONS(135),
    [anon_sym_AT_ATdm] = ACTIONS(135),
    [anon_sym_AT_ATr] = ACTIONS(135),
    [anon_sym_AT_ATs_COLON] = ACTIONS(135),
    [anon_sym_AT] = ACTIONS(137),
    [anon_sym_AT_BANG] = ACTIONS(135),
    [anon_sym_AT_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_ATa_COLON] = ACTIONS(135),
    [anon_sym_ATb_COLON] = ACTIONS(135),
    [anon_sym_ATB_COLON] = ACTIONS(135),
    [anon_sym_ATe_COLON] = ACTIONS(135),
    [anon_sym_ATF_COLON] = ACTIONS(135),
    [anon_sym_ATi_COLON] = ACTIONS(135),
    [anon_sym_ATk_COLON] = ACTIONS(135),
    [anon_sym_ATo_COLON] = ACTIONS(135),
    [anon_sym_ATr_COLON] = ACTIONS(135),
    [anon_sym_ATf_COLON] = ACTIONS(135),
    [anon_sym_ATs_COLON] = ACTIONS(135),
    [anon_sym_ATv_COLON] = ACTIONS(135),
    [anon_sym_ATx_COLON] = ACTIONS(135),
    [anon_sym_PIPE_DOT] = ACTIONS(135),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(135),
    [sym_html_redirect_operator] = ACTIONS(137),
    [sym_html_append_operator] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(121),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(135),
    [anon_sym_CR] = ACTIONS(135),
    [sym_file_descriptor] = ACTIONS(135),
  },
  [50] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(57),
    [sym_args] = STATE(268),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(57),
    [ts_builtin_sym_end] = ACTIONS(139),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(141),
    [anon_sym_PIPEH] = ACTIONS(139),
    [anon_sym_AT_AT_DOT] = ACTIONS(139),
    [anon_sym_AT_AT_EQ] = ACTIONS(139),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(139),
    [anon_sym_AT_AT] = ACTIONS(141),
    [anon_sym_AT_ATc_COLON] = ACTIONS(139),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(139),
    [anon_sym_AT_ATC] = ACTIONS(139),
    [anon_sym_AT_ATdbt] = ACTIONS(141),
    [anon_sym_AT_ATdbta] = ACTIONS(139),
    [anon_sym_AT_ATdbtb] = ACTIONS(139),
    [anon_sym_AT_ATdbts] = ACTIONS(139),
    [anon_sym_AT_ATt] = ACTIONS(139),
    [anon_sym_AT_ATb] = ACTIONS(139),
    [anon_sym_AT_ATi] = ACTIONS(141),
    [anon_sym_AT_ATii] = ACTIONS(139),
    [anon_sym_AT_ATiS] = ACTIONS(141),
    [anon_sym_AT_ATiSS] = ACTIONS(139),
    [anon_sym_AT_ATis] = ACTIONS(139),
    [anon_sym_AT_ATiz] = ACTIONS(139),
    [anon_sym_AT_ATf] = ACTIONS(139),
    [anon_sym_AT_ATF] = ACTIONS(139),
    [anon_sym_AT_ATom] = ACTIONS(139),
    [anon_sym_AT_ATdm] = ACTIONS(139),
    [anon_sym_AT_ATr] = ACTIONS(139),
    [anon_sym_AT_ATs_COLON] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(141),
    [anon_sym_AT_BANG] = ACTIONS(139),
    [anon_sym_AT_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(139),
    [anon_sym_ATa_COLON] = ACTIONS(139),
    [anon_sym_ATb_COLON] = ACTIONS(139),
    [anon_sym_ATB_COLON] = ACTIONS(139),
    [anon_sym_ATe_COLON] = ACTIONS(139),
    [anon_sym_ATF_COLON] = ACTIONS(139),
    [anon_sym_ATi_COLON] = ACTIONS(139),
    [anon_sym_ATk_COLON] = ACTIONS(139),
    [anon_sym_ATo_COLON] = ACTIONS(139),
    [anon_sym_ATr_COLON] = ACTIONS(139),
    [anon_sym_ATf_COLON] = ACTIONS(139),
    [anon_sym_ATs_COLON] = ACTIONS(139),
    [anon_sym_ATv_COLON] = ACTIONS(139),
    [anon_sym_ATx_COLON] = ACTIONS(139),
    [anon_sym_PIPE_DOT] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(141),
    [anon_sym_GT_GT] = ACTIONS(139),
    [sym_html_redirect_operator] = ACTIONS(141),
    [sym_html_append_operator] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(121),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(139),
    [anon_sym_CR] = ACTIONS(139),
    [sym_file_descriptor] = ACTIONS(139),
  },
  [51] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(57),
    [sym_args] = STATE(208),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(57),
    [ts_builtin_sym_end] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(143),
    [anon_sym_PIPE] = ACTIONS(145),
    [anon_sym_PIPEH] = ACTIONS(143),
    [anon_sym_AT_AT_DOT] = ACTIONS(143),
    [anon_sym_AT_AT_EQ] = ACTIONS(143),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(143),
    [anon_sym_AT_AT] = ACTIONS(145),
    [anon_sym_AT_ATc_COLON] = ACTIONS(143),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(143),
    [anon_sym_AT_ATC] = ACTIONS(143),
    [anon_sym_AT_ATdbt] = ACTIONS(145),
    [anon_sym_AT_ATdbta] = ACTIONS(143),
    [anon_sym_AT_ATdbtb] = ACTIONS(143),
    [anon_sym_AT_ATdbts] = ACTIONS(143),
    [anon_sym_AT_ATt] = ACTIONS(143),
    [anon_sym_AT_ATb] = ACTIONS(143),
    [anon_sym_AT_ATi] = ACTIONS(145),
    [anon_sym_AT_ATii] = ACTIONS(143),
    [anon_sym_AT_ATiS] = ACTIONS(145),
    [anon_sym_AT_ATiSS] = ACTIONS(143),
    [anon_sym_AT_ATis] = ACTIONS(143),
    [anon_sym_AT_ATiz] = ACTIONS(143),
    [anon_sym_AT_ATf] = ACTIONS(143),
    [anon_sym_AT_ATF] = ACTIONS(143),
    [anon_sym_AT_ATom] = ACTIONS(143),
    [anon_sym_AT_ATdm] = ACTIONS(143),
    [anon_sym_AT_ATr] = ACTIONS(143),
    [anon_sym_AT_ATs_COLON] = ACTIONS(143),
    [anon_sym_AT] = ACTIONS(145),
    [anon_sym_AT_BANG] = ACTIONS(143),
    [anon_sym_AT_LPAREN] = ACTIONS(143),
    [anon_sym_RPAREN] = ACTIONS(143),
    [anon_sym_ATa_COLON] = ACTIONS(143),
    [anon_sym_ATb_COLON] = ACTIONS(143),
    [anon_sym_ATB_COLON] = ACTIONS(143),
    [anon_sym_ATe_COLON] = ACTIONS(143),
    [anon_sym_ATF_COLON] = ACTIONS(143),
    [anon_sym_ATi_COLON] = ACTIONS(143),
    [anon_sym_ATk_COLON] = ACTIONS(143),
    [anon_sym_ATo_COLON] = ACTIONS(143),
    [anon_sym_ATr_COLON] = ACTIONS(143),
    [anon_sym_ATf_COLON] = ACTIONS(143),
    [anon_sym_ATs_COLON] = ACTIONS(143),
    [anon_sym_ATv_COLON] = ACTIONS(143),
    [anon_sym_ATx_COLON] = ACTIONS(143),
    [anon_sym_PIPE_DOT] = ACTIONS(143),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(143),
    [sym_html_redirect_operator] = ACTIONS(145),
    [sym_html_append_operator] = ACTIONS(143),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(121),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(143),
    [anon_sym_CR] = ACTIONS(143),
    [sym_file_descriptor] = ACTIONS(143),
  },
  [52] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(57),
    [sym_args] = STATE(266),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(57),
    [ts_builtin_sym_end] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_PIPEH] = ACTIONS(147),
    [anon_sym_AT_AT_DOT] = ACTIONS(147),
    [anon_sym_AT_AT_EQ] = ACTIONS(147),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(147),
    [anon_sym_AT_AT] = ACTIONS(149),
    [anon_sym_AT_ATc_COLON] = ACTIONS(147),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(147),
    [anon_sym_AT_ATC] = ACTIONS(147),
    [anon_sym_AT_ATdbt] = ACTIONS(149),
    [anon_sym_AT_ATdbta] = ACTIONS(147),
    [anon_sym_AT_ATdbtb] = ACTIONS(147),
    [anon_sym_AT_ATdbts] = ACTIONS(147),
    [anon_sym_AT_ATt] = ACTIONS(147),
    [anon_sym_AT_ATb] = ACTIONS(147),
    [anon_sym_AT_ATi] = ACTIONS(149),
    [anon_sym_AT_ATii] = ACTIONS(147),
    [anon_sym_AT_ATiS] = ACTIONS(149),
    [anon_sym_AT_ATiSS] = ACTIONS(147),
    [anon_sym_AT_ATis] = ACTIONS(147),
    [anon_sym_AT_ATiz] = ACTIONS(147),
    [anon_sym_AT_ATf] = ACTIONS(147),
    [anon_sym_AT_ATF] = ACTIONS(147),
    [anon_sym_AT_ATom] = ACTIONS(147),
    [anon_sym_AT_ATdm] = ACTIONS(147),
    [anon_sym_AT_ATr] = ACTIONS(147),
    [anon_sym_AT_ATs_COLON] = ACTIONS(147),
    [anon_sym_AT] = ACTIONS(149),
    [anon_sym_AT_BANG] = ACTIONS(147),
    [anon_sym_AT_LPAREN] = ACTIONS(147),
    [anon_sym_RPAREN] = ACTIONS(147),
    [anon_sym_ATa_COLON] = ACTIONS(147),
    [anon_sym_ATb_COLON] = ACTIONS(147),
    [anon_sym_ATB_COLON] = ACTIONS(147),
    [anon_sym_ATe_COLON] = ACTIONS(147),
    [anon_sym_ATF_COLON] = ACTIONS(147),
    [anon_sym_ATi_COLON] = ACTIONS(147),
    [anon_sym_ATk_COLON] = ACTIONS(147),
    [anon_sym_ATo_COLON] = ACTIONS(147),
    [anon_sym_ATr_COLON] = ACTIONS(147),
    [anon_sym_ATf_COLON] = ACTIONS(147),
    [anon_sym_ATs_COLON] = ACTIONS(147),
    [anon_sym_ATv_COLON] = ACTIONS(147),
    [anon_sym_ATx_COLON] = ACTIONS(147),
    [anon_sym_PIPE_DOT] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(147),
    [sym_html_redirect_operator] = ACTIONS(149),
    [sym_html_append_operator] = ACTIONS(147),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(121),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(147),
    [anon_sym_CR] = ACTIONS(147),
    [sym_file_descriptor] = ACTIONS(147),
  },
  [53] = {
    [sym_macro_content] = STATE(135),
    [sym_macro_args] = STATE(196),
    [sym__arg_with_paren] = STATE(325),
    [sym__arg] = STATE(325),
    [sym_arg] = STATE(282),
    [sym_arg_identifier] = STATE(325),
    [sym_double_quoted_arg] = STATE(325),
    [sym_single_quoted_arg] = STATE(325),
    [sym_cmd_substitution_arg] = STATE(325),
    [sym_concatenation] = STATE(351),
    [ts_builtin_sym_end] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_PIPEH] = ACTIONS(151),
    [anon_sym_AT_AT_DOT] = ACTIONS(151),
    [anon_sym_AT_AT_EQ] = ACTIONS(151),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(151),
    [anon_sym_AT_AT] = ACTIONS(155),
    [anon_sym_AT_ATc_COLON] = ACTIONS(151),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(151),
    [anon_sym_AT_ATC] = ACTIONS(151),
    [anon_sym_AT_ATdbt] = ACTIONS(155),
    [anon_sym_AT_ATdbta] = ACTIONS(151),
    [anon_sym_AT_ATdbtb] = ACTIONS(151),
    [anon_sym_AT_ATdbts] = ACTIONS(151),
    [anon_sym_AT_ATt] = ACTIONS(151),
    [anon_sym_AT_ATb] = ACTIONS(151),
    [anon_sym_AT_ATi] = ACTIONS(155),
    [anon_sym_AT_ATii] = ACTIONS(151),
    [anon_sym_AT_ATiS] = ACTIONS(155),
    [anon_sym_AT_ATiSS] = ACTIONS(151),
    [anon_sym_AT_ATis] = ACTIONS(151),
    [anon_sym_AT_ATiz] = ACTIONS(151),
    [anon_sym_AT_ATf] = ACTIONS(151),
    [anon_sym_AT_ATF] = ACTIONS(151),
    [anon_sym_AT_ATom] = ACTIONS(151),
    [anon_sym_AT_ATdm] = ACTIONS(151),
    [anon_sym_AT_ATr] = ACTIONS(151),
    [anon_sym_AT_ATs_COLON] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_AT_BANG] = ACTIONS(151),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_ATa_COLON] = ACTIONS(151),
    [anon_sym_ATb_COLON] = ACTIONS(151),
    [anon_sym_ATB_COLON] = ACTIONS(151),
    [anon_sym_ATe_COLON] = ACTIONS(151),
    [anon_sym_ATF_COLON] = ACTIONS(151),
    [anon_sym_ATi_COLON] = ACTIONS(151),
    [anon_sym_ATk_COLON] = ACTIONS(151),
    [anon_sym_ATo_COLON] = ACTIONS(151),
    [anon_sym_ATr_COLON] = ACTIONS(151),
    [anon_sym_ATf_COLON] = ACTIONS(151),
    [anon_sym_ATs_COLON] = ACTIONS(151),
    [anon_sym_ATv_COLON] = ACTIONS(151),
    [anon_sym_ATx_COLON] = ACTIONS(151),
    [anon_sym_PIPE_DOT] = ACTIONS(151),
    [anon_sym_DOLLAR] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(159),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_GT_GT] = ACTIONS(151),
    [sym_html_redirect_operator] = ACTIONS(155),
    [sym_html_append_operator] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(161),
    [aux_sym_arg_identifier_token1] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(167),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(151),
    [anon_sym_CR] = ACTIONS(151),
    [sym_file_descriptor] = ACTIONS(151),
  },
  [54] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(57),
    [sym_args] = STATE(187),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(57),
    [ts_builtin_sym_end] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_PIPEH] = ACTIONS(169),
    [anon_sym_AT_AT_DOT] = ACTIONS(169),
    [anon_sym_AT_AT_EQ] = ACTIONS(169),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(169),
    [anon_sym_AT_AT] = ACTIONS(171),
    [anon_sym_AT_ATc_COLON] = ACTIONS(169),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(169),
    [anon_sym_AT_ATC] = ACTIONS(169),
    [anon_sym_AT_ATdbt] = ACTIONS(171),
    [anon_sym_AT_ATdbta] = ACTIONS(169),
    [anon_sym_AT_ATdbtb] = ACTIONS(169),
    [anon_sym_AT_ATdbts] = ACTIONS(169),
    [anon_sym_AT_ATt] = ACTIONS(169),
    [anon_sym_AT_ATb] = ACTIONS(169),
    [anon_sym_AT_ATi] = ACTIONS(171),
    [anon_sym_AT_ATii] = ACTIONS(169),
    [anon_sym_AT_ATiS] = ACTIONS(171),
    [anon_sym_AT_ATiSS] = ACTIONS(169),
    [anon_sym_AT_ATis] = ACTIONS(169),
    [anon_sym_AT_ATiz] = ACTIONS(169),
    [anon_sym_AT_ATf] = ACTIONS(169),
    [anon_sym_AT_ATF] = ACTIONS(169),
    [anon_sym_AT_ATom] = ACTIONS(169),
    [anon_sym_AT_ATdm] = ACTIONS(169),
    [anon_sym_AT_ATr] = ACTIONS(169),
    [anon_sym_AT_ATs_COLON] = ACTIONS(169),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_AT_BANG] = ACTIONS(169),
    [anon_sym_AT_LPAREN] = ACTIONS(169),
    [anon_sym_RPAREN] = ACTIONS(169),
    [anon_sym_ATa_COLON] = ACTIONS(169),
    [anon_sym_ATb_COLON] = ACTIONS(169),
    [anon_sym_ATB_COLON] = ACTIONS(169),
    [anon_sym_ATe_COLON] = ACTIONS(169),
    [anon_sym_ATF_COLON] = ACTIONS(169),
    [anon_sym_ATi_COLON] = ACTIONS(169),
    [anon_sym_ATk_COLON] = ACTIONS(169),
    [anon_sym_ATo_COLON] = ACTIONS(169),
    [anon_sym_ATr_COLON] = ACTIONS(169),
    [anon_sym_ATf_COLON] = ACTIONS(169),
    [anon_sym_ATs_COLON] = ACTIONS(169),
    [anon_sym_ATv_COLON] = ACTIONS(169),
    [anon_sym_ATx_COLON] = ACTIONS(169),
    [anon_sym_PIPE_DOT] = ACTIONS(169),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(171),
    [anon_sym_GT_GT] = ACTIONS(169),
    [sym_html_redirect_operator] = ACTIONS(171),
    [sym_html_append_operator] = ACTIONS(169),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(121),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_CR] = ACTIONS(169),
    [sym_file_descriptor] = ACTIONS(169),
  },
  [55] = {
    [sym__Cf_args] = STATE(261),
    [sym__arg_with_paren] = STATE(390),
    [sym__arg] = STATE(390),
    [sym_arg] = STATE(349),
    [sym_arg_identifier] = STATE(390),
    [sym_double_quoted_arg] = STATE(390),
    [sym_single_quoted_arg] = STATE(390),
    [sym_cmd_substitution_arg] = STATE(390),
    [sym_concatenation] = STATE(413),
    [ts_builtin_sym_end] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_PIPE] = ACTIONS(177),
    [anon_sym_PIPEH] = ACTIONS(173),
    [anon_sym_AT_AT_DOT] = ACTIONS(173),
    [anon_sym_AT_AT_EQ] = ACTIONS(173),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(173),
    [anon_sym_AT_AT] = ACTIONS(177),
    [anon_sym_AT_ATc_COLON] = ACTIONS(173),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(173),
    [anon_sym_AT_ATC] = ACTIONS(173),
    [anon_sym_AT_ATdbt] = ACTIONS(177),
    [anon_sym_AT_ATdbta] = ACTIONS(173),
    [anon_sym_AT_ATdbtb] = ACTIONS(173),
    [anon_sym_AT_ATdbts] = ACTIONS(173),
    [anon_sym_AT_ATt] = ACTIONS(173),
    [anon_sym_AT_ATb] = ACTIONS(173),
    [anon_sym_AT_ATi] = ACTIONS(177),
    [anon_sym_AT_ATii] = ACTIONS(173),
    [anon_sym_AT_ATiS] = ACTIONS(177),
    [anon_sym_AT_ATiSS] = ACTIONS(173),
    [anon_sym_AT_ATis] = ACTIONS(173),
    [anon_sym_AT_ATiz] = ACTIONS(173),
    [anon_sym_AT_ATf] = ACTIONS(173),
    [anon_sym_AT_ATF] = ACTIONS(173),
    [anon_sym_AT_ATom] = ACTIONS(173),
    [anon_sym_AT_ATdm] = ACTIONS(173),
    [anon_sym_AT_ATr] = ACTIONS(173),
    [anon_sym_AT_ATs_COLON] = ACTIONS(173),
    [anon_sym_AT] = ACTIONS(177),
    [anon_sym_AT_BANG] = ACTIONS(173),
    [anon_sym_AT_LPAREN] = ACTIONS(173),
    [anon_sym_RPAREN] = ACTIONS(173),
    [anon_sym_ATa_COLON] = ACTIONS(173),
    [anon_sym_ATb_COLON] = ACTIONS(173),
    [anon_sym_ATB_COLON] = ACTIONS(173),
    [anon_sym_ATe_COLON] = ACTIONS(173),
    [anon_sym_ATF_COLON] = ACTIONS(173),
    [anon_sym_ATi_COLON] = ACTIONS(173),
    [anon_sym_ATk_COLON] = ACTIONS(173),
    [anon_sym_ATo_COLON] = ACTIONS(173),
    [anon_sym_ATr_COLON] = ACTIONS(173),
    [anon_sym_ATf_COLON] = ACTIONS(173),
    [anon_sym_ATs_COLON] = ACTIONS(173),
    [anon_sym_ATv_COLON] = ACTIONS(173),
    [anon_sym_ATx_COLON] = ACTIONS(173),
    [anon_sym_PIPE_DOT] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(179),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(173),
    [anon_sym_GT] = ACTIONS(177),
    [anon_sym_GT_GT] = ACTIONS(173),
    [sym_html_redirect_operator] = ACTIONS(177),
    [sym_html_append_operator] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(183),
    [aux_sym_arg_identifier_token1] = ACTIONS(179),
    [anon_sym_SQUOTE] = ACTIONS(185),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(189),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(173),
    [anon_sym_CR] = ACTIONS(173),
    [sym_file_descriptor] = ACTIONS(173),
  },
  [56] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(56),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(56),
    [ts_builtin_sym_end] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(193),
    [anon_sym_TILDE] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(196),
    [anon_sym_PIPEH] = ACTIONS(191),
    [anon_sym_AT_AT_DOT] = ACTIONS(191),
    [anon_sym_AT_AT_EQ] = ACTIONS(191),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(191),
    [anon_sym_AT_AT] = ACTIONS(196),
    [anon_sym_AT_ATc_COLON] = ACTIONS(191),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(191),
    [anon_sym_AT_ATC] = ACTIONS(191),
    [anon_sym_AT_ATdbt] = ACTIONS(196),
    [anon_sym_AT_ATdbta] = ACTIONS(191),
    [anon_sym_AT_ATdbtb] = ACTIONS(191),
    [anon_sym_AT_ATdbts] = ACTIONS(191),
    [anon_sym_AT_ATt] = ACTIONS(191),
    [anon_sym_AT_ATb] = ACTIONS(191),
    [anon_sym_AT_ATi] = ACTIONS(196),
    [anon_sym_AT_ATii] = ACTIONS(191),
    [anon_sym_AT_ATiS] = ACTIONS(196),
    [anon_sym_AT_ATiSS] = ACTIONS(191),
    [anon_sym_AT_ATis] = ACTIONS(191),
    [anon_sym_AT_ATiz] = ACTIONS(191),
    [anon_sym_AT_ATf] = ACTIONS(191),
    [anon_sym_AT_ATF] = ACTIONS(191),
    [anon_sym_AT_ATom] = ACTIONS(191),
    [anon_sym_AT_ATdm] = ACTIONS(191),
    [anon_sym_AT_ATr] = ACTIONS(191),
    [anon_sym_AT_ATs_COLON] = ACTIONS(191),
    [anon_sym_AT] = ACTIONS(196),
    [anon_sym_AT_BANG] = ACTIONS(191),
    [anon_sym_AT_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(191),
    [anon_sym_ATa_COLON] = ACTIONS(191),
    [anon_sym_ATb_COLON] = ACTIONS(191),
    [anon_sym_ATB_COLON] = ACTIONS(191),
    [anon_sym_ATe_COLON] = ACTIONS(191),
    [anon_sym_ATF_COLON] = ACTIONS(191),
    [anon_sym_ATi_COLON] = ACTIONS(191),
    [anon_sym_ATk_COLON] = ACTIONS(191),
    [anon_sym_ATo_COLON] = ACTIONS(191),
    [anon_sym_ATr_COLON] = ACTIONS(191),
    [anon_sym_ATf_COLON] = ACTIONS(191),
    [anon_sym_ATs_COLON] = ACTIONS(191),
    [anon_sym_ATv_COLON] = ACTIONS(191),
    [anon_sym_ATx_COLON] = ACTIONS(191),
    [anon_sym_PIPE_DOT] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(191),
    [anon_sym_GT] = ACTIONS(196),
    [anon_sym_GT_GT] = ACTIONS(191),
    [sym_html_redirect_operator] = ACTIONS(196),
    [sym_html_append_operator] = ACTIONS(191),
    [anon_sym_COMMA] = ACTIONS(204),
    [aux_sym_arg_identifier_token1] = ACTIONS(198),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(210),
    [anon_sym_BQUOTE] = ACTIONS(213),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(191),
    [anon_sym_CR] = ACTIONS(191),
    [sym_file_descriptor] = ACTIONS(191),
  },
  [57] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(56),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(56),
    [ts_builtin_sym_end] = ACTIONS(216),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(216),
    [anon_sym_PIPE] = ACTIONS(218),
    [anon_sym_PIPEH] = ACTIONS(216),
    [anon_sym_AT_AT_DOT] = ACTIONS(216),
    [anon_sym_AT_AT_EQ] = ACTIONS(216),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(216),
    [anon_sym_AT_AT] = ACTIONS(218),
    [anon_sym_AT_ATc_COLON] = ACTIONS(216),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(216),
    [anon_sym_AT_ATC] = ACTIONS(216),
    [anon_sym_AT_ATdbt] = ACTIONS(218),
    [anon_sym_AT_ATdbta] = ACTIONS(216),
    [anon_sym_AT_ATdbtb] = ACTIONS(216),
    [anon_sym_AT_ATdbts] = ACTIONS(216),
    [anon_sym_AT_ATt] = ACTIONS(216),
    [anon_sym_AT_ATb] = ACTIONS(216),
    [anon_sym_AT_ATi] = ACTIONS(218),
    [anon_sym_AT_ATii] = ACTIONS(216),
    [anon_sym_AT_ATiS] = ACTIONS(218),
    [anon_sym_AT_ATiSS] = ACTIONS(216),
    [anon_sym_AT_ATis] = ACTIONS(216),
    [anon_sym_AT_ATiz] = ACTIONS(216),
    [anon_sym_AT_ATf] = ACTIONS(216),
    [anon_sym_AT_ATF] = ACTIONS(216),
    [anon_sym_AT_ATom] = ACTIONS(216),
    [anon_sym_AT_ATdm] = ACTIONS(216),
    [anon_sym_AT_ATr] = ACTIONS(216),
    [anon_sym_AT_ATs_COLON] = ACTIONS(216),
    [anon_sym_AT] = ACTIONS(218),
    [anon_sym_AT_BANG] = ACTIONS(216),
    [anon_sym_AT_LPAREN] = ACTIONS(216),
    [anon_sym_RPAREN] = ACTIONS(216),
    [anon_sym_ATa_COLON] = ACTIONS(216),
    [anon_sym_ATb_COLON] = ACTIONS(216),
    [anon_sym_ATB_COLON] = ACTIONS(216),
    [anon_sym_ATe_COLON] = ACTIONS(216),
    [anon_sym_ATF_COLON] = ACTIONS(216),
    [anon_sym_ATi_COLON] = ACTIONS(216),
    [anon_sym_ATk_COLON] = ACTIONS(216),
    [anon_sym_ATo_COLON] = ACTIONS(216),
    [anon_sym_ATr_COLON] = ACTIONS(216),
    [anon_sym_ATf_COLON] = ACTIONS(216),
    [anon_sym_ATs_COLON] = ACTIONS(216),
    [anon_sym_ATv_COLON] = ACTIONS(216),
    [anon_sym_ATx_COLON] = ACTIONS(216),
    [anon_sym_PIPE_DOT] = ACTIONS(216),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(216),
    [anon_sym_GT] = ACTIONS(218),
    [anon_sym_GT_GT] = ACTIONS(216),
    [sym_html_redirect_operator] = ACTIONS(218),
    [sym_html_append_operator] = ACTIONS(216),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(121),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(216),
    [anon_sym_CR] = ACTIONS(216),
    [sym_file_descriptor] = ACTIONS(216),
  },
  [58] = {
    [sym__pf_arg_parentheses] = STATE(101),
    [sym_pf_arg_identifier] = STATE(101),
    [sym__pf_arg] = STATE(101),
    [sym_pf_concatenation] = STATE(115),
    [sym_pf_arg] = STATE(72),
    [sym_pf_args] = STATE(242),
    [sym_cmd_substitution_arg] = STATE(101),
    [aux_sym_pf_args_repeat1] = STATE(72),
    [aux_sym_pf_dot_args_repeat1] = STATE(121),
    [ts_builtin_sym_end] = ACTIONS(220),
    [anon_sym_TILDE] = ACTIONS(220),
    [anon_sym_PIPE] = ACTIONS(222),
    [anon_sym_PIPEH] = ACTIONS(220),
    [anon_sym_AT_AT_DOT] = ACTIONS(220),
    [anon_sym_AT_AT_EQ] = ACTIONS(220),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(220),
    [anon_sym_AT_AT] = ACTIONS(222),
    [anon_sym_AT_ATc_COLON] = ACTIONS(220),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(220),
    [anon_sym_AT_ATC] = ACTIONS(220),
    [anon_sym_AT_ATdbt] = ACTIONS(222),
    [anon_sym_AT_ATdbta] = ACTIONS(220),
    [anon_sym_AT_ATdbtb] = ACTIONS(220),
    [anon_sym_AT_ATdbts] = ACTIONS(220),
    [anon_sym_AT_ATt] = ACTIONS(220),
    [anon_sym_AT_ATb] = ACTIONS(220),
    [anon_sym_AT_ATi] = ACTIONS(222),
    [anon_sym_AT_ATii] = ACTIONS(220),
    [anon_sym_AT_ATiS] = ACTIONS(222),
    [anon_sym_AT_ATiSS] = ACTIONS(220),
    [anon_sym_AT_ATis] = ACTIONS(220),
    [anon_sym_AT_ATiz] = ACTIONS(220),
    [anon_sym_AT_ATf] = ACTIONS(220),
    [anon_sym_AT_ATF] = ACTIONS(220),
    [anon_sym_AT_ATom] = ACTIONS(220),
    [anon_sym_AT_ATdm] = ACTIONS(220),
    [anon_sym_AT_ATr] = ACTIONS(220),
    [anon_sym_AT_ATs_COLON] = ACTIONS(220),
    [anon_sym_AT] = ACTIONS(222),
    [anon_sym_AT_BANG] = ACTIONS(220),
    [anon_sym_AT_LPAREN] = ACTIONS(220),
    [anon_sym_RPAREN] = ACTIONS(220),
    [anon_sym_ATa_COLON] = ACTIONS(220),
    [anon_sym_ATb_COLON] = ACTIONS(220),
    [anon_sym_ATB_COLON] = ACTIONS(220),
    [anon_sym_ATe_COLON] = ACTIONS(220),
    [anon_sym_ATF_COLON] = ACTIONS(220),
    [anon_sym_ATi_COLON] = ACTIONS(220),
    [anon_sym_ATk_COLON] = ACTIONS(220),
    [anon_sym_ATo_COLON] = ACTIONS(220),
    [anon_sym_ATr_COLON] = ACTIONS(220),
    [anon_sym_ATf_COLON] = ACTIONS(220),
    [anon_sym_ATs_COLON] = ACTIONS(220),
    [anon_sym_ATv_COLON] = ACTIONS(220),
    [anon_sym_ATx_COLON] = ACTIONS(220),
    [anon_sym_PIPE_DOT] = ACTIONS(220),
    [anon_sym_EQ] = ACTIONS(222),
    [anon_sym_DOLLAR] = ACTIONS(224),
    [anon_sym_LPAREN] = ACTIONS(226),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(220),
    [anon_sym_GT] = ACTIONS(222),
    [anon_sym_GT_GT] = ACTIONS(220),
    [sym_html_redirect_operator] = ACTIONS(222),
    [sym_html_append_operator] = ACTIONS(220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(228),
    [anon_sym_BQUOTE] = ACTIONS(230),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(220),
    [anon_sym_CR] = ACTIONS(220),
    [sym_file_descriptor] = ACTIONS(220),
    [sym__concat_pf_dot] = ACTIONS(232),
  },
  [59] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(71),
    [sym_args] = STATE(185),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(71),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_PIPEH] = ACTIONS(105),
    [anon_sym_AT_AT_DOT] = ACTIONS(105),
    [anon_sym_AT_AT_EQ] = ACTIONS(105),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(105),
    [anon_sym_AT_AT] = ACTIONS(109),
    [anon_sym_AT_ATc_COLON] = ACTIONS(105),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(105),
    [anon_sym_AT_ATC] = ACTIONS(105),
    [anon_sym_AT_ATdbt] = ACTIONS(109),
    [anon_sym_AT_ATdbta] = ACTIONS(105),
    [anon_sym_AT_ATdbtb] = ACTIONS(105),
    [anon_sym_AT_ATdbts] = ACTIONS(105),
    [anon_sym_AT_ATt] = ACTIONS(105),
    [anon_sym_AT_ATb] = ACTIONS(105),
    [anon_sym_AT_ATi] = ACTIONS(109),
    [anon_sym_AT_ATii] = ACTIONS(105),
    [anon_sym_AT_ATiS] = ACTIONS(109),
    [anon_sym_AT_ATiSS] = ACTIONS(105),
    [anon_sym_AT_ATis] = ACTIONS(105),
    [anon_sym_AT_ATiz] = ACTIONS(105),
    [anon_sym_AT_ATf] = ACTIONS(105),
    [anon_sym_AT_ATF] = ACTIONS(105),
    [anon_sym_AT_ATom] = ACTIONS(105),
    [anon_sym_AT_ATdm] = ACTIONS(105),
    [anon_sym_AT_ATr] = ACTIONS(105),
    [anon_sym_AT_ATs_COLON] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(109),
    [anon_sym_AT_BANG] = ACTIONS(105),
    [anon_sym_AT_LPAREN] = ACTIONS(105),
    [anon_sym_ATa_COLON] = ACTIONS(105),
    [anon_sym_ATb_COLON] = ACTIONS(105),
    [anon_sym_ATB_COLON] = ACTIONS(105),
    [anon_sym_ATe_COLON] = ACTIONS(105),
    [anon_sym_ATF_COLON] = ACTIONS(105),
    [anon_sym_ATi_COLON] = ACTIONS(105),
    [anon_sym_ATk_COLON] = ACTIONS(105),
    [anon_sym_ATo_COLON] = ACTIONS(105),
    [anon_sym_ATr_COLON] = ACTIONS(105),
    [anon_sym_ATf_COLON] = ACTIONS(105),
    [anon_sym_ATs_COLON] = ACTIONS(105),
    [anon_sym_ATv_COLON] = ACTIONS(105),
    [anon_sym_ATx_COLON] = ACTIONS(105),
    [anon_sym_PIPE_DOT] = ACTIONS(105),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(105),
    [sym_html_redirect_operator] = ACTIONS(109),
    [sym_html_append_operator] = ACTIONS(105),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(105),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(105),
  },
  [60] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(71),
    [sym_args] = STATE(203),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(71),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(125),
    [anon_sym_PIPEH] = ACTIONS(123),
    [anon_sym_AT_AT_DOT] = ACTIONS(123),
    [anon_sym_AT_AT_EQ] = ACTIONS(123),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(123),
    [anon_sym_AT_AT] = ACTIONS(125),
    [anon_sym_AT_ATc_COLON] = ACTIONS(123),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(123),
    [anon_sym_AT_ATC] = ACTIONS(123),
    [anon_sym_AT_ATdbt] = ACTIONS(125),
    [anon_sym_AT_ATdbta] = ACTIONS(123),
    [anon_sym_AT_ATdbtb] = ACTIONS(123),
    [anon_sym_AT_ATdbts] = ACTIONS(123),
    [anon_sym_AT_ATt] = ACTIONS(123),
    [anon_sym_AT_ATb] = ACTIONS(123),
    [anon_sym_AT_ATi] = ACTIONS(125),
    [anon_sym_AT_ATii] = ACTIONS(123),
    [anon_sym_AT_ATiS] = ACTIONS(125),
    [anon_sym_AT_ATiSS] = ACTIONS(123),
    [anon_sym_AT_ATis] = ACTIONS(123),
    [anon_sym_AT_ATiz] = ACTIONS(123),
    [anon_sym_AT_ATf] = ACTIONS(123),
    [anon_sym_AT_ATF] = ACTIONS(123),
    [anon_sym_AT_ATom] = ACTIONS(123),
    [anon_sym_AT_ATdm] = ACTIONS(123),
    [anon_sym_AT_ATr] = ACTIONS(123),
    [anon_sym_AT_ATs_COLON] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(125),
    [anon_sym_AT_BANG] = ACTIONS(123),
    [anon_sym_AT_LPAREN] = ACTIONS(123),
    [anon_sym_ATa_COLON] = ACTIONS(123),
    [anon_sym_ATb_COLON] = ACTIONS(123),
    [anon_sym_ATB_COLON] = ACTIONS(123),
    [anon_sym_ATe_COLON] = ACTIONS(123),
    [anon_sym_ATF_COLON] = ACTIONS(123),
    [anon_sym_ATi_COLON] = ACTIONS(123),
    [anon_sym_ATk_COLON] = ACTIONS(123),
    [anon_sym_ATo_COLON] = ACTIONS(123),
    [anon_sym_ATr_COLON] = ACTIONS(123),
    [anon_sym_ATf_COLON] = ACTIONS(123),
    [anon_sym_ATs_COLON] = ACTIONS(123),
    [anon_sym_ATv_COLON] = ACTIONS(123),
    [anon_sym_ATx_COLON] = ACTIONS(123),
    [anon_sym_PIPE_DOT] = ACTIONS(123),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_GT_GT] = ACTIONS(123),
    [sym_html_redirect_operator] = ACTIONS(125),
    [sym_html_append_operator] = ACTIONS(123),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(123),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(123),
  },
  [61] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(71),
    [sym_args] = STATE(266),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(71),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_PIPEH] = ACTIONS(147),
    [anon_sym_AT_AT_DOT] = ACTIONS(147),
    [anon_sym_AT_AT_EQ] = ACTIONS(147),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(147),
    [anon_sym_AT_AT] = ACTIONS(149),
    [anon_sym_AT_ATc_COLON] = ACTIONS(147),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(147),
    [anon_sym_AT_ATC] = ACTIONS(147),
    [anon_sym_AT_ATdbt] = ACTIONS(149),
    [anon_sym_AT_ATdbta] = ACTIONS(147),
    [anon_sym_AT_ATdbtb] = ACTIONS(147),
    [anon_sym_AT_ATdbts] = ACTIONS(147),
    [anon_sym_AT_ATt] = ACTIONS(147),
    [anon_sym_AT_ATb] = ACTIONS(147),
    [anon_sym_AT_ATi] = ACTIONS(149),
    [anon_sym_AT_ATii] = ACTIONS(147),
    [anon_sym_AT_ATiS] = ACTIONS(149),
    [anon_sym_AT_ATiSS] = ACTIONS(147),
    [anon_sym_AT_ATis] = ACTIONS(147),
    [anon_sym_AT_ATiz] = ACTIONS(147),
    [anon_sym_AT_ATf] = ACTIONS(147),
    [anon_sym_AT_ATF] = ACTIONS(147),
    [anon_sym_AT_ATom] = ACTIONS(147),
    [anon_sym_AT_ATdm] = ACTIONS(147),
    [anon_sym_AT_ATr] = ACTIONS(147),
    [anon_sym_AT_ATs_COLON] = ACTIONS(147),
    [anon_sym_AT] = ACTIONS(149),
    [anon_sym_AT_BANG] = ACTIONS(147),
    [anon_sym_AT_LPAREN] = ACTIONS(147),
    [anon_sym_ATa_COLON] = ACTIONS(147),
    [anon_sym_ATb_COLON] = ACTIONS(147),
    [anon_sym_ATB_COLON] = ACTIONS(147),
    [anon_sym_ATe_COLON] = ACTIONS(147),
    [anon_sym_ATF_COLON] = ACTIONS(147),
    [anon_sym_ATi_COLON] = ACTIONS(147),
    [anon_sym_ATk_COLON] = ACTIONS(147),
    [anon_sym_ATo_COLON] = ACTIONS(147),
    [anon_sym_ATr_COLON] = ACTIONS(147),
    [anon_sym_ATf_COLON] = ACTIONS(147),
    [anon_sym_ATs_COLON] = ACTIONS(147),
    [anon_sym_ATv_COLON] = ACTIONS(147),
    [anon_sym_ATx_COLON] = ACTIONS(147),
    [anon_sym_PIPE_DOT] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(147),
    [sym_html_redirect_operator] = ACTIONS(149),
    [sym_html_append_operator] = ACTIONS(147),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(147),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(147),
  },
  [62] = {
    [sym_macro_content] = STATE(135),
    [sym_macro_args] = STATE(196),
    [sym__arg_with_paren] = STATE(325),
    [sym__arg] = STATE(325),
    [sym_arg] = STATE(282),
    [sym_arg_identifier] = STATE(325),
    [sym_double_quoted_arg] = STATE(325),
    [sym_single_quoted_arg] = STATE(325),
    [sym_cmd_substitution_arg] = STATE(325),
    [sym_concatenation] = STATE(351),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_PIPEH] = ACTIONS(151),
    [anon_sym_AT_AT_DOT] = ACTIONS(151),
    [anon_sym_AT_AT_EQ] = ACTIONS(151),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(151),
    [anon_sym_AT_AT] = ACTIONS(155),
    [anon_sym_AT_ATc_COLON] = ACTIONS(151),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(151),
    [anon_sym_AT_ATC] = ACTIONS(151),
    [anon_sym_AT_ATdbt] = ACTIONS(155),
    [anon_sym_AT_ATdbta] = ACTIONS(151),
    [anon_sym_AT_ATdbtb] = ACTIONS(151),
    [anon_sym_AT_ATdbts] = ACTIONS(151),
    [anon_sym_AT_ATt] = ACTIONS(151),
    [anon_sym_AT_ATb] = ACTIONS(151),
    [anon_sym_AT_ATi] = ACTIONS(155),
    [anon_sym_AT_ATii] = ACTIONS(151),
    [anon_sym_AT_ATiS] = ACTIONS(155),
    [anon_sym_AT_ATiSS] = ACTIONS(151),
    [anon_sym_AT_ATis] = ACTIONS(151),
    [anon_sym_AT_ATiz] = ACTIONS(151),
    [anon_sym_AT_ATf] = ACTIONS(151),
    [anon_sym_AT_ATF] = ACTIONS(151),
    [anon_sym_AT_ATom] = ACTIONS(151),
    [anon_sym_AT_ATdm] = ACTIONS(151),
    [anon_sym_AT_ATr] = ACTIONS(151),
    [anon_sym_AT_ATs_COLON] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(155),
    [anon_sym_AT_BANG] = ACTIONS(151),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_ATa_COLON] = ACTIONS(151),
    [anon_sym_ATb_COLON] = ACTIONS(151),
    [anon_sym_ATB_COLON] = ACTIONS(151),
    [anon_sym_ATe_COLON] = ACTIONS(151),
    [anon_sym_ATF_COLON] = ACTIONS(151),
    [anon_sym_ATi_COLON] = ACTIONS(151),
    [anon_sym_ATk_COLON] = ACTIONS(151),
    [anon_sym_ATo_COLON] = ACTIONS(151),
    [anon_sym_ATr_COLON] = ACTIONS(151),
    [anon_sym_ATf_COLON] = ACTIONS(151),
    [anon_sym_ATs_COLON] = ACTIONS(151),
    [anon_sym_ATv_COLON] = ACTIONS(151),
    [anon_sym_ATx_COLON] = ACTIONS(151),
    [anon_sym_PIPE_DOT] = ACTIONS(151),
    [anon_sym_DOLLAR] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(159),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_GT_GT] = ACTIONS(151),
    [sym_html_redirect_operator] = ACTIONS(155),
    [sym_html_append_operator] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(161),
    [aux_sym_arg_identifier_token1] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(151),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(151),
  },
  [63] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(71),
    [sym_args] = STATE(209),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(71),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_PIPEH] = ACTIONS(135),
    [anon_sym_AT_AT_DOT] = ACTIONS(135),
    [anon_sym_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT] = ACTIONS(137),
    [anon_sym_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_ATC] = ACTIONS(135),
    [anon_sym_AT_ATdbt] = ACTIONS(137),
    [anon_sym_AT_ATdbta] = ACTIONS(135),
    [anon_sym_AT_ATdbtb] = ACTIONS(135),
    [anon_sym_AT_ATdbts] = ACTIONS(135),
    [anon_sym_AT_ATt] = ACTIONS(135),
    [anon_sym_AT_ATb] = ACTIONS(135),
    [anon_sym_AT_ATi] = ACTIONS(137),
    [anon_sym_AT_ATii] = ACTIONS(135),
    [anon_sym_AT_ATiS] = ACTIONS(137),
    [anon_sym_AT_ATiSS] = ACTIONS(135),
    [anon_sym_AT_ATis] = ACTIONS(135),
    [anon_sym_AT_ATiz] = ACTIONS(135),
    [anon_sym_AT_ATf] = ACTIONS(135),
    [anon_sym_AT_ATF] = ACTIONS(135),
    [anon_sym_AT_ATom] = ACTIONS(135),
    [anon_sym_AT_ATdm] = ACTIONS(135),
    [anon_sym_AT_ATr] = ACTIONS(135),
    [anon_sym_AT_ATs_COLON] = ACTIONS(135),
    [anon_sym_AT] = ACTIONS(137),
    [anon_sym_AT_BANG] = ACTIONS(135),
    [anon_sym_AT_LPAREN] = ACTIONS(135),
    [anon_sym_ATa_COLON] = ACTIONS(135),
    [anon_sym_ATb_COLON] = ACTIONS(135),
    [anon_sym_ATB_COLON] = ACTIONS(135),
    [anon_sym_ATe_COLON] = ACTIONS(135),
    [anon_sym_ATF_COLON] = ACTIONS(135),
    [anon_sym_ATi_COLON] = ACTIONS(135),
    [anon_sym_ATk_COLON] = ACTIONS(135),
    [anon_sym_ATo_COLON] = ACTIONS(135),
    [anon_sym_ATr_COLON] = ACTIONS(135),
    [anon_sym_ATf_COLON] = ACTIONS(135),
    [anon_sym_ATs_COLON] = ACTIONS(135),
    [anon_sym_ATv_COLON] = ACTIONS(135),
    [anon_sym_ATx_COLON] = ACTIONS(135),
    [anon_sym_PIPE_DOT] = ACTIONS(135),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(135),
    [sym_html_redirect_operator] = ACTIONS(137),
    [sym_html_append_operator] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(121),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(135),
  },
  [64] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(71),
    [sym_args] = STATE(268),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(71),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(141),
    [anon_sym_PIPEH] = ACTIONS(139),
    [anon_sym_AT_AT_DOT] = ACTIONS(139),
    [anon_sym_AT_AT_EQ] = ACTIONS(139),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(139),
    [anon_sym_AT_AT] = ACTIONS(141),
    [anon_sym_AT_ATc_COLON] = ACTIONS(139),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(139),
    [anon_sym_AT_ATC] = ACTIONS(139),
    [anon_sym_AT_ATdbt] = ACTIONS(141),
    [anon_sym_AT_ATdbta] = ACTIONS(139),
    [anon_sym_AT_ATdbtb] = ACTIONS(139),
    [anon_sym_AT_ATdbts] = ACTIONS(139),
    [anon_sym_AT_ATt] = ACTIONS(139),
    [anon_sym_AT_ATb] = ACTIONS(139),
    [anon_sym_AT_ATi] = ACTIONS(141),
    [anon_sym_AT_ATii] = ACTIONS(139),
    [anon_sym_AT_ATiS] = ACTIONS(141),
    [anon_sym_AT_ATiSS] = ACTIONS(139),
    [anon_sym_AT_ATis] = ACTIONS(139),
    [anon_sym_AT_ATiz] = ACTIONS(139),
    [anon_sym_AT_ATf] = ACTIONS(139),
    [anon_sym_AT_ATF] = ACTIONS(139),
    [anon_sym_AT_ATom] = ACTIONS(139),
    [anon_sym_AT_ATdm] = ACTIONS(139),
    [anon_sym_AT_ATr] = ACTIONS(139),
    [anon_sym_AT_ATs_COLON] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(141),
    [anon_sym_AT_BANG] = ACTIONS(139),
    [anon_sym_AT_LPAREN] = ACTIONS(139),
    [anon_sym_ATa_COLON] = ACTIONS(139),
    [anon_sym_ATb_COLON] = ACTIONS(139),
    [anon_sym_ATB_COLON] = ACTIONS(139),
    [anon_sym_ATe_COLON] = ACTIONS(139),
    [anon_sym_ATF_COLON] = ACTIONS(139),
    [anon_sym_ATi_COLON] = ACTIONS(139),
    [anon_sym_ATk_COLON] = ACTIONS(139),
    [anon_sym_ATo_COLON] = ACTIONS(139),
    [anon_sym_ATr_COLON] = ACTIONS(139),
    [anon_sym_ATf_COLON] = ACTIONS(139),
    [anon_sym_ATs_COLON] = ACTIONS(139),
    [anon_sym_ATv_COLON] = ACTIONS(139),
    [anon_sym_ATx_COLON] = ACTIONS(139),
    [anon_sym_PIPE_DOT] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(141),
    [anon_sym_GT_GT] = ACTIONS(139),
    [sym_html_redirect_operator] = ACTIONS(141),
    [sym_html_append_operator] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(139),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(139),
  },
  [65] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(71),
    [sym_args] = STATE(187),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(71),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_PIPEH] = ACTIONS(169),
    [anon_sym_AT_AT_DOT] = ACTIONS(169),
    [anon_sym_AT_AT_EQ] = ACTIONS(169),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(169),
    [anon_sym_AT_AT] = ACTIONS(171),
    [anon_sym_AT_ATc_COLON] = ACTIONS(169),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(169),
    [anon_sym_AT_ATC] = ACTIONS(169),
    [anon_sym_AT_ATdbt] = ACTIONS(171),
    [anon_sym_AT_ATdbta] = ACTIONS(169),
    [anon_sym_AT_ATdbtb] = ACTIONS(169),
    [anon_sym_AT_ATdbts] = ACTIONS(169),
    [anon_sym_AT_ATt] = ACTIONS(169),
    [anon_sym_AT_ATb] = ACTIONS(169),
    [anon_sym_AT_ATi] = ACTIONS(171),
    [anon_sym_AT_ATii] = ACTIONS(169),
    [anon_sym_AT_ATiS] = ACTIONS(171),
    [anon_sym_AT_ATiSS] = ACTIONS(169),
    [anon_sym_AT_ATis] = ACTIONS(169),
    [anon_sym_AT_ATiz] = ACTIONS(169),
    [anon_sym_AT_ATf] = ACTIONS(169),
    [anon_sym_AT_ATF] = ACTIONS(169),
    [anon_sym_AT_ATom] = ACTIONS(169),
    [anon_sym_AT_ATdm] = ACTIONS(169),
    [anon_sym_AT_ATr] = ACTIONS(169),
    [anon_sym_AT_ATs_COLON] = ACTIONS(169),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_AT_BANG] = ACTIONS(169),
    [anon_sym_AT_LPAREN] = ACTIONS(169),
    [anon_sym_ATa_COLON] = ACTIONS(169),
    [anon_sym_ATb_COLON] = ACTIONS(169),
    [anon_sym_ATB_COLON] = ACTIONS(169),
    [anon_sym_ATe_COLON] = ACTIONS(169),
    [anon_sym_ATF_COLON] = ACTIONS(169),
    [anon_sym_ATi_COLON] = ACTIONS(169),
    [anon_sym_ATk_COLON] = ACTIONS(169),
    [anon_sym_ATo_COLON] = ACTIONS(169),
    [anon_sym_ATr_COLON] = ACTIONS(169),
    [anon_sym_ATf_COLON] = ACTIONS(169),
    [anon_sym_ATs_COLON] = ACTIONS(169),
    [anon_sym_ATv_COLON] = ACTIONS(169),
    [anon_sym_ATx_COLON] = ACTIONS(169),
    [anon_sym_PIPE_DOT] = ACTIONS(169),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(171),
    [anon_sym_GT_GT] = ACTIONS(169),
    [sym_html_redirect_operator] = ACTIONS(171),
    [sym_html_append_operator] = ACTIONS(169),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(169),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(169),
  },
  [66] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(71),
    [sym_args] = STATE(206),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(71),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_PIPEH] = ACTIONS(127),
    [anon_sym_AT_AT_DOT] = ACTIONS(127),
    [anon_sym_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT] = ACTIONS(129),
    [anon_sym_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_ATC] = ACTIONS(127),
    [anon_sym_AT_ATdbt] = ACTIONS(129),
    [anon_sym_AT_ATdbta] = ACTIONS(127),
    [anon_sym_AT_ATdbtb] = ACTIONS(127),
    [anon_sym_AT_ATdbts] = ACTIONS(127),
    [anon_sym_AT_ATt] = ACTIONS(127),
    [anon_sym_AT_ATb] = ACTIONS(127),
    [anon_sym_AT_ATi] = ACTIONS(129),
    [anon_sym_AT_ATii] = ACTIONS(127),
    [anon_sym_AT_ATiS] = ACTIONS(129),
    [anon_sym_AT_ATiSS] = ACTIONS(127),
    [anon_sym_AT_ATis] = ACTIONS(127),
    [anon_sym_AT_ATiz] = ACTIONS(127),
    [anon_sym_AT_ATf] = ACTIONS(127),
    [anon_sym_AT_ATF] = ACTIONS(127),
    [anon_sym_AT_ATom] = ACTIONS(127),
    [anon_sym_AT_ATdm] = ACTIONS(127),
    [anon_sym_AT_ATr] = ACTIONS(127),
    [anon_sym_AT_ATs_COLON] = ACTIONS(127),
    [anon_sym_AT] = ACTIONS(129),
    [anon_sym_AT_BANG] = ACTIONS(127),
    [anon_sym_AT_LPAREN] = ACTIONS(127),
    [anon_sym_ATa_COLON] = ACTIONS(127),
    [anon_sym_ATb_COLON] = ACTIONS(127),
    [anon_sym_ATB_COLON] = ACTIONS(127),
    [anon_sym_ATe_COLON] = ACTIONS(127),
    [anon_sym_ATF_COLON] = ACTIONS(127),
    [anon_sym_ATi_COLON] = ACTIONS(127),
    [anon_sym_ATk_COLON] = ACTIONS(127),
    [anon_sym_ATo_COLON] = ACTIONS(127),
    [anon_sym_ATr_COLON] = ACTIONS(127),
    [anon_sym_ATf_COLON] = ACTIONS(127),
    [anon_sym_ATs_COLON] = ACTIONS(127),
    [anon_sym_ATv_COLON] = ACTIONS(127),
    [anon_sym_ATx_COLON] = ACTIONS(127),
    [anon_sym_PIPE_DOT] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(127),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(127),
    [sym_html_redirect_operator] = ACTIONS(129),
    [sym_html_append_operator] = ACTIONS(127),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(127),
  },
  [67] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(71),
    [sym_args] = STATE(267),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(71),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_PIPEH] = ACTIONS(131),
    [anon_sym_AT_AT_DOT] = ACTIONS(131),
    [anon_sym_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT] = ACTIONS(133),
    [anon_sym_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_ATC] = ACTIONS(131),
    [anon_sym_AT_ATdbt] = ACTIONS(133),
    [anon_sym_AT_ATdbta] = ACTIONS(131),
    [anon_sym_AT_ATdbtb] = ACTIONS(131),
    [anon_sym_AT_ATdbts] = ACTIONS(131),
    [anon_sym_AT_ATt] = ACTIONS(131),
    [anon_sym_AT_ATb] = ACTIONS(131),
    [anon_sym_AT_ATi] = ACTIONS(133),
    [anon_sym_AT_ATii] = ACTIONS(131),
    [anon_sym_AT_ATiS] = ACTIONS(133),
    [anon_sym_AT_ATiSS] = ACTIONS(131),
    [anon_sym_AT_ATis] = ACTIONS(131),
    [anon_sym_AT_ATiz] = ACTIONS(131),
    [anon_sym_AT_ATf] = ACTIONS(131),
    [anon_sym_AT_ATF] = ACTIONS(131),
    [anon_sym_AT_ATom] = ACTIONS(131),
    [anon_sym_AT_ATdm] = ACTIONS(131),
    [anon_sym_AT_ATr] = ACTIONS(131),
    [anon_sym_AT_ATs_COLON] = ACTIONS(131),
    [anon_sym_AT] = ACTIONS(133),
    [anon_sym_AT_BANG] = ACTIONS(131),
    [anon_sym_AT_LPAREN] = ACTIONS(131),
    [anon_sym_ATa_COLON] = ACTIONS(131),
    [anon_sym_ATb_COLON] = ACTIONS(131),
    [anon_sym_ATB_COLON] = ACTIONS(131),
    [anon_sym_ATe_COLON] = ACTIONS(131),
    [anon_sym_ATF_COLON] = ACTIONS(131),
    [anon_sym_ATi_COLON] = ACTIONS(131),
    [anon_sym_ATk_COLON] = ACTIONS(131),
    [anon_sym_ATo_COLON] = ACTIONS(131),
    [anon_sym_ATr_COLON] = ACTIONS(131),
    [anon_sym_ATf_COLON] = ACTIONS(131),
    [anon_sym_ATs_COLON] = ACTIONS(131),
    [anon_sym_ATv_COLON] = ACTIONS(131),
    [anon_sym_ATx_COLON] = ACTIONS(131),
    [anon_sym_PIPE_DOT] = ACTIONS(131),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(131),
    [sym_html_redirect_operator] = ACTIONS(133),
    [sym_html_append_operator] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(131),
  },
  [68] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(71),
    [sym_args] = STATE(200),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(71),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(109),
    [anon_sym_PIPEH] = ACTIONS(105),
    [anon_sym_AT_AT_DOT] = ACTIONS(105),
    [anon_sym_AT_AT_EQ] = ACTIONS(105),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(105),
    [anon_sym_AT_AT] = ACTIONS(109),
    [anon_sym_AT_ATc_COLON] = ACTIONS(105),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(105),
    [anon_sym_AT_ATC] = ACTIONS(105),
    [anon_sym_AT_ATdbt] = ACTIONS(109),
    [anon_sym_AT_ATdbta] = ACTIONS(105),
    [anon_sym_AT_ATdbtb] = ACTIONS(105),
    [anon_sym_AT_ATdbts] = ACTIONS(105),
    [anon_sym_AT_ATt] = ACTIONS(105),
    [anon_sym_AT_ATb] = ACTIONS(105),
    [anon_sym_AT_ATi] = ACTIONS(109),
    [anon_sym_AT_ATii] = ACTIONS(105),
    [anon_sym_AT_ATiS] = ACTIONS(109),
    [anon_sym_AT_ATiSS] = ACTIONS(105),
    [anon_sym_AT_ATis] = ACTIONS(105),
    [anon_sym_AT_ATiz] = ACTIONS(105),
    [anon_sym_AT_ATf] = ACTIONS(105),
    [anon_sym_AT_ATF] = ACTIONS(105),
    [anon_sym_AT_ATom] = ACTIONS(105),
    [anon_sym_AT_ATdm] = ACTIONS(105),
    [anon_sym_AT_ATr] = ACTIONS(105),
    [anon_sym_AT_ATs_COLON] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(109),
    [anon_sym_AT_BANG] = ACTIONS(105),
    [anon_sym_AT_LPAREN] = ACTIONS(105),
    [anon_sym_ATa_COLON] = ACTIONS(105),
    [anon_sym_ATb_COLON] = ACTIONS(105),
    [anon_sym_ATB_COLON] = ACTIONS(105),
    [anon_sym_ATe_COLON] = ACTIONS(105),
    [anon_sym_ATF_COLON] = ACTIONS(105),
    [anon_sym_ATi_COLON] = ACTIONS(105),
    [anon_sym_ATk_COLON] = ACTIONS(105),
    [anon_sym_ATo_COLON] = ACTIONS(105),
    [anon_sym_ATr_COLON] = ACTIONS(105),
    [anon_sym_ATf_COLON] = ACTIONS(105),
    [anon_sym_ATs_COLON] = ACTIONS(105),
    [anon_sym_ATv_COLON] = ACTIONS(105),
    [anon_sym_ATx_COLON] = ACTIONS(105),
    [anon_sym_PIPE_DOT] = ACTIONS(105),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(105),
    [sym_html_redirect_operator] = ACTIONS(109),
    [sym_html_append_operator] = ACTIONS(105),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(105),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(105),
  },
  [69] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(71),
    [sym_args] = STATE(208),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(71),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(143),
    [anon_sym_PIPE] = ACTIONS(145),
    [anon_sym_PIPEH] = ACTIONS(143),
    [anon_sym_AT_AT_DOT] = ACTIONS(143),
    [anon_sym_AT_AT_EQ] = ACTIONS(143),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(143),
    [anon_sym_AT_AT] = ACTIONS(145),
    [anon_sym_AT_ATc_COLON] = ACTIONS(143),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(143),
    [anon_sym_AT_ATC] = ACTIONS(143),
    [anon_sym_AT_ATdbt] = ACTIONS(145),
    [anon_sym_AT_ATdbta] = ACTIONS(143),
    [anon_sym_AT_ATdbtb] = ACTIONS(143),
    [anon_sym_AT_ATdbts] = ACTIONS(143),
    [anon_sym_AT_ATt] = ACTIONS(143),
    [anon_sym_AT_ATb] = ACTIONS(143),
    [anon_sym_AT_ATi] = ACTIONS(145),
    [anon_sym_AT_ATii] = ACTIONS(143),
    [anon_sym_AT_ATiS] = ACTIONS(145),
    [anon_sym_AT_ATiSS] = ACTIONS(143),
    [anon_sym_AT_ATis] = ACTIONS(143),
    [anon_sym_AT_ATiz] = ACTIONS(143),
    [anon_sym_AT_ATf] = ACTIONS(143),
    [anon_sym_AT_ATF] = ACTIONS(143),
    [anon_sym_AT_ATom] = ACTIONS(143),
    [anon_sym_AT_ATdm] = ACTIONS(143),
    [anon_sym_AT_ATr] = ACTIONS(143),
    [anon_sym_AT_ATs_COLON] = ACTIONS(143),
    [anon_sym_AT] = ACTIONS(145),
    [anon_sym_AT_BANG] = ACTIONS(143),
    [anon_sym_AT_LPAREN] = ACTIONS(143),
    [anon_sym_ATa_COLON] = ACTIONS(143),
    [anon_sym_ATb_COLON] = ACTIONS(143),
    [anon_sym_ATB_COLON] = ACTIONS(143),
    [anon_sym_ATe_COLON] = ACTIONS(143),
    [anon_sym_ATF_COLON] = ACTIONS(143),
    [anon_sym_ATi_COLON] = ACTIONS(143),
    [anon_sym_ATk_COLON] = ACTIONS(143),
    [anon_sym_ATo_COLON] = ACTIONS(143),
    [anon_sym_ATr_COLON] = ACTIONS(143),
    [anon_sym_ATf_COLON] = ACTIONS(143),
    [anon_sym_ATs_COLON] = ACTIONS(143),
    [anon_sym_ATv_COLON] = ACTIONS(143),
    [anon_sym_ATx_COLON] = ACTIONS(143),
    [anon_sym_PIPE_DOT] = ACTIONS(143),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(143),
    [sym_html_redirect_operator] = ACTIONS(145),
    [sym_html_append_operator] = ACTIONS(143),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(121),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(143),
  },
  [70] = {
    [sym__Cf_args] = STATE(261),
    [sym__arg_with_paren] = STATE(390),
    [sym__arg] = STATE(390),
    [sym_arg] = STATE(346),
    [sym_arg_identifier] = STATE(390),
    [sym_double_quoted_arg] = STATE(390),
    [sym_single_quoted_arg] = STATE(390),
    [sym_cmd_substitution_arg] = STATE(390),
    [sym_concatenation] = STATE(413),
    [anon_sym_DQUOTE] = ACTIONS(175),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_PIPE] = ACTIONS(177),
    [anon_sym_PIPEH] = ACTIONS(173),
    [anon_sym_AT_AT_DOT] = ACTIONS(173),
    [anon_sym_AT_AT_EQ] = ACTIONS(173),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(173),
    [anon_sym_AT_AT] = ACTIONS(177),
    [anon_sym_AT_ATc_COLON] = ACTIONS(173),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(173),
    [anon_sym_AT_ATC] = ACTIONS(173),
    [anon_sym_AT_ATdbt] = ACTIONS(177),
    [anon_sym_AT_ATdbta] = ACTIONS(173),
    [anon_sym_AT_ATdbtb] = ACTIONS(173),
    [anon_sym_AT_ATdbts] = ACTIONS(173),
    [anon_sym_AT_ATt] = ACTIONS(173),
    [anon_sym_AT_ATb] = ACTIONS(173),
    [anon_sym_AT_ATi] = ACTIONS(177),
    [anon_sym_AT_ATii] = ACTIONS(173),
    [anon_sym_AT_ATiS] = ACTIONS(177),
    [anon_sym_AT_ATiSS] = ACTIONS(173),
    [anon_sym_AT_ATis] = ACTIONS(173),
    [anon_sym_AT_ATiz] = ACTIONS(173),
    [anon_sym_AT_ATf] = ACTIONS(173),
    [anon_sym_AT_ATF] = ACTIONS(173),
    [anon_sym_AT_ATom] = ACTIONS(173),
    [anon_sym_AT_ATdm] = ACTIONS(173),
    [anon_sym_AT_ATr] = ACTIONS(173),
    [anon_sym_AT_ATs_COLON] = ACTIONS(173),
    [anon_sym_AT] = ACTIONS(177),
    [anon_sym_AT_BANG] = ACTIONS(173),
    [anon_sym_AT_LPAREN] = ACTIONS(173),
    [anon_sym_ATa_COLON] = ACTIONS(173),
    [anon_sym_ATb_COLON] = ACTIONS(173),
    [anon_sym_ATB_COLON] = ACTIONS(173),
    [anon_sym_ATe_COLON] = ACTIONS(173),
    [anon_sym_ATF_COLON] = ACTIONS(173),
    [anon_sym_ATi_COLON] = ACTIONS(173),
    [anon_sym_ATk_COLON] = ACTIONS(173),
    [anon_sym_ATo_COLON] = ACTIONS(173),
    [anon_sym_ATr_COLON] = ACTIONS(173),
    [anon_sym_ATf_COLON] = ACTIONS(173),
    [anon_sym_ATs_COLON] = ACTIONS(173),
    [anon_sym_ATv_COLON] = ACTIONS(173),
    [anon_sym_ATx_COLON] = ACTIONS(173),
    [anon_sym_PIPE_DOT] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(179),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(173),
    [anon_sym_GT] = ACTIONS(177),
    [anon_sym_GT_GT] = ACTIONS(173),
    [sym_html_redirect_operator] = ACTIONS(177),
    [sym_html_append_operator] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(183),
    [aux_sym_arg_identifier_token1] = ACTIONS(179),
    [anon_sym_SQUOTE] = ACTIONS(185),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(173),
  },
  [71] = {
    [sym__arg_with_paren] = STATE(80),
    [sym__arg] = STATE(80),
    [sym_arg] = STATE(56),
    [sym_arg_identifier] = STATE(80),
    [sym_double_quoted_arg] = STATE(80),
    [sym_single_quoted_arg] = STATE(80),
    [sym_cmd_substitution_arg] = STATE(80),
    [sym_concatenation] = STATE(98),
    [aux_sym_args_repeat1] = STATE(56),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(216),
    [anon_sym_PIPE] = ACTIONS(218),
    [anon_sym_PIPEH] = ACTIONS(216),
    [anon_sym_AT_AT_DOT] = ACTIONS(216),
    [anon_sym_AT_AT_EQ] = ACTIONS(216),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(216),
    [anon_sym_AT_AT] = ACTIONS(218),
    [anon_sym_AT_ATc_COLON] = ACTIONS(216),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(216),
    [anon_sym_AT_ATC] = ACTIONS(216),
    [anon_sym_AT_ATdbt] = ACTIONS(218),
    [anon_sym_AT_ATdbta] = ACTIONS(216),
    [anon_sym_AT_ATdbtb] = ACTIONS(216),
    [anon_sym_AT_ATdbts] = ACTIONS(216),
    [anon_sym_AT_ATt] = ACTIONS(216),
    [anon_sym_AT_ATb] = ACTIONS(216),
    [anon_sym_AT_ATi] = ACTIONS(218),
    [anon_sym_AT_ATii] = ACTIONS(216),
    [anon_sym_AT_ATiS] = ACTIONS(218),
    [anon_sym_AT_ATiSS] = ACTIONS(216),
    [anon_sym_AT_ATis] = ACTIONS(216),
    [anon_sym_AT_ATiz] = ACTIONS(216),
    [anon_sym_AT_ATf] = ACTIONS(216),
    [anon_sym_AT_ATF] = ACTIONS(216),
    [anon_sym_AT_ATom] = ACTIONS(216),
    [anon_sym_AT_ATdm] = ACTIONS(216),
    [anon_sym_AT_ATr] = ACTIONS(216),
    [anon_sym_AT_ATs_COLON] = ACTIONS(216),
    [anon_sym_AT] = ACTIONS(218),
    [anon_sym_AT_BANG] = ACTIONS(216),
    [anon_sym_AT_LPAREN] = ACTIONS(216),
    [anon_sym_ATa_COLON] = ACTIONS(216),
    [anon_sym_ATb_COLON] = ACTIONS(216),
    [anon_sym_ATB_COLON] = ACTIONS(216),
    [anon_sym_ATe_COLON] = ACTIONS(216),
    [anon_sym_ATF_COLON] = ACTIONS(216),
    [anon_sym_ATi_COLON] = ACTIONS(216),
    [anon_sym_ATk_COLON] = ACTIONS(216),
    [anon_sym_ATo_COLON] = ACTIONS(216),
    [anon_sym_ATr_COLON] = ACTIONS(216),
    [anon_sym_ATf_COLON] = ACTIONS(216),
    [anon_sym_ATs_COLON] = ACTIONS(216),
    [anon_sym_ATv_COLON] = ACTIONS(216),
    [anon_sym_ATx_COLON] = ACTIONS(216),
    [anon_sym_PIPE_DOT] = ACTIONS(216),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(216),
    [anon_sym_GT] = ACTIONS(218),
    [anon_sym_GT_GT] = ACTIONS(216),
    [sym_html_redirect_operator] = ACTIONS(218),
    [sym_html_append_operator] = ACTIONS(216),
    [anon_sym_COMMA] = ACTIONS(115),
    [aux_sym_arg_identifier_token1] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(119),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(216),
  },
  [72] = {
    [sym__pf_arg_parentheses] = STATE(101),
    [sym_pf_arg_identifier] = STATE(101),
    [sym__pf_arg] = STATE(101),
    [sym_pf_concatenation] = STATE(115),
    [sym_pf_arg] = STATE(75),
    [sym_cmd_substitution_arg] = STATE(101),
    [aux_sym_pf_args_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(234),
    [anon_sym_TILDE] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_PIPEH] = ACTIONS(234),
    [anon_sym_AT_AT_DOT] = ACTIONS(234),
    [anon_sym_AT_AT_EQ] = ACTIONS(234),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(234),
    [anon_sym_AT_AT] = ACTIONS(236),
    [anon_sym_AT_ATc_COLON] = ACTIONS(234),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(234),
    [anon_sym_AT_ATC] = ACTIONS(234),
    [anon_sym_AT_ATdbt] = ACTIONS(236),
    [anon_sym_AT_ATdbta] = ACTIONS(234),
    [anon_sym_AT_ATdbtb] = ACTIONS(234),
    [anon_sym_AT_ATdbts] = ACTIONS(234),
    [anon_sym_AT_ATt] = ACTIONS(234),
    [anon_sym_AT_ATb] = ACTIONS(234),
    [anon_sym_AT_ATi] = ACTIONS(236),
    [anon_sym_AT_ATii] = ACTIONS(234),
    [anon_sym_AT_ATiS] = ACTIONS(236),
    [anon_sym_AT_ATiSS] = ACTIONS(234),
    [anon_sym_AT_ATis] = ACTIONS(234),
    [anon_sym_AT_ATiz] = ACTIONS(234),
    [anon_sym_AT_ATf] = ACTIONS(234),
    [anon_sym_AT_ATF] = ACTIONS(234),
    [anon_sym_AT_ATom] = ACTIONS(234),
    [anon_sym_AT_ATdm] = ACTIONS(234),
    [anon_sym_AT_ATr] = ACTIONS(234),
    [anon_sym_AT_ATs_COLON] = ACTIONS(234),
    [anon_sym_AT] = ACTIONS(236),
    [anon_sym_AT_BANG] = ACTIONS(234),
    [anon_sym_AT_LPAREN] = ACTIONS(234),
    [anon_sym_RPAREN] = ACTIONS(234),
    [anon_sym_ATa_COLON] = ACTIONS(234),
    [anon_sym_ATb_COLON] = ACTIONS(234),
    [anon_sym_ATB_COLON] = ACTIONS(234),
    [anon_sym_ATe_COLON] = ACTIONS(234),
    [anon_sym_ATF_COLON] = ACTIONS(234),
    [anon_sym_ATi_COLON] = ACTIONS(234),
    [anon_sym_ATk_COLON] = ACTIONS(234),
    [anon_sym_ATo_COLON] = ACTIONS(234),
    [anon_sym_ATr_COLON] = ACTIONS(234),
    [anon_sym_ATf_COLON] = ACTIONS(234),
    [anon_sym_ATs_COLON] = ACTIONS(234),
    [anon_sym_ATv_COLON] = ACTIONS(234),
    [anon_sym_ATx_COLON] = ACTIONS(234),
    [anon_sym_PIPE_DOT] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(224),
    [anon_sym_LPAREN] = ACTIONS(226),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(234),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(234),
    [sym_html_redirect_operator] = ACTIONS(236),
    [sym_html_append_operator] = ACTIONS(234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(228),
    [anon_sym_BQUOTE] = ACTIONS(230),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(234),
    [anon_sym_CR] = ACTIONS(234),
    [sym_file_descriptor] = ACTIONS(234),
  },
  [73] = {
    [sym__pf_arg_parentheses] = STATE(101),
    [sym_pf_arg_identifier] = STATE(101),
    [sym__pf_arg] = STATE(101),
    [sym_pf_concatenation] = STATE(115),
    [sym_pf_arg] = STATE(94),
    [sym_pf_args] = STATE(242),
    [sym_cmd_substitution_arg] = STATE(101),
    [aux_sym_pf_args_repeat1] = STATE(94),
    [aux_sym_pf_dot_args_repeat1] = STATE(121),
    [anon_sym_TILDE] = ACTIONS(220),
    [anon_sym_PIPE] = ACTIONS(222),
    [anon_sym_PIPEH] = ACTIONS(220),
    [anon_sym_AT_AT_DOT] = ACTIONS(220),
    [anon_sym_AT_AT_EQ] = ACTIONS(220),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(220),
    [anon_sym_AT_AT] = ACTIONS(222),
    [anon_sym_AT_ATc_COLON] = ACTIONS(220),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(220),
    [anon_sym_AT_ATC] = ACTIONS(220),
    [anon_sym_AT_ATdbt] = ACTIONS(222),
    [anon_sym_AT_ATdbta] = ACTIONS(220),
    [anon_sym_AT_ATdbtb] = ACTIONS(220),
    [anon_sym_AT_ATdbts] = ACTIONS(220),
    [anon_sym_AT_ATt] = ACTIONS(220),
    [anon_sym_AT_ATb] = ACTIONS(220),
    [anon_sym_AT_ATi] = ACTIONS(222),
    [anon_sym_AT_ATii] = ACTIONS(220),
    [anon_sym_AT_ATiS] = ACTIONS(222),
    [anon_sym_AT_ATiSS] = ACTIONS(220),
    [anon_sym_AT_ATis] = ACTIONS(220),
    [anon_sym_AT_ATiz] = ACTIONS(220),
    [anon_sym_AT_ATf] = ACTIONS(220),
    [anon_sym_AT_ATF] = ACTIONS(220),
    [anon_sym_AT_ATom] = ACTIONS(220),
    [anon_sym_AT_ATdm] = ACTIONS(220),
    [anon_sym_AT_ATr] = ACTIONS(220),
    [anon_sym_AT_ATs_COLON] = ACTIONS(220),
    [anon_sym_AT] = ACTIONS(222),
    [anon_sym_AT_BANG] = ACTIONS(220),
    [anon_sym_AT_LPAREN] = ACTIONS(220),
    [anon_sym_ATa_COLON] = ACTIONS(220),
    [anon_sym_ATb_COLON] = ACTIONS(220),
    [anon_sym_ATB_COLON] = ACTIONS(220),
    [anon_sym_ATe_COLON] = ACTIONS(220),
    [anon_sym_ATF_COLON] = ACTIONS(220),
    [anon_sym_ATi_COLON] = ACTIONS(220),
    [anon_sym_ATk_COLON] = ACTIONS(220),
    [anon_sym_ATo_COLON] = ACTIONS(220),
    [anon_sym_ATr_COLON] = ACTIONS(220),
    [anon_sym_ATf_COLON] = ACTIONS(220),
    [anon_sym_ATs_COLON] = ACTIONS(220),
    [anon_sym_ATv_COLON] = ACTIONS(220),
    [anon_sym_ATx_COLON] = ACTIONS(220),
    [anon_sym_PIPE_DOT] = ACTIONS(220),
    [anon_sym_EQ] = ACTIONS(222),
    [anon_sym_DOLLAR] = ACTIONS(224),
    [anon_sym_LPAREN] = ACTIONS(226),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(220),
    [anon_sym_GT] = ACTIONS(222),
    [anon_sym_GT_GT] = ACTIONS(220),
    [sym_html_redirect_operator] = ACTIONS(222),
    [sym_html_append_operator] = ACTIONS(220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(228),
    [anon_sym_BQUOTE] = ACTIONS(220),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(220),
    [sym__concat_pf_dot] = ACTIONS(232),
  },
  [74] = {
    [sym_eq_sep_args] = STATE(254),
    [sym__eq_sep_key_single] = STATE(130),
    [sym__eq_sep_key_concatenation] = STATE(177),
    [sym__eq_sep_key] = STATE(179),
    [sym_double_quoted_arg] = STATE(130),
    [sym_single_quoted_arg] = STATE(130),
    [sym_cmd_substitution_arg] = STATE(130),
    [ts_builtin_sym_end] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(240),
    [anon_sym_TILDE] = ACTIONS(238),
    [anon_sym_PIPE] = ACTIONS(242),
    [anon_sym_PIPEH] = ACTIONS(238),
    [anon_sym_AT_AT_DOT] = ACTIONS(238),
    [anon_sym_AT_AT_EQ] = ACTIONS(238),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(238),
    [anon_sym_AT_AT] = ACTIONS(242),
    [anon_sym_AT_ATc_COLON] = ACTIONS(238),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(238),
    [anon_sym_AT_ATC] = ACTIONS(238),
    [anon_sym_AT_ATdbt] = ACTIONS(242),
    [anon_sym_AT_ATdbta] = ACTIONS(238),
    [anon_sym_AT_ATdbtb] = ACTIONS(238),
    [anon_sym_AT_ATdbts] = ACTIONS(238),
    [anon_sym_AT_ATt] = ACTIONS(238),
    [anon_sym_AT_ATb] = ACTIONS(238),
    [anon_sym_AT_ATi] = ACTIONS(242),
    [anon_sym_AT_ATii] = ACTIONS(238),
    [anon_sym_AT_ATiS] = ACTIONS(242),
    [anon_sym_AT_ATiSS] = ACTIONS(238),
    [anon_sym_AT_ATis] = ACTIONS(238),
    [anon_sym_AT_ATiz] = ACTIONS(238),
    [anon_sym_AT_ATf] = ACTIONS(238),
    [anon_sym_AT_ATF] = ACTIONS(238),
    [anon_sym_AT_ATom] = ACTIONS(238),
    [anon_sym_AT_ATdm] = ACTIONS(238),
    [anon_sym_AT_ATr] = ACTIONS(238),
    [anon_sym_AT_ATs_COLON] = ACTIONS(238),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_AT_BANG] = ACTIONS(238),
    [anon_sym_AT_LPAREN] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(238),
    [anon_sym_ATa_COLON] = ACTIONS(238),
    [anon_sym_ATb_COLON] = ACTIONS(238),
    [anon_sym_ATB_COLON] = ACTIONS(238),
    [anon_sym_ATe_COLON] = ACTIONS(238),
    [anon_sym_ATF_COLON] = ACTIONS(238),
    [anon_sym_ATi_COLON] = ACTIONS(238),
    [anon_sym_ATk_COLON] = ACTIONS(238),
    [anon_sym_ATo_COLON] = ACTIONS(238),
    [anon_sym_ATr_COLON] = ACTIONS(238),
    [anon_sym_ATf_COLON] = ACTIONS(238),
    [anon_sym_ATs_COLON] = ACTIONS(238),
    [anon_sym_ATv_COLON] = ACTIONS(238),
    [anon_sym_ATx_COLON] = ACTIONS(238),
    [anon_sym_PIPE_DOT] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_GT] = ACTIONS(242),
    [anon_sym_GT_GT] = ACTIONS(238),
    [sym_html_redirect_operator] = ACTIONS(242),
    [sym_html_append_operator] = ACTIONS(238),
    [sym__eq_sep_key_identifier] = ACTIONS(244),
    [anon_sym_SQUOTE] = ACTIONS(246),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(248),
    [anon_sym_BQUOTE] = ACTIONS(250),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(238),
    [anon_sym_CR] = ACTIONS(238),
    [sym_file_descriptor] = ACTIONS(238),
  },
  [75] = {
    [sym__pf_arg_parentheses] = STATE(101),
    [sym_pf_arg_identifier] = STATE(101),
    [sym__pf_arg] = STATE(101),
    [sym_pf_concatenation] = STATE(115),
    [sym_pf_arg] = STATE(75),
    [sym_cmd_substitution_arg] = STATE(101),
    [aux_sym_pf_args_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(252),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PIPEH] = ACTIONS(252),
    [anon_sym_AT_AT_DOT] = ACTIONS(252),
    [anon_sym_AT_AT_EQ] = ACTIONS(252),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(252),
    [anon_sym_AT_AT] = ACTIONS(254),
    [anon_sym_AT_ATc_COLON] = ACTIONS(252),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(252),
    [anon_sym_AT_ATC] = ACTIONS(252),
    [anon_sym_AT_ATdbt] = ACTIONS(254),
    [anon_sym_AT_ATdbta] = ACTIONS(252),
    [anon_sym_AT_ATdbtb] = ACTIONS(252),
    [anon_sym_AT_ATdbts] = ACTIONS(252),
    [anon_sym_AT_ATt] = ACTIONS(252),
    [anon_sym_AT_ATb] = ACTIONS(252),
    [anon_sym_AT_ATi] = ACTIONS(254),
    [anon_sym_AT_ATii] = ACTIONS(252),
    [anon_sym_AT_ATiS] = ACTIONS(254),
    [anon_sym_AT_ATiSS] = ACTIONS(252),
    [anon_sym_AT_ATis] = ACTIONS(252),
    [anon_sym_AT_ATiz] = ACTIONS(252),
    [anon_sym_AT_ATf] = ACTIONS(252),
    [anon_sym_AT_ATF] = ACTIONS(252),
    [anon_sym_AT_ATom] = ACTIONS(252),
    [anon_sym_AT_ATdm] = ACTIONS(252),
    [anon_sym_AT_ATr] = ACTIONS(252),
    [anon_sym_AT_ATs_COLON] = ACTIONS(252),
    [anon_sym_AT] = ACTIONS(254),
    [anon_sym_AT_BANG] = ACTIONS(252),
    [anon_sym_AT_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(252),
    [anon_sym_ATa_COLON] = ACTIONS(252),
    [anon_sym_ATb_COLON] = ACTIONS(252),
    [anon_sym_ATB_COLON] = ACTIONS(252),
    [anon_sym_ATe_COLON] = ACTIONS(252),
    [anon_sym_ATF_COLON] = ACTIONS(252),
    [anon_sym_ATi_COLON] = ACTIONS(252),
    [anon_sym_ATk_COLON] = ACTIONS(252),
    [anon_sym_ATo_COLON] = ACTIONS(252),
    [anon_sym_ATr_COLON] = ACTIONS(252),
    [anon_sym_ATf_COLON] = ACTIONS(252),
    [anon_sym_ATs_COLON] = ACTIONS(252),
    [anon_sym_ATv_COLON] = ACTIONS(252),
    [anon_sym_ATx_COLON] = ACTIONS(252),
    [anon_sym_PIPE_DOT] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_LPAREN] = ACTIONS(259),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(256),
    [anon_sym_SEMI] = ACTIONS(252),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_GT_GT] = ACTIONS(252),
    [sym_html_redirect_operator] = ACTIONS(254),
    [sym_html_append_operator] = ACTIONS(252),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(262),
    [anon_sym_BQUOTE] = ACTIONS(265),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(252),
    [anon_sym_CR] = ACTIONS(252),
    [sym_file_descriptor] = ACTIONS(252),
  },
  [76] = {
    [sym_specifiers] = STATE(96),
    [aux_sym_specifiers_repeat1] = STATE(81),
    [ts_builtin_sym_end] = ACTIONS(268),
    [anon_sym_DQUOTE] = ACTIONS(268),
    [anon_sym_TILDE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(270),
    [anon_sym_PIPEH] = ACTIONS(268),
    [anon_sym_AT_AT_DOT] = ACTIONS(268),
    [anon_sym_AT_AT_EQ] = ACTIONS(268),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(268),
    [anon_sym_AT_AT] = ACTIONS(270),
    [anon_sym_AT_ATc_COLON] = ACTIONS(268),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(268),
    [anon_sym_AT_ATC] = ACTIONS(268),
    [anon_sym_AT_ATdbt] = ACTIONS(270),
    [anon_sym_AT_ATdbta] = ACTIONS(268),
    [anon_sym_AT_ATdbtb] = ACTIONS(268),
    [anon_sym_AT_ATdbts] = ACTIONS(268),
    [anon_sym_AT_ATt] = ACTIONS(268),
    [anon_sym_AT_ATb] = ACTIONS(268),
    [anon_sym_AT_ATi] = ACTIONS(270),
    [anon_sym_AT_ATii] = ACTIONS(268),
    [anon_sym_AT_ATiS] = ACTIONS(270),
    [anon_sym_AT_ATiSS] = ACTIONS(268),
    [anon_sym_AT_ATis] = ACTIONS(268),
    [anon_sym_AT_ATiz] = ACTIONS(268),
    [anon_sym_AT_ATf] = ACTIONS(268),
    [anon_sym_AT_ATF] = ACTIONS(268),
    [anon_sym_AT_ATom] = ACTIONS(268),
    [anon_sym_AT_ATdm] = ACTIONS(268),
    [anon_sym_AT_ATr] = ACTIONS(268),
    [anon_sym_AT_ATs_COLON] = ACTIONS(268),
    [anon_sym_AT] = ACTIONS(270),
    [anon_sym_AT_BANG] = ACTIONS(268),
    [anon_sym_AT_LPAREN] = ACTIONS(268),
    [anon_sym_RPAREN] = ACTIONS(268),
    [anon_sym_ATa_COLON] = ACTIONS(268),
    [anon_sym_ATb_COLON] = ACTIONS(268),
    [anon_sym_ATB_COLON] = ACTIONS(268),
    [anon_sym_ATe_COLON] = ACTIONS(268),
    [anon_sym_ATF_COLON] = ACTIONS(268),
    [anon_sym_ATi_COLON] = ACTIONS(268),
    [anon_sym_ATk_COLON] = ACTIONS(268),
    [anon_sym_ATo_COLON] = ACTIONS(268),
    [anon_sym_ATr_COLON] = ACTIONS(268),
    [anon_sym_ATf_COLON] = ACTIONS(268),
    [anon_sym_ATs_COLON] = ACTIONS(268),
    [anon_sym_ATv_COLON] = ACTIONS(268),
    [anon_sym_ATx_COLON] = ACTIONS(268),
    [anon_sym_PIPE_DOT] = ACTIONS(268),
    [anon_sym_DOLLAR] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(268),
    [anon_sym_SEMI] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(270),
    [anon_sym_GT_GT] = ACTIONS(268),
    [sym_html_redirect_operator] = ACTIONS(270),
    [sym_html_append_operator] = ACTIONS(268),
    [anon_sym_COMMA] = ACTIONS(268),
    [aux_sym_arg_identifier_token1] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(268),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(268),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(268),
    [anon_sym_CR] = ACTIONS(268),
    [sym_file_descriptor] = ACTIONS(268),
    [sym__spec_sep] = ACTIONS(272),
  },
  [77] = {
    [aux_sym_concatenation_repeat1] = STATE(77),
    [ts_builtin_sym_end] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_TILDE] = ACTIONS(274),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_PIPEH] = ACTIONS(274),
    [anon_sym_AT_AT_DOT] = ACTIONS(274),
    [anon_sym_AT_AT_EQ] = ACTIONS(274),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(274),
    [anon_sym_AT_AT] = ACTIONS(276),
    [anon_sym_AT_ATc_COLON] = ACTIONS(274),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(274),
    [anon_sym_AT_ATC] = ACTIONS(274),
    [anon_sym_AT_ATdbt] = ACTIONS(276),
    [anon_sym_AT_ATdbta] = ACTIONS(274),
    [anon_sym_AT_ATdbtb] = ACTIONS(274),
    [anon_sym_AT_ATdbts] = ACTIONS(274),
    [anon_sym_AT_ATt] = ACTIONS(274),
    [anon_sym_AT_ATb] = ACTIONS(274),
    [anon_sym_AT_ATi] = ACTIONS(276),
    [anon_sym_AT_ATii] = ACTIONS(274),
    [anon_sym_AT_ATiS] = ACTIONS(276),
    [anon_sym_AT_ATiSS] = ACTIONS(274),
    [anon_sym_AT_ATis] = ACTIONS(274),
    [anon_sym_AT_ATiz] = ACTIONS(274),
    [anon_sym_AT_ATf] = ACTIONS(274),
    [anon_sym_AT_ATF] = ACTIONS(274),
    [anon_sym_AT_ATom] = ACTIONS(274),
    [anon_sym_AT_ATdm] = ACTIONS(274),
    [anon_sym_AT_ATr] = ACTIONS(274),
    [anon_sym_AT_ATs_COLON] = ACTIONS(274),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_AT_BANG] = ACTIONS(274),
    [anon_sym_AT_LPAREN] = ACTIONS(274),
    [anon_sym_RPAREN] = ACTIONS(274),
    [anon_sym_ATa_COLON] = ACTIONS(274),
    [anon_sym_ATb_COLON] = ACTIONS(274),
    [anon_sym_ATB_COLON] = ACTIONS(274),
    [anon_sym_ATe_COLON] = ACTIONS(274),
    [anon_sym_ATF_COLON] = ACTIONS(274),
    [anon_sym_ATi_COLON] = ACTIONS(274),
    [anon_sym_ATk_COLON] = ACTIONS(274),
    [anon_sym_ATo_COLON] = ACTIONS(274),
    [anon_sym_ATr_COLON] = ACTIONS(274),
    [anon_sym_ATf_COLON] = ACTIONS(274),
    [anon_sym_ATs_COLON] = ACTIONS(274),
    [anon_sym_ATv_COLON] = ACTIONS(274),
    [anon_sym_ATx_COLON] = ACTIONS(274),
    [anon_sym_PIPE_DOT] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_SEMI] = ACTIONS(274),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_GT_GT] = ACTIONS(274),
    [sym_html_redirect_operator] = ACTIONS(276),
    [sym_html_append_operator] = ACTIONS(274),
    [anon_sym_COMMA] = ACTIONS(274),
    [aux_sym_arg_identifier_token1] = ACTIONS(276),
    [anon_sym_SQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(274),
    [anon_sym_BQUOTE] = ACTIONS(274),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(274),
    [anon_sym_CR] = ACTIONS(274),
    [sym_file_descriptor] = ACTIONS(274),
    [sym__concat] = ACTIONS(278),
  },
  [78] = {
    [aux_sym_concatenation_repeat1] = STATE(77),
    [ts_builtin_sym_end] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(281),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_PIPEH] = ACTIONS(281),
    [anon_sym_AT_AT_DOT] = ACTIONS(281),
    [anon_sym_AT_AT_EQ] = ACTIONS(281),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(281),
    [anon_sym_AT_AT] = ACTIONS(283),
    [anon_sym_AT_ATc_COLON] = ACTIONS(281),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(281),
    [anon_sym_AT_ATC] = ACTIONS(281),
    [anon_sym_AT_ATdbt] = ACTIONS(283),
    [anon_sym_AT_ATdbta] = ACTIONS(281),
    [anon_sym_AT_ATdbtb] = ACTIONS(281),
    [anon_sym_AT_ATdbts] = ACTIONS(281),
    [anon_sym_AT_ATt] = ACTIONS(281),
    [anon_sym_AT_ATb] = ACTIONS(281),
    [anon_sym_AT_ATi] = ACTIONS(283),
    [anon_sym_AT_ATii] = ACTIONS(281),
    [anon_sym_AT_ATiS] = ACTIONS(283),
    [anon_sym_AT_ATiSS] = ACTIONS(281),
    [anon_sym_AT_ATis] = ACTIONS(281),
    [anon_sym_AT_ATiz] = ACTIONS(281),
    [anon_sym_AT_ATf] = ACTIONS(281),
    [anon_sym_AT_ATF] = ACTIONS(281),
    [anon_sym_AT_ATom] = ACTIONS(281),
    [anon_sym_AT_ATdm] = ACTIONS(281),
    [anon_sym_AT_ATr] = ACTIONS(281),
    [anon_sym_AT_ATs_COLON] = ACTIONS(281),
    [anon_sym_AT] = ACTIONS(283),
    [anon_sym_AT_BANG] = ACTIONS(281),
    [anon_sym_AT_LPAREN] = ACTIONS(281),
    [anon_sym_RPAREN] = ACTIONS(281),
    [anon_sym_ATa_COLON] = ACTIONS(281),
    [anon_sym_ATb_COLON] = ACTIONS(281),
    [anon_sym_ATB_COLON] = ACTIONS(281),
    [anon_sym_ATe_COLON] = ACTIONS(281),
    [anon_sym_ATF_COLON] = ACTIONS(281),
    [anon_sym_ATi_COLON] = ACTIONS(281),
    [anon_sym_ATk_COLON] = ACTIONS(281),
    [anon_sym_ATo_COLON] = ACTIONS(281),
    [anon_sym_ATr_COLON] = ACTIONS(281),
    [anon_sym_ATf_COLON] = ACTIONS(281),
    [anon_sym_ATs_COLON] = ACTIONS(281),
    [anon_sym_ATv_COLON] = ACTIONS(281),
    [anon_sym_ATx_COLON] = ACTIONS(281),
    [anon_sym_PIPE_DOT] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(281),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_GT] = ACTIONS(283),
    [anon_sym_GT_GT] = ACTIONS(281),
    [sym_html_redirect_operator] = ACTIONS(283),
    [sym_html_append_operator] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(281),
    [aux_sym_arg_identifier_token1] = ACTIONS(283),
    [anon_sym_SQUOTE] = ACTIONS(281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(281),
    [anon_sym_BQUOTE] = ACTIONS(281),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(281),
    [anon_sym_CR] = ACTIONS(281),
    [sym_file_descriptor] = ACTIONS(281),
    [sym__concat] = ACTIONS(285),
  },
  [79] = {
    [aux_sym_specifiers_repeat1] = STATE(79),
    [ts_builtin_sym_end] = ACTIONS(287),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(289),
    [anon_sym_PIPEH] = ACTIONS(287),
    [anon_sym_AT_AT_DOT] = ACTIONS(287),
    [anon_sym_AT_AT_EQ] = ACTIONS(287),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(287),
    [anon_sym_AT_AT] = ACTIONS(289),
    [anon_sym_AT_ATc_COLON] = ACTIONS(287),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(287),
    [anon_sym_AT_ATC] = ACTIONS(287),
    [anon_sym_AT_ATdbt] = ACTIONS(289),
    [anon_sym_AT_ATdbta] = ACTIONS(287),
    [anon_sym_AT_ATdbtb] = ACTIONS(287),
    [anon_sym_AT_ATdbts] = ACTIONS(287),
    [anon_sym_AT_ATt] = ACTIONS(287),
    [anon_sym_AT_ATb] = ACTIONS(287),
    [anon_sym_AT_ATi] = ACTIONS(289),
    [anon_sym_AT_ATii] = ACTIONS(287),
    [anon_sym_AT_ATiS] = ACTIONS(289),
    [anon_sym_AT_ATiSS] = ACTIONS(287),
    [anon_sym_AT_ATis] = ACTIONS(287),
    [anon_sym_AT_ATiz] = ACTIONS(287),
    [anon_sym_AT_ATf] = ACTIONS(287),
    [anon_sym_AT_ATF] = ACTIONS(287),
    [anon_sym_AT_ATom] = ACTIONS(287),
    [anon_sym_AT_ATdm] = ACTIONS(287),
    [anon_sym_AT_ATr] = ACTIONS(287),
    [anon_sym_AT_ATs_COLON] = ACTIONS(287),
    [anon_sym_AT] = ACTIONS(289),
    [anon_sym_AT_BANG] = ACTIONS(287),
    [anon_sym_AT_LPAREN] = ACTIONS(287),
    [anon_sym_RPAREN] = ACTIONS(287),
    [anon_sym_ATa_COLON] = ACTIONS(287),
    [anon_sym_ATb_COLON] = ACTIONS(287),
    [anon_sym_ATB_COLON] = ACTIONS(287),
    [anon_sym_ATe_COLON] = ACTIONS(287),
    [anon_sym_ATF_COLON] = ACTIONS(287),
    [anon_sym_ATi_COLON] = ACTIONS(287),
    [anon_sym_ATk_COLON] = ACTIONS(287),
    [anon_sym_ATo_COLON] = ACTIONS(287),
    [anon_sym_ATr_COLON] = ACTIONS(287),
    [anon_sym_ATf_COLON] = ACTIONS(287),
    [anon_sym_ATs_COLON] = ACTIONS(287),
    [anon_sym_ATv_COLON] = ACTIONS(287),
    [anon_sym_ATx_COLON] = ACTIONS(287),
    [anon_sym_PIPE_DOT] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(289),
    [anon_sym_GT_GT] = ACTIONS(287),
    [sym_html_redirect_operator] = ACTIONS(289),
    [sym_html_append_operator] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(287),
    [aux_sym_arg_identifier_token1] = ACTIONS(289),
    [anon_sym_SQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(287),
    [anon_sym_BQUOTE] = ACTIONS(287),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(287),
    [anon_sym_CR] = ACTIONS(287),
    [sym_file_descriptor] = ACTIONS(287),
    [sym__spec_sep] = ACTIONS(291),
  },
  [80] = {
    [aux_sym_concatenation_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(294),
    [anon_sym_PIPE] = ACTIONS(296),
    [anon_sym_PIPEH] = ACTIONS(294),
    [anon_sym_AT_AT_DOT] = ACTIONS(294),
    [anon_sym_AT_AT_EQ] = ACTIONS(294),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(294),
    [anon_sym_AT_AT] = ACTIONS(296),
    [anon_sym_AT_ATc_COLON] = ACTIONS(294),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(294),
    [anon_sym_AT_ATC] = ACTIONS(294),
    [anon_sym_AT_ATdbt] = ACTIONS(296),
    [anon_sym_AT_ATdbta] = ACTIONS(294),
    [anon_sym_AT_ATdbtb] = ACTIONS(294),
    [anon_sym_AT_ATdbts] = ACTIONS(294),
    [anon_sym_AT_ATt] = ACTIONS(294),
    [anon_sym_AT_ATb] = ACTIONS(294),
    [anon_sym_AT_ATi] = ACTIONS(296),
    [anon_sym_AT_ATii] = ACTIONS(294),
    [anon_sym_AT_ATiS] = ACTIONS(296),
    [anon_sym_AT_ATiSS] = ACTIONS(294),
    [anon_sym_AT_ATis] = ACTIONS(294),
    [anon_sym_AT_ATiz] = ACTIONS(294),
    [anon_sym_AT_ATf] = ACTIONS(294),
    [anon_sym_AT_ATF] = ACTIONS(294),
    [anon_sym_AT_ATom] = ACTIONS(294),
    [anon_sym_AT_ATdm] = ACTIONS(294),
    [anon_sym_AT_ATr] = ACTIONS(294),
    [anon_sym_AT_ATs_COLON] = ACTIONS(294),
    [anon_sym_AT] = ACTIONS(296),
    [anon_sym_AT_BANG] = ACTIONS(294),
    [anon_sym_AT_LPAREN] = ACTIONS(294),
    [anon_sym_RPAREN] = ACTIONS(294),
    [anon_sym_ATa_COLON] = ACTIONS(294),
    [anon_sym_ATb_COLON] = ACTIONS(294),
    [anon_sym_ATB_COLON] = ACTIONS(294),
    [anon_sym_ATe_COLON] = ACTIONS(294),
    [anon_sym_ATF_COLON] = ACTIONS(294),
    [anon_sym_ATi_COLON] = ACTIONS(294),
    [anon_sym_ATk_COLON] = ACTIONS(294),
    [anon_sym_ATo_COLON] = ACTIONS(294),
    [anon_sym_ATr_COLON] = ACTIONS(294),
    [anon_sym_ATf_COLON] = ACTIONS(294),
    [anon_sym_ATs_COLON] = ACTIONS(294),
    [anon_sym_ATv_COLON] = ACTIONS(294),
    [anon_sym_ATx_COLON] = ACTIONS(294),
    [anon_sym_PIPE_DOT] = ACTIONS(294),
    [anon_sym_DOLLAR] = ACTIONS(296),
    [anon_sym_LPAREN] = ACTIONS(294),
    [anon_sym_SEMI] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(296),
    [anon_sym_GT_GT] = ACTIONS(294),
    [sym_html_redirect_operator] = ACTIONS(296),
    [sym_html_append_operator] = ACTIONS(294),
    [anon_sym_COMMA] = ACTIONS(294),
    [aux_sym_arg_identifier_token1] = ACTIONS(296),
    [anon_sym_SQUOTE] = ACTIONS(294),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(294),
    [anon_sym_BQUOTE] = ACTIONS(294),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(294),
    [anon_sym_CR] = ACTIONS(294),
    [sym_file_descriptor] = ACTIONS(294),
    [sym__concat] = ACTIONS(285),
  },
  [81] = {
    [aux_sym_specifiers_repeat1] = STATE(79),
    [ts_builtin_sym_end] = ACTIONS(298),
    [anon_sym_DQUOTE] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(300),
    [anon_sym_PIPEH] = ACTIONS(298),
    [anon_sym_AT_AT_DOT] = ACTIONS(298),
    [anon_sym_AT_AT_EQ] = ACTIONS(298),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(298),
    [anon_sym_AT_AT] = ACTIONS(300),
    [anon_sym_AT_ATc_COLON] = ACTIONS(298),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(298),
    [anon_sym_AT_ATC] = ACTIONS(298),
    [anon_sym_AT_ATdbt] = ACTIONS(300),
    [anon_sym_AT_ATdbta] = ACTIONS(298),
    [anon_sym_AT_ATdbtb] = ACTIONS(298),
    [anon_sym_AT_ATdbts] = ACTIONS(298),
    [anon_sym_AT_ATt] = ACTIONS(298),
    [anon_sym_AT_ATb] = ACTIONS(298),
    [anon_sym_AT_ATi] = ACTIONS(300),
    [anon_sym_AT_ATii] = ACTIONS(298),
    [anon_sym_AT_ATiS] = ACTIONS(300),
    [anon_sym_AT_ATiSS] = ACTIONS(298),
    [anon_sym_AT_ATis] = ACTIONS(298),
    [anon_sym_AT_ATiz] = ACTIONS(298),
    [anon_sym_AT_ATf] = ACTIONS(298),
    [anon_sym_AT_ATF] = ACTIONS(298),
    [anon_sym_AT_ATom] = ACTIONS(298),
    [anon_sym_AT_ATdm] = ACTIONS(298),
    [anon_sym_AT_ATr] = ACTIONS(298),
    [anon_sym_AT_ATs_COLON] = ACTIONS(298),
    [anon_sym_AT] = ACTIONS(300),
    [anon_sym_AT_BANG] = ACTIONS(298),
    [anon_sym_AT_LPAREN] = ACTIONS(298),
    [anon_sym_RPAREN] = ACTIONS(298),
    [anon_sym_ATa_COLON] = ACTIONS(298),
    [anon_sym_ATb_COLON] = ACTIONS(298),
    [anon_sym_ATB_COLON] = ACTIONS(298),
    [anon_sym_ATe_COLON] = ACTIONS(298),
    [anon_sym_ATF_COLON] = ACTIONS(298),
    [anon_sym_ATi_COLON] = ACTIONS(298),
    [anon_sym_ATk_COLON] = ACTIONS(298),
    [anon_sym_ATo_COLON] = ACTIONS(298),
    [anon_sym_ATr_COLON] = ACTIONS(298),
    [anon_sym_ATf_COLON] = ACTIONS(298),
    [anon_sym_ATs_COLON] = ACTIONS(298),
    [anon_sym_ATv_COLON] = ACTIONS(298),
    [anon_sym_ATx_COLON] = ACTIONS(298),
    [anon_sym_PIPE_DOT] = ACTIONS(298),
    [anon_sym_DOLLAR] = ACTIONS(300),
    [anon_sym_LPAREN] = ACTIONS(298),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_GT_GT] = ACTIONS(298),
    [sym_html_redirect_operator] = ACTIONS(300),
    [sym_html_append_operator] = ACTIONS(298),
    [anon_sym_COMMA] = ACTIONS(298),
    [aux_sym_arg_identifier_token1] = ACTIONS(300),
    [anon_sym_SQUOTE] = ACTIONS(298),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(298),
    [anon_sym_BQUOTE] = ACTIONS(298),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(298),
    [anon_sym_CR] = ACTIONS(298),
    [sym_file_descriptor] = ACTIONS(298),
    [sym__spec_sep] = ACTIONS(272),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(302),
    [anon_sym_TILDE] = ACTIONS(302),
    [anon_sym_PIPE] = ACTIONS(304),
    [anon_sym_PIPEH] = ACTIONS(302),
    [anon_sym_AT_AT_DOT] = ACTIONS(302),
    [anon_sym_AT_AT_EQ] = ACTIONS(302),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(302),
    [anon_sym_AT_AT] = ACTIONS(304),
    [anon_sym_AT_ATc_COLON] = ACTIONS(302),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(302),
    [anon_sym_AT_ATC] = ACTIONS(302),
    [anon_sym_AT_ATdbt] = ACTIONS(304),
    [anon_sym_AT_ATdbta] = ACTIONS(302),
    [anon_sym_AT_ATdbtb] = ACTIONS(302),
    [anon_sym_AT_ATdbts] = ACTIONS(302),
    [anon_sym_AT_ATt] = ACTIONS(302),
    [anon_sym_AT_ATb] = ACTIONS(302),
    [anon_sym_AT_ATi] = ACTIONS(304),
    [anon_sym_AT_ATii] = ACTIONS(302),
    [anon_sym_AT_ATiS] = ACTIONS(304),
    [anon_sym_AT_ATiSS] = ACTIONS(302),
    [anon_sym_AT_ATis] = ACTIONS(302),
    [anon_sym_AT_ATiz] = ACTIONS(302),
    [anon_sym_AT_ATf] = ACTIONS(302),
    [anon_sym_AT_ATF] = ACTIONS(302),
    [anon_sym_AT_ATom] = ACTIONS(302),
    [anon_sym_AT_ATdm] = ACTIONS(302),
    [anon_sym_AT_ATr] = ACTIONS(302),
    [anon_sym_AT_ATs_COLON] = ACTIONS(302),
    [anon_sym_AT] = ACTIONS(304),
    [anon_sym_AT_BANG] = ACTIONS(302),
    [anon_sym_AT_LPAREN] = ACTIONS(302),
    [anon_sym_RPAREN] = ACTIONS(302),
    [anon_sym_ATa_COLON] = ACTIONS(302),
    [anon_sym_ATb_COLON] = ACTIONS(302),
    [anon_sym_ATB_COLON] = ACTIONS(302),
    [anon_sym_ATe_COLON] = ACTIONS(302),
    [anon_sym_ATF_COLON] = ACTIONS(302),
    [anon_sym_ATi_COLON] = ACTIONS(302),
    [anon_sym_ATk_COLON] = ACTIONS(302),
    [anon_sym_ATo_COLON] = ACTIONS(302),
    [anon_sym_ATr_COLON] = ACTIONS(302),
    [anon_sym_ATf_COLON] = ACTIONS(302),
    [anon_sym_ATs_COLON] = ACTIONS(302),
    [anon_sym_ATv_COLON] = ACTIONS(302),
    [anon_sym_ATx_COLON] = ACTIONS(302),
    [anon_sym_PIPE_DOT] = ACTIONS(302),
    [anon_sym_DOLLAR] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(302),
    [anon_sym_GT] = ACTIONS(304),
    [anon_sym_GT_GT] = ACTIONS(302),
    [sym_html_redirect_operator] = ACTIONS(304),
    [sym_html_append_operator] = ACTIONS(302),
    [anon_sym_COMMA] = ACTIONS(302),
    [aux_sym_arg_identifier_token1] = ACTIONS(304),
    [anon_sym_SQUOTE] = ACTIONS(302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(302),
    [anon_sym_BQUOTE] = ACTIONS(302),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(302),
    [anon_sym_CR] = ACTIONS(302),
    [sym_file_descriptor] = ACTIONS(302),
    [sym__concat] = ACTIONS(302),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(306),
    [anon_sym_DQUOTE] = ACTIONS(306),
    [anon_sym_TILDE] = ACTIONS(306),
    [anon_sym_PIPE] = ACTIONS(308),
    [anon_sym_PIPEH] = ACTIONS(306),
    [anon_sym_AT_AT_DOT] = ACTIONS(306),
    [anon_sym_AT_AT_EQ] = ACTIONS(306),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(306),
    [anon_sym_AT_AT] = ACTIONS(308),
    [anon_sym_AT_ATc_COLON] = ACTIONS(306),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(306),
    [anon_sym_AT_ATC] = ACTIONS(306),
    [anon_sym_AT_ATdbt] = ACTIONS(308),
    [anon_sym_AT_ATdbta] = ACTIONS(306),
    [anon_sym_AT_ATdbtb] = ACTIONS(306),
    [anon_sym_AT_ATdbts] = ACTIONS(306),
    [anon_sym_AT_ATt] = ACTIONS(306),
    [anon_sym_AT_ATb] = ACTIONS(306),
    [anon_sym_AT_ATi] = ACTIONS(308),
    [anon_sym_AT_ATii] = ACTIONS(306),
    [anon_sym_AT_ATiS] = ACTIONS(308),
    [anon_sym_AT_ATiSS] = ACTIONS(306),
    [anon_sym_AT_ATis] = ACTIONS(306),
    [anon_sym_AT_ATiz] = ACTIONS(306),
    [anon_sym_AT_ATf] = ACTIONS(306),
    [anon_sym_AT_ATF] = ACTIONS(306),
    [anon_sym_AT_ATom] = ACTIONS(306),
    [anon_sym_AT_ATdm] = ACTIONS(306),
    [anon_sym_AT_ATr] = ACTIONS(306),
    [anon_sym_AT_ATs_COLON] = ACTIONS(306),
    [anon_sym_AT] = ACTIONS(308),
    [anon_sym_AT_BANG] = ACTIONS(306),
    [anon_sym_AT_LPAREN] = ACTIONS(306),
    [anon_sym_RPAREN] = ACTIONS(306),
    [anon_sym_ATa_COLON] = ACTIONS(306),
    [anon_sym_ATb_COLON] = ACTIONS(306),
    [anon_sym_ATB_COLON] = ACTIONS(306),
    [anon_sym_ATe_COLON] = ACTIONS(306),
    [anon_sym_ATF_COLON] = ACTIONS(306),
    [anon_sym_ATi_COLON] = ACTIONS(306),
    [anon_sym_ATk_COLON] = ACTIONS(306),
    [anon_sym_ATo_COLON] = ACTIONS(306),
    [anon_sym_ATr_COLON] = ACTIONS(306),
    [anon_sym_ATf_COLON] = ACTIONS(306),
    [anon_sym_ATs_COLON] = ACTIONS(306),
    [anon_sym_ATv_COLON] = ACTIONS(306),
    [anon_sym_ATx_COLON] = ACTIONS(306),
    [anon_sym_PIPE_DOT] = ACTIONS(306),
    [anon_sym_DOLLAR] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_SEMI] = ACTIONS(306),
    [anon_sym_GT] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(306),
    [sym_html_redirect_operator] = ACTIONS(308),
    [sym_html_append_operator] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(306),
    [aux_sym_arg_identifier_token1] = ACTIONS(308),
    [anon_sym_SQUOTE] = ACTIONS(306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(306),
    [anon_sym_BQUOTE] = ACTIONS(306),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(306),
    [anon_sym_CR] = ACTIONS(306),
    [sym_file_descriptor] = ACTIONS(306),
    [sym__concat] = ACTIONS(306),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_TILDE] = ACTIONS(274),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_PIPEH] = ACTIONS(274),
    [anon_sym_AT_AT_DOT] = ACTIONS(274),
    [anon_sym_AT_AT_EQ] = ACTIONS(274),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(274),
    [anon_sym_AT_AT] = ACTIONS(276),
    [anon_sym_AT_ATc_COLON] = ACTIONS(274),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(274),
    [anon_sym_AT_ATC] = ACTIONS(274),
    [anon_sym_AT_ATdbt] = ACTIONS(276),
    [anon_sym_AT_ATdbta] = ACTIONS(274),
    [anon_sym_AT_ATdbtb] = ACTIONS(274),
    [anon_sym_AT_ATdbts] = ACTIONS(274),
    [anon_sym_AT_ATt] = ACTIONS(274),
    [anon_sym_AT_ATb] = ACTIONS(274),
    [anon_sym_AT_ATi] = ACTIONS(276),
    [anon_sym_AT_ATii] = ACTIONS(274),
    [anon_sym_AT_ATiS] = ACTIONS(276),
    [anon_sym_AT_ATiSS] = ACTIONS(274),
    [anon_sym_AT_ATis] = ACTIONS(274),
    [anon_sym_AT_ATiz] = ACTIONS(274),
    [anon_sym_AT_ATf] = ACTIONS(274),
    [anon_sym_AT_ATF] = ACTIONS(274),
    [anon_sym_AT_ATom] = ACTIONS(274),
    [anon_sym_AT_ATdm] = ACTIONS(274),
    [anon_sym_AT_ATr] = ACTIONS(274),
    [anon_sym_AT_ATs_COLON] = ACTIONS(274),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_AT_BANG] = ACTIONS(274),
    [anon_sym_AT_LPAREN] = ACTIONS(274),
    [anon_sym_RPAREN] = ACTIONS(274),
    [anon_sym_ATa_COLON] = ACTIONS(274),
    [anon_sym_ATb_COLON] = ACTIONS(274),
    [anon_sym_ATB_COLON] = ACTIONS(274),
    [anon_sym_ATe_COLON] = ACTIONS(274),
    [anon_sym_ATF_COLON] = ACTIONS(274),
    [anon_sym_ATi_COLON] = ACTIONS(274),
    [anon_sym_ATk_COLON] = ACTIONS(274),
    [anon_sym_ATo_COLON] = ACTIONS(274),
    [anon_sym_ATr_COLON] = ACTIONS(274),
    [anon_sym_ATf_COLON] = ACTIONS(274),
    [anon_sym_ATs_COLON] = ACTIONS(274),
    [anon_sym_ATv_COLON] = ACTIONS(274),
    [anon_sym_ATx_COLON] = ACTIONS(274),
    [anon_sym_PIPE_DOT] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_SEMI] = ACTIONS(274),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_GT_GT] = ACTIONS(274),
    [sym_html_redirect_operator] = ACTIONS(276),
    [sym_html_append_operator] = ACTIONS(274),
    [anon_sym_COMMA] = ACTIONS(274),
    [aux_sym_arg_identifier_token1] = ACTIONS(276),
    [anon_sym_SQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(274),
    [anon_sym_BQUOTE] = ACTIONS(274),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(274),
    [anon_sym_CR] = ACTIONS(274),
    [sym_file_descriptor] = ACTIONS(274),
    [sym__concat] = ACTIONS(274),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [anon_sym_TILDE] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(312),
    [anon_sym_PIPEH] = ACTIONS(310),
    [anon_sym_AT_AT_DOT] = ACTIONS(310),
    [anon_sym_AT_AT_EQ] = ACTIONS(310),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(310),
    [anon_sym_AT_AT] = ACTIONS(312),
    [anon_sym_AT_ATc_COLON] = ACTIONS(310),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(310),
    [anon_sym_AT_ATC] = ACTIONS(310),
    [anon_sym_AT_ATdbt] = ACTIONS(312),
    [anon_sym_AT_ATdbta] = ACTIONS(310),
    [anon_sym_AT_ATdbtb] = ACTIONS(310),
    [anon_sym_AT_ATdbts] = ACTIONS(310),
    [anon_sym_AT_ATt] = ACTIONS(310),
    [anon_sym_AT_ATb] = ACTIONS(310),
    [anon_sym_AT_ATi] = ACTIONS(312),
    [anon_sym_AT_ATii] = ACTIONS(310),
    [anon_sym_AT_ATiS] = ACTIONS(312),
    [anon_sym_AT_ATiSS] = ACTIONS(310),
    [anon_sym_AT_ATis] = ACTIONS(310),
    [anon_sym_AT_ATiz] = ACTIONS(310),
    [anon_sym_AT_ATf] = ACTIONS(310),
    [anon_sym_AT_ATF] = ACTIONS(310),
    [anon_sym_AT_ATom] = ACTIONS(310),
    [anon_sym_AT_ATdm] = ACTIONS(310),
    [anon_sym_AT_ATr] = ACTIONS(310),
    [anon_sym_AT_ATs_COLON] = ACTIONS(310),
    [anon_sym_AT] = ACTIONS(312),
    [anon_sym_AT_BANG] = ACTIONS(310),
    [anon_sym_AT_LPAREN] = ACTIONS(310),
    [anon_sym_RPAREN] = ACTIONS(310),
    [anon_sym_ATa_COLON] = ACTIONS(310),
    [anon_sym_ATb_COLON] = ACTIONS(310),
    [anon_sym_ATB_COLON] = ACTIONS(310),
    [anon_sym_ATe_COLON] = ACTIONS(310),
    [anon_sym_ATF_COLON] = ACTIONS(310),
    [anon_sym_ATi_COLON] = ACTIONS(310),
    [anon_sym_ATk_COLON] = ACTIONS(310),
    [anon_sym_ATo_COLON] = ACTIONS(310),
    [anon_sym_ATr_COLON] = ACTIONS(310),
    [anon_sym_ATf_COLON] = ACTIONS(310),
    [anon_sym_ATs_COLON] = ACTIONS(310),
    [anon_sym_ATv_COLON] = ACTIONS(310),
    [anon_sym_ATx_COLON] = ACTIONS(310),
    [anon_sym_PIPE_DOT] = ACTIONS(310),
    [anon_sym_DOLLAR] = ACTIONS(312),
    [anon_sym_LPAREN] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(312),
    [anon_sym_GT_GT] = ACTIONS(310),
    [sym_html_redirect_operator] = ACTIONS(312),
    [sym_html_append_operator] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(310),
    [aux_sym_arg_identifier_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(310),
    [anon_sym_BQUOTE] = ACTIONS(310),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(310),
    [anon_sym_CR] = ACTIONS(310),
    [sym_file_descriptor] = ACTIONS(310),
    [sym__concat] = ACTIONS(310),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(314),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_TILDE] = ACTIONS(314),
    [anon_sym_PIPE] = ACTIONS(316),
    [anon_sym_PIPEH] = ACTIONS(314),
    [anon_sym_AT_AT_DOT] = ACTIONS(314),
    [anon_sym_AT_AT_EQ] = ACTIONS(314),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(314),
    [anon_sym_AT_AT] = ACTIONS(316),
    [anon_sym_AT_ATc_COLON] = ACTIONS(314),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(314),
    [anon_sym_AT_ATC] = ACTIONS(314),
    [anon_sym_AT_ATdbt] = ACTIONS(316),
    [anon_sym_AT_ATdbta] = ACTIONS(314),
    [anon_sym_AT_ATdbtb] = ACTIONS(314),
    [anon_sym_AT_ATdbts] = ACTIONS(314),
    [anon_sym_AT_ATt] = ACTIONS(314),
    [anon_sym_AT_ATb] = ACTIONS(314),
    [anon_sym_AT_ATi] = ACTIONS(316),
    [anon_sym_AT_ATii] = ACTIONS(314),
    [anon_sym_AT_ATiS] = ACTIONS(316),
    [anon_sym_AT_ATiSS] = ACTIONS(314),
    [anon_sym_AT_ATis] = ACTIONS(314),
    [anon_sym_AT_ATiz] = ACTIONS(314),
    [anon_sym_AT_ATf] = ACTIONS(314),
    [anon_sym_AT_ATF] = ACTIONS(314),
    [anon_sym_AT_ATom] = ACTIONS(314),
    [anon_sym_AT_ATdm] = ACTIONS(314),
    [anon_sym_AT_ATr] = ACTIONS(314),
    [anon_sym_AT_ATs_COLON] = ACTIONS(314),
    [anon_sym_AT] = ACTIONS(316),
    [anon_sym_AT_BANG] = ACTIONS(314),
    [anon_sym_AT_LPAREN] = ACTIONS(314),
    [anon_sym_RPAREN] = ACTIONS(314),
    [anon_sym_ATa_COLON] = ACTIONS(314),
    [anon_sym_ATb_COLON] = ACTIONS(314),
    [anon_sym_ATB_COLON] = ACTIONS(314),
    [anon_sym_ATe_COLON] = ACTIONS(314),
    [anon_sym_ATF_COLON] = ACTIONS(314),
    [anon_sym_ATi_COLON] = ACTIONS(314),
    [anon_sym_ATk_COLON] = ACTIONS(314),
    [anon_sym_ATo_COLON] = ACTIONS(314),
    [anon_sym_ATr_COLON] = ACTIONS(314),
    [anon_sym_ATf_COLON] = ACTIONS(314),
    [anon_sym_ATs_COLON] = ACTIONS(314),
    [anon_sym_ATv_COLON] = ACTIONS(314),
    [anon_sym_ATx_COLON] = ACTIONS(314),
    [anon_sym_PIPE_DOT] = ACTIONS(314),
    [anon_sym_DOLLAR] = ACTIONS(316),
    [anon_sym_LPAREN] = ACTIONS(314),
    [anon_sym_SEMI] = ACTIONS(314),
    [anon_sym_GT] = ACTIONS(316),
    [anon_sym_GT_GT] = ACTIONS(314),
    [sym_html_redirect_operator] = ACTIONS(316),
    [sym_html_append_operator] = ACTIONS(314),
    [anon_sym_COMMA] = ACTIONS(314),
    [aux_sym_arg_identifier_token1] = ACTIONS(316),
    [anon_sym_SQUOTE] = ACTIONS(314),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(314),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(314),
    [anon_sym_CR] = ACTIONS(314),
    [sym_file_descriptor] = ACTIONS(314),
    [sym__concat] = ACTIONS(314),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(318),
    [anon_sym_DQUOTE] = ACTIONS(318),
    [anon_sym_TILDE] = ACTIONS(318),
    [anon_sym_PIPE] = ACTIONS(320),
    [anon_sym_PIPEH] = ACTIONS(318),
    [anon_sym_AT_AT_DOT] = ACTIONS(318),
    [anon_sym_AT_AT_EQ] = ACTIONS(318),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(318),
    [anon_sym_AT_AT] = ACTIONS(320),
    [anon_sym_AT_ATc_COLON] = ACTIONS(318),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(318),
    [anon_sym_AT_ATC] = ACTIONS(318),
    [anon_sym_AT_ATdbt] = ACTIONS(320),
    [anon_sym_AT_ATdbta] = ACTIONS(318),
    [anon_sym_AT_ATdbtb] = ACTIONS(318),
    [anon_sym_AT_ATdbts] = ACTIONS(318),
    [anon_sym_AT_ATt] = ACTIONS(318),
    [anon_sym_AT_ATb] = ACTIONS(318),
    [anon_sym_AT_ATi] = ACTIONS(320),
    [anon_sym_AT_ATii] = ACTIONS(318),
    [anon_sym_AT_ATiS] = ACTIONS(320),
    [anon_sym_AT_ATiSS] = ACTIONS(318),
    [anon_sym_AT_ATis] = ACTIONS(318),
    [anon_sym_AT_ATiz] = ACTIONS(318),
    [anon_sym_AT_ATf] = ACTIONS(318),
    [anon_sym_AT_ATF] = ACTIONS(318),
    [anon_sym_AT_ATom] = ACTIONS(318),
    [anon_sym_AT_ATdm] = ACTIONS(318),
    [anon_sym_AT_ATr] = ACTIONS(318),
    [anon_sym_AT_ATs_COLON] = ACTIONS(318),
    [anon_sym_AT] = ACTIONS(320),
    [anon_sym_AT_BANG] = ACTIONS(318),
    [anon_sym_AT_LPAREN] = ACTIONS(318),
    [anon_sym_RPAREN] = ACTIONS(318),
    [anon_sym_ATa_COLON] = ACTIONS(318),
    [anon_sym_ATb_COLON] = ACTIONS(318),
    [anon_sym_ATB_COLON] = ACTIONS(318),
    [anon_sym_ATe_COLON] = ACTIONS(318),
    [anon_sym_ATF_COLON] = ACTIONS(318),
    [anon_sym_ATi_COLON] = ACTIONS(318),
    [anon_sym_ATk_COLON] = ACTIONS(318),
    [anon_sym_ATo_COLON] = ACTIONS(318),
    [anon_sym_ATr_COLON] = ACTIONS(318),
    [anon_sym_ATf_COLON] = ACTIONS(318),
    [anon_sym_ATs_COLON] = ACTIONS(318),
    [anon_sym_ATv_COLON] = ACTIONS(318),
    [anon_sym_ATx_COLON] = ACTIONS(318),
    [anon_sym_PIPE_DOT] = ACTIONS(318),
    [anon_sym_DOLLAR] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(318),
    [anon_sym_SEMI] = ACTIONS(318),
    [anon_sym_GT] = ACTIONS(320),
    [anon_sym_GT_GT] = ACTIONS(318),
    [sym_html_redirect_operator] = ACTIONS(320),
    [sym_html_append_operator] = ACTIONS(318),
    [anon_sym_COMMA] = ACTIONS(318),
    [aux_sym_arg_identifier_token1] = ACTIONS(320),
    [anon_sym_SQUOTE] = ACTIONS(318),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(318),
    [anon_sym_BQUOTE] = ACTIONS(318),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(318),
    [anon_sym_CR] = ACTIONS(318),
    [sym_file_descriptor] = ACTIONS(318),
    [sym__concat] = ACTIONS(318),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(322),
    [anon_sym_DQUOTE] = ACTIONS(322),
    [anon_sym_TILDE] = ACTIONS(322),
    [anon_sym_PIPE] = ACTIONS(324),
    [anon_sym_PIPEH] = ACTIONS(322),
    [anon_sym_AT_AT_DOT] = ACTIONS(322),
    [anon_sym_AT_AT_EQ] = ACTIONS(322),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(322),
    [anon_sym_AT_AT] = ACTIONS(324),
    [anon_sym_AT_ATc_COLON] = ACTIONS(322),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(322),
    [anon_sym_AT_ATC] = ACTIONS(322),
    [anon_sym_AT_ATdbt] = ACTIONS(324),
    [anon_sym_AT_ATdbta] = ACTIONS(322),
    [anon_sym_AT_ATdbtb] = ACTIONS(322),
    [anon_sym_AT_ATdbts] = ACTIONS(322),
    [anon_sym_AT_ATt] = ACTIONS(322),
    [anon_sym_AT_ATb] = ACTIONS(322),
    [anon_sym_AT_ATi] = ACTIONS(324),
    [anon_sym_AT_ATii] = ACTIONS(322),
    [anon_sym_AT_ATiS] = ACTIONS(324),
    [anon_sym_AT_ATiSS] = ACTIONS(322),
    [anon_sym_AT_ATis] = ACTIONS(322),
    [anon_sym_AT_ATiz] = ACTIONS(322),
    [anon_sym_AT_ATf] = ACTIONS(322),
    [anon_sym_AT_ATF] = ACTIONS(322),
    [anon_sym_AT_ATom] = ACTIONS(322),
    [anon_sym_AT_ATdm] = ACTIONS(322),
    [anon_sym_AT_ATr] = ACTIONS(322),
    [anon_sym_AT_ATs_COLON] = ACTIONS(322),
    [anon_sym_AT] = ACTIONS(324),
    [anon_sym_AT_BANG] = ACTIONS(322),
    [anon_sym_AT_LPAREN] = ACTIONS(322),
    [anon_sym_RPAREN] = ACTIONS(322),
    [anon_sym_ATa_COLON] = ACTIONS(322),
    [anon_sym_ATb_COLON] = ACTIONS(322),
    [anon_sym_ATB_COLON] = ACTIONS(322),
    [anon_sym_ATe_COLON] = ACTIONS(322),
    [anon_sym_ATF_COLON] = ACTIONS(322),
    [anon_sym_ATi_COLON] = ACTIONS(322),
    [anon_sym_ATk_COLON] = ACTIONS(322),
    [anon_sym_ATo_COLON] = ACTIONS(322),
    [anon_sym_ATr_COLON] = ACTIONS(322),
    [anon_sym_ATf_COLON] = ACTIONS(322),
    [anon_sym_ATs_COLON] = ACTIONS(322),
    [anon_sym_ATv_COLON] = ACTIONS(322),
    [anon_sym_ATx_COLON] = ACTIONS(322),
    [anon_sym_PIPE_DOT] = ACTIONS(322),
    [anon_sym_DOLLAR] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_SEMI] = ACTIONS(322),
    [anon_sym_GT] = ACTIONS(324),
    [anon_sym_GT_GT] = ACTIONS(322),
    [sym_html_redirect_operator] = ACTIONS(324),
    [sym_html_append_operator] = ACTIONS(322),
    [anon_sym_COMMA] = ACTIONS(322),
    [aux_sym_arg_identifier_token1] = ACTIONS(324),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(322),
    [anon_sym_BQUOTE] = ACTIONS(322),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(322),
    [anon_sym_CR] = ACTIONS(322),
    [sym_file_descriptor] = ACTIONS(322),
    [sym__concat] = ACTIONS(322),
  },
  [89] = {
    [ts_builtin_sym_end] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [anon_sym_TILDE] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(312),
    [anon_sym_PIPEH] = ACTIONS(310),
    [anon_sym_AT_AT_DOT] = ACTIONS(310),
    [anon_sym_AT_AT_EQ] = ACTIONS(310),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(310),
    [anon_sym_AT_AT] = ACTIONS(312),
    [anon_sym_AT_ATc_COLON] = ACTIONS(310),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(310),
    [anon_sym_AT_ATC] = ACTIONS(310),
    [anon_sym_AT_ATdbt] = ACTIONS(312),
    [anon_sym_AT_ATdbta] = ACTIONS(310),
    [anon_sym_AT_ATdbtb] = ACTIONS(310),
    [anon_sym_AT_ATdbts] = ACTIONS(310),
    [anon_sym_AT_ATt] = ACTIONS(310),
    [anon_sym_AT_ATb] = ACTIONS(310),
    [anon_sym_AT_ATi] = ACTIONS(312),
    [anon_sym_AT_ATii] = ACTIONS(310),
    [anon_sym_AT_ATiS] = ACTIONS(312),
    [anon_sym_AT_ATiSS] = ACTIONS(310),
    [anon_sym_AT_ATis] = ACTIONS(310),
    [anon_sym_AT_ATiz] = ACTIONS(310),
    [anon_sym_AT_ATf] = ACTIONS(310),
    [anon_sym_AT_ATF] = ACTIONS(310),
    [anon_sym_AT_ATom] = ACTIONS(310),
    [anon_sym_AT_ATdm] = ACTIONS(310),
    [anon_sym_AT_ATr] = ACTIONS(310),
    [anon_sym_AT_ATs_COLON] = ACTIONS(310),
    [anon_sym_AT] = ACTIONS(312),
    [anon_sym_AT_BANG] = ACTIONS(310),
    [anon_sym_AT_LPAREN] = ACTIONS(310),
    [anon_sym_RPAREN] = ACTIONS(310),
    [anon_sym_ATa_COLON] = ACTIONS(310),
    [anon_sym_ATb_COLON] = ACTIONS(310),
    [anon_sym_ATB_COLON] = ACTIONS(310),
    [anon_sym_ATe_COLON] = ACTIONS(310),
    [anon_sym_ATF_COLON] = ACTIONS(310),
    [anon_sym_ATi_COLON] = ACTIONS(310),
    [anon_sym_ATk_COLON] = ACTIONS(310),
    [anon_sym_ATo_COLON] = ACTIONS(310),
    [anon_sym_ATr_COLON] = ACTIONS(310),
    [anon_sym_ATf_COLON] = ACTIONS(310),
    [anon_sym_ATs_COLON] = ACTIONS(310),
    [anon_sym_ATv_COLON] = ACTIONS(310),
    [anon_sym_ATx_COLON] = ACTIONS(310),
    [anon_sym_PIPE_DOT] = ACTIONS(310),
    [anon_sym_DOLLAR] = ACTIONS(312),
    [anon_sym_LPAREN] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(312),
    [anon_sym_GT_GT] = ACTIONS(310),
    [sym_html_redirect_operator] = ACTIONS(312),
    [sym_html_append_operator] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(310),
    [aux_sym_arg_identifier_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(310),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(310),
    [anon_sym_BQUOTE] = ACTIONS(310),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(310),
    [anon_sym_CR] = ACTIONS(310),
    [sym_file_descriptor] = ACTIONS(310),
    [sym__concat] = ACTIONS(310),
  },
  [90] = {
    [ts_builtin_sym_end] = ACTIONS(326),
    [anon_sym_DQUOTE] = ACTIONS(326),
    [anon_sym_TILDE] = ACTIONS(326),
    [anon_sym_PIPE] = ACTIONS(328),
    [anon_sym_PIPEH] = ACTIONS(326),
    [anon_sym_AT_AT_DOT] = ACTIONS(326),
    [anon_sym_AT_AT_EQ] = ACTIONS(326),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(326),
    [anon_sym_AT_AT] = ACTIONS(328),
    [anon_sym_AT_ATc_COLON] = ACTIONS(326),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(326),
    [anon_sym_AT_ATC] = ACTIONS(326),
    [anon_sym_AT_ATdbt] = ACTIONS(328),
    [anon_sym_AT_ATdbta] = ACTIONS(326),
    [anon_sym_AT_ATdbtb] = ACTIONS(326),
    [anon_sym_AT_ATdbts] = ACTIONS(326),
    [anon_sym_AT_ATt] = ACTIONS(326),
    [anon_sym_AT_ATb] = ACTIONS(326),
    [anon_sym_AT_ATi] = ACTIONS(328),
    [anon_sym_AT_ATii] = ACTIONS(326),
    [anon_sym_AT_ATiS] = ACTIONS(328),
    [anon_sym_AT_ATiSS] = ACTIONS(326),
    [anon_sym_AT_ATis] = ACTIONS(326),
    [anon_sym_AT_ATiz] = ACTIONS(326),
    [anon_sym_AT_ATf] = ACTIONS(326),
    [anon_sym_AT_ATF] = ACTIONS(326),
    [anon_sym_AT_ATom] = ACTIONS(326),
    [anon_sym_AT_ATdm] = ACTIONS(326),
    [anon_sym_AT_ATr] = ACTIONS(326),
    [anon_sym_AT_ATs_COLON] = ACTIONS(326),
    [anon_sym_AT] = ACTIONS(328),
    [anon_sym_AT_BANG] = ACTIONS(326),
    [anon_sym_AT_LPAREN] = ACTIONS(326),
    [anon_sym_RPAREN] = ACTIONS(326),
    [anon_sym_ATa_COLON] = ACTIONS(326),
    [anon_sym_ATb_COLON] = ACTIONS(326),
    [anon_sym_ATB_COLON] = ACTIONS(326),
    [anon_sym_ATe_COLON] = ACTIONS(326),
    [anon_sym_ATF_COLON] = ACTIONS(326),
    [anon_sym_ATi_COLON] = ACTIONS(326),
    [anon_sym_ATk_COLON] = ACTIONS(326),
    [anon_sym_ATo_COLON] = ACTIONS(326),
    [anon_sym_ATr_COLON] = ACTIONS(326),
    [anon_sym_ATf_COLON] = ACTIONS(326),
    [anon_sym_ATs_COLON] = ACTIONS(326),
    [anon_sym_ATv_COLON] = ACTIONS(326),
    [anon_sym_ATx_COLON] = ACTIONS(326),
    [anon_sym_PIPE_DOT] = ACTIONS(326),
    [anon_sym_DOLLAR] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(326),
    [anon_sym_SEMI] = ACTIONS(326),
    [anon_sym_GT] = ACTIONS(328),
    [anon_sym_GT_GT] = ACTIONS(326),
    [sym_html_redirect_operator] = ACTIONS(328),
    [sym_html_append_operator] = ACTIONS(326),
    [anon_sym_COMMA] = ACTIONS(326),
    [aux_sym_arg_identifier_token1] = ACTIONS(328),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(326),
    [anon_sym_BQUOTE] = ACTIONS(326),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(326),
    [anon_sym_CR] = ACTIONS(326),
    [sym_file_descriptor] = ACTIONS(326),
    [sym__spec_sep] = ACTIONS(326),
  },
  [91] = {
    [ts_builtin_sym_end] = ACTIONS(330),
    [anon_sym_DQUOTE] = ACTIONS(330),
    [anon_sym_TILDE] = ACTIONS(330),
    [anon_sym_PIPE] = ACTIONS(332),
    [anon_sym_PIPEH] = ACTIONS(330),
    [anon_sym_AT_AT_DOT] = ACTIONS(330),
    [anon_sym_AT_AT_EQ] = ACTIONS(330),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(330),
    [anon_sym_AT_AT] = ACTIONS(332),
    [anon_sym_AT_ATc_COLON] = ACTIONS(330),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(330),
    [anon_sym_AT_ATC] = ACTIONS(330),
    [anon_sym_AT_ATdbt] = ACTIONS(332),
    [anon_sym_AT_ATdbta] = ACTIONS(330),
    [anon_sym_AT_ATdbtb] = ACTIONS(330),
    [anon_sym_AT_ATdbts] = ACTIONS(330),
    [anon_sym_AT_ATt] = ACTIONS(330),
    [anon_sym_AT_ATb] = ACTIONS(330),
    [anon_sym_AT_ATi] = ACTIONS(332),
    [anon_sym_AT_ATii] = ACTIONS(330),
    [anon_sym_AT_ATiS] = ACTIONS(332),
    [anon_sym_AT_ATiSS] = ACTIONS(330),
    [anon_sym_AT_ATis] = ACTIONS(330),
    [anon_sym_AT_ATiz] = ACTIONS(330),
    [anon_sym_AT_ATf] = ACTIONS(330),
    [anon_sym_AT_ATF] = ACTIONS(330),
    [anon_sym_AT_ATom] = ACTIONS(330),
    [anon_sym_AT_ATdm] = ACTIONS(330),
    [anon_sym_AT_ATr] = ACTIONS(330),
    [anon_sym_AT_ATs_COLON] = ACTIONS(330),
    [anon_sym_AT] = ACTIONS(332),
    [anon_sym_AT_BANG] = ACTIONS(330),
    [anon_sym_AT_LPAREN] = ACTIONS(330),
    [anon_sym_RPAREN] = ACTIONS(330),
    [anon_sym_ATa_COLON] = ACTIONS(330),
    [anon_sym_ATb_COLON] = ACTIONS(330),
    [anon_sym_ATB_COLON] = ACTIONS(330),
    [anon_sym_ATe_COLON] = ACTIONS(330),
    [anon_sym_ATF_COLON] = ACTIONS(330),
    [anon_sym_ATi_COLON] = ACTIONS(330),
    [anon_sym_ATk_COLON] = ACTIONS(330),
    [anon_sym_ATo_COLON] = ACTIONS(330),
    [anon_sym_ATr_COLON] = ACTIONS(330),
    [anon_sym_ATf_COLON] = ACTIONS(330),
    [anon_sym_ATs_COLON] = ACTIONS(330),
    [anon_sym_ATv_COLON] = ACTIONS(330),
    [anon_sym_ATx_COLON] = ACTIONS(330),
    [anon_sym_PIPE_DOT] = ACTIONS(330),
    [anon_sym_DOLLAR] = ACTIONS(332),
    [anon_sym_LPAREN] = ACTIONS(330),
    [anon_sym_SEMI] = ACTIONS(330),
    [anon_sym_GT] = ACTIONS(332),
    [anon_sym_GT_GT] = ACTIONS(330),
    [sym_html_redirect_operator] = ACTIONS(332),
    [sym_html_append_operator] = ACTIONS(330),
    [anon_sym_COMMA] = ACTIONS(330),
    [aux_sym_arg_identifier_token1] = ACTIONS(332),
    [anon_sym_SQUOTE] = ACTIONS(330),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(330),
    [anon_sym_BQUOTE] = ACTIONS(330),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(330),
    [anon_sym_CR] = ACTIONS(330),
    [sym_file_descriptor] = ACTIONS(330),
    [sym__spec_sep] = ACTIONS(330),
  },
  [92] = {
    [ts_builtin_sym_end] = ACTIONS(334),
    [anon_sym_DQUOTE] = ACTIONS(334),
    [anon_sym_TILDE] = ACTIONS(334),
    [anon_sym_PIPE] = ACTIONS(336),
    [anon_sym_PIPEH] = ACTIONS(334),
    [anon_sym_AT_AT_DOT] = ACTIONS(334),
    [anon_sym_AT_AT_EQ] = ACTIONS(334),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(334),
    [anon_sym_AT_AT] = ACTIONS(336),
    [anon_sym_AT_ATc_COLON] = ACTIONS(334),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(334),
    [anon_sym_AT_ATC] = ACTIONS(334),
    [anon_sym_AT_ATdbt] = ACTIONS(336),
    [anon_sym_AT_ATdbta] = ACTIONS(334),
    [anon_sym_AT_ATdbtb] = ACTIONS(334),
    [anon_sym_AT_ATdbts] = ACTIONS(334),
    [anon_sym_AT_ATt] = ACTIONS(334),
    [anon_sym_AT_ATb] = ACTIONS(334),
    [anon_sym_AT_ATi] = ACTIONS(336),
    [anon_sym_AT_ATii] = ACTIONS(334),
    [anon_sym_AT_ATiS] = ACTIONS(336),
    [anon_sym_AT_ATiSS] = ACTIONS(334),
    [anon_sym_AT_ATis] = ACTIONS(334),
    [anon_sym_AT_ATiz] = ACTIONS(334),
    [anon_sym_AT_ATf] = ACTIONS(334),
    [anon_sym_AT_ATF] = ACTIONS(334),
    [anon_sym_AT_ATom] = ACTIONS(334),
    [anon_sym_AT_ATdm] = ACTIONS(334),
    [anon_sym_AT_ATr] = ACTIONS(334),
    [anon_sym_AT_ATs_COLON] = ACTIONS(334),
    [anon_sym_AT] = ACTIONS(336),
    [anon_sym_AT_BANG] = ACTIONS(334),
    [anon_sym_AT_LPAREN] = ACTIONS(334),
    [anon_sym_RPAREN] = ACTIONS(334),
    [anon_sym_ATa_COLON] = ACTIONS(334),
    [anon_sym_ATb_COLON] = ACTIONS(334),
    [anon_sym_ATB_COLON] = ACTIONS(334),
    [anon_sym_ATe_COLON] = ACTIONS(334),
    [anon_sym_ATF_COLON] = ACTIONS(334),
    [anon_sym_ATi_COLON] = ACTIONS(334),
    [anon_sym_ATk_COLON] = ACTIONS(334),
    [anon_sym_ATo_COLON] = ACTIONS(334),
    [anon_sym_ATr_COLON] = ACTIONS(334),
    [anon_sym_ATf_COLON] = ACTIONS(334),
    [anon_sym_ATs_COLON] = ACTIONS(334),
    [anon_sym_ATv_COLON] = ACTIONS(334),
    [anon_sym_ATx_COLON] = ACTIONS(334),
    [anon_sym_PIPE_DOT] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_LPAREN] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(334),
    [anon_sym_GT] = ACTIONS(336),
    [anon_sym_GT_GT] = ACTIONS(334),
    [sym_html_redirect_operator] = ACTIONS(336),
    [sym_html_append_operator] = ACTIONS(334),
    [anon_sym_COMMA] = ACTIONS(334),
    [aux_sym_arg_identifier_token1] = ACTIONS(336),
    [anon_sym_SQUOTE] = ACTIONS(334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(334),
    [anon_sym_BQUOTE] = ACTIONS(334),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(334),
    [anon_sym_CR] = ACTIONS(334),
    [sym_file_descriptor] = ACTIONS(334),
    [sym__concat] = ACTIONS(334),
  },
  [93] = {
    [ts_builtin_sym_end] = ACTIONS(338),
    [anon_sym_DQUOTE] = ACTIONS(338),
    [anon_sym_TILDE] = ACTIONS(338),
    [anon_sym_PIPE] = ACTIONS(340),
    [anon_sym_PIPEH] = ACTIONS(338),
    [anon_sym_AT_AT_DOT] = ACTIONS(338),
    [anon_sym_AT_AT_EQ] = ACTIONS(338),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(338),
    [anon_sym_AT_AT] = ACTIONS(340),
    [anon_sym_AT_ATc_COLON] = ACTIONS(338),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(338),
    [anon_sym_AT_ATC] = ACTIONS(338),
    [anon_sym_AT_ATdbt] = ACTIONS(340),
    [anon_sym_AT_ATdbta] = ACTIONS(338),
    [anon_sym_AT_ATdbtb] = ACTIONS(338),
    [anon_sym_AT_ATdbts] = ACTIONS(338),
    [anon_sym_AT_ATt] = ACTIONS(338),
    [anon_sym_AT_ATb] = ACTIONS(338),
    [anon_sym_AT_ATi] = ACTIONS(340),
    [anon_sym_AT_ATii] = ACTIONS(338),
    [anon_sym_AT_ATiS] = ACTIONS(340),
    [anon_sym_AT_ATiSS] = ACTIONS(338),
    [anon_sym_AT_ATis] = ACTIONS(338),
    [anon_sym_AT_ATiz] = ACTIONS(338),
    [anon_sym_AT_ATf] = ACTIONS(338),
    [anon_sym_AT_ATF] = ACTIONS(338),
    [anon_sym_AT_ATom] = ACTIONS(338),
    [anon_sym_AT_ATdm] = ACTIONS(338),
    [anon_sym_AT_ATr] = ACTIONS(338),
    [anon_sym_AT_ATs_COLON] = ACTIONS(338),
    [anon_sym_AT] = ACTIONS(340),
    [anon_sym_AT_BANG] = ACTIONS(338),
    [anon_sym_AT_LPAREN] = ACTIONS(338),
    [anon_sym_RPAREN] = ACTIONS(338),
    [anon_sym_ATa_COLON] = ACTIONS(338),
    [anon_sym_ATb_COLON] = ACTIONS(338),
    [anon_sym_ATB_COLON] = ACTIONS(338),
    [anon_sym_ATe_COLON] = ACTIONS(338),
    [anon_sym_ATF_COLON] = ACTIONS(338),
    [anon_sym_ATi_COLON] = ACTIONS(338),
    [anon_sym_ATk_COLON] = ACTIONS(338),
    [anon_sym_ATo_COLON] = ACTIONS(338),
    [anon_sym_ATr_COLON] = ACTIONS(338),
    [anon_sym_ATf_COLON] = ACTIONS(338),
    [anon_sym_ATs_COLON] = ACTIONS(338),
    [anon_sym_ATv_COLON] = ACTIONS(338),
    [anon_sym_ATx_COLON] = ACTIONS(338),
    [anon_sym_PIPE_DOT] = ACTIONS(338),
    [anon_sym_DOLLAR] = ACTIONS(340),
    [anon_sym_LPAREN] = ACTIONS(338),
    [anon_sym_SEMI] = ACTIONS(338),
    [anon_sym_GT] = ACTIONS(340),
    [anon_sym_GT_GT] = ACTIONS(338),
    [sym_html_redirect_operator] = ACTIONS(340),
    [sym_html_append_operator] = ACTIONS(338),
    [anon_sym_COMMA] = ACTIONS(338),
    [aux_sym_arg_identifier_token1] = ACTIONS(340),
    [anon_sym_SQUOTE] = ACTIONS(338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(338),
    [anon_sym_BQUOTE] = ACTIONS(338),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(338),
    [anon_sym_CR] = ACTIONS(338),
    [sym_file_descriptor] = ACTIONS(338),
    [sym__concat] = ACTIONS(338),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 9,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(115), 1,
      sym_pf_concatenation,
    ACTIONS(224), 2,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
    STATE(75), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(101), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
    ACTIONS(236), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(234), 44,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [83] = 4,
    ACTIONS(3), 1,
      sym__comment,
    STATE(99), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(344), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(342), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [156] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(348), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      anon_sym_GT,
      sym_html_redirect_operator,
      aux_sym_arg_identifier_token1,
    ACTIONS(346), 53,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [227] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(354), 1,
      sym__concat_pf_dot,
    STATE(97), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(352), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(350), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [302] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(296), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      anon_sym_GT,
      sym_html_redirect_operator,
      aux_sym_arg_identifier_token1,
    ACTIONS(294), 53,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [373] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(361), 1,
      sym__concat_pf_dot,
    STATE(97), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(359), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(357), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [448] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(240), 1,
      anon_sym_DQUOTE,
    ACTIONS(244), 1,
      sym__eq_sep_key_identifier,
    ACTIONS(246), 1,
      anon_sym_SQUOTE,
    ACTIONS(248), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(177), 1,
      sym__eq_sep_key_concatenation,
    STATE(179), 1,
      sym__eq_sep_key,
    STATE(254), 1,
      sym_eq_sep_args,
    STATE(130), 4,
      sym__eq_sep_key_single,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
    ACTIONS(242), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(238), 44,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [535] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(367), 1,
      sym__concat,
    STATE(107), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(365), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(363), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [609] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(310), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [679] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(344), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(342), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [749] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(352), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(350), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [819] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(310), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [889] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(371), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(369), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [959] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(367), 1,
      sym__concat,
    STATE(108), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(375), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(373), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1033] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(381), 1,
      sym__concat,
    STATE(108), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(379), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(377), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1107] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(386), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(384), 51,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1176] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(379), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(377), 51,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1245] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(310), 51,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1314] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(310), 51,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1383] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(390), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(388), 51,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1452] = 8,
    ACTIONS(396), 1,
      sym_grep_specifier_identifier,
    ACTIONS(398), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(400), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(402), 1,
      anon_sym_BQUOTE,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(392), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    STATE(117), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(394), 52,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [1530] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(365), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(363), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1598] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(408), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
      sym__eq_sep_key_identifier,
    ACTIONS(406), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1666] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(414), 1,
      sym_grep_specifier_identifier,
    ACTIONS(417), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(420), 1,
      anon_sym_BQUOTE,
    ACTIONS(410), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    STATE(117), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(412), 53,
      anon_sym_TILDE,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [1742] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(423), 1,
      sym__concat,
    STATE(120), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(296), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(294), 49,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1813] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(232), 1,
      sym__concat_pf_dot,
    STATE(121), 1,
      aux_sym_pf_dot_args_repeat1,
    ACTIONS(222), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(220), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1884] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(423), 1,
      sym__concat,
    STATE(124), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(283), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(281), 49,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1955] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(232), 1,
      sym__concat_pf_dot,
    STATE(131), 1,
      aux_sym_pf_dot_args_repeat1,
    ACTIONS(427), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(425), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2026] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(433), 1,
      sym__eq_sep_concat,
    STATE(125), 1,
      aux_sym__eq_sep_key_concatenation_repeat1,
    ACTIONS(431), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(429), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2097] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(435), 1,
      sym__concat_pf_dot,
    STATE(123), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(352), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(350), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2168] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(438), 1,
      sym__concat,
    STATE(124), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(276), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(274), 49,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2239] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(445), 1,
      sym__eq_sep_concat,
    STATE(125), 1,
      aux_sym__eq_sep_key_concatenation_repeat1,
    ACTIONS(443), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(441), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2310] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(452), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(126), 1,
      aux_sym_tmp_eval_arg_repeat1,
    ACTIONS(450), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(448), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2381] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(459), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(126), 1,
      aux_sym_tmp_eval_arg_repeat1,
    ACTIONS(457), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(455), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2452] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(461), 1,
      sym__concat_pf_dot,
    STATE(123), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(359), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(357), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2523] = 4,
    ACTIONS(3), 1,
      sym__comment,
    STATE(128), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(344), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(342), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2592] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(433), 1,
      sym__eq_sep_concat,
    STATE(122), 1,
      aux_sym__eq_sep_key_concatenation_repeat1,
    ACTIONS(465), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(463), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2663] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(471), 1,
      sym__concat_pf_dot,
    STATE(131), 1,
      aux_sym_pf_dot_args_repeat1,
    ACTIONS(469), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(467), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2734] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(294), 1,
      sym__eq_sep_concat,
    ACTIONS(478), 1,
      sym__concat,
    STATE(434), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(476), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(474), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2807] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(484), 1,
      anon_sym_COMMA,
    STATE(133), 1,
      aux_sym_tmp_eval_args_repeat1,
    ACTIONS(482), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(480), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2877] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(371), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(369), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2943] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(491), 1,
      anon_sym_LPAREN,
    STATE(198), 1,
      sym_macro_call_full_content,
    ACTIONS(489), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(487), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3013] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(340), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(338), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3079] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(308), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(306), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3145] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(497), 1,
      anon_sym_COMMA,
    STATE(141), 1,
      aux_sym_tmp_eval_args_repeat1,
    ACTIONS(495), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(493), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3215] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(503), 1,
      sym__eq_sep_concat,
    STATE(139), 1,
      aux_sym__eq_sep_val_concatenation_repeat1,
    ACTIONS(501), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(499), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3285] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(320), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(318), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3351] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(497), 1,
      anon_sym_COMMA,
    STATE(133), 1,
      aux_sym_tmp_eval_args_repeat1,
    ACTIONS(508), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(506), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3421] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(512), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(510), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3487] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(310), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3553] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(276), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(274), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3619] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(310), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3685] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(310), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3751] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(443), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(441), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3817] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(310), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3883] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(310), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3949] = 3,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(310), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    ACTIONS(312), 56,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4015] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(336), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(334), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4081] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(308), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(306), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4147] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(320), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(318), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4213] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(316), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(314), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4279] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(310), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4345] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(518), 1,
      sym__eq_sep_concat,
    STATE(139), 1,
      aux_sym__eq_sep_val_concatenation_repeat1,
    ACTIONS(516), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(514), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4415] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(316), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(314), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4481] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(324), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(322), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4547] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(344), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(342), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4613] = 3,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(310), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    ACTIONS(312), 56,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4679] = 8,
    ACTIONS(392), 1,
      sym_file_descriptor,
    ACTIONS(398), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(520), 1,
      sym_grep_specifier_identifier,
    ACTIONS(522), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(524), 1,
      anon_sym_BQUOTE,
    STATE(163), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(394), 51,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
  [4755] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(336), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(334), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4821] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(410), 1,
      sym_file_descriptor,
    ACTIONS(526), 1,
      sym_grep_specifier_identifier,
    ACTIONS(529), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(532), 1,
      anon_sym_BQUOTE,
    STATE(163), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(412), 52,
      anon_sym_TILDE,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
  [4895] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(352), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(350), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4961] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(304), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(302), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5027] = 7,
    ACTIONS(392), 1,
      sym_file_descriptor,
    ACTIONS(398), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(520), 1,
      sym_grep_specifier_identifier,
    ACTIONS(522), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(163), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(394), 51,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [5100] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(539), 1,
      anon_sym_COLON,
    ACTIONS(537), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(535), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5167] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(545), 1,
      anon_sym_COLON,
    ACTIONS(543), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(541), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5234] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(551), 1,
      anon_sym_COLON,
    ACTIONS(549), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(547), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5301] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(296), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(294), 49,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5366] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(555), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(553), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5431] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(559), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(557), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5496] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(563), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(561), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5561] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(567), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(565), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5626] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(501), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(499), 49,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5691] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(482), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(480), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5756] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(465), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(463), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5821] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(571), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(569), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5886] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(577), 1,
      anon_sym_EQ,
    ACTIONS(575), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(573), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5953] = 53,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(581), 1,
      anon_sym_TILDE,
    ACTIONS(583), 1,
      anon_sym_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPEH,
    ACTIONS(587), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(589), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(591), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(593), 1,
      anon_sym_AT_AT,
    ACTIONS(595), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(597), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(599), 1,
      anon_sym_AT_ATC,
    ACTIONS(601), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(603), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(605), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(607), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(609), 1,
      anon_sym_AT_ATt,
    ACTIONS(611), 1,
      anon_sym_AT_ATb,
    ACTIONS(613), 1,
      anon_sym_AT_ATi,
    ACTIONS(615), 1,
      anon_sym_AT_ATii,
    ACTIONS(617), 1,
      anon_sym_AT_ATiS,
    ACTIONS(619), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(621), 1,
      anon_sym_AT_ATis,
    ACTIONS(623), 1,
      anon_sym_AT_ATiz,
    ACTIONS(625), 1,
      anon_sym_AT_ATf,
    ACTIONS(627), 1,
      anon_sym_AT_ATF,
    ACTIONS(629), 1,
      anon_sym_AT_ATom,
    ACTIONS(631), 1,
      anon_sym_AT_ATdm,
    ACTIONS(633), 1,
      anon_sym_AT_ATr,
    ACTIONS(635), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(637), 1,
      anon_sym_AT,
    ACTIONS(639), 1,
      anon_sym_AT_BANG,
    ACTIONS(641), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(643), 1,
      anon_sym_ATa_COLON,
    ACTIONS(645), 1,
      anon_sym_ATb_COLON,
    ACTIONS(647), 1,
      anon_sym_ATB_COLON,
    ACTIONS(649), 1,
      anon_sym_ATe_COLON,
    ACTIONS(651), 1,
      anon_sym_ATF_COLON,
    ACTIONS(653), 1,
      anon_sym_ATi_COLON,
    ACTIONS(655), 1,
      anon_sym_ATk_COLON,
    ACTIONS(657), 1,
      anon_sym_ATo_COLON,
    ACTIONS(659), 1,
      anon_sym_ATr_COLON,
    ACTIONS(661), 1,
      anon_sym_ATf_COLON,
    ACTIONS(663), 1,
      anon_sym_ATs_COLON,
    ACTIONS(665), 1,
      anon_sym_ATv_COLON,
    ACTIONS(667), 1,
      anon_sym_ATx_COLON,
    ACTIONS(669), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(671), 1,
      anon_sym_GT,
    ACTIONS(673), 1,
      anon_sym_GT_GT,
    ACTIONS(675), 1,
      sym_html_redirect_operator,
    ACTIONS(677), 1,
      sym_html_append_operator,
    ACTIONS(679), 1,
      sym_file_descriptor,
    STATE(312), 3,
      sym__redirect_operator,
      sym_fdn_redirect_operator,
      sym_fdn_append_operator,
    ACTIONS(579), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [6118] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(683), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(681), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6182] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(687), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(685), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6246] = 3,
    ACTIONS(310), 1,
      sym_file_descriptor,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(312), 55,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [6310] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(57), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(55), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6374] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(691), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(689), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6438] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(695), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(693), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6502] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(699), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(697), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6566] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(703), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(701), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6630] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(707), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(705), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6694] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(711), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(709), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6758] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(715), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(713), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6822] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(721), 1,
      anon_sym_EQ,
    ACTIONS(719), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(717), 47,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [6888] = 4,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(723), 1,
      aux_sym__interpret_stmt_token2,
    ACTIONS(123), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    ACTIONS(125), 53,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [6954] = 3,
    ACTIONS(310), 1,
      sym_file_descriptor,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(312), 55,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [7018] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(727), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(725), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7082] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(731), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(729), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7146] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(735), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(733), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7210] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(739), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(737), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7274] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(743), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(741), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7338] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(747), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(745), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7402] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(751), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(749), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7466] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(755), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(753), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7530] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(755), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(753), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7594] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(394), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(392), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7658] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(759), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(757), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7722] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(763), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(761), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7786] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(767), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(765), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7850] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(771), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(769), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7914] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(775), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(773), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7978] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(781), 1,
      sym__concat_pf_dot,
    ACTIONS(779), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(777), 47,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [8044] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(785), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(783), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8108] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(789), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(787), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8172] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(793), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(791), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8236] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(797), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(795), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8300] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(801), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(799), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8364] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(805), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(803), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8428] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(809), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(807), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8492] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(813), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(811), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8556] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(817), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(815), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8620] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(821), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(819), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8684] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(825), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(823), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8748] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(829), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(827), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8812] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(833), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(831), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8876] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(837), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(835), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8940] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(841), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(839), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9004] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(845), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(843), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9068] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(849), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(847), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9132] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(853), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(851), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9196] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(857), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(855), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9260] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(861), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(859), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9324] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(865), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(863), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9388] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(869), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(867), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9452] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(61), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(59), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9516] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(873), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(871), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9580] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(877), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(875), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9644] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(687), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(685), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9708] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(687), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(685), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9772] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(687), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(685), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9836] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(881), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(879), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9900] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(885), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(883), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9964] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(687), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(685), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10028] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(889), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(887), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10092] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(893), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(891), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10156] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(897), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(895), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10220] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(476), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(474), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10284] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(901), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(899), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10348] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(905), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(903), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10412] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(687), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(685), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10476] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(909), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(907), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10540] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(913), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(911), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10604] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(917), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(915), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10668] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(921), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(919), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10732] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(925), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(923), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10796] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(929), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(927), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10860] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(687), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(685), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10924] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(933), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(931), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10988] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(687), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(685), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11052] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(937), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(935), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11116] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(941), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(939), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11180] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(945), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(943), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11244] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(949), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(947), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11308] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(953), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(951), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11372] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(687), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(685), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11436] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(957), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(955), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11500] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(961), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(959), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11564] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(965), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(963), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11628] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(969), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(967), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11692] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(973), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(971), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11756] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(977), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(975), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11820] = 53,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(583), 1,
      anon_sym_PIPE,
    ACTIONS(585), 1,
      anon_sym_PIPEH,
    ACTIONS(587), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(589), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(591), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(593), 1,
      anon_sym_AT_AT,
    ACTIONS(595), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(597), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(599), 1,
      anon_sym_AT_ATC,
    ACTIONS(601), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(603), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(605), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(607), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(609), 1,
      anon_sym_AT_ATt,
    ACTIONS(611), 1,
      anon_sym_AT_ATb,
    ACTIONS(613), 1,
      anon_sym_AT_ATi,
    ACTIONS(615), 1,
      anon_sym_AT_ATii,
    ACTIONS(617), 1,
      anon_sym_AT_ATiS,
    ACTIONS(619), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(621), 1,
      anon_sym_AT_ATis,
    ACTIONS(623), 1,
      anon_sym_AT_ATiz,
    ACTIONS(625), 1,
      anon_sym_AT_ATf,
    ACTIONS(627), 1,
      anon_sym_AT_ATF,
    ACTIONS(629), 1,
      anon_sym_AT_ATom,
    ACTIONS(631), 1,
      anon_sym_AT_ATdm,
    ACTIONS(633), 1,
      anon_sym_AT_ATr,
    ACTIONS(635), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(637), 1,
      anon_sym_AT,
    ACTIONS(639), 1,
      anon_sym_AT_BANG,
    ACTIONS(641), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(643), 1,
      anon_sym_ATa_COLON,
    ACTIONS(645), 1,
      anon_sym_ATb_COLON,
    ACTIONS(647), 1,
      anon_sym_ATB_COLON,
    ACTIONS(649), 1,
      anon_sym_ATe_COLON,
    ACTIONS(651), 1,
      anon_sym_ATF_COLON,
    ACTIONS(653), 1,
      anon_sym_ATi_COLON,
    ACTIONS(655), 1,
      anon_sym_ATk_COLON,
    ACTIONS(657), 1,
      anon_sym_ATo_COLON,
    ACTIONS(659), 1,
      anon_sym_ATr_COLON,
    ACTIONS(661), 1,
      anon_sym_ATf_COLON,
    ACTIONS(663), 1,
      anon_sym_ATs_COLON,
    ACTIONS(665), 1,
      anon_sym_ATv_COLON,
    ACTIONS(667), 1,
      anon_sym_ATx_COLON,
    ACTIONS(669), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(671), 1,
      anon_sym_GT,
    ACTIONS(673), 1,
      anon_sym_GT_GT,
    ACTIONS(675), 1,
      sym_html_redirect_operator,
    ACTIONS(677), 1,
      sym_html_append_operator,
    ACTIONS(679), 1,
      sym_file_descriptor,
    ACTIONS(979), 1,
      anon_sym_TILDE,
    ACTIONS(579), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(312), 3,
      sym__redirect_operator,
      sym_fdn_redirect_operator,
      sym_fdn_append_operator,
  [11983] = 53,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(585), 1,
      anon_sym_PIPEH,
    ACTIONS(587), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(599), 1,
      anon_sym_AT_ATC,
    ACTIONS(601), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(603), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(605), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(607), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(609), 1,
      anon_sym_AT_ATt,
    ACTIONS(611), 1,
      anon_sym_AT_ATb,
    ACTIONS(613), 1,
      anon_sym_AT_ATi,
    ACTIONS(615), 1,
      anon_sym_AT_ATii,
    ACTIONS(617), 1,
      anon_sym_AT_ATiS,
    ACTIONS(619), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(621), 1,
      anon_sym_AT_ATis,
    ACTIONS(623), 1,
      anon_sym_AT_ATiz,
    ACTIONS(625), 1,
      anon_sym_AT_ATf,
    ACTIONS(627), 1,
      anon_sym_AT_ATF,
    ACTIONS(629), 1,
      anon_sym_AT_ATom,
    ACTIONS(631), 1,
      anon_sym_AT_ATdm,
    ACTIONS(633), 1,
      anon_sym_AT_ATr,
    ACTIONS(641), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(643), 1,
      anon_sym_ATa_COLON,
    ACTIONS(647), 1,
      anon_sym_ATB_COLON,
    ACTIONS(649), 1,
      anon_sym_ATe_COLON,
    ACTIONS(651), 1,
      anon_sym_ATF_COLON,
    ACTIONS(655), 1,
      anon_sym_ATk_COLON,
    ACTIONS(659), 1,
      anon_sym_ATr_COLON,
    ACTIONS(661), 1,
      anon_sym_ATf_COLON,
    ACTIONS(663), 1,
      anon_sym_ATs_COLON,
    ACTIONS(665), 1,
      anon_sym_ATv_COLON,
    ACTIONS(667), 1,
      anon_sym_ATx_COLON,
    ACTIONS(669), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(671), 1,
      anon_sym_GT,
    ACTIONS(673), 1,
      anon_sym_GT_GT,
    ACTIONS(675), 1,
      sym_html_redirect_operator,
    ACTIONS(677), 1,
      sym_html_append_operator,
    ACTIONS(679), 1,
      sym_file_descriptor,
    ACTIONS(981), 1,
      anon_sym_TILDE,
    ACTIONS(983), 1,
      anon_sym_PIPE,
    ACTIONS(985), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(987), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(989), 1,
      anon_sym_AT_AT,
    ACTIONS(991), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(993), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(995), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(997), 1,
      anon_sym_AT,
    ACTIONS(999), 1,
      anon_sym_AT_BANG,
    ACTIONS(1001), 1,
      anon_sym_ATb_COLON,
    ACTIONS(1003), 1,
      anon_sym_ATi_COLON,
    ACTIONS(1005), 1,
      anon_sym_ATo_COLON,
    ACTIONS(579), 2,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(312), 3,
      sym__redirect_operator,
      sym_fdn_redirect_operator,
      sym_fdn_append_operator,
  [12146] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(585), 1,
      anon_sym_PIPEH,
    ACTIONS(587), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(589), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(591), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(593), 1,
      anon_sym_AT_AT,
    ACTIONS(595), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(597), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(599), 1,
      anon_sym_AT_ATC,
    ACTIONS(601), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(603), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(605), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(607), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(609), 1,
      anon_sym_AT_ATt,
    ACTIONS(611), 1,
      anon_sym_AT_ATb,
    ACTIONS(613), 1,
      anon_sym_AT_ATi,
    ACTIONS(615), 1,
      anon_sym_AT_ATii,
    ACTIONS(617), 1,
      anon_sym_AT_ATiS,
    ACTIONS(619), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(621), 1,
      anon_sym_AT_ATis,
    ACTIONS(623), 1,
      anon_sym_AT_ATiz,
    ACTIONS(625), 1,
      anon_sym_AT_ATf,
    ACTIONS(627), 1,
      anon_sym_AT_ATF,
    ACTIONS(629), 1,
      anon_sym_AT_ATom,
    ACTIONS(631), 1,
      anon_sym_AT_ATdm,
    ACTIONS(633), 1,
      anon_sym_AT_ATr,
    ACTIONS(635), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(637), 1,
      anon_sym_AT,
    ACTIONS(639), 1,
      anon_sym_AT_BANG,
    ACTIONS(641), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(643), 1,
      anon_sym_ATa_COLON,
    ACTIONS(645), 1,
      anon_sym_ATb_COLON,
    ACTIONS(647), 1,
      anon_sym_ATB_COLON,
    ACTIONS(649), 1,
      anon_sym_ATe_COLON,
    ACTIONS(651), 1,
      anon_sym_ATF_COLON,
    ACTIONS(653), 1,
      anon_sym_ATi_COLON,
    ACTIONS(655), 1,
      anon_sym_ATk_COLON,
    ACTIONS(657), 1,
      anon_sym_ATo_COLON,
    ACTIONS(659), 1,
      anon_sym_ATr_COLON,
    ACTIONS(661), 1,
      anon_sym_ATf_COLON,
    ACTIONS(663), 1,
      anon_sym_ATs_COLON,
    ACTIONS(665), 1,
      anon_sym_ATv_COLON,
    ACTIONS(667), 1,
      anon_sym_ATx_COLON,
    ACTIONS(669), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(1009), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(1007), 9,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [12295] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(585), 1,
      anon_sym_PIPEH,
    ACTIONS(587), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(589), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(591), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(593), 1,
      anon_sym_AT_AT,
    ACTIONS(595), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(597), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(599), 1,
      anon_sym_AT_ATC,
    ACTIONS(601), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(603), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(605), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(607), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(609), 1,
      anon_sym_AT_ATt,
    ACTIONS(611), 1,
      anon_sym_AT_ATb,
    ACTIONS(613), 1,
      anon_sym_AT_ATi,
    ACTIONS(615), 1,
      anon_sym_AT_ATii,
    ACTIONS(617), 1,
      anon_sym_AT_ATiS,
    ACTIONS(619), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(621), 1,
      anon_sym_AT_ATis,
    ACTIONS(623), 1,
      anon_sym_AT_ATiz,
    ACTIONS(625), 1,
      anon_sym_AT_ATf,
    ACTIONS(627), 1,
      anon_sym_AT_ATF,
    ACTIONS(629), 1,
      anon_sym_AT_ATom,
    ACTIONS(631), 1,
      anon_sym_AT_ATdm,
    ACTIONS(633), 1,
      anon_sym_AT_ATr,
    ACTIONS(635), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(637), 1,
      anon_sym_AT,
    ACTIONS(639), 1,
      anon_sym_AT_BANG,
    ACTIONS(641), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(643), 1,
      anon_sym_ATa_COLON,
    ACTIONS(645), 1,
      anon_sym_ATb_COLON,
    ACTIONS(647), 1,
      anon_sym_ATB_COLON,
    ACTIONS(649), 1,
      anon_sym_ATe_COLON,
    ACTIONS(651), 1,
      anon_sym_ATF_COLON,
    ACTIONS(653), 1,
      anon_sym_ATi_COLON,
    ACTIONS(655), 1,
      anon_sym_ATk_COLON,
    ACTIONS(657), 1,
      anon_sym_ATo_COLON,
    ACTIONS(659), 1,
      anon_sym_ATr_COLON,
    ACTIONS(661), 1,
      anon_sym_ATf_COLON,
    ACTIONS(663), 1,
      anon_sym_ATs_COLON,
    ACTIONS(665), 1,
      anon_sym_ATv_COLON,
    ACTIONS(667), 1,
      anon_sym_ATx_COLON,
    ACTIONS(669), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(1013), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(1011), 9,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [12444] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1015), 1,
      anon_sym_EQ,
    ACTIONS(719), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(717), 44,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12507] = 4,
    ACTIONS(123), 1,
      sym_file_descriptor,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1017), 1,
      aux_sym__interpret_stmt_token2,
    ACTIONS(125), 51,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12570] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1019), 1,
      sym__concat_pf_dot,
    ACTIONS(779), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(777), 44,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12633] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(585), 1,
      anon_sym_PIPEH,
    ACTIONS(587), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(599), 1,
      anon_sym_AT_ATC,
    ACTIONS(601), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(603), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(605), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(607), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(609), 1,
      anon_sym_AT_ATt,
    ACTIONS(611), 1,
      anon_sym_AT_ATb,
    ACTIONS(613), 1,
      anon_sym_AT_ATi,
    ACTIONS(615), 1,
      anon_sym_AT_ATii,
    ACTIONS(617), 1,
      anon_sym_AT_ATiS,
    ACTIONS(619), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(621), 1,
      anon_sym_AT_ATis,
    ACTIONS(623), 1,
      anon_sym_AT_ATiz,
    ACTIONS(625), 1,
      anon_sym_AT_ATf,
    ACTIONS(627), 1,
      anon_sym_AT_ATF,
    ACTIONS(629), 1,
      anon_sym_AT_ATom,
    ACTIONS(631), 1,
      anon_sym_AT_ATdm,
    ACTIONS(633), 1,
      anon_sym_AT_ATr,
    ACTIONS(641), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(643), 1,
      anon_sym_ATa_COLON,
    ACTIONS(647), 1,
      anon_sym_ATB_COLON,
    ACTIONS(649), 1,
      anon_sym_ATe_COLON,
    ACTIONS(651), 1,
      anon_sym_ATF_COLON,
    ACTIONS(655), 1,
      anon_sym_ATk_COLON,
    ACTIONS(659), 1,
      anon_sym_ATr_COLON,
    ACTIONS(661), 1,
      anon_sym_ATf_COLON,
    ACTIONS(663), 1,
      anon_sym_ATs_COLON,
    ACTIONS(665), 1,
      anon_sym_ATv_COLON,
    ACTIONS(667), 1,
      anon_sym_ATx_COLON,
    ACTIONS(669), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(985), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(987), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(989), 1,
      anon_sym_AT_AT,
    ACTIONS(991), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(993), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(995), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(997), 1,
      anon_sym_AT,
    ACTIONS(999), 1,
      anon_sym_AT_BANG,
    ACTIONS(1001), 1,
      anon_sym_ATb_COLON,
    ACTIONS(1003), 1,
      anon_sym_ATi_COLON,
    ACTIONS(1005), 1,
      anon_sym_ATo_COLON,
    ACTIONS(1013), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(1011), 6,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12779] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(585), 1,
      anon_sym_PIPEH,
    ACTIONS(587), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(599), 1,
      anon_sym_AT_ATC,
    ACTIONS(601), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(603), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(605), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(607), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(609), 1,
      anon_sym_AT_ATt,
    ACTIONS(611), 1,
      anon_sym_AT_ATb,
    ACTIONS(613), 1,
      anon_sym_AT_ATi,
    ACTIONS(615), 1,
      anon_sym_AT_ATii,
    ACTIONS(617), 1,
      anon_sym_AT_ATiS,
    ACTIONS(619), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(621), 1,
      anon_sym_AT_ATis,
    ACTIONS(623), 1,
      anon_sym_AT_ATiz,
    ACTIONS(625), 1,
      anon_sym_AT_ATf,
    ACTIONS(627), 1,
      anon_sym_AT_ATF,
    ACTIONS(629), 1,
      anon_sym_AT_ATom,
    ACTIONS(631), 1,
      anon_sym_AT_ATdm,
    ACTIONS(633), 1,
      anon_sym_AT_ATr,
    ACTIONS(641), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(643), 1,
      anon_sym_ATa_COLON,
    ACTIONS(647), 1,
      anon_sym_ATB_COLON,
    ACTIONS(649), 1,
      anon_sym_ATe_COLON,
    ACTIONS(651), 1,
      anon_sym_ATF_COLON,
    ACTIONS(655), 1,
      anon_sym_ATk_COLON,
    ACTIONS(659), 1,
      anon_sym_ATr_COLON,
    ACTIONS(661), 1,
      anon_sym_ATf_COLON,
    ACTIONS(663), 1,
      anon_sym_ATs_COLON,
    ACTIONS(665), 1,
      anon_sym_ATv_COLON,
    ACTIONS(667), 1,
      anon_sym_ATx_COLON,
    ACTIONS(669), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(985), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(987), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(989), 1,
      anon_sym_AT_AT,
    ACTIONS(991), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(993), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(995), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(997), 1,
      anon_sym_AT,
    ACTIONS(999), 1,
      anon_sym_AT_BANG,
    ACTIONS(1001), 1,
      anon_sym_ATb_COLON,
    ACTIONS(1003), 1,
      anon_sym_ATi_COLON,
    ACTIONS(1005), 1,
      anon_sym_ATo_COLON,
    ACTIONS(1009), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(1007), 6,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12925] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(279), 1,
      aux_sym_statements_repeat1,
    ACTIONS(1025), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
    ACTIONS(1023), 6,
      anon_sym_0,
      anon_sym_DOT,
      aux_sym__interpret_stmt_token1,
      aux_sym_pf_cmd_token1,
      anon_sym_DOT_DOT_DOT,
      aux_sym__dec_number_token2,
    ACTIONS(1021), 19,
      sym__cmd_identifier,
      sym__help_stmt,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      aux_sym_number_stmt_token1,
      aux_sym__interpret_stmt_token3,
      anon_sym_DOT_LPAREN,
      anon_sym_DOT_SLASH,
      anon_sym_pfo,
      anon_sym_Cf,
      sym_pf_dot_cmd_identifier,
      sym_pf_dot_full_cmd_identifier,
      anon_sym_PERCENT,
      anon_sym_env,
      sym_system_identifier,
      sym_question_mark_identifier,
      sym_pointer_identifier,
      sym_macro_identifier,
      aux_sym__dec_number_token1,
  [12966] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1032), 1,
      anon_sym_SEMI,
    STATE(280), 1,
      aux_sym__statements_singleline_repeat1,
    ACTIONS(1030), 6,
      anon_sym_0,
      anon_sym_DOT,
      aux_sym__interpret_stmt_token1,
      aux_sym_pf_cmd_token1,
      anon_sym_DOT_DOT_DOT,
      aux_sym__dec_number_token2,
    ACTIONS(1028), 18,
      sym__cmd_identifier,
      sym__help_stmt,
      anon_sym_DQUOTE,
      aux_sym_number_stmt_token1,
      aux_sym__interpret_stmt_token3,
      anon_sym_DOT_LPAREN,
      anon_sym_DOT_SLASH,
      anon_sym_pfo,
      anon_sym_Cf,
      sym_pf_dot_cmd_identifier,
      sym_pf_dot_full_cmd_identifier,
      anon_sym_PERCENT,
      anon_sym_env,
      sym_system_identifier,
      sym_question_mark_identifier,
      sym_pointer_identifier,
      sym_macro_identifier,
      aux_sym__dec_number_token1,
  [13004] = 15,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(153), 1,
      anon_sym_DQUOTE,
    ACTIONS(157), 1,
      anon_sym_DOLLAR,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_COMMA,
    ACTIONS(163), 1,
      anon_sym_SQUOTE,
    ACTIONS(165), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1035), 1,
      anon_sym_RPAREN,
    ACTIONS(1037), 1,
      aux_sym_arg_identifier_token1,
    STATE(247), 1,
      sym_macro_call_content,
    STATE(351), 1,
      sym_concatenation,
    STATE(466), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(325), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13056] = 15,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(153), 1,
      anon_sym_DQUOTE,
    ACTIONS(157), 1,
      anon_sym_DOLLAR,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_COMMA,
    ACTIONS(163), 1,
      anon_sym_SQUOTE,
    ACTIONS(165), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1037), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1039), 1,
      anon_sym_RPAREN,
    ACTIONS(1041), 1,
      anon_sym_SEMI,
    STATE(351), 1,
      sym_concatenation,
    STATE(458), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(325), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13108] = 15,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(153), 1,
      anon_sym_DQUOTE,
    ACTIONS(157), 1,
      anon_sym_DOLLAR,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_COMMA,
    ACTIONS(163), 1,
      anon_sym_SQUOTE,
    ACTIONS(165), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1035), 1,
      anon_sym_RPAREN,
    ACTIONS(1037), 1,
      aux_sym_arg_identifier_token1,
    STATE(203), 1,
      sym_macro_call_content,
    STATE(351), 1,
      sym_concatenation,
    STATE(466), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(325), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13160] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1043), 1,
      anon_sym_DQUOTE,
    ACTIONS(1046), 1,
      anon_sym_DOLLAR,
    ACTIONS(1049), 1,
      anon_sym_LPAREN,
    ACTIONS(1052), 1,
      anon_sym_COMMA,
    ACTIONS(1055), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1058), 1,
      anon_sym_SQUOTE,
    ACTIONS(1061), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1064), 1,
      anon_sym_BQUOTE,
    STATE(351), 1,
      sym_concatenation,
    ACTIONS(191), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(284), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(325), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13207] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(153), 1,
      anon_sym_DQUOTE,
    ACTIONS(157), 1,
      anon_sym_DOLLAR,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_COMMA,
    ACTIONS(163), 1,
      anon_sym_SQUOTE,
    ACTIONS(165), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1037), 1,
      aux_sym_arg_identifier_token1,
    STATE(351), 1,
      sym_concatenation,
    ACTIONS(216), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(284), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(325), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13254] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(227), 1,
      sym_args,
    STATE(57), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13300] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(216), 1,
      sym_args,
    STATE(71), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13346] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(221), 1,
      sym_args,
    STATE(71), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13392] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(203), 1,
      sym_args,
    STATE(71), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13438] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(225), 1,
      sym_args,
    STATE(57), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13484] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(153), 1,
      anon_sym_DQUOTE,
    ACTIONS(157), 1,
      anon_sym_DOLLAR,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_COMMA,
    ACTIONS(163), 1,
      anon_sym_SQUOTE,
    ACTIONS(165), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1037), 1,
      aux_sym_arg_identifier_token1,
    STATE(351), 1,
      sym_concatenation,
    STATE(504), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(325), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13530] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(225), 1,
      sym_args,
    STATE(71), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13576] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(221), 1,
      sym_args,
    STATE(57), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13622] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(227), 1,
      sym_args,
    STATE(71), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13668] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(240), 1,
      sym_args,
    STATE(71), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13714] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(217), 1,
      sym_args,
    STATE(71), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13760] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(218), 1,
      sym_args,
    STATE(71), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13806] = 14,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1069), 1,
      anon_sym_DQUOTE,
    ACTIONS(1071), 1,
      anon_sym_DOLLAR,
    ACTIONS(1073), 1,
      anon_sym_LPAREN,
    ACTIONS(1075), 1,
      anon_sym_COMMA,
    ACTIONS(1077), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1079), 1,
      anon_sym_SQUOTE,
    ACTIONS(1081), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1083), 1,
      anon_sym_BQUOTE,
    STATE(245), 1,
      sym__eq_sep_val_concatenation,
    STATE(246), 1,
      sym__eq_sep_val,
    STATE(449), 1,
      sym_arg,
    STATE(476), 1,
      sym_concatenation,
    STATE(132), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13854] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(153), 1,
      anon_sym_DQUOTE,
    ACTIONS(157), 1,
      anon_sym_DOLLAR,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_COMMA,
    ACTIONS(163), 1,
      anon_sym_SQUOTE,
    ACTIONS(165), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1037), 1,
      aux_sym_arg_identifier_token1,
    STATE(351), 1,
      sym_concatenation,
    STATE(487), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(325), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13900] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(153), 1,
      anon_sym_DQUOTE,
    ACTIONS(157), 1,
      anon_sym_DOLLAR,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_COMMA,
    ACTIONS(163), 1,
      anon_sym_SQUOTE,
    ACTIONS(165), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1037), 1,
      aux_sym_arg_identifier_token1,
    STATE(351), 1,
      sym_concatenation,
    STATE(501), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(325), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13946] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(218), 1,
      sym_args,
    STATE(57), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13992] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(217), 1,
      sym_args,
    STATE(57), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14038] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(153), 1,
      anon_sym_DQUOTE,
    ACTIONS(157), 1,
      anon_sym_DOLLAR,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_COMMA,
    ACTIONS(163), 1,
      anon_sym_SQUOTE,
    ACTIONS(165), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1037), 1,
      aux_sym_arg_identifier_token1,
    STATE(351), 1,
      sym_concatenation,
    STATE(485), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(325), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14084] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(153), 1,
      anon_sym_DQUOTE,
    ACTIONS(157), 1,
      anon_sym_DOLLAR,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_COMMA,
    ACTIONS(163), 1,
      anon_sym_SQUOTE,
    ACTIONS(165), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1037), 1,
      aux_sym_arg_identifier_token1,
    STATE(351), 1,
      sym_concatenation,
    STATE(491), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(325), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14130] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(216), 1,
      sym_args,
    STATE(57), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14176] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(153), 1,
      anon_sym_DQUOTE,
    ACTIONS(157), 1,
      anon_sym_DOLLAR,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_COMMA,
    ACTIONS(163), 1,
      anon_sym_SQUOTE,
    ACTIONS(165), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1037), 1,
      aux_sym_arg_identifier_token1,
    STATE(351), 1,
      sym_concatenation,
    STATE(495), 1,
      sym_args,
    STATE(285), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(325), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14222] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(203), 1,
      sym_args,
    STATE(57), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14268] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(240), 1,
      sym_args,
    STATE(57), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14314] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(224), 1,
      sym_arg,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14356] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(251), 1,
      sym_arg,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14398] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1069), 1,
      anon_sym_DQUOTE,
    ACTIONS(1071), 1,
      anon_sym_DOLLAR,
    ACTIONS(1073), 1,
      anon_sym_LPAREN,
    ACTIONS(1075), 1,
      anon_sym_COMMA,
    ACTIONS(1077), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1079), 1,
      anon_sym_SQUOTE,
    ACTIONS(1081), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1083), 1,
      anon_sym_BQUOTE,
    STATE(170), 1,
      sym_concatenation,
    STATE(175), 1,
      sym_arg,
    STATE(118), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14440] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(153), 1,
      anon_sym_DQUOTE,
    ACTIONS(157), 1,
      anon_sym_DOLLAR,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_COMMA,
    ACTIONS(163), 1,
      anon_sym_SQUOTE,
    ACTIONS(165), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1037), 1,
      aux_sym_arg_identifier_token1,
    STATE(351), 1,
      sym_concatenation,
    STATE(398), 1,
      sym_arg,
    STATE(325), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14482] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(232), 1,
      sym_arg,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14524] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(207), 1,
      sym_arg,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14566] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(231), 1,
      sym_arg,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14608] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(230), 1,
      sym_arg,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14650] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(229), 1,
      sym_arg,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14692] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(228), 1,
      sym_arg,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14734] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(226), 1,
      sym_arg,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14776] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(222), 1,
      sym_arg,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14818] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(253), 1,
      sym_arg,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14860] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(220), 1,
      sym_arg,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14902] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(98), 1,
      sym_concatenation,
    STATE(252), 1,
      sym_arg,
    STATE(80), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14944] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(283), 1,
      anon_sym_DOLLAR,
    ACTIONS(1085), 1,
      sym__concat,
    STATE(326), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(281), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [14971] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(296), 1,
      anon_sym_DOLLAR,
    ACTIONS(1085), 1,
      sym__concat,
    STATE(324), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(294), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [14998] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(276), 1,
      anon_sym_DOLLAR,
    ACTIONS(1087), 1,
      sym__concat,
    STATE(326), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(274), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15025] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 1,
      anon_sym_DOLLAR,
    ACTIONS(310), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15047] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(340), 1,
      anon_sym_DOLLAR,
    ACTIONS(338), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15069] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(320), 1,
      anon_sym_DOLLAR,
    ACTIONS(318), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15091] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(117), 1,
      anon_sym_SQUOTE,
    ACTIONS(119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(121), 1,
      anon_sym_BQUOTE,
    ACTIONS(1067), 1,
      aux_sym_arg_identifier_token1,
    STATE(84), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15127] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1069), 1,
      anon_sym_DQUOTE,
    ACTIONS(1071), 1,
      anon_sym_DOLLAR,
    ACTIONS(1073), 1,
      anon_sym_LPAREN,
    ACTIONS(1075), 1,
      anon_sym_COMMA,
    ACTIONS(1077), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1079), 1,
      anon_sym_SQUOTE,
    ACTIONS(1081), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1083), 1,
      anon_sym_BQUOTE,
    STATE(144), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15163] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1090), 1,
      anon_sym_DQUOTE,
    ACTIONS(1092), 1,
      anon_sym_DOLLAR,
    ACTIONS(1094), 1,
      anon_sym_LPAREN,
    ACTIONS(1096), 1,
      anon_sym_COMMA,
    ACTIONS(1098), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1100), 1,
      anon_sym_SQUOTE,
    ACTIONS(1102), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1104), 1,
      anon_sym_BQUOTE,
    STATE(462), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15199] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(324), 1,
      anon_sym_DOLLAR,
    ACTIONS(322), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15221] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(304), 1,
      anon_sym_DOLLAR,
    ACTIONS(302), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15243] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(175), 1,
      anon_sym_DQUOTE,
    ACTIONS(179), 1,
      anon_sym_DOLLAR,
    ACTIONS(181), 1,
      anon_sym_LPAREN,
    ACTIONS(183), 1,
      anon_sym_COMMA,
    ACTIONS(185), 1,
      anon_sym_SQUOTE,
    ACTIONS(187), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(189), 1,
      anon_sym_BQUOTE,
    ACTIONS(1106), 1,
      aux_sym_arg_identifier_token1,
    STATE(407), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15279] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 1,
      anon_sym_DOLLAR,
    ACTIONS(310), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15301] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(316), 1,
      anon_sym_DOLLAR,
    ACTIONS(314), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15323] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(153), 1,
      anon_sym_DQUOTE,
    ACTIONS(157), 1,
      anon_sym_DOLLAR,
    ACTIONS(159), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_COMMA,
    ACTIONS(163), 1,
      anon_sym_SQUOTE,
    ACTIONS(165), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(167), 1,
      anon_sym_BQUOTE,
    ACTIONS(1037), 1,
      aux_sym_arg_identifier_token1,
    STATE(340), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15359] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(334), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15381] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(276), 1,
      anon_sym_DOLLAR,
    ACTIONS(274), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15403] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(308), 1,
      anon_sym_DOLLAR,
    ACTIONS(306), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15425] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(187), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(189), 1,
      anon_sym_BQUOTE,
    ACTIONS(234), 1,
      anon_sym_RPAREN,
    ACTIONS(1108), 1,
      anon_sym_DOLLAR,
    ACTIONS(1110), 1,
      anon_sym_LPAREN,
    ACTIONS(1112), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(399), 1,
      sym_pf_concatenation,
    STATE(352), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(376), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15460] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1114), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(115), 1,
      sym_pf_concatenation,
    STATE(265), 1,
      sym_pf_args,
    STATE(72), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(101), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15495] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(187), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(189), 1,
      anon_sym_BQUOTE,
    ACTIONS(1108), 1,
      anon_sym_DOLLAR,
    ACTIONS(1110), 1,
      anon_sym_LPAREN,
    ACTIONS(1112), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(399), 1,
      sym_pf_concatenation,
    STATE(498), 1,
      sym_pf_args,
    STATE(342), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(376), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15530] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1114), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(115), 1,
      sym_pf_concatenation,
    STATE(262), 1,
      sym_pf_args,
    STATE(94), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(101), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15565] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1114), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(115), 1,
      sym_pf_concatenation,
    STATE(189), 1,
      sym_pf_args,
    STATE(94), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(101), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15600] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(187), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(189), 1,
      anon_sym_BQUOTE,
    ACTIONS(1108), 1,
      anon_sym_DOLLAR,
    ACTIONS(1110), 1,
      anon_sym_LPAREN,
    ACTIONS(1112), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(399), 1,
      sym_pf_concatenation,
    STATE(506), 1,
      sym_pf_args,
    STATE(342), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(376), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15635] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1114), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(115), 1,
      sym_pf_concatenation,
    STATE(265), 1,
      sym_pf_args,
    STATE(94), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(101), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15670] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1114), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(115), 1,
      sym_pf_concatenation,
    STATE(189), 1,
      sym_pf_args,
    STATE(72), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(101), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15705] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1114), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(115), 1,
      sym_pf_concatenation,
    STATE(262), 1,
      sym_pf_args,
    STATE(72), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(101), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15740] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(296), 1,
      anon_sym_DOLLAR,
    ACTIONS(294), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15761] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(252), 1,
      anon_sym_RPAREN,
    ACTIONS(1116), 1,
      anon_sym_DOLLAR,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    ACTIONS(1122), 1,
      aux_sym_pf_arg_identifier_token1,
    ACTIONS(1125), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1128), 1,
      anon_sym_BQUOTE,
    STATE(399), 1,
      sym_pf_concatenation,
    STATE(352), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(376), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15796] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(240), 1,
      anon_sym_DQUOTE,
    ACTIONS(246), 1,
      anon_sym_SQUOTE,
    ACTIONS(248), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(250), 1,
      anon_sym_BQUOTE,
    ACTIONS(1131), 1,
      sym__eq_sep_key_identifier,
    STATE(177), 1,
      sym__eq_sep_key_concatenation,
    STATE(179), 1,
      sym__eq_sep_key,
    STATE(195), 1,
      sym_eq_sep_args,
    STATE(130), 4,
      sym__eq_sep_key_single,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15830] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1133), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR,
    ACTIONS(1137), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1139), 1,
      anon_sym_BQUOTE,
    STATE(58), 1,
      sym_pf_dot_arg,
    STATE(103), 1,
      sym_pf_dot_concatenation,
    STATE(190), 1,
      sym_pf_new_args,
    STATE(191), 1,
      sym_pf_dot_cmd_args,
    STATE(192), 1,
      sym_pf_dot_args,
    STATE(95), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15866] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1133), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR,
    ACTIONS(1137), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1139), 1,
      anon_sym_BQUOTE,
    STATE(73), 1,
      sym_pf_dot_arg,
    STATE(103), 1,
      sym_pf_dot_concatenation,
    STATE(190), 1,
      sym_pf_new_args,
    STATE(191), 1,
      sym_pf_dot_cmd_args,
    STATE(274), 1,
      sym_pf_dot_args,
    STATE(95), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15902] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1141), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1143), 1,
      anon_sym_DOLLAR,
    ACTIONS(1145), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1147), 1,
      anon_sym_BQUOTE,
    STATE(119), 1,
      sym_pf_dot_arg,
    STATE(159), 1,
      sym_pf_dot_concatenation,
    STATE(191), 1,
      sym_pf_dot_cmd_args,
    STATE(192), 1,
      sym_pf_dot_args,
    STATE(129), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15935] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1141), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1143), 1,
      anon_sym_DOLLAR,
    ACTIONS(1145), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1147), 1,
      anon_sym_BQUOTE,
    STATE(119), 1,
      sym_pf_dot_arg,
    STATE(159), 1,
      sym_pf_dot_concatenation,
    STATE(191), 1,
      sym_pf_dot_cmd_args,
    STATE(274), 1,
      sym_pf_dot_args,
    STATE(129), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15968] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(187), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(189), 1,
      anon_sym_BQUOTE,
    ACTIONS(1108), 1,
      anon_sym_DOLLAR,
    ACTIONS(1110), 1,
      anon_sym_LPAREN,
    ACTIONS(1112), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(394), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15993] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1114), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(110), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [16018] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(240), 1,
      anon_sym_DQUOTE,
    ACTIONS(246), 1,
      anon_sym_SQUOTE,
    ACTIONS(248), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(250), 1,
      anon_sym_BQUOTE,
    ACTIONS(1149), 1,
      sym__eq_sep_key_identifier,
    STATE(147), 4,
      sym__eq_sep_key_single,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [16043] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1141), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1143), 1,
      anon_sym_DOLLAR,
    ACTIONS(1145), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1147), 1,
      anon_sym_BQUOTE,
    STATE(142), 1,
      sym_pf_dot_arg,
    STATE(159), 1,
      sym_pf_dot_concatenation,
    STATE(129), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [16070] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1151), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1157), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_BQUOTE,
    ACTIONS(1155), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(365), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16094] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1157), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_BQUOTE,
    ACTIONS(1161), 1,
      anon_sym_DQUOTE,
    ACTIONS(1163), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1165), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(374), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16118] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1157), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_BQUOTE,
    ACTIONS(1167), 1,
      anon_sym_DQUOTE,
    ACTIONS(1169), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1171), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(366), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16142] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1157), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_BQUOTE,
    ACTIONS(1163), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(374), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16166] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1157), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_BQUOTE,
    ACTIONS(1163), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1175), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(374), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16190] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1157), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_DQUOTE,
    ACTIONS(1179), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1181), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(378), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16214] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1157), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_BQUOTE,
    ACTIONS(1183), 1,
      anon_sym_DQUOTE,
    ACTIONS(1185), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1187), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(363), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16238] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1191), 1,
      anon_sym_DOLLAR,
    ACTIONS(1189), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16254] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1195), 1,
      anon_sym_DOLLAR,
    ACTIONS(1193), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16270] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1199), 1,
      anon_sym_DOLLAR,
    ACTIONS(1197), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16286] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1157), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_BQUOTE,
    ACTIONS(1163), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1201), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(374), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16310] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(375), 1,
      anon_sym_DOLLAR,
    ACTIONS(1203), 1,
      sym__concat,
    STATE(379), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(373), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16330] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1205), 1,
      anon_sym_DQUOTE,
    ACTIONS(1207), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1213), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1216), 1,
      anon_sym_BQUOTE,
    ACTIONS(1210), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(374), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16354] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1157), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_BQUOTE,
    ACTIONS(1219), 1,
      anon_sym_DQUOTE,
    ACTIONS(1221), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1223), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(372), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16378] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(365), 1,
      anon_sym_DOLLAR,
    ACTIONS(1203), 1,
      sym__concat,
    STATE(373), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(363), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16398] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1227), 1,
      anon_sym_DOLLAR,
    ACTIONS(1225), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16414] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1157), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_BQUOTE,
    ACTIONS(1163), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1229), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(374), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16438] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(379), 1,
      anon_sym_DOLLAR,
    ACTIONS(1231), 1,
      sym__concat,
    STATE(379), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(377), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16458] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1157), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_DQUOTE,
    ACTIONS(1236), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1238), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(381), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16482] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1157), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1159), 1,
      anon_sym_BQUOTE,
    ACTIONS(1163), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1240), 1,
      anon_sym_DQUOTE,
    ACTIONS(1165), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(374), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16506] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1244), 1,
      anon_sym_DOLLAR,
    ACTIONS(1242), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16522] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(283), 1,
      anon_sym_DOLLAR,
    ACTIONS(1246), 1,
      sym__concat,
    STATE(387), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(281), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16541] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 1,
      anon_sym_DOLLAR,
    ACTIONS(310), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16556] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(386), 1,
      anon_sym_DOLLAR,
    ACTIONS(384), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16571] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 1,
      anon_sym_DOLLAR,
    ACTIONS(310), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16586] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(276), 1,
      anon_sym_DOLLAR,
    ACTIONS(1248), 1,
      sym__concat,
    STATE(387), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(274), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16605] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1133), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR,
    ACTIONS(1137), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1139), 1,
      anon_sym_BQUOTE,
    STATE(104), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [16626] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1141), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1143), 1,
      anon_sym_DOLLAR,
    ACTIONS(1145), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1147), 1,
      anon_sym_BQUOTE,
    STATE(164), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [16647] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(296), 1,
      anon_sym_DOLLAR,
    ACTIONS(1246), 1,
      sym__concat,
    STATE(383), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(294), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16666] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(390), 1,
      anon_sym_DOLLAR,
    ACTIONS(388), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16681] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(522), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(524), 1,
      anon_sym_BQUOTE,
    ACTIONS(1251), 1,
      sym_grep_specifier_identifier,
    ACTIONS(1253), 1,
      aux_sym_grep_specifier_token1,
    STATE(205), 1,
      sym_grep_specifier,
    STATE(161), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
  [16704] = 7,
    ACTIONS(400), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(402), 1,
      anon_sym_BQUOTE,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1253), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(1255), 1,
      sym_grep_specifier_identifier,
    STATE(205), 1,
      sym_grep_specifier,
    STATE(114), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
  [16727] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(379), 1,
      anon_sym_DOLLAR,
    ACTIONS(377), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16742] = 7,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(522), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(524), 1,
      anon_sym_BQUOTE,
    ACTIONS(1253), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(1257), 1,
      sym_grep_specifier_identifier,
    STATE(205), 1,
      sym_grep_specifier,
    STATE(166), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
  [16765] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(304), 1,
      anon_sym_DOLLAR,
    ACTIONS(302), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16779] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(334), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16793] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1259), 6,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [16805] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(365), 1,
      anon_sym_DOLLAR,
    ACTIONS(363), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16819] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(340), 1,
      anon_sym_DOLLAR,
    ACTIONS(338), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16833] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(308), 1,
      anon_sym_DOLLAR,
    ACTIONS(306), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16847] = 3,
    ACTIONS(310), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(312), 5,
      anon_sym_DQUOTE,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16861] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(320), 1,
      anon_sym_DOLLAR,
    ACTIONS(318), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16875] = 3,
    ACTIONS(310), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(312), 5,
      anon_sym_DQUOTE,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16889] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(316), 1,
      anon_sym_DOLLAR,
    ACTIONS(314), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16903] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(324), 1,
      anon_sym_DOLLAR,
    ACTIONS(322), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16917] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(276), 1,
      anon_sym_DOLLAR,
    ACTIONS(274), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16931] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1261), 1,
      ts_builtin_sym_end,
    STATE(408), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1263), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [16946] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1266), 1,
      ts_builtin_sym_end,
    STATE(408), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1268), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [16961] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(87), 1,
      ts_builtin_sym_end,
    STATE(412), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1268), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [16976] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1270), 1,
      ts_builtin_sym_end,
    STATE(409), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1268), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [16991] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1270), 1,
      ts_builtin_sym_end,
    STATE(408), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1268), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [17006] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(296), 1,
      anon_sym_DOLLAR,
    ACTIONS(294), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [17019] = 5,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1272), 1,
      anon_sym_SQUOTE,
    ACTIONS(1274), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1276), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(421), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17035] = 5,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1278), 1,
      anon_sym_SQUOTE,
    ACTIONS(1280), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1282), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(426), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17051] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1261), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [17061] = 5,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1284), 1,
      anon_sym_SQUOTE,
    ACTIONS(1286), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1288), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(419), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17077] = 5,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1290), 1,
      anon_sym_SQUOTE,
    ACTIONS(1292), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1295), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17093] = 5,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1298), 1,
      anon_sym_SQUOTE,
    ACTIONS(1300), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1302), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17109] = 5,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1300), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1302), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1304), 1,
      anon_sym_SQUOTE,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17125] = 5,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1300), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1302), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1306), 1,
      anon_sym_SQUOTE,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17141] = 5,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1300), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1302), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1308), 1,
      anon_sym_SQUOTE,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17157] = 5,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1310), 1,
      anon_sym_SQUOTE,
    ACTIONS(1312), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1314), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(428), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17173] = 5,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1316), 1,
      anon_sym_SQUOTE,
    ACTIONS(1318), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1320), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(422), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17189] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1322), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(127), 1,
      aux_sym_tmp_eval_arg_repeat1,
    STATE(138), 1,
      sym_tmp_eval_arg,
    STATE(223), 1,
      sym_tmp_eval_args,
  [17205] = 5,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1300), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1302), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1324), 1,
      anon_sym_SQUOTE,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17221] = 5,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1326), 1,
      anon_sym_SQUOTE,
    ACTIONS(1328), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1330), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(420), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17237] = 5,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1300), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1302), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1332), 1,
      anon_sym_SQUOTE,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17253] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1334), 1,
      anon_sym_RPAREN,
    ACTIONS(1336), 1,
      anon_sym_SEMI,
    STATE(431), 1,
      aux_sym_macro_content_repeat1,
  [17266] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1338), 1,
      anon_sym_RPAREN,
    ACTIONS(1340), 1,
      anon_sym_SEMI,
    STATE(446), 1,
      aux_sym__statements_singleline_repeat2,
  [17279] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1342), 1,
      anon_sym_RPAREN,
    ACTIONS(1344), 1,
      anon_sym_SEMI,
    STATE(431), 1,
      aux_sym_macro_content_repeat1,
  [17292] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(274), 1,
      sym__eq_sep_concat,
    ACTIONS(1347), 1,
      sym__concat,
    STATE(432), 1,
      aux_sym_concatenation_repeat1,
  [17305] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1336), 1,
      anon_sym_SEMI,
    ACTIONS(1350), 1,
      anon_sym_RPAREN,
    STATE(429), 1,
      aux_sym_macro_content_repeat1,
  [17318] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(281), 1,
      sym__eq_sep_concat,
    ACTIONS(478), 1,
      sym__concat,
    STATE(432), 1,
      aux_sym_concatenation_repeat1,
  [17331] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1336), 1,
      anon_sym_SEMI,
    ACTIONS(1350), 1,
      anon_sym_RPAREN,
    STATE(431), 1,
      aux_sym_macro_content_repeat1,
  [17344] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1352), 1,
      anon_sym_DOLLAR,
    ACTIONS(1354), 1,
      aux_sym_spec_arg_identifier_token1,
    STATE(91), 1,
      sym_spec_arg_identifier,
  [17357] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1340), 1,
      anon_sym_SEMI,
    ACTIONS(1356), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      aux_sym__statements_singleline_repeat2,
  [17370] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1358), 1,
      anon_sym_RPAREN,
    ACTIONS(1360), 1,
      anon_sym_SEMI,
    STATE(438), 1,
      aux_sym__statements_singleline_repeat2,
  [17383] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1358), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
  [17392] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1338), 1,
      anon_sym_BQUOTE,
    ACTIONS(1363), 1,
      anon_sym_SEMI,
    STATE(442), 1,
      aux_sym__statements_singleline_repeat2,
  [17405] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1322), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(127), 1,
      aux_sym_tmp_eval_arg_repeat1,
    STATE(176), 1,
      sym_tmp_eval_arg,
  [17418] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1363), 1,
      anon_sym_SEMI,
    ACTIONS(1365), 1,
      anon_sym_BQUOTE,
    STATE(448), 1,
      aux_sym__statements_singleline_repeat2,
  [17431] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1336), 1,
      anon_sym_SEMI,
    ACTIONS(1367), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      aux_sym_macro_content_repeat1,
  [17444] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1363), 1,
      anon_sym_SEMI,
    ACTIONS(1365), 1,
      anon_sym_BQUOTE,
    STATE(445), 1,
      aux_sym__statements_singleline_repeat2,
  [17457] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1356), 1,
      anon_sym_BQUOTE,
    ACTIONS(1363), 1,
      anon_sym_SEMI,
    STATE(448), 1,
      aux_sym__statements_singleline_repeat2,
  [17470] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1340), 1,
      anon_sym_SEMI,
    ACTIONS(1365), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      aux_sym__statements_singleline_repeat2,
  [17483] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1340), 1,
      anon_sym_SEMI,
    ACTIONS(1365), 1,
      anon_sym_RPAREN,
    STATE(437), 1,
      aux_sym__statements_singleline_repeat2,
  [17496] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1369), 1,
      anon_sym_SEMI,
    STATE(448), 1,
      aux_sym__statements_singleline_repeat2,
  [17509] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(518), 1,
      sym__eq_sep_concat,
    STATE(156), 1,
      aux_sym__eq_sep_val_concatenation_repeat1,
  [17519] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(318), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17527] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1372), 1,
      aux_sym__search_stmt_token1,
    STATE(250), 1,
      sym__search_stmt,
  [17537] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(310), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17545] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(314), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17553] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(322), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17561] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1374), 1,
      aux_sym__search_stmt_token1,
    STATE(250), 1,
      sym__search_stmt,
  [17571] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(338), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17579] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(310), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17587] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1376), 1,
      anon_sym_RPAREN,
    ACTIONS(1378), 1,
      anon_sym_SEMI,
  [17597] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(306), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17605] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1380), 1,
      anon_sym_GT,
    ACTIONS(1382), 1,
      anon_sym_GT_GT,
  [17615] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(334), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17623] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(274), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17631] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1342), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [17639] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(302), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17647] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1384), 1,
      anon_sym_RPAREN,
  [17654] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1386), 1,
      anon_sym_RPAREN,
  [17661] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1388), 1,
      anon_sym_RPAREN,
  [17668] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1390), 1,
      anon_sym_BQUOTE,
  [17675] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1392), 1,
      anon_sym_BQUOTE,
  [17682] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1394), 1,
      anon_sym_RPAREN,
  [17689] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1396), 1,
      anon_sym_BQUOTE,
  [17696] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1398), 1,
      anon_sym_RPAREN,
  [17703] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1400), 1,
      anon_sym_BQUOTE,
  [17710] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1402), 1,
      anon_sym_RPAREN,
  [17717] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1404), 1,
      anon_sym_BQUOTE,
  [17724] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(294), 1,
      sym__eq_sep_concat,
  [17731] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1406), 1,
      anon_sym_RPAREN,
  [17738] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1408), 1,
      anon_sym_BQUOTE,
  [17745] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1410), 1,
      anon_sym_RPAREN,
  [17752] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1412), 1,
      sym__concat,
  [17759] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1414), 1,
      sym__concat_pf_dot,
  [17766] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1416), 1,
      sym__concat,
  [17773] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1418), 1,
      anon_sym_BQUOTE,
  [17780] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1420), 1,
      anon_sym_RPAREN,
  [17787] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1422), 1,
      anon_sym_RPAREN,
  [17794] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1424), 1,
      anon_sym_BQUOTE,
  [17801] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1426), 1,
      anon_sym_RPAREN,
  [17808] = 2,
    ACTIONS(404), 1,
      sym__comment,
    ACTIONS(1428), 1,
      aux_sym_legacy_quoted_stmt_token1,
  [17815] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1430), 1,
      anon_sym_BQUOTE,
  [17822] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1432), 1,
      anon_sym_RPAREN,
  [17829] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1434), 1,
      anon_sym_RPAREN,
  [17836] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1436), 1,
      anon_sym_DOT,
  [17843] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1438), 1,
      anon_sym_BQUOTE,
  [17850] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1440), 1,
      anon_sym_RPAREN,
  [17857] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1442), 1,
      anon_sym_RPAREN,
  [17864] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1444), 1,
      ts_builtin_sym_end,
  [17871] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1446), 1,
      anon_sym_RPAREN,
  [17878] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1448), 1,
      anon_sym_RPAREN,
  [17885] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1450), 1,
      anon_sym_BQUOTE,
  [17892] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1452), 1,
      sym__concat_pf_dot,
  [17899] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1454), 1,
      anon_sym_RPAREN,
  [17906] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1456), 1,
      anon_sym_RPAREN,
  [17913] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1458), 1,
      anon_sym_DQUOTE,
  [17920] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1460), 1,
      anon_sym_RPAREN,
  [17927] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1462), 1,
      sym__concat,
  [17934] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1464), 1,
      anon_sym_RPAREN,
  [17941] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1466), 1,
      anon_sym_BQUOTE,
  [17948] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1468), 1,
      sym__concat_pf_dot,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(94)] = 0,
  [SMALL_STATE(95)] = 83,
  [SMALL_STATE(96)] = 156,
  [SMALL_STATE(97)] = 227,
  [SMALL_STATE(98)] = 302,
  [SMALL_STATE(99)] = 373,
  [SMALL_STATE(100)] = 448,
  [SMALL_STATE(101)] = 535,
  [SMALL_STATE(102)] = 609,
  [SMALL_STATE(103)] = 679,
  [SMALL_STATE(104)] = 749,
  [SMALL_STATE(105)] = 819,
  [SMALL_STATE(106)] = 889,
  [SMALL_STATE(107)] = 959,
  [SMALL_STATE(108)] = 1033,
  [SMALL_STATE(109)] = 1107,
  [SMALL_STATE(110)] = 1176,
  [SMALL_STATE(111)] = 1245,
  [SMALL_STATE(112)] = 1314,
  [SMALL_STATE(113)] = 1383,
  [SMALL_STATE(114)] = 1452,
  [SMALL_STATE(115)] = 1530,
  [SMALL_STATE(116)] = 1598,
  [SMALL_STATE(117)] = 1666,
  [SMALL_STATE(118)] = 1742,
  [SMALL_STATE(119)] = 1813,
  [SMALL_STATE(120)] = 1884,
  [SMALL_STATE(121)] = 1955,
  [SMALL_STATE(122)] = 2026,
  [SMALL_STATE(123)] = 2097,
  [SMALL_STATE(124)] = 2168,
  [SMALL_STATE(125)] = 2239,
  [SMALL_STATE(126)] = 2310,
  [SMALL_STATE(127)] = 2381,
  [SMALL_STATE(128)] = 2452,
  [SMALL_STATE(129)] = 2523,
  [SMALL_STATE(130)] = 2592,
  [SMALL_STATE(131)] = 2663,
  [SMALL_STATE(132)] = 2734,
  [SMALL_STATE(133)] = 2807,
  [SMALL_STATE(134)] = 2877,
  [SMALL_STATE(135)] = 2943,
  [SMALL_STATE(136)] = 3013,
  [SMALL_STATE(137)] = 3079,
  [SMALL_STATE(138)] = 3145,
  [SMALL_STATE(139)] = 3215,
  [SMALL_STATE(140)] = 3285,
  [SMALL_STATE(141)] = 3351,
  [SMALL_STATE(142)] = 3421,
  [SMALL_STATE(143)] = 3487,
  [SMALL_STATE(144)] = 3553,
  [SMALL_STATE(145)] = 3619,
  [SMALL_STATE(146)] = 3685,
  [SMALL_STATE(147)] = 3751,
  [SMALL_STATE(148)] = 3817,
  [SMALL_STATE(149)] = 3883,
  [SMALL_STATE(150)] = 3949,
  [SMALL_STATE(151)] = 4015,
  [SMALL_STATE(152)] = 4081,
  [SMALL_STATE(153)] = 4147,
  [SMALL_STATE(154)] = 4213,
  [SMALL_STATE(155)] = 4279,
  [SMALL_STATE(156)] = 4345,
  [SMALL_STATE(157)] = 4415,
  [SMALL_STATE(158)] = 4481,
  [SMALL_STATE(159)] = 4547,
  [SMALL_STATE(160)] = 4613,
  [SMALL_STATE(161)] = 4679,
  [SMALL_STATE(162)] = 4755,
  [SMALL_STATE(163)] = 4821,
  [SMALL_STATE(164)] = 4895,
  [SMALL_STATE(165)] = 4961,
  [SMALL_STATE(166)] = 5027,
  [SMALL_STATE(167)] = 5100,
  [SMALL_STATE(168)] = 5167,
  [SMALL_STATE(169)] = 5234,
  [SMALL_STATE(170)] = 5301,
  [SMALL_STATE(171)] = 5366,
  [SMALL_STATE(172)] = 5431,
  [SMALL_STATE(173)] = 5496,
  [SMALL_STATE(174)] = 5561,
  [SMALL_STATE(175)] = 5626,
  [SMALL_STATE(176)] = 5691,
  [SMALL_STATE(177)] = 5756,
  [SMALL_STATE(178)] = 5821,
  [SMALL_STATE(179)] = 5886,
  [SMALL_STATE(180)] = 5953,
  [SMALL_STATE(181)] = 6118,
  [SMALL_STATE(182)] = 6182,
  [SMALL_STATE(183)] = 6246,
  [SMALL_STATE(184)] = 6310,
  [SMALL_STATE(185)] = 6374,
  [SMALL_STATE(186)] = 6438,
  [SMALL_STATE(187)] = 6502,
  [SMALL_STATE(188)] = 6566,
  [SMALL_STATE(189)] = 6630,
  [SMALL_STATE(190)] = 6694,
  [SMALL_STATE(191)] = 6758,
  [SMALL_STATE(192)] = 6822,
  [SMALL_STATE(193)] = 6888,
  [SMALL_STATE(194)] = 6954,
  [SMALL_STATE(195)] = 7018,
  [SMALL_STATE(196)] = 7082,
  [SMALL_STATE(197)] = 7146,
  [SMALL_STATE(198)] = 7210,
  [SMALL_STATE(199)] = 7274,
  [SMALL_STATE(200)] = 7338,
  [SMALL_STATE(201)] = 7402,
  [SMALL_STATE(202)] = 7466,
  [SMALL_STATE(203)] = 7530,
  [SMALL_STATE(204)] = 7594,
  [SMALL_STATE(205)] = 7658,
  [SMALL_STATE(206)] = 7722,
  [SMALL_STATE(207)] = 7786,
  [SMALL_STATE(208)] = 7850,
  [SMALL_STATE(209)] = 7914,
  [SMALL_STATE(210)] = 7978,
  [SMALL_STATE(211)] = 8044,
  [SMALL_STATE(212)] = 8108,
  [SMALL_STATE(213)] = 8172,
  [SMALL_STATE(214)] = 8236,
  [SMALL_STATE(215)] = 8300,
  [SMALL_STATE(216)] = 8364,
  [SMALL_STATE(217)] = 8428,
  [SMALL_STATE(218)] = 8492,
  [SMALL_STATE(219)] = 8556,
  [SMALL_STATE(220)] = 8620,
  [SMALL_STATE(221)] = 8684,
  [SMALL_STATE(222)] = 8748,
  [SMALL_STATE(223)] = 8812,
  [SMALL_STATE(224)] = 8876,
  [SMALL_STATE(225)] = 8940,
  [SMALL_STATE(226)] = 9004,
  [SMALL_STATE(227)] = 9068,
  [SMALL_STATE(228)] = 9132,
  [SMALL_STATE(229)] = 9196,
  [SMALL_STATE(230)] = 9260,
  [SMALL_STATE(231)] = 9324,
  [SMALL_STATE(232)] = 9388,
  [SMALL_STATE(233)] = 9452,
  [SMALL_STATE(234)] = 9516,
  [SMALL_STATE(235)] = 9580,
  [SMALL_STATE(236)] = 9644,
  [SMALL_STATE(237)] = 9708,
  [SMALL_STATE(238)] = 9772,
  [SMALL_STATE(239)] = 9836,
  [SMALL_STATE(240)] = 9900,
  [SMALL_STATE(241)] = 9964,
  [SMALL_STATE(242)] = 10028,
  [SMALL_STATE(243)] = 10092,
  [SMALL_STATE(244)] = 10156,
  [SMALL_STATE(245)] = 10220,
  [SMALL_STATE(246)] = 10284,
  [SMALL_STATE(247)] = 10348,
  [SMALL_STATE(248)] = 10412,
  [SMALL_STATE(249)] = 10476,
  [SMALL_STATE(250)] = 10540,
  [SMALL_STATE(251)] = 10604,
  [SMALL_STATE(252)] = 10668,
  [SMALL_STATE(253)] = 10732,
  [SMALL_STATE(254)] = 10796,
  [SMALL_STATE(255)] = 10860,
  [SMALL_STATE(256)] = 10924,
  [SMALL_STATE(257)] = 10988,
  [SMALL_STATE(258)] = 11052,
  [SMALL_STATE(259)] = 11116,
  [SMALL_STATE(260)] = 11180,
  [SMALL_STATE(261)] = 11244,
  [SMALL_STATE(262)] = 11308,
  [SMALL_STATE(263)] = 11372,
  [SMALL_STATE(264)] = 11436,
  [SMALL_STATE(265)] = 11500,
  [SMALL_STATE(266)] = 11564,
  [SMALL_STATE(267)] = 11628,
  [SMALL_STATE(268)] = 11692,
  [SMALL_STATE(269)] = 11756,
  [SMALL_STATE(270)] = 11820,
  [SMALL_STATE(271)] = 11983,
  [SMALL_STATE(272)] = 12146,
  [SMALL_STATE(273)] = 12295,
  [SMALL_STATE(274)] = 12444,
  [SMALL_STATE(275)] = 12507,
  [SMALL_STATE(276)] = 12570,
  [SMALL_STATE(277)] = 12633,
  [SMALL_STATE(278)] = 12779,
  [SMALL_STATE(279)] = 12925,
  [SMALL_STATE(280)] = 12966,
  [SMALL_STATE(281)] = 13004,
  [SMALL_STATE(282)] = 13056,
  [SMALL_STATE(283)] = 13108,
  [SMALL_STATE(284)] = 13160,
  [SMALL_STATE(285)] = 13207,
  [SMALL_STATE(286)] = 13254,
  [SMALL_STATE(287)] = 13300,
  [SMALL_STATE(288)] = 13346,
  [SMALL_STATE(289)] = 13392,
  [SMALL_STATE(290)] = 13438,
  [SMALL_STATE(291)] = 13484,
  [SMALL_STATE(292)] = 13530,
  [SMALL_STATE(293)] = 13576,
  [SMALL_STATE(294)] = 13622,
  [SMALL_STATE(295)] = 13668,
  [SMALL_STATE(296)] = 13714,
  [SMALL_STATE(297)] = 13760,
  [SMALL_STATE(298)] = 13806,
  [SMALL_STATE(299)] = 13854,
  [SMALL_STATE(300)] = 13900,
  [SMALL_STATE(301)] = 13946,
  [SMALL_STATE(302)] = 13992,
  [SMALL_STATE(303)] = 14038,
  [SMALL_STATE(304)] = 14084,
  [SMALL_STATE(305)] = 14130,
  [SMALL_STATE(306)] = 14176,
  [SMALL_STATE(307)] = 14222,
  [SMALL_STATE(308)] = 14268,
  [SMALL_STATE(309)] = 14314,
  [SMALL_STATE(310)] = 14356,
  [SMALL_STATE(311)] = 14398,
  [SMALL_STATE(312)] = 14440,
  [SMALL_STATE(313)] = 14482,
  [SMALL_STATE(314)] = 14524,
  [SMALL_STATE(315)] = 14566,
  [SMALL_STATE(316)] = 14608,
  [SMALL_STATE(317)] = 14650,
  [SMALL_STATE(318)] = 14692,
  [SMALL_STATE(319)] = 14734,
  [SMALL_STATE(320)] = 14776,
  [SMALL_STATE(321)] = 14818,
  [SMALL_STATE(322)] = 14860,
  [SMALL_STATE(323)] = 14902,
  [SMALL_STATE(324)] = 14944,
  [SMALL_STATE(325)] = 14971,
  [SMALL_STATE(326)] = 14998,
  [SMALL_STATE(327)] = 15025,
  [SMALL_STATE(328)] = 15047,
  [SMALL_STATE(329)] = 15069,
  [SMALL_STATE(330)] = 15091,
  [SMALL_STATE(331)] = 15127,
  [SMALL_STATE(332)] = 15163,
  [SMALL_STATE(333)] = 15199,
  [SMALL_STATE(334)] = 15221,
  [SMALL_STATE(335)] = 15243,
  [SMALL_STATE(336)] = 15279,
  [SMALL_STATE(337)] = 15301,
  [SMALL_STATE(338)] = 15323,
  [SMALL_STATE(339)] = 15359,
  [SMALL_STATE(340)] = 15381,
  [SMALL_STATE(341)] = 15403,
  [SMALL_STATE(342)] = 15425,
  [SMALL_STATE(343)] = 15460,
  [SMALL_STATE(344)] = 15495,
  [SMALL_STATE(345)] = 15530,
  [SMALL_STATE(346)] = 15565,
  [SMALL_STATE(347)] = 15600,
  [SMALL_STATE(348)] = 15635,
  [SMALL_STATE(349)] = 15670,
  [SMALL_STATE(350)] = 15705,
  [SMALL_STATE(351)] = 15740,
  [SMALL_STATE(352)] = 15761,
  [SMALL_STATE(353)] = 15796,
  [SMALL_STATE(354)] = 15830,
  [SMALL_STATE(355)] = 15866,
  [SMALL_STATE(356)] = 15902,
  [SMALL_STATE(357)] = 15935,
  [SMALL_STATE(358)] = 15968,
  [SMALL_STATE(359)] = 15993,
  [SMALL_STATE(360)] = 16018,
  [SMALL_STATE(361)] = 16043,
  [SMALL_STATE(362)] = 16070,
  [SMALL_STATE(363)] = 16094,
  [SMALL_STATE(364)] = 16118,
  [SMALL_STATE(365)] = 16142,
  [SMALL_STATE(366)] = 16166,
  [SMALL_STATE(367)] = 16190,
  [SMALL_STATE(368)] = 16214,
  [SMALL_STATE(369)] = 16238,
  [SMALL_STATE(370)] = 16254,
  [SMALL_STATE(371)] = 16270,
  [SMALL_STATE(372)] = 16286,
  [SMALL_STATE(373)] = 16310,
  [SMALL_STATE(374)] = 16330,
  [SMALL_STATE(375)] = 16354,
  [SMALL_STATE(376)] = 16378,
  [SMALL_STATE(377)] = 16398,
  [SMALL_STATE(378)] = 16414,
  [SMALL_STATE(379)] = 16438,
  [SMALL_STATE(380)] = 16458,
  [SMALL_STATE(381)] = 16482,
  [SMALL_STATE(382)] = 16506,
  [SMALL_STATE(383)] = 16522,
  [SMALL_STATE(384)] = 16541,
  [SMALL_STATE(385)] = 16556,
  [SMALL_STATE(386)] = 16571,
  [SMALL_STATE(387)] = 16586,
  [SMALL_STATE(388)] = 16605,
  [SMALL_STATE(389)] = 16626,
  [SMALL_STATE(390)] = 16647,
  [SMALL_STATE(391)] = 16666,
  [SMALL_STATE(392)] = 16681,
  [SMALL_STATE(393)] = 16704,
  [SMALL_STATE(394)] = 16727,
  [SMALL_STATE(395)] = 16742,
  [SMALL_STATE(396)] = 16765,
  [SMALL_STATE(397)] = 16779,
  [SMALL_STATE(398)] = 16793,
  [SMALL_STATE(399)] = 16805,
  [SMALL_STATE(400)] = 16819,
  [SMALL_STATE(401)] = 16833,
  [SMALL_STATE(402)] = 16847,
  [SMALL_STATE(403)] = 16861,
  [SMALL_STATE(404)] = 16875,
  [SMALL_STATE(405)] = 16889,
  [SMALL_STATE(406)] = 16903,
  [SMALL_STATE(407)] = 16917,
  [SMALL_STATE(408)] = 16931,
  [SMALL_STATE(409)] = 16946,
  [SMALL_STATE(410)] = 16961,
  [SMALL_STATE(411)] = 16976,
  [SMALL_STATE(412)] = 16991,
  [SMALL_STATE(413)] = 17006,
  [SMALL_STATE(414)] = 17019,
  [SMALL_STATE(415)] = 17035,
  [SMALL_STATE(416)] = 17051,
  [SMALL_STATE(417)] = 17061,
  [SMALL_STATE(418)] = 17077,
  [SMALL_STATE(419)] = 17093,
  [SMALL_STATE(420)] = 17109,
  [SMALL_STATE(421)] = 17125,
  [SMALL_STATE(422)] = 17141,
  [SMALL_STATE(423)] = 17157,
  [SMALL_STATE(424)] = 17173,
  [SMALL_STATE(425)] = 17189,
  [SMALL_STATE(426)] = 17205,
  [SMALL_STATE(427)] = 17221,
  [SMALL_STATE(428)] = 17237,
  [SMALL_STATE(429)] = 17253,
  [SMALL_STATE(430)] = 17266,
  [SMALL_STATE(431)] = 17279,
  [SMALL_STATE(432)] = 17292,
  [SMALL_STATE(433)] = 17305,
  [SMALL_STATE(434)] = 17318,
  [SMALL_STATE(435)] = 17331,
  [SMALL_STATE(436)] = 17344,
  [SMALL_STATE(437)] = 17357,
  [SMALL_STATE(438)] = 17370,
  [SMALL_STATE(439)] = 17383,
  [SMALL_STATE(440)] = 17392,
  [SMALL_STATE(441)] = 17405,
  [SMALL_STATE(442)] = 17418,
  [SMALL_STATE(443)] = 17431,
  [SMALL_STATE(444)] = 17444,
  [SMALL_STATE(445)] = 17457,
  [SMALL_STATE(446)] = 17470,
  [SMALL_STATE(447)] = 17483,
  [SMALL_STATE(448)] = 17496,
  [SMALL_STATE(449)] = 17509,
  [SMALL_STATE(450)] = 17519,
  [SMALL_STATE(451)] = 17527,
  [SMALL_STATE(452)] = 17537,
  [SMALL_STATE(453)] = 17545,
  [SMALL_STATE(454)] = 17553,
  [SMALL_STATE(455)] = 17561,
  [SMALL_STATE(456)] = 17571,
  [SMALL_STATE(457)] = 17579,
  [SMALL_STATE(458)] = 17587,
  [SMALL_STATE(459)] = 17597,
  [SMALL_STATE(460)] = 17605,
  [SMALL_STATE(461)] = 17615,
  [SMALL_STATE(462)] = 17623,
  [SMALL_STATE(463)] = 17631,
  [SMALL_STATE(464)] = 17639,
  [SMALL_STATE(465)] = 17647,
  [SMALL_STATE(466)] = 17654,
  [SMALL_STATE(467)] = 17661,
  [SMALL_STATE(468)] = 17668,
  [SMALL_STATE(469)] = 17675,
  [SMALL_STATE(470)] = 17682,
  [SMALL_STATE(471)] = 17689,
  [SMALL_STATE(472)] = 17696,
  [SMALL_STATE(473)] = 17703,
  [SMALL_STATE(474)] = 17710,
  [SMALL_STATE(475)] = 17717,
  [SMALL_STATE(476)] = 17724,
  [SMALL_STATE(477)] = 17731,
  [SMALL_STATE(478)] = 17738,
  [SMALL_STATE(479)] = 17745,
  [SMALL_STATE(480)] = 17752,
  [SMALL_STATE(481)] = 17759,
  [SMALL_STATE(482)] = 17766,
  [SMALL_STATE(483)] = 17773,
  [SMALL_STATE(484)] = 17780,
  [SMALL_STATE(485)] = 17787,
  [SMALL_STATE(486)] = 17794,
  [SMALL_STATE(487)] = 17801,
  [SMALL_STATE(488)] = 17808,
  [SMALL_STATE(489)] = 17815,
  [SMALL_STATE(490)] = 17822,
  [SMALL_STATE(491)] = 17829,
  [SMALL_STATE(492)] = 17836,
  [SMALL_STATE(493)] = 17843,
  [SMALL_STATE(494)] = 17850,
  [SMALL_STATE(495)] = 17857,
  [SMALL_STATE(496)] = 17864,
  [SMALL_STATE(497)] = 17871,
  [SMALL_STATE(498)] = 17878,
  [SMALL_STATE(499)] = 17885,
  [SMALL_STATE(500)] = 17892,
  [SMALL_STATE(501)] = 17899,
  [SMALL_STATE(502)] = 17906,
  [SMALL_STATE(503)] = 17913,
  [SMALL_STATE(504)] = 17920,
  [SMALL_STATE(505)] = 17927,
  [SMALL_STATE(506)] = 17934,
  [SMALL_STATE(507)] = 17941,
  [SMALL_STATE(508)] = 17948,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statements, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [55] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_stmt, 1),
  [57] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_stmt, 1),
  [59] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_stmt_identifier, 1),
  [61] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_last_stmt_identifier, 1),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [87] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statements, 1),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [91] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statements_repeat2, 1),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [97] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat2, 1),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dec_number, 1),
  [103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__dec_number, 1),
  [105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_help_stmt, 1, .production_id = 2),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_help_stmt, 1, .production_id = 2),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 1, .production_id = 3),
  [125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 1, .production_id = 3),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_disable_stmt, 2, .production_id = 2),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_disable_stmt, 2, .production_id = 2),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__search_stmt, 1, .production_id = 2),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__search_stmt, 1, .production_id = 2),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsetssizes_stmt, 2),
  [137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsetssizes_stmt, 2),
  [139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_arged_stmt, 1, .production_id = 2),
  [141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_arged_stmt, 1, .production_id = 2),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsets_stmt, 2),
  [145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsets_stmt, 2),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__system_stmt, 1, .production_id = 2),
  [149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__system_stmt, 1, .production_id = 2),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__macro_arged_stmt, 1, .production_id = 2),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__macro_arged_stmt, 1, .production_id = 2),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 2, .production_id = 3),
  [171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 2, .production_id = 3),
  [173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Cf_cmd, 1, .production_id = 2),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Cf_cmd, 1, .production_id = 2),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2),
  [193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(368),
  [196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_args_repeat1, 2),
  [198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(82),
  [201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(299),
  [204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(88),
  [207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(417),
  [210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(9),
  [213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(10),
  [216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_args, 1),
  [218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_args, 1),
  [220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_args, 1),
  [222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_args, 1),
  [224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_args, 1),
  [236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_args, 1),
  [238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__env_stmt, 1, .production_id = 2),
  [240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__env_stmt, 1, .production_id = 2),
  [244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2),
  [254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_args_repeat1, 2),
  [256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(113),
  [259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(347),
  [262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(30),
  [265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(29),
  [268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmd_identifier, 1, .production_id = 1),
  [270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmd_identifier, 1, .production_id = 1),
  [272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(330),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenation, 2),
  [283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenation, 2),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_specifiers_repeat1, 2),
  [289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_specifiers_repeat1, 2),
  [291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specifiers_repeat1, 2), SHIFT_REPEAT(480),
  [294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arg, 1),
  [296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arg, 1),
  [298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specifiers, 1),
  [300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specifiers, 1),
  [302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arg_identifier, 1),
  [304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arg_identifier, 1),
  [306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double_quoted_arg, 3),
  [308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double_quoted_arg, 3),
  [310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmd_substitution_arg, 3),
  [312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmd_substitution_arg, 3),
  [314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double_quoted_arg, 2),
  [316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double_quoted_arg, 2),
  [318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_single_quoted_arg, 2),
  [320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_single_quoted_arg, 2),
  [322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg, 1, .production_id = 7),
  [324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg, 1, .production_id = 7),
  [326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spec_arg_identifier, 1),
  [328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_spec_arg_identifier, 1),
  [330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_specifiers_repeat1, 3),
  [332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_specifiers_repeat1, 3),
  [334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_single_quoted_arg, 3),
  [336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_single_quoted_arg, 3),
  [338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg_with_paren, 3, .production_id = 18),
  [340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg_with_paren, 3, .production_id = 18),
  [342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_arg, 1),
  [344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_arg, 1),
  [346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmd_identifier, 2, .production_id = 6),
  [348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmd_identifier, 2, .production_id = 6),
  [350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2),
  [352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2),
  [354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2), SHIFT_REPEAT(388),
  [357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_concatenation, 2),
  [359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_concatenation, 2),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_arg, 1),
  [365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_arg, 1),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_dot_arg_identifier, 1),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_dot_arg_identifier, 1),
  [373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_concatenation, 2),
  [375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_concatenation, 2),
  [377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2),
  [379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2),
  [381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2), SHIFT_REPEAT(359),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_arg_parentheses, 3, .production_id = 19),
  [386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_arg_parentheses, 3, .production_id = 19),
  [388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_arg_identifier, 1),
  [390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_arg_identifier, 1),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grep_specifier, 1),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grep_specifier, 1),
  [396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__env_stmt_identifier, 1),
  [408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__env_stmt_identifier, 1),
  [410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_grep_specifier_repeat1, 2),
  [412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2),
  [414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(117),
  [417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(16),
  [420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(15),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_args, 2),
  [427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_args, 2),
  [429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_key_concatenation, 2),
  [431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_key_concatenation, 2),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2), SHIFT_REPEAT(389),
  [438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(331),
  [441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__eq_sep_key_concatenation_repeat1, 2),
  [443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__eq_sep_key_concatenation_repeat1, 2),
  [445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__eq_sep_key_concatenation_repeat1, 2), SHIFT_REPEAT(360),
  [448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 2),
  [450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 2),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 2), SHIFT_REPEAT(126),
  [455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_arg, 1),
  [457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_arg, 1),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_key, 1),
  [465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_key, 1),
  [467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_dot_args_repeat1, 2),
  [469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_dot_args_repeat1, 2),
  [471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_dot_args_repeat1, 2), SHIFT_REPEAT(492),
  [474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_val, 1),
  [476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_val, 1),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tmp_eval_args_repeat1, 2),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tmp_eval_args_repeat1, 2),
  [484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tmp_eval_args_repeat1, 2), SHIFT_REPEAT(441),
  [487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_args, 1),
  [489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_args, 1),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_args, 1),
  [495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_args, 1),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__eq_sep_val_concatenation_repeat1, 2),
  [501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__eq_sep_val_concatenation_repeat1, 2),
  [503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__eq_sep_val_concatenation_repeat1, 2), SHIFT_REPEAT(311),
  [506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_args, 2),
  [508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_args, 2),
  [510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_dot_args_repeat1, 4),
  [512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_dot_args_repeat1, 4),
  [514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_val_concatenation, 2),
  [516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_val_concatenation, 2),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(163),
  [529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(11),
  [532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(22),
  [535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_comment_stmt, 2),
  [537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_comment_stmt, 2),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_flags_stmt, 2),
  [543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_flags_stmt, 2),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_function_stmt, 2),
  [549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_function_stmt, 2),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 3, .production_id = 15),
  [555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 3, .production_id = 15),
  [557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 2, .production_id = 15),
  [559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 2, .production_id = 15),
  [561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 6, .production_id = 15),
  [563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 6, .production_id = 15),
  [565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 5, .production_id = 15),
  [567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 5, .production_id = 15),
  [569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 4, .production_id = 15),
  [571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 4, .production_id = 15),
  [573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_eq_sep_args, 1),
  [575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_eq_sep_args, 1),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_fromto_stmt, 4),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_fromto_stmt, 4),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arged_stmt, 1, .production_id = 4),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arged_stmt, 1, .production_id = 4),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__math_arged_stmt, 2, .production_id = 8),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__math_arged_stmt, 2, .production_id = 8),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_legacy_quoted_stmt, 3, .production_id = 12),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_legacy_quoted_stmt, 3, .production_id = 12),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 3, .production_id = 13),
  [699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 3, .production_id = 13),
  [701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_call_content, 2),
  [703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_call_content, 2),
  [705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__Cf_args, 2),
  [707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__Cf_args, 2),
  [709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_new_cmd, 3, .production_id = 14),
  [711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_new_cmd, 3, .production_id = 14),
  [713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_cmd, 3, .production_id = 14),
  [715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_cmd, 3, .production_id = 14),
  [717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_cmd_args, 1),
  [719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_cmd_args, 1),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pointer_arged_stmt, 2, .production_id = 8),
  [727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pointer_arged_stmt, 2, .production_id = 8),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__macro_arged_stmt, 2, .production_id = 8),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__macro_arged_stmt, 2, .production_id = 8),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__last_stmt, 1, .production_id = 2),
  [735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__last_stmt, 1, .production_id = 2),
  [737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_args, 2),
  [739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_args, 2),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_enable_stmt, 2, .production_id = 2),
  [743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_enable_stmt, 2, .production_id = 2),
  [745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_arged_stmt_question, 2, .production_id = 8),
  [747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_arged_stmt_question, 2, .production_id = 8),
  [749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arged_stmt, 1, .production_id = 5),
  [751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arged_stmt, 1, .production_id = 5),
  [753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 2, .production_id = 9),
  [755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 2, .production_id = 9),
  [757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grep_stmt, 3, .production_id = 16),
  [759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grep_stmt, 3, .production_id = 16),
  [761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_stmt, 3),
  [763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pipe_stmt, 3),
  [765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_file_lines_stmt, 3),
  [767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_file_lines_stmt, 3),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsets_stmt, 3),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsets_stmt, 3),
  [773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsetssizes_stmt, 3),
  [775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsetssizes_stmt, 3),
  [777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_arged_stmt, 1, .production_id = 2),
  [779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_arged_stmt, 1, .production_id = 2),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbta_stmt, 2),
  [785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbta_stmt, 2),
  [787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbtb_stmt, 2),
  [789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbtb_stmt, 2),
  [791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbts_stmt, 2),
  [793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbts_stmt, 2),
  [795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_threads_stmt, 2),
  [797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_threads_stmt, 2),
  [799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_bbs_stmt, 2),
  [801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_bbs_stmt, 2),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_step_stmt, 3),
  [805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_step_stmt, 3),
  [807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_seek_stmt, 3),
  [809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_seek_stmt, 3),
  [811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_blksz_stmt, 3),
  [813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_blksz_stmt, 3),
  [815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_instrs_stmt, 2),
  [817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_instrs_stmt, 2),
  [819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_arch_stmt, 3),
  [821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_arch_stmt, 3),
  [823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_bits_stmt, 3),
  [825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_bits_stmt, 3),
  [827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_nthi_stmt, 3),
  [829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_nthi_stmt, 3),
  [831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_stmt, 3),
  [833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_stmt, 3),
  [835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_fs_stmt, 3),
  [837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_fs_stmt, 3),
  [839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_reli_stmt, 3),
  [841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_reli_stmt, 3),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_kuery_stmt, 3),
  [845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_kuery_stmt, 3),
  [847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_fd_stmt, 3),
  [849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_fd_stmt, 3),
  [851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_reg_stmt, 3),
  [853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_reg_stmt, 3),
  [855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_file_stmt, 3),
  [857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_file_stmt, 3),
  [859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_string_stmt, 3),
  [861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_string_stmt, 3),
  [863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_value_stmt, 3),
  [865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_value_stmt, 3),
  [867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_hex_stmt, 3),
  [869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_hex_stmt, 3),
  [871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_import_stmt, 2),
  [873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_import_stmt, 2),
  [875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_call_content, 1),
  [877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_call_content, 1),
  [879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_sections_stmt, 2),
  [881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_sections_stmt, 2),
  [883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_arged_stmt, 2, .production_id = 8),
  [885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_arged_stmt, 2, .production_id = 8),
  [887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_new_args, 2),
  [889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_new_args, 2),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_segments_stmt, 2),
  [893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_segments_stmt, 2),
  [895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_symbol_stmt, 2),
  [897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_symbol_stmt, 2),
  [899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_eq_sep_args, 3),
  [901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_eq_sep_args, 3),
  [903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_call_full_content, 2),
  [905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_call_full_content, 2),
  [907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grep_specifier, 2),
  [909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grep_specifier, 2),
  [911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_hit_stmt, 4, .production_id = 20),
  [913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_hit_stmt, 4, .production_id = 20),
  [915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_comment_stmt, 4),
  [917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_comment_stmt, 4),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_flags_stmt, 4),
  [921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_flags_stmt, 4),
  [923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_function_stmt, 4),
  [925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_function_stmt, 4),
  [927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__env_stmt, 2, .production_id = 8),
  [929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__env_stmt, 2, .production_id = 8),
  [931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_string_stmt, 2),
  [933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_string_stmt, 2),
  [935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_iomap_stmt, 2),
  [937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_iomap_stmt, 2),
  [939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbgmap_stmt, 2),
  [941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbgmap_stmt, 2),
  [943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_register_stmt, 2),
  [945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_register_stmt, 2),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Cf_cmd, 2, .production_id = 8),
  [949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Cf_cmd, 2, .production_id = 8),
  [951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_cmd, 2, .production_id = 8),
  [953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_cmd, 2, .production_id = 8),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 2, .production_id = 10),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 2, .production_id = 10),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_cmd_args, 3, .production_id = 21),
  [961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_cmd_args, 3, .production_id = 21),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__system_stmt, 2, .production_id = 8),
  [965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__system_stmt, 2, .production_id = 8),
  [967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__search_stmt, 2, .production_id = 8),
  [969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__search_stmt, 2, .production_id = 8),
  [971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_arged_stmt, 2, .production_id = 8),
  [973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_arged_stmt, 2, .production_id = 8),
  [975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_stmt, 2, .production_id = 11),
  [977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_stmt, 2, .production_id = 11),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_interpret_offsetssizes_stmt, 3),
  [1009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_interpret_offsetssizes_stmt, 3),
  [1011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_interpret_stmt, 3),
  [1013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_interpret_stmt, 3),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [1021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statements_repeat1, 2),
  [1023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_statements_repeat1, 2),
  [1025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statements_repeat1, 2), SHIFT_REPEAT(279),
  [1028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat1, 2),
  [1030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statements_singleline_repeat1, 2),
  [1032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat1, 2), SHIFT_REPEAT(280),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(375),
  [1046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(334),
  [1049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(291),
  [1052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(333),
  [1055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(334),
  [1058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(424),
  [1061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(20),
  [1064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(8),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(338),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(391),
  [1119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(344),
  [1122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(391),
  [1125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(25),
  [1128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(31),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [1189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_search_identifier, 1),
  [1191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_search_identifier, 1),
  [1193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_redirect_operator, 2),
  [1195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_redirect_operator, 2),
  [1197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_append_operator, 2),
  [1199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_append_operator, 2),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [1205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2),
  [1207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(374),
  [1210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(374),
  [1213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(26),
  [1216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(24),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_append_operator, 1),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_append_operator, 1),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [1231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2), SHIFT_REPEAT(358),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_redirect_operator, 1),
  [1244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_redirect_operator, 1),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(335),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirect_stmt, 3, .production_id = 17),
  [1261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statements_repeat2, 2),
  [1263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statements_repeat2, 2), SHIFT_REPEAT(7),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statements, 3),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statements, 2),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [1278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [1284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [1290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_single_quoted_arg_repeat1, 2),
  [1292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_single_quoted_arg_repeat1, 2), SHIFT_REPEAT(418),
  [1295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_single_quoted_arg_repeat1, 2), SHIFT_REPEAT(418),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [1332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements_singleline, 1),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_content_repeat1, 2),
  [1344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_content_repeat1, 2), SHIFT_REPEAT(37),
  [1347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(332),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements_singleline, 3),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat2, 2),
  [1360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat2, 2), SHIFT_REPEAT(32),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements_singleline, 2),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat2, 2), SHIFT_REPEAT(34),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1444] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_rzcmd_external_scanner_create(void);
void tree_sitter_rzcmd_external_scanner_destroy(void *);
bool tree_sitter_rzcmd_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_rzcmd_external_scanner_serialize(void *, char *);
void tree_sitter_rzcmd_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_rzcmd(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = (const uint16_t *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_rzcmd_external_scanner_create,
      tree_sitter_rzcmd_external_scanner_destroy,
      tree_sitter_rzcmd_external_scanner_scan,
      tree_sitter_rzcmd_external_scanner_serialize,
      tree_sitter_rzcmd_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
