#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1437
#define LARGE_STATE_COUNT 384
#define SYMBOL_COUNT 256
#define ALIAS_COUNT 3
#define TOKEN_COUNT 127
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 24
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 82

enum {
  sym_identifier = 1,
  anon_sym___TYPE_EXPRESSION = 2,
  anon_sym___VANILLA_C = 3,
  aux_sym_preproc_include_token1 = 4,
  anon_sym_LF = 5,
  aux_sym_preproc_def_token1 = 6,
  anon_sym_LPAREN = 7,
  anon_sym_DOT_DOT_DOT = 8,
  anon_sym_COMMA = 9,
  anon_sym_RPAREN = 10,
  aux_sym_preproc_if_token1 = 11,
  aux_sym_preproc_if_token2 = 12,
  aux_sym_preproc_ifdef_token1 = 13,
  aux_sym_preproc_ifdef_token2 = 14,
  aux_sym_preproc_else_token1 = 15,
  aux_sym_preproc_elif_token1 = 16,
  sym_preproc_directive = 17,
  sym_preproc_arg = 18,
  anon_sym_LPAREN2 = 19,
  anon_sym_defined = 20,
  anon_sym_BANG = 21,
  anon_sym_TILDE = 22,
  anon_sym_DASH = 23,
  anon_sym_PLUS = 24,
  anon_sym_STAR = 25,
  anon_sym_SLASH = 26,
  anon_sym_PERCENT = 27,
  anon_sym_PIPE_PIPE = 28,
  anon_sym_AMP_AMP = 29,
  anon_sym_PIPE = 30,
  anon_sym_CARET = 31,
  anon_sym_AMP = 32,
  anon_sym_EQ_EQ = 33,
  anon_sym_BANG_EQ = 34,
  anon_sym_GT = 35,
  anon_sym_GT_EQ = 36,
  anon_sym_LT_EQ = 37,
  anon_sym_LT = 38,
  anon_sym_LT_LT = 39,
  anon_sym_GT_GT = 40,
  anon_sym_SEMI = 41,
  anon_sym_typedef = 42,
  anon_sym_extern = 43,
  anon_sym___attribute__ = 44,
  anon_sym___declspec = 45,
  anon_sym___based = 46,
  anon_sym___cdecl = 47,
  anon_sym___clrcall = 48,
  anon_sym___stdcall = 49,
  anon_sym___fastcall = 50,
  anon_sym___thiscall = 51,
  anon_sym___vectorcall = 52,
  sym_ms_restrict_modifier = 53,
  sym_ms_unsigned_ptr_modifier = 54,
  sym_ms_signed_ptr_modifier = 55,
  anon_sym__unaligned = 56,
  anon_sym___unaligned = 57,
  anon_sym_LBRACE = 58,
  anon_sym_RBRACE = 59,
  anon_sym_LBRACK = 60,
  anon_sym_RBRACK = 61,
  anon_sym_EQ = 62,
  anon_sym_static = 63,
  anon_sym_auto = 64,
  anon_sym_register = 65,
  anon_sym_inline = 66,
  anon_sym_const = 67,
  anon_sym_volatile = 68,
  anon_sym_restrict = 69,
  anon_sym__Atomic = 70,
  anon_sym_signed = 71,
  anon_sym_unsigned = 72,
  anon_sym_long = 73,
  anon_sym_short = 74,
  sym_primitive_type = 75,
  anon_sym_enum = 76,
  anon_sym_struct = 77,
  anon_sym_union = 78,
  anon_sym_COLON = 79,
  anon_sym_if = 80,
  anon_sym_else = 81,
  anon_sym_switch = 82,
  anon_sym_case = 83,
  anon_sym_default = 84,
  anon_sym_while = 85,
  anon_sym_do = 86,
  anon_sym_for = 87,
  anon_sym_return = 88,
  anon_sym_break = 89,
  anon_sym_continue = 90,
  anon_sym_goto = 91,
  anon_sym_QMARK = 92,
  anon_sym_STAR_EQ = 93,
  anon_sym_SLASH_EQ = 94,
  anon_sym_PERCENT_EQ = 95,
  anon_sym_PLUS_EQ = 96,
  anon_sym_DASH_EQ = 97,
  anon_sym_LT_LT_EQ = 98,
  anon_sym_GT_GT_EQ = 99,
  anon_sym_AMP_EQ = 100,
  anon_sym_CARET_EQ = 101,
  anon_sym_PIPE_EQ = 102,
  anon_sym_DASH_DASH = 103,
  anon_sym_PLUS_PLUS = 104,
  anon_sym_sizeof = 105,
  anon_sym_DOT = 106,
  anon_sym_DASH_GT = 107,
  sym_number_literal = 108,
  anon_sym_L_SQUOTE = 109,
  anon_sym_u_SQUOTE = 110,
  anon_sym_U_SQUOTE = 111,
  anon_sym_u8_SQUOTE = 112,
  anon_sym_SQUOTE = 113,
  aux_sym_char_literal_token1 = 114,
  anon_sym_L_DQUOTE = 115,
  anon_sym_u_DQUOTE = 116,
  anon_sym_U_DQUOTE = 117,
  anon_sym_u8_DQUOTE = 118,
  anon_sym_DQUOTE = 119,
  aux_sym_string_literal_token1 = 120,
  sym_escape_sequence = 121,
  sym_system_lib_string = 122,
  sym_true = 123,
  sym_false = 124,
  sym_null = 125,
  sym_comment = 126,
  sym_translation_unit = 127,
  sym_vanilla_expression = 128,
  sym_preproc_include = 129,
  sym_preproc_def = 130,
  sym_preproc_function_def = 131,
  sym_preproc_params = 132,
  sym_preproc_call = 133,
  sym_preproc_if = 134,
  sym_preproc_ifdef = 135,
  sym_preproc_else = 136,
  sym_preproc_elif = 137,
  sym_preproc_if_in_field_declaration_list = 138,
  sym_preproc_ifdef_in_field_declaration_list = 139,
  sym_preproc_else_in_field_declaration_list = 140,
  sym_preproc_elif_in_field_declaration_list = 141,
  sym__preproc_expression = 142,
  sym_preproc_parenthesized_expression = 143,
  sym_preproc_defined = 144,
  sym_preproc_unary_expression = 145,
  sym_preproc_call_expression = 146,
  sym_preproc_argument_list = 147,
  sym_preproc_binary_expression = 148,
  sym_function_definition = 149,
  sym_declaration = 150,
  sym_type_definition = 151,
  sym__declaration_specifiers = 152,
  sym_linkage_specification = 153,
  sym_attribute_specifier = 154,
  sym_ms_declspec_modifier = 155,
  sym_ms_based_modifier = 156,
  sym_ms_call_modifier = 157,
  sym_ms_unaligned_ptr_modifier = 158,
  sym_ms_pointer_modifier = 159,
  sym_declaration_list = 160,
  sym__declarator = 161,
  sym__field_declarator = 162,
  sym__type_declarator = 163,
  sym__abstract_declarator = 164,
  sym_parenthesized_declarator = 165,
  sym_parenthesized_field_declarator = 166,
  sym_parenthesized_type_declarator = 167,
  sym_abstract_parenthesized_declarator = 168,
  sym_pointer_declarator = 169,
  sym_pointer_field_declarator = 170,
  sym_pointer_type_declarator = 171,
  sym_abstract_pointer_declarator = 172,
  sym_function_declarator = 173,
  sym_function_field_declarator = 174,
  sym_function_type_declarator = 175,
  sym_abstract_function_declarator = 176,
  sym_array_declarator = 177,
  sym_array_field_declarator = 178,
  sym_array_type_declarator = 179,
  sym_abstract_array_declarator = 180,
  sym_init_declarator = 181,
  sym_compound_statement = 182,
  sym_storage_class_specifier = 183,
  sym_type_qualifier = 184,
  sym__type_specifier = 185,
  sym_sized_type_specifier = 186,
  sym_enum_specifier = 187,
  sym_enumerator_list = 188,
  sym_struct_specifier = 189,
  sym_union_specifier = 190,
  sym_field_declaration_list = 191,
  sym__field_declaration_list_item = 192,
  sym_field_declaration = 193,
  sym_bitfield_clause = 194,
  sym_enumerator = 195,
  sym_parameter_list = 196,
  sym_parameter_declaration = 197,
  sym_labeled_statement = 198,
  sym_expression_statement = 199,
  sym_if_statement = 200,
  sym_switch_statement = 201,
  sym_case_statement = 202,
  sym_while_statement = 203,
  sym_do_statement = 204,
  sym_for_statement = 205,
  sym_return_statement = 206,
  sym_break_statement = 207,
  sym_continue_statement = 208,
  sym_goto_statement = 209,
  sym__expression = 210,
  sym_comma_expression = 211,
  sym_conditional_expression = 212,
  sym_assignment_expression = 213,
  sym_pointer_expression = 214,
  sym_unary_expression = 215,
  sym_binary_expression = 216,
  sym_update_expression = 217,
  sym_cast_expression = 218,
  sym_type_descriptor = 219,
  sym_sizeof_expression = 220,
  sym_subscript_expression = 221,
  sym_call_expression = 222,
  sym_argument_list = 223,
  sym_field_expression = 224,
  sym_compound_literal_expression = 225,
  sym_parenthesized_expression = 226,
  sym_initializer_list = 227,
  sym_initializer_pair = 228,
  sym_subscript_designator = 229,
  sym_field_designator = 230,
  sym_char_literal = 231,
  sym_concatenated_string = 232,
  sym_string_literal = 233,
  sym__empty_declaration = 234,
  sym_macro_type_specifier = 235,
  aux_sym_translation_unit_repeat1 = 236,
  aux_sym_preproc_params_repeat1 = 237,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 238,
  aux_sym_preproc_argument_list_repeat1 = 239,
  aux_sym_declaration_repeat1 = 240,
  aux_sym_type_definition_repeat1 = 241,
  aux_sym_type_definition_repeat2 = 242,
  aux_sym__declaration_specifiers_repeat1 = 243,
  aux_sym_pointer_declarator_repeat1 = 244,
  aux_sym_function_declarator_repeat1 = 245,
  aux_sym_sized_type_specifier_repeat1 = 246,
  aux_sym_enumerator_list_repeat1 = 247,
  aux_sym_field_declaration_repeat1 = 248,
  aux_sym_parameter_list_repeat1 = 249,
  aux_sym_case_statement_repeat1 = 250,
  aux_sym_argument_list_repeat1 = 251,
  aux_sym_initializer_list_repeat1 = 252,
  aux_sym_initializer_pair_repeat1 = 253,
  aux_sym_concatenated_string_repeat1 = 254,
  aux_sym_string_literal_repeat1 = 255,
  alias_sym_field_identifier = 256,
  alias_sym_statement_identifier = 257,
  alias_sym_type_identifier = 258,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym___TYPE_EXPRESSION] = "__TYPE_EXPRESSION",
  [anon_sym___VANILLA_C] = "__VANILLA_C",
  [aux_sym_preproc_include_token1] = "#include",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [sym_preproc_directive] = "preproc_directive",
  [sym_preproc_arg] = "preproc_arg",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_SEMI] = ";",
  [anon_sym_typedef] = "typedef",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_auto] = "auto",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym_const] = "const",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_COLON] = ":",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym_DOT] = ".",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "char_literal_token1",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_literal_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_comment] = "comment",
  [sym_translation_unit] = "translation_unit",
  [sym_vanilla_expression] = "vanilla_expression",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym__type_specifier] = "_type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_labeled_statement] = "labeled_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym__expression] = "_expression",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_macro_type_specifier] = "macro_type_specifier",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym_type_definition_repeat2] = "type_definition_repeat2",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_function_declarator_repeat1] = "function_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym___TYPE_EXPRESSION] = anon_sym___TYPE_EXPRESSION,
  [anon_sym___VANILLA_C] = anon_sym___VANILLA_C,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [sym_preproc_directive] = sym_preproc_directive,
  [sym_preproc_arg] = sym_preproc_arg,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_auto] = anon_sym_auto,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [sym_primitive_type] = sym_primitive_type,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym_number_literal] = sym_number_literal,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_comment] = sym_comment,
  [sym_translation_unit] = sym_translation_unit,
  [sym_vanilla_expression] = sym_vanilla_expression,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym_type_definition] = sym_type_definition,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym__type_specifier] = sym__type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym__expression] = sym__expression,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_macro_type_specifier] = sym_macro_type_specifier,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym_type_definition_repeat2] = aux_sym_type_definition_repeat2,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_function_declarator_repeat1] = aux_sym_function_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym_field_declaration_repeat1] = aux_sym_field_declaration_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym___TYPE_EXPRESSION] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___VANILLA_C] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_auto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_vanilla_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_body = 4,
  field_condition = 5,
  field_consequence = 6,
  field_declarator = 7,
  field_designator = 8,
  field_directive = 9,
  field_field = 10,
  field_function = 11,
  field_index = 12,
  field_initializer = 13,
  field_label = 14,
  field_left = 15,
  field_name = 16,
  field_operator = 17,
  field_parameters = 18,
  field_path = 19,
  field_right = 20,
  field_size = 21,
  field_type = 22,
  field_update = 23,
  field_value = 24,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_declarator] = "declarator",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_field] = "field",
  [field_function] = "function",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_label] = "label",
  [field_left] = "left",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_right] = "right",
  [field_size] = "size",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 1},
  [8] = {.index = 7, .length = 2},
  [9] = {.index = 9, .length = 2},
  [10] = {.index = 11, .length = 1},
  [11] = {.index = 11, .length = 1},
  [12] = {.index = 12, .length = 2},
  [13] = {.index = 14, .length = 1},
  [14] = {.index = 15, .length = 1},
  [15] = {.index = 4, .length = 1},
  [16] = {.index = 16, .length = 2},
  [17] = {.index = 18, .length = 2},
  [18] = {.index = 20, .length = 1},
  [19] = {.index = 21, .length = 2},
  [20] = {.index = 23, .length = 1},
  [21] = {.index = 24, .length = 1},
  [22] = {.index = 25, .length = 2},
  [23] = {.index = 27, .length = 2},
  [24] = {.index = 29, .length = 1},
  [25] = {.index = 30, .length = 2},
  [26] = {.index = 32, .length = 1},
  [27] = {.index = 33, .length = 1},
  [28] = {.index = 34, .length = 2},
  [29] = {.index = 36, .length = 3},
  [30] = {.index = 39, .length = 2},
  [31] = {.index = 41, .length = 3},
  [32] = {.index = 44, .length = 2},
  [33] = {.index = 46, .length = 1},
  [34] = {.index = 47, .length = 2},
  [35] = {.index = 49, .length = 2},
  [36] = {.index = 51, .length = 2},
  [37] = {.index = 53, .length = 2},
  [38] = {.index = 55, .length = 1},
  [39] = {.index = 56, .length = 2},
  [40] = {.index = 58, .length = 2},
  [42] = {.index = 60, .length = 2},
  [43] = {.index = 62, .length = 1},
  [44] = {.index = 63, .length = 2},
  [45] = {.index = 65, .length = 1},
  [46] = {.index = 66, .length = 1},
  [47] = {.index = 67, .length = 2},
  [48] = {.index = 69, .length = 3},
  [49] = {.index = 72, .length = 2},
  [50] = {.index = 74, .length = 3},
  [51] = {.index = 77, .length = 2},
  [52] = {.index = 79, .length = 1},
  [53] = {.index = 80, .length = 2},
  [54] = {.index = 82, .length = 3},
  [55] = {.index = 85, .length = 2},
  [56] = {.index = 87, .length = 2},
  [57] = {.index = 89, .length = 3},
  [58] = {.index = 92, .length = 2},
  [59] = {.index = 94, .length = 2},
  [60] = {.index = 96, .length = 3},
  [61] = {.index = 99, .length = 2},
  [62] = {.index = 101, .length = 1},
  [63] = {.index = 102, .length = 2},
  [64] = {.index = 104, .length = 3},
  [65] = {.index = 107, .length = 1},
  [66] = {.index = 108, .length = 2},
  [68] = {.index = 110, .length = 3},
  [69] = {.index = 113, .length = 1},
  [70] = {.index = 114, .length = 1},
  [71] = {.index = 115, .length = 2},
  [72] = {.index = 117, .length = 2},
  [73] = {.index = 119, .length = 1},
  [74] = {.index = 120, .length = 1},
  [75] = {.index = 121, .length = 2},
  [76] = {.index = 123, .length = 2},
  [77] = {.index = 125, .length = 2},
  [78] = {.index = 127, .length = 3},
  [79] = {.index = 130, .length = 2},
  [80] = {.index = 132, .length = 2},
  [81] = {.index = 134, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0},
  [1] =
    {field_directive, 0},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_name, 1},
  [5] =
    {field_body, 1},
  [6] =
    {field_value, 1},
  [7] =
    {field_argument, 0},
    {field_operator, 1},
  [9] =
    {field_arguments, 1},
    {field_function, 0},
  [11] =
    {field_type, 1},
  [12] =
    {field_declarator, 1},
    {field_type, 0},
  [14] =
    {field_parameters, 0},
  [15] =
    {field_path, 1},
  [16] =
    {field_argument, 1},
    {field_directive, 0},
  [18] =
    {field_body, 2},
    {field_value, 1},
  [20] =
    {field_name, 0},
  [21] =
    {field_body, 2},
    {field_name, 1},
  [23] =
    {field_name, 2},
  [24] =
    {field_body, 2},
  [25] =
    {field_condition, 1},
    {field_consequence, 2},
  [27] =
    {field_body, 2},
    {field_condition, 1},
  [29] =
    {field_label, 1},
  [30] =
    {field_left, 0},
    {field_right, 2},
  [32] =
    {field_label, 0},
  [33] =
    {field_declarator, 1},
  [34] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [36] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [39] =
    {field_declarator, 0},
    {field_parameters, 1},
  [41] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [44] =
    {field_argument, 0},
    {field_field, 2},
  [46] =
    {field_type, 0, .inherited = true},
  [47] =
    {field_declarator, 2},
    {field_type, 0},
  [49] =
    {field_declarator, 2},
    {field_type, 1},
  [51] =
    {field_name, 1},
    {field_value, 2},
  [53] =
    {field_name, 1},
    {field_parameters, 2},
  [55] =
    {field_condition, 1},
  [56] =
    {field_alternative, 2},
    {field_name, 1},
  [58] =
    {field_type, 1},
    {field_value, 3},
  [60] =
    {field_body, 3},
    {field_name, 2},
  [62] =
    {field_type, 2},
  [63] =
    {field_name, 0},
    {field_type, 2},
  [65] =
    {field_declarator, 2},
  [66] =
    {field_declarator, 0},
  [67] =
    {field_declarator, 0},
    {field_value, 2},
  [69] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [72] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [74] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [77] =
    {field_argument, 0},
    {field_index, 2},
  [79] =
    {field_size, 1},
  [80] =
    {field_declarator, 3},
    {field_type, 1},
  [82] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [85] =
    {field_alternative, 3},
    {field_condition, 1},
  [87] =
    {field_alternative, 3},
    {field_name, 1},
  [89] =
    {field_declarator, 2},
    {field_declarator, 3, .inherited = true},
    {field_type, 1},
  [92] =
    {field_declarator, 3},
    {field_type, 2},
  [94] =
    {field_name, 0},
    {field_value, 2},
  [96] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [99] =
    {field_body, 1},
    {field_condition, 3},
  [101] =
    {field_declarator, 3},
  [102] =
    {field_declarator, 0},
    {field_size, 2},
  [104] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [107] =
    {field_size, 2},
  [108] =
    {field_alternative, 4},
    {field_condition, 1},
  [110] =
    {field_declarator, 3},
    {field_declarator, 4, .inherited = true},
    {field_type, 2},
  [113] =
    {field_initializer, 2},
  [114] =
    {field_declarator, 4},
  [115] =
    {field_declarator, 0},
    {field_size, 3},
  [117] =
    {field_designator, 0},
    {field_value, 2},
  [119] =
    {field_update, 4},
  [120] =
    {field_condition, 3},
  [121] =
    {field_initializer, 2},
    {field_update, 4},
  [123] =
    {field_condition, 3},
    {field_initializer, 2},
  [125] =
    {field_condition, 3},
    {field_update, 5},
  [127] =
    {field_condition, 3},
    {field_initializer, 2},
    {field_update, 5},
  [130] =
    {field_initializer, 2},
    {field_update, 5},
  [132] =
    {field_condition, 4},
    {field_initializer, 2},
  [134] =
    {field_condition, 4},
    {field_initializer, 2},
    {field_update, 6},
};

static TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [5] = {
    [1] = alias_sym_type_identifier,
  },
  [11] = {
    [1] = alias_sym_type_identifier,
  },
  [19] = {
    [1] = alias_sym_type_identifier,
  },
  [20] = {
    [2] = alias_sym_type_identifier,
  },
  [24] = {
    [1] = alias_sym_statement_identifier,
  },
  [26] = {
    [0] = alias_sym_statement_identifier,
  },
  [32] = {
    [2] = alias_sym_field_identifier,
  },
  [41] = {
    [0] = alias_sym_field_identifier,
  },
  [42] = {
    [2] = alias_sym_type_identifier,
  },
  [67] = {
    [1] = alias_sym_field_identifier,
  },
};

static uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(81);
      if (lookahead == '!') ADVANCE(137);
      if (lookahead == '"') ADVANCE(229);
      if (lookahead == '#') ADVANCE(46);
      if (lookahead == '%') ADVANCE(154);
      if (lookahead == '&') ADVANCE(163);
      if (lookahead == '\'') ADVANCE(220);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(150);
      if (lookahead == '+') ADVANCE(145);
      if (lookahead == ',') ADVANCE(88);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(198);
      if (lookahead == '/') ADVANCE(152);
      if (lookahead == '0') ADVANCE(205);
      if (lookahead == ':') ADVANCE(183);
      if (lookahead == ';') ADVANCE(176);
      if (lookahead == '<') ADVANCE(170);
      if (lookahead == '=') ADVANCE(182);
      if (lookahead == '>') ADVANCE(166);
      if (lookahead == '?') ADVANCE(184);
      if (lookahead == 'L') ADVANCE(241);
      if (lookahead == 'U') ADVANCE(243);
      if (lookahead == '[') ADVANCE(179);
      if (lookahead == '\\') SKIP(73)
      if (lookahead == ']') ADVANCE(180);
      if (lookahead == '^') ADVANCE(160);
      if (lookahead == 'u') ADVANCE(245);
      if (lookahead == '{') ADVANCE(177);
      if (lookahead == '|') ADVANCE(157);
      if (lookahead == '}') ADVANCE(178);
      if (lookahead == '~') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(78)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(26)
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(26)
      if (lookahead == '\r') SKIP(1)
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(25)
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(25)
      if (lookahead == '\r') SKIP(3)
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(30)
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(30)
      if (lookahead == '\r') SKIP(5)
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(29)
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(29)
      if (lookahead == '\r') SKIP(7)
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(33)
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(33)
      if (lookahead == '\r') SKIP(9)
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(28)
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(28)
      if (lookahead == '\r') SKIP(11)
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(15)
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(15)
      if (lookahead == '\r') SKIP(13)
      END_STATE();
    case 15:
      if (lookahead == '\n') ADVANCE(83);
      if (lookahead == '!') ADVANCE(42);
      if (lookahead == '%') ADVANCE(153);
      if (lookahead == '&') ADVANCE(162);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == '*') ADVANCE(149);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead == '<') ADVANCE(171);
      if (lookahead == '=') ADVANCE(43);
      if (lookahead == '>') ADVANCE(167);
      if (lookahead == '\\') SKIP(14)
      if (lookahead == '^') ADVANCE(159);
      if (lookahead == '|') ADVANCE(158);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(15)
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(31)
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(31)
      if (lookahead == '\r') SKIP(16)
      END_STATE();
    case 18:
      if (lookahead == '\n') ADVANCE(84);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == '/') ADVANCE(128);
      if (lookahead == '\\') ADVANCE(126);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(125);
      if (lookahead != 0) ADVANCE(129);
      END_STATE();
    case 19:
      if (lookahead == '\n') ADVANCE(84);
      if (lookahead == '/') ADVANCE(128);
      if (lookahead == '\\') ADVANCE(126);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(125);
      if (lookahead != 0) ADVANCE(129);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(32)
      if (lookahead == '"') ADVANCE(229);
      if (lookahead == '/') ADVANCE(230);
      if (lookahead == '\\') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(233);
      if (lookahead != 0) ADVANCE(234);
      END_STATE();
    case 21:
      if (lookahead == '\n') ADVANCE(236);
      if (lookahead == '\r') ADVANCE(235);
      if (lookahead == 'U') ADVANCE(70);
      if (lookahead == 'u') ADVANCE(66);
      if (lookahead == 'x') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      if (lookahead != 0) ADVANCE(235);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(41)
      if (lookahead == '/') ADVANCE(223);
      if (lookahead == '\\') ADVANCE(222);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(224);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(221);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(27)
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(27)
      if (lookahead == '\r') SKIP(23)
      END_STATE();
    case 25:
      if (lookahead == '!') ADVANCE(137);
      if (lookahead == '"') ADVANCE(229);
      if (lookahead == '#') ADVANCE(53);
      if (lookahead == '%') ADVANCE(154);
      if (lookahead == '&') ADVANCE(163);
      if (lookahead == '\'') ADVANCE(220);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(150);
      if (lookahead == '+') ADVANCE(145);
      if (lookahead == ',') ADVANCE(88);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(199);
      if (lookahead == '/') ADVANCE(152);
      if (lookahead == '0') ADVANCE(205);
      if (lookahead == ':') ADVANCE(183);
      if (lookahead == ';') ADVANCE(176);
      if (lookahead == '<') ADVANCE(170);
      if (lookahead == '=') ADVANCE(182);
      if (lookahead == '>') ADVANCE(166);
      if (lookahead == '?') ADVANCE(184);
      if (lookahead == 'L') ADVANCE(241);
      if (lookahead == 'U') ADVANCE(243);
      if (lookahead == '[') ADVANCE(179);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == ']') ADVANCE(180);
      if (lookahead == '^') ADVANCE(160);
      if (lookahead == 'u') ADVANCE(245);
      if (lookahead == '{') ADVANCE(177);
      if (lookahead == '|') ADVANCE(157);
      if (lookahead == '}') ADVANCE(178);
      if (lookahead == '~') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(25)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 26:
      if (lookahead == '!') ADVANCE(136);
      if (lookahead == '"') ADVANCE(229);
      if (lookahead == '#') ADVANCE(46);
      if (lookahead == '&') ADVANCE(161);
      if (lookahead == '\'') ADVANCE(220);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == '*') ADVANCE(149);
      if (lookahead == '+') ADVANCE(146);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '/') ADVANCE(34);
      if (lookahead == '0') ADVANCE(205);
      if (lookahead == ';') ADVANCE(176);
      if (lookahead == 'L') ADVANCE(241);
      if (lookahead == 'U') ADVANCE(243);
      if (lookahead == '\\') SKIP(2)
      if (lookahead == 'u') ADVANCE(245);
      if (lookahead == '{') ADVANCE(177);
      if (lookahead == '~') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(26)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 27:
      if (lookahead == '!') ADVANCE(136);
      if (lookahead == '"') ADVANCE(229);
      if (lookahead == '#') ADVANCE(48);
      if (lookahead == '&') ADVANCE(161);
      if (lookahead == '\'') ADVANCE(220);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == '*') ADVANCE(149);
      if (lookahead == '+') ADVANCE(146);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '/') ADVANCE(34);
      if (lookahead == '0') ADVANCE(205);
      if (lookahead == ';') ADVANCE(176);
      if (lookahead == 'L') ADVANCE(241);
      if (lookahead == 'U') ADVANCE(243);
      if (lookahead == '\\') SKIP(24)
      if (lookahead == 'u') ADVANCE(245);
      if (lookahead == '{') ADVANCE(177);
      if (lookahead == '~') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(27)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 28:
      if (lookahead == '!') ADVANCE(136);
      if (lookahead == '\'') ADVANCE(220);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '+') ADVANCE(148);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '/') ADVANCE(34);
      if (lookahead == '0') ADVANCE(205);
      if (lookahead == 'L') ADVANCE(249);
      if (lookahead == 'U') ADVANCE(250);
      if (lookahead == '\\') SKIP(12)
      if (lookahead == 'u') ADVANCE(251);
      if (lookahead == '~') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(28)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 29:
      if (lookahead == '!') ADVANCE(42);
      if (lookahead == '"') ADVANCE(229);
      if (lookahead == '%') ADVANCE(154);
      if (lookahead == '&') ADVANCE(163);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(150);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == ',') ADVANCE(88);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '.') ADVANCE(197);
      if (lookahead == '/') ADVANCE(152);
      if (lookahead == ':') ADVANCE(183);
      if (lookahead == ';') ADVANCE(176);
      if (lookahead == '<') ADVANCE(170);
      if (lookahead == '=') ADVANCE(182);
      if (lookahead == '>') ADVANCE(166);
      if (lookahead == '?') ADVANCE(184);
      if (lookahead == 'L') ADVANCE(242);
      if (lookahead == 'U') ADVANCE(244);
      if (lookahead == '[') ADVANCE(179);
      if (lookahead == '\\') SKIP(8)
      if (lookahead == ']') ADVANCE(180);
      if (lookahead == '^') ADVANCE(160);
      if (lookahead == 'u') ADVANCE(246);
      if (lookahead == '|') ADVANCE(157);
      if (lookahead == '}') ADVANCE(178);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(29)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 30:
      if (lookahead == '!') ADVANCE(42);
      if (lookahead == '#') ADVANCE(51);
      if (lookahead == '%') ADVANCE(153);
      if (lookahead == '&') ADVANCE(162);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(149);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == ',') ADVANCE(88);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead == '<') ADVANCE(171);
      if (lookahead == '=') ADVANCE(43);
      if (lookahead == '>') ADVANCE(167);
      if (lookahead == '[') ADVANCE(179);
      if (lookahead == '\\') SKIP(6)
      if (lookahead == '^') ADVANCE(159);
      if (lookahead == '|') ADVANCE(158);
      if (lookahead == '}') ADVANCE(178);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(30)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 31:
      if (lookahead == '"') ADVANCE(229);
      if (lookahead == '/') ADVANCE(34);
      if (lookahead == '<') ADVANCE(44);
      if (lookahead == 'L') ADVANCE(242);
      if (lookahead == 'U') ADVANCE(244);
      if (lookahead == '\\') SKIP(17)
      if (lookahead == 'u') ADVANCE(246);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(31)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 32:
      if (lookahead == '"') ADVANCE(229);
      if (lookahead == '/') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(32)
      END_STATE();
    case 33:
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '/') ADVANCE(34);
      if (lookahead == '\\') SKIP(10)
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(33)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 34:
      if (lookahead == '*') ADVANCE(36);
      if (lookahead == '/') ADVANCE(256);
      END_STATE();
    case 35:
      if (lookahead == '*') ADVANCE(35);
      if (lookahead == '/') ADVANCE(254);
      if (lookahead != 0) ADVANCE(36);
      END_STATE();
    case 36:
      if (lookahead == '*') ADVANCE(35);
      if (lookahead != 0) ADVANCE(36);
      END_STATE();
    case 37:
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '0') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(212);
      END_STATE();
    case 38:
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '0') ADVANCE(206);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 39:
      if (lookahead == '.') ADVANCE(40);
      END_STATE();
    case 40:
      if (lookahead == '.') ADVANCE(87);
      END_STATE();
    case 41:
      if (lookahead == '/') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(41)
      END_STATE();
    case 42:
      if (lookahead == '=') ADVANCE(165);
      END_STATE();
    case 43:
      if (lookahead == '=') ADVANCE(164);
      END_STATE();
    case 44:
      if (lookahead == '>') ADVANCE(239);
      if (lookahead == '\\') ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == '>') ADVANCE(240);
      if (lookahead == '\\') ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(44);
      END_STATE();
    case 46:
      if (lookahead == 'd') ADVANCE(101);
      if (lookahead == 'e') ADVANCE(117);
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(46);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 47:
      if (lookahead == 'd') ADVANCE(101);
      if (lookahead == 'e') ADVANCE(117);
      if (lookahead == 'i') ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(47);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 48:
      if (lookahead == 'd') ADVANCE(101);
      if (lookahead == 'e') ADVANCE(119);
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(48);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(101);
      if (lookahead == 'e') ADVANCE(119);
      if (lookahead == 'i') ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 50:
      if (lookahead == 'd') ADVANCE(101);
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(50);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 51:
      if (lookahead == 'd') ADVANCE(101);
      if (lookahead == 'i') ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(51);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(55);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(56);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(53);
      END_STATE();
    case 54:
      if (lookahead == 'f') ADVANCE(91);
      END_STATE();
    case 55:
      if (lookahead == 'i') ADVANCE(54);
      END_STATE();
    case 56:
      if (lookahead == 'n') ADVANCE(52);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(201);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(212);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(209);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(212);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(202);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(235);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 67:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(69);
      END_STATE();
    case 71:
      if (lookahead != 0 &&
          lookahead != '\r') ADVANCE(256);
      if (lookahead == '\r') ADVANCE(258);
      END_STATE();
    case 72:
      if (eof) ADVANCE(81);
      if (lookahead == '\n') SKIP(78)
      END_STATE();
    case 73:
      if (eof) ADVANCE(81);
      if (lookahead == '\n') SKIP(78)
      if (lookahead == '\r') SKIP(72)
      END_STATE();
    case 74:
      if (eof) ADVANCE(81);
      if (lookahead == '\n') SKIP(79)
      END_STATE();
    case 75:
      if (eof) ADVANCE(81);
      if (lookahead == '\n') SKIP(79)
      if (lookahead == '\r') SKIP(74)
      END_STATE();
    case 76:
      if (eof) ADVANCE(81);
      if (lookahead == '\n') SKIP(80)
      END_STATE();
    case 77:
      if (eof) ADVANCE(81);
      if (lookahead == '\n') SKIP(80)
      if (lookahead == '\r') SKIP(76)
      END_STATE();
    case 78:
      if (eof) ADVANCE(81);
      if (lookahead == '!') ADVANCE(137);
      if (lookahead == '"') ADVANCE(229);
      if (lookahead == '#') ADVANCE(46);
      if (lookahead == '%') ADVANCE(154);
      if (lookahead == '&') ADVANCE(163);
      if (lookahead == '\'') ADVANCE(220);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(150);
      if (lookahead == '+') ADVANCE(145);
      if (lookahead == ',') ADVANCE(88);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(198);
      if (lookahead == '/') ADVANCE(152);
      if (lookahead == '0') ADVANCE(205);
      if (lookahead == ':') ADVANCE(183);
      if (lookahead == ';') ADVANCE(176);
      if (lookahead == '<') ADVANCE(170);
      if (lookahead == '=') ADVANCE(182);
      if (lookahead == '>') ADVANCE(166);
      if (lookahead == '?') ADVANCE(184);
      if (lookahead == 'L') ADVANCE(241);
      if (lookahead == 'U') ADVANCE(243);
      if (lookahead == '[') ADVANCE(179);
      if (lookahead == '\\') SKIP(73)
      if (lookahead == ']') ADVANCE(180);
      if (lookahead == '^') ADVANCE(160);
      if (lookahead == 'u') ADVANCE(245);
      if (lookahead == '{') ADVANCE(177);
      if (lookahead == '|') ADVANCE(157);
      if (lookahead == '}') ADVANCE(178);
      if (lookahead == '~') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(78)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 79:
      if (eof) ADVANCE(81);
      if (lookahead == '!') ADVANCE(136);
      if (lookahead == '"') ADVANCE(229);
      if (lookahead == '#') ADVANCE(50);
      if (lookahead == '&') ADVANCE(161);
      if (lookahead == '\'') ADVANCE(220);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(149);
      if (lookahead == '+') ADVANCE(146);
      if (lookahead == ',') ADVANCE(88);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '.') ADVANCE(199);
      if (lookahead == '/') ADVANCE(34);
      if (lookahead == '0') ADVANCE(205);
      if (lookahead == ':') ADVANCE(183);
      if (lookahead == ';') ADVANCE(176);
      if (lookahead == '=') ADVANCE(181);
      if (lookahead == 'L') ADVANCE(241);
      if (lookahead == 'U') ADVANCE(243);
      if (lookahead == '[') ADVANCE(179);
      if (lookahead == '\\') SKIP(75)
      if (lookahead == ']') ADVANCE(180);
      if (lookahead == 'u') ADVANCE(245);
      if (lookahead == '{') ADVANCE(177);
      if (lookahead == '}') ADVANCE(178);
      if (lookahead == '~') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(79)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 80:
      if (eof) ADVANCE(81);
      if (lookahead == '!') ADVANCE(42);
      if (lookahead == '#') ADVANCE(47);
      if (lookahead == '%') ADVANCE(154);
      if (lookahead == '&') ADVANCE(163);
      if (lookahead == '(') ADVANCE(135);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(150);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == ',') ADVANCE(88);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '.') ADVANCE(197);
      if (lookahead == '/') ADVANCE(152);
      if (lookahead == ':') ADVANCE(183);
      if (lookahead == ';') ADVANCE(176);
      if (lookahead == '<') ADVANCE(170);
      if (lookahead == '=') ADVANCE(182);
      if (lookahead == '>') ADVANCE(166);
      if (lookahead == '?') ADVANCE(184);
      if (lookahead == '[') ADVANCE(179);
      if (lookahead == '\\') SKIP(77)
      if (lookahead == ']') ADVANCE(180);
      if (lookahead == '^') ADVANCE(160);
      if (lookahead == '{') ADVANCE(177);
      if (lookahead == '|') ADVANCE(157);
      if (lookahead == '}') ADVANCE(178);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(80)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(83);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(126);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(125);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(105);
      if (lookahead == 'n') ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(90);
      if (lookahead == 'n') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(94);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(120);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(110);
      if (lookahead == 's') ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(115);
      if (lookahead == 'n') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(36);
      if (lookahead == '*') ADVANCE(123);
      if (lookahead == '/') ADVANCE(254);
      if (lookahead == '\\') ADVANCE(130);
      if (lookahead != 0) ADVANCE(124);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(36);
      if (lookahead == '*') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(130);
      if (lookahead != 0) ADVANCE(124);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(84);
      if (lookahead == '/') ADVANCE(128);
      if (lookahead == '\\') ADVANCE(126);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(125);
      if (lookahead != 0) ADVANCE(129);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(125);
      if (lookahead == '\r') ADVANCE(127);
      if (lookahead == '\\') ADVANCE(131);
      if (lookahead != 0) ADVANCE(129);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(125);
      if (lookahead == '\\') ADVANCE(131);
      if (lookahead != 0) ADVANCE(129);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(124);
      if (lookahead == '/') ADVANCE(257);
      if (lookahead == '\\') ADVANCE(131);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(129);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\\') ADVANCE(131);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(129);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '*' &&
          lookahead != '\\') ADVANCE(124);
      if (lookahead == '\r') ADVANCE(133);
      if (lookahead == '*') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(130);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(129);
      if (lookahead == '\r') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(131);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(257);
      if (lookahead == '\r') ADVANCE(259);
      if (lookahead == '\\') ADVANCE(255);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '\\') ADVANCE(124);
      if (lookahead == '*') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(130);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(129);
      if (lookahead == '\\') ADVANCE(131);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(165);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(195);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '0') ADVANCE(205);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == '>') ADVANCE(200);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(195);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '0') ADVANCE(205);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(195);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == '>') ADVANCE(200);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '0') ADVANCE(205);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(196);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '0') ADVANCE(205);
      if (lookahead == '=') ADVANCE(188);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(196);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '0') ADVANCE(205);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(196);
      if (lookahead == '=') ADVANCE(188);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '0') ADVANCE(205);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(185);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(36);
      if (lookahead == '/') ADVANCE(256);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(36);
      if (lookahead == '/') ADVANCE(256);
      if (lookahead == '=') ADVANCE(186);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(187);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(194);
      if (lookahead == '|') ADVANCE(155);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(155);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(193);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(156);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(156);
      if (lookahead == '=') ADVANCE(192);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(168);
      if (lookahead == '>') ADVANCE(175);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(168);
      if (lookahead == '>') ADVANCE(174);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(173);
      if (lookahead == '=') ADVANCE(169);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(172);
      if (lookahead == '=') ADVANCE(169);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(190);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(191);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(164);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(201);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(201);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(58);
      if (lookahead == 'F' ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'f' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(201);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(62);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(202);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(202);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(59);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(212);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (lookahead == 'b') ADVANCE(211);
      if (lookahead == 'x') ADVANCE(61);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(210);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(214);
      if (('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(212);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(204);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(59);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(212);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(210);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(214);
      if (('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(212);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(57);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == 'F' ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'f' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (lookahead == 'b') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(37);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(57);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == 'F' ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'f' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (lookahead == 'b') ADVANCE(57);
      if (lookahead == 'x') ADVANCE(61);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(57);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == 'F' ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'f' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(209);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(62);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(208);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(209);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(209);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(208);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(209);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(61);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(212);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(62);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(210);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(212);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(61);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(212);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(210);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(214);
      if (('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(212);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(204);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(61);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(212);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(210);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(212);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(209);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(208);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(209);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(202);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(202);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'F' ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'f' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(215);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(236);
      if (lookahead == '\r') ADVANCE(235);
      if (lookahead == 'U') ADVANCE(70);
      if (lookahead == 'u') ADVANCE(66);
      if (lookahead == 'x') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      if (lookahead != 0) ADVANCE(235);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(36);
      if (lookahead == '/') ADVANCE(256);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(21);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(232);
      if (lookahead == '/') ADVANCE(234);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(234);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(231);
      if (lookahead == '/') ADVANCE(234);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(232);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(231);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(232);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(230);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(233);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(234);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(234);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(21);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(237);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(239);
      if (lookahead == '\\') ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(44);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(225);
      if (lookahead == '\'') ADVANCE(216);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(225);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(227);
      if (lookahead == '\'') ADVANCE(218);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(227);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(226);
      if (lookahead == '\'') ADVANCE(217);
      if (lookahead == '8') ADVANCE(247);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(226);
      if (lookahead == '8') ADVANCE(248);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(228);
      if (lookahead == '\'') ADVANCE(219);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(228);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(216);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(218);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(217);
      if (lookahead == '8') ADVANCE(252);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(219);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(253);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(257);
      if (lookahead == '\\') ADVANCE(132);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(257);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(71);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(256);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(132);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(257);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(256);
      if (lookahead == '\\') ADVANCE(71);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(257);
      if (lookahead == '\\') ADVANCE(132);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == '_') ADVANCE(5);
      if (lookahead == 'a') ADVANCE(6);
      if (lookahead == 'b') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 'd') ADVANCE(9);
      if (lookahead == 'e') ADVANCE(10);
      if (lookahead == 'f') ADVANCE(11);
      if (lookahead == 'g') ADVANCE(12);
      if (lookahead == 'i') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'A') ADVANCE(21);
      END_STATE();
    case 2:
      if (lookahead == 'U') ADVANCE(22);
      END_STATE();
    case 3:
      if (lookahead == 'R') ADVANCE(23);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(24)
      END_STATE();
    case 5:
      if (lookahead == 'A') ADVANCE(25);
      if (lookahead == '_') ADVANCE(26);
      if (lookahead == 'u') ADVANCE(27);
      END_STATE();
    case 6:
      if (lookahead == 'u') ADVANCE(28);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(29);
      if (lookahead == 'r') ADVANCE(30);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(31);
      if (lookahead == 'h') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(34);
      if (lookahead == 'o') ADVANCE(35);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(36);
      if (lookahead == 'n') ADVANCE(37);
      if (lookahead == 'x') ADVANCE(38);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(39);
      if (lookahead == 'l') ADVANCE(40);
      if (lookahead == 'o') ADVANCE(41);
      END_STATE();
    case 12:
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(44);
      END_STATE();
    case 14:
      if (lookahead == 'o') ADVANCE(45);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(46);
      END_STATE();
    case 16:
      if (lookahead == 'h') ADVANCE(47);
      if (lookahead == 'i') ADVANCE(48);
      if (lookahead == 's') ADVANCE(49);
      if (lookahead == 't') ADVANCE(50);
      if (lookahead == 'w') ADVANCE(51);
      END_STATE();
    case 17:
      if (lookahead == 'r') ADVANCE(52);
      if (lookahead == 'y') ADVANCE(53);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(54);
      if (lookahead == 'n') ADVANCE(55);
      END_STATE();
    case 19:
      if (lookahead == 'o') ADVANCE(56);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(57);
      END_STATE();
    case 21:
      if (lookahead == 'L') ADVANCE(58);
      END_STATE();
    case 22:
      if (lookahead == 'L') ADVANCE(59);
      END_STATE();
    case 23:
      if (lookahead == 'U') ADVANCE(60);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 25:
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 26:
      if (lookahead == 'T') ADVANCE(62);
      if (lookahead == 'V') ADVANCE(63);
      if (lookahead == 'a') ADVANCE(64);
      if (lookahead == 'b') ADVANCE(65);
      if (lookahead == 'c') ADVANCE(66);
      if (lookahead == 'd') ADVANCE(67);
      if (lookahead == 'f') ADVANCE(68);
      if (lookahead == 'r') ADVANCE(69);
      if (lookahead == 's') ADVANCE(70);
      if (lookahead == 't') ADVANCE(71);
      if (lookahead == 'u') ADVANCE(72);
      if (lookahead == 'v') ADVANCE(73);
      END_STATE();
    case 27:
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 28:
      if (lookahead == 't') ADVANCE(75);
      END_STATE();
    case 29:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(78);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(79);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(80);
      END_STATE();
    case 34:
      if (lookahead == 'f') ADVANCE(81);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(82);
      END_STATE();
    case 36:
      if (lookahead == 's') ADVANCE(83);
      END_STATE();
    case 37:
      if (lookahead == 'u') ADVANCE(84);
      END_STATE();
    case 38:
      if (lookahead == 't') ADVANCE(85);
      END_STATE();
    case 39:
      if (lookahead == 'l') ADVANCE(86);
      END_STATE();
    case 40:
      if (lookahead == 'o') ADVANCE(87);
      END_STATE();
    case 41:
      if (lookahead == 'r') ADVANCE(88);
      END_STATE();
    case 42:
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'l') ADVANCE(90);
      if (lookahead == 't') ADVANCE(91);
      END_STATE();
    case 45:
      if (lookahead == 'n') ADVANCE(92);
      END_STATE();
    case 46:
      if (lookahead == 'g') ADVANCE(93);
      if (lookahead == 's') ADVANCE(94);
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 47:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 48:
      if (lookahead == 'g') ADVANCE(97);
      if (lookahead == 'z') ADVANCE(98);
      END_STATE();
    case 49:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 50:
      if (lookahead == 'a') ADVANCE(100);
      if (lookahead == 'r') ADVANCE(101);
      END_STATE();
    case 51:
      if (lookahead == 'i') ADVANCE(102);
      END_STATE();
    case 52:
      if (lookahead == 'u') ADVANCE(103);
      END_STATE();
    case 53:
      if (lookahead == 'p') ADVANCE(104);
      END_STATE();
    case 54:
      if (lookahead == 'n') ADVANCE(105);
      END_STATE();
    case 55:
      if (lookahead == 'i') ADVANCE(106);
      if (lookahead == 's') ADVANCE(107);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(108);
      if (lookahead == 'l') ADVANCE(109);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(110);
      END_STATE();
    case 58:
      if (lookahead == 'S') ADVANCE(111);
      END_STATE();
    case 59:
      if (lookahead == 'L') ADVANCE(112);
      END_STATE();
    case 60:
      if (lookahead == 'E') ADVANCE(113);
      END_STATE();
    case 61:
      if (lookahead == 'o') ADVANCE(114);
      END_STATE();
    case 62:
      if (lookahead == 'Y') ADVANCE(115);
      END_STATE();
    case 63:
      if (lookahead == 'A') ADVANCE(116);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(117);
      END_STATE();
    case 65:
      if (lookahead == 'a') ADVANCE(118);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(119);
      if (lookahead == 'l') ADVANCE(120);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 68:
      if (lookahead == 'a') ADVANCE(122);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(123);
      END_STATE();
    case 70:
      if (lookahead == 'p') ADVANCE(124);
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 71:
      if (lookahead == 'h') ADVANCE(126);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(127);
      if (lookahead == 'p') ADVANCE(128);
      END_STATE();
    case 73:
      if (lookahead == 'e') ADVANCE(129);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(130);
      END_STATE();
    case 75:
      if (lookahead == 'o') ADVANCE(131);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(132);
      END_STATE();
    case 77:
      if (lookahead == 'a') ADVANCE(133);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(134);
      END_STATE();
    case 79:
      if (lookahead == 'r') ADVANCE(135);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(136);
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(138);
      if (lookahead == 'i') ADVANCE(139);
      END_STATE();
    case 82:
      if (lookahead == 'b') ADVANCE(140);
      END_STATE();
    case 83:
      if (lookahead == 'e') ADVANCE(141);
      END_STATE();
    case 84:
      if (lookahead == 'm') ADVANCE(142);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(143);
      END_STATE();
    case 86:
      if (lookahead == 's') ADVANCE(144);
      END_STATE();
    case 87:
      if (lookahead == 'a') ADVANCE(145);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 89:
      if (lookahead == 'o') ADVANCE(146);
      END_STATE();
    case 90:
      if (lookahead == 'i') ADVANCE(147);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(148);
      if (lookahead == '3') ADVANCE(149);
      if (lookahead == '6') ADVANCE(150);
      if (lookahead == '8') ADVANCE(151);
      if (lookahead == 'p') ADVANCE(152);
      END_STATE();
    case 92:
      if (lookahead == 'g') ADVANCE(153);
      END_STATE();
    case 93:
      if (lookahead == 'i') ADVANCE(154);
      END_STATE();
    case 94:
      if (lookahead == 't') ADVANCE(155);
      END_STATE();
    case 95:
      if (lookahead == 'u') ADVANCE(156);
      END_STATE();
    case 96:
      if (lookahead == 'r') ADVANCE(157);
      END_STATE();
    case 97:
      if (lookahead == 'n') ADVANCE(158);
      END_STATE();
    case 98:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 99:
      if (lookahead == 'z') ADVANCE(160);
      END_STATE();
    case 100:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 101:
      if (lookahead == 'u') ADVANCE(162);
      END_STATE();
    case 102:
      if (lookahead == 't') ADVANCE(163);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(113);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(165);
      END_STATE();
    case 106:
      if (lookahead == 'o') ADVANCE(166);
      END_STATE();
    case 107:
      if (lookahead == 'i') ADVANCE(167);
      END_STATE();
    case 108:
      if (lookahead == 'd') ADVANCE(132);
      END_STATE();
    case 109:
      if (lookahead == 'a') ADVANCE(168);
      END_STATE();
    case 110:
      if (lookahead == 'l') ADVANCE(169);
      END_STATE();
    case 111:
      if (lookahead == 'E') ADVANCE(170);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 114:
      if (lookahead == 'm') ADVANCE(171);
      END_STATE();
    case 115:
      if (lookahead == 'P') ADVANCE(172);
      END_STATE();
    case 116:
      if (lookahead == 'N') ADVANCE(173);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 118:
      if (lookahead == 's') ADVANCE(175);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 120:
      if (lookahead == 'r') ADVANCE(177);
      END_STATE();
    case 121:
      if (lookahead == 'c') ADVANCE(178);
      END_STATE();
    case 122:
      if (lookahead == 's') ADVANCE(179);
      END_STATE();
    case 123:
      if (lookahead == 's') ADVANCE(180);
      END_STATE();
    case 124:
      if (lookahead == 't') ADVANCE(181);
      END_STATE();
    case 125:
      if (lookahead == 'd') ADVANCE(182);
      END_STATE();
    case 126:
      if (lookahead == 'i') ADVANCE(183);
      END_STATE();
    case 127:
      if (lookahead == 'a') ADVANCE(184);
      END_STATE();
    case 128:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 129:
      if (lookahead == 'c') ADVANCE(186);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(187);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_auto);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_primitive_type);
      END_STATE();
    case 133:
      if (lookahead == 'k') ADVANCE(188);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(189);
      if (lookahead == '3') ADVANCE(190);
      if (lookahead == '6') ADVANCE(191);
      if (lookahead == '8') ADVANCE(192);
      if (lookahead == 'p') ADVANCE(193);
      END_STATE();
    case 136:
      if (lookahead == 't') ADVANCE(194);
      END_STATE();
    case 137:
      if (lookahead == 'i') ADVANCE(195);
      END_STATE();
    case 138:
      if (lookahead == 'u') ADVANCE(196);
      END_STATE();
    case 139:
      if (lookahead == 'n') ADVANCE(197);
      END_STATE();
    case 140:
      if (lookahead == 'l') ADVANCE(198);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 143:
      if (lookahead == 'r') ADVANCE(199);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 145:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 147:
      if (lookahead == 'n') ADVANCE(200);
      END_STATE();
    case 148:
      if (lookahead == '6') ADVANCE(201);
      END_STATE();
    case 149:
      if (lookahead == '2') ADVANCE(202);
      END_STATE();
    case 150:
      if (lookahead == '4') ADVANCE(203);
      END_STATE();
    case 151:
      if (lookahead == '_') ADVANCE(204);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(205);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 154:
      if (lookahead == 's') ADVANCE(206);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(207);
      END_STATE();
    case 156:
      if (lookahead == 'r') ADVANCE(208);
      END_STATE();
    case 157:
      if (lookahead == 't') ADVANCE(209);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 159:
      if (lookahead == '_') ADVANCE(211);
      if (lookahead == 'o') ADVANCE(212);
      END_STATE();
    case 160:
      if (lookahead == 'e') ADVANCE(213);
      END_STATE();
    case 161:
      if (lookahead == 'i') ADVANCE(214);
      END_STATE();
    case 162:
      if (lookahead == 'c') ADVANCE(215);
      END_STATE();
    case 163:
      if (lookahead == 'c') ADVANCE(216);
      END_STATE();
    case 164:
      if (lookahead == 'd') ADVANCE(217);
      END_STATE();
    case 165:
      if (lookahead == '1') ADVANCE(218);
      if (lookahead == '3') ADVANCE(219);
      if (lookahead == '6') ADVANCE(220);
      if (lookahead == '8') ADVANCE(221);
      if (lookahead == 'p') ADVANCE(222);
      END_STATE();
    case 166:
      if (lookahead == 'n') ADVANCE(223);
      END_STATE();
    case 167:
      if (lookahead == 'g') ADVANCE(224);
      END_STATE();
    case 168:
      if (lookahead == 't') ADVANCE(225);
      END_STATE();
    case 169:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 171:
      if (lookahead == 'i') ADVANCE(227);
      END_STATE();
    case 172:
      if (lookahead == 'E') ADVANCE(228);
      END_STATE();
    case 173:
      if (lookahead == 'I') ADVANCE(229);
      END_STATE();
    case 174:
      if (lookahead == 'r') ADVANCE(230);
      END_STATE();
    case 175:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 176:
      if (lookahead == 'c') ADVANCE(232);
      END_STATE();
    case 177:
      if (lookahead == 'c') ADVANCE(233);
      END_STATE();
    case 178:
      if (lookahead == 'l') ADVANCE(234);
      END_STATE();
    case 179:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 180:
      if (lookahead == 't') ADVANCE(236);
      END_STATE();
    case 181:
      if (lookahead == 'r') ADVANCE(237);
      END_STATE();
    case 182:
      if (lookahead == 'c') ADVANCE(238);
      END_STATE();
    case 183:
      if (lookahead == 's') ADVANCE(239);
      END_STATE();
    case 184:
      if (lookahead == 'l') ADVANCE(240);
      END_STATE();
    case 185:
      if (lookahead == 'r') ADVANCE(241);
      END_STATE();
    case 186:
      if (lookahead == 't') ADVANCE(242);
      END_STATE();
    case 187:
      if (lookahead == 'i') ADVANCE(243);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 189:
      if (lookahead == '6') ADVANCE(244);
      END_STATE();
    case 190:
      if (lookahead == '2') ADVANCE(245);
      END_STATE();
    case 191:
      if (lookahead == '4') ADVANCE(246);
      END_STATE();
    case 192:
      if (lookahead == '_') ADVANCE(247);
      END_STATE();
    case 193:
      if (lookahead == 't') ADVANCE(248);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 195:
      if (lookahead == 'n') ADVANCE(249);
      END_STATE();
    case 196:
      if (lookahead == 'l') ADVANCE(250);
      END_STATE();
    case 197:
      if (lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 198:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 199:
      if (lookahead == 'n') ADVANCE(252);
      END_STATE();
    case 200:
      if (lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 201:
      if (lookahead == '_') ADVANCE(254);
      END_STATE();
    case 202:
      if (lookahead == '_') ADVANCE(255);
      END_STATE();
    case 203:
      if (lookahead == '_') ADVANCE(256);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 205:
      if (lookahead == 'r') ADVANCE(257);
      END_STATE();
    case 206:
      if (lookahead == 't') ADVANCE(258);
      END_STATE();
    case 207:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 208:
      if (lookahead == 'n') ADVANCE(260);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 210:
      if (lookahead == 'd') ADVANCE(261);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 212:
      if (lookahead == 'f') ADVANCE(262);
      END_STATE();
    case 213:
      if (lookahead == '_') ADVANCE(263);
      END_STATE();
    case 214:
      if (lookahead == 'c') ADVANCE(264);
      END_STATE();
    case 215:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 216:
      if (lookahead == 'h') ADVANCE(266);
      END_STATE();
    case 217:
      if (lookahead == 'e') ADVANCE(267);
      END_STATE();
    case 218:
      if (lookahead == '6') ADVANCE(268);
      END_STATE();
    case 219:
      if (lookahead == '2') ADVANCE(269);
      END_STATE();
    case 220:
      if (lookahead == '4') ADVANCE(270);
      END_STATE();
    case 221:
      if (lookahead == '_') ADVANCE(271);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(272);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 224:
      if (lookahead == 'n') ADVANCE(273);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(274);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      if (lookahead == 'c') ADVANCE(275);
      END_STATE();
    case 228:
      if (lookahead == '_') ADVANCE(276);
      END_STATE();
    case 229:
      if (lookahead == 'L') ADVANCE(277);
      END_STATE();
    case 230:
      if (lookahead == 'i') ADVANCE(278);
      END_STATE();
    case 231:
      if (lookahead == 'd') ADVANCE(279);
      END_STATE();
    case 232:
      if (lookahead == 'l') ADVANCE(280);
      END_STATE();
    case 233:
      if (lookahead == 'a') ADVANCE(281);
      END_STATE();
    case 234:
      if (lookahead == 's') ADVANCE(282);
      END_STATE();
    case 235:
      if (lookahead == 'c') ADVANCE(283);
      END_STATE();
    case 236:
      if (lookahead == 'r') ADVANCE(284);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 238:
      if (lookahead == 'a') ADVANCE(285);
      END_STATE();
    case 239:
      if (lookahead == 'c') ADVANCE(286);
      END_STATE();
    case 240:
      if (lookahead == 'i') ADVANCE(287);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 242:
      if (lookahead == 'o') ADVANCE(288);
      END_STATE();
    case 243:
      if (lookahead == 'g') ADVANCE(289);
      END_STATE();
    case 244:
      if (lookahead == '_') ADVANCE(290);
      END_STATE();
    case 245:
      if (lookahead == '_') ADVANCE(291);
      END_STATE();
    case 246:
      if (lookahead == '_') ADVANCE(292);
      END_STATE();
    case 247:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 248:
      if (lookahead == 'r') ADVANCE(293);
      END_STATE();
    case 249:
      if (lookahead == 'u') ADVANCE(294);
      END_STATE();
    case 250:
      if (lookahead == 't') ADVANCE(295);
      END_STATE();
    case 251:
      if (lookahead == 'd') ADVANCE(296);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 254:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 255:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 256:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 257:
      if (lookahead == '_') ADVANCE(297);
      END_STATE();
    case 258:
      if (lookahead == 'e') ADVANCE(298);
      END_STATE();
    case 259:
      if (lookahead == 'c') ADVANCE(299);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 263:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 267:
      if (lookahead == 'f') ADVANCE(300);
      END_STATE();
    case 268:
      if (lookahead == '_') ADVANCE(301);
      END_STATE();
    case 269:
      if (lookahead == '_') ADVANCE(302);
      END_STATE();
    case 270:
      if (lookahead == '_') ADVANCE(303);
      END_STATE();
    case 271:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 272:
      if (lookahead == 'r') ADVANCE(304);
      END_STATE();
    case 273:
      if (lookahead == 'e') ADVANCE(305);
      END_STATE();
    case 274:
      if (lookahead == 'l') ADVANCE(306);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 276:
      if (lookahead == 'E') ADVANCE(307);
      END_STATE();
    case 277:
      if (lookahead == 'L') ADVANCE(308);
      END_STATE();
    case 278:
      if (lookahead == 'b') ADVANCE(309);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 281:
      if (lookahead == 'l') ADVANCE(310);
      END_STATE();
    case 282:
      if (lookahead == 'p') ADVANCE(311);
      END_STATE();
    case 283:
      if (lookahead == 'a') ADVANCE(312);
      END_STATE();
    case 284:
      if (lookahead == 'i') ADVANCE(313);
      END_STATE();
    case 285:
      if (lookahead == 'l') ADVANCE(314);
      END_STATE();
    case 286:
      if (lookahead == 'a') ADVANCE(315);
      END_STATE();
    case 287:
      if (lookahead == 'g') ADVANCE(316);
      END_STATE();
    case 288:
      if (lookahead == 'r') ADVANCE(317);
      END_STATE();
    case 289:
      if (lookahead == 'n') ADVANCE(318);
      END_STATE();
    case 290:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 291:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 292:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 293:
      if (lookahead == '_') ADVANCE(319);
      END_STATE();
    case 294:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 297:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 298:
      if (lookahead == 'r') ADVANCE(321);
      END_STATE();
    case 299:
      if (lookahead == 't') ADVANCE(322);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 301:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 302:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 303:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 304:
      if (lookahead == '_') ADVANCE(323);
      END_STATE();
    case 305:
      if (lookahead == 'd') ADVANCE(324);
      END_STATE();
    case 306:
      if (lookahead == 'e') ADVANCE(325);
      END_STATE();
    case 307:
      if (lookahead == 'X') ADVANCE(326);
      END_STATE();
    case 308:
      if (lookahead == 'A') ADVANCE(327);
      END_STATE();
    case 309:
      if (lookahead == 'u') ADVANCE(328);
      END_STATE();
    case 310:
      if (lookahead == 'l') ADVANCE(329);
      END_STATE();
    case 311:
      if (lookahead == 'e') ADVANCE(330);
      END_STATE();
    case 312:
      if (lookahead == 'l') ADVANCE(331);
      END_STATE();
    case 313:
      if (lookahead == 'c') ADVANCE(332);
      END_STATE();
    case 314:
      if (lookahead == 'l') ADVANCE(333);
      END_STATE();
    case 315:
      if (lookahead == 'l') ADVANCE(334);
      END_STATE();
    case 316:
      if (lookahead == 'n') ADVANCE(335);
      END_STATE();
    case 317:
      if (lookahead == 'c') ADVANCE(336);
      END_STATE();
    case 318:
      if (lookahead == 'e') ADVANCE(337);
      END_STATE();
    case 319:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 323:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 326:
      if (lookahead == 'P') ADVANCE(338);
      END_STATE();
    case 327:
      if (lookahead == '_') ADVANCE(339);
      END_STATE();
    case 328:
      if (lookahead == 't') ADVANCE(340);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 330:
      if (lookahead == 'c') ADVANCE(341);
      END_STATE();
    case 331:
      if (lookahead == 'l') ADVANCE(342);
      END_STATE();
    case 332:
      if (lookahead == 't') ADVANCE(343);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 334:
      if (lookahead == 'l') ADVANCE(344);
      END_STATE();
    case 335:
      if (lookahead == 'e') ADVANCE(345);
      END_STATE();
    case 336:
      if (lookahead == 'a') ADVANCE(346);
      END_STATE();
    case 337:
      if (lookahead == 'd') ADVANCE(347);
      END_STATE();
    case 338:
      if (lookahead == 'R') ADVANCE(348);
      END_STATE();
    case 339:
      if (lookahead == 'C') ADVANCE(349);
      END_STATE();
    case 340:
      if (lookahead == 'e') ADVANCE(350);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 345:
      if (lookahead == 'd') ADVANCE(351);
      END_STATE();
    case 346:
      if (lookahead == 'l') ADVANCE(352);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 348:
      if (lookahead == 'E') ADVANCE(353);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym___VANILLA_C);
      END_STATE();
    case 350:
      if (lookahead == '_') ADVANCE(354);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 352:
      if (lookahead == 'l') ADVANCE(355);
      END_STATE();
    case 353:
      if (lookahead == 'S') ADVANCE(356);
      END_STATE();
    case 354:
      if (lookahead == '_') ADVANCE(357);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 356:
      if (lookahead == 'S') ADVANCE(358);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 358:
      if (lookahead == 'I') ADVANCE(359);
      END_STATE();
    case 359:
      if (lookahead == 'O') ADVANCE(360);
      END_STATE();
    case 360:
      if (lookahead == 'N') ADVANCE(361);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym___TYPE_EXPRESSION);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 79},
  [2] = {.lex_state = 26},
  [3] = {.lex_state = 26},
  [4] = {.lex_state = 26},
  [5] = {.lex_state = 26},
  [6] = {.lex_state = 26},
  [7] = {.lex_state = 26},
  [8] = {.lex_state = 26},
  [9] = {.lex_state = 26},
  [10] = {.lex_state = 26},
  [11] = {.lex_state = 26},
  [12] = {.lex_state = 26},
  [13] = {.lex_state = 26},
  [14] = {.lex_state = 26},
  [15] = {.lex_state = 26},
  [16] = {.lex_state = 26},
  [17] = {.lex_state = 26},
  [18] = {.lex_state = 26},
  [19] = {.lex_state = 26},
  [20] = {.lex_state = 26},
  [21] = {.lex_state = 79},
  [22] = {.lex_state = 79},
  [23] = {.lex_state = 79},
  [24] = {.lex_state = 79},
  [25] = {.lex_state = 27},
  [26] = {.lex_state = 79},
  [27] = {.lex_state = 79},
  [28] = {.lex_state = 79},
  [29] = {.lex_state = 79},
  [30] = {.lex_state = 79},
  [31] = {.lex_state = 79},
  [32] = {.lex_state = 79},
  [33] = {.lex_state = 79},
  [34] = {.lex_state = 79},
  [35] = {.lex_state = 79},
  [36] = {.lex_state = 27},
  [37] = {.lex_state = 79},
  [38] = {.lex_state = 79},
  [39] = {.lex_state = 79},
  [40] = {.lex_state = 27},
  [41] = {.lex_state = 79},
  [42] = {.lex_state = 79},
  [43] = {.lex_state = 79},
  [44] = {.lex_state = 79},
  [45] = {.lex_state = 26},
  [46] = {.lex_state = 26},
  [47] = {.lex_state = 26},
  [48] = {.lex_state = 26},
  [49] = {.lex_state = 26},
  [50] = {.lex_state = 79},
  [51] = {.lex_state = 27},
  [52] = {.lex_state = 27},
  [53] = {.lex_state = 79},
  [54] = {.lex_state = 27},
  [55] = {.lex_state = 79},
  [56] = {.lex_state = 79},
  [57] = {.lex_state = 27},
  [58] = {.lex_state = 79},
  [59] = {.lex_state = 79},
  [60] = {.lex_state = 27},
  [61] = {.lex_state = 79},
  [62] = {.lex_state = 79},
  [63] = {.lex_state = 79},
  [64] = {.lex_state = 79},
  [65] = {.lex_state = 25},
  [66] = {.lex_state = 79},
  [67] = {.lex_state = 79},
  [68] = {.lex_state = 79},
  [69] = {.lex_state = 79},
  [70] = {.lex_state = 79},
  [71] = {.lex_state = 26},
  [72] = {.lex_state = 26},
  [73] = {.lex_state = 26},
  [74] = {.lex_state = 26},
  [75] = {.lex_state = 26},
  [76] = {.lex_state = 26},
  [77] = {.lex_state = 26},
  [78] = {.lex_state = 26},
  [79] = {.lex_state = 26},
  [80] = {.lex_state = 26},
  [81] = {.lex_state = 26},
  [82] = {.lex_state = 26},
  [83] = {.lex_state = 26},
  [84] = {.lex_state = 26},
  [85] = {.lex_state = 26},
  [86] = {.lex_state = 26},
  [87] = {.lex_state = 26},
  [88] = {.lex_state = 26},
  [89] = {.lex_state = 26},
  [90] = {.lex_state = 26},
  [91] = {.lex_state = 26},
  [92] = {.lex_state = 26},
  [93] = {.lex_state = 26},
  [94] = {.lex_state = 26},
  [95] = {.lex_state = 26},
  [96] = {.lex_state = 26},
  [97] = {.lex_state = 26},
  [98] = {.lex_state = 26},
  [99] = {.lex_state = 26},
  [100] = {.lex_state = 26},
  [101] = {.lex_state = 26},
  [102] = {.lex_state = 26},
  [103] = {.lex_state = 26},
  [104] = {.lex_state = 26},
  [105] = {.lex_state = 26},
  [106] = {.lex_state = 26},
  [107] = {.lex_state = 26},
  [108] = {.lex_state = 26},
  [109] = {.lex_state = 26},
  [110] = {.lex_state = 26},
  [111] = {.lex_state = 26},
  [112] = {.lex_state = 26},
  [113] = {.lex_state = 26},
  [114] = {.lex_state = 26},
  [115] = {.lex_state = 26},
  [116] = {.lex_state = 26},
  [117] = {.lex_state = 26},
  [118] = {.lex_state = 26},
  [119] = {.lex_state = 26},
  [120] = {.lex_state = 26},
  [121] = {.lex_state = 26},
  [122] = {.lex_state = 26},
  [123] = {.lex_state = 26},
  [124] = {.lex_state = 26},
  [125] = {.lex_state = 26},
  [126] = {.lex_state = 26},
  [127] = {.lex_state = 79},
  [128] = {.lex_state = 79},
  [129] = {.lex_state = 79},
  [130] = {.lex_state = 79},
  [131] = {.lex_state = 27},
  [132] = {.lex_state = 79},
  [133] = {.lex_state = 79},
  [134] = {.lex_state = 79},
  [135] = {.lex_state = 79},
  [136] = {.lex_state = 79},
  [137] = {.lex_state = 27},
  [138] = {.lex_state = 27},
  [139] = {.lex_state = 27},
  [140] = {.lex_state = 79},
  [141] = {.lex_state = 79},
  [142] = {.lex_state = 79},
  [143] = {.lex_state = 27},
  [144] = {.lex_state = 27},
  [145] = {.lex_state = 79},
  [146] = {.lex_state = 27},
  [147] = {.lex_state = 79},
  [148] = {.lex_state = 79},
  [149] = {.lex_state = 79},
  [150] = {.lex_state = 27},
  [151] = {.lex_state = 27},
  [152] = {.lex_state = 79},
  [153] = {.lex_state = 79},
  [154] = {.lex_state = 27},
  [155] = {.lex_state = 79},
  [156] = {.lex_state = 27},
  [157] = {.lex_state = 27},
  [158] = {.lex_state = 79},
  [159] = {.lex_state = 79},
  [160] = {.lex_state = 27},
  [161] = {.lex_state = 27},
  [162] = {.lex_state = 79},
  [163] = {.lex_state = 27},
  [164] = {.lex_state = 79},
  [165] = {.lex_state = 79},
  [166] = {.lex_state = 79},
  [167] = {.lex_state = 79},
  [168] = {.lex_state = 79},
  [169] = {.lex_state = 27},
  [170] = {.lex_state = 27},
  [171] = {.lex_state = 27},
  [172] = {.lex_state = 79},
  [173] = {.lex_state = 79},
  [174] = {.lex_state = 27},
  [175] = {.lex_state = 79},
  [176] = {.lex_state = 79},
  [177] = {.lex_state = 79},
  [178] = {.lex_state = 79},
  [179] = {.lex_state = 79},
  [180] = {.lex_state = 79},
  [181] = {.lex_state = 27},
  [182] = {.lex_state = 27},
  [183] = {.lex_state = 79},
  [184] = {.lex_state = 79},
  [185] = {.lex_state = 27},
  [186] = {.lex_state = 79},
  [187] = {.lex_state = 27},
  [188] = {.lex_state = 79},
  [189] = {.lex_state = 27},
  [190] = {.lex_state = 27},
  [191] = {.lex_state = 27},
  [192] = {.lex_state = 27},
  [193] = {.lex_state = 79},
  [194] = {.lex_state = 79},
  [195] = {.lex_state = 27},
  [196] = {.lex_state = 79},
  [197] = {.lex_state = 79},
  [198] = {.lex_state = 27},
  [199] = {.lex_state = 79},
  [200] = {.lex_state = 27},
  [201] = {.lex_state = 27},
  [202] = {.lex_state = 79},
  [203] = {.lex_state = 79},
  [204] = {.lex_state = 79},
  [205] = {.lex_state = 79},
  [206] = {.lex_state = 79},
  [207] = {.lex_state = 27},
  [208] = {.lex_state = 27},
  [209] = {.lex_state = 79},
  [210] = {.lex_state = 79},
  [211] = {.lex_state = 27},
  [212] = {.lex_state = 79},
  [213] = {.lex_state = 79},
  [214] = {.lex_state = 79},
  [215] = {.lex_state = 79},
  [216] = {.lex_state = 79},
  [217] = {.lex_state = 79},
  [218] = {.lex_state = 79},
  [219] = {.lex_state = 79},
  [220] = {.lex_state = 79},
  [221] = {.lex_state = 79},
  [222] = {.lex_state = 79},
  [223] = {.lex_state = 79},
  [224] = {.lex_state = 27},
  [225] = {.lex_state = 79},
  [226] = {.lex_state = 79},
  [227] = {.lex_state = 79},
  [228] = {.lex_state = 79},
  [229] = {.lex_state = 79},
  [230] = {.lex_state = 79},
  [231] = {.lex_state = 79},
  [232] = {.lex_state = 27},
  [233] = {.lex_state = 27},
  [234] = {.lex_state = 79},
  [235] = {.lex_state = 79},
  [236] = {.lex_state = 79},
  [237] = {.lex_state = 79},
  [238] = {.lex_state = 79},
  [239] = {.lex_state = 79},
  [240] = {.lex_state = 79},
  [241] = {.lex_state = 79},
  [242] = {.lex_state = 79},
  [243] = {.lex_state = 79},
  [244] = {.lex_state = 27},
  [245] = {.lex_state = 27},
  [246] = {.lex_state = 27},
  [247] = {.lex_state = 27},
  [248] = {.lex_state = 27},
  [249] = {.lex_state = 27},
  [250] = {.lex_state = 79},
  [251] = {.lex_state = 79},
  [252] = {.lex_state = 79},
  [253] = {.lex_state = 79},
  [254] = {.lex_state = 79},
  [255] = {.lex_state = 79},
  [256] = {.lex_state = 79},
  [257] = {.lex_state = 79},
  [258] = {.lex_state = 27},
  [259] = {.lex_state = 79},
  [260] = {.lex_state = 79},
  [261] = {.lex_state = 27},
  [262] = {.lex_state = 79},
  [263] = {.lex_state = 27},
  [264] = {.lex_state = 27},
  [265] = {.lex_state = 27},
  [266] = {.lex_state = 79},
  [267] = {.lex_state = 79},
  [268] = {.lex_state = 79},
  [269] = {.lex_state = 79},
  [270] = {.lex_state = 27},
  [271] = {.lex_state = 79},
  [272] = {.lex_state = 79},
  [273] = {.lex_state = 27},
  [274] = {.lex_state = 27},
  [275] = {.lex_state = 27},
  [276] = {.lex_state = 79},
  [277] = {.lex_state = 79},
  [278] = {.lex_state = 27},
  [279] = {.lex_state = 79},
  [280] = {.lex_state = 79},
  [281] = {.lex_state = 79},
  [282] = {.lex_state = 27},
  [283] = {.lex_state = 27},
  [284] = {.lex_state = 79},
  [285] = {.lex_state = 79},
  [286] = {.lex_state = 27},
  [287] = {.lex_state = 79},
  [288] = {.lex_state = 79},
  [289] = {.lex_state = 79},
  [290] = {.lex_state = 79},
  [291] = {.lex_state = 79},
  [292] = {.lex_state = 79},
  [293] = {.lex_state = 79},
  [294] = {.lex_state = 79},
  [295] = {.lex_state = 79},
  [296] = {.lex_state = 79},
  [297] = {.lex_state = 79},
  [298] = {.lex_state = 79},
  [299] = {.lex_state = 79},
  [300] = {.lex_state = 79},
  [301] = {.lex_state = 79},
  [302] = {.lex_state = 79},
  [303] = {.lex_state = 79},
  [304] = {.lex_state = 79},
  [305] = {.lex_state = 79},
  [306] = {.lex_state = 79},
  [307] = {.lex_state = 79},
  [308] = {.lex_state = 79},
  [309] = {.lex_state = 79},
  [310] = {.lex_state = 79},
  [311] = {.lex_state = 79},
  [312] = {.lex_state = 79},
  [313] = {.lex_state = 79},
  [314] = {.lex_state = 79},
  [315] = {.lex_state = 79},
  [316] = {.lex_state = 79},
  [317] = {.lex_state = 79},
  [318] = {.lex_state = 79},
  [319] = {.lex_state = 79},
  [320] = {.lex_state = 79},
  [321] = {.lex_state = 79},
  [322] = {.lex_state = 79},
  [323] = {.lex_state = 79},
  [324] = {.lex_state = 79},
  [325] = {.lex_state = 79},
  [326] = {.lex_state = 79},
  [327] = {.lex_state = 79},
  [328] = {.lex_state = 79},
  [329] = {.lex_state = 79},
  [330] = {.lex_state = 79},
  [331] = {.lex_state = 79},
  [332] = {.lex_state = 79},
  [333] = {.lex_state = 79},
  [334] = {.lex_state = 79},
  [335] = {.lex_state = 79},
  [336] = {.lex_state = 79},
  [337] = {.lex_state = 79},
  [338] = {.lex_state = 79},
  [339] = {.lex_state = 79},
  [340] = {.lex_state = 79},
  [341] = {.lex_state = 79},
  [342] = {.lex_state = 79},
  [343] = {.lex_state = 79},
  [344] = {.lex_state = 79},
  [345] = {.lex_state = 79},
  [346] = {.lex_state = 79},
  [347] = {.lex_state = 79},
  [348] = {.lex_state = 79},
  [349] = {.lex_state = 79},
  [350] = {.lex_state = 79},
  [351] = {.lex_state = 79},
  [352] = {.lex_state = 79},
  [353] = {.lex_state = 79},
  [354] = {.lex_state = 79},
  [355] = {.lex_state = 79},
  [356] = {.lex_state = 79},
  [357] = {.lex_state = 79},
  [358] = {.lex_state = 79},
  [359] = {.lex_state = 79},
  [360] = {.lex_state = 79},
  [361] = {.lex_state = 79},
  [362] = {.lex_state = 79},
  [363] = {.lex_state = 79},
  [364] = {.lex_state = 79},
  [365] = {.lex_state = 79},
  [366] = {.lex_state = 79},
  [367] = {.lex_state = 79},
  [368] = {.lex_state = 79},
  [369] = {.lex_state = 79},
  [370] = {.lex_state = 79},
  [371] = {.lex_state = 79},
  [372] = {.lex_state = 79},
  [373] = {.lex_state = 79},
  [374] = {.lex_state = 79},
  [375] = {.lex_state = 79},
  [376] = {.lex_state = 79},
  [377] = {.lex_state = 79},
  [378] = {.lex_state = 79},
  [379] = {.lex_state = 25},
  [380] = {.lex_state = 79},
  [381] = {.lex_state = 79},
  [382] = {.lex_state = 79},
  [383] = {.lex_state = 79},
  [384] = {.lex_state = 80},
  [385] = {.lex_state = 80},
  [386] = {.lex_state = 80},
  [387] = {.lex_state = 80},
  [388] = {.lex_state = 30},
  [389] = {.lex_state = 79},
  [390] = {.lex_state = 80},
  [391] = {.lex_state = 80},
  [392] = {.lex_state = 80},
  [393] = {.lex_state = 80},
  [394] = {.lex_state = 80},
  [395] = {.lex_state = 79},
  [396] = {.lex_state = 80},
  [397] = {.lex_state = 80},
  [398] = {.lex_state = 80},
  [399] = {.lex_state = 80},
  [400] = {.lex_state = 80},
  [401] = {.lex_state = 80},
  [402] = {.lex_state = 80},
  [403] = {.lex_state = 80},
  [404] = {.lex_state = 80},
  [405] = {.lex_state = 80},
  [406] = {.lex_state = 80},
  [407] = {.lex_state = 79},
  [408] = {.lex_state = 80},
  [409] = {.lex_state = 80},
  [410] = {.lex_state = 80},
  [411] = {.lex_state = 79},
  [412] = {.lex_state = 79},
  [413] = {.lex_state = 79},
  [414] = {.lex_state = 79},
  [415] = {.lex_state = 79},
  [416] = {.lex_state = 79},
  [417] = {.lex_state = 79},
  [418] = {.lex_state = 29},
  [419] = {.lex_state = 79},
  [420] = {.lex_state = 80},
  [421] = {.lex_state = 29},
  [422] = {.lex_state = 79},
  [423] = {.lex_state = 79},
  [424] = {.lex_state = 29},
  [425] = {.lex_state = 79},
  [426] = {.lex_state = 30},
  [427] = {.lex_state = 33},
  [428] = {.lex_state = 33},
  [429] = {.lex_state = 33},
  [430] = {.lex_state = 30},
  [431] = {.lex_state = 30},
  [432] = {.lex_state = 29},
  [433] = {.lex_state = 29},
  [434] = {.lex_state = 30},
  [435] = {.lex_state = 30},
  [436] = {.lex_state = 30},
  [437] = {.lex_state = 79},
  [438] = {.lex_state = 79},
  [439] = {.lex_state = 79},
  [440] = {.lex_state = 79},
  [441] = {.lex_state = 79},
  [442] = {.lex_state = 79},
  [443] = {.lex_state = 79},
  [444] = {.lex_state = 79},
  [445] = {.lex_state = 79},
  [446] = {.lex_state = 79},
  [447] = {.lex_state = 79},
  [448] = {.lex_state = 79},
  [449] = {.lex_state = 79},
  [450] = {.lex_state = 79},
  [451] = {.lex_state = 79},
  [452] = {.lex_state = 79},
  [453] = {.lex_state = 80},
  [454] = {.lex_state = 79},
  [455] = {.lex_state = 79},
  [456] = {.lex_state = 79},
  [457] = {.lex_state = 79},
  [458] = {.lex_state = 79},
  [459] = {.lex_state = 79},
  [460] = {.lex_state = 79},
  [461] = {.lex_state = 79},
  [462] = {.lex_state = 79},
  [463] = {.lex_state = 79},
  [464] = {.lex_state = 79},
  [465] = {.lex_state = 79},
  [466] = {.lex_state = 79},
  [467] = {.lex_state = 80},
  [468] = {.lex_state = 79},
  [469] = {.lex_state = 79},
  [470] = {.lex_state = 79},
  [471] = {.lex_state = 80},
  [472] = {.lex_state = 79},
  [473] = {.lex_state = 80},
  [474] = {.lex_state = 79},
  [475] = {.lex_state = 79},
  [476] = {.lex_state = 79},
  [477] = {.lex_state = 79},
  [478] = {.lex_state = 79},
  [479] = {.lex_state = 79},
  [480] = {.lex_state = 80},
  [481] = {.lex_state = 80},
  [482] = {.lex_state = 80},
  [483] = {.lex_state = 79},
  [484] = {.lex_state = 80},
  [485] = {.lex_state = 80},
  [486] = {.lex_state = 80},
  [487] = {.lex_state = 79},
  [488] = {.lex_state = 79},
  [489] = {.lex_state = 79},
  [490] = {.lex_state = 80},
  [491] = {.lex_state = 79},
  [492] = {.lex_state = 80},
  [493] = {.lex_state = 80},
  [494] = {.lex_state = 80},
  [495] = {.lex_state = 80},
  [496] = {.lex_state = 80},
  [497] = {.lex_state = 79},
  [498] = {.lex_state = 79},
  [499] = {.lex_state = 80},
  [500] = {.lex_state = 79},
  [501] = {.lex_state = 80},
  [502] = {.lex_state = 80},
  [503] = {.lex_state = 79},
  [504] = {.lex_state = 79},
  [505] = {.lex_state = 80},
  [506] = {.lex_state = 80},
  [507] = {.lex_state = 79},
  [508] = {.lex_state = 79},
  [509] = {.lex_state = 79},
  [510] = {.lex_state = 79},
  [511] = {.lex_state = 79},
  [512] = {.lex_state = 79},
  [513] = {.lex_state = 79},
  [514] = {.lex_state = 79},
  [515] = {.lex_state = 80},
  [516] = {.lex_state = 79},
  [517] = {.lex_state = 79},
  [518] = {.lex_state = 79},
  [519] = {.lex_state = 79},
  [520] = {.lex_state = 79},
  [521] = {.lex_state = 79},
  [522] = {.lex_state = 79},
  [523] = {.lex_state = 79},
  [524] = {.lex_state = 79},
  [525] = {.lex_state = 79},
  [526] = {.lex_state = 80},
  [527] = {.lex_state = 79},
  [528] = {.lex_state = 79},
  [529] = {.lex_state = 79},
  [530] = {.lex_state = 79},
  [531] = {.lex_state = 79},
  [532] = {.lex_state = 79},
  [533] = {.lex_state = 79},
  [534] = {.lex_state = 79},
  [535] = {.lex_state = 80},
  [536] = {.lex_state = 79},
  [537] = {.lex_state = 80},
  [538] = {.lex_state = 79},
  [539] = {.lex_state = 79},
  [540] = {.lex_state = 80},
  [541] = {.lex_state = 79},
  [542] = {.lex_state = 79},
  [543] = {.lex_state = 79},
  [544] = {.lex_state = 79},
  [545] = {.lex_state = 79},
  [546] = {.lex_state = 80},
  [547] = {.lex_state = 80},
  [548] = {.lex_state = 80},
  [549] = {.lex_state = 79},
  [550] = {.lex_state = 79},
  [551] = {.lex_state = 79},
  [552] = {.lex_state = 79},
  [553] = {.lex_state = 79},
  [554] = {.lex_state = 79},
  [555] = {.lex_state = 79},
  [556] = {.lex_state = 79},
  [557] = {.lex_state = 79},
  [558] = {.lex_state = 79},
  [559] = {.lex_state = 79},
  [560] = {.lex_state = 79},
  [561] = {.lex_state = 79},
  [562] = {.lex_state = 80},
  [563] = {.lex_state = 79},
  [564] = {.lex_state = 79},
  [565] = {.lex_state = 79},
  [566] = {.lex_state = 79},
  [567] = {.lex_state = 79},
  [568] = {.lex_state = 79},
  [569] = {.lex_state = 80},
  [570] = {.lex_state = 80},
  [571] = {.lex_state = 80},
  [572] = {.lex_state = 80},
  [573] = {.lex_state = 79},
  [574] = {.lex_state = 80},
  [575] = {.lex_state = 80},
  [576] = {.lex_state = 80},
  [577] = {.lex_state = 79},
  [578] = {.lex_state = 79},
  [579] = {.lex_state = 79},
  [580] = {.lex_state = 79},
  [581] = {.lex_state = 80},
  [582] = {.lex_state = 79},
  [583] = {.lex_state = 80},
  [584] = {.lex_state = 80},
  [585] = {.lex_state = 80},
  [586] = {.lex_state = 80},
  [587] = {.lex_state = 80},
  [588] = {.lex_state = 80},
  [589] = {.lex_state = 79},
  [590] = {.lex_state = 30},
  [591] = {.lex_state = 30},
  [592] = {.lex_state = 80},
  [593] = {.lex_state = 80},
  [594] = {.lex_state = 80},
  [595] = {.lex_state = 80},
  [596] = {.lex_state = 80},
  [597] = {.lex_state = 80},
  [598] = {.lex_state = 80},
  [599] = {.lex_state = 80},
  [600] = {.lex_state = 80},
  [601] = {.lex_state = 80},
  [602] = {.lex_state = 79},
  [603] = {.lex_state = 80},
  [604] = {.lex_state = 80},
  [605] = {.lex_state = 80},
  [606] = {.lex_state = 80},
  [607] = {.lex_state = 80},
  [608] = {.lex_state = 80},
  [609] = {.lex_state = 80},
  [610] = {.lex_state = 80},
  [611] = {.lex_state = 80},
  [612] = {.lex_state = 79},
  [613] = {.lex_state = 80},
  [614] = {.lex_state = 80},
  [615] = {.lex_state = 80},
  [616] = {.lex_state = 80},
  [617] = {.lex_state = 80},
  [618] = {.lex_state = 80},
  [619] = {.lex_state = 80},
  [620] = {.lex_state = 80},
  [621] = {.lex_state = 80},
  [622] = {.lex_state = 80},
  [623] = {.lex_state = 80},
  [624] = {.lex_state = 80},
  [625] = {.lex_state = 80},
  [626] = {.lex_state = 80},
  [627] = {.lex_state = 80},
  [628] = {.lex_state = 80},
  [629] = {.lex_state = 80},
  [630] = {.lex_state = 80},
  [631] = {.lex_state = 80},
  [632] = {.lex_state = 80},
  [633] = {.lex_state = 80},
  [634] = {.lex_state = 80},
  [635] = {.lex_state = 80},
  [636] = {.lex_state = 80},
  [637] = {.lex_state = 80},
  [638] = {.lex_state = 80},
  [639] = {.lex_state = 80},
  [640] = {.lex_state = 80},
  [641] = {.lex_state = 80},
  [642] = {.lex_state = 80},
  [643] = {.lex_state = 80},
  [644] = {.lex_state = 80},
  [645] = {.lex_state = 80},
  [646] = {.lex_state = 80},
  [647] = {.lex_state = 80},
  [648] = {.lex_state = 80},
  [649] = {.lex_state = 80},
  [650] = {.lex_state = 80},
  [651] = {.lex_state = 80},
  [652] = {.lex_state = 80},
  [653] = {.lex_state = 80},
  [654] = {.lex_state = 80},
  [655] = {.lex_state = 80},
  [656] = {.lex_state = 80},
  [657] = {.lex_state = 80},
  [658] = {.lex_state = 80},
  [659] = {.lex_state = 80},
  [660] = {.lex_state = 80},
  [661] = {.lex_state = 80},
  [662] = {.lex_state = 80},
  [663] = {.lex_state = 80},
  [664] = {.lex_state = 80},
  [665] = {.lex_state = 80},
  [666] = {.lex_state = 80},
  [667] = {.lex_state = 80},
  [668] = {.lex_state = 80},
  [669] = {.lex_state = 80},
  [670] = {.lex_state = 80},
  [671] = {.lex_state = 80},
  [672] = {.lex_state = 80},
  [673] = {.lex_state = 80},
  [674] = {.lex_state = 80},
  [675] = {.lex_state = 80},
  [676] = {.lex_state = 80},
  [677] = {.lex_state = 80},
  [678] = {.lex_state = 80},
  [679] = {.lex_state = 80},
  [680] = {.lex_state = 80},
  [681] = {.lex_state = 80},
  [682] = {.lex_state = 80},
  [683] = {.lex_state = 80},
  [684] = {.lex_state = 80},
  [685] = {.lex_state = 80},
  [686] = {.lex_state = 80},
  [687] = {.lex_state = 80},
  [688] = {.lex_state = 80},
  [689] = {.lex_state = 80},
  [690] = {.lex_state = 80},
  [691] = {.lex_state = 80},
  [692] = {.lex_state = 80},
  [693] = {.lex_state = 80},
  [694] = {.lex_state = 80},
  [695] = {.lex_state = 80},
  [696] = {.lex_state = 80},
  [697] = {.lex_state = 80},
  [698] = {.lex_state = 80},
  [699] = {.lex_state = 80},
  [700] = {.lex_state = 80},
  [701] = {.lex_state = 80},
  [702] = {.lex_state = 80},
  [703] = {.lex_state = 80},
  [704] = {.lex_state = 80},
  [705] = {.lex_state = 80},
  [706] = {.lex_state = 80},
  [707] = {.lex_state = 80},
  [708] = {.lex_state = 80},
  [709] = {.lex_state = 80},
  [710] = {.lex_state = 80},
  [711] = {.lex_state = 80},
  [712] = {.lex_state = 80},
  [713] = {.lex_state = 80},
  [714] = {.lex_state = 80},
  [715] = {.lex_state = 80},
  [716] = {.lex_state = 80},
  [717] = {.lex_state = 80},
  [718] = {.lex_state = 80},
  [719] = {.lex_state = 80},
  [720] = {.lex_state = 80},
  [721] = {.lex_state = 80},
  [722] = {.lex_state = 80},
  [723] = {.lex_state = 80},
  [724] = {.lex_state = 80},
  [725] = {.lex_state = 80},
  [726] = {.lex_state = 33},
  [727] = {.lex_state = 30},
  [728] = {.lex_state = 30},
  [729] = {.lex_state = 33},
  [730] = {.lex_state = 29},
  [731] = {.lex_state = 33},
  [732] = {.lex_state = 30},
  [733] = {.lex_state = 30},
  [734] = {.lex_state = 30},
  [735] = {.lex_state = 33},
  [736] = {.lex_state = 33},
  [737] = {.lex_state = 33},
  [738] = {.lex_state = 30},
  [739] = {.lex_state = 29},
  [740] = {.lex_state = 30},
  [741] = {.lex_state = 30},
  [742] = {.lex_state = 30},
  [743] = {.lex_state = 30},
  [744] = {.lex_state = 33},
  [745] = {.lex_state = 30},
  [746] = {.lex_state = 33},
  [747] = {.lex_state = 30},
  [748] = {.lex_state = 33},
  [749] = {.lex_state = 30},
  [750] = {.lex_state = 33},
  [751] = {.lex_state = 33},
  [752] = {.lex_state = 33},
  [753] = {.lex_state = 33},
  [754] = {.lex_state = 29},
  [755] = {.lex_state = 29},
  [756] = {.lex_state = 33},
  [757] = {.lex_state = 30},
  [758] = {.lex_state = 33},
  [759] = {.lex_state = 30},
  [760] = {.lex_state = 30},
  [761] = {.lex_state = 30},
  [762] = {.lex_state = 30},
  [763] = {.lex_state = 80},
  [764] = {.lex_state = 30},
  [765] = {.lex_state = 33},
  [766] = {.lex_state = 33},
  [767] = {.lex_state = 33},
  [768] = {.lex_state = 80},
  [769] = {.lex_state = 33},
  [770] = {.lex_state = 30},
  [771] = {.lex_state = 33},
  [772] = {.lex_state = 80},
  [773] = {.lex_state = 80},
  [774] = {.lex_state = 80},
  [775] = {.lex_state = 80},
  [776] = {.lex_state = 80},
  [777] = {.lex_state = 80},
  [778] = {.lex_state = 80},
  [779] = {.lex_state = 80},
  [780] = {.lex_state = 80},
  [781] = {.lex_state = 80},
  [782] = {.lex_state = 80},
  [783] = {.lex_state = 80},
  [784] = {.lex_state = 80},
  [785] = {.lex_state = 80},
  [786] = {.lex_state = 80},
  [787] = {.lex_state = 80},
  [788] = {.lex_state = 80},
  [789] = {.lex_state = 80},
  [790] = {.lex_state = 80},
  [791] = {.lex_state = 80},
  [792] = {.lex_state = 80},
  [793] = {.lex_state = 80},
  [794] = {.lex_state = 80},
  [795] = {.lex_state = 80},
  [796] = {.lex_state = 80},
  [797] = {.lex_state = 80},
  [798] = {.lex_state = 80},
  [799] = {.lex_state = 80},
  [800] = {.lex_state = 80},
  [801] = {.lex_state = 30},
  [802] = {.lex_state = 80},
  [803] = {.lex_state = 80},
  [804] = {.lex_state = 80},
  [805] = {.lex_state = 80},
  [806] = {.lex_state = 80},
  [807] = {.lex_state = 80},
  [808] = {.lex_state = 28},
  [809] = {.lex_state = 30},
  [810] = {.lex_state = 28},
  [811] = {.lex_state = 80},
  [812] = {.lex_state = 15},
  [813] = {.lex_state = 80},
  [814] = {.lex_state = 80},
  [815] = {.lex_state = 80},
  [816] = {.lex_state = 80},
  [817] = {.lex_state = 30},
  [818] = {.lex_state = 30},
  [819] = {.lex_state = 28},
  [820] = {.lex_state = 28},
  [821] = {.lex_state = 80},
  [822] = {.lex_state = 30},
  [823] = {.lex_state = 80},
  [824] = {.lex_state = 30},
  [825] = {.lex_state = 30},
  [826] = {.lex_state = 30},
  [827] = {.lex_state = 28},
  [828] = {.lex_state = 28},
  [829] = {.lex_state = 80},
  [830] = {.lex_state = 80},
  [831] = {.lex_state = 80},
  [832] = {.lex_state = 30},
  [833] = {.lex_state = 30},
  [834] = {.lex_state = 30},
  [835] = {.lex_state = 30},
  [836] = {.lex_state = 30},
  [837] = {.lex_state = 30},
  [838] = {.lex_state = 30},
  [839] = {.lex_state = 30},
  [840] = {.lex_state = 30},
  [841] = {.lex_state = 30},
  [842] = {.lex_state = 30},
  [843] = {.lex_state = 30},
  [844] = {.lex_state = 80},
  [845] = {.lex_state = 80},
  [846] = {.lex_state = 28},
  [847] = {.lex_state = 28},
  [848] = {.lex_state = 80},
  [849] = {.lex_state = 28},
  [850] = {.lex_state = 80},
  [851] = {.lex_state = 80},
  [852] = {.lex_state = 80},
  [853] = {.lex_state = 28},
  [854] = {.lex_state = 28},
  [855] = {.lex_state = 28},
  [856] = {.lex_state = 28},
  [857] = {.lex_state = 28},
  [858] = {.lex_state = 28},
  [859] = {.lex_state = 28},
  [860] = {.lex_state = 28},
  [861] = {.lex_state = 28},
  [862] = {.lex_state = 28},
  [863] = {.lex_state = 28},
  [864] = {.lex_state = 28},
  [865] = {.lex_state = 28},
  [866] = {.lex_state = 28},
  [867] = {.lex_state = 28},
  [868] = {.lex_state = 30},
  [869] = {.lex_state = 30},
  [870] = {.lex_state = 30},
  [871] = {.lex_state = 80},
  [872] = {.lex_state = 28},
  [873] = {.lex_state = 28},
  [874] = {.lex_state = 28},
  [875] = {.lex_state = 28},
  [876] = {.lex_state = 80},
  [877] = {.lex_state = 80},
  [878] = {.lex_state = 80},
  [879] = {.lex_state = 80},
  [880] = {.lex_state = 28},
  [881] = {.lex_state = 28},
  [882] = {.lex_state = 28},
  [883] = {.lex_state = 28},
  [884] = {.lex_state = 80},
  [885] = {.lex_state = 28},
  [886] = {.lex_state = 80},
  [887] = {.lex_state = 80},
  [888] = {.lex_state = 80},
  [889] = {.lex_state = 80},
  [890] = {.lex_state = 28},
  [891] = {.lex_state = 28},
  [892] = {.lex_state = 80},
  [893] = {.lex_state = 28},
  [894] = {.lex_state = 15},
  [895] = {.lex_state = 15},
  [896] = {.lex_state = 15},
  [897] = {.lex_state = 30},
  [898] = {.lex_state = 80},
  [899] = {.lex_state = 15},
  [900] = {.lex_state = 15},
  [901] = {.lex_state = 15},
  [902] = {.lex_state = 15},
  [903] = {.lex_state = 30},
  [904] = {.lex_state = 15},
  [905] = {.lex_state = 15},
  [906] = {.lex_state = 15},
  [907] = {.lex_state = 15},
  [908] = {.lex_state = 15},
  [909] = {.lex_state = 15},
  [910] = {.lex_state = 15},
  [911] = {.lex_state = 15},
  [912] = {.lex_state = 15},
  [913] = {.lex_state = 15},
  [914] = {.lex_state = 15},
  [915] = {.lex_state = 15},
  [916] = {.lex_state = 15},
  [917] = {.lex_state = 15},
  [918] = {.lex_state = 15},
  [919] = {.lex_state = 15},
  [920] = {.lex_state = 15},
  [921] = {.lex_state = 15},
  [922] = {.lex_state = 15},
  [923] = {.lex_state = 15},
  [924] = {.lex_state = 15},
  [925] = {.lex_state = 80},
  [926] = {.lex_state = 80},
  [927] = {.lex_state = 80},
  [928] = {.lex_state = 80},
  [929] = {.lex_state = 80},
  [930] = {.lex_state = 80},
  [931] = {.lex_state = 80},
  [932] = {.lex_state = 80},
  [933] = {.lex_state = 80},
  [934] = {.lex_state = 80},
  [935] = {.lex_state = 80},
  [936] = {.lex_state = 80},
  [937] = {.lex_state = 80},
  [938] = {.lex_state = 80},
  [939] = {.lex_state = 80},
  [940] = {.lex_state = 80},
  [941] = {.lex_state = 80},
  [942] = {.lex_state = 80},
  [943] = {.lex_state = 80},
  [944] = {.lex_state = 80},
  [945] = {.lex_state = 80},
  [946] = {.lex_state = 80},
  [947] = {.lex_state = 80},
  [948] = {.lex_state = 80},
  [949] = {.lex_state = 80},
  [950] = {.lex_state = 80},
  [951] = {.lex_state = 80},
  [952] = {.lex_state = 80},
  [953] = {.lex_state = 80},
  [954] = {.lex_state = 80},
  [955] = {.lex_state = 80},
  [956] = {.lex_state = 80},
  [957] = {.lex_state = 80},
  [958] = {.lex_state = 80},
  [959] = {.lex_state = 80},
  [960] = {.lex_state = 80},
  [961] = {.lex_state = 80},
  [962] = {.lex_state = 80},
  [963] = {.lex_state = 80},
  [964] = {.lex_state = 80},
  [965] = {.lex_state = 80},
  [966] = {.lex_state = 80},
  [967] = {.lex_state = 80},
  [968] = {.lex_state = 80},
  [969] = {.lex_state = 80},
  [970] = {.lex_state = 80},
  [971] = {.lex_state = 80},
  [972] = {.lex_state = 80},
  [973] = {.lex_state = 80},
  [974] = {.lex_state = 80},
  [975] = {.lex_state = 80},
  [976] = {.lex_state = 80},
  [977] = {.lex_state = 80},
  [978] = {.lex_state = 80},
  [979] = {.lex_state = 80},
  [980] = {.lex_state = 80},
  [981] = {.lex_state = 80},
  [982] = {.lex_state = 80},
  [983] = {.lex_state = 80},
  [984] = {.lex_state = 80},
  [985] = {.lex_state = 80},
  [986] = {.lex_state = 80},
  [987] = {.lex_state = 80},
  [988] = {.lex_state = 80},
  [989] = {.lex_state = 80},
  [990] = {.lex_state = 80},
  [991] = {.lex_state = 80},
  [992] = {.lex_state = 80},
  [993] = {.lex_state = 80},
  [994] = {.lex_state = 79},
  [995] = {.lex_state = 31},
  [996] = {.lex_state = 79},
  [997] = {.lex_state = 31},
  [998] = {.lex_state = 79},
  [999] = {.lex_state = 31},
  [1000] = {.lex_state = 79},
  [1001] = {.lex_state = 31},
  [1002] = {.lex_state = 80},
  [1003] = {.lex_state = 80},
  [1004] = {.lex_state = 80},
  [1005] = {.lex_state = 79},
  [1006] = {.lex_state = 80},
  [1007] = {.lex_state = 79},
  [1008] = {.lex_state = 80},
  [1009] = {.lex_state = 80},
  [1010] = {.lex_state = 79},
  [1011] = {.lex_state = 80},
  [1012] = {.lex_state = 80},
  [1013] = {.lex_state = 80},
  [1014] = {.lex_state = 80},
  [1015] = {.lex_state = 79},
  [1016] = {.lex_state = 79},
  [1017] = {.lex_state = 80},
  [1018] = {.lex_state = 80},
  [1019] = {.lex_state = 80},
  [1020] = {.lex_state = 80},
  [1021] = {.lex_state = 80},
  [1022] = {.lex_state = 80},
  [1023] = {.lex_state = 79},
  [1024] = {.lex_state = 80},
  [1025] = {.lex_state = 80},
  [1026] = {.lex_state = 80},
  [1027] = {.lex_state = 80},
  [1028] = {.lex_state = 79},
  [1029] = {.lex_state = 80},
  [1030] = {.lex_state = 80},
  [1031] = {.lex_state = 80},
  [1032] = {.lex_state = 79},
  [1033] = {.lex_state = 79},
  [1034] = {.lex_state = 79},
  [1035] = {.lex_state = 79},
  [1036] = {.lex_state = 79},
  [1037] = {.lex_state = 79},
  [1038] = {.lex_state = 79},
  [1039] = {.lex_state = 79},
  [1040] = {.lex_state = 79},
  [1041] = {.lex_state = 79},
  [1042] = {.lex_state = 79},
  [1043] = {.lex_state = 79},
  [1044] = {.lex_state = 79},
  [1045] = {.lex_state = 79},
  [1046] = {.lex_state = 79},
  [1047] = {.lex_state = 79},
  [1048] = {.lex_state = 79},
  [1049] = {.lex_state = 79},
  [1050] = {.lex_state = 79},
  [1051] = {.lex_state = 79},
  [1052] = {.lex_state = 79},
  [1053] = {.lex_state = 79},
  [1054] = {.lex_state = 79},
  [1055] = {.lex_state = 79},
  [1056] = {.lex_state = 79},
  [1057] = {.lex_state = 79},
  [1058] = {.lex_state = 79},
  [1059] = {.lex_state = 79},
  [1060] = {.lex_state = 79},
  [1061] = {.lex_state = 79},
  [1062] = {.lex_state = 79},
  [1063] = {.lex_state = 79},
  [1064] = {.lex_state = 79},
  [1065] = {.lex_state = 79},
  [1066] = {.lex_state = 79},
  [1067] = {.lex_state = 79},
  [1068] = {.lex_state = 79},
  [1069] = {.lex_state = 79},
  [1070] = {.lex_state = 79},
  [1071] = {.lex_state = 79},
  [1072] = {.lex_state = 79},
  [1073] = {.lex_state = 79},
  [1074] = {.lex_state = 79},
  [1075] = {.lex_state = 79},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 79},
  [1078] = {.lex_state = 79},
  [1079] = {.lex_state = 79},
  [1080] = {.lex_state = 79},
  [1081] = {.lex_state = 79},
  [1082] = {.lex_state = 79},
  [1083] = {.lex_state = 79},
  [1084] = {.lex_state = 80},
  [1085] = {.lex_state = 79},
  [1086] = {.lex_state = 79},
  [1087] = {.lex_state = 79},
  [1088] = {.lex_state = 80},
  [1089] = {.lex_state = 79},
  [1090] = {.lex_state = 79},
  [1091] = {.lex_state = 79},
  [1092] = {.lex_state = 79},
  [1093] = {.lex_state = 80},
  [1094] = {.lex_state = 79},
  [1095] = {.lex_state = 80},
  [1096] = {.lex_state = 79},
  [1097] = {.lex_state = 79},
  [1098] = {.lex_state = 79},
  [1099] = {.lex_state = 79},
  [1100] = {.lex_state = 79},
  [1101] = {.lex_state = 79},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 79},
  [1104] = {.lex_state = 79},
  [1105] = {.lex_state = 79},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 79},
  [1108] = {.lex_state = 79},
  [1109] = {.lex_state = 79},
  [1110] = {.lex_state = 18},
  [1111] = {.lex_state = 20},
  [1112] = {.lex_state = 20},
  [1113] = {.lex_state = 20},
  [1114] = {.lex_state = 18},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 79},
  [1117] = {.lex_state = 80},
  [1118] = {.lex_state = 20},
  [1119] = {.lex_state = 20},
  [1120] = {.lex_state = 20},
  [1121] = {.lex_state = 20},
  [1122] = {.lex_state = 18},
  [1123] = {.lex_state = 18},
  [1124] = {.lex_state = 18},
  [1125] = {.lex_state = 18},
  [1126] = {.lex_state = 79},
  [1127] = {.lex_state = 79},
  [1128] = {.lex_state = 79},
  [1129] = {.lex_state = 80},
  [1130] = {.lex_state = 18},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 30},
  [1133] = {.lex_state = 80},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 15},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 80},
  [1139] = {.lex_state = 0},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 80},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 15},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 15},
  [1149] = {.lex_state = 80},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 80},
  [1153] = {.lex_state = 80},
  [1154] = {.lex_state = 80},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 0},
  [1161] = {.lex_state = 80},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 15},
  [1164] = {.lex_state = 80},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 0},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 0},
  [1175] = {.lex_state = 0},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 0},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 0},
  [1181] = {.lex_state = 0},
  [1182] = {.lex_state = 0},
  [1183] = {.lex_state = 79},
  [1184] = {.lex_state = 0},
  [1185] = {.lex_state = 0},
  [1186] = {.lex_state = 80},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 0},
  [1189] = {.lex_state = 79},
  [1190] = {.lex_state = 79},
  [1191] = {.lex_state = 22},
  [1192] = {.lex_state = 80},
  [1193] = {.lex_state = 19},
  [1194] = {.lex_state = 79},
  [1195] = {.lex_state = 79},
  [1196] = {.lex_state = 79},
  [1197] = {.lex_state = 22},
  [1198] = {.lex_state = 0},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 0},
  [1201] = {.lex_state = 19},
  [1202] = {.lex_state = 79},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 80},
  [1205] = {.lex_state = 79},
  [1206] = {.lex_state = 79},
  [1207] = {.lex_state = 79},
  [1208] = {.lex_state = 0},
  [1209] = {.lex_state = 22},
  [1210] = {.lex_state = 79},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 79},
  [1213] = {.lex_state = 19},
  [1214] = {.lex_state = 79},
  [1215] = {.lex_state = 80},
  [1216] = {.lex_state = 19},
  [1217] = {.lex_state = 30},
  [1218] = {.lex_state = 79},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 79},
  [1221] = {.lex_state = 0},
  [1222] = {.lex_state = 19},
  [1223] = {.lex_state = 19},
  [1224] = {.lex_state = 0},
  [1225] = {.lex_state = 19},
  [1226] = {.lex_state = 19},
  [1227] = {.lex_state = 79},
  [1228] = {.lex_state = 19},
  [1229] = {.lex_state = 19},
  [1230] = {.lex_state = 19},
  [1231] = {.lex_state = 19},
  [1232] = {.lex_state = 80},
  [1233] = {.lex_state = 19},
  [1234] = {.lex_state = 0},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 79},
  [1237] = {.lex_state = 19},
  [1238] = {.lex_state = 79},
  [1239] = {.lex_state = 79},
  [1240] = {.lex_state = 79},
  [1241] = {.lex_state = 79},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 19},
  [1244] = {.lex_state = 19},
  [1245] = {.lex_state = 19},
  [1246] = {.lex_state = 79},
  [1247] = {.lex_state = 15},
  [1248] = {.lex_state = 0},
  [1249] = {.lex_state = 25},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 15},
  [1254] = {.lex_state = 15},
  [1255] = {.lex_state = 15},
  [1256] = {.lex_state = 25},
  [1257] = {.lex_state = 25},
  [1258] = {.lex_state = 0},
  [1259] = {.lex_state = 80},
  [1260] = {.lex_state = 0},
  [1261] = {.lex_state = 0},
  [1262] = {.lex_state = 0},
  [1263] = {.lex_state = 0},
  [1264] = {.lex_state = 15},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 25},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 15},
  [1269] = {.lex_state = 0},
  [1270] = {.lex_state = 25},
  [1271] = {.lex_state = 0},
  [1272] = {.lex_state = 15},
  [1273] = {.lex_state = 25},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 25},
  [1276] = {.lex_state = 0},
  [1277] = {.lex_state = 0},
  [1278] = {.lex_state = 0},
  [1279] = {.lex_state = 25},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 0},
  [1282] = {.lex_state = 80},
  [1283] = {.lex_state = 0},
  [1284] = {.lex_state = 25},
  [1285] = {.lex_state = 15},
  [1286] = {.lex_state = 0},
  [1287] = {.lex_state = 0},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 0},
  [1290] = {.lex_state = 0},
  [1291] = {.lex_state = 0},
  [1292] = {.lex_state = 0},
  [1293] = {.lex_state = 25},
  [1294] = {.lex_state = 15},
  [1295] = {.lex_state = 15},
  [1296] = {.lex_state = 15},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 15},
  [1299] = {.lex_state = 15},
  [1300] = {.lex_state = 15},
  [1301] = {.lex_state = 15},
  [1302] = {.lex_state = 15},
  [1303] = {.lex_state = 15},
  [1304] = {.lex_state = 0},
  [1305] = {.lex_state = 80},
  [1306] = {.lex_state = 80},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 0},
  [1309] = {.lex_state = 80},
  [1310] = {.lex_state = 80},
  [1311] = {.lex_state = 15},
  [1312] = {.lex_state = 0},
  [1313] = {.lex_state = 25},
  [1314] = {.lex_state = 0},
  [1315] = {.lex_state = 0},
  [1316] = {.lex_state = 25},
  [1317] = {.lex_state = 15},
  [1318] = {.lex_state = 25},
  [1319] = {.lex_state = 0},
  [1320] = {.lex_state = 80},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 80},
  [1323] = {.lex_state = 0},
  [1324] = {.lex_state = 0},
  [1325] = {.lex_state = 0},
  [1326] = {.lex_state = 0},
  [1327] = {.lex_state = 0},
  [1328] = {.lex_state = 25},
  [1329] = {.lex_state = 0},
  [1330] = {.lex_state = 25},
  [1331] = {.lex_state = 25},
  [1332] = {.lex_state = 15},
  [1333] = {.lex_state = 0},
  [1334] = {.lex_state = 0},
  [1335] = {.lex_state = 0},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 0},
  [1338] = {.lex_state = 0},
  [1339] = {.lex_state = 80},
  [1340] = {.lex_state = 0},
  [1341] = {.lex_state = 0},
  [1342] = {.lex_state = 0},
  [1343] = {.lex_state = 25},
  [1344] = {.lex_state = 0},
  [1345] = {.lex_state = 25},
  [1346] = {.lex_state = 0},
  [1347] = {.lex_state = 0},
  [1348] = {.lex_state = 0},
  [1349] = {.lex_state = 0},
  [1350] = {.lex_state = 25},
  [1351] = {.lex_state = 80},
  [1352] = {.lex_state = 80},
  [1353] = {.lex_state = 25},
  [1354] = {.lex_state = 0},
  [1355] = {.lex_state = 80},
  [1356] = {.lex_state = 80},
  [1357] = {.lex_state = 0},
  [1358] = {.lex_state = 25},
  [1359] = {.lex_state = 25},
  [1360] = {.lex_state = 25},
  [1361] = {.lex_state = 0},
  [1362] = {.lex_state = 15},
  [1363] = {.lex_state = 80},
  [1364] = {.lex_state = 0},
  [1365] = {.lex_state = 0},
  [1366] = {.lex_state = 0},
  [1367] = {.lex_state = 0},
  [1368] = {.lex_state = 0},
  [1369] = {.lex_state = 0},
  [1370] = {.lex_state = 15},
  [1371] = {.lex_state = 0},
  [1372] = {.lex_state = 0},
  [1373] = {.lex_state = 80},
  [1374] = {.lex_state = 80},
  [1375] = {.lex_state = 0},
  [1376] = {.lex_state = 15},
  [1377] = {.lex_state = 0},
  [1378] = {.lex_state = 80},
  [1379] = {.lex_state = 0},
  [1380] = {.lex_state = 0},
  [1381] = {.lex_state = 25},
  [1382] = {.lex_state = 25},
  [1383] = {.lex_state = 25},
  [1384] = {.lex_state = 25},
  [1385] = {.lex_state = 25},
  [1386] = {.lex_state = 15},
  [1387] = {.lex_state = 0},
  [1388] = {.lex_state = 15},
  [1389] = {.lex_state = 0},
  [1390] = {.lex_state = 0},
  [1391] = {.lex_state = 80},
  [1392] = {.lex_state = 80},
  [1393] = {.lex_state = 80},
  [1394] = {.lex_state = 0},
  [1395] = {.lex_state = 0},
  [1396] = {.lex_state = 0},
  [1397] = {.lex_state = 25},
  [1398] = {.lex_state = 0},
  [1399] = {.lex_state = 80},
  [1400] = {.lex_state = 0},
  [1401] = {.lex_state = 0},
  [1402] = {.lex_state = 0},
  [1403] = {.lex_state = 0},
  [1404] = {.lex_state = 80},
  [1405] = {.lex_state = 0},
  [1406] = {.lex_state = 80},
  [1407] = {.lex_state = 0},
  [1408] = {.lex_state = 0},
  [1409] = {.lex_state = 79},
  [1410] = {.lex_state = 0},
  [1411] = {.lex_state = 0},
  [1412] = {.lex_state = 0},
  [1413] = {.lex_state = 0},
  [1414] = {.lex_state = 80},
  [1415] = {.lex_state = 25},
  [1416] = {.lex_state = 25},
  [1417] = {.lex_state = 0},
  [1418] = {.lex_state = 0},
  [1419] = {.lex_state = 0},
  [1420] = {.lex_state = 0},
  [1421] = {.lex_state = 15},
  [1422] = {.lex_state = 25},
  [1423] = {.lex_state = 80},
  [1424] = {.lex_state = 15},
  [1425] = {.lex_state = 79},
  [1426] = {.lex_state = 0},
  [1427] = {.lex_state = 79},
  [1428] = {.lex_state = 79},
  [1429] = {.lex_state = 0},
  [1430] = {.lex_state = 80},
  [1431] = {.lex_state = 0},
  [1432] = {.lex_state = 0},
  [1433] = {.lex_state = 79},
  [1434] = {.lex_state = 80},
  [1435] = {.lex_state = 79},
  [1436] = {.lex_state = 79},
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym___TYPE_EXPRESSION] = ACTIONS(1),
    [anon_sym___VANILLA_C] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_auto] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [sym_primitive_type] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_translation_unit] = STATE(1402),
    [sym_vanilla_expression] = STATE(1400),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_specifiers] = STATE(962),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(595),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(815),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(33),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym___TYPE_EXPRESSION] = ACTIONS(9),
    [anon_sym___VANILLA_C] = ACTIONS(11),
    [aux_sym_preproc_include_token1] = ACTIONS(13),
    [aux_sym_preproc_def_token1] = ACTIONS(15),
    [aux_sym_preproc_if_token1] = ACTIONS(17),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(19),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(19),
    [sym_preproc_directive] = ACTIONS(21),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_typedef] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1257),
    [sym_preproc_elif] = STATE(1257),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(101),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_preproc_include] = STATE(2),
    [sym_preproc_def] = STATE(2),
    [sym_preproc_function_def] = STATE(2),
    [sym_preproc_call] = STATE(2),
    [sym_preproc_if] = STATE(2),
    [sym_preproc_ifdef] = STATE(2),
    [sym_preproc_else] = STATE(1330),
    [sym_preproc_elif] = STATE(1330),
    [sym_function_definition] = STATE(2),
    [sym_declaration] = STATE(2),
    [sym_type_definition] = STATE(2),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(2),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(2),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_switch_statement] = STATE(2),
    [sym_case_statement] = STATE(2),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(2),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(2),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(141),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym_preproc_include] = STATE(13),
    [sym_preproc_def] = STATE(13),
    [sym_preproc_function_def] = STATE(13),
    [sym_preproc_call] = STATE(13),
    [sym_preproc_if] = STATE(13),
    [sym_preproc_ifdef] = STATE(13),
    [sym_preproc_else] = STATE(1328),
    [sym_preproc_elif] = STATE(1328),
    [sym_function_definition] = STATE(13),
    [sym_declaration] = STATE(13),
    [sym_type_definition] = STATE(13),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(13),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(13),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_case_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_goto_statement] = STATE(13),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(13),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(13),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(143),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1279),
    [sym_preproc_elif] = STATE(1279),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(145),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1275),
    [sym_preproc_elif] = STATE(1275),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(147),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym_preproc_include] = STATE(5),
    [sym_preproc_def] = STATE(5),
    [sym_preproc_function_def] = STATE(5),
    [sym_preproc_call] = STATE(5),
    [sym_preproc_if] = STATE(5),
    [sym_preproc_ifdef] = STATE(5),
    [sym_preproc_else] = STATE(1273),
    [sym_preproc_elif] = STATE(1273),
    [sym_function_definition] = STATE(5),
    [sym_declaration] = STATE(5),
    [sym_type_definition] = STATE(5),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(5),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(5),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(5),
    [sym_expression_statement] = STATE(5),
    [sym_if_statement] = STATE(5),
    [sym_switch_statement] = STATE(5),
    [sym_case_statement] = STATE(5),
    [sym_while_statement] = STATE(5),
    [sym_do_statement] = STATE(5),
    [sym_for_statement] = STATE(5),
    [sym_return_statement] = STATE(5),
    [sym_break_statement] = STATE(5),
    [sym_continue_statement] = STATE(5),
    [sym_goto_statement] = STATE(5),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(5),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(5),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(149),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym_preproc_include] = STATE(6),
    [sym_preproc_def] = STATE(6),
    [sym_preproc_function_def] = STATE(6),
    [sym_preproc_call] = STATE(6),
    [sym_preproc_if] = STATE(6),
    [sym_preproc_ifdef] = STATE(6),
    [sym_preproc_else] = STATE(1266),
    [sym_preproc_elif] = STATE(1266),
    [sym_function_definition] = STATE(6),
    [sym_declaration] = STATE(6),
    [sym_type_definition] = STATE(6),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(6),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(6),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_case_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_goto_statement] = STATE(6),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(6),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(6),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(151),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym_preproc_include] = STATE(10),
    [sym_preproc_def] = STATE(10),
    [sym_preproc_function_def] = STATE(10),
    [sym_preproc_call] = STATE(10),
    [sym_preproc_if] = STATE(10),
    [sym_preproc_ifdef] = STATE(10),
    [sym_preproc_else] = STATE(1256),
    [sym_preproc_elif] = STATE(1256),
    [sym_function_definition] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_type_definition] = STATE(10),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(10),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(10),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_case_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_goto_statement] = STATE(10),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(10),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(10),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(153),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1353),
    [sym_preproc_elif] = STATE(1353),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(155),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym_preproc_include] = STATE(17),
    [sym_preproc_def] = STATE(17),
    [sym_preproc_function_def] = STATE(17),
    [sym_preproc_call] = STATE(17),
    [sym_preproc_if] = STATE(17),
    [sym_preproc_ifdef] = STATE(17),
    [sym_preproc_else] = STATE(1382),
    [sym_preproc_elif] = STATE(1382),
    [sym_function_definition] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_type_definition] = STATE(17),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(17),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(17),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_case_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_goto_statement] = STATE(17),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(17),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(17),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(157),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym_preproc_include] = STATE(15),
    [sym_preproc_def] = STATE(15),
    [sym_preproc_function_def] = STATE(15),
    [sym_preproc_call] = STATE(15),
    [sym_preproc_if] = STATE(15),
    [sym_preproc_ifdef] = STATE(15),
    [sym_preproc_else] = STATE(1249),
    [sym_preproc_elif] = STATE(1249),
    [sym_function_definition] = STATE(15),
    [sym_declaration] = STATE(15),
    [sym_type_definition] = STATE(15),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(15),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(15),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_case_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_goto_statement] = STATE(15),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(15),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(15),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1381),
    [sym_preproc_elif] = STATE(1381),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(161),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_preproc_include] = STATE(18),
    [sym_preproc_def] = STATE(18),
    [sym_preproc_function_def] = STATE(18),
    [sym_preproc_call] = STATE(18),
    [sym_preproc_if] = STATE(18),
    [sym_preproc_ifdef] = STATE(18),
    [sym_preproc_else] = STATE(1384),
    [sym_preproc_elif] = STATE(1384),
    [sym_function_definition] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_type_definition] = STATE(18),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(18),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(18),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_case_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_goto_statement] = STATE(18),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(18),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(18),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(163),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1313),
    [sym_preproc_elif] = STATE(1313),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(165),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_preproc_include] = STATE(19),
    [sym_preproc_def] = STATE(19),
    [sym_preproc_function_def] = STATE(19),
    [sym_preproc_call] = STATE(19),
    [sym_preproc_if] = STATE(19),
    [sym_preproc_ifdef] = STATE(19),
    [sym_preproc_else] = STATE(1358),
    [sym_preproc_elif] = STATE(1358),
    [sym_function_definition] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_type_definition] = STATE(19),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(19),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(19),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_goto_statement] = STATE(19),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(19),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(19),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(167),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1350),
    [sym_preproc_elif] = STATE(1350),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1415),
    [sym_preproc_elif] = STATE(1415),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1345),
    [sym_preproc_elif] = STATE(1345),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(93),
    [aux_sym_preproc_include_token1] = ACTIONS(95),
    [aux_sym_preproc_def_token1] = ACTIONS(97),
    [aux_sym_preproc_if_token1] = ACTIONS(99),
    [aux_sym_preproc_if_token2] = ACTIONS(173),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(103),
    [aux_sym_preproc_else_token1] = ACTIONS(105),
    [aux_sym_preproc_elif_token1] = ACTIONS(107),
    [sym_preproc_directive] = ACTIONS(109),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(115),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_specifiers] = STATE(963),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(594),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(813),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(175),
    [aux_sym_preproc_include_token1] = ACTIONS(178),
    [aux_sym_preproc_def_token1] = ACTIONS(181),
    [aux_sym_preproc_if_token1] = ACTIONS(184),
    [aux_sym_preproc_if_token2] = ACTIONS(187),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(187),
    [aux_sym_preproc_elif_token1] = ACTIONS(187),
    [sym_preproc_directive] = ACTIONS(192),
    [anon_sym_LPAREN2] = ACTIONS(195),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_TILDE] = ACTIONS(198),
    [anon_sym_DASH] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(204),
    [anon_sym_SEMI] = ACTIONS(207),
    [anon_sym_typedef] = ACTIONS(210),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym___attribute__] = ACTIONS(216),
    [anon_sym___declspec] = ACTIONS(219),
    [anon_sym___cdecl] = ACTIONS(222),
    [anon_sym___clrcall] = ACTIONS(222),
    [anon_sym___stdcall] = ACTIONS(222),
    [anon_sym___fastcall] = ACTIONS(222),
    [anon_sym___thiscall] = ACTIONS(222),
    [anon_sym___vectorcall] = ACTIONS(222),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_auto] = ACTIONS(228),
    [anon_sym_register] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_const] = ACTIONS(231),
    [anon_sym_volatile] = ACTIONS(231),
    [anon_sym_restrict] = ACTIONS(231),
    [anon_sym__Atomic] = ACTIONS(231),
    [anon_sym_signed] = ACTIONS(234),
    [anon_sym_unsigned] = ACTIONS(234),
    [anon_sym_long] = ACTIONS(234),
    [anon_sym_short] = ACTIONS(234),
    [sym_primitive_type] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(240),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_union] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(249),
    [anon_sym_switch] = ACTIONS(252),
    [anon_sym_case] = ACTIONS(255),
    [anon_sym_default] = ACTIONS(258),
    [anon_sym_while] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(264),
    [anon_sym_for] = ACTIONS(267),
    [anon_sym_return] = ACTIONS(270),
    [anon_sym_break] = ACTIONS(273),
    [anon_sym_continue] = ACTIONS(276),
    [anon_sym_goto] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_sizeof] = ACTIONS(285),
    [sym_number_literal] = ACTIONS(288),
    [anon_sym_L_SQUOTE] = ACTIONS(291),
    [anon_sym_u_SQUOTE] = ACTIONS(291),
    [anon_sym_U_SQUOTE] = ACTIONS(291),
    [anon_sym_u8_SQUOTE] = ACTIONS(291),
    [anon_sym_SQUOTE] = ACTIONS(291),
    [anon_sym_L_DQUOTE] = ACTIONS(294),
    [anon_sym_u_DQUOTE] = ACTIONS(294),
    [anon_sym_U_DQUOTE] = ACTIONS(294),
    [anon_sym_u8_DQUOTE] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_null] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(30),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_case_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_goto_statement] = STATE(30),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(30),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(320),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_specifiers] = STATE(962),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(595),
    [sym_compound_statement] = STATE(32),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(815),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_case_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_goto_statement] = STATE(32),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(32),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [ts_builtin_sym_end] = ACTIONS(344),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(13),
    [aux_sym_preproc_def_token1] = ACTIONS(15),
    [aux_sym_preproc_if_token1] = ACTIONS(17),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(19),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(19),
    [sym_preproc_directive] = ACTIONS(21),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_typedef] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(24),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_goto_statement] = STATE(24),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(346),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(44),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(348),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym_preproc_include] = STATE(36),
    [sym_preproc_def] = STATE(36),
    [sym_preproc_function_def] = STATE(36),
    [sym_preproc_call] = STATE(36),
    [sym_preproc_if] = STATE(36),
    [sym_preproc_ifdef] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_declaration] = STATE(36),
    [sym_type_definition] = STATE(36),
    [sym__declaration_specifiers] = STATE(956),
    [sym_linkage_specification] = STATE(36),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(596),
    [sym_compound_statement] = STATE(36),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(814),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(36),
    [sym_expression_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_switch_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_do_statement] = STATE(36),
    [sym_for_statement] = STATE(36),
    [sym_return_statement] = STATE(36),
    [sym_break_statement] = STATE(36),
    [sym_continue_statement] = STATE(36),
    [sym_goto_statement] = STATE(36),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(36),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(36),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(350),
    [aux_sym_preproc_include_token1] = ACTIONS(352),
    [aux_sym_preproc_def_token1] = ACTIONS(354),
    [aux_sym_preproc_if_token1] = ACTIONS(356),
    [aux_sym_preproc_if_token2] = ACTIONS(358),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(360),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(360),
    [sym_preproc_directive] = ACTIONS(362),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_typedef] = ACTIONS(366),
    [anon_sym_extern] = ACTIONS(368),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(39),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(39),
    [sym_expression_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_switch_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_do_statement] = STATE(39),
    [sym_for_statement] = STATE(39),
    [sym_return_statement] = STATE(39),
    [sym_break_statement] = STATE(39),
    [sym_continue_statement] = STATE(39),
    [sym_goto_statement] = STATE(39),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(39),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(39),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(394),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(396),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym_preproc_include] = STATE(34),
    [sym_preproc_def] = STATE(34),
    [sym_preproc_function_def] = STATE(34),
    [sym_preproc_call] = STATE(34),
    [sym_preproc_if] = STATE(34),
    [sym_preproc_ifdef] = STATE(34),
    [sym_function_definition] = STATE(34),
    [sym_declaration] = STATE(34),
    [sym_type_definition] = STATE(34),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(34),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(34),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_if_statement] = STATE(34),
    [sym_switch_statement] = STATE(34),
    [sym_case_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_do_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_goto_statement] = STATE(34),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(34),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(34),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(398),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(44),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(400),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(44),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(402),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(44),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(404),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_specifiers] = STATE(962),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(595),
    [sym_compound_statement] = STATE(32),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(815),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_case_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_goto_statement] = STATE(32),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(32),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [ts_builtin_sym_end] = ACTIONS(406),
    [sym_identifier] = ACTIONS(408),
    [aux_sym_preproc_include_token1] = ACTIONS(411),
    [aux_sym_preproc_def_token1] = ACTIONS(414),
    [aux_sym_preproc_if_token1] = ACTIONS(417),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(420),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(420),
    [sym_preproc_directive] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(195),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_TILDE] = ACTIONS(198),
    [anon_sym_DASH] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(204),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_typedef] = ACTIONS(429),
    [anon_sym_extern] = ACTIONS(432),
    [anon_sym___attribute__] = ACTIONS(216),
    [anon_sym___declspec] = ACTIONS(219),
    [anon_sym___cdecl] = ACTIONS(222),
    [anon_sym___clrcall] = ACTIONS(222),
    [anon_sym___stdcall] = ACTIONS(222),
    [anon_sym___fastcall] = ACTIONS(222),
    [anon_sym___thiscall] = ACTIONS(222),
    [anon_sym___vectorcall] = ACTIONS(222),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_auto] = ACTIONS(228),
    [anon_sym_register] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_const] = ACTIONS(231),
    [anon_sym_volatile] = ACTIONS(231),
    [anon_sym_restrict] = ACTIONS(231),
    [anon_sym__Atomic] = ACTIONS(231),
    [anon_sym_signed] = ACTIONS(234),
    [anon_sym_unsigned] = ACTIONS(234),
    [anon_sym_long] = ACTIONS(234),
    [anon_sym_short] = ACTIONS(234),
    [sym_primitive_type] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(240),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_union] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(438),
    [anon_sym_switch] = ACTIONS(441),
    [anon_sym_case] = ACTIONS(444),
    [anon_sym_default] = ACTIONS(447),
    [anon_sym_while] = ACTIONS(450),
    [anon_sym_do] = ACTIONS(453),
    [anon_sym_for] = ACTIONS(456),
    [anon_sym_return] = ACTIONS(459),
    [anon_sym_break] = ACTIONS(462),
    [anon_sym_continue] = ACTIONS(465),
    [anon_sym_goto] = ACTIONS(468),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_sizeof] = ACTIONS(285),
    [sym_number_literal] = ACTIONS(288),
    [anon_sym_L_SQUOTE] = ACTIONS(291),
    [anon_sym_u_SQUOTE] = ACTIONS(291),
    [anon_sym_U_SQUOTE] = ACTIONS(291),
    [anon_sym_u8_SQUOTE] = ACTIONS(291),
    [anon_sym_SQUOTE] = ACTIONS(291),
    [anon_sym_L_DQUOTE] = ACTIONS(294),
    [anon_sym_u_DQUOTE] = ACTIONS(294),
    [anon_sym_U_DQUOTE] = ACTIONS(294),
    [anon_sym_u8_DQUOTE] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_null] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_specifiers] = STATE(962),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(595),
    [sym_compound_statement] = STATE(32),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(815),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_case_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_goto_statement] = STATE(32),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(32),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [ts_builtin_sym_end] = ACTIONS(471),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(13),
    [aux_sym_preproc_def_token1] = ACTIONS(15),
    [aux_sym_preproc_if_token1] = ACTIONS(17),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(19),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(19),
    [sym_preproc_directive] = ACTIONS(21),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_typedef] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(44),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(473),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_preproc_include] = STATE(37),
    [sym_preproc_def] = STATE(37),
    [sym_preproc_function_def] = STATE(37),
    [sym_preproc_call] = STATE(37),
    [sym_preproc_if] = STATE(37),
    [sym_preproc_ifdef] = STATE(37),
    [sym_function_definition] = STATE(37),
    [sym_declaration] = STATE(37),
    [sym_type_definition] = STATE(37),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(37),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(37),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(37),
    [sym_expression_statement] = STATE(37),
    [sym_if_statement] = STATE(37),
    [sym_switch_statement] = STATE(37),
    [sym_case_statement] = STATE(37),
    [sym_while_statement] = STATE(37),
    [sym_do_statement] = STATE(37),
    [sym_for_statement] = STATE(37),
    [sym_return_statement] = STATE(37),
    [sym_break_statement] = STATE(37),
    [sym_continue_statement] = STATE(37),
    [sym_goto_statement] = STATE(37),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(37),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(37),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(475),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_specifiers] = STATE(956),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(596),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(814),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(350),
    [aux_sym_preproc_include_token1] = ACTIONS(352),
    [aux_sym_preproc_def_token1] = ACTIONS(354),
    [aux_sym_preproc_if_token1] = ACTIONS(356),
    [aux_sym_preproc_if_token2] = ACTIONS(477),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(360),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(360),
    [sym_preproc_directive] = ACTIONS(362),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_typedef] = ACTIONS(366),
    [anon_sym_extern] = ACTIONS(368),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(44),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym_preproc_include] = STATE(31),
    [sym_preproc_def] = STATE(31),
    [sym_preproc_function_def] = STATE(31),
    [sym_preproc_call] = STATE(31),
    [sym_preproc_if] = STATE(31),
    [sym_preproc_ifdef] = STATE(31),
    [sym_function_definition] = STATE(31),
    [sym_declaration] = STATE(31),
    [sym_type_definition] = STATE(31),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(31),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(31),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(31),
    [sym_expression_statement] = STATE(31),
    [sym_if_statement] = STATE(31),
    [sym_switch_statement] = STATE(31),
    [sym_case_statement] = STATE(31),
    [sym_while_statement] = STATE(31),
    [sym_do_statement] = STATE(31),
    [sym_for_statement] = STATE(31),
    [sym_return_statement] = STATE(31),
    [sym_break_statement] = STATE(31),
    [sym_continue_statement] = STATE(31),
    [sym_goto_statement] = STATE(31),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(31),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(31),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(44),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(483),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_specifiers] = STATE(956),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(596),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(814),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(485),
    [aux_sym_preproc_include_token1] = ACTIONS(488),
    [aux_sym_preproc_def_token1] = ACTIONS(491),
    [aux_sym_preproc_if_token1] = ACTIONS(494),
    [aux_sym_preproc_if_token2] = ACTIONS(187),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(497),
    [sym_preproc_directive] = ACTIONS(500),
    [anon_sym_LPAREN2] = ACTIONS(195),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_TILDE] = ACTIONS(198),
    [anon_sym_DASH] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(204),
    [anon_sym_SEMI] = ACTIONS(503),
    [anon_sym_typedef] = ACTIONS(506),
    [anon_sym_extern] = ACTIONS(509),
    [anon_sym___attribute__] = ACTIONS(216),
    [anon_sym___declspec] = ACTIONS(219),
    [anon_sym___cdecl] = ACTIONS(222),
    [anon_sym___clrcall] = ACTIONS(222),
    [anon_sym___stdcall] = ACTIONS(222),
    [anon_sym___fastcall] = ACTIONS(222),
    [anon_sym___thiscall] = ACTIONS(222),
    [anon_sym___vectorcall] = ACTIONS(222),
    [anon_sym_LBRACE] = ACTIONS(512),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_auto] = ACTIONS(228),
    [anon_sym_register] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_const] = ACTIONS(231),
    [anon_sym_volatile] = ACTIONS(231),
    [anon_sym_restrict] = ACTIONS(231),
    [anon_sym__Atomic] = ACTIONS(231),
    [anon_sym_signed] = ACTIONS(234),
    [anon_sym_unsigned] = ACTIONS(234),
    [anon_sym_long] = ACTIONS(234),
    [anon_sym_short] = ACTIONS(234),
    [sym_primitive_type] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(240),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_union] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(515),
    [anon_sym_switch] = ACTIONS(518),
    [anon_sym_case] = ACTIONS(521),
    [anon_sym_default] = ACTIONS(524),
    [anon_sym_while] = ACTIONS(527),
    [anon_sym_do] = ACTIONS(530),
    [anon_sym_for] = ACTIONS(533),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(539),
    [anon_sym_continue] = ACTIONS(542),
    [anon_sym_goto] = ACTIONS(545),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_sizeof] = ACTIONS(285),
    [sym_number_literal] = ACTIONS(288),
    [anon_sym_L_SQUOTE] = ACTIONS(291),
    [anon_sym_u_SQUOTE] = ACTIONS(291),
    [anon_sym_U_SQUOTE] = ACTIONS(291),
    [anon_sym_u8_SQUOTE] = ACTIONS(291),
    [anon_sym_SQUOTE] = ACTIONS(291),
    [anon_sym_L_DQUOTE] = ACTIONS(294),
    [anon_sym_u_DQUOTE] = ACTIONS(294),
    [anon_sym_U_DQUOTE] = ACTIONS(294),
    [anon_sym_u8_DQUOTE] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_null] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(44),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(548),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(41),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_case_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(41),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(300),
    [aux_sym_preproc_include_token1] = ACTIONS(302),
    [aux_sym_preproc_def_token1] = ACTIONS(304),
    [aux_sym_preproc_if_token1] = ACTIONS(306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(308),
    [sym_preproc_directive] = ACTIONS(310),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(316),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(550),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_specifiers] = STATE(962),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(595),
    [sym_compound_statement] = STATE(22),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(815),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_case_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_goto_statement] = STATE(22),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [ts_builtin_sym_end] = ACTIONS(552),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(13),
    [aux_sym_preproc_def_token1] = ACTIONS(15),
    [aux_sym_preproc_if_token1] = ACTIONS(17),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(19),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(19),
    [sym_preproc_directive] = ACTIONS(21),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_typedef] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(41),
    [anon_sym___clrcall] = ACTIONS(41),
    [anon_sym___stdcall] = ACTIONS(41),
    [anon_sym___fastcall] = ACTIONS(41),
    [anon_sym___thiscall] = ACTIONS(41),
    [anon_sym___vectorcall] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_specifiers] = STATE(958),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_ms_call_modifier] = STATE(593),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(816),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym__empty_declaration] = STATE(44),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_translation_unit_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(554),
    [aux_sym_preproc_include_token1] = ACTIONS(557),
    [aux_sym_preproc_def_token1] = ACTIONS(560),
    [aux_sym_preproc_if_token1] = ACTIONS(563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(566),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(566),
    [sym_preproc_directive] = ACTIONS(569),
    [anon_sym_LPAREN2] = ACTIONS(195),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_TILDE] = ACTIONS(198),
    [anon_sym_DASH] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_AMP] = ACTIONS(204),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_typedef] = ACTIONS(575),
    [anon_sym_extern] = ACTIONS(578),
    [anon_sym___attribute__] = ACTIONS(216),
    [anon_sym___declspec] = ACTIONS(219),
    [anon_sym___cdecl] = ACTIONS(222),
    [anon_sym___clrcall] = ACTIONS(222),
    [anon_sym___stdcall] = ACTIONS(222),
    [anon_sym___fastcall] = ACTIONS(222),
    [anon_sym___thiscall] = ACTIONS(222),
    [anon_sym___vectorcall] = ACTIONS(222),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_RBRACE] = ACTIONS(406),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_auto] = ACTIONS(228),
    [anon_sym_register] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_const] = ACTIONS(231),
    [anon_sym_volatile] = ACTIONS(231),
    [anon_sym_restrict] = ACTIONS(231),
    [anon_sym__Atomic] = ACTIONS(231),
    [anon_sym_signed] = ACTIONS(234),
    [anon_sym_unsigned] = ACTIONS(234),
    [anon_sym_long] = ACTIONS(234),
    [anon_sym_short] = ACTIONS(234),
    [sym_primitive_type] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(240),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_union] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(584),
    [anon_sym_switch] = ACTIONS(587),
    [anon_sym_case] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(593),
    [anon_sym_while] = ACTIONS(596),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_for] = ACTIONS(602),
    [anon_sym_return] = ACTIONS(605),
    [anon_sym_break] = ACTIONS(608),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(614),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_sizeof] = ACTIONS(285),
    [sym_number_literal] = ACTIONS(288),
    [anon_sym_L_SQUOTE] = ACTIONS(291),
    [anon_sym_u_SQUOTE] = ACTIONS(291),
    [anon_sym_U_SQUOTE] = ACTIONS(291),
    [anon_sym_u8_SQUOTE] = ACTIONS(291),
    [anon_sym_SQUOTE] = ACTIONS(291),
    [anon_sym_L_DQUOTE] = ACTIONS(294),
    [anon_sym_u_DQUOTE] = ACTIONS(294),
    [anon_sym_U_DQUOTE] = ACTIONS(294),
    [anon_sym_u8_DQUOTE] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_null] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_declaration] = STATE(45),
    [sym_type_definition] = STATE(45),
    [sym__declaration_specifiers] = STATE(960),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(45),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(45),
    [sym_expression_statement] = STATE(45),
    [sym_if_statement] = STATE(45),
    [sym_switch_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_do_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_return_statement] = STATE(45),
    [sym_break_statement] = STATE(45),
    [sym_continue_statement] = STATE(45),
    [sym_goto_statement] = STATE(45),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(45),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(620),
    [aux_sym_preproc_def_token1] = ACTIONS(620),
    [aux_sym_preproc_if_token1] = ACTIONS(620),
    [aux_sym_preproc_if_token2] = ACTIONS(620),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(620),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(620),
    [aux_sym_preproc_else_token1] = ACTIONS(620),
    [aux_sym_preproc_elif_token1] = ACTIONS(620),
    [sym_preproc_directive] = ACTIONS(620),
    [anon_sym_LPAREN2] = ACTIONS(622),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_TILDE] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_AMP] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(634),
    [anon_sym_typedef] = ACTIONS(637),
    [anon_sym_extern] = ACTIONS(640),
    [anon_sym___attribute__] = ACTIONS(643),
    [anon_sym___declspec] = ACTIONS(646),
    [anon_sym___cdecl] = ACTIONS(620),
    [anon_sym___clrcall] = ACTIONS(620),
    [anon_sym___stdcall] = ACTIONS(620),
    [anon_sym___fastcall] = ACTIONS(620),
    [anon_sym___thiscall] = ACTIONS(620),
    [anon_sym___vectorcall] = ACTIONS(620),
    [anon_sym_LBRACE] = ACTIONS(649),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_auto] = ACTIONS(640),
    [anon_sym_register] = ACTIONS(640),
    [anon_sym_inline] = ACTIONS(640),
    [anon_sym_const] = ACTIONS(652),
    [anon_sym_volatile] = ACTIONS(652),
    [anon_sym_restrict] = ACTIONS(652),
    [anon_sym__Atomic] = ACTIONS(652),
    [anon_sym_signed] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(655),
    [anon_sym_long] = ACTIONS(655),
    [anon_sym_short] = ACTIONS(655),
    [sym_primitive_type] = ACTIONS(658),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(664),
    [anon_sym_union] = ACTIONS(667),
    [anon_sym_if] = ACTIONS(670),
    [anon_sym_else] = ACTIONS(620),
    [anon_sym_switch] = ACTIONS(673),
    [anon_sym_case] = ACTIONS(620),
    [anon_sym_default] = ACTIONS(620),
    [anon_sym_while] = ACTIONS(676),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(682),
    [anon_sym_return] = ACTIONS(685),
    [anon_sym_break] = ACTIONS(688),
    [anon_sym_continue] = ACTIONS(691),
    [anon_sym_goto] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(697),
    [anon_sym_PLUS_PLUS] = ACTIONS(697),
    [anon_sym_sizeof] = ACTIONS(700),
    [sym_number_literal] = ACTIONS(703),
    [anon_sym_L_SQUOTE] = ACTIONS(706),
    [anon_sym_u_SQUOTE] = ACTIONS(706),
    [anon_sym_U_SQUOTE] = ACTIONS(706),
    [anon_sym_u8_SQUOTE] = ACTIONS(706),
    [anon_sym_SQUOTE] = ACTIONS(706),
    [anon_sym_L_DQUOTE] = ACTIONS(709),
    [anon_sym_u_DQUOTE] = ACTIONS(709),
    [anon_sym_U_DQUOTE] = ACTIONS(709),
    [anon_sym_u8_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_declaration] = STATE(45),
    [sym_type_definition] = STATE(45),
    [sym__declaration_specifiers] = STATE(960),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(45),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(45),
    [sym_expression_statement] = STATE(45),
    [sym_if_statement] = STATE(45),
    [sym_switch_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_do_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_return_statement] = STATE(45),
    [sym_break_statement] = STATE(45),
    [sym_continue_statement] = STATE(45),
    [sym_goto_statement] = STATE(45),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(45),
    [sym_identifier] = ACTIONS(715),
    [aux_sym_preproc_include_token1] = ACTIONS(717),
    [aux_sym_preproc_def_token1] = ACTIONS(717),
    [aux_sym_preproc_if_token1] = ACTIONS(717),
    [aux_sym_preproc_if_token2] = ACTIONS(717),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(717),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(717),
    [aux_sym_preproc_else_token1] = ACTIONS(717),
    [aux_sym_preproc_elif_token1] = ACTIONS(717),
    [sym_preproc_directive] = ACTIONS(717),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(717),
    [anon_sym___clrcall] = ACTIONS(717),
    [anon_sym___stdcall] = ACTIONS(717),
    [anon_sym___fastcall] = ACTIONS(717),
    [anon_sym___thiscall] = ACTIONS(717),
    [anon_sym___vectorcall] = ACTIONS(717),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_else] = ACTIONS(717),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(717),
    [anon_sym_default] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym__declaration_specifiers] = STATE(960),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(49),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(49),
    [sym_expression_statement] = STATE(49),
    [sym_if_statement] = STATE(49),
    [sym_switch_statement] = STATE(49),
    [sym_while_statement] = STATE(49),
    [sym_do_statement] = STATE(49),
    [sym_for_statement] = STATE(49),
    [sym_return_statement] = STATE(49),
    [sym_break_statement] = STATE(49),
    [sym_continue_statement] = STATE(49),
    [sym_goto_statement] = STATE(49),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(49),
    [sym_identifier] = ACTIONS(715),
    [aux_sym_preproc_include_token1] = ACTIONS(719),
    [aux_sym_preproc_def_token1] = ACTIONS(719),
    [aux_sym_preproc_if_token1] = ACTIONS(719),
    [aux_sym_preproc_if_token2] = ACTIONS(719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(719),
    [aux_sym_preproc_else_token1] = ACTIONS(719),
    [aux_sym_preproc_elif_token1] = ACTIONS(719),
    [sym_preproc_directive] = ACTIONS(719),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(719),
    [anon_sym___clrcall] = ACTIONS(719),
    [anon_sym___stdcall] = ACTIONS(719),
    [anon_sym___fastcall] = ACTIONS(719),
    [anon_sym___thiscall] = ACTIONS(719),
    [anon_sym___vectorcall] = ACTIONS(719),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_else] = ACTIONS(719),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(719),
    [anon_sym_default] = ACTIONS(719),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [sym_declaration] = STATE(46),
    [sym_type_definition] = STATE(46),
    [sym__declaration_specifiers] = STATE(960),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(46),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(46),
    [sym_expression_statement] = STATE(46),
    [sym_if_statement] = STATE(46),
    [sym_switch_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_do_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_return_statement] = STATE(46),
    [sym_break_statement] = STATE(46),
    [sym_continue_statement] = STATE(46),
    [sym_goto_statement] = STATE(46),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(46),
    [sym_identifier] = ACTIONS(715),
    [aux_sym_preproc_include_token1] = ACTIONS(721),
    [aux_sym_preproc_def_token1] = ACTIONS(721),
    [aux_sym_preproc_if_token1] = ACTIONS(721),
    [aux_sym_preproc_if_token2] = ACTIONS(721),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(721),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(721),
    [aux_sym_preproc_else_token1] = ACTIONS(721),
    [aux_sym_preproc_elif_token1] = ACTIONS(721),
    [sym_preproc_directive] = ACTIONS(721),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(721),
    [anon_sym___clrcall] = ACTIONS(721),
    [anon_sym___stdcall] = ACTIONS(721),
    [anon_sym___fastcall] = ACTIONS(721),
    [anon_sym___thiscall] = ACTIONS(721),
    [anon_sym___vectorcall] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_else] = ACTIONS(721),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(721),
    [anon_sym_default] = ACTIONS(721),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym_declaration] = STATE(45),
    [sym_type_definition] = STATE(45),
    [sym__declaration_specifiers] = STATE(960),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(45),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(45),
    [sym_expression_statement] = STATE(45),
    [sym_if_statement] = STATE(45),
    [sym_switch_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_do_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_return_statement] = STATE(45),
    [sym_break_statement] = STATE(45),
    [sym_continue_statement] = STATE(45),
    [sym_goto_statement] = STATE(45),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(45),
    [sym_identifier] = ACTIONS(715),
    [aux_sym_preproc_include_token1] = ACTIONS(723),
    [aux_sym_preproc_def_token1] = ACTIONS(723),
    [aux_sym_preproc_if_token1] = ACTIONS(723),
    [aux_sym_preproc_if_token2] = ACTIONS(723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(723),
    [aux_sym_preproc_else_token1] = ACTIONS(723),
    [aux_sym_preproc_elif_token1] = ACTIONS(723),
    [sym_preproc_directive] = ACTIONS(723),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_typedef] = ACTIONS(113),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(723),
    [anon_sym___clrcall] = ACTIONS(723),
    [anon_sym___stdcall] = ACTIONS(723),
    [anon_sym___fastcall] = ACTIONS(723),
    [anon_sym___thiscall] = ACTIONS(723),
    [anon_sym___vectorcall] = ACTIONS(723),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_else] = ACTIONS(723),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(723),
    [anon_sym_default] = ACTIONS(723),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_specifiers] = STATE(957),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(61),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(61),
    [sym_expression_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_switch_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_do_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_return_statement] = STATE(61),
    [sym_break_statement] = STATE(61),
    [sym_continue_statement] = STATE(61),
    [sym_goto_statement] = STATE(61),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(61),
    [sym_identifier] = ACTIONS(725),
    [aux_sym_preproc_include_token1] = ACTIONS(723),
    [aux_sym_preproc_def_token1] = ACTIONS(723),
    [aux_sym_preproc_if_token1] = ACTIONS(723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(723),
    [sym_preproc_directive] = ACTIONS(723),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(723),
    [anon_sym___clrcall] = ACTIONS(723),
    [anon_sym___stdcall] = ACTIONS(723),
    [anon_sym___fastcall] = ACTIONS(723),
    [anon_sym___thiscall] = ACTIONS(723),
    [anon_sym___vectorcall] = ACTIONS(723),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_else] = ACTIONS(723),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(723),
    [anon_sym_default] = ACTIONS(723),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_specifiers] = STATE(964),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(54),
    [sym_identifier] = ACTIONS(729),
    [aux_sym_preproc_include_token1] = ACTIONS(719),
    [aux_sym_preproc_def_token1] = ACTIONS(719),
    [aux_sym_preproc_if_token1] = ACTIONS(719),
    [aux_sym_preproc_if_token2] = ACTIONS(719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(719),
    [sym_preproc_directive] = ACTIONS(719),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_typedef] = ACTIONS(366),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(719),
    [anon_sym___clrcall] = ACTIONS(719),
    [anon_sym___stdcall] = ACTIONS(719),
    [anon_sym___fastcall] = ACTIONS(719),
    [anon_sym___thiscall] = ACTIONS(719),
    [anon_sym___vectorcall] = ACTIONS(719),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_else] = ACTIONS(719),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(719),
    [anon_sym_default] = ACTIONS(719),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_declaration] = STATE(57),
    [sym_type_definition] = STATE(57),
    [sym__declaration_specifiers] = STATE(964),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(57),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(57),
    [sym_expression_statement] = STATE(57),
    [sym_if_statement] = STATE(57),
    [sym_switch_statement] = STATE(57),
    [sym_while_statement] = STATE(57),
    [sym_do_statement] = STATE(57),
    [sym_for_statement] = STATE(57),
    [sym_return_statement] = STATE(57),
    [sym_break_statement] = STATE(57),
    [sym_continue_statement] = STATE(57),
    [sym_goto_statement] = STATE(57),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(57),
    [sym_identifier] = ACTIONS(729),
    [aux_sym_preproc_include_token1] = ACTIONS(717),
    [aux_sym_preproc_def_token1] = ACTIONS(717),
    [aux_sym_preproc_if_token1] = ACTIONS(717),
    [aux_sym_preproc_if_token2] = ACTIONS(717),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(717),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(717),
    [sym_preproc_directive] = ACTIONS(717),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_typedef] = ACTIONS(366),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(717),
    [anon_sym___clrcall] = ACTIONS(717),
    [anon_sym___stdcall] = ACTIONS(717),
    [anon_sym___fastcall] = ACTIONS(717),
    [anon_sym___thiscall] = ACTIONS(717),
    [anon_sym___vectorcall] = ACTIONS(717),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_else] = ACTIONS(717),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(717),
    [anon_sym_default] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_specifiers] = STATE(961),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(62),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(62),
    [sym_expression_statement] = STATE(62),
    [sym_if_statement] = STATE(62),
    [sym_switch_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_do_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_return_statement] = STATE(62),
    [sym_break_statement] = STATE(62),
    [sym_continue_statement] = STATE(62),
    [sym_goto_statement] = STATE(62),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(62),
    [ts_builtin_sym_end] = ACTIONS(731),
    [sym_identifier] = ACTIONS(733),
    [aux_sym_preproc_include_token1] = ACTIONS(717),
    [aux_sym_preproc_def_token1] = ACTIONS(717),
    [aux_sym_preproc_if_token1] = ACTIONS(717),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(717),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(717),
    [sym_preproc_directive] = ACTIONS(717),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_typedef] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(717),
    [anon_sym___clrcall] = ACTIONS(717),
    [anon_sym___stdcall] = ACTIONS(717),
    [anon_sym___fastcall] = ACTIONS(717),
    [anon_sym___thiscall] = ACTIONS(717),
    [anon_sym___vectorcall] = ACTIONS(717),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_else] = ACTIONS(717),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(717),
    [anon_sym_default] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_declaration] = STATE(57),
    [sym_type_definition] = STATE(57),
    [sym__declaration_specifiers] = STATE(964),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(57),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(57),
    [sym_expression_statement] = STATE(57),
    [sym_if_statement] = STATE(57),
    [sym_switch_statement] = STATE(57),
    [sym_while_statement] = STATE(57),
    [sym_do_statement] = STATE(57),
    [sym_for_statement] = STATE(57),
    [sym_return_statement] = STATE(57),
    [sym_break_statement] = STATE(57),
    [sym_continue_statement] = STATE(57),
    [sym_goto_statement] = STATE(57),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(57),
    [sym_identifier] = ACTIONS(729),
    [aux_sym_preproc_include_token1] = ACTIONS(723),
    [aux_sym_preproc_def_token1] = ACTIONS(723),
    [aux_sym_preproc_if_token1] = ACTIONS(723),
    [aux_sym_preproc_if_token2] = ACTIONS(723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(723),
    [sym_preproc_directive] = ACTIONS(723),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_typedef] = ACTIONS(366),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(723),
    [anon_sym___clrcall] = ACTIONS(723),
    [anon_sym___stdcall] = ACTIONS(723),
    [anon_sym___fastcall] = ACTIONS(723),
    [anon_sym___thiscall] = ACTIONS(723),
    [anon_sym___vectorcall] = ACTIONS(723),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_else] = ACTIONS(723),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(723),
    [anon_sym_default] = ACTIONS(723),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym_declaration] = STATE(63),
    [sym_type_definition] = STATE(63),
    [sym__declaration_specifiers] = STATE(961),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(63),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(63),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(63),
    [ts_builtin_sym_end] = ACTIONS(735),
    [sym_identifier] = ACTIONS(733),
    [aux_sym_preproc_include_token1] = ACTIONS(719),
    [aux_sym_preproc_def_token1] = ACTIONS(719),
    [aux_sym_preproc_if_token1] = ACTIONS(719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(719),
    [sym_preproc_directive] = ACTIONS(719),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_typedef] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(719),
    [anon_sym___clrcall] = ACTIONS(719),
    [anon_sym___stdcall] = ACTIONS(719),
    [anon_sym___fastcall] = ACTIONS(719),
    [anon_sym___thiscall] = ACTIONS(719),
    [anon_sym___vectorcall] = ACTIONS(719),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_else] = ACTIONS(719),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(719),
    [anon_sym_default] = ACTIONS(719),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_specifiers] = STATE(961),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(53),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(53),
    [sym_expression_statement] = STATE(53),
    [sym_if_statement] = STATE(53),
    [sym_switch_statement] = STATE(53),
    [sym_while_statement] = STATE(53),
    [sym_do_statement] = STATE(53),
    [sym_for_statement] = STATE(53),
    [sym_return_statement] = STATE(53),
    [sym_break_statement] = STATE(53),
    [sym_continue_statement] = STATE(53),
    [sym_goto_statement] = STATE(53),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(53),
    [ts_builtin_sym_end] = ACTIONS(737),
    [sym_identifier] = ACTIONS(733),
    [aux_sym_preproc_include_token1] = ACTIONS(721),
    [aux_sym_preproc_def_token1] = ACTIONS(721),
    [aux_sym_preproc_if_token1] = ACTIONS(721),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(721),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(721),
    [sym_preproc_directive] = ACTIONS(721),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_typedef] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(721),
    [anon_sym___clrcall] = ACTIONS(721),
    [anon_sym___stdcall] = ACTIONS(721),
    [anon_sym___fastcall] = ACTIONS(721),
    [anon_sym___thiscall] = ACTIONS(721),
    [anon_sym___vectorcall] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_else] = ACTIONS(721),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(721),
    [anon_sym_default] = ACTIONS(721),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [57] = {
    [sym_declaration] = STATE(57),
    [sym_type_definition] = STATE(57),
    [sym__declaration_specifiers] = STATE(964),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(57),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(57),
    [sym_expression_statement] = STATE(57),
    [sym_if_statement] = STATE(57),
    [sym_switch_statement] = STATE(57),
    [sym_while_statement] = STATE(57),
    [sym_do_statement] = STATE(57),
    [sym_for_statement] = STATE(57),
    [sym_return_statement] = STATE(57),
    [sym_break_statement] = STATE(57),
    [sym_continue_statement] = STATE(57),
    [sym_goto_statement] = STATE(57),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(57),
    [sym_identifier] = ACTIONS(739),
    [aux_sym_preproc_include_token1] = ACTIONS(620),
    [aux_sym_preproc_def_token1] = ACTIONS(620),
    [aux_sym_preproc_if_token1] = ACTIONS(620),
    [aux_sym_preproc_if_token2] = ACTIONS(620),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(620),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(620),
    [sym_preproc_directive] = ACTIONS(620),
    [anon_sym_LPAREN2] = ACTIONS(622),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_TILDE] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_AMP] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(742),
    [anon_sym_typedef] = ACTIONS(745),
    [anon_sym_extern] = ACTIONS(640),
    [anon_sym___attribute__] = ACTIONS(643),
    [anon_sym___declspec] = ACTIONS(646),
    [anon_sym___cdecl] = ACTIONS(620),
    [anon_sym___clrcall] = ACTIONS(620),
    [anon_sym___stdcall] = ACTIONS(620),
    [anon_sym___fastcall] = ACTIONS(620),
    [anon_sym___thiscall] = ACTIONS(620),
    [anon_sym___vectorcall] = ACTIONS(620),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_auto] = ACTIONS(640),
    [anon_sym_register] = ACTIONS(640),
    [anon_sym_inline] = ACTIONS(640),
    [anon_sym_const] = ACTIONS(652),
    [anon_sym_volatile] = ACTIONS(652),
    [anon_sym_restrict] = ACTIONS(652),
    [anon_sym__Atomic] = ACTIONS(652),
    [anon_sym_signed] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(655),
    [anon_sym_long] = ACTIONS(655),
    [anon_sym_short] = ACTIONS(655),
    [sym_primitive_type] = ACTIONS(658),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(664),
    [anon_sym_union] = ACTIONS(667),
    [anon_sym_if] = ACTIONS(751),
    [anon_sym_else] = ACTIONS(620),
    [anon_sym_switch] = ACTIONS(754),
    [anon_sym_case] = ACTIONS(620),
    [anon_sym_default] = ACTIONS(620),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_do] = ACTIONS(760),
    [anon_sym_for] = ACTIONS(763),
    [anon_sym_return] = ACTIONS(766),
    [anon_sym_break] = ACTIONS(769),
    [anon_sym_continue] = ACTIONS(772),
    [anon_sym_goto] = ACTIONS(775),
    [anon_sym_DASH_DASH] = ACTIONS(697),
    [anon_sym_PLUS_PLUS] = ACTIONS(697),
    [anon_sym_sizeof] = ACTIONS(700),
    [sym_number_literal] = ACTIONS(703),
    [anon_sym_L_SQUOTE] = ACTIONS(706),
    [anon_sym_u_SQUOTE] = ACTIONS(706),
    [anon_sym_U_SQUOTE] = ACTIONS(706),
    [anon_sym_u8_SQUOTE] = ACTIONS(706),
    [anon_sym_SQUOTE] = ACTIONS(706),
    [anon_sym_L_DQUOTE] = ACTIONS(709),
    [anon_sym_u_DQUOTE] = ACTIONS(709),
    [anon_sym_U_DQUOTE] = ACTIONS(709),
    [anon_sym_u8_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_specifiers] = STATE(957),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(59),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_switch_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_do_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_break_statement] = STATE(59),
    [sym_continue_statement] = STATE(59),
    [sym_goto_statement] = STATE(59),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(59),
    [sym_identifier] = ACTIONS(725),
    [aux_sym_preproc_include_token1] = ACTIONS(721),
    [aux_sym_preproc_def_token1] = ACTIONS(721),
    [aux_sym_preproc_if_token1] = ACTIONS(721),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(721),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(721),
    [sym_preproc_directive] = ACTIONS(721),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(721),
    [anon_sym___clrcall] = ACTIONS(721),
    [anon_sym___stdcall] = ACTIONS(721),
    [anon_sym___fastcall] = ACTIONS(721),
    [anon_sym___thiscall] = ACTIONS(721),
    [anon_sym___vectorcall] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_else] = ACTIONS(721),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(721),
    [anon_sym_default] = ACTIONS(721),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_specifiers] = STATE(957),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(61),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(61),
    [sym_expression_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_switch_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_do_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_return_statement] = STATE(61),
    [sym_break_statement] = STATE(61),
    [sym_continue_statement] = STATE(61),
    [sym_goto_statement] = STATE(61),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(61),
    [sym_identifier] = ACTIONS(725),
    [aux_sym_preproc_include_token1] = ACTIONS(717),
    [aux_sym_preproc_def_token1] = ACTIONS(717),
    [aux_sym_preproc_if_token1] = ACTIONS(717),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(717),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(717),
    [sym_preproc_directive] = ACTIONS(717),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(717),
    [anon_sym___clrcall] = ACTIONS(717),
    [anon_sym___stdcall] = ACTIONS(717),
    [anon_sym___fastcall] = ACTIONS(717),
    [anon_sym___thiscall] = ACTIONS(717),
    [anon_sym___vectorcall] = ACTIONS(717),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_else] = ACTIONS(717),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(717),
    [anon_sym_default] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_specifiers] = STATE(964),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(52),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(52),
    [sym_expression_statement] = STATE(52),
    [sym_if_statement] = STATE(52),
    [sym_switch_statement] = STATE(52),
    [sym_while_statement] = STATE(52),
    [sym_do_statement] = STATE(52),
    [sym_for_statement] = STATE(52),
    [sym_return_statement] = STATE(52),
    [sym_break_statement] = STATE(52),
    [sym_continue_statement] = STATE(52),
    [sym_goto_statement] = STATE(52),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(729),
    [aux_sym_preproc_include_token1] = ACTIONS(721),
    [aux_sym_preproc_def_token1] = ACTIONS(721),
    [aux_sym_preproc_if_token1] = ACTIONS(721),
    [aux_sym_preproc_if_token2] = ACTIONS(721),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(721),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(721),
    [sym_preproc_directive] = ACTIONS(721),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_typedef] = ACTIONS(366),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(721),
    [anon_sym___clrcall] = ACTIONS(721),
    [anon_sym___stdcall] = ACTIONS(721),
    [anon_sym___fastcall] = ACTIONS(721),
    [anon_sym___thiscall] = ACTIONS(721),
    [anon_sym___vectorcall] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_else] = ACTIONS(721),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(721),
    [anon_sym_default] = ACTIONS(721),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_specifiers] = STATE(957),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(61),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(61),
    [sym_expression_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_switch_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_do_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_return_statement] = STATE(61),
    [sym_break_statement] = STATE(61),
    [sym_continue_statement] = STATE(61),
    [sym_goto_statement] = STATE(61),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(61),
    [sym_identifier] = ACTIONS(778),
    [aux_sym_preproc_include_token1] = ACTIONS(620),
    [aux_sym_preproc_def_token1] = ACTIONS(620),
    [aux_sym_preproc_if_token1] = ACTIONS(620),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(620),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(620),
    [sym_preproc_directive] = ACTIONS(620),
    [anon_sym_LPAREN2] = ACTIONS(622),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_TILDE] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_AMP] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_typedef] = ACTIONS(784),
    [anon_sym_extern] = ACTIONS(640),
    [anon_sym___attribute__] = ACTIONS(643),
    [anon_sym___declspec] = ACTIONS(646),
    [anon_sym___cdecl] = ACTIONS(620),
    [anon_sym___clrcall] = ACTIONS(620),
    [anon_sym___stdcall] = ACTIONS(620),
    [anon_sym___fastcall] = ACTIONS(620),
    [anon_sym___thiscall] = ACTIONS(620),
    [anon_sym___vectorcall] = ACTIONS(620),
    [anon_sym_LBRACE] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(790),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_auto] = ACTIONS(640),
    [anon_sym_register] = ACTIONS(640),
    [anon_sym_inline] = ACTIONS(640),
    [anon_sym_const] = ACTIONS(652),
    [anon_sym_volatile] = ACTIONS(652),
    [anon_sym_restrict] = ACTIONS(652),
    [anon_sym__Atomic] = ACTIONS(652),
    [anon_sym_signed] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(655),
    [anon_sym_long] = ACTIONS(655),
    [anon_sym_short] = ACTIONS(655),
    [sym_primitive_type] = ACTIONS(658),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(664),
    [anon_sym_union] = ACTIONS(667),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_else] = ACTIONS(620),
    [anon_sym_switch] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(620),
    [anon_sym_default] = ACTIONS(620),
    [anon_sym_while] = ACTIONS(798),
    [anon_sym_do] = ACTIONS(801),
    [anon_sym_for] = ACTIONS(804),
    [anon_sym_return] = ACTIONS(807),
    [anon_sym_break] = ACTIONS(810),
    [anon_sym_continue] = ACTIONS(813),
    [anon_sym_goto] = ACTIONS(816),
    [anon_sym_DASH_DASH] = ACTIONS(697),
    [anon_sym_PLUS_PLUS] = ACTIONS(697),
    [anon_sym_sizeof] = ACTIONS(700),
    [sym_number_literal] = ACTIONS(703),
    [anon_sym_L_SQUOTE] = ACTIONS(706),
    [anon_sym_u_SQUOTE] = ACTIONS(706),
    [anon_sym_U_SQUOTE] = ACTIONS(706),
    [anon_sym_u8_SQUOTE] = ACTIONS(706),
    [anon_sym_SQUOTE] = ACTIONS(706),
    [anon_sym_L_DQUOTE] = ACTIONS(709),
    [anon_sym_u_DQUOTE] = ACTIONS(709),
    [anon_sym_U_DQUOTE] = ACTIONS(709),
    [anon_sym_u8_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_specifiers] = STATE(961),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(62),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(62),
    [sym_expression_statement] = STATE(62),
    [sym_if_statement] = STATE(62),
    [sym_switch_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_do_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_return_statement] = STATE(62),
    [sym_break_statement] = STATE(62),
    [sym_continue_statement] = STATE(62),
    [sym_goto_statement] = STATE(62),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(62),
    [ts_builtin_sym_end] = ACTIONS(790),
    [sym_identifier] = ACTIONS(819),
    [aux_sym_preproc_include_token1] = ACTIONS(620),
    [aux_sym_preproc_def_token1] = ACTIONS(620),
    [aux_sym_preproc_if_token1] = ACTIONS(620),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(620),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(620),
    [sym_preproc_directive] = ACTIONS(620),
    [anon_sym_LPAREN2] = ACTIONS(622),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_TILDE] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_AMP] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_typedef] = ACTIONS(825),
    [anon_sym_extern] = ACTIONS(640),
    [anon_sym___attribute__] = ACTIONS(643),
    [anon_sym___declspec] = ACTIONS(646),
    [anon_sym___cdecl] = ACTIONS(620),
    [anon_sym___clrcall] = ACTIONS(620),
    [anon_sym___stdcall] = ACTIONS(620),
    [anon_sym___fastcall] = ACTIONS(620),
    [anon_sym___thiscall] = ACTIONS(620),
    [anon_sym___vectorcall] = ACTIONS(620),
    [anon_sym_LBRACE] = ACTIONS(828),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_auto] = ACTIONS(640),
    [anon_sym_register] = ACTIONS(640),
    [anon_sym_inline] = ACTIONS(640),
    [anon_sym_const] = ACTIONS(652),
    [anon_sym_volatile] = ACTIONS(652),
    [anon_sym_restrict] = ACTIONS(652),
    [anon_sym__Atomic] = ACTIONS(652),
    [anon_sym_signed] = ACTIONS(655),
    [anon_sym_unsigned] = ACTIONS(655),
    [anon_sym_long] = ACTIONS(655),
    [anon_sym_short] = ACTIONS(655),
    [sym_primitive_type] = ACTIONS(658),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(664),
    [anon_sym_union] = ACTIONS(667),
    [anon_sym_if] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(620),
    [anon_sym_switch] = ACTIONS(834),
    [anon_sym_case] = ACTIONS(620),
    [anon_sym_default] = ACTIONS(620),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(840),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_return] = ACTIONS(846),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_continue] = ACTIONS(852),
    [anon_sym_goto] = ACTIONS(855),
    [anon_sym_DASH_DASH] = ACTIONS(697),
    [anon_sym_PLUS_PLUS] = ACTIONS(697),
    [anon_sym_sizeof] = ACTIONS(700),
    [sym_number_literal] = ACTIONS(703),
    [anon_sym_L_SQUOTE] = ACTIONS(706),
    [anon_sym_u_SQUOTE] = ACTIONS(706),
    [anon_sym_U_SQUOTE] = ACTIONS(706),
    [anon_sym_u8_SQUOTE] = ACTIONS(706),
    [anon_sym_SQUOTE] = ACTIONS(706),
    [anon_sym_L_DQUOTE] = ACTIONS(709),
    [anon_sym_u_DQUOTE] = ACTIONS(709),
    [anon_sym_U_DQUOTE] = ACTIONS(709),
    [anon_sym_u8_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(709),
    [sym_true] = ACTIONS(712),
    [sym_false] = ACTIONS(712),
    [sym_null] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_specifiers] = STATE(961),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(62),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(62),
    [sym_expression_statement] = STATE(62),
    [sym_if_statement] = STATE(62),
    [sym_switch_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_do_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_return_statement] = STATE(62),
    [sym_break_statement] = STATE(62),
    [sym_continue_statement] = STATE(62),
    [sym_goto_statement] = STATE(62),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(62),
    [ts_builtin_sym_end] = ACTIONS(727),
    [sym_identifier] = ACTIONS(733),
    [aux_sym_preproc_include_token1] = ACTIONS(723),
    [aux_sym_preproc_def_token1] = ACTIONS(723),
    [aux_sym_preproc_if_token1] = ACTIONS(723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(723),
    [sym_preproc_directive] = ACTIONS(723),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_typedef] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(723),
    [anon_sym___clrcall] = ACTIONS(723),
    [anon_sym___stdcall] = ACTIONS(723),
    [anon_sym___fastcall] = ACTIONS(723),
    [anon_sym___thiscall] = ACTIONS(723),
    [anon_sym___vectorcall] = ACTIONS(723),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_else] = ACTIONS(723),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(723),
    [anon_sym_default] = ACTIONS(723),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym_declaration] = STATE(50),
    [sym_type_definition] = STATE(50),
    [sym__declaration_specifiers] = STATE(957),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_compound_statement] = STATE(50),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym_labeled_statement] = STATE(50),
    [sym_expression_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym_switch_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_do_statement] = STATE(50),
    [sym_for_statement] = STATE(50),
    [sym_return_statement] = STATE(50),
    [sym_break_statement] = STATE(50),
    [sym_continue_statement] = STATE(50),
    [sym_goto_statement] = STATE(50),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [aux_sym_case_statement_repeat1] = STATE(50),
    [sym_identifier] = ACTIONS(725),
    [aux_sym_preproc_include_token1] = ACTIONS(719),
    [aux_sym_preproc_def_token1] = ACTIONS(719),
    [aux_sym_preproc_if_token1] = ACTIONS(719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(719),
    [sym_preproc_directive] = ACTIONS(719),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_typedef] = ACTIONS(314),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym___cdecl] = ACTIONS(719),
    [anon_sym___clrcall] = ACTIONS(719),
    [anon_sym___stdcall] = ACTIONS(719),
    [anon_sym___fastcall] = ACTIONS(719),
    [anon_sym___thiscall] = ACTIONS(719),
    [anon_sym___vectorcall] = ACTIONS(719),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(735),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_else] = ACTIONS(719),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(719),
    [anon_sym_default] = ACTIONS(719),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym__expression] = STATE(505),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(583),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(583),
    [sym_call_expression] = STATE(583),
    [sym_field_expression] = STATE(583),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(583),
    [sym_initializer_list] = STATE(537),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(858),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_RPAREN] = ACTIONS(860),
    [anon_sym_LPAREN2] = ACTIONS(862),
    [anon_sym_BANG] = ACTIONS(864),
    [anon_sym_TILDE] = ACTIONS(866),
    [anon_sym_DASH] = ACTIONS(864),
    [anon_sym_PLUS] = ACTIONS(864),
    [anon_sym_STAR] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(870),
    [anon_sym_PERCENT] = ACTIONS(870),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(870),
    [anon_sym_CARET] = ACTIONS(870),
    [anon_sym_AMP] = ACTIONS(868),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_GT] = ACTIONS(870),
    [anon_sym_GT_EQ] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(860),
    [anon_sym_LT] = ACTIONS(870),
    [anon_sym_LT_LT] = ACTIONS(870),
    [anon_sym_GT_GT] = ACTIONS(870),
    [anon_sym_SEMI] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(872),
    [anon_sym_RBRACE] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(860),
    [anon_sym_RBRACK] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(870),
    [anon_sym_COLON] = ACTIONS(860),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_STAR_EQ] = ACTIONS(860),
    [anon_sym_SLASH_EQ] = ACTIONS(860),
    [anon_sym_PERCENT_EQ] = ACTIONS(860),
    [anon_sym_PLUS_EQ] = ACTIONS(860),
    [anon_sym_DASH_EQ] = ACTIONS(860),
    [anon_sym_LT_LT_EQ] = ACTIONS(860),
    [anon_sym_GT_GT_EQ] = ACTIONS(860),
    [anon_sym_AMP_EQ] = ACTIONS(860),
    [anon_sym_CARET_EQ] = ACTIONS(860),
    [anon_sym_PIPE_EQ] = ACTIONS(860),
    [anon_sym_DASH_DASH] = ACTIONS(874),
    [anon_sym_PLUS_PLUS] = ACTIONS(874),
    [anon_sym_sizeof] = ACTIONS(876),
    [anon_sym_DOT] = ACTIONS(870),
    [anon_sym_DASH_GT] = ACTIONS(860),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym_declaration] = STATE(503),
    [sym__declaration_specifiers] = STATE(957),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym__expression] = STATE(624),
    [sym_comma_expression] = STATE(1418),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(878),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(880),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym_declaration] = STATE(522),
    [sym__declaration_specifiers] = STATE(957),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym__expression] = STATE(659),
    [sym_comma_expression] = STATE(1431),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(878),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(882),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym_declaration] = STATE(500),
    [sym__declaration_specifiers] = STATE(957),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym__expression] = STATE(637),
    [sym_comma_expression] = STATE(1429),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(878),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(884),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym_declaration] = STATE(510),
    [sym__declaration_specifiers] = STATE(957),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym__expression] = STATE(644),
    [sym_comma_expression] = STATE(1405),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(878),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(886),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [sym_declaration] = STATE(509),
    [sym__declaration_specifiers] = STATE(957),
    [sym_attribute_specifier] = STATE(600),
    [sym_ms_declspec_modifier] = STATE(600),
    [sym_storage_class_specifier] = STATE(600),
    [sym_type_qualifier] = STATE(600),
    [sym__type_specifier] = STATE(776),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym__expression] = STATE(620),
    [sym_comma_expression] = STATE(1426),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(600),
    [aux_sym_sized_type_specifier_repeat1] = STATE(768),
    [sym_identifier] = ACTIONS(878),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(888),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(37),
    [anon_sym___declspec] = ACTIONS(39),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_identifier] = ACTIONS(890),
    [aux_sym_preproc_include_token1] = ACTIONS(890),
    [aux_sym_preproc_def_token1] = ACTIONS(890),
    [aux_sym_preproc_if_token1] = ACTIONS(890),
    [aux_sym_preproc_if_token2] = ACTIONS(890),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(890),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(890),
    [aux_sym_preproc_else_token1] = ACTIONS(890),
    [aux_sym_preproc_elif_token1] = ACTIONS(890),
    [sym_preproc_directive] = ACTIONS(890),
    [anon_sym_LPAREN2] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(892),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(892),
    [anon_sym_typedef] = ACTIONS(890),
    [anon_sym_extern] = ACTIONS(890),
    [anon_sym___attribute__] = ACTIONS(890),
    [anon_sym___declspec] = ACTIONS(890),
    [anon_sym___cdecl] = ACTIONS(890),
    [anon_sym___clrcall] = ACTIONS(890),
    [anon_sym___stdcall] = ACTIONS(890),
    [anon_sym___fastcall] = ACTIONS(890),
    [anon_sym___thiscall] = ACTIONS(890),
    [anon_sym___vectorcall] = ACTIONS(890),
    [anon_sym_LBRACE] = ACTIONS(892),
    [anon_sym_static] = ACTIONS(890),
    [anon_sym_auto] = ACTIONS(890),
    [anon_sym_register] = ACTIONS(890),
    [anon_sym_inline] = ACTIONS(890),
    [anon_sym_const] = ACTIONS(890),
    [anon_sym_volatile] = ACTIONS(890),
    [anon_sym_restrict] = ACTIONS(890),
    [anon_sym__Atomic] = ACTIONS(890),
    [anon_sym_signed] = ACTIONS(890),
    [anon_sym_unsigned] = ACTIONS(890),
    [anon_sym_long] = ACTIONS(890),
    [anon_sym_short] = ACTIONS(890),
    [sym_primitive_type] = ACTIONS(890),
    [anon_sym_enum] = ACTIONS(890),
    [anon_sym_struct] = ACTIONS(890),
    [anon_sym_union] = ACTIONS(890),
    [anon_sym_if] = ACTIONS(890),
    [anon_sym_else] = ACTIONS(890),
    [anon_sym_switch] = ACTIONS(890),
    [anon_sym_case] = ACTIONS(890),
    [anon_sym_default] = ACTIONS(890),
    [anon_sym_while] = ACTIONS(890),
    [anon_sym_do] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(890),
    [anon_sym_return] = ACTIONS(890),
    [anon_sym_break] = ACTIONS(890),
    [anon_sym_continue] = ACTIONS(890),
    [anon_sym_goto] = ACTIONS(890),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_sizeof] = ACTIONS(890),
    [sym_number_literal] = ACTIONS(892),
    [anon_sym_L_SQUOTE] = ACTIONS(892),
    [anon_sym_u_SQUOTE] = ACTIONS(892),
    [anon_sym_U_SQUOTE] = ACTIONS(892),
    [anon_sym_u8_SQUOTE] = ACTIONS(892),
    [anon_sym_SQUOTE] = ACTIONS(892),
    [anon_sym_L_DQUOTE] = ACTIONS(892),
    [anon_sym_u_DQUOTE] = ACTIONS(892),
    [anon_sym_U_DQUOTE] = ACTIONS(892),
    [anon_sym_u8_DQUOTE] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_true] = ACTIONS(890),
    [sym_false] = ACTIONS(890),
    [sym_null] = ACTIONS(890),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym_identifier] = ACTIONS(894),
    [aux_sym_preproc_include_token1] = ACTIONS(894),
    [aux_sym_preproc_def_token1] = ACTIONS(894),
    [aux_sym_preproc_if_token1] = ACTIONS(894),
    [aux_sym_preproc_if_token2] = ACTIONS(894),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(894),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(894),
    [aux_sym_preproc_else_token1] = ACTIONS(894),
    [aux_sym_preproc_elif_token1] = ACTIONS(894),
    [sym_preproc_directive] = ACTIONS(894),
    [anon_sym_LPAREN2] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(896),
    [anon_sym_SEMI] = ACTIONS(896),
    [anon_sym_typedef] = ACTIONS(894),
    [anon_sym_extern] = ACTIONS(894),
    [anon_sym___attribute__] = ACTIONS(894),
    [anon_sym___declspec] = ACTIONS(894),
    [anon_sym___cdecl] = ACTIONS(894),
    [anon_sym___clrcall] = ACTIONS(894),
    [anon_sym___stdcall] = ACTIONS(894),
    [anon_sym___fastcall] = ACTIONS(894),
    [anon_sym___thiscall] = ACTIONS(894),
    [anon_sym___vectorcall] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(896),
    [anon_sym_static] = ACTIONS(894),
    [anon_sym_auto] = ACTIONS(894),
    [anon_sym_register] = ACTIONS(894),
    [anon_sym_inline] = ACTIONS(894),
    [anon_sym_const] = ACTIONS(894),
    [anon_sym_volatile] = ACTIONS(894),
    [anon_sym_restrict] = ACTIONS(894),
    [anon_sym__Atomic] = ACTIONS(894),
    [anon_sym_signed] = ACTIONS(894),
    [anon_sym_unsigned] = ACTIONS(894),
    [anon_sym_long] = ACTIONS(894),
    [anon_sym_short] = ACTIONS(894),
    [sym_primitive_type] = ACTIONS(894),
    [anon_sym_enum] = ACTIONS(894),
    [anon_sym_struct] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(894),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_switch] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_default] = ACTIONS(894),
    [anon_sym_while] = ACTIONS(894),
    [anon_sym_do] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(894),
    [anon_sym_break] = ACTIONS(894),
    [anon_sym_continue] = ACTIONS(894),
    [anon_sym_goto] = ACTIONS(894),
    [anon_sym_DASH_DASH] = ACTIONS(896),
    [anon_sym_PLUS_PLUS] = ACTIONS(896),
    [anon_sym_sizeof] = ACTIONS(894),
    [sym_number_literal] = ACTIONS(896),
    [anon_sym_L_SQUOTE] = ACTIONS(896),
    [anon_sym_u_SQUOTE] = ACTIONS(896),
    [anon_sym_U_SQUOTE] = ACTIONS(896),
    [anon_sym_u8_SQUOTE] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(896),
    [anon_sym_L_DQUOTE] = ACTIONS(896),
    [anon_sym_u_DQUOTE] = ACTIONS(896),
    [anon_sym_U_DQUOTE] = ACTIONS(896),
    [anon_sym_u8_DQUOTE] = ACTIONS(896),
    [anon_sym_DQUOTE] = ACTIONS(896),
    [sym_true] = ACTIONS(894),
    [sym_false] = ACTIONS(894),
    [sym_null] = ACTIONS(894),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [sym_identifier] = ACTIONS(898),
    [aux_sym_preproc_include_token1] = ACTIONS(898),
    [aux_sym_preproc_def_token1] = ACTIONS(898),
    [aux_sym_preproc_if_token1] = ACTIONS(898),
    [aux_sym_preproc_if_token2] = ACTIONS(898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(898),
    [aux_sym_preproc_else_token1] = ACTIONS(898),
    [aux_sym_preproc_elif_token1] = ACTIONS(898),
    [sym_preproc_directive] = ACTIONS(898),
    [anon_sym_LPAREN2] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(900),
    [anon_sym_TILDE] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_SEMI] = ACTIONS(900),
    [anon_sym_typedef] = ACTIONS(898),
    [anon_sym_extern] = ACTIONS(898),
    [anon_sym___attribute__] = ACTIONS(898),
    [anon_sym___declspec] = ACTIONS(898),
    [anon_sym___cdecl] = ACTIONS(898),
    [anon_sym___clrcall] = ACTIONS(898),
    [anon_sym___stdcall] = ACTIONS(898),
    [anon_sym___fastcall] = ACTIONS(898),
    [anon_sym___thiscall] = ACTIONS(898),
    [anon_sym___vectorcall] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_static] = ACTIONS(898),
    [anon_sym_auto] = ACTIONS(898),
    [anon_sym_register] = ACTIONS(898),
    [anon_sym_inline] = ACTIONS(898),
    [anon_sym_const] = ACTIONS(898),
    [anon_sym_volatile] = ACTIONS(898),
    [anon_sym_restrict] = ACTIONS(898),
    [anon_sym__Atomic] = ACTIONS(898),
    [anon_sym_signed] = ACTIONS(898),
    [anon_sym_unsigned] = ACTIONS(898),
    [anon_sym_long] = ACTIONS(898),
    [anon_sym_short] = ACTIONS(898),
    [sym_primitive_type] = ACTIONS(898),
    [anon_sym_enum] = ACTIONS(898),
    [anon_sym_struct] = ACTIONS(898),
    [anon_sym_union] = ACTIONS(898),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_else] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(898),
    [anon_sym_case] = ACTIONS(898),
    [anon_sym_default] = ACTIONS(898),
    [anon_sym_while] = ACTIONS(898),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_for] = ACTIONS(898),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_break] = ACTIONS(898),
    [anon_sym_continue] = ACTIONS(898),
    [anon_sym_goto] = ACTIONS(898),
    [anon_sym_DASH_DASH] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(898),
    [sym_number_literal] = ACTIONS(900),
    [anon_sym_L_SQUOTE] = ACTIONS(900),
    [anon_sym_u_SQUOTE] = ACTIONS(900),
    [anon_sym_U_SQUOTE] = ACTIONS(900),
    [anon_sym_u8_SQUOTE] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(900),
    [anon_sym_L_DQUOTE] = ACTIONS(900),
    [anon_sym_u_DQUOTE] = ACTIONS(900),
    [anon_sym_U_DQUOTE] = ACTIONS(900),
    [anon_sym_u8_DQUOTE] = ACTIONS(900),
    [anon_sym_DQUOTE] = ACTIONS(900),
    [sym_true] = ACTIONS(898),
    [sym_false] = ACTIONS(898),
    [sym_null] = ACTIONS(898),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym_identifier] = ACTIONS(902),
    [aux_sym_preproc_include_token1] = ACTIONS(902),
    [aux_sym_preproc_def_token1] = ACTIONS(902),
    [aux_sym_preproc_if_token1] = ACTIONS(902),
    [aux_sym_preproc_if_token2] = ACTIONS(902),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(902),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(902),
    [aux_sym_preproc_else_token1] = ACTIONS(902),
    [aux_sym_preproc_elif_token1] = ACTIONS(902),
    [sym_preproc_directive] = ACTIONS(902),
    [anon_sym_LPAREN2] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(904),
    [anon_sym_TILDE] = ACTIONS(904),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(904),
    [anon_sym_SEMI] = ACTIONS(904),
    [anon_sym_typedef] = ACTIONS(902),
    [anon_sym_extern] = ACTIONS(902),
    [anon_sym___attribute__] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(902),
    [anon_sym___cdecl] = ACTIONS(902),
    [anon_sym___clrcall] = ACTIONS(902),
    [anon_sym___stdcall] = ACTIONS(902),
    [anon_sym___fastcall] = ACTIONS(902),
    [anon_sym___thiscall] = ACTIONS(902),
    [anon_sym___vectorcall] = ACTIONS(902),
    [anon_sym_LBRACE] = ACTIONS(904),
    [anon_sym_static] = ACTIONS(902),
    [anon_sym_auto] = ACTIONS(902),
    [anon_sym_register] = ACTIONS(902),
    [anon_sym_inline] = ACTIONS(902),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_volatile] = ACTIONS(902),
    [anon_sym_restrict] = ACTIONS(902),
    [anon_sym__Atomic] = ACTIONS(902),
    [anon_sym_signed] = ACTIONS(902),
    [anon_sym_unsigned] = ACTIONS(902),
    [anon_sym_long] = ACTIONS(902),
    [anon_sym_short] = ACTIONS(902),
    [sym_primitive_type] = ACTIONS(902),
    [anon_sym_enum] = ACTIONS(902),
    [anon_sym_struct] = ACTIONS(902),
    [anon_sym_union] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(902),
    [anon_sym_else] = ACTIONS(902),
    [anon_sym_switch] = ACTIONS(902),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(902),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_do] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(902),
    [anon_sym_return] = ACTIONS(902),
    [anon_sym_break] = ACTIONS(902),
    [anon_sym_continue] = ACTIONS(902),
    [anon_sym_goto] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(904),
    [anon_sym_PLUS_PLUS] = ACTIONS(904),
    [anon_sym_sizeof] = ACTIONS(902),
    [sym_number_literal] = ACTIONS(904),
    [anon_sym_L_SQUOTE] = ACTIONS(904),
    [anon_sym_u_SQUOTE] = ACTIONS(904),
    [anon_sym_U_SQUOTE] = ACTIONS(904),
    [anon_sym_u8_SQUOTE] = ACTIONS(904),
    [anon_sym_SQUOTE] = ACTIONS(904),
    [anon_sym_L_DQUOTE] = ACTIONS(904),
    [anon_sym_u_DQUOTE] = ACTIONS(904),
    [anon_sym_U_DQUOTE] = ACTIONS(904),
    [anon_sym_u8_DQUOTE] = ACTIONS(904),
    [anon_sym_DQUOTE] = ACTIONS(904),
    [sym_true] = ACTIONS(902),
    [sym_false] = ACTIONS(902),
    [sym_null] = ACTIONS(902),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_identifier] = ACTIONS(906),
    [aux_sym_preproc_include_token1] = ACTIONS(906),
    [aux_sym_preproc_def_token1] = ACTIONS(906),
    [aux_sym_preproc_if_token1] = ACTIONS(906),
    [aux_sym_preproc_if_token2] = ACTIONS(906),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(906),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(906),
    [aux_sym_preproc_else_token1] = ACTIONS(906),
    [aux_sym_preproc_elif_token1] = ACTIONS(906),
    [sym_preproc_directive] = ACTIONS(906),
    [anon_sym_LPAREN2] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(908),
    [anon_sym_TILDE] = ACTIONS(908),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_STAR] = ACTIONS(908),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_SEMI] = ACTIONS(908),
    [anon_sym_typedef] = ACTIONS(906),
    [anon_sym_extern] = ACTIONS(906),
    [anon_sym___attribute__] = ACTIONS(906),
    [anon_sym___declspec] = ACTIONS(906),
    [anon_sym___cdecl] = ACTIONS(906),
    [anon_sym___clrcall] = ACTIONS(906),
    [anon_sym___stdcall] = ACTIONS(906),
    [anon_sym___fastcall] = ACTIONS(906),
    [anon_sym___thiscall] = ACTIONS(906),
    [anon_sym___vectorcall] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_static] = ACTIONS(906),
    [anon_sym_auto] = ACTIONS(906),
    [anon_sym_register] = ACTIONS(906),
    [anon_sym_inline] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(906),
    [anon_sym_volatile] = ACTIONS(906),
    [anon_sym_restrict] = ACTIONS(906),
    [anon_sym__Atomic] = ACTIONS(906),
    [anon_sym_signed] = ACTIONS(906),
    [anon_sym_unsigned] = ACTIONS(906),
    [anon_sym_long] = ACTIONS(906),
    [anon_sym_short] = ACTIONS(906),
    [sym_primitive_type] = ACTIONS(906),
    [anon_sym_enum] = ACTIONS(906),
    [anon_sym_struct] = ACTIONS(906),
    [anon_sym_union] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_else] = ACTIONS(906),
    [anon_sym_switch] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_default] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(906),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_return] = ACTIONS(906),
    [anon_sym_break] = ACTIONS(906),
    [anon_sym_continue] = ACTIONS(906),
    [anon_sym_goto] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_sizeof] = ACTIONS(906),
    [sym_number_literal] = ACTIONS(908),
    [anon_sym_L_SQUOTE] = ACTIONS(908),
    [anon_sym_u_SQUOTE] = ACTIONS(908),
    [anon_sym_U_SQUOTE] = ACTIONS(908),
    [anon_sym_u8_SQUOTE] = ACTIONS(908),
    [anon_sym_SQUOTE] = ACTIONS(908),
    [anon_sym_L_DQUOTE] = ACTIONS(908),
    [anon_sym_u_DQUOTE] = ACTIONS(908),
    [anon_sym_U_DQUOTE] = ACTIONS(908),
    [anon_sym_u8_DQUOTE] = ACTIONS(908),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [sym_true] = ACTIONS(906),
    [sym_false] = ACTIONS(906),
    [sym_null] = ACTIONS(906),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_identifier] = ACTIONS(910),
    [aux_sym_preproc_include_token1] = ACTIONS(910),
    [aux_sym_preproc_def_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token2] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(910),
    [aux_sym_preproc_else_token1] = ACTIONS(910),
    [aux_sym_preproc_elif_token1] = ACTIONS(910),
    [sym_preproc_directive] = ACTIONS(910),
    [anon_sym_LPAREN2] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_typedef] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym___attribute__] = ACTIONS(910),
    [anon_sym___declspec] = ACTIONS(910),
    [anon_sym___cdecl] = ACTIONS(910),
    [anon_sym___clrcall] = ACTIONS(910),
    [anon_sym___stdcall] = ACTIONS(910),
    [anon_sym___fastcall] = ACTIONS(910),
    [anon_sym___thiscall] = ACTIONS(910),
    [anon_sym___vectorcall] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_auto] = ACTIONS(910),
    [anon_sym_register] = ACTIONS(910),
    [anon_sym_inline] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_restrict] = ACTIONS(910),
    [anon_sym__Atomic] = ACTIONS(910),
    [anon_sym_signed] = ACTIONS(910),
    [anon_sym_unsigned] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [sym_primitive_type] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_goto] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_sizeof] = ACTIONS(910),
    [sym_number_literal] = ACTIONS(912),
    [anon_sym_L_SQUOTE] = ACTIONS(912),
    [anon_sym_u_SQUOTE] = ACTIONS(912),
    [anon_sym_U_SQUOTE] = ACTIONS(912),
    [anon_sym_u8_SQUOTE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(912),
    [anon_sym_L_DQUOTE] = ACTIONS(912),
    [anon_sym_u_DQUOTE] = ACTIONS(912),
    [anon_sym_U_DQUOTE] = ACTIONS(912),
    [anon_sym_u8_DQUOTE] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(912),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_identifier] = ACTIONS(914),
    [aux_sym_preproc_include_token1] = ACTIONS(914),
    [aux_sym_preproc_def_token1] = ACTIONS(914),
    [aux_sym_preproc_if_token1] = ACTIONS(914),
    [aux_sym_preproc_if_token2] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(914),
    [aux_sym_preproc_else_token1] = ACTIONS(914),
    [aux_sym_preproc_elif_token1] = ACTIONS(914),
    [sym_preproc_directive] = ACTIONS(914),
    [anon_sym_LPAREN2] = ACTIONS(916),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(914),
    [anon_sym_STAR] = ACTIONS(916),
    [anon_sym_AMP] = ACTIONS(916),
    [anon_sym_SEMI] = ACTIONS(916),
    [anon_sym_typedef] = ACTIONS(914),
    [anon_sym_extern] = ACTIONS(914),
    [anon_sym___attribute__] = ACTIONS(914),
    [anon_sym___declspec] = ACTIONS(914),
    [anon_sym___cdecl] = ACTIONS(914),
    [anon_sym___clrcall] = ACTIONS(914),
    [anon_sym___stdcall] = ACTIONS(914),
    [anon_sym___fastcall] = ACTIONS(914),
    [anon_sym___thiscall] = ACTIONS(914),
    [anon_sym___vectorcall] = ACTIONS(914),
    [anon_sym_LBRACE] = ACTIONS(916),
    [anon_sym_static] = ACTIONS(914),
    [anon_sym_auto] = ACTIONS(914),
    [anon_sym_register] = ACTIONS(914),
    [anon_sym_inline] = ACTIONS(914),
    [anon_sym_const] = ACTIONS(914),
    [anon_sym_volatile] = ACTIONS(914),
    [anon_sym_restrict] = ACTIONS(914),
    [anon_sym__Atomic] = ACTIONS(914),
    [anon_sym_signed] = ACTIONS(914),
    [anon_sym_unsigned] = ACTIONS(914),
    [anon_sym_long] = ACTIONS(914),
    [anon_sym_short] = ACTIONS(914),
    [sym_primitive_type] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(914),
    [anon_sym_struct] = ACTIONS(914),
    [anon_sym_union] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_else] = ACTIONS(914),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_case] = ACTIONS(914),
    [anon_sym_default] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [anon_sym_do] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_goto] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_sizeof] = ACTIONS(914),
    [sym_number_literal] = ACTIONS(916),
    [anon_sym_L_SQUOTE] = ACTIONS(916),
    [anon_sym_u_SQUOTE] = ACTIONS(916),
    [anon_sym_U_SQUOTE] = ACTIONS(916),
    [anon_sym_u8_SQUOTE] = ACTIONS(916),
    [anon_sym_SQUOTE] = ACTIONS(916),
    [anon_sym_L_DQUOTE] = ACTIONS(916),
    [anon_sym_u_DQUOTE] = ACTIONS(916),
    [anon_sym_U_DQUOTE] = ACTIONS(916),
    [anon_sym_u8_DQUOTE] = ACTIONS(916),
    [anon_sym_DQUOTE] = ACTIONS(916),
    [sym_true] = ACTIONS(914),
    [sym_false] = ACTIONS(914),
    [sym_null] = ACTIONS(914),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_identifier] = ACTIONS(918),
    [aux_sym_preproc_include_token1] = ACTIONS(918),
    [aux_sym_preproc_def_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token2] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(918),
    [aux_sym_preproc_else_token1] = ACTIONS(918),
    [aux_sym_preproc_elif_token1] = ACTIONS(918),
    [sym_preproc_directive] = ACTIONS(918),
    [anon_sym_LPAREN2] = ACTIONS(920),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_STAR] = ACTIONS(920),
    [anon_sym_AMP] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(920),
    [anon_sym_typedef] = ACTIONS(918),
    [anon_sym_extern] = ACTIONS(918),
    [anon_sym___attribute__] = ACTIONS(918),
    [anon_sym___declspec] = ACTIONS(918),
    [anon_sym___cdecl] = ACTIONS(918),
    [anon_sym___clrcall] = ACTIONS(918),
    [anon_sym___stdcall] = ACTIONS(918),
    [anon_sym___fastcall] = ACTIONS(918),
    [anon_sym___thiscall] = ACTIONS(918),
    [anon_sym___vectorcall] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_static] = ACTIONS(918),
    [anon_sym_auto] = ACTIONS(918),
    [anon_sym_register] = ACTIONS(918),
    [anon_sym_inline] = ACTIONS(918),
    [anon_sym_const] = ACTIONS(918),
    [anon_sym_volatile] = ACTIONS(918),
    [anon_sym_restrict] = ACTIONS(918),
    [anon_sym__Atomic] = ACTIONS(918),
    [anon_sym_signed] = ACTIONS(918),
    [anon_sym_unsigned] = ACTIONS(918),
    [anon_sym_long] = ACTIONS(918),
    [anon_sym_short] = ACTIONS(918),
    [sym_primitive_type] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(918),
    [anon_sym_struct] = ACTIONS(918),
    [anon_sym_union] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(918),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_for] = ACTIONS(918),
    [anon_sym_return] = ACTIONS(918),
    [anon_sym_break] = ACTIONS(918),
    [anon_sym_continue] = ACTIONS(918),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(920),
    [anon_sym_sizeof] = ACTIONS(918),
    [sym_number_literal] = ACTIONS(920),
    [anon_sym_L_SQUOTE] = ACTIONS(920),
    [anon_sym_u_SQUOTE] = ACTIONS(920),
    [anon_sym_U_SQUOTE] = ACTIONS(920),
    [anon_sym_u8_SQUOTE] = ACTIONS(920),
    [anon_sym_SQUOTE] = ACTIONS(920),
    [anon_sym_L_DQUOTE] = ACTIONS(920),
    [anon_sym_u_DQUOTE] = ACTIONS(920),
    [anon_sym_U_DQUOTE] = ACTIONS(920),
    [anon_sym_u8_DQUOTE] = ACTIONS(920),
    [anon_sym_DQUOTE] = ACTIONS(920),
    [sym_true] = ACTIONS(918),
    [sym_false] = ACTIONS(918),
    [sym_null] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_identifier] = ACTIONS(922),
    [aux_sym_preproc_include_token1] = ACTIONS(922),
    [aux_sym_preproc_def_token1] = ACTIONS(922),
    [aux_sym_preproc_if_token1] = ACTIONS(922),
    [aux_sym_preproc_if_token2] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(922),
    [aux_sym_preproc_else_token1] = ACTIONS(922),
    [aux_sym_preproc_elif_token1] = ACTIONS(922),
    [sym_preproc_directive] = ACTIONS(922),
    [anon_sym_LPAREN2] = ACTIONS(924),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(924),
    [anon_sym_typedef] = ACTIONS(922),
    [anon_sym_extern] = ACTIONS(922),
    [anon_sym___attribute__] = ACTIONS(922),
    [anon_sym___declspec] = ACTIONS(922),
    [anon_sym___cdecl] = ACTIONS(922),
    [anon_sym___clrcall] = ACTIONS(922),
    [anon_sym___stdcall] = ACTIONS(922),
    [anon_sym___fastcall] = ACTIONS(922),
    [anon_sym___thiscall] = ACTIONS(922),
    [anon_sym___vectorcall] = ACTIONS(922),
    [anon_sym_LBRACE] = ACTIONS(924),
    [anon_sym_static] = ACTIONS(922),
    [anon_sym_auto] = ACTIONS(922),
    [anon_sym_register] = ACTIONS(922),
    [anon_sym_inline] = ACTIONS(922),
    [anon_sym_const] = ACTIONS(922),
    [anon_sym_volatile] = ACTIONS(922),
    [anon_sym_restrict] = ACTIONS(922),
    [anon_sym__Atomic] = ACTIONS(922),
    [anon_sym_signed] = ACTIONS(922),
    [anon_sym_unsigned] = ACTIONS(922),
    [anon_sym_long] = ACTIONS(922),
    [anon_sym_short] = ACTIONS(922),
    [sym_primitive_type] = ACTIONS(922),
    [anon_sym_enum] = ACTIONS(922),
    [anon_sym_struct] = ACTIONS(922),
    [anon_sym_union] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(922),
    [anon_sym_else] = ACTIONS(922),
    [anon_sym_switch] = ACTIONS(922),
    [anon_sym_case] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(922),
    [anon_sym_while] = ACTIONS(922),
    [anon_sym_do] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(922),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(922),
    [anon_sym_goto] = ACTIONS(922),
    [anon_sym_DASH_DASH] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(924),
    [anon_sym_sizeof] = ACTIONS(922),
    [sym_number_literal] = ACTIONS(924),
    [anon_sym_L_SQUOTE] = ACTIONS(924),
    [anon_sym_u_SQUOTE] = ACTIONS(924),
    [anon_sym_U_SQUOTE] = ACTIONS(924),
    [anon_sym_u8_SQUOTE] = ACTIONS(924),
    [anon_sym_SQUOTE] = ACTIONS(924),
    [anon_sym_L_DQUOTE] = ACTIONS(924),
    [anon_sym_u_DQUOTE] = ACTIONS(924),
    [anon_sym_U_DQUOTE] = ACTIONS(924),
    [anon_sym_u8_DQUOTE] = ACTIONS(924),
    [anon_sym_DQUOTE] = ACTIONS(924),
    [sym_true] = ACTIONS(922),
    [sym_false] = ACTIONS(922),
    [sym_null] = ACTIONS(922),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_identifier] = ACTIONS(926),
    [aux_sym_preproc_include_token1] = ACTIONS(926),
    [aux_sym_preproc_def_token1] = ACTIONS(926),
    [aux_sym_preproc_if_token1] = ACTIONS(926),
    [aux_sym_preproc_if_token2] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(926),
    [aux_sym_preproc_else_token1] = ACTIONS(926),
    [aux_sym_preproc_elif_token1] = ACTIONS(926),
    [sym_preproc_directive] = ACTIONS(926),
    [anon_sym_LPAREN2] = ACTIONS(928),
    [anon_sym_BANG] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(928),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_STAR] = ACTIONS(928),
    [anon_sym_AMP] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(928),
    [anon_sym_typedef] = ACTIONS(926),
    [anon_sym_extern] = ACTIONS(926),
    [anon_sym___attribute__] = ACTIONS(926),
    [anon_sym___declspec] = ACTIONS(926),
    [anon_sym___cdecl] = ACTIONS(926),
    [anon_sym___clrcall] = ACTIONS(926),
    [anon_sym___stdcall] = ACTIONS(926),
    [anon_sym___fastcall] = ACTIONS(926),
    [anon_sym___thiscall] = ACTIONS(926),
    [anon_sym___vectorcall] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(926),
    [anon_sym_auto] = ACTIONS(926),
    [anon_sym_register] = ACTIONS(926),
    [anon_sym_inline] = ACTIONS(926),
    [anon_sym_const] = ACTIONS(926),
    [anon_sym_volatile] = ACTIONS(926),
    [anon_sym_restrict] = ACTIONS(926),
    [anon_sym__Atomic] = ACTIONS(926),
    [anon_sym_signed] = ACTIONS(926),
    [anon_sym_unsigned] = ACTIONS(926),
    [anon_sym_long] = ACTIONS(926),
    [anon_sym_short] = ACTIONS(926),
    [sym_primitive_type] = ACTIONS(926),
    [anon_sym_enum] = ACTIONS(926),
    [anon_sym_struct] = ACTIONS(926),
    [anon_sym_union] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(926),
    [anon_sym_else] = ACTIONS(930),
    [anon_sym_switch] = ACTIONS(926),
    [anon_sym_case] = ACTIONS(926),
    [anon_sym_default] = ACTIONS(926),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_do] = ACTIONS(926),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(926),
    [anon_sym_break] = ACTIONS(926),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_goto] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(928),
    [anon_sym_PLUS_PLUS] = ACTIONS(928),
    [anon_sym_sizeof] = ACTIONS(926),
    [sym_number_literal] = ACTIONS(928),
    [anon_sym_L_SQUOTE] = ACTIONS(928),
    [anon_sym_u_SQUOTE] = ACTIONS(928),
    [anon_sym_U_SQUOTE] = ACTIONS(928),
    [anon_sym_u8_SQUOTE] = ACTIONS(928),
    [anon_sym_SQUOTE] = ACTIONS(928),
    [anon_sym_L_DQUOTE] = ACTIONS(928),
    [anon_sym_u_DQUOTE] = ACTIONS(928),
    [anon_sym_U_DQUOTE] = ACTIONS(928),
    [anon_sym_u8_DQUOTE] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(928),
    [sym_true] = ACTIONS(926),
    [sym_false] = ACTIONS(926),
    [sym_null] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [sym_identifier] = ACTIONS(932),
    [aux_sym_preproc_include_token1] = ACTIONS(932),
    [aux_sym_preproc_def_token1] = ACTIONS(932),
    [aux_sym_preproc_if_token1] = ACTIONS(932),
    [aux_sym_preproc_if_token2] = ACTIONS(932),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(932),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(932),
    [aux_sym_preproc_else_token1] = ACTIONS(932),
    [aux_sym_preproc_elif_token1] = ACTIONS(932),
    [sym_preproc_directive] = ACTIONS(932),
    [anon_sym_LPAREN2] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(934),
    [anon_sym_TILDE] = ACTIONS(934),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_STAR] = ACTIONS(934),
    [anon_sym_AMP] = ACTIONS(934),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_typedef] = ACTIONS(932),
    [anon_sym_extern] = ACTIONS(932),
    [anon_sym___attribute__] = ACTIONS(932),
    [anon_sym___declspec] = ACTIONS(932),
    [anon_sym___cdecl] = ACTIONS(932),
    [anon_sym___clrcall] = ACTIONS(932),
    [anon_sym___stdcall] = ACTIONS(932),
    [anon_sym___fastcall] = ACTIONS(932),
    [anon_sym___thiscall] = ACTIONS(932),
    [anon_sym___vectorcall] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(934),
    [anon_sym_static] = ACTIONS(932),
    [anon_sym_auto] = ACTIONS(932),
    [anon_sym_register] = ACTIONS(932),
    [anon_sym_inline] = ACTIONS(932),
    [anon_sym_const] = ACTIONS(932),
    [anon_sym_volatile] = ACTIONS(932),
    [anon_sym_restrict] = ACTIONS(932),
    [anon_sym__Atomic] = ACTIONS(932),
    [anon_sym_signed] = ACTIONS(932),
    [anon_sym_unsigned] = ACTIONS(932),
    [anon_sym_long] = ACTIONS(932),
    [anon_sym_short] = ACTIONS(932),
    [sym_primitive_type] = ACTIONS(932),
    [anon_sym_enum] = ACTIONS(932),
    [anon_sym_struct] = ACTIONS(932),
    [anon_sym_union] = ACTIONS(932),
    [anon_sym_if] = ACTIONS(932),
    [anon_sym_else] = ACTIONS(932),
    [anon_sym_switch] = ACTIONS(932),
    [anon_sym_case] = ACTIONS(932),
    [anon_sym_default] = ACTIONS(932),
    [anon_sym_while] = ACTIONS(932),
    [anon_sym_do] = ACTIONS(932),
    [anon_sym_for] = ACTIONS(932),
    [anon_sym_return] = ACTIONS(932),
    [anon_sym_break] = ACTIONS(932),
    [anon_sym_continue] = ACTIONS(932),
    [anon_sym_goto] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_sizeof] = ACTIONS(932),
    [sym_number_literal] = ACTIONS(934),
    [anon_sym_L_SQUOTE] = ACTIONS(934),
    [anon_sym_u_SQUOTE] = ACTIONS(934),
    [anon_sym_U_SQUOTE] = ACTIONS(934),
    [anon_sym_u8_SQUOTE] = ACTIONS(934),
    [anon_sym_SQUOTE] = ACTIONS(934),
    [anon_sym_L_DQUOTE] = ACTIONS(934),
    [anon_sym_u_DQUOTE] = ACTIONS(934),
    [anon_sym_U_DQUOTE] = ACTIONS(934),
    [anon_sym_u8_DQUOTE] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(934),
    [sym_true] = ACTIONS(932),
    [sym_false] = ACTIONS(932),
    [sym_null] = ACTIONS(932),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [sym_identifier] = ACTIONS(936),
    [aux_sym_preproc_include_token1] = ACTIONS(936),
    [aux_sym_preproc_def_token1] = ACTIONS(936),
    [aux_sym_preproc_if_token1] = ACTIONS(936),
    [aux_sym_preproc_if_token2] = ACTIONS(936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(936),
    [aux_sym_preproc_else_token1] = ACTIONS(936),
    [aux_sym_preproc_elif_token1] = ACTIONS(936),
    [sym_preproc_directive] = ACTIONS(936),
    [anon_sym_LPAREN2] = ACTIONS(938),
    [anon_sym_BANG] = ACTIONS(938),
    [anon_sym_TILDE] = ACTIONS(938),
    [anon_sym_DASH] = ACTIONS(936),
    [anon_sym_PLUS] = ACTIONS(936),
    [anon_sym_STAR] = ACTIONS(938),
    [anon_sym_AMP] = ACTIONS(938),
    [anon_sym_SEMI] = ACTIONS(938),
    [anon_sym_typedef] = ACTIONS(936),
    [anon_sym_extern] = ACTIONS(936),
    [anon_sym___attribute__] = ACTIONS(936),
    [anon_sym___declspec] = ACTIONS(936),
    [anon_sym___cdecl] = ACTIONS(936),
    [anon_sym___clrcall] = ACTIONS(936),
    [anon_sym___stdcall] = ACTIONS(936),
    [anon_sym___fastcall] = ACTIONS(936),
    [anon_sym___thiscall] = ACTIONS(936),
    [anon_sym___vectorcall] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(938),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_auto] = ACTIONS(936),
    [anon_sym_register] = ACTIONS(936),
    [anon_sym_inline] = ACTIONS(936),
    [anon_sym_const] = ACTIONS(936),
    [anon_sym_volatile] = ACTIONS(936),
    [anon_sym_restrict] = ACTIONS(936),
    [anon_sym__Atomic] = ACTIONS(936),
    [anon_sym_signed] = ACTIONS(936),
    [anon_sym_unsigned] = ACTIONS(936),
    [anon_sym_long] = ACTIONS(936),
    [anon_sym_short] = ACTIONS(936),
    [sym_primitive_type] = ACTIONS(936),
    [anon_sym_enum] = ACTIONS(936),
    [anon_sym_struct] = ACTIONS(936),
    [anon_sym_union] = ACTIONS(936),
    [anon_sym_if] = ACTIONS(936),
    [anon_sym_else] = ACTIONS(936),
    [anon_sym_switch] = ACTIONS(936),
    [anon_sym_case] = ACTIONS(936),
    [anon_sym_default] = ACTIONS(936),
    [anon_sym_while] = ACTIONS(936),
    [anon_sym_do] = ACTIONS(936),
    [anon_sym_for] = ACTIONS(936),
    [anon_sym_return] = ACTIONS(936),
    [anon_sym_break] = ACTIONS(936),
    [anon_sym_continue] = ACTIONS(936),
    [anon_sym_goto] = ACTIONS(936),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_sizeof] = ACTIONS(936),
    [sym_number_literal] = ACTIONS(938),
    [anon_sym_L_SQUOTE] = ACTIONS(938),
    [anon_sym_u_SQUOTE] = ACTIONS(938),
    [anon_sym_U_SQUOTE] = ACTIONS(938),
    [anon_sym_u8_SQUOTE] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(938),
    [anon_sym_L_DQUOTE] = ACTIONS(938),
    [anon_sym_u_DQUOTE] = ACTIONS(938),
    [anon_sym_U_DQUOTE] = ACTIONS(938),
    [anon_sym_u8_DQUOTE] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [sym_true] = ACTIONS(936),
    [sym_false] = ACTIONS(936),
    [sym_null] = ACTIONS(936),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym_identifier] = ACTIONS(940),
    [aux_sym_preproc_include_token1] = ACTIONS(940),
    [aux_sym_preproc_def_token1] = ACTIONS(940),
    [aux_sym_preproc_if_token1] = ACTIONS(940),
    [aux_sym_preproc_if_token2] = ACTIONS(940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(940),
    [aux_sym_preproc_else_token1] = ACTIONS(940),
    [aux_sym_preproc_elif_token1] = ACTIONS(940),
    [sym_preproc_directive] = ACTIONS(940),
    [anon_sym_LPAREN2] = ACTIONS(942),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_STAR] = ACTIONS(942),
    [anon_sym_AMP] = ACTIONS(942),
    [anon_sym_SEMI] = ACTIONS(942),
    [anon_sym_typedef] = ACTIONS(940),
    [anon_sym_extern] = ACTIONS(940),
    [anon_sym___attribute__] = ACTIONS(940),
    [anon_sym___declspec] = ACTIONS(940),
    [anon_sym___cdecl] = ACTIONS(940),
    [anon_sym___clrcall] = ACTIONS(940),
    [anon_sym___stdcall] = ACTIONS(940),
    [anon_sym___fastcall] = ACTIONS(940),
    [anon_sym___thiscall] = ACTIONS(940),
    [anon_sym___vectorcall] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(942),
    [anon_sym_static] = ACTIONS(940),
    [anon_sym_auto] = ACTIONS(940),
    [anon_sym_register] = ACTIONS(940),
    [anon_sym_inline] = ACTIONS(940),
    [anon_sym_const] = ACTIONS(940),
    [anon_sym_volatile] = ACTIONS(940),
    [anon_sym_restrict] = ACTIONS(940),
    [anon_sym__Atomic] = ACTIONS(940),
    [anon_sym_signed] = ACTIONS(940),
    [anon_sym_unsigned] = ACTIONS(940),
    [anon_sym_long] = ACTIONS(940),
    [anon_sym_short] = ACTIONS(940),
    [sym_primitive_type] = ACTIONS(940),
    [anon_sym_enum] = ACTIONS(940),
    [anon_sym_struct] = ACTIONS(940),
    [anon_sym_union] = ACTIONS(940),
    [anon_sym_if] = ACTIONS(940),
    [anon_sym_else] = ACTIONS(940),
    [anon_sym_switch] = ACTIONS(940),
    [anon_sym_case] = ACTIONS(940),
    [anon_sym_default] = ACTIONS(940),
    [anon_sym_while] = ACTIONS(940),
    [anon_sym_do] = ACTIONS(940),
    [anon_sym_for] = ACTIONS(940),
    [anon_sym_return] = ACTIONS(940),
    [anon_sym_break] = ACTIONS(940),
    [anon_sym_continue] = ACTIONS(940),
    [anon_sym_goto] = ACTIONS(940),
    [anon_sym_DASH_DASH] = ACTIONS(942),
    [anon_sym_PLUS_PLUS] = ACTIONS(942),
    [anon_sym_sizeof] = ACTIONS(940),
    [sym_number_literal] = ACTIONS(942),
    [anon_sym_L_SQUOTE] = ACTIONS(942),
    [anon_sym_u_SQUOTE] = ACTIONS(942),
    [anon_sym_U_SQUOTE] = ACTIONS(942),
    [anon_sym_u8_SQUOTE] = ACTIONS(942),
    [anon_sym_SQUOTE] = ACTIONS(942),
    [anon_sym_L_DQUOTE] = ACTIONS(942),
    [anon_sym_u_DQUOTE] = ACTIONS(942),
    [anon_sym_U_DQUOTE] = ACTIONS(942),
    [anon_sym_u8_DQUOTE] = ACTIONS(942),
    [anon_sym_DQUOTE] = ACTIONS(942),
    [sym_true] = ACTIONS(940),
    [sym_false] = ACTIONS(940),
    [sym_null] = ACTIONS(940),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym_identifier] = ACTIONS(944),
    [aux_sym_preproc_include_token1] = ACTIONS(944),
    [aux_sym_preproc_def_token1] = ACTIONS(944),
    [aux_sym_preproc_if_token1] = ACTIONS(944),
    [aux_sym_preproc_if_token2] = ACTIONS(944),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(944),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(944),
    [aux_sym_preproc_else_token1] = ACTIONS(944),
    [aux_sym_preproc_elif_token1] = ACTIONS(944),
    [sym_preproc_directive] = ACTIONS(944),
    [anon_sym_LPAREN2] = ACTIONS(946),
    [anon_sym_BANG] = ACTIONS(946),
    [anon_sym_TILDE] = ACTIONS(946),
    [anon_sym_DASH] = ACTIONS(944),
    [anon_sym_PLUS] = ACTIONS(944),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_AMP] = ACTIONS(946),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_typedef] = ACTIONS(944),
    [anon_sym_extern] = ACTIONS(944),
    [anon_sym___attribute__] = ACTIONS(944),
    [anon_sym___declspec] = ACTIONS(944),
    [anon_sym___cdecl] = ACTIONS(944),
    [anon_sym___clrcall] = ACTIONS(944),
    [anon_sym___stdcall] = ACTIONS(944),
    [anon_sym___fastcall] = ACTIONS(944),
    [anon_sym___thiscall] = ACTIONS(944),
    [anon_sym___vectorcall] = ACTIONS(944),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_auto] = ACTIONS(944),
    [anon_sym_register] = ACTIONS(944),
    [anon_sym_inline] = ACTIONS(944),
    [anon_sym_const] = ACTIONS(944),
    [anon_sym_volatile] = ACTIONS(944),
    [anon_sym_restrict] = ACTIONS(944),
    [anon_sym__Atomic] = ACTIONS(944),
    [anon_sym_signed] = ACTIONS(944),
    [anon_sym_unsigned] = ACTIONS(944),
    [anon_sym_long] = ACTIONS(944),
    [anon_sym_short] = ACTIONS(944),
    [sym_primitive_type] = ACTIONS(944),
    [anon_sym_enum] = ACTIONS(944),
    [anon_sym_struct] = ACTIONS(944),
    [anon_sym_union] = ACTIONS(944),
    [anon_sym_if] = ACTIONS(944),
    [anon_sym_else] = ACTIONS(944),
    [anon_sym_switch] = ACTIONS(944),
    [anon_sym_case] = ACTIONS(944),
    [anon_sym_default] = ACTIONS(944),
    [anon_sym_while] = ACTIONS(944),
    [anon_sym_do] = ACTIONS(944),
    [anon_sym_for] = ACTIONS(944),
    [anon_sym_return] = ACTIONS(944),
    [anon_sym_break] = ACTIONS(944),
    [anon_sym_continue] = ACTIONS(944),
    [anon_sym_goto] = ACTIONS(944),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_sizeof] = ACTIONS(944),
    [sym_number_literal] = ACTIONS(946),
    [anon_sym_L_SQUOTE] = ACTIONS(946),
    [anon_sym_u_SQUOTE] = ACTIONS(946),
    [anon_sym_U_SQUOTE] = ACTIONS(946),
    [anon_sym_u8_SQUOTE] = ACTIONS(946),
    [anon_sym_SQUOTE] = ACTIONS(946),
    [anon_sym_L_DQUOTE] = ACTIONS(946),
    [anon_sym_u_DQUOTE] = ACTIONS(946),
    [anon_sym_U_DQUOTE] = ACTIONS(946),
    [anon_sym_u8_DQUOTE] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(946),
    [sym_true] = ACTIONS(944),
    [sym_false] = ACTIONS(944),
    [sym_null] = ACTIONS(944),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_identifier] = ACTIONS(948),
    [aux_sym_preproc_include_token1] = ACTIONS(948),
    [aux_sym_preproc_def_token1] = ACTIONS(948),
    [aux_sym_preproc_if_token1] = ACTIONS(948),
    [aux_sym_preproc_if_token2] = ACTIONS(948),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(948),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(948),
    [aux_sym_preproc_else_token1] = ACTIONS(948),
    [aux_sym_preproc_elif_token1] = ACTIONS(948),
    [sym_preproc_directive] = ACTIONS(948),
    [anon_sym_LPAREN2] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(950),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_DASH] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_SEMI] = ACTIONS(950),
    [anon_sym_typedef] = ACTIONS(948),
    [anon_sym_extern] = ACTIONS(948),
    [anon_sym___attribute__] = ACTIONS(948),
    [anon_sym___declspec] = ACTIONS(948),
    [anon_sym___cdecl] = ACTIONS(948),
    [anon_sym___clrcall] = ACTIONS(948),
    [anon_sym___stdcall] = ACTIONS(948),
    [anon_sym___fastcall] = ACTIONS(948),
    [anon_sym___thiscall] = ACTIONS(948),
    [anon_sym___vectorcall] = ACTIONS(948),
    [anon_sym_LBRACE] = ACTIONS(950),
    [anon_sym_static] = ACTIONS(948),
    [anon_sym_auto] = ACTIONS(948),
    [anon_sym_register] = ACTIONS(948),
    [anon_sym_inline] = ACTIONS(948),
    [anon_sym_const] = ACTIONS(948),
    [anon_sym_volatile] = ACTIONS(948),
    [anon_sym_restrict] = ACTIONS(948),
    [anon_sym__Atomic] = ACTIONS(948),
    [anon_sym_signed] = ACTIONS(948),
    [anon_sym_unsigned] = ACTIONS(948),
    [anon_sym_long] = ACTIONS(948),
    [anon_sym_short] = ACTIONS(948),
    [sym_primitive_type] = ACTIONS(948),
    [anon_sym_enum] = ACTIONS(948),
    [anon_sym_struct] = ACTIONS(948),
    [anon_sym_union] = ACTIONS(948),
    [anon_sym_if] = ACTIONS(948),
    [anon_sym_else] = ACTIONS(948),
    [anon_sym_switch] = ACTIONS(948),
    [anon_sym_case] = ACTIONS(948),
    [anon_sym_default] = ACTIONS(948),
    [anon_sym_while] = ACTIONS(948),
    [anon_sym_do] = ACTIONS(948),
    [anon_sym_for] = ACTIONS(948),
    [anon_sym_return] = ACTIONS(948),
    [anon_sym_break] = ACTIONS(948),
    [anon_sym_continue] = ACTIONS(948),
    [anon_sym_goto] = ACTIONS(948),
    [anon_sym_DASH_DASH] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(950),
    [anon_sym_sizeof] = ACTIONS(948),
    [sym_number_literal] = ACTIONS(950),
    [anon_sym_L_SQUOTE] = ACTIONS(950),
    [anon_sym_u_SQUOTE] = ACTIONS(950),
    [anon_sym_U_SQUOTE] = ACTIONS(950),
    [anon_sym_u8_SQUOTE] = ACTIONS(950),
    [anon_sym_SQUOTE] = ACTIONS(950),
    [anon_sym_L_DQUOTE] = ACTIONS(950),
    [anon_sym_u_DQUOTE] = ACTIONS(950),
    [anon_sym_U_DQUOTE] = ACTIONS(950),
    [anon_sym_u8_DQUOTE] = ACTIONS(950),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [sym_true] = ACTIONS(948),
    [sym_false] = ACTIONS(948),
    [sym_null] = ACTIONS(948),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_identifier] = ACTIONS(910),
    [aux_sym_preproc_include_token1] = ACTIONS(910),
    [aux_sym_preproc_def_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token2] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(910),
    [aux_sym_preproc_else_token1] = ACTIONS(910),
    [aux_sym_preproc_elif_token1] = ACTIONS(910),
    [sym_preproc_directive] = ACTIONS(910),
    [anon_sym_LPAREN2] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_typedef] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym___attribute__] = ACTIONS(910),
    [anon_sym___declspec] = ACTIONS(910),
    [anon_sym___cdecl] = ACTIONS(910),
    [anon_sym___clrcall] = ACTIONS(910),
    [anon_sym___stdcall] = ACTIONS(910),
    [anon_sym___fastcall] = ACTIONS(910),
    [anon_sym___thiscall] = ACTIONS(910),
    [anon_sym___vectorcall] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_auto] = ACTIONS(910),
    [anon_sym_register] = ACTIONS(910),
    [anon_sym_inline] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_restrict] = ACTIONS(910),
    [anon_sym__Atomic] = ACTIONS(910),
    [anon_sym_signed] = ACTIONS(910),
    [anon_sym_unsigned] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [sym_primitive_type] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_goto] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_sizeof] = ACTIONS(910),
    [sym_number_literal] = ACTIONS(912),
    [anon_sym_L_SQUOTE] = ACTIONS(912),
    [anon_sym_u_SQUOTE] = ACTIONS(912),
    [anon_sym_U_SQUOTE] = ACTIONS(912),
    [anon_sym_u8_SQUOTE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(912),
    [anon_sym_L_DQUOTE] = ACTIONS(912),
    [anon_sym_u_DQUOTE] = ACTIONS(912),
    [anon_sym_U_DQUOTE] = ACTIONS(912),
    [anon_sym_u8_DQUOTE] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(912),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_identifier] = ACTIONS(952),
    [aux_sym_preproc_include_token1] = ACTIONS(952),
    [aux_sym_preproc_def_token1] = ACTIONS(952),
    [aux_sym_preproc_if_token1] = ACTIONS(952),
    [aux_sym_preproc_if_token2] = ACTIONS(952),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(952),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(952),
    [aux_sym_preproc_else_token1] = ACTIONS(952),
    [aux_sym_preproc_elif_token1] = ACTIONS(952),
    [sym_preproc_directive] = ACTIONS(952),
    [anon_sym_LPAREN2] = ACTIONS(954),
    [anon_sym_BANG] = ACTIONS(954),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_DASH] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(952),
    [anon_sym_STAR] = ACTIONS(954),
    [anon_sym_AMP] = ACTIONS(954),
    [anon_sym_SEMI] = ACTIONS(954),
    [anon_sym_typedef] = ACTIONS(952),
    [anon_sym_extern] = ACTIONS(952),
    [anon_sym___attribute__] = ACTIONS(952),
    [anon_sym___declspec] = ACTIONS(952),
    [anon_sym___cdecl] = ACTIONS(952),
    [anon_sym___clrcall] = ACTIONS(952),
    [anon_sym___stdcall] = ACTIONS(952),
    [anon_sym___fastcall] = ACTIONS(952),
    [anon_sym___thiscall] = ACTIONS(952),
    [anon_sym___vectorcall] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(954),
    [anon_sym_static] = ACTIONS(952),
    [anon_sym_auto] = ACTIONS(952),
    [anon_sym_register] = ACTIONS(952),
    [anon_sym_inline] = ACTIONS(952),
    [anon_sym_const] = ACTIONS(952),
    [anon_sym_volatile] = ACTIONS(952),
    [anon_sym_restrict] = ACTIONS(952),
    [anon_sym__Atomic] = ACTIONS(952),
    [anon_sym_signed] = ACTIONS(952),
    [anon_sym_unsigned] = ACTIONS(952),
    [anon_sym_long] = ACTIONS(952),
    [anon_sym_short] = ACTIONS(952),
    [sym_primitive_type] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(952),
    [anon_sym_struct] = ACTIONS(952),
    [anon_sym_union] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_else] = ACTIONS(952),
    [anon_sym_switch] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_default] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_do] = ACTIONS(952),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_return] = ACTIONS(952),
    [anon_sym_break] = ACTIONS(952),
    [anon_sym_continue] = ACTIONS(952),
    [anon_sym_goto] = ACTIONS(952),
    [anon_sym_DASH_DASH] = ACTIONS(954),
    [anon_sym_PLUS_PLUS] = ACTIONS(954),
    [anon_sym_sizeof] = ACTIONS(952),
    [sym_number_literal] = ACTIONS(954),
    [anon_sym_L_SQUOTE] = ACTIONS(954),
    [anon_sym_u_SQUOTE] = ACTIONS(954),
    [anon_sym_U_SQUOTE] = ACTIONS(954),
    [anon_sym_u8_SQUOTE] = ACTIONS(954),
    [anon_sym_SQUOTE] = ACTIONS(954),
    [anon_sym_L_DQUOTE] = ACTIONS(954),
    [anon_sym_u_DQUOTE] = ACTIONS(954),
    [anon_sym_U_DQUOTE] = ACTIONS(954),
    [anon_sym_u8_DQUOTE] = ACTIONS(954),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [sym_true] = ACTIONS(952),
    [sym_false] = ACTIONS(952),
    [sym_null] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
  },
  [88] = {
    [sym_identifier] = ACTIONS(956),
    [aux_sym_preproc_include_token1] = ACTIONS(956),
    [aux_sym_preproc_def_token1] = ACTIONS(956),
    [aux_sym_preproc_if_token1] = ACTIONS(956),
    [aux_sym_preproc_if_token2] = ACTIONS(956),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(956),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(956),
    [aux_sym_preproc_else_token1] = ACTIONS(956),
    [aux_sym_preproc_elif_token1] = ACTIONS(956),
    [sym_preproc_directive] = ACTIONS(956),
    [anon_sym_LPAREN2] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(958),
    [anon_sym_AMP] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(958),
    [anon_sym_typedef] = ACTIONS(956),
    [anon_sym_extern] = ACTIONS(956),
    [anon_sym___attribute__] = ACTIONS(956),
    [anon_sym___declspec] = ACTIONS(956),
    [anon_sym___cdecl] = ACTIONS(956),
    [anon_sym___clrcall] = ACTIONS(956),
    [anon_sym___stdcall] = ACTIONS(956),
    [anon_sym___fastcall] = ACTIONS(956),
    [anon_sym___thiscall] = ACTIONS(956),
    [anon_sym___vectorcall] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_auto] = ACTIONS(956),
    [anon_sym_register] = ACTIONS(956),
    [anon_sym_inline] = ACTIONS(956),
    [anon_sym_const] = ACTIONS(956),
    [anon_sym_volatile] = ACTIONS(956),
    [anon_sym_restrict] = ACTIONS(956),
    [anon_sym__Atomic] = ACTIONS(956),
    [anon_sym_signed] = ACTIONS(956),
    [anon_sym_unsigned] = ACTIONS(956),
    [anon_sym_long] = ACTIONS(956),
    [anon_sym_short] = ACTIONS(956),
    [sym_primitive_type] = ACTIONS(956),
    [anon_sym_enum] = ACTIONS(956),
    [anon_sym_struct] = ACTIONS(956),
    [anon_sym_union] = ACTIONS(956),
    [anon_sym_if] = ACTIONS(956),
    [anon_sym_else] = ACTIONS(956),
    [anon_sym_switch] = ACTIONS(956),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_default] = ACTIONS(956),
    [anon_sym_while] = ACTIONS(956),
    [anon_sym_do] = ACTIONS(956),
    [anon_sym_for] = ACTIONS(956),
    [anon_sym_return] = ACTIONS(956),
    [anon_sym_break] = ACTIONS(956),
    [anon_sym_continue] = ACTIONS(956),
    [anon_sym_goto] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(956),
    [sym_number_literal] = ACTIONS(958),
    [anon_sym_L_SQUOTE] = ACTIONS(958),
    [anon_sym_u_SQUOTE] = ACTIONS(958),
    [anon_sym_U_SQUOTE] = ACTIONS(958),
    [anon_sym_u8_SQUOTE] = ACTIONS(958),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [anon_sym_L_DQUOTE] = ACTIONS(958),
    [anon_sym_u_DQUOTE] = ACTIONS(958),
    [anon_sym_U_DQUOTE] = ACTIONS(958),
    [anon_sym_u8_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [sym_true] = ACTIONS(956),
    [sym_false] = ACTIONS(956),
    [sym_null] = ACTIONS(956),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_identifier] = ACTIONS(960),
    [aux_sym_preproc_include_token1] = ACTIONS(960),
    [aux_sym_preproc_def_token1] = ACTIONS(960),
    [aux_sym_preproc_if_token1] = ACTIONS(960),
    [aux_sym_preproc_if_token2] = ACTIONS(960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(960),
    [aux_sym_preproc_else_token1] = ACTIONS(960),
    [aux_sym_preproc_elif_token1] = ACTIONS(960),
    [sym_preproc_directive] = ACTIONS(960),
    [anon_sym_LPAREN2] = ACTIONS(962),
    [anon_sym_BANG] = ACTIONS(962),
    [anon_sym_TILDE] = ACTIONS(962),
    [anon_sym_DASH] = ACTIONS(960),
    [anon_sym_PLUS] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_typedef] = ACTIONS(960),
    [anon_sym_extern] = ACTIONS(960),
    [anon_sym___attribute__] = ACTIONS(960),
    [anon_sym___declspec] = ACTIONS(960),
    [anon_sym___cdecl] = ACTIONS(960),
    [anon_sym___clrcall] = ACTIONS(960),
    [anon_sym___stdcall] = ACTIONS(960),
    [anon_sym___fastcall] = ACTIONS(960),
    [anon_sym___thiscall] = ACTIONS(960),
    [anon_sym___vectorcall] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_auto] = ACTIONS(960),
    [anon_sym_register] = ACTIONS(960),
    [anon_sym_inline] = ACTIONS(960),
    [anon_sym_const] = ACTIONS(960),
    [anon_sym_volatile] = ACTIONS(960),
    [anon_sym_restrict] = ACTIONS(960),
    [anon_sym__Atomic] = ACTIONS(960),
    [anon_sym_signed] = ACTIONS(960),
    [anon_sym_unsigned] = ACTIONS(960),
    [anon_sym_long] = ACTIONS(960),
    [anon_sym_short] = ACTIONS(960),
    [sym_primitive_type] = ACTIONS(960),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_struct] = ACTIONS(960),
    [anon_sym_union] = ACTIONS(960),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_else] = ACTIONS(960),
    [anon_sym_switch] = ACTIONS(960),
    [anon_sym_case] = ACTIONS(960),
    [anon_sym_default] = ACTIONS(960),
    [anon_sym_while] = ACTIONS(960),
    [anon_sym_do] = ACTIONS(960),
    [anon_sym_for] = ACTIONS(960),
    [anon_sym_return] = ACTIONS(960),
    [anon_sym_break] = ACTIONS(960),
    [anon_sym_continue] = ACTIONS(960),
    [anon_sym_goto] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(962),
    [anon_sym_PLUS_PLUS] = ACTIONS(962),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_L_SQUOTE] = ACTIONS(962),
    [anon_sym_u_SQUOTE] = ACTIONS(962),
    [anon_sym_U_SQUOTE] = ACTIONS(962),
    [anon_sym_u8_SQUOTE] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(962),
    [anon_sym_L_DQUOTE] = ACTIONS(962),
    [anon_sym_u_DQUOTE] = ACTIONS(962),
    [anon_sym_U_DQUOTE] = ACTIONS(962),
    [anon_sym_u8_DQUOTE] = ACTIONS(962),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [sym_true] = ACTIONS(960),
    [sym_false] = ACTIONS(960),
    [sym_null] = ACTIONS(960),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_identifier] = ACTIONS(964),
    [aux_sym_preproc_include_token1] = ACTIONS(964),
    [aux_sym_preproc_def_token1] = ACTIONS(964),
    [aux_sym_preproc_if_token1] = ACTIONS(964),
    [aux_sym_preproc_if_token2] = ACTIONS(964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(964),
    [aux_sym_preproc_else_token1] = ACTIONS(964),
    [aux_sym_preproc_elif_token1] = ACTIONS(964),
    [sym_preproc_directive] = ACTIONS(964),
    [anon_sym_LPAREN2] = ACTIONS(966),
    [anon_sym_BANG] = ACTIONS(966),
    [anon_sym_TILDE] = ACTIONS(966),
    [anon_sym_DASH] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(964),
    [anon_sym_STAR] = ACTIONS(966),
    [anon_sym_AMP] = ACTIONS(966),
    [anon_sym_SEMI] = ACTIONS(966),
    [anon_sym_typedef] = ACTIONS(964),
    [anon_sym_extern] = ACTIONS(964),
    [anon_sym___attribute__] = ACTIONS(964),
    [anon_sym___declspec] = ACTIONS(964),
    [anon_sym___cdecl] = ACTIONS(964),
    [anon_sym___clrcall] = ACTIONS(964),
    [anon_sym___stdcall] = ACTIONS(964),
    [anon_sym___fastcall] = ACTIONS(964),
    [anon_sym___thiscall] = ACTIONS(964),
    [anon_sym___vectorcall] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(966),
    [anon_sym_static] = ACTIONS(964),
    [anon_sym_auto] = ACTIONS(964),
    [anon_sym_register] = ACTIONS(964),
    [anon_sym_inline] = ACTIONS(964),
    [anon_sym_const] = ACTIONS(964),
    [anon_sym_volatile] = ACTIONS(964),
    [anon_sym_restrict] = ACTIONS(964),
    [anon_sym__Atomic] = ACTIONS(964),
    [anon_sym_signed] = ACTIONS(964),
    [anon_sym_unsigned] = ACTIONS(964),
    [anon_sym_long] = ACTIONS(964),
    [anon_sym_short] = ACTIONS(964),
    [sym_primitive_type] = ACTIONS(964),
    [anon_sym_enum] = ACTIONS(964),
    [anon_sym_struct] = ACTIONS(964),
    [anon_sym_union] = ACTIONS(964),
    [anon_sym_if] = ACTIONS(964),
    [anon_sym_else] = ACTIONS(964),
    [anon_sym_switch] = ACTIONS(964),
    [anon_sym_case] = ACTIONS(964),
    [anon_sym_default] = ACTIONS(964),
    [anon_sym_while] = ACTIONS(964),
    [anon_sym_do] = ACTIONS(964),
    [anon_sym_for] = ACTIONS(964),
    [anon_sym_return] = ACTIONS(964),
    [anon_sym_break] = ACTIONS(964),
    [anon_sym_continue] = ACTIONS(964),
    [anon_sym_goto] = ACTIONS(964),
    [anon_sym_DASH_DASH] = ACTIONS(966),
    [anon_sym_PLUS_PLUS] = ACTIONS(966),
    [anon_sym_sizeof] = ACTIONS(964),
    [sym_number_literal] = ACTIONS(966),
    [anon_sym_L_SQUOTE] = ACTIONS(966),
    [anon_sym_u_SQUOTE] = ACTIONS(966),
    [anon_sym_U_SQUOTE] = ACTIONS(966),
    [anon_sym_u8_SQUOTE] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(966),
    [anon_sym_L_DQUOTE] = ACTIONS(966),
    [anon_sym_u_DQUOTE] = ACTIONS(966),
    [anon_sym_U_DQUOTE] = ACTIONS(966),
    [anon_sym_u8_DQUOTE] = ACTIONS(966),
    [anon_sym_DQUOTE] = ACTIONS(966),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_identifier] = ACTIONS(968),
    [aux_sym_preproc_include_token1] = ACTIONS(968),
    [aux_sym_preproc_def_token1] = ACTIONS(968),
    [aux_sym_preproc_if_token1] = ACTIONS(968),
    [aux_sym_preproc_if_token2] = ACTIONS(968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(968),
    [aux_sym_preproc_else_token1] = ACTIONS(968),
    [aux_sym_preproc_elif_token1] = ACTIONS(968),
    [sym_preproc_directive] = ACTIONS(968),
    [anon_sym_LPAREN2] = ACTIONS(970),
    [anon_sym_BANG] = ACTIONS(970),
    [anon_sym_TILDE] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(968),
    [anon_sym_PLUS] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(970),
    [anon_sym_AMP] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(970),
    [anon_sym_typedef] = ACTIONS(968),
    [anon_sym_extern] = ACTIONS(968),
    [anon_sym___attribute__] = ACTIONS(968),
    [anon_sym___declspec] = ACTIONS(968),
    [anon_sym___cdecl] = ACTIONS(968),
    [anon_sym___clrcall] = ACTIONS(968),
    [anon_sym___stdcall] = ACTIONS(968),
    [anon_sym___fastcall] = ACTIONS(968),
    [anon_sym___thiscall] = ACTIONS(968),
    [anon_sym___vectorcall] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(970),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_auto] = ACTIONS(968),
    [anon_sym_register] = ACTIONS(968),
    [anon_sym_inline] = ACTIONS(968),
    [anon_sym_const] = ACTIONS(968),
    [anon_sym_volatile] = ACTIONS(968),
    [anon_sym_restrict] = ACTIONS(968),
    [anon_sym__Atomic] = ACTIONS(968),
    [anon_sym_signed] = ACTIONS(968),
    [anon_sym_unsigned] = ACTIONS(968),
    [anon_sym_long] = ACTIONS(968),
    [anon_sym_short] = ACTIONS(968),
    [sym_primitive_type] = ACTIONS(968),
    [anon_sym_enum] = ACTIONS(968),
    [anon_sym_struct] = ACTIONS(968),
    [anon_sym_union] = ACTIONS(968),
    [anon_sym_if] = ACTIONS(968),
    [anon_sym_else] = ACTIONS(968),
    [anon_sym_switch] = ACTIONS(968),
    [anon_sym_case] = ACTIONS(968),
    [anon_sym_default] = ACTIONS(968),
    [anon_sym_while] = ACTIONS(968),
    [anon_sym_do] = ACTIONS(968),
    [anon_sym_for] = ACTIONS(968),
    [anon_sym_return] = ACTIONS(968),
    [anon_sym_break] = ACTIONS(968),
    [anon_sym_continue] = ACTIONS(968),
    [anon_sym_goto] = ACTIONS(968),
    [anon_sym_DASH_DASH] = ACTIONS(970),
    [anon_sym_PLUS_PLUS] = ACTIONS(970),
    [anon_sym_sizeof] = ACTIONS(968),
    [sym_number_literal] = ACTIONS(970),
    [anon_sym_L_SQUOTE] = ACTIONS(970),
    [anon_sym_u_SQUOTE] = ACTIONS(970),
    [anon_sym_U_SQUOTE] = ACTIONS(970),
    [anon_sym_u8_SQUOTE] = ACTIONS(970),
    [anon_sym_SQUOTE] = ACTIONS(970),
    [anon_sym_L_DQUOTE] = ACTIONS(970),
    [anon_sym_u_DQUOTE] = ACTIONS(970),
    [anon_sym_U_DQUOTE] = ACTIONS(970),
    [anon_sym_u8_DQUOTE] = ACTIONS(970),
    [anon_sym_DQUOTE] = ACTIONS(970),
    [sym_true] = ACTIONS(968),
    [sym_false] = ACTIONS(968),
    [sym_null] = ACTIONS(968),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_identifier] = ACTIONS(972),
    [aux_sym_preproc_include_token1] = ACTIONS(972),
    [aux_sym_preproc_def_token1] = ACTIONS(972),
    [aux_sym_preproc_if_token1] = ACTIONS(972),
    [aux_sym_preproc_if_token2] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(972),
    [aux_sym_preproc_else_token1] = ACTIONS(972),
    [aux_sym_preproc_elif_token1] = ACTIONS(972),
    [sym_preproc_directive] = ACTIONS(972),
    [anon_sym_LPAREN2] = ACTIONS(974),
    [anon_sym_BANG] = ACTIONS(974),
    [anon_sym_TILDE] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_typedef] = ACTIONS(972),
    [anon_sym_extern] = ACTIONS(972),
    [anon_sym___attribute__] = ACTIONS(972),
    [anon_sym___declspec] = ACTIONS(972),
    [anon_sym___cdecl] = ACTIONS(972),
    [anon_sym___clrcall] = ACTIONS(972),
    [anon_sym___stdcall] = ACTIONS(972),
    [anon_sym___fastcall] = ACTIONS(972),
    [anon_sym___thiscall] = ACTIONS(972),
    [anon_sym___vectorcall] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(974),
    [anon_sym_static] = ACTIONS(972),
    [anon_sym_auto] = ACTIONS(972),
    [anon_sym_register] = ACTIONS(972),
    [anon_sym_inline] = ACTIONS(972),
    [anon_sym_const] = ACTIONS(972),
    [anon_sym_volatile] = ACTIONS(972),
    [anon_sym_restrict] = ACTIONS(972),
    [anon_sym__Atomic] = ACTIONS(972),
    [anon_sym_signed] = ACTIONS(972),
    [anon_sym_unsigned] = ACTIONS(972),
    [anon_sym_long] = ACTIONS(972),
    [anon_sym_short] = ACTIONS(972),
    [sym_primitive_type] = ACTIONS(972),
    [anon_sym_enum] = ACTIONS(972),
    [anon_sym_struct] = ACTIONS(972),
    [anon_sym_union] = ACTIONS(972),
    [anon_sym_if] = ACTIONS(972),
    [anon_sym_else] = ACTIONS(972),
    [anon_sym_switch] = ACTIONS(972),
    [anon_sym_case] = ACTIONS(972),
    [anon_sym_default] = ACTIONS(972),
    [anon_sym_while] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(972),
    [anon_sym_for] = ACTIONS(972),
    [anon_sym_return] = ACTIONS(972),
    [anon_sym_break] = ACTIONS(972),
    [anon_sym_continue] = ACTIONS(972),
    [anon_sym_goto] = ACTIONS(972),
    [anon_sym_DASH_DASH] = ACTIONS(974),
    [anon_sym_PLUS_PLUS] = ACTIONS(974),
    [anon_sym_sizeof] = ACTIONS(972),
    [sym_number_literal] = ACTIONS(974),
    [anon_sym_L_SQUOTE] = ACTIONS(974),
    [anon_sym_u_SQUOTE] = ACTIONS(974),
    [anon_sym_U_SQUOTE] = ACTIONS(974),
    [anon_sym_u8_SQUOTE] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(974),
    [anon_sym_L_DQUOTE] = ACTIONS(974),
    [anon_sym_u_DQUOTE] = ACTIONS(974),
    [anon_sym_U_DQUOTE] = ACTIONS(974),
    [anon_sym_u8_DQUOTE] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [sym_true] = ACTIONS(972),
    [sym_false] = ACTIONS(972),
    [sym_null] = ACTIONS(972),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_identifier] = ACTIONS(976),
    [aux_sym_preproc_include_token1] = ACTIONS(976),
    [aux_sym_preproc_def_token1] = ACTIONS(976),
    [aux_sym_preproc_if_token1] = ACTIONS(976),
    [aux_sym_preproc_if_token2] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(976),
    [aux_sym_preproc_else_token1] = ACTIONS(976),
    [aux_sym_preproc_elif_token1] = ACTIONS(976),
    [sym_preproc_directive] = ACTIONS(976),
    [anon_sym_LPAREN2] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(978),
    [anon_sym_TILDE] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_STAR] = ACTIONS(978),
    [anon_sym_AMP] = ACTIONS(978),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym_typedef] = ACTIONS(976),
    [anon_sym_extern] = ACTIONS(976),
    [anon_sym___attribute__] = ACTIONS(976),
    [anon_sym___declspec] = ACTIONS(976),
    [anon_sym___cdecl] = ACTIONS(976),
    [anon_sym___clrcall] = ACTIONS(976),
    [anon_sym___stdcall] = ACTIONS(976),
    [anon_sym___fastcall] = ACTIONS(976),
    [anon_sym___thiscall] = ACTIONS(976),
    [anon_sym___vectorcall] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_static] = ACTIONS(976),
    [anon_sym_auto] = ACTIONS(976),
    [anon_sym_register] = ACTIONS(976),
    [anon_sym_inline] = ACTIONS(976),
    [anon_sym_const] = ACTIONS(976),
    [anon_sym_volatile] = ACTIONS(976),
    [anon_sym_restrict] = ACTIONS(976),
    [anon_sym__Atomic] = ACTIONS(976),
    [anon_sym_signed] = ACTIONS(976),
    [anon_sym_unsigned] = ACTIONS(976),
    [anon_sym_long] = ACTIONS(976),
    [anon_sym_short] = ACTIONS(976),
    [sym_primitive_type] = ACTIONS(976),
    [anon_sym_enum] = ACTIONS(976),
    [anon_sym_struct] = ACTIONS(976),
    [anon_sym_union] = ACTIONS(976),
    [anon_sym_if] = ACTIONS(976),
    [anon_sym_else] = ACTIONS(976),
    [anon_sym_switch] = ACTIONS(976),
    [anon_sym_case] = ACTIONS(976),
    [anon_sym_default] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(976),
    [anon_sym_do] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_return] = ACTIONS(976),
    [anon_sym_break] = ACTIONS(976),
    [anon_sym_continue] = ACTIONS(976),
    [anon_sym_goto] = ACTIONS(976),
    [anon_sym_DASH_DASH] = ACTIONS(978),
    [anon_sym_PLUS_PLUS] = ACTIONS(978),
    [anon_sym_sizeof] = ACTIONS(976),
    [sym_number_literal] = ACTIONS(978),
    [anon_sym_L_SQUOTE] = ACTIONS(978),
    [anon_sym_u_SQUOTE] = ACTIONS(978),
    [anon_sym_U_SQUOTE] = ACTIONS(978),
    [anon_sym_u8_SQUOTE] = ACTIONS(978),
    [anon_sym_SQUOTE] = ACTIONS(978),
    [anon_sym_L_DQUOTE] = ACTIONS(978),
    [anon_sym_u_DQUOTE] = ACTIONS(978),
    [anon_sym_U_DQUOTE] = ACTIONS(978),
    [anon_sym_u8_DQUOTE] = ACTIONS(978),
    [anon_sym_DQUOTE] = ACTIONS(978),
    [sym_true] = ACTIONS(976),
    [sym_false] = ACTIONS(976),
    [sym_null] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_identifier] = ACTIONS(980),
    [aux_sym_preproc_include_token1] = ACTIONS(980),
    [aux_sym_preproc_def_token1] = ACTIONS(980),
    [aux_sym_preproc_if_token1] = ACTIONS(980),
    [aux_sym_preproc_if_token2] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(980),
    [aux_sym_preproc_else_token1] = ACTIONS(980),
    [aux_sym_preproc_elif_token1] = ACTIONS(980),
    [sym_preproc_directive] = ACTIONS(980),
    [anon_sym_LPAREN2] = ACTIONS(982),
    [anon_sym_BANG] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(980),
    [anon_sym_STAR] = ACTIONS(982),
    [anon_sym_AMP] = ACTIONS(982),
    [anon_sym_SEMI] = ACTIONS(982),
    [anon_sym_typedef] = ACTIONS(980),
    [anon_sym_extern] = ACTIONS(980),
    [anon_sym___attribute__] = ACTIONS(980),
    [anon_sym___declspec] = ACTIONS(980),
    [anon_sym___cdecl] = ACTIONS(980),
    [anon_sym___clrcall] = ACTIONS(980),
    [anon_sym___stdcall] = ACTIONS(980),
    [anon_sym___fastcall] = ACTIONS(980),
    [anon_sym___thiscall] = ACTIONS(980),
    [anon_sym___vectorcall] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(982),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_auto] = ACTIONS(980),
    [anon_sym_register] = ACTIONS(980),
    [anon_sym_inline] = ACTIONS(980),
    [anon_sym_const] = ACTIONS(980),
    [anon_sym_volatile] = ACTIONS(980),
    [anon_sym_restrict] = ACTIONS(980),
    [anon_sym__Atomic] = ACTIONS(980),
    [anon_sym_signed] = ACTIONS(980),
    [anon_sym_unsigned] = ACTIONS(980),
    [anon_sym_long] = ACTIONS(980),
    [anon_sym_short] = ACTIONS(980),
    [sym_primitive_type] = ACTIONS(980),
    [anon_sym_enum] = ACTIONS(980),
    [anon_sym_struct] = ACTIONS(980),
    [anon_sym_union] = ACTIONS(980),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_else] = ACTIONS(980),
    [anon_sym_switch] = ACTIONS(980),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_default] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [anon_sym_do] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_goto] = ACTIONS(980),
    [anon_sym_DASH_DASH] = ACTIONS(982),
    [anon_sym_PLUS_PLUS] = ACTIONS(982),
    [anon_sym_sizeof] = ACTIONS(980),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_L_SQUOTE] = ACTIONS(982),
    [anon_sym_u_SQUOTE] = ACTIONS(982),
    [anon_sym_U_SQUOTE] = ACTIONS(982),
    [anon_sym_u8_SQUOTE] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(982),
    [anon_sym_L_DQUOTE] = ACTIONS(982),
    [anon_sym_u_DQUOTE] = ACTIONS(982),
    [anon_sym_U_DQUOTE] = ACTIONS(982),
    [anon_sym_u8_DQUOTE] = ACTIONS(982),
    [anon_sym_DQUOTE] = ACTIONS(982),
    [sym_true] = ACTIONS(980),
    [sym_false] = ACTIONS(980),
    [sym_null] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_identifier] = ACTIONS(984),
    [aux_sym_preproc_include_token1] = ACTIONS(984),
    [aux_sym_preproc_def_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token2] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(984),
    [aux_sym_preproc_else_token1] = ACTIONS(984),
    [aux_sym_preproc_elif_token1] = ACTIONS(984),
    [sym_preproc_directive] = ACTIONS(984),
    [anon_sym_LPAREN2] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_AMP] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_typedef] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym___attribute__] = ACTIONS(984),
    [anon_sym___declspec] = ACTIONS(984),
    [anon_sym___cdecl] = ACTIONS(984),
    [anon_sym___clrcall] = ACTIONS(984),
    [anon_sym___stdcall] = ACTIONS(984),
    [anon_sym___fastcall] = ACTIONS(984),
    [anon_sym___thiscall] = ACTIONS(984),
    [anon_sym___vectorcall] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_auto] = ACTIONS(984),
    [anon_sym_register] = ACTIONS(984),
    [anon_sym_inline] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_volatile] = ACTIONS(984),
    [anon_sym_restrict] = ACTIONS(984),
    [anon_sym__Atomic] = ACTIONS(984),
    [anon_sym_signed] = ACTIONS(984),
    [anon_sym_unsigned] = ACTIONS(984),
    [anon_sym_long] = ACTIONS(984),
    [anon_sym_short] = ACTIONS(984),
    [sym_primitive_type] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_struct] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(984),
    [anon_sym_switch] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_do] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_goto] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_sizeof] = ACTIONS(984),
    [sym_number_literal] = ACTIONS(986),
    [anon_sym_L_SQUOTE] = ACTIONS(986),
    [anon_sym_u_SQUOTE] = ACTIONS(986),
    [anon_sym_U_SQUOTE] = ACTIONS(986),
    [anon_sym_u8_SQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [anon_sym_L_DQUOTE] = ACTIONS(986),
    [anon_sym_u_DQUOTE] = ACTIONS(986),
    [anon_sym_U_DQUOTE] = ACTIONS(986),
    [anon_sym_u8_DQUOTE] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_identifier] = ACTIONS(988),
    [aux_sym_preproc_include_token1] = ACTIONS(988),
    [aux_sym_preproc_def_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token2] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(988),
    [aux_sym_preproc_else_token1] = ACTIONS(988),
    [aux_sym_preproc_elif_token1] = ACTIONS(988),
    [sym_preproc_directive] = ACTIONS(988),
    [anon_sym_LPAREN2] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(990),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_SEMI] = ACTIONS(990),
    [anon_sym_typedef] = ACTIONS(988),
    [anon_sym_extern] = ACTIONS(988),
    [anon_sym___attribute__] = ACTIONS(988),
    [anon_sym___declspec] = ACTIONS(988),
    [anon_sym___cdecl] = ACTIONS(988),
    [anon_sym___clrcall] = ACTIONS(988),
    [anon_sym___stdcall] = ACTIONS(988),
    [anon_sym___fastcall] = ACTIONS(988),
    [anon_sym___thiscall] = ACTIONS(988),
    [anon_sym___vectorcall] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(990),
    [anon_sym_static] = ACTIONS(988),
    [anon_sym_auto] = ACTIONS(988),
    [anon_sym_register] = ACTIONS(988),
    [anon_sym_inline] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(988),
    [anon_sym_volatile] = ACTIONS(988),
    [anon_sym_restrict] = ACTIONS(988),
    [anon_sym__Atomic] = ACTIONS(988),
    [anon_sym_signed] = ACTIONS(988),
    [anon_sym_unsigned] = ACTIONS(988),
    [anon_sym_long] = ACTIONS(988),
    [anon_sym_short] = ACTIONS(988),
    [sym_primitive_type] = ACTIONS(988),
    [anon_sym_enum] = ACTIONS(988),
    [anon_sym_struct] = ACTIONS(988),
    [anon_sym_union] = ACTIONS(988),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(988),
    [anon_sym_switch] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(988),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_while] = ACTIONS(988),
    [anon_sym_do] = ACTIONS(988),
    [anon_sym_for] = ACTIONS(988),
    [anon_sym_return] = ACTIONS(988),
    [anon_sym_break] = ACTIONS(988),
    [anon_sym_continue] = ACTIONS(988),
    [anon_sym_goto] = ACTIONS(988),
    [anon_sym_DASH_DASH] = ACTIONS(990),
    [anon_sym_PLUS_PLUS] = ACTIONS(990),
    [anon_sym_sizeof] = ACTIONS(988),
    [sym_number_literal] = ACTIONS(990),
    [anon_sym_L_SQUOTE] = ACTIONS(990),
    [anon_sym_u_SQUOTE] = ACTIONS(990),
    [anon_sym_U_SQUOTE] = ACTIONS(990),
    [anon_sym_u8_SQUOTE] = ACTIONS(990),
    [anon_sym_SQUOTE] = ACTIONS(990),
    [anon_sym_L_DQUOTE] = ACTIONS(990),
    [anon_sym_u_DQUOTE] = ACTIONS(990),
    [anon_sym_U_DQUOTE] = ACTIONS(990),
    [anon_sym_u8_DQUOTE] = ACTIONS(990),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_true] = ACTIONS(988),
    [sym_false] = ACTIONS(988),
    [sym_null] = ACTIONS(988),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_identifier] = ACTIONS(992),
    [aux_sym_preproc_include_token1] = ACTIONS(992),
    [aux_sym_preproc_def_token1] = ACTIONS(992),
    [aux_sym_preproc_if_token1] = ACTIONS(992),
    [aux_sym_preproc_if_token2] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(992),
    [aux_sym_preproc_else_token1] = ACTIONS(992),
    [aux_sym_preproc_elif_token1] = ACTIONS(992),
    [sym_preproc_directive] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(994),
    [anon_sym_BANG] = ACTIONS(994),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_AMP] = ACTIONS(994),
    [anon_sym_SEMI] = ACTIONS(994),
    [anon_sym_typedef] = ACTIONS(992),
    [anon_sym_extern] = ACTIONS(992),
    [anon_sym___attribute__] = ACTIONS(992),
    [anon_sym___declspec] = ACTIONS(992),
    [anon_sym___cdecl] = ACTIONS(992),
    [anon_sym___clrcall] = ACTIONS(992),
    [anon_sym___stdcall] = ACTIONS(992),
    [anon_sym___fastcall] = ACTIONS(992),
    [anon_sym___thiscall] = ACTIONS(992),
    [anon_sym___vectorcall] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(994),
    [anon_sym_static] = ACTIONS(992),
    [anon_sym_auto] = ACTIONS(992),
    [anon_sym_register] = ACTIONS(992),
    [anon_sym_inline] = ACTIONS(992),
    [anon_sym_const] = ACTIONS(992),
    [anon_sym_volatile] = ACTIONS(992),
    [anon_sym_restrict] = ACTIONS(992),
    [anon_sym__Atomic] = ACTIONS(992),
    [anon_sym_signed] = ACTIONS(992),
    [anon_sym_unsigned] = ACTIONS(992),
    [anon_sym_long] = ACTIONS(992),
    [anon_sym_short] = ACTIONS(992),
    [sym_primitive_type] = ACTIONS(992),
    [anon_sym_enum] = ACTIONS(992),
    [anon_sym_struct] = ACTIONS(992),
    [anon_sym_union] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_switch] = ACTIONS(992),
    [anon_sym_case] = ACTIONS(992),
    [anon_sym_default] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_goto] = ACTIONS(992),
    [anon_sym_DASH_DASH] = ACTIONS(994),
    [anon_sym_PLUS_PLUS] = ACTIONS(994),
    [anon_sym_sizeof] = ACTIONS(992),
    [sym_number_literal] = ACTIONS(994),
    [anon_sym_L_SQUOTE] = ACTIONS(994),
    [anon_sym_u_SQUOTE] = ACTIONS(994),
    [anon_sym_U_SQUOTE] = ACTIONS(994),
    [anon_sym_u8_SQUOTE] = ACTIONS(994),
    [anon_sym_SQUOTE] = ACTIONS(994),
    [anon_sym_L_DQUOTE] = ACTIONS(994),
    [anon_sym_u_DQUOTE] = ACTIONS(994),
    [anon_sym_U_DQUOTE] = ACTIONS(994),
    [anon_sym_u8_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_true] = ACTIONS(992),
    [sym_false] = ACTIONS(992),
    [sym_null] = ACTIONS(992),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_identifier] = ACTIONS(996),
    [aux_sym_preproc_include_token1] = ACTIONS(996),
    [aux_sym_preproc_def_token1] = ACTIONS(996),
    [aux_sym_preproc_if_token1] = ACTIONS(996),
    [aux_sym_preproc_if_token2] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(996),
    [aux_sym_preproc_else_token1] = ACTIONS(996),
    [aux_sym_preproc_elif_token1] = ACTIONS(996),
    [sym_preproc_directive] = ACTIONS(996),
    [anon_sym_LPAREN2] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(998),
    [anon_sym_AMP] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(998),
    [anon_sym_typedef] = ACTIONS(996),
    [anon_sym_extern] = ACTIONS(996),
    [anon_sym___attribute__] = ACTIONS(996),
    [anon_sym___declspec] = ACTIONS(996),
    [anon_sym___cdecl] = ACTIONS(996),
    [anon_sym___clrcall] = ACTIONS(996),
    [anon_sym___stdcall] = ACTIONS(996),
    [anon_sym___fastcall] = ACTIONS(996),
    [anon_sym___thiscall] = ACTIONS(996),
    [anon_sym___vectorcall] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_static] = ACTIONS(996),
    [anon_sym_auto] = ACTIONS(996),
    [anon_sym_register] = ACTIONS(996),
    [anon_sym_inline] = ACTIONS(996),
    [anon_sym_const] = ACTIONS(996),
    [anon_sym_volatile] = ACTIONS(996),
    [anon_sym_restrict] = ACTIONS(996),
    [anon_sym__Atomic] = ACTIONS(996),
    [anon_sym_signed] = ACTIONS(996),
    [anon_sym_unsigned] = ACTIONS(996),
    [anon_sym_long] = ACTIONS(996),
    [anon_sym_short] = ACTIONS(996),
    [sym_primitive_type] = ACTIONS(996),
    [anon_sym_enum] = ACTIONS(996),
    [anon_sym_struct] = ACTIONS(996),
    [anon_sym_union] = ACTIONS(996),
    [anon_sym_if] = ACTIONS(996),
    [anon_sym_else] = ACTIONS(996),
    [anon_sym_switch] = ACTIONS(996),
    [anon_sym_case] = ACTIONS(996),
    [anon_sym_default] = ACTIONS(996),
    [anon_sym_while] = ACTIONS(996),
    [anon_sym_do] = ACTIONS(996),
    [anon_sym_for] = ACTIONS(996),
    [anon_sym_return] = ACTIONS(996),
    [anon_sym_break] = ACTIONS(996),
    [anon_sym_continue] = ACTIONS(996),
    [anon_sym_goto] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(996),
    [sym_number_literal] = ACTIONS(998),
    [anon_sym_L_SQUOTE] = ACTIONS(998),
    [anon_sym_u_SQUOTE] = ACTIONS(998),
    [anon_sym_U_SQUOTE] = ACTIONS(998),
    [anon_sym_u8_SQUOTE] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(998),
    [anon_sym_L_DQUOTE] = ACTIONS(998),
    [anon_sym_u_DQUOTE] = ACTIONS(998),
    [anon_sym_U_DQUOTE] = ACTIONS(998),
    [anon_sym_u8_DQUOTE] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(998),
    [sym_true] = ACTIONS(996),
    [sym_false] = ACTIONS(996),
    [sym_null] = ACTIONS(996),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_identifier] = ACTIONS(984),
    [aux_sym_preproc_include_token1] = ACTIONS(984),
    [aux_sym_preproc_def_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token2] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(984),
    [aux_sym_preproc_else_token1] = ACTIONS(984),
    [aux_sym_preproc_elif_token1] = ACTIONS(984),
    [sym_preproc_directive] = ACTIONS(984),
    [anon_sym_LPAREN2] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_AMP] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_typedef] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym___attribute__] = ACTIONS(984),
    [anon_sym___declspec] = ACTIONS(984),
    [anon_sym___cdecl] = ACTIONS(984),
    [anon_sym___clrcall] = ACTIONS(984),
    [anon_sym___stdcall] = ACTIONS(984),
    [anon_sym___fastcall] = ACTIONS(984),
    [anon_sym___thiscall] = ACTIONS(984),
    [anon_sym___vectorcall] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_auto] = ACTIONS(984),
    [anon_sym_register] = ACTIONS(984),
    [anon_sym_inline] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_volatile] = ACTIONS(984),
    [anon_sym_restrict] = ACTIONS(984),
    [anon_sym__Atomic] = ACTIONS(984),
    [anon_sym_signed] = ACTIONS(984),
    [anon_sym_unsigned] = ACTIONS(984),
    [anon_sym_long] = ACTIONS(984),
    [anon_sym_short] = ACTIONS(984),
    [sym_primitive_type] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_struct] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(984),
    [anon_sym_switch] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_do] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_goto] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_sizeof] = ACTIONS(984),
    [sym_number_literal] = ACTIONS(986),
    [anon_sym_L_SQUOTE] = ACTIONS(986),
    [anon_sym_u_SQUOTE] = ACTIONS(986),
    [anon_sym_U_SQUOTE] = ACTIONS(986),
    [anon_sym_u8_SQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [anon_sym_L_DQUOTE] = ACTIONS(986),
    [anon_sym_u_DQUOTE] = ACTIONS(986),
    [anon_sym_U_DQUOTE] = ACTIONS(986),
    [anon_sym_u8_DQUOTE] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_identifier] = ACTIONS(1000),
    [aux_sym_preproc_include_token1] = ACTIONS(1000),
    [aux_sym_preproc_def_token1] = ACTIONS(1000),
    [aux_sym_preproc_if_token1] = ACTIONS(1000),
    [aux_sym_preproc_if_token2] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1000),
    [aux_sym_preproc_else_token1] = ACTIONS(1000),
    [aux_sym_preproc_elif_token1] = ACTIONS(1000),
    [sym_preproc_directive] = ACTIONS(1000),
    [anon_sym_LPAREN2] = ACTIONS(1002),
    [anon_sym_BANG] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_typedef] = ACTIONS(1000),
    [anon_sym_extern] = ACTIONS(1000),
    [anon_sym___attribute__] = ACTIONS(1000),
    [anon_sym___declspec] = ACTIONS(1000),
    [anon_sym___cdecl] = ACTIONS(1000),
    [anon_sym___clrcall] = ACTIONS(1000),
    [anon_sym___stdcall] = ACTIONS(1000),
    [anon_sym___fastcall] = ACTIONS(1000),
    [anon_sym___thiscall] = ACTIONS(1000),
    [anon_sym___vectorcall] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(1002),
    [anon_sym_static] = ACTIONS(1000),
    [anon_sym_auto] = ACTIONS(1000),
    [anon_sym_register] = ACTIONS(1000),
    [anon_sym_inline] = ACTIONS(1000),
    [anon_sym_const] = ACTIONS(1000),
    [anon_sym_volatile] = ACTIONS(1000),
    [anon_sym_restrict] = ACTIONS(1000),
    [anon_sym__Atomic] = ACTIONS(1000),
    [anon_sym_signed] = ACTIONS(1000),
    [anon_sym_unsigned] = ACTIONS(1000),
    [anon_sym_long] = ACTIONS(1000),
    [anon_sym_short] = ACTIONS(1000),
    [sym_primitive_type] = ACTIONS(1000),
    [anon_sym_enum] = ACTIONS(1000),
    [anon_sym_struct] = ACTIONS(1000),
    [anon_sym_union] = ACTIONS(1000),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_else] = ACTIONS(1000),
    [anon_sym_switch] = ACTIONS(1000),
    [anon_sym_case] = ACTIONS(1000),
    [anon_sym_default] = ACTIONS(1000),
    [anon_sym_while] = ACTIONS(1000),
    [anon_sym_do] = ACTIONS(1000),
    [anon_sym_for] = ACTIONS(1000),
    [anon_sym_return] = ACTIONS(1000),
    [anon_sym_break] = ACTIONS(1000),
    [anon_sym_continue] = ACTIONS(1000),
    [anon_sym_goto] = ACTIONS(1000),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1002),
    [anon_sym_L_SQUOTE] = ACTIONS(1002),
    [anon_sym_u_SQUOTE] = ACTIONS(1002),
    [anon_sym_U_SQUOTE] = ACTIONS(1002),
    [anon_sym_u8_SQUOTE] = ACTIONS(1002),
    [anon_sym_SQUOTE] = ACTIONS(1002),
    [anon_sym_L_DQUOTE] = ACTIONS(1002),
    [anon_sym_u_DQUOTE] = ACTIONS(1002),
    [anon_sym_U_DQUOTE] = ACTIONS(1002),
    [anon_sym_u8_DQUOTE] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1002),
    [sym_true] = ACTIONS(1000),
    [sym_false] = ACTIONS(1000),
    [sym_null] = ACTIONS(1000),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_identifier] = ACTIONS(1004),
    [aux_sym_preproc_include_token1] = ACTIONS(1004),
    [aux_sym_preproc_def_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token2] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1004),
    [aux_sym_preproc_else_token1] = ACTIONS(1004),
    [aux_sym_preproc_elif_token1] = ACTIONS(1004),
    [sym_preproc_directive] = ACTIONS(1004),
    [anon_sym_LPAREN2] = ACTIONS(1006),
    [anon_sym_BANG] = ACTIONS(1006),
    [anon_sym_TILDE] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1006),
    [anon_sym_AMP] = ACTIONS(1006),
    [anon_sym_SEMI] = ACTIONS(1006),
    [anon_sym_typedef] = ACTIONS(1004),
    [anon_sym_extern] = ACTIONS(1004),
    [anon_sym___attribute__] = ACTIONS(1004),
    [anon_sym___declspec] = ACTIONS(1004),
    [anon_sym___cdecl] = ACTIONS(1004),
    [anon_sym___clrcall] = ACTIONS(1004),
    [anon_sym___stdcall] = ACTIONS(1004),
    [anon_sym___fastcall] = ACTIONS(1004),
    [anon_sym___thiscall] = ACTIONS(1004),
    [anon_sym___vectorcall] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1006),
    [anon_sym_static] = ACTIONS(1004),
    [anon_sym_auto] = ACTIONS(1004),
    [anon_sym_register] = ACTIONS(1004),
    [anon_sym_inline] = ACTIONS(1004),
    [anon_sym_const] = ACTIONS(1004),
    [anon_sym_volatile] = ACTIONS(1004),
    [anon_sym_restrict] = ACTIONS(1004),
    [anon_sym__Atomic] = ACTIONS(1004),
    [anon_sym_signed] = ACTIONS(1004),
    [anon_sym_unsigned] = ACTIONS(1004),
    [anon_sym_long] = ACTIONS(1004),
    [anon_sym_short] = ACTIONS(1004),
    [sym_primitive_type] = ACTIONS(1004),
    [anon_sym_enum] = ACTIONS(1004),
    [anon_sym_struct] = ACTIONS(1004),
    [anon_sym_union] = ACTIONS(1004),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(1004),
    [anon_sym_do] = ACTIONS(1004),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_return] = ACTIONS(1004),
    [anon_sym_break] = ACTIONS(1004),
    [anon_sym_continue] = ACTIONS(1004),
    [anon_sym_goto] = ACTIONS(1004),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_sizeof] = ACTIONS(1004),
    [sym_number_literal] = ACTIONS(1006),
    [anon_sym_L_SQUOTE] = ACTIONS(1006),
    [anon_sym_u_SQUOTE] = ACTIONS(1006),
    [anon_sym_U_SQUOTE] = ACTIONS(1006),
    [anon_sym_u8_SQUOTE] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1006),
    [anon_sym_L_DQUOTE] = ACTIONS(1006),
    [anon_sym_u_DQUOTE] = ACTIONS(1006),
    [anon_sym_U_DQUOTE] = ACTIONS(1006),
    [anon_sym_u8_DQUOTE] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1006),
    [sym_true] = ACTIONS(1004),
    [sym_false] = ACTIONS(1004),
    [sym_null] = ACTIONS(1004),
    [sym_comment] = ACTIONS(3),
  },
  [102] = {
    [sym_identifier] = ACTIONS(1008),
    [aux_sym_preproc_include_token1] = ACTIONS(1008),
    [aux_sym_preproc_def_token1] = ACTIONS(1008),
    [aux_sym_preproc_if_token1] = ACTIONS(1008),
    [aux_sym_preproc_if_token2] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1008),
    [aux_sym_preproc_else_token1] = ACTIONS(1008),
    [aux_sym_preproc_elif_token1] = ACTIONS(1008),
    [sym_preproc_directive] = ACTIONS(1008),
    [anon_sym_LPAREN2] = ACTIONS(1010),
    [anon_sym_BANG] = ACTIONS(1010),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1010),
    [anon_sym_typedef] = ACTIONS(1008),
    [anon_sym_extern] = ACTIONS(1008),
    [anon_sym___attribute__] = ACTIONS(1008),
    [anon_sym___declspec] = ACTIONS(1008),
    [anon_sym___cdecl] = ACTIONS(1008),
    [anon_sym___clrcall] = ACTIONS(1008),
    [anon_sym___stdcall] = ACTIONS(1008),
    [anon_sym___fastcall] = ACTIONS(1008),
    [anon_sym___thiscall] = ACTIONS(1008),
    [anon_sym___vectorcall] = ACTIONS(1008),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_auto] = ACTIONS(1008),
    [anon_sym_register] = ACTIONS(1008),
    [anon_sym_inline] = ACTIONS(1008),
    [anon_sym_const] = ACTIONS(1008),
    [anon_sym_volatile] = ACTIONS(1008),
    [anon_sym_restrict] = ACTIONS(1008),
    [anon_sym__Atomic] = ACTIONS(1008),
    [anon_sym_signed] = ACTIONS(1008),
    [anon_sym_unsigned] = ACTIONS(1008),
    [anon_sym_long] = ACTIONS(1008),
    [anon_sym_short] = ACTIONS(1008),
    [sym_primitive_type] = ACTIONS(1008),
    [anon_sym_enum] = ACTIONS(1008),
    [anon_sym_struct] = ACTIONS(1008),
    [anon_sym_union] = ACTIONS(1008),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_else] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1008),
    [anon_sym_case] = ACTIONS(1008),
    [anon_sym_default] = ACTIONS(1008),
    [anon_sym_while] = ACTIONS(1008),
    [anon_sym_do] = ACTIONS(1008),
    [anon_sym_for] = ACTIONS(1008),
    [anon_sym_return] = ACTIONS(1008),
    [anon_sym_break] = ACTIONS(1008),
    [anon_sym_continue] = ACTIONS(1008),
    [anon_sym_goto] = ACTIONS(1008),
    [anon_sym_DASH_DASH] = ACTIONS(1010),
    [anon_sym_PLUS_PLUS] = ACTIONS(1010),
    [anon_sym_sizeof] = ACTIONS(1008),
    [sym_number_literal] = ACTIONS(1010),
    [anon_sym_L_SQUOTE] = ACTIONS(1010),
    [anon_sym_u_SQUOTE] = ACTIONS(1010),
    [anon_sym_U_SQUOTE] = ACTIONS(1010),
    [anon_sym_u8_SQUOTE] = ACTIONS(1010),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [anon_sym_L_DQUOTE] = ACTIONS(1010),
    [anon_sym_u_DQUOTE] = ACTIONS(1010),
    [anon_sym_U_DQUOTE] = ACTIONS(1010),
    [anon_sym_u8_DQUOTE] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [sym_true] = ACTIONS(1008),
    [sym_false] = ACTIONS(1008),
    [sym_null] = ACTIONS(1008),
    [sym_comment] = ACTIONS(3),
  },
  [103] = {
    [sym_identifier] = ACTIONS(1012),
    [aux_sym_preproc_include_token1] = ACTIONS(1012),
    [aux_sym_preproc_def_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token2] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1012),
    [aux_sym_preproc_else_token1] = ACTIONS(1012),
    [aux_sym_preproc_elif_token1] = ACTIONS(1012),
    [sym_preproc_directive] = ACTIONS(1012),
    [anon_sym_LPAREN2] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_typedef] = ACTIONS(1012),
    [anon_sym_extern] = ACTIONS(1012),
    [anon_sym___attribute__] = ACTIONS(1012),
    [anon_sym___declspec] = ACTIONS(1012),
    [anon_sym___cdecl] = ACTIONS(1012),
    [anon_sym___clrcall] = ACTIONS(1012),
    [anon_sym___stdcall] = ACTIONS(1012),
    [anon_sym___fastcall] = ACTIONS(1012),
    [anon_sym___thiscall] = ACTIONS(1012),
    [anon_sym___vectorcall] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_auto] = ACTIONS(1012),
    [anon_sym_register] = ACTIONS(1012),
    [anon_sym_inline] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_volatile] = ACTIONS(1012),
    [anon_sym_restrict] = ACTIONS(1012),
    [anon_sym__Atomic] = ACTIONS(1012),
    [anon_sym_signed] = ACTIONS(1012),
    [anon_sym_unsigned] = ACTIONS(1012),
    [anon_sym_long] = ACTIONS(1012),
    [anon_sym_short] = ACTIONS(1012),
    [sym_primitive_type] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_goto] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_sizeof] = ACTIONS(1012),
    [sym_number_literal] = ACTIONS(1014),
    [anon_sym_L_SQUOTE] = ACTIONS(1014),
    [anon_sym_u_SQUOTE] = ACTIONS(1014),
    [anon_sym_U_SQUOTE] = ACTIONS(1014),
    [anon_sym_u8_SQUOTE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_L_DQUOTE] = ACTIONS(1014),
    [anon_sym_u_DQUOTE] = ACTIONS(1014),
    [anon_sym_U_DQUOTE] = ACTIONS(1014),
    [anon_sym_u8_DQUOTE] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_identifier] = ACTIONS(1016),
    [aux_sym_preproc_include_token1] = ACTIONS(1016),
    [aux_sym_preproc_def_token1] = ACTIONS(1016),
    [aux_sym_preproc_if_token1] = ACTIONS(1016),
    [aux_sym_preproc_if_token2] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1016),
    [aux_sym_preproc_else_token1] = ACTIONS(1016),
    [aux_sym_preproc_elif_token1] = ACTIONS(1016),
    [sym_preproc_directive] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1018),
    [anon_sym_BANG] = ACTIONS(1018),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1016),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_AMP] = ACTIONS(1018),
    [anon_sym_SEMI] = ACTIONS(1018),
    [anon_sym_typedef] = ACTIONS(1016),
    [anon_sym_extern] = ACTIONS(1016),
    [anon_sym___attribute__] = ACTIONS(1016),
    [anon_sym___declspec] = ACTIONS(1016),
    [anon_sym___cdecl] = ACTIONS(1016),
    [anon_sym___clrcall] = ACTIONS(1016),
    [anon_sym___stdcall] = ACTIONS(1016),
    [anon_sym___fastcall] = ACTIONS(1016),
    [anon_sym___thiscall] = ACTIONS(1016),
    [anon_sym___vectorcall] = ACTIONS(1016),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_static] = ACTIONS(1016),
    [anon_sym_auto] = ACTIONS(1016),
    [anon_sym_register] = ACTIONS(1016),
    [anon_sym_inline] = ACTIONS(1016),
    [anon_sym_const] = ACTIONS(1016),
    [anon_sym_volatile] = ACTIONS(1016),
    [anon_sym_restrict] = ACTIONS(1016),
    [anon_sym__Atomic] = ACTIONS(1016),
    [anon_sym_signed] = ACTIONS(1016),
    [anon_sym_unsigned] = ACTIONS(1016),
    [anon_sym_long] = ACTIONS(1016),
    [anon_sym_short] = ACTIONS(1016),
    [sym_primitive_type] = ACTIONS(1016),
    [anon_sym_enum] = ACTIONS(1016),
    [anon_sym_struct] = ACTIONS(1016),
    [anon_sym_union] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1016),
    [anon_sym_switch] = ACTIONS(1016),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_default] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_goto] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [anon_sym_sizeof] = ACTIONS(1016),
    [sym_number_literal] = ACTIONS(1018),
    [anon_sym_L_SQUOTE] = ACTIONS(1018),
    [anon_sym_u_SQUOTE] = ACTIONS(1018),
    [anon_sym_U_SQUOTE] = ACTIONS(1018),
    [anon_sym_u8_SQUOTE] = ACTIONS(1018),
    [anon_sym_SQUOTE] = ACTIONS(1018),
    [anon_sym_L_DQUOTE] = ACTIONS(1018),
    [anon_sym_u_DQUOTE] = ACTIONS(1018),
    [anon_sym_U_DQUOTE] = ACTIONS(1018),
    [anon_sym_u8_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [sym_true] = ACTIONS(1016),
    [sym_false] = ACTIONS(1016),
    [sym_null] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [sym_identifier] = ACTIONS(1020),
    [aux_sym_preproc_include_token1] = ACTIONS(1020),
    [aux_sym_preproc_def_token1] = ACTIONS(1020),
    [aux_sym_preproc_if_token1] = ACTIONS(1020),
    [aux_sym_preproc_if_token2] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1020),
    [aux_sym_preproc_else_token1] = ACTIONS(1020),
    [aux_sym_preproc_elif_token1] = ACTIONS(1020),
    [sym_preproc_directive] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1022),
    [anon_sym_TILDE] = ACTIONS(1022),
    [anon_sym_DASH] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1020),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_AMP] = ACTIONS(1022),
    [anon_sym_SEMI] = ACTIONS(1022),
    [anon_sym_typedef] = ACTIONS(1020),
    [anon_sym_extern] = ACTIONS(1020),
    [anon_sym___attribute__] = ACTIONS(1020),
    [anon_sym___declspec] = ACTIONS(1020),
    [anon_sym___cdecl] = ACTIONS(1020),
    [anon_sym___clrcall] = ACTIONS(1020),
    [anon_sym___stdcall] = ACTIONS(1020),
    [anon_sym___fastcall] = ACTIONS(1020),
    [anon_sym___thiscall] = ACTIONS(1020),
    [anon_sym___vectorcall] = ACTIONS(1020),
    [anon_sym_LBRACE] = ACTIONS(1022),
    [anon_sym_static] = ACTIONS(1020),
    [anon_sym_auto] = ACTIONS(1020),
    [anon_sym_register] = ACTIONS(1020),
    [anon_sym_inline] = ACTIONS(1020),
    [anon_sym_const] = ACTIONS(1020),
    [anon_sym_volatile] = ACTIONS(1020),
    [anon_sym_restrict] = ACTIONS(1020),
    [anon_sym__Atomic] = ACTIONS(1020),
    [anon_sym_signed] = ACTIONS(1020),
    [anon_sym_unsigned] = ACTIONS(1020),
    [anon_sym_long] = ACTIONS(1020),
    [anon_sym_short] = ACTIONS(1020),
    [sym_primitive_type] = ACTIONS(1020),
    [anon_sym_enum] = ACTIONS(1020),
    [anon_sym_struct] = ACTIONS(1020),
    [anon_sym_union] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_switch] = ACTIONS(1020),
    [anon_sym_case] = ACTIONS(1020),
    [anon_sym_default] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_goto] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1022),
    [anon_sym_PLUS_PLUS] = ACTIONS(1022),
    [anon_sym_sizeof] = ACTIONS(1020),
    [sym_number_literal] = ACTIONS(1022),
    [anon_sym_L_SQUOTE] = ACTIONS(1022),
    [anon_sym_u_SQUOTE] = ACTIONS(1022),
    [anon_sym_U_SQUOTE] = ACTIONS(1022),
    [anon_sym_u8_SQUOTE] = ACTIONS(1022),
    [anon_sym_SQUOTE] = ACTIONS(1022),
    [anon_sym_L_DQUOTE] = ACTIONS(1022),
    [anon_sym_u_DQUOTE] = ACTIONS(1022),
    [anon_sym_U_DQUOTE] = ACTIONS(1022),
    [anon_sym_u8_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [sym_true] = ACTIONS(1020),
    [sym_false] = ACTIONS(1020),
    [sym_null] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
  },
  [106] = {
    [sym_identifier] = ACTIONS(1024),
    [aux_sym_preproc_include_token1] = ACTIONS(1024),
    [aux_sym_preproc_def_token1] = ACTIONS(1024),
    [aux_sym_preproc_if_token1] = ACTIONS(1024),
    [aux_sym_preproc_if_token2] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1024),
    [aux_sym_preproc_else_token1] = ACTIONS(1024),
    [aux_sym_preproc_elif_token1] = ACTIONS(1024),
    [sym_preproc_directive] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1026),
    [anon_sym_TILDE] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_AMP] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1026),
    [anon_sym_typedef] = ACTIONS(1024),
    [anon_sym_extern] = ACTIONS(1024),
    [anon_sym___attribute__] = ACTIONS(1024),
    [anon_sym___declspec] = ACTIONS(1024),
    [anon_sym___cdecl] = ACTIONS(1024),
    [anon_sym___clrcall] = ACTIONS(1024),
    [anon_sym___stdcall] = ACTIONS(1024),
    [anon_sym___fastcall] = ACTIONS(1024),
    [anon_sym___thiscall] = ACTIONS(1024),
    [anon_sym___vectorcall] = ACTIONS(1024),
    [anon_sym_LBRACE] = ACTIONS(1026),
    [anon_sym_static] = ACTIONS(1024),
    [anon_sym_auto] = ACTIONS(1024),
    [anon_sym_register] = ACTIONS(1024),
    [anon_sym_inline] = ACTIONS(1024),
    [anon_sym_const] = ACTIONS(1024),
    [anon_sym_volatile] = ACTIONS(1024),
    [anon_sym_restrict] = ACTIONS(1024),
    [anon_sym__Atomic] = ACTIONS(1024),
    [anon_sym_signed] = ACTIONS(1024),
    [anon_sym_unsigned] = ACTIONS(1024),
    [anon_sym_long] = ACTIONS(1024),
    [anon_sym_short] = ACTIONS(1024),
    [sym_primitive_type] = ACTIONS(1024),
    [anon_sym_enum] = ACTIONS(1024),
    [anon_sym_struct] = ACTIONS(1024),
    [anon_sym_union] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1024),
    [anon_sym_switch] = ACTIONS(1024),
    [anon_sym_case] = ACTIONS(1024),
    [anon_sym_default] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_do] = ACTIONS(1024),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_goto] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_sizeof] = ACTIONS(1024),
    [sym_number_literal] = ACTIONS(1026),
    [anon_sym_L_SQUOTE] = ACTIONS(1026),
    [anon_sym_u_SQUOTE] = ACTIONS(1026),
    [anon_sym_U_SQUOTE] = ACTIONS(1026),
    [anon_sym_u8_SQUOTE] = ACTIONS(1026),
    [anon_sym_SQUOTE] = ACTIONS(1026),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1024),
    [sym_false] = ACTIONS(1024),
    [sym_null] = ACTIONS(1024),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_identifier] = ACTIONS(1028),
    [aux_sym_preproc_include_token1] = ACTIONS(1028),
    [aux_sym_preproc_def_token1] = ACTIONS(1028),
    [aux_sym_preproc_if_token1] = ACTIONS(1028),
    [aux_sym_preproc_if_token2] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1028),
    [aux_sym_preproc_else_token1] = ACTIONS(1028),
    [aux_sym_preproc_elif_token1] = ACTIONS(1028),
    [sym_preproc_directive] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1030),
    [anon_sym_BANG] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1028),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_AMP] = ACTIONS(1030),
    [anon_sym_SEMI] = ACTIONS(1030),
    [anon_sym_typedef] = ACTIONS(1028),
    [anon_sym_extern] = ACTIONS(1028),
    [anon_sym___attribute__] = ACTIONS(1028),
    [anon_sym___declspec] = ACTIONS(1028),
    [anon_sym___cdecl] = ACTIONS(1028),
    [anon_sym___clrcall] = ACTIONS(1028),
    [anon_sym___stdcall] = ACTIONS(1028),
    [anon_sym___fastcall] = ACTIONS(1028),
    [anon_sym___thiscall] = ACTIONS(1028),
    [anon_sym___vectorcall] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1030),
    [anon_sym_static] = ACTIONS(1028),
    [anon_sym_auto] = ACTIONS(1028),
    [anon_sym_register] = ACTIONS(1028),
    [anon_sym_inline] = ACTIONS(1028),
    [anon_sym_const] = ACTIONS(1028),
    [anon_sym_volatile] = ACTIONS(1028),
    [anon_sym_restrict] = ACTIONS(1028),
    [anon_sym__Atomic] = ACTIONS(1028),
    [anon_sym_signed] = ACTIONS(1028),
    [anon_sym_unsigned] = ACTIONS(1028),
    [anon_sym_long] = ACTIONS(1028),
    [anon_sym_short] = ACTIONS(1028),
    [sym_primitive_type] = ACTIONS(1028),
    [anon_sym_enum] = ACTIONS(1028),
    [anon_sym_struct] = ACTIONS(1028),
    [anon_sym_union] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1028),
    [anon_sym_switch] = ACTIONS(1028),
    [anon_sym_case] = ACTIONS(1028),
    [anon_sym_default] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_goto] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1030),
    [anon_sym_sizeof] = ACTIONS(1028),
    [sym_number_literal] = ACTIONS(1030),
    [anon_sym_L_SQUOTE] = ACTIONS(1030),
    [anon_sym_u_SQUOTE] = ACTIONS(1030),
    [anon_sym_U_SQUOTE] = ACTIONS(1030),
    [anon_sym_u8_SQUOTE] = ACTIONS(1030),
    [anon_sym_SQUOTE] = ACTIONS(1030),
    [anon_sym_L_DQUOTE] = ACTIONS(1030),
    [anon_sym_u_DQUOTE] = ACTIONS(1030),
    [anon_sym_U_DQUOTE] = ACTIONS(1030),
    [anon_sym_u8_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [sym_true] = ACTIONS(1028),
    [sym_false] = ACTIONS(1028),
    [sym_null] = ACTIONS(1028),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_identifier] = ACTIONS(1032),
    [aux_sym_preproc_include_token1] = ACTIONS(1032),
    [aux_sym_preproc_def_token1] = ACTIONS(1032),
    [aux_sym_preproc_if_token1] = ACTIONS(1032),
    [aux_sym_preproc_if_token2] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1032),
    [aux_sym_preproc_else_token1] = ACTIONS(1032),
    [aux_sym_preproc_elif_token1] = ACTIONS(1032),
    [sym_preproc_directive] = ACTIONS(1032),
    [anon_sym_LPAREN2] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_STAR] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1034),
    [anon_sym_typedef] = ACTIONS(1032),
    [anon_sym_extern] = ACTIONS(1032),
    [anon_sym___attribute__] = ACTIONS(1032),
    [anon_sym___declspec] = ACTIONS(1032),
    [anon_sym___cdecl] = ACTIONS(1032),
    [anon_sym___clrcall] = ACTIONS(1032),
    [anon_sym___stdcall] = ACTIONS(1032),
    [anon_sym___fastcall] = ACTIONS(1032),
    [anon_sym___thiscall] = ACTIONS(1032),
    [anon_sym___vectorcall] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_static] = ACTIONS(1032),
    [anon_sym_auto] = ACTIONS(1032),
    [anon_sym_register] = ACTIONS(1032),
    [anon_sym_inline] = ACTIONS(1032),
    [anon_sym_const] = ACTIONS(1032),
    [anon_sym_volatile] = ACTIONS(1032),
    [anon_sym_restrict] = ACTIONS(1032),
    [anon_sym__Atomic] = ACTIONS(1032),
    [anon_sym_signed] = ACTIONS(1032),
    [anon_sym_unsigned] = ACTIONS(1032),
    [anon_sym_long] = ACTIONS(1032),
    [anon_sym_short] = ACTIONS(1032),
    [sym_primitive_type] = ACTIONS(1032),
    [anon_sym_enum] = ACTIONS(1032),
    [anon_sym_struct] = ACTIONS(1032),
    [anon_sym_union] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(1032),
    [anon_sym_default] = ACTIONS(1032),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_do] = ACTIONS(1032),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_goto] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1034),
    [anon_sym_PLUS_PLUS] = ACTIONS(1034),
    [anon_sym_sizeof] = ACTIONS(1032),
    [sym_number_literal] = ACTIONS(1034),
    [anon_sym_L_SQUOTE] = ACTIONS(1034),
    [anon_sym_u_SQUOTE] = ACTIONS(1034),
    [anon_sym_U_SQUOTE] = ACTIONS(1034),
    [anon_sym_u8_SQUOTE] = ACTIONS(1034),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [anon_sym_L_DQUOTE] = ACTIONS(1034),
    [anon_sym_u_DQUOTE] = ACTIONS(1034),
    [anon_sym_U_DQUOTE] = ACTIONS(1034),
    [anon_sym_u8_DQUOTE] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [sym_true] = ACTIONS(1032),
    [sym_false] = ACTIONS(1032),
    [sym_null] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [109] = {
    [sym_identifier] = ACTIONS(1036),
    [aux_sym_preproc_include_token1] = ACTIONS(1036),
    [aux_sym_preproc_def_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token2] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1036),
    [aux_sym_preproc_else_token1] = ACTIONS(1036),
    [aux_sym_preproc_elif_token1] = ACTIONS(1036),
    [sym_preproc_directive] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_typedef] = ACTIONS(1036),
    [anon_sym_extern] = ACTIONS(1036),
    [anon_sym___attribute__] = ACTIONS(1036),
    [anon_sym___declspec] = ACTIONS(1036),
    [anon_sym___cdecl] = ACTIONS(1036),
    [anon_sym___clrcall] = ACTIONS(1036),
    [anon_sym___stdcall] = ACTIONS(1036),
    [anon_sym___fastcall] = ACTIONS(1036),
    [anon_sym___thiscall] = ACTIONS(1036),
    [anon_sym___vectorcall] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_auto] = ACTIONS(1036),
    [anon_sym_register] = ACTIONS(1036),
    [anon_sym_inline] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_restrict] = ACTIONS(1036),
    [anon_sym__Atomic] = ACTIONS(1036),
    [anon_sym_signed] = ACTIONS(1036),
    [anon_sym_unsigned] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [sym_primitive_type] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_union] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_goto] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_sizeof] = ACTIONS(1036),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_L_SQUOTE] = ACTIONS(1038),
    [anon_sym_u_SQUOTE] = ACTIONS(1038),
    [anon_sym_U_SQUOTE] = ACTIONS(1038),
    [anon_sym_u8_SQUOTE] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_L_DQUOTE] = ACTIONS(1038),
    [anon_sym_u_DQUOTE] = ACTIONS(1038),
    [anon_sym_U_DQUOTE] = ACTIONS(1038),
    [anon_sym_u8_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
  },
  [110] = {
    [sym_identifier] = ACTIONS(1040),
    [aux_sym_preproc_include_token1] = ACTIONS(1040),
    [aux_sym_preproc_def_token1] = ACTIONS(1040),
    [aux_sym_preproc_if_token1] = ACTIONS(1040),
    [aux_sym_preproc_if_token2] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1040),
    [aux_sym_preproc_else_token1] = ACTIONS(1040),
    [aux_sym_preproc_elif_token1] = ACTIONS(1040),
    [sym_preproc_directive] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_typedef] = ACTIONS(1040),
    [anon_sym_extern] = ACTIONS(1040),
    [anon_sym___attribute__] = ACTIONS(1040),
    [anon_sym___declspec] = ACTIONS(1040),
    [anon_sym___cdecl] = ACTIONS(1040),
    [anon_sym___clrcall] = ACTIONS(1040),
    [anon_sym___stdcall] = ACTIONS(1040),
    [anon_sym___fastcall] = ACTIONS(1040),
    [anon_sym___thiscall] = ACTIONS(1040),
    [anon_sym___vectorcall] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1040),
    [anon_sym_auto] = ACTIONS(1040),
    [anon_sym_register] = ACTIONS(1040),
    [anon_sym_inline] = ACTIONS(1040),
    [anon_sym_const] = ACTIONS(1040),
    [anon_sym_volatile] = ACTIONS(1040),
    [anon_sym_restrict] = ACTIONS(1040),
    [anon_sym__Atomic] = ACTIONS(1040),
    [anon_sym_signed] = ACTIONS(1040),
    [anon_sym_unsigned] = ACTIONS(1040),
    [anon_sym_long] = ACTIONS(1040),
    [anon_sym_short] = ACTIONS(1040),
    [sym_primitive_type] = ACTIONS(1040),
    [anon_sym_enum] = ACTIONS(1040),
    [anon_sym_struct] = ACTIONS(1040),
    [anon_sym_union] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1040),
    [anon_sym_case] = ACTIONS(1040),
    [anon_sym_default] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_goto] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1042),
    [anon_sym_sizeof] = ACTIONS(1040),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_L_SQUOTE] = ACTIONS(1042),
    [anon_sym_u_SQUOTE] = ACTIONS(1042),
    [anon_sym_U_SQUOTE] = ACTIONS(1042),
    [anon_sym_u8_SQUOTE] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(1042),
    [anon_sym_L_DQUOTE] = ACTIONS(1042),
    [anon_sym_u_DQUOTE] = ACTIONS(1042),
    [anon_sym_U_DQUOTE] = ACTIONS(1042),
    [anon_sym_u8_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_identifier] = ACTIONS(1044),
    [aux_sym_preproc_include_token1] = ACTIONS(1044),
    [aux_sym_preproc_def_token1] = ACTIONS(1044),
    [aux_sym_preproc_if_token1] = ACTIONS(1044),
    [aux_sym_preproc_if_token2] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1044),
    [aux_sym_preproc_else_token1] = ACTIONS(1044),
    [aux_sym_preproc_elif_token1] = ACTIONS(1044),
    [sym_preproc_directive] = ACTIONS(1044),
    [anon_sym_LPAREN2] = ACTIONS(1046),
    [anon_sym_BANG] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1044),
    [anon_sym_STAR] = ACTIONS(1046),
    [anon_sym_AMP] = ACTIONS(1046),
    [anon_sym_SEMI] = ACTIONS(1046),
    [anon_sym_typedef] = ACTIONS(1044),
    [anon_sym_extern] = ACTIONS(1044),
    [anon_sym___attribute__] = ACTIONS(1044),
    [anon_sym___declspec] = ACTIONS(1044),
    [anon_sym___cdecl] = ACTIONS(1044),
    [anon_sym___clrcall] = ACTIONS(1044),
    [anon_sym___stdcall] = ACTIONS(1044),
    [anon_sym___fastcall] = ACTIONS(1044),
    [anon_sym___thiscall] = ACTIONS(1044),
    [anon_sym___vectorcall] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [anon_sym_static] = ACTIONS(1044),
    [anon_sym_auto] = ACTIONS(1044),
    [anon_sym_register] = ACTIONS(1044),
    [anon_sym_inline] = ACTIONS(1044),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym_signed] = ACTIONS(1044),
    [anon_sym_unsigned] = ACTIONS(1044),
    [anon_sym_long] = ACTIONS(1044),
    [anon_sym_short] = ACTIONS(1044),
    [sym_primitive_type] = ACTIONS(1044),
    [anon_sym_enum] = ACTIONS(1044),
    [anon_sym_struct] = ACTIONS(1044),
    [anon_sym_union] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1044),
    [anon_sym_switch] = ACTIONS(1044),
    [anon_sym_case] = ACTIONS(1044),
    [anon_sym_default] = ACTIONS(1044),
    [anon_sym_while] = ACTIONS(1044),
    [anon_sym_do] = ACTIONS(1044),
    [anon_sym_for] = ACTIONS(1044),
    [anon_sym_return] = ACTIONS(1044),
    [anon_sym_break] = ACTIONS(1044),
    [anon_sym_continue] = ACTIONS(1044),
    [anon_sym_goto] = ACTIONS(1044),
    [anon_sym_DASH_DASH] = ACTIONS(1046),
    [anon_sym_PLUS_PLUS] = ACTIONS(1046),
    [anon_sym_sizeof] = ACTIONS(1044),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_L_SQUOTE] = ACTIONS(1046),
    [anon_sym_u_SQUOTE] = ACTIONS(1046),
    [anon_sym_U_SQUOTE] = ACTIONS(1046),
    [anon_sym_u8_SQUOTE] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(1046),
    [anon_sym_L_DQUOTE] = ACTIONS(1046),
    [anon_sym_u_DQUOTE] = ACTIONS(1046),
    [anon_sym_U_DQUOTE] = ACTIONS(1046),
    [anon_sym_u8_DQUOTE] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_comment] = ACTIONS(3),
  },
  [112] = {
    [sym_identifier] = ACTIONS(1048),
    [aux_sym_preproc_include_token1] = ACTIONS(1048),
    [aux_sym_preproc_def_token1] = ACTIONS(1048),
    [aux_sym_preproc_if_token1] = ACTIONS(1048),
    [aux_sym_preproc_if_token2] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1048),
    [aux_sym_preproc_else_token1] = ACTIONS(1048),
    [aux_sym_preproc_elif_token1] = ACTIONS(1048),
    [sym_preproc_directive] = ACTIONS(1048),
    [anon_sym_LPAREN2] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1048),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(1050),
    [anon_sym_SEMI] = ACTIONS(1050),
    [anon_sym_typedef] = ACTIONS(1048),
    [anon_sym_extern] = ACTIONS(1048),
    [anon_sym___attribute__] = ACTIONS(1048),
    [anon_sym___declspec] = ACTIONS(1048),
    [anon_sym___cdecl] = ACTIONS(1048),
    [anon_sym___clrcall] = ACTIONS(1048),
    [anon_sym___stdcall] = ACTIONS(1048),
    [anon_sym___fastcall] = ACTIONS(1048),
    [anon_sym___thiscall] = ACTIONS(1048),
    [anon_sym___vectorcall] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_static] = ACTIONS(1048),
    [anon_sym_auto] = ACTIONS(1048),
    [anon_sym_register] = ACTIONS(1048),
    [anon_sym_inline] = ACTIONS(1048),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_volatile] = ACTIONS(1048),
    [anon_sym_restrict] = ACTIONS(1048),
    [anon_sym__Atomic] = ACTIONS(1048),
    [anon_sym_signed] = ACTIONS(1048),
    [anon_sym_unsigned] = ACTIONS(1048),
    [anon_sym_long] = ACTIONS(1048),
    [anon_sym_short] = ACTIONS(1048),
    [sym_primitive_type] = ACTIONS(1048),
    [anon_sym_enum] = ACTIONS(1048),
    [anon_sym_struct] = ACTIONS(1048),
    [anon_sym_union] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1048),
    [anon_sym_switch] = ACTIONS(1048),
    [anon_sym_case] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1048),
    [anon_sym_while] = ACTIONS(1048),
    [anon_sym_do] = ACTIONS(1048),
    [anon_sym_for] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [anon_sym_goto] = ACTIONS(1048),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [anon_sym_sizeof] = ACTIONS(1048),
    [sym_number_literal] = ACTIONS(1050),
    [anon_sym_L_SQUOTE] = ACTIONS(1050),
    [anon_sym_u_SQUOTE] = ACTIONS(1050),
    [anon_sym_U_SQUOTE] = ACTIONS(1050),
    [anon_sym_u8_SQUOTE] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [anon_sym_L_DQUOTE] = ACTIONS(1050),
    [anon_sym_u_DQUOTE] = ACTIONS(1050),
    [anon_sym_U_DQUOTE] = ACTIONS(1050),
    [anon_sym_u8_DQUOTE] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_identifier] = ACTIONS(1052),
    [aux_sym_preproc_include_token1] = ACTIONS(1052),
    [aux_sym_preproc_def_token1] = ACTIONS(1052),
    [aux_sym_preproc_if_token1] = ACTIONS(1052),
    [aux_sym_preproc_if_token2] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1052),
    [aux_sym_preproc_else_token1] = ACTIONS(1052),
    [aux_sym_preproc_elif_token1] = ACTIONS(1052),
    [sym_preproc_directive] = ACTIONS(1052),
    [anon_sym_LPAREN2] = ACTIONS(1054),
    [anon_sym_BANG] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(1054),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_STAR] = ACTIONS(1054),
    [anon_sym_AMP] = ACTIONS(1054),
    [anon_sym_SEMI] = ACTIONS(1054),
    [anon_sym_typedef] = ACTIONS(1052),
    [anon_sym_extern] = ACTIONS(1052),
    [anon_sym___attribute__] = ACTIONS(1052),
    [anon_sym___declspec] = ACTIONS(1052),
    [anon_sym___cdecl] = ACTIONS(1052),
    [anon_sym___clrcall] = ACTIONS(1052),
    [anon_sym___stdcall] = ACTIONS(1052),
    [anon_sym___fastcall] = ACTIONS(1052),
    [anon_sym___thiscall] = ACTIONS(1052),
    [anon_sym___vectorcall] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_static] = ACTIONS(1052),
    [anon_sym_auto] = ACTIONS(1052),
    [anon_sym_register] = ACTIONS(1052),
    [anon_sym_inline] = ACTIONS(1052),
    [anon_sym_const] = ACTIONS(1052),
    [anon_sym_volatile] = ACTIONS(1052),
    [anon_sym_restrict] = ACTIONS(1052),
    [anon_sym__Atomic] = ACTIONS(1052),
    [anon_sym_signed] = ACTIONS(1052),
    [anon_sym_unsigned] = ACTIONS(1052),
    [anon_sym_long] = ACTIONS(1052),
    [anon_sym_short] = ACTIONS(1052),
    [sym_primitive_type] = ACTIONS(1052),
    [anon_sym_enum] = ACTIONS(1052),
    [anon_sym_struct] = ACTIONS(1052),
    [anon_sym_union] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1052),
    [anon_sym_switch] = ACTIONS(1052),
    [anon_sym_case] = ACTIONS(1052),
    [anon_sym_default] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_do] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_goto] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_PLUS_PLUS] = ACTIONS(1054),
    [anon_sym_sizeof] = ACTIONS(1052),
    [sym_number_literal] = ACTIONS(1054),
    [anon_sym_L_SQUOTE] = ACTIONS(1054),
    [anon_sym_u_SQUOTE] = ACTIONS(1054),
    [anon_sym_U_SQUOTE] = ACTIONS(1054),
    [anon_sym_u8_SQUOTE] = ACTIONS(1054),
    [anon_sym_SQUOTE] = ACTIONS(1054),
    [anon_sym_L_DQUOTE] = ACTIONS(1054),
    [anon_sym_u_DQUOTE] = ACTIONS(1054),
    [anon_sym_U_DQUOTE] = ACTIONS(1054),
    [anon_sym_u8_DQUOTE] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [sym_true] = ACTIONS(1052),
    [sym_false] = ACTIONS(1052),
    [sym_null] = ACTIONS(1052),
    [sym_comment] = ACTIONS(3),
  },
  [114] = {
    [sym_identifier] = ACTIONS(1056),
    [aux_sym_preproc_include_token1] = ACTIONS(1056),
    [aux_sym_preproc_def_token1] = ACTIONS(1056),
    [aux_sym_preproc_if_token1] = ACTIONS(1056),
    [aux_sym_preproc_if_token2] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1056),
    [aux_sym_preproc_else_token1] = ACTIONS(1056),
    [aux_sym_preproc_elif_token1] = ACTIONS(1056),
    [sym_preproc_directive] = ACTIONS(1056),
    [anon_sym_LPAREN2] = ACTIONS(1058),
    [anon_sym_BANG] = ACTIONS(1058),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1056),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_AMP] = ACTIONS(1058),
    [anon_sym_SEMI] = ACTIONS(1058),
    [anon_sym_typedef] = ACTIONS(1056),
    [anon_sym_extern] = ACTIONS(1056),
    [anon_sym___attribute__] = ACTIONS(1056),
    [anon_sym___declspec] = ACTIONS(1056),
    [anon_sym___cdecl] = ACTIONS(1056),
    [anon_sym___clrcall] = ACTIONS(1056),
    [anon_sym___stdcall] = ACTIONS(1056),
    [anon_sym___fastcall] = ACTIONS(1056),
    [anon_sym___thiscall] = ACTIONS(1056),
    [anon_sym___vectorcall] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_auto] = ACTIONS(1056),
    [anon_sym_register] = ACTIONS(1056),
    [anon_sym_inline] = ACTIONS(1056),
    [anon_sym_const] = ACTIONS(1056),
    [anon_sym_volatile] = ACTIONS(1056),
    [anon_sym_restrict] = ACTIONS(1056),
    [anon_sym__Atomic] = ACTIONS(1056),
    [anon_sym_signed] = ACTIONS(1056),
    [anon_sym_unsigned] = ACTIONS(1056),
    [anon_sym_long] = ACTIONS(1056),
    [anon_sym_short] = ACTIONS(1056),
    [sym_primitive_type] = ACTIONS(1056),
    [anon_sym_enum] = ACTIONS(1056),
    [anon_sym_struct] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_switch] = ACTIONS(1056),
    [anon_sym_case] = ACTIONS(1056),
    [anon_sym_default] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_do] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_goto] = ACTIONS(1056),
    [anon_sym_DASH_DASH] = ACTIONS(1058),
    [anon_sym_PLUS_PLUS] = ACTIONS(1058),
    [anon_sym_sizeof] = ACTIONS(1056),
    [sym_number_literal] = ACTIONS(1058),
    [anon_sym_L_SQUOTE] = ACTIONS(1058),
    [anon_sym_u_SQUOTE] = ACTIONS(1058),
    [anon_sym_U_SQUOTE] = ACTIONS(1058),
    [anon_sym_u8_SQUOTE] = ACTIONS(1058),
    [anon_sym_SQUOTE] = ACTIONS(1058),
    [anon_sym_L_DQUOTE] = ACTIONS(1058),
    [anon_sym_u_DQUOTE] = ACTIONS(1058),
    [anon_sym_U_DQUOTE] = ACTIONS(1058),
    [anon_sym_u8_DQUOTE] = ACTIONS(1058),
    [anon_sym_DQUOTE] = ACTIONS(1058),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_null] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_identifier] = ACTIONS(1060),
    [aux_sym_preproc_include_token1] = ACTIONS(1060),
    [aux_sym_preproc_def_token1] = ACTIONS(1060),
    [aux_sym_preproc_if_token1] = ACTIONS(1060),
    [aux_sym_preproc_if_token2] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1060),
    [aux_sym_preproc_else_token1] = ACTIONS(1060),
    [aux_sym_preproc_elif_token1] = ACTIONS(1060),
    [sym_preproc_directive] = ACTIONS(1060),
    [anon_sym_LPAREN2] = ACTIONS(1062),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_AMP] = ACTIONS(1062),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_typedef] = ACTIONS(1060),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym___attribute__] = ACTIONS(1060),
    [anon_sym___declspec] = ACTIONS(1060),
    [anon_sym___cdecl] = ACTIONS(1060),
    [anon_sym___clrcall] = ACTIONS(1060),
    [anon_sym___stdcall] = ACTIONS(1060),
    [anon_sym___fastcall] = ACTIONS(1060),
    [anon_sym___thiscall] = ACTIONS(1060),
    [anon_sym___vectorcall] = ACTIONS(1060),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1060),
    [anon_sym_auto] = ACTIONS(1060),
    [anon_sym_register] = ACTIONS(1060),
    [anon_sym_inline] = ACTIONS(1060),
    [anon_sym_const] = ACTIONS(1060),
    [anon_sym_volatile] = ACTIONS(1060),
    [anon_sym_restrict] = ACTIONS(1060),
    [anon_sym__Atomic] = ACTIONS(1060),
    [anon_sym_signed] = ACTIONS(1060),
    [anon_sym_unsigned] = ACTIONS(1060),
    [anon_sym_long] = ACTIONS(1060),
    [anon_sym_short] = ACTIONS(1060),
    [sym_primitive_type] = ACTIONS(1060),
    [anon_sym_enum] = ACTIONS(1060),
    [anon_sym_struct] = ACTIONS(1060),
    [anon_sym_union] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_switch] = ACTIONS(1060),
    [anon_sym_case] = ACTIONS(1060),
    [anon_sym_default] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_do] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_goto] = ACTIONS(1060),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_sizeof] = ACTIONS(1060),
    [sym_number_literal] = ACTIONS(1062),
    [anon_sym_L_SQUOTE] = ACTIONS(1062),
    [anon_sym_u_SQUOTE] = ACTIONS(1062),
    [anon_sym_U_SQUOTE] = ACTIONS(1062),
    [anon_sym_u8_SQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [anon_sym_L_DQUOTE] = ACTIONS(1062),
    [anon_sym_u_DQUOTE] = ACTIONS(1062),
    [anon_sym_U_DQUOTE] = ACTIONS(1062),
    [anon_sym_u8_DQUOTE] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_null] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
  },
  [116] = {
    [sym_identifier] = ACTIONS(1064),
    [aux_sym_preproc_include_token1] = ACTIONS(1064),
    [aux_sym_preproc_def_token1] = ACTIONS(1064),
    [aux_sym_preproc_if_token1] = ACTIONS(1064),
    [aux_sym_preproc_if_token2] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1064),
    [aux_sym_preproc_else_token1] = ACTIONS(1064),
    [aux_sym_preproc_elif_token1] = ACTIONS(1064),
    [sym_preproc_directive] = ACTIONS(1064),
    [anon_sym_LPAREN2] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_AMP] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1066),
    [anon_sym_typedef] = ACTIONS(1064),
    [anon_sym_extern] = ACTIONS(1064),
    [anon_sym___attribute__] = ACTIONS(1064),
    [anon_sym___declspec] = ACTIONS(1064),
    [anon_sym___cdecl] = ACTIONS(1064),
    [anon_sym___clrcall] = ACTIONS(1064),
    [anon_sym___stdcall] = ACTIONS(1064),
    [anon_sym___fastcall] = ACTIONS(1064),
    [anon_sym___thiscall] = ACTIONS(1064),
    [anon_sym___vectorcall] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_auto] = ACTIONS(1064),
    [anon_sym_register] = ACTIONS(1064),
    [anon_sym_inline] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_volatile] = ACTIONS(1064),
    [anon_sym_restrict] = ACTIONS(1064),
    [anon_sym__Atomic] = ACTIONS(1064),
    [anon_sym_signed] = ACTIONS(1064),
    [anon_sym_unsigned] = ACTIONS(1064),
    [anon_sym_long] = ACTIONS(1064),
    [anon_sym_short] = ACTIONS(1064),
    [sym_primitive_type] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [anon_sym_struct] = ACTIONS(1064),
    [anon_sym_union] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_goto] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1064),
    [sym_number_literal] = ACTIONS(1066),
    [anon_sym_L_SQUOTE] = ACTIONS(1066),
    [anon_sym_u_SQUOTE] = ACTIONS(1066),
    [anon_sym_U_SQUOTE] = ACTIONS(1066),
    [anon_sym_u8_SQUOTE] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [anon_sym_L_DQUOTE] = ACTIONS(1066),
    [anon_sym_u_DQUOTE] = ACTIONS(1066),
    [anon_sym_U_DQUOTE] = ACTIONS(1066),
    [anon_sym_u8_DQUOTE] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_identifier] = ACTIONS(1068),
    [aux_sym_preproc_include_token1] = ACTIONS(1068),
    [aux_sym_preproc_def_token1] = ACTIONS(1068),
    [aux_sym_preproc_if_token1] = ACTIONS(1068),
    [aux_sym_preproc_if_token2] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1068),
    [aux_sym_preproc_else_token1] = ACTIONS(1068),
    [aux_sym_preproc_elif_token1] = ACTIONS(1068),
    [sym_preproc_directive] = ACTIONS(1068),
    [anon_sym_LPAREN2] = ACTIONS(1070),
    [anon_sym_BANG] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_typedef] = ACTIONS(1068),
    [anon_sym_extern] = ACTIONS(1068),
    [anon_sym___attribute__] = ACTIONS(1068),
    [anon_sym___declspec] = ACTIONS(1068),
    [anon_sym___cdecl] = ACTIONS(1068),
    [anon_sym___clrcall] = ACTIONS(1068),
    [anon_sym___stdcall] = ACTIONS(1068),
    [anon_sym___fastcall] = ACTIONS(1068),
    [anon_sym___thiscall] = ACTIONS(1068),
    [anon_sym___vectorcall] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_static] = ACTIONS(1068),
    [anon_sym_auto] = ACTIONS(1068),
    [anon_sym_register] = ACTIONS(1068),
    [anon_sym_inline] = ACTIONS(1068),
    [anon_sym_const] = ACTIONS(1068),
    [anon_sym_volatile] = ACTIONS(1068),
    [anon_sym_restrict] = ACTIONS(1068),
    [anon_sym__Atomic] = ACTIONS(1068),
    [anon_sym_signed] = ACTIONS(1068),
    [anon_sym_unsigned] = ACTIONS(1068),
    [anon_sym_long] = ACTIONS(1068),
    [anon_sym_short] = ACTIONS(1068),
    [sym_primitive_type] = ACTIONS(1068),
    [anon_sym_enum] = ACTIONS(1068),
    [anon_sym_struct] = ACTIONS(1068),
    [anon_sym_union] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_switch] = ACTIONS(1068),
    [anon_sym_case] = ACTIONS(1068),
    [anon_sym_default] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_do] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_goto] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1070),
    [anon_sym_PLUS_PLUS] = ACTIONS(1070),
    [anon_sym_sizeof] = ACTIONS(1068),
    [sym_number_literal] = ACTIONS(1070),
    [anon_sym_L_SQUOTE] = ACTIONS(1070),
    [anon_sym_u_SQUOTE] = ACTIONS(1070),
    [anon_sym_U_SQUOTE] = ACTIONS(1070),
    [anon_sym_u8_SQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [anon_sym_L_DQUOTE] = ACTIONS(1070),
    [anon_sym_u_DQUOTE] = ACTIONS(1070),
    [anon_sym_U_DQUOTE] = ACTIONS(1070),
    [anon_sym_u8_DQUOTE] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_null] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_identifier] = ACTIONS(1072),
    [aux_sym_preproc_include_token1] = ACTIONS(1072),
    [aux_sym_preproc_def_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token2] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1072),
    [aux_sym_preproc_else_token1] = ACTIONS(1072),
    [aux_sym_preproc_elif_token1] = ACTIONS(1072),
    [sym_preproc_directive] = ACTIONS(1072),
    [anon_sym_LPAREN2] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_typedef] = ACTIONS(1072),
    [anon_sym_extern] = ACTIONS(1072),
    [anon_sym___attribute__] = ACTIONS(1072),
    [anon_sym___declspec] = ACTIONS(1072),
    [anon_sym___cdecl] = ACTIONS(1072),
    [anon_sym___clrcall] = ACTIONS(1072),
    [anon_sym___stdcall] = ACTIONS(1072),
    [anon_sym___fastcall] = ACTIONS(1072),
    [anon_sym___thiscall] = ACTIONS(1072),
    [anon_sym___vectorcall] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_auto] = ACTIONS(1072),
    [anon_sym_register] = ACTIONS(1072),
    [anon_sym_inline] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_volatile] = ACTIONS(1072),
    [anon_sym_restrict] = ACTIONS(1072),
    [anon_sym__Atomic] = ACTIONS(1072),
    [anon_sym_signed] = ACTIONS(1072),
    [anon_sym_unsigned] = ACTIONS(1072),
    [anon_sym_long] = ACTIONS(1072),
    [anon_sym_short] = ACTIONS(1072),
    [sym_primitive_type] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1072),
    [anon_sym_union] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1072),
    [anon_sym_default] = ACTIONS(1072),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_do] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_goto] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_sizeof] = ACTIONS(1072),
    [sym_number_literal] = ACTIONS(1074),
    [anon_sym_L_SQUOTE] = ACTIONS(1074),
    [anon_sym_u_SQUOTE] = ACTIONS(1074),
    [anon_sym_U_SQUOTE] = ACTIONS(1074),
    [anon_sym_u8_SQUOTE] = ACTIONS(1074),
    [anon_sym_SQUOTE] = ACTIONS(1074),
    [anon_sym_L_DQUOTE] = ACTIONS(1074),
    [anon_sym_u_DQUOTE] = ACTIONS(1074),
    [anon_sym_U_DQUOTE] = ACTIONS(1074),
    [anon_sym_u8_DQUOTE] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_null] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_identifier] = ACTIONS(1076),
    [aux_sym_preproc_include_token1] = ACTIONS(1076),
    [aux_sym_preproc_def_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token2] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1076),
    [aux_sym_preproc_else_token1] = ACTIONS(1076),
    [aux_sym_preproc_elif_token1] = ACTIONS(1076),
    [sym_preproc_directive] = ACTIONS(1076),
    [anon_sym_LPAREN2] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1078),
    [anon_sym_typedef] = ACTIONS(1076),
    [anon_sym_extern] = ACTIONS(1076),
    [anon_sym___attribute__] = ACTIONS(1076),
    [anon_sym___declspec] = ACTIONS(1076),
    [anon_sym___cdecl] = ACTIONS(1076),
    [anon_sym___clrcall] = ACTIONS(1076),
    [anon_sym___stdcall] = ACTIONS(1076),
    [anon_sym___fastcall] = ACTIONS(1076),
    [anon_sym___thiscall] = ACTIONS(1076),
    [anon_sym___vectorcall] = ACTIONS(1076),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_auto] = ACTIONS(1076),
    [anon_sym_register] = ACTIONS(1076),
    [anon_sym_inline] = ACTIONS(1076),
    [anon_sym_const] = ACTIONS(1076),
    [anon_sym_volatile] = ACTIONS(1076),
    [anon_sym_restrict] = ACTIONS(1076),
    [anon_sym__Atomic] = ACTIONS(1076),
    [anon_sym_signed] = ACTIONS(1076),
    [anon_sym_unsigned] = ACTIONS(1076),
    [anon_sym_long] = ACTIONS(1076),
    [anon_sym_short] = ACTIONS(1076),
    [sym_primitive_type] = ACTIONS(1076),
    [anon_sym_enum] = ACTIONS(1076),
    [anon_sym_struct] = ACTIONS(1076),
    [anon_sym_union] = ACTIONS(1076),
    [anon_sym_if] = ACTIONS(1076),
    [anon_sym_switch] = ACTIONS(1076),
    [anon_sym_case] = ACTIONS(1076),
    [anon_sym_default] = ACTIONS(1076),
    [anon_sym_while] = ACTIONS(1076),
    [anon_sym_do] = ACTIONS(1076),
    [anon_sym_for] = ACTIONS(1076),
    [anon_sym_return] = ACTIONS(1076),
    [anon_sym_break] = ACTIONS(1076),
    [anon_sym_continue] = ACTIONS(1076),
    [anon_sym_goto] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1078),
    [anon_sym_sizeof] = ACTIONS(1076),
    [sym_number_literal] = ACTIONS(1078),
    [anon_sym_L_SQUOTE] = ACTIONS(1078),
    [anon_sym_u_SQUOTE] = ACTIONS(1078),
    [anon_sym_U_SQUOTE] = ACTIONS(1078),
    [anon_sym_u8_SQUOTE] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [anon_sym_L_DQUOTE] = ACTIONS(1078),
    [anon_sym_u_DQUOTE] = ACTIONS(1078),
    [anon_sym_U_DQUOTE] = ACTIONS(1078),
    [anon_sym_u8_DQUOTE] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [sym_true] = ACTIONS(1076),
    [sym_false] = ACTIONS(1076),
    [sym_null] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_identifier] = ACTIONS(1080),
    [aux_sym_preproc_include_token1] = ACTIONS(1080),
    [aux_sym_preproc_def_token1] = ACTIONS(1080),
    [aux_sym_preproc_if_token1] = ACTIONS(1080),
    [aux_sym_preproc_if_token2] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1080),
    [aux_sym_preproc_else_token1] = ACTIONS(1080),
    [aux_sym_preproc_elif_token1] = ACTIONS(1080),
    [sym_preproc_directive] = ACTIONS(1080),
    [anon_sym_LPAREN2] = ACTIONS(1082),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1082),
    [anon_sym_AMP] = ACTIONS(1082),
    [anon_sym_SEMI] = ACTIONS(1082),
    [anon_sym_typedef] = ACTIONS(1080),
    [anon_sym_extern] = ACTIONS(1080),
    [anon_sym___attribute__] = ACTIONS(1080),
    [anon_sym___declspec] = ACTIONS(1080),
    [anon_sym___cdecl] = ACTIONS(1080),
    [anon_sym___clrcall] = ACTIONS(1080),
    [anon_sym___stdcall] = ACTIONS(1080),
    [anon_sym___fastcall] = ACTIONS(1080),
    [anon_sym___thiscall] = ACTIONS(1080),
    [anon_sym___vectorcall] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1082),
    [anon_sym_static] = ACTIONS(1080),
    [anon_sym_auto] = ACTIONS(1080),
    [anon_sym_register] = ACTIONS(1080),
    [anon_sym_inline] = ACTIONS(1080),
    [anon_sym_const] = ACTIONS(1080),
    [anon_sym_volatile] = ACTIONS(1080),
    [anon_sym_restrict] = ACTIONS(1080),
    [anon_sym__Atomic] = ACTIONS(1080),
    [anon_sym_signed] = ACTIONS(1080),
    [anon_sym_unsigned] = ACTIONS(1080),
    [anon_sym_long] = ACTIONS(1080),
    [anon_sym_short] = ACTIONS(1080),
    [sym_primitive_type] = ACTIONS(1080),
    [anon_sym_enum] = ACTIONS(1080),
    [anon_sym_struct] = ACTIONS(1080),
    [anon_sym_union] = ACTIONS(1080),
    [anon_sym_if] = ACTIONS(1080),
    [anon_sym_switch] = ACTIONS(1080),
    [anon_sym_case] = ACTIONS(1080),
    [anon_sym_default] = ACTIONS(1080),
    [anon_sym_while] = ACTIONS(1080),
    [anon_sym_do] = ACTIONS(1080),
    [anon_sym_for] = ACTIONS(1080),
    [anon_sym_return] = ACTIONS(1080),
    [anon_sym_break] = ACTIONS(1080),
    [anon_sym_continue] = ACTIONS(1080),
    [anon_sym_goto] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1082),
    [anon_sym_PLUS_PLUS] = ACTIONS(1082),
    [anon_sym_sizeof] = ACTIONS(1080),
    [sym_number_literal] = ACTIONS(1082),
    [anon_sym_L_SQUOTE] = ACTIONS(1082),
    [anon_sym_u_SQUOTE] = ACTIONS(1082),
    [anon_sym_U_SQUOTE] = ACTIONS(1082),
    [anon_sym_u8_SQUOTE] = ACTIONS(1082),
    [anon_sym_SQUOTE] = ACTIONS(1082),
    [anon_sym_L_DQUOTE] = ACTIONS(1082),
    [anon_sym_u_DQUOTE] = ACTIONS(1082),
    [anon_sym_U_DQUOTE] = ACTIONS(1082),
    [anon_sym_u8_DQUOTE] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1082),
    [sym_true] = ACTIONS(1080),
    [sym_false] = ACTIONS(1080),
    [sym_null] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_identifier] = ACTIONS(1084),
    [aux_sym_preproc_include_token1] = ACTIONS(1084),
    [aux_sym_preproc_def_token1] = ACTIONS(1084),
    [aux_sym_preproc_if_token1] = ACTIONS(1084),
    [aux_sym_preproc_if_token2] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1084),
    [aux_sym_preproc_else_token1] = ACTIONS(1084),
    [aux_sym_preproc_elif_token1] = ACTIONS(1084),
    [sym_preproc_directive] = ACTIONS(1084),
    [anon_sym_LPAREN2] = ACTIONS(1086),
    [anon_sym_BANG] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_STAR] = ACTIONS(1086),
    [anon_sym_AMP] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_typedef] = ACTIONS(1084),
    [anon_sym_extern] = ACTIONS(1084),
    [anon_sym___attribute__] = ACTIONS(1084),
    [anon_sym___declspec] = ACTIONS(1084),
    [anon_sym___cdecl] = ACTIONS(1084),
    [anon_sym___clrcall] = ACTIONS(1084),
    [anon_sym___stdcall] = ACTIONS(1084),
    [anon_sym___fastcall] = ACTIONS(1084),
    [anon_sym___thiscall] = ACTIONS(1084),
    [anon_sym___vectorcall] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_static] = ACTIONS(1084),
    [anon_sym_auto] = ACTIONS(1084),
    [anon_sym_register] = ACTIONS(1084),
    [anon_sym_inline] = ACTIONS(1084),
    [anon_sym_const] = ACTIONS(1084),
    [anon_sym_volatile] = ACTIONS(1084),
    [anon_sym_restrict] = ACTIONS(1084),
    [anon_sym__Atomic] = ACTIONS(1084),
    [anon_sym_signed] = ACTIONS(1084),
    [anon_sym_unsigned] = ACTIONS(1084),
    [anon_sym_long] = ACTIONS(1084),
    [anon_sym_short] = ACTIONS(1084),
    [sym_primitive_type] = ACTIONS(1084),
    [anon_sym_enum] = ACTIONS(1084),
    [anon_sym_struct] = ACTIONS(1084),
    [anon_sym_union] = ACTIONS(1084),
    [anon_sym_if] = ACTIONS(1084),
    [anon_sym_switch] = ACTIONS(1084),
    [anon_sym_case] = ACTIONS(1084),
    [anon_sym_default] = ACTIONS(1084),
    [anon_sym_while] = ACTIONS(1084),
    [anon_sym_do] = ACTIONS(1084),
    [anon_sym_for] = ACTIONS(1084),
    [anon_sym_return] = ACTIONS(1084),
    [anon_sym_break] = ACTIONS(1084),
    [anon_sym_continue] = ACTIONS(1084),
    [anon_sym_goto] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1084),
    [sym_number_literal] = ACTIONS(1086),
    [anon_sym_L_SQUOTE] = ACTIONS(1086),
    [anon_sym_u_SQUOTE] = ACTIONS(1086),
    [anon_sym_U_SQUOTE] = ACTIONS(1086),
    [anon_sym_u8_SQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1086),
    [anon_sym_L_DQUOTE] = ACTIONS(1086),
    [anon_sym_u_DQUOTE] = ACTIONS(1086),
    [anon_sym_U_DQUOTE] = ACTIONS(1086),
    [anon_sym_u8_DQUOTE] = ACTIONS(1086),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [sym_true] = ACTIONS(1084),
    [sym_false] = ACTIONS(1084),
    [sym_null] = ACTIONS(1084),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_identifier] = ACTIONS(1088),
    [aux_sym_preproc_include_token1] = ACTIONS(1088),
    [aux_sym_preproc_def_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token2] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1088),
    [aux_sym_preproc_else_token1] = ACTIONS(1088),
    [aux_sym_preproc_elif_token1] = ACTIONS(1088),
    [sym_preproc_directive] = ACTIONS(1088),
    [anon_sym_LPAREN2] = ACTIONS(1090),
    [anon_sym_BANG] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_STAR] = ACTIONS(1090),
    [anon_sym_AMP] = ACTIONS(1090),
    [anon_sym_SEMI] = ACTIONS(1090),
    [anon_sym_typedef] = ACTIONS(1088),
    [anon_sym_extern] = ACTIONS(1088),
    [anon_sym___attribute__] = ACTIONS(1088),
    [anon_sym___declspec] = ACTIONS(1088),
    [anon_sym___cdecl] = ACTIONS(1088),
    [anon_sym___clrcall] = ACTIONS(1088),
    [anon_sym___stdcall] = ACTIONS(1088),
    [anon_sym___fastcall] = ACTIONS(1088),
    [anon_sym___thiscall] = ACTIONS(1088),
    [anon_sym___vectorcall] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_static] = ACTIONS(1088),
    [anon_sym_auto] = ACTIONS(1088),
    [anon_sym_register] = ACTIONS(1088),
    [anon_sym_inline] = ACTIONS(1088),
    [anon_sym_const] = ACTIONS(1088),
    [anon_sym_volatile] = ACTIONS(1088),
    [anon_sym_restrict] = ACTIONS(1088),
    [anon_sym__Atomic] = ACTIONS(1088),
    [anon_sym_signed] = ACTIONS(1088),
    [anon_sym_unsigned] = ACTIONS(1088),
    [anon_sym_long] = ACTIONS(1088),
    [anon_sym_short] = ACTIONS(1088),
    [sym_primitive_type] = ACTIONS(1088),
    [anon_sym_enum] = ACTIONS(1088),
    [anon_sym_struct] = ACTIONS(1088),
    [anon_sym_union] = ACTIONS(1088),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(1088),
    [anon_sym_case] = ACTIONS(1088),
    [anon_sym_default] = ACTIONS(1088),
    [anon_sym_while] = ACTIONS(1088),
    [anon_sym_do] = ACTIONS(1088),
    [anon_sym_for] = ACTIONS(1088),
    [anon_sym_return] = ACTIONS(1088),
    [anon_sym_break] = ACTIONS(1088),
    [anon_sym_continue] = ACTIONS(1088),
    [anon_sym_goto] = ACTIONS(1088),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_sizeof] = ACTIONS(1088),
    [sym_number_literal] = ACTIONS(1090),
    [anon_sym_L_SQUOTE] = ACTIONS(1090),
    [anon_sym_u_SQUOTE] = ACTIONS(1090),
    [anon_sym_U_SQUOTE] = ACTIONS(1090),
    [anon_sym_u8_SQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [anon_sym_L_DQUOTE] = ACTIONS(1090),
    [anon_sym_u_DQUOTE] = ACTIONS(1090),
    [anon_sym_U_DQUOTE] = ACTIONS(1090),
    [anon_sym_u8_DQUOTE] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [sym_true] = ACTIONS(1088),
    [sym_false] = ACTIONS(1088),
    [sym_null] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_identifier] = ACTIONS(1092),
    [aux_sym_preproc_include_token1] = ACTIONS(1092),
    [aux_sym_preproc_def_token1] = ACTIONS(1092),
    [aux_sym_preproc_if_token1] = ACTIONS(1092),
    [aux_sym_preproc_if_token2] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1092),
    [aux_sym_preproc_else_token1] = ACTIONS(1092),
    [aux_sym_preproc_elif_token1] = ACTIONS(1092),
    [sym_preproc_directive] = ACTIONS(1092),
    [anon_sym_LPAREN2] = ACTIONS(1094),
    [anon_sym_BANG] = ACTIONS(1094),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1094),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_SEMI] = ACTIONS(1094),
    [anon_sym_typedef] = ACTIONS(1092),
    [anon_sym_extern] = ACTIONS(1092),
    [anon_sym___attribute__] = ACTIONS(1092),
    [anon_sym___declspec] = ACTIONS(1092),
    [anon_sym___cdecl] = ACTIONS(1092),
    [anon_sym___clrcall] = ACTIONS(1092),
    [anon_sym___stdcall] = ACTIONS(1092),
    [anon_sym___fastcall] = ACTIONS(1092),
    [anon_sym___thiscall] = ACTIONS(1092),
    [anon_sym___vectorcall] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_static] = ACTIONS(1092),
    [anon_sym_auto] = ACTIONS(1092),
    [anon_sym_register] = ACTIONS(1092),
    [anon_sym_inline] = ACTIONS(1092),
    [anon_sym_const] = ACTIONS(1092),
    [anon_sym_volatile] = ACTIONS(1092),
    [anon_sym_restrict] = ACTIONS(1092),
    [anon_sym__Atomic] = ACTIONS(1092),
    [anon_sym_signed] = ACTIONS(1092),
    [anon_sym_unsigned] = ACTIONS(1092),
    [anon_sym_long] = ACTIONS(1092),
    [anon_sym_short] = ACTIONS(1092),
    [sym_primitive_type] = ACTIONS(1092),
    [anon_sym_enum] = ACTIONS(1092),
    [anon_sym_struct] = ACTIONS(1092),
    [anon_sym_union] = ACTIONS(1092),
    [anon_sym_if] = ACTIONS(1092),
    [anon_sym_switch] = ACTIONS(1092),
    [anon_sym_case] = ACTIONS(1092),
    [anon_sym_default] = ACTIONS(1092),
    [anon_sym_while] = ACTIONS(1092),
    [anon_sym_do] = ACTIONS(1092),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(1092),
    [anon_sym_break] = ACTIONS(1092),
    [anon_sym_continue] = ACTIONS(1092),
    [anon_sym_goto] = ACTIONS(1092),
    [anon_sym_DASH_DASH] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1094),
    [anon_sym_sizeof] = ACTIONS(1092),
    [sym_number_literal] = ACTIONS(1094),
    [anon_sym_L_SQUOTE] = ACTIONS(1094),
    [anon_sym_u_SQUOTE] = ACTIONS(1094),
    [anon_sym_U_SQUOTE] = ACTIONS(1094),
    [anon_sym_u8_SQUOTE] = ACTIONS(1094),
    [anon_sym_SQUOTE] = ACTIONS(1094),
    [anon_sym_L_DQUOTE] = ACTIONS(1094),
    [anon_sym_u_DQUOTE] = ACTIONS(1094),
    [anon_sym_U_DQUOTE] = ACTIONS(1094),
    [anon_sym_u8_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE] = ACTIONS(1094),
    [sym_true] = ACTIONS(1092),
    [sym_false] = ACTIONS(1092),
    [sym_null] = ACTIONS(1092),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_identifier] = ACTIONS(1096),
    [aux_sym_preproc_include_token1] = ACTIONS(1096),
    [aux_sym_preproc_def_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token2] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1096),
    [aux_sym_preproc_else_token1] = ACTIONS(1096),
    [aux_sym_preproc_elif_token1] = ACTIONS(1096),
    [sym_preproc_directive] = ACTIONS(1096),
    [anon_sym_LPAREN2] = ACTIONS(1098),
    [anon_sym_BANG] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1096),
    [anon_sym_PLUS] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1098),
    [anon_sym_AMP] = ACTIONS(1098),
    [anon_sym_SEMI] = ACTIONS(1098),
    [anon_sym_typedef] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(1096),
    [anon_sym___attribute__] = ACTIONS(1096),
    [anon_sym___declspec] = ACTIONS(1096),
    [anon_sym___cdecl] = ACTIONS(1096),
    [anon_sym___clrcall] = ACTIONS(1096),
    [anon_sym___stdcall] = ACTIONS(1096),
    [anon_sym___fastcall] = ACTIONS(1096),
    [anon_sym___thiscall] = ACTIONS(1096),
    [anon_sym___vectorcall] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1098),
    [anon_sym_static] = ACTIONS(1096),
    [anon_sym_auto] = ACTIONS(1096),
    [anon_sym_register] = ACTIONS(1096),
    [anon_sym_inline] = ACTIONS(1096),
    [anon_sym_const] = ACTIONS(1096),
    [anon_sym_volatile] = ACTIONS(1096),
    [anon_sym_restrict] = ACTIONS(1096),
    [anon_sym__Atomic] = ACTIONS(1096),
    [anon_sym_signed] = ACTIONS(1096),
    [anon_sym_unsigned] = ACTIONS(1096),
    [anon_sym_long] = ACTIONS(1096),
    [anon_sym_short] = ACTIONS(1096),
    [sym_primitive_type] = ACTIONS(1096),
    [anon_sym_enum] = ACTIONS(1096),
    [anon_sym_struct] = ACTIONS(1096),
    [anon_sym_union] = ACTIONS(1096),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_switch] = ACTIONS(1096),
    [anon_sym_case] = ACTIONS(1096),
    [anon_sym_default] = ACTIONS(1096),
    [anon_sym_while] = ACTIONS(1096),
    [anon_sym_do] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1096),
    [anon_sym_return] = ACTIONS(1096),
    [anon_sym_break] = ACTIONS(1096),
    [anon_sym_continue] = ACTIONS(1096),
    [anon_sym_goto] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1098),
    [anon_sym_sizeof] = ACTIONS(1096),
    [sym_number_literal] = ACTIONS(1098),
    [anon_sym_L_SQUOTE] = ACTIONS(1098),
    [anon_sym_u_SQUOTE] = ACTIONS(1098),
    [anon_sym_U_SQUOTE] = ACTIONS(1098),
    [anon_sym_u8_SQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [anon_sym_L_DQUOTE] = ACTIONS(1098),
    [anon_sym_u_DQUOTE] = ACTIONS(1098),
    [anon_sym_U_DQUOTE] = ACTIONS(1098),
    [anon_sym_u8_DQUOTE] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [sym_identifier] = ACTIONS(1100),
    [aux_sym_preproc_include_token1] = ACTIONS(1100),
    [aux_sym_preproc_def_token1] = ACTIONS(1100),
    [aux_sym_preproc_if_token1] = ACTIONS(1100),
    [aux_sym_preproc_if_token2] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1100),
    [aux_sym_preproc_else_token1] = ACTIONS(1100),
    [aux_sym_preproc_elif_token1] = ACTIONS(1100),
    [sym_preproc_directive] = ACTIONS(1100),
    [anon_sym_LPAREN2] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_AMP] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_typedef] = ACTIONS(1100),
    [anon_sym_extern] = ACTIONS(1100),
    [anon_sym___attribute__] = ACTIONS(1100),
    [anon_sym___declspec] = ACTIONS(1100),
    [anon_sym___cdecl] = ACTIONS(1100),
    [anon_sym___clrcall] = ACTIONS(1100),
    [anon_sym___stdcall] = ACTIONS(1100),
    [anon_sym___fastcall] = ACTIONS(1100),
    [anon_sym___thiscall] = ACTIONS(1100),
    [anon_sym___vectorcall] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1100),
    [anon_sym_auto] = ACTIONS(1100),
    [anon_sym_register] = ACTIONS(1100),
    [anon_sym_inline] = ACTIONS(1100),
    [anon_sym_const] = ACTIONS(1100),
    [anon_sym_volatile] = ACTIONS(1100),
    [anon_sym_restrict] = ACTIONS(1100),
    [anon_sym__Atomic] = ACTIONS(1100),
    [anon_sym_signed] = ACTIONS(1100),
    [anon_sym_unsigned] = ACTIONS(1100),
    [anon_sym_long] = ACTIONS(1100),
    [anon_sym_short] = ACTIONS(1100),
    [sym_primitive_type] = ACTIONS(1100),
    [anon_sym_enum] = ACTIONS(1100),
    [anon_sym_struct] = ACTIONS(1100),
    [anon_sym_union] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_switch] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_do] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_goto] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_sizeof] = ACTIONS(1100),
    [sym_number_literal] = ACTIONS(1102),
    [anon_sym_L_SQUOTE] = ACTIONS(1102),
    [anon_sym_u_SQUOTE] = ACTIONS(1102),
    [anon_sym_U_SQUOTE] = ACTIONS(1102),
    [anon_sym_u8_SQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [anon_sym_L_DQUOTE] = ACTIONS(1102),
    [anon_sym_u_DQUOTE] = ACTIONS(1102),
    [anon_sym_U_DQUOTE] = ACTIONS(1102),
    [anon_sym_u8_DQUOTE] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_null] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_identifier] = ACTIONS(1104),
    [aux_sym_preproc_include_token1] = ACTIONS(1104),
    [aux_sym_preproc_def_token1] = ACTIONS(1104),
    [aux_sym_preproc_if_token1] = ACTIONS(1104),
    [aux_sym_preproc_if_token2] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1104),
    [aux_sym_preproc_else_token1] = ACTIONS(1104),
    [aux_sym_preproc_elif_token1] = ACTIONS(1104),
    [sym_preproc_directive] = ACTIONS(1104),
    [anon_sym_LPAREN2] = ACTIONS(1106),
    [anon_sym_BANG] = ACTIONS(1106),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_AMP] = ACTIONS(1106),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_typedef] = ACTIONS(1104),
    [anon_sym_extern] = ACTIONS(1104),
    [anon_sym___attribute__] = ACTIONS(1104),
    [anon_sym___declspec] = ACTIONS(1104),
    [anon_sym___cdecl] = ACTIONS(1104),
    [anon_sym___clrcall] = ACTIONS(1104),
    [anon_sym___stdcall] = ACTIONS(1104),
    [anon_sym___fastcall] = ACTIONS(1104),
    [anon_sym___thiscall] = ACTIONS(1104),
    [anon_sym___vectorcall] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_auto] = ACTIONS(1104),
    [anon_sym_register] = ACTIONS(1104),
    [anon_sym_inline] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_volatile] = ACTIONS(1104),
    [anon_sym_restrict] = ACTIONS(1104),
    [anon_sym__Atomic] = ACTIONS(1104),
    [anon_sym_signed] = ACTIONS(1104),
    [anon_sym_unsigned] = ACTIONS(1104),
    [anon_sym_long] = ACTIONS(1104),
    [anon_sym_short] = ACTIONS(1104),
    [sym_primitive_type] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [anon_sym_struct] = ACTIONS(1104),
    [anon_sym_union] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_goto] = ACTIONS(1104),
    [anon_sym_DASH_DASH] = ACTIONS(1106),
    [anon_sym_PLUS_PLUS] = ACTIONS(1106),
    [anon_sym_sizeof] = ACTIONS(1104),
    [sym_number_literal] = ACTIONS(1106),
    [anon_sym_L_SQUOTE] = ACTIONS(1106),
    [anon_sym_u_SQUOTE] = ACTIONS(1106),
    [anon_sym_U_SQUOTE] = ACTIONS(1106),
    [anon_sym_u8_SQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [anon_sym_L_DQUOTE] = ACTIONS(1106),
    [anon_sym_u_DQUOTE] = ACTIONS(1106),
    [anon_sym_U_DQUOTE] = ACTIONS(1106),
    [anon_sym_u8_DQUOTE] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(994),
    [sym_identifier] = ACTIONS(992),
    [aux_sym_preproc_include_token1] = ACTIONS(992),
    [aux_sym_preproc_def_token1] = ACTIONS(992),
    [aux_sym_preproc_if_token1] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(992),
    [sym_preproc_directive] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(994),
    [anon_sym_BANG] = ACTIONS(994),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_AMP] = ACTIONS(994),
    [anon_sym_SEMI] = ACTIONS(994),
    [anon_sym_typedef] = ACTIONS(992),
    [anon_sym_extern] = ACTIONS(992),
    [anon_sym___attribute__] = ACTIONS(992),
    [anon_sym___declspec] = ACTIONS(992),
    [anon_sym___cdecl] = ACTIONS(992),
    [anon_sym___clrcall] = ACTIONS(992),
    [anon_sym___stdcall] = ACTIONS(992),
    [anon_sym___fastcall] = ACTIONS(992),
    [anon_sym___thiscall] = ACTIONS(992),
    [anon_sym___vectorcall] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(994),
    [anon_sym_static] = ACTIONS(992),
    [anon_sym_auto] = ACTIONS(992),
    [anon_sym_register] = ACTIONS(992),
    [anon_sym_inline] = ACTIONS(992),
    [anon_sym_const] = ACTIONS(992),
    [anon_sym_volatile] = ACTIONS(992),
    [anon_sym_restrict] = ACTIONS(992),
    [anon_sym__Atomic] = ACTIONS(992),
    [anon_sym_signed] = ACTIONS(992),
    [anon_sym_unsigned] = ACTIONS(992),
    [anon_sym_long] = ACTIONS(992),
    [anon_sym_short] = ACTIONS(992),
    [sym_primitive_type] = ACTIONS(992),
    [anon_sym_enum] = ACTIONS(992),
    [anon_sym_struct] = ACTIONS(992),
    [anon_sym_union] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_switch] = ACTIONS(992),
    [anon_sym_case] = ACTIONS(992),
    [anon_sym_default] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_goto] = ACTIONS(992),
    [anon_sym_DASH_DASH] = ACTIONS(994),
    [anon_sym_PLUS_PLUS] = ACTIONS(994),
    [anon_sym_sizeof] = ACTIONS(992),
    [sym_number_literal] = ACTIONS(994),
    [anon_sym_L_SQUOTE] = ACTIONS(994),
    [anon_sym_u_SQUOTE] = ACTIONS(994),
    [anon_sym_U_SQUOTE] = ACTIONS(994),
    [anon_sym_u8_SQUOTE] = ACTIONS(994),
    [anon_sym_SQUOTE] = ACTIONS(994),
    [anon_sym_L_DQUOTE] = ACTIONS(994),
    [anon_sym_u_DQUOTE] = ACTIONS(994),
    [anon_sym_U_DQUOTE] = ACTIONS(994),
    [anon_sym_u8_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_true] = ACTIONS(992),
    [sym_false] = ACTIONS(992),
    [sym_null] = ACTIONS(992),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(974),
    [sym_identifier] = ACTIONS(972),
    [aux_sym_preproc_include_token1] = ACTIONS(972),
    [aux_sym_preproc_def_token1] = ACTIONS(972),
    [aux_sym_preproc_if_token1] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(972),
    [sym_preproc_directive] = ACTIONS(972),
    [anon_sym_LPAREN2] = ACTIONS(974),
    [anon_sym_BANG] = ACTIONS(974),
    [anon_sym_TILDE] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_typedef] = ACTIONS(972),
    [anon_sym_extern] = ACTIONS(972),
    [anon_sym___attribute__] = ACTIONS(972),
    [anon_sym___declspec] = ACTIONS(972),
    [anon_sym___cdecl] = ACTIONS(972),
    [anon_sym___clrcall] = ACTIONS(972),
    [anon_sym___stdcall] = ACTIONS(972),
    [anon_sym___fastcall] = ACTIONS(972),
    [anon_sym___thiscall] = ACTIONS(972),
    [anon_sym___vectorcall] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(974),
    [anon_sym_static] = ACTIONS(972),
    [anon_sym_auto] = ACTIONS(972),
    [anon_sym_register] = ACTIONS(972),
    [anon_sym_inline] = ACTIONS(972),
    [anon_sym_const] = ACTIONS(972),
    [anon_sym_volatile] = ACTIONS(972),
    [anon_sym_restrict] = ACTIONS(972),
    [anon_sym__Atomic] = ACTIONS(972),
    [anon_sym_signed] = ACTIONS(972),
    [anon_sym_unsigned] = ACTIONS(972),
    [anon_sym_long] = ACTIONS(972),
    [anon_sym_short] = ACTIONS(972),
    [sym_primitive_type] = ACTIONS(972),
    [anon_sym_enum] = ACTIONS(972),
    [anon_sym_struct] = ACTIONS(972),
    [anon_sym_union] = ACTIONS(972),
    [anon_sym_if] = ACTIONS(972),
    [anon_sym_else] = ACTIONS(972),
    [anon_sym_switch] = ACTIONS(972),
    [anon_sym_case] = ACTIONS(972),
    [anon_sym_default] = ACTIONS(972),
    [anon_sym_while] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(972),
    [anon_sym_for] = ACTIONS(972),
    [anon_sym_return] = ACTIONS(972),
    [anon_sym_break] = ACTIONS(972),
    [anon_sym_continue] = ACTIONS(972),
    [anon_sym_goto] = ACTIONS(972),
    [anon_sym_DASH_DASH] = ACTIONS(974),
    [anon_sym_PLUS_PLUS] = ACTIONS(974),
    [anon_sym_sizeof] = ACTIONS(972),
    [sym_number_literal] = ACTIONS(974),
    [anon_sym_L_SQUOTE] = ACTIONS(974),
    [anon_sym_u_SQUOTE] = ACTIONS(974),
    [anon_sym_U_SQUOTE] = ACTIONS(974),
    [anon_sym_u8_SQUOTE] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(974),
    [anon_sym_L_DQUOTE] = ACTIONS(974),
    [anon_sym_u_DQUOTE] = ACTIONS(974),
    [anon_sym_U_DQUOTE] = ACTIONS(974),
    [anon_sym_u8_DQUOTE] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [sym_true] = ACTIONS(972),
    [sym_false] = ACTIONS(972),
    [sym_null] = ACTIONS(972),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_identifier] = ACTIONS(940),
    [aux_sym_preproc_include_token1] = ACTIONS(940),
    [aux_sym_preproc_def_token1] = ACTIONS(940),
    [aux_sym_preproc_if_token1] = ACTIONS(940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(940),
    [sym_preproc_directive] = ACTIONS(940),
    [anon_sym_LPAREN2] = ACTIONS(942),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_STAR] = ACTIONS(942),
    [anon_sym_AMP] = ACTIONS(942),
    [anon_sym_SEMI] = ACTIONS(942),
    [anon_sym_typedef] = ACTIONS(940),
    [anon_sym_extern] = ACTIONS(940),
    [anon_sym___attribute__] = ACTIONS(940),
    [anon_sym___declspec] = ACTIONS(940),
    [anon_sym___cdecl] = ACTIONS(940),
    [anon_sym___clrcall] = ACTIONS(940),
    [anon_sym___stdcall] = ACTIONS(940),
    [anon_sym___fastcall] = ACTIONS(940),
    [anon_sym___thiscall] = ACTIONS(940),
    [anon_sym___vectorcall] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(942),
    [anon_sym_RBRACE] = ACTIONS(942),
    [anon_sym_static] = ACTIONS(940),
    [anon_sym_auto] = ACTIONS(940),
    [anon_sym_register] = ACTIONS(940),
    [anon_sym_inline] = ACTIONS(940),
    [anon_sym_const] = ACTIONS(940),
    [anon_sym_volatile] = ACTIONS(940),
    [anon_sym_restrict] = ACTIONS(940),
    [anon_sym__Atomic] = ACTIONS(940),
    [anon_sym_signed] = ACTIONS(940),
    [anon_sym_unsigned] = ACTIONS(940),
    [anon_sym_long] = ACTIONS(940),
    [anon_sym_short] = ACTIONS(940),
    [sym_primitive_type] = ACTIONS(940),
    [anon_sym_enum] = ACTIONS(940),
    [anon_sym_struct] = ACTIONS(940),
    [anon_sym_union] = ACTIONS(940),
    [anon_sym_if] = ACTIONS(940),
    [anon_sym_else] = ACTIONS(940),
    [anon_sym_switch] = ACTIONS(940),
    [anon_sym_case] = ACTIONS(940),
    [anon_sym_default] = ACTIONS(940),
    [anon_sym_while] = ACTIONS(940),
    [anon_sym_do] = ACTIONS(940),
    [anon_sym_for] = ACTIONS(940),
    [anon_sym_return] = ACTIONS(940),
    [anon_sym_break] = ACTIONS(940),
    [anon_sym_continue] = ACTIONS(940),
    [anon_sym_goto] = ACTIONS(940),
    [anon_sym_DASH_DASH] = ACTIONS(942),
    [anon_sym_PLUS_PLUS] = ACTIONS(942),
    [anon_sym_sizeof] = ACTIONS(940),
    [sym_number_literal] = ACTIONS(942),
    [anon_sym_L_SQUOTE] = ACTIONS(942),
    [anon_sym_u_SQUOTE] = ACTIONS(942),
    [anon_sym_U_SQUOTE] = ACTIONS(942),
    [anon_sym_u8_SQUOTE] = ACTIONS(942),
    [anon_sym_SQUOTE] = ACTIONS(942),
    [anon_sym_L_DQUOTE] = ACTIONS(942),
    [anon_sym_u_DQUOTE] = ACTIONS(942),
    [anon_sym_U_DQUOTE] = ACTIONS(942),
    [anon_sym_u8_DQUOTE] = ACTIONS(942),
    [anon_sym_DQUOTE] = ACTIONS(942),
    [sym_true] = ACTIONS(940),
    [sym_false] = ACTIONS(940),
    [sym_null] = ACTIONS(940),
    [sym_comment] = ACTIONS(3),
  },
  [130] = {
    [sym_identifier] = ACTIONS(926),
    [aux_sym_preproc_include_token1] = ACTIONS(926),
    [aux_sym_preproc_def_token1] = ACTIONS(926),
    [aux_sym_preproc_if_token1] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(926),
    [sym_preproc_directive] = ACTIONS(926),
    [anon_sym_LPAREN2] = ACTIONS(928),
    [anon_sym_BANG] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(928),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_STAR] = ACTIONS(928),
    [anon_sym_AMP] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(928),
    [anon_sym_typedef] = ACTIONS(926),
    [anon_sym_extern] = ACTIONS(926),
    [anon_sym___attribute__] = ACTIONS(926),
    [anon_sym___declspec] = ACTIONS(926),
    [anon_sym___cdecl] = ACTIONS(926),
    [anon_sym___clrcall] = ACTIONS(926),
    [anon_sym___stdcall] = ACTIONS(926),
    [anon_sym___fastcall] = ACTIONS(926),
    [anon_sym___thiscall] = ACTIONS(926),
    [anon_sym___vectorcall] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_RBRACE] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(926),
    [anon_sym_auto] = ACTIONS(926),
    [anon_sym_register] = ACTIONS(926),
    [anon_sym_inline] = ACTIONS(926),
    [anon_sym_const] = ACTIONS(926),
    [anon_sym_volatile] = ACTIONS(926),
    [anon_sym_restrict] = ACTIONS(926),
    [anon_sym__Atomic] = ACTIONS(926),
    [anon_sym_signed] = ACTIONS(926),
    [anon_sym_unsigned] = ACTIONS(926),
    [anon_sym_long] = ACTIONS(926),
    [anon_sym_short] = ACTIONS(926),
    [sym_primitive_type] = ACTIONS(926),
    [anon_sym_enum] = ACTIONS(926),
    [anon_sym_struct] = ACTIONS(926),
    [anon_sym_union] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(926),
    [anon_sym_else] = ACTIONS(1108),
    [anon_sym_switch] = ACTIONS(926),
    [anon_sym_case] = ACTIONS(926),
    [anon_sym_default] = ACTIONS(926),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_do] = ACTIONS(926),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(926),
    [anon_sym_break] = ACTIONS(926),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_goto] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(928),
    [anon_sym_PLUS_PLUS] = ACTIONS(928),
    [anon_sym_sizeof] = ACTIONS(926),
    [sym_number_literal] = ACTIONS(928),
    [anon_sym_L_SQUOTE] = ACTIONS(928),
    [anon_sym_u_SQUOTE] = ACTIONS(928),
    [anon_sym_U_SQUOTE] = ACTIONS(928),
    [anon_sym_u8_SQUOTE] = ACTIONS(928),
    [anon_sym_SQUOTE] = ACTIONS(928),
    [anon_sym_L_DQUOTE] = ACTIONS(928),
    [anon_sym_u_DQUOTE] = ACTIONS(928),
    [anon_sym_U_DQUOTE] = ACTIONS(928),
    [anon_sym_u8_DQUOTE] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(928),
    [sym_true] = ACTIONS(926),
    [sym_false] = ACTIONS(926),
    [sym_null] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
  },
  [131] = {
    [sym_identifier] = ACTIONS(948),
    [aux_sym_preproc_include_token1] = ACTIONS(948),
    [aux_sym_preproc_def_token1] = ACTIONS(948),
    [aux_sym_preproc_if_token1] = ACTIONS(948),
    [aux_sym_preproc_if_token2] = ACTIONS(948),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(948),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(948),
    [sym_preproc_directive] = ACTIONS(948),
    [anon_sym_LPAREN2] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(950),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_DASH] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_SEMI] = ACTIONS(950),
    [anon_sym_typedef] = ACTIONS(948),
    [anon_sym_extern] = ACTIONS(948),
    [anon_sym___attribute__] = ACTIONS(948),
    [anon_sym___declspec] = ACTIONS(948),
    [anon_sym___cdecl] = ACTIONS(948),
    [anon_sym___clrcall] = ACTIONS(948),
    [anon_sym___stdcall] = ACTIONS(948),
    [anon_sym___fastcall] = ACTIONS(948),
    [anon_sym___thiscall] = ACTIONS(948),
    [anon_sym___vectorcall] = ACTIONS(948),
    [anon_sym_LBRACE] = ACTIONS(950),
    [anon_sym_static] = ACTIONS(948),
    [anon_sym_auto] = ACTIONS(948),
    [anon_sym_register] = ACTIONS(948),
    [anon_sym_inline] = ACTIONS(948),
    [anon_sym_const] = ACTIONS(948),
    [anon_sym_volatile] = ACTIONS(948),
    [anon_sym_restrict] = ACTIONS(948),
    [anon_sym__Atomic] = ACTIONS(948),
    [anon_sym_signed] = ACTIONS(948),
    [anon_sym_unsigned] = ACTIONS(948),
    [anon_sym_long] = ACTIONS(948),
    [anon_sym_short] = ACTIONS(948),
    [sym_primitive_type] = ACTIONS(948),
    [anon_sym_enum] = ACTIONS(948),
    [anon_sym_struct] = ACTIONS(948),
    [anon_sym_union] = ACTIONS(948),
    [anon_sym_if] = ACTIONS(948),
    [anon_sym_else] = ACTIONS(948),
    [anon_sym_switch] = ACTIONS(948),
    [anon_sym_case] = ACTIONS(948),
    [anon_sym_default] = ACTIONS(948),
    [anon_sym_while] = ACTIONS(948),
    [anon_sym_do] = ACTIONS(948),
    [anon_sym_for] = ACTIONS(948),
    [anon_sym_return] = ACTIONS(948),
    [anon_sym_break] = ACTIONS(948),
    [anon_sym_continue] = ACTIONS(948),
    [anon_sym_goto] = ACTIONS(948),
    [anon_sym_DASH_DASH] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(950),
    [anon_sym_sizeof] = ACTIONS(948),
    [sym_number_literal] = ACTIONS(950),
    [anon_sym_L_SQUOTE] = ACTIONS(950),
    [anon_sym_u_SQUOTE] = ACTIONS(950),
    [anon_sym_U_SQUOTE] = ACTIONS(950),
    [anon_sym_u8_SQUOTE] = ACTIONS(950),
    [anon_sym_SQUOTE] = ACTIONS(950),
    [anon_sym_L_DQUOTE] = ACTIONS(950),
    [anon_sym_u_DQUOTE] = ACTIONS(950),
    [anon_sym_U_DQUOTE] = ACTIONS(950),
    [anon_sym_u8_DQUOTE] = ACTIONS(950),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [sym_true] = ACTIONS(948),
    [sym_false] = ACTIONS(948),
    [sym_null] = ACTIONS(948),
    [sym_comment] = ACTIONS(3),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(998),
    [sym_identifier] = ACTIONS(996),
    [aux_sym_preproc_include_token1] = ACTIONS(996),
    [aux_sym_preproc_def_token1] = ACTIONS(996),
    [aux_sym_preproc_if_token1] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(996),
    [sym_preproc_directive] = ACTIONS(996),
    [anon_sym_LPAREN2] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(998),
    [anon_sym_AMP] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(998),
    [anon_sym_typedef] = ACTIONS(996),
    [anon_sym_extern] = ACTIONS(996),
    [anon_sym___attribute__] = ACTIONS(996),
    [anon_sym___declspec] = ACTIONS(996),
    [anon_sym___cdecl] = ACTIONS(996),
    [anon_sym___clrcall] = ACTIONS(996),
    [anon_sym___stdcall] = ACTIONS(996),
    [anon_sym___fastcall] = ACTIONS(996),
    [anon_sym___thiscall] = ACTIONS(996),
    [anon_sym___vectorcall] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_static] = ACTIONS(996),
    [anon_sym_auto] = ACTIONS(996),
    [anon_sym_register] = ACTIONS(996),
    [anon_sym_inline] = ACTIONS(996),
    [anon_sym_const] = ACTIONS(996),
    [anon_sym_volatile] = ACTIONS(996),
    [anon_sym_restrict] = ACTIONS(996),
    [anon_sym__Atomic] = ACTIONS(996),
    [anon_sym_signed] = ACTIONS(996),
    [anon_sym_unsigned] = ACTIONS(996),
    [anon_sym_long] = ACTIONS(996),
    [anon_sym_short] = ACTIONS(996),
    [sym_primitive_type] = ACTIONS(996),
    [anon_sym_enum] = ACTIONS(996),
    [anon_sym_struct] = ACTIONS(996),
    [anon_sym_union] = ACTIONS(996),
    [anon_sym_if] = ACTIONS(996),
    [anon_sym_else] = ACTIONS(996),
    [anon_sym_switch] = ACTIONS(996),
    [anon_sym_case] = ACTIONS(996),
    [anon_sym_default] = ACTIONS(996),
    [anon_sym_while] = ACTIONS(996),
    [anon_sym_do] = ACTIONS(996),
    [anon_sym_for] = ACTIONS(996),
    [anon_sym_return] = ACTIONS(996),
    [anon_sym_break] = ACTIONS(996),
    [anon_sym_continue] = ACTIONS(996),
    [anon_sym_goto] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(996),
    [sym_number_literal] = ACTIONS(998),
    [anon_sym_L_SQUOTE] = ACTIONS(998),
    [anon_sym_u_SQUOTE] = ACTIONS(998),
    [anon_sym_U_SQUOTE] = ACTIONS(998),
    [anon_sym_u8_SQUOTE] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(998),
    [anon_sym_L_DQUOTE] = ACTIONS(998),
    [anon_sym_u_DQUOTE] = ACTIONS(998),
    [anon_sym_U_DQUOTE] = ACTIONS(998),
    [anon_sym_u8_DQUOTE] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(998),
    [sym_true] = ACTIONS(996),
    [sym_false] = ACTIONS(996),
    [sym_null] = ACTIONS(996),
    [sym_comment] = ACTIONS(3),
  },
  [133] = {
    [sym_identifier] = ACTIONS(964),
    [aux_sym_preproc_include_token1] = ACTIONS(964),
    [aux_sym_preproc_def_token1] = ACTIONS(964),
    [aux_sym_preproc_if_token1] = ACTIONS(964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(964),
    [sym_preproc_directive] = ACTIONS(964),
    [anon_sym_LPAREN2] = ACTIONS(966),
    [anon_sym_BANG] = ACTIONS(966),
    [anon_sym_TILDE] = ACTIONS(966),
    [anon_sym_DASH] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(964),
    [anon_sym_STAR] = ACTIONS(966),
    [anon_sym_AMP] = ACTIONS(966),
    [anon_sym_SEMI] = ACTIONS(966),
    [anon_sym_typedef] = ACTIONS(964),
    [anon_sym_extern] = ACTIONS(964),
    [anon_sym___attribute__] = ACTIONS(964),
    [anon_sym___declspec] = ACTIONS(964),
    [anon_sym___cdecl] = ACTIONS(964),
    [anon_sym___clrcall] = ACTIONS(964),
    [anon_sym___stdcall] = ACTIONS(964),
    [anon_sym___fastcall] = ACTIONS(964),
    [anon_sym___thiscall] = ACTIONS(964),
    [anon_sym___vectorcall] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(966),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_static] = ACTIONS(964),
    [anon_sym_auto] = ACTIONS(964),
    [anon_sym_register] = ACTIONS(964),
    [anon_sym_inline] = ACTIONS(964),
    [anon_sym_const] = ACTIONS(964),
    [anon_sym_volatile] = ACTIONS(964),
    [anon_sym_restrict] = ACTIONS(964),
    [anon_sym__Atomic] = ACTIONS(964),
    [anon_sym_signed] = ACTIONS(964),
    [anon_sym_unsigned] = ACTIONS(964),
    [anon_sym_long] = ACTIONS(964),
    [anon_sym_short] = ACTIONS(964),
    [sym_primitive_type] = ACTIONS(964),
    [anon_sym_enum] = ACTIONS(964),
    [anon_sym_struct] = ACTIONS(964),
    [anon_sym_union] = ACTIONS(964),
    [anon_sym_if] = ACTIONS(964),
    [anon_sym_else] = ACTIONS(964),
    [anon_sym_switch] = ACTIONS(964),
    [anon_sym_case] = ACTIONS(964),
    [anon_sym_default] = ACTIONS(964),
    [anon_sym_while] = ACTIONS(964),
    [anon_sym_do] = ACTIONS(964),
    [anon_sym_for] = ACTIONS(964),
    [anon_sym_return] = ACTIONS(964),
    [anon_sym_break] = ACTIONS(964),
    [anon_sym_continue] = ACTIONS(964),
    [anon_sym_goto] = ACTIONS(964),
    [anon_sym_DASH_DASH] = ACTIONS(966),
    [anon_sym_PLUS_PLUS] = ACTIONS(966),
    [anon_sym_sizeof] = ACTIONS(964),
    [sym_number_literal] = ACTIONS(966),
    [anon_sym_L_SQUOTE] = ACTIONS(966),
    [anon_sym_u_SQUOTE] = ACTIONS(966),
    [anon_sym_U_SQUOTE] = ACTIONS(966),
    [anon_sym_u8_SQUOTE] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(966),
    [anon_sym_L_DQUOTE] = ACTIONS(966),
    [anon_sym_u_DQUOTE] = ACTIONS(966),
    [anon_sym_U_DQUOTE] = ACTIONS(966),
    [anon_sym_u8_DQUOTE] = ACTIONS(966),
    [anon_sym_DQUOTE] = ACTIONS(966),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_identifier] = ACTIONS(968),
    [aux_sym_preproc_include_token1] = ACTIONS(968),
    [aux_sym_preproc_def_token1] = ACTIONS(968),
    [aux_sym_preproc_if_token1] = ACTIONS(968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(968),
    [sym_preproc_directive] = ACTIONS(968),
    [anon_sym_LPAREN2] = ACTIONS(970),
    [anon_sym_BANG] = ACTIONS(970),
    [anon_sym_TILDE] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(968),
    [anon_sym_PLUS] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(970),
    [anon_sym_AMP] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(970),
    [anon_sym_typedef] = ACTIONS(968),
    [anon_sym_extern] = ACTIONS(968),
    [anon_sym___attribute__] = ACTIONS(968),
    [anon_sym___declspec] = ACTIONS(968),
    [anon_sym___cdecl] = ACTIONS(968),
    [anon_sym___clrcall] = ACTIONS(968),
    [anon_sym___stdcall] = ACTIONS(968),
    [anon_sym___fastcall] = ACTIONS(968),
    [anon_sym___thiscall] = ACTIONS(968),
    [anon_sym___vectorcall] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(970),
    [anon_sym_RBRACE] = ACTIONS(970),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_auto] = ACTIONS(968),
    [anon_sym_register] = ACTIONS(968),
    [anon_sym_inline] = ACTIONS(968),
    [anon_sym_const] = ACTIONS(968),
    [anon_sym_volatile] = ACTIONS(968),
    [anon_sym_restrict] = ACTIONS(968),
    [anon_sym__Atomic] = ACTIONS(968),
    [anon_sym_signed] = ACTIONS(968),
    [anon_sym_unsigned] = ACTIONS(968),
    [anon_sym_long] = ACTIONS(968),
    [anon_sym_short] = ACTIONS(968),
    [sym_primitive_type] = ACTIONS(968),
    [anon_sym_enum] = ACTIONS(968),
    [anon_sym_struct] = ACTIONS(968),
    [anon_sym_union] = ACTIONS(968),
    [anon_sym_if] = ACTIONS(968),
    [anon_sym_else] = ACTIONS(968),
    [anon_sym_switch] = ACTIONS(968),
    [anon_sym_case] = ACTIONS(968),
    [anon_sym_default] = ACTIONS(968),
    [anon_sym_while] = ACTIONS(968),
    [anon_sym_do] = ACTIONS(968),
    [anon_sym_for] = ACTIONS(968),
    [anon_sym_return] = ACTIONS(968),
    [anon_sym_break] = ACTIONS(968),
    [anon_sym_continue] = ACTIONS(968),
    [anon_sym_goto] = ACTIONS(968),
    [anon_sym_DASH_DASH] = ACTIONS(970),
    [anon_sym_PLUS_PLUS] = ACTIONS(970),
    [anon_sym_sizeof] = ACTIONS(968),
    [sym_number_literal] = ACTIONS(970),
    [anon_sym_L_SQUOTE] = ACTIONS(970),
    [anon_sym_u_SQUOTE] = ACTIONS(970),
    [anon_sym_U_SQUOTE] = ACTIONS(970),
    [anon_sym_u8_SQUOTE] = ACTIONS(970),
    [anon_sym_SQUOTE] = ACTIONS(970),
    [anon_sym_L_DQUOTE] = ACTIONS(970),
    [anon_sym_u_DQUOTE] = ACTIONS(970),
    [anon_sym_U_DQUOTE] = ACTIONS(970),
    [anon_sym_u8_DQUOTE] = ACTIONS(970),
    [anon_sym_DQUOTE] = ACTIONS(970),
    [sym_true] = ACTIONS(968),
    [sym_false] = ACTIONS(968),
    [sym_null] = ACTIONS(968),
    [sym_comment] = ACTIONS(3),
  },
  [135] = {
    [sym_identifier] = ACTIONS(972),
    [aux_sym_preproc_include_token1] = ACTIONS(972),
    [aux_sym_preproc_def_token1] = ACTIONS(972),
    [aux_sym_preproc_if_token1] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(972),
    [sym_preproc_directive] = ACTIONS(972),
    [anon_sym_LPAREN2] = ACTIONS(974),
    [anon_sym_BANG] = ACTIONS(974),
    [anon_sym_TILDE] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_typedef] = ACTIONS(972),
    [anon_sym_extern] = ACTIONS(972),
    [anon_sym___attribute__] = ACTIONS(972),
    [anon_sym___declspec] = ACTIONS(972),
    [anon_sym___cdecl] = ACTIONS(972),
    [anon_sym___clrcall] = ACTIONS(972),
    [anon_sym___stdcall] = ACTIONS(972),
    [anon_sym___fastcall] = ACTIONS(972),
    [anon_sym___thiscall] = ACTIONS(972),
    [anon_sym___vectorcall] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(974),
    [anon_sym_RBRACE] = ACTIONS(974),
    [anon_sym_static] = ACTIONS(972),
    [anon_sym_auto] = ACTIONS(972),
    [anon_sym_register] = ACTIONS(972),
    [anon_sym_inline] = ACTIONS(972),
    [anon_sym_const] = ACTIONS(972),
    [anon_sym_volatile] = ACTIONS(972),
    [anon_sym_restrict] = ACTIONS(972),
    [anon_sym__Atomic] = ACTIONS(972),
    [anon_sym_signed] = ACTIONS(972),
    [anon_sym_unsigned] = ACTIONS(972),
    [anon_sym_long] = ACTIONS(972),
    [anon_sym_short] = ACTIONS(972),
    [sym_primitive_type] = ACTIONS(972),
    [anon_sym_enum] = ACTIONS(972),
    [anon_sym_struct] = ACTIONS(972),
    [anon_sym_union] = ACTIONS(972),
    [anon_sym_if] = ACTIONS(972),
    [anon_sym_else] = ACTIONS(972),
    [anon_sym_switch] = ACTIONS(972),
    [anon_sym_case] = ACTIONS(972),
    [anon_sym_default] = ACTIONS(972),
    [anon_sym_while] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(972),
    [anon_sym_for] = ACTIONS(972),
    [anon_sym_return] = ACTIONS(972),
    [anon_sym_break] = ACTIONS(972),
    [anon_sym_continue] = ACTIONS(972),
    [anon_sym_goto] = ACTIONS(972),
    [anon_sym_DASH_DASH] = ACTIONS(974),
    [anon_sym_PLUS_PLUS] = ACTIONS(974),
    [anon_sym_sizeof] = ACTIONS(972),
    [sym_number_literal] = ACTIONS(974),
    [anon_sym_L_SQUOTE] = ACTIONS(974),
    [anon_sym_u_SQUOTE] = ACTIONS(974),
    [anon_sym_U_SQUOTE] = ACTIONS(974),
    [anon_sym_u8_SQUOTE] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(974),
    [anon_sym_L_DQUOTE] = ACTIONS(974),
    [anon_sym_u_DQUOTE] = ACTIONS(974),
    [anon_sym_U_DQUOTE] = ACTIONS(974),
    [anon_sym_u8_DQUOTE] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [sym_true] = ACTIONS(972),
    [sym_false] = ACTIONS(972),
    [sym_null] = ACTIONS(972),
    [sym_comment] = ACTIONS(3),
  },
  [136] = {
    [sym_identifier] = ACTIONS(914),
    [aux_sym_preproc_include_token1] = ACTIONS(914),
    [aux_sym_preproc_def_token1] = ACTIONS(914),
    [aux_sym_preproc_if_token1] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(914),
    [sym_preproc_directive] = ACTIONS(914),
    [anon_sym_LPAREN2] = ACTIONS(916),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(914),
    [anon_sym_STAR] = ACTIONS(916),
    [anon_sym_AMP] = ACTIONS(916),
    [anon_sym_SEMI] = ACTIONS(916),
    [anon_sym_typedef] = ACTIONS(914),
    [anon_sym_extern] = ACTIONS(914),
    [anon_sym___attribute__] = ACTIONS(914),
    [anon_sym___declspec] = ACTIONS(914),
    [anon_sym___cdecl] = ACTIONS(914),
    [anon_sym___clrcall] = ACTIONS(914),
    [anon_sym___stdcall] = ACTIONS(914),
    [anon_sym___fastcall] = ACTIONS(914),
    [anon_sym___thiscall] = ACTIONS(914),
    [anon_sym___vectorcall] = ACTIONS(914),
    [anon_sym_LBRACE] = ACTIONS(916),
    [anon_sym_RBRACE] = ACTIONS(916),
    [anon_sym_static] = ACTIONS(914),
    [anon_sym_auto] = ACTIONS(914),
    [anon_sym_register] = ACTIONS(914),
    [anon_sym_inline] = ACTIONS(914),
    [anon_sym_const] = ACTIONS(914),
    [anon_sym_volatile] = ACTIONS(914),
    [anon_sym_restrict] = ACTIONS(914),
    [anon_sym__Atomic] = ACTIONS(914),
    [anon_sym_signed] = ACTIONS(914),
    [anon_sym_unsigned] = ACTIONS(914),
    [anon_sym_long] = ACTIONS(914),
    [anon_sym_short] = ACTIONS(914),
    [sym_primitive_type] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(914),
    [anon_sym_struct] = ACTIONS(914),
    [anon_sym_union] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_else] = ACTIONS(914),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_case] = ACTIONS(914),
    [anon_sym_default] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [anon_sym_do] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_goto] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_sizeof] = ACTIONS(914),
    [sym_number_literal] = ACTIONS(916),
    [anon_sym_L_SQUOTE] = ACTIONS(916),
    [anon_sym_u_SQUOTE] = ACTIONS(916),
    [anon_sym_U_SQUOTE] = ACTIONS(916),
    [anon_sym_u8_SQUOTE] = ACTIONS(916),
    [anon_sym_SQUOTE] = ACTIONS(916),
    [anon_sym_L_DQUOTE] = ACTIONS(916),
    [anon_sym_u_DQUOTE] = ACTIONS(916),
    [anon_sym_U_DQUOTE] = ACTIONS(916),
    [anon_sym_u8_DQUOTE] = ACTIONS(916),
    [anon_sym_DQUOTE] = ACTIONS(916),
    [sym_true] = ACTIONS(914),
    [sym_false] = ACTIONS(914),
    [sym_null] = ACTIONS(914),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_identifier] = ACTIONS(960),
    [aux_sym_preproc_include_token1] = ACTIONS(960),
    [aux_sym_preproc_def_token1] = ACTIONS(960),
    [aux_sym_preproc_if_token1] = ACTIONS(960),
    [aux_sym_preproc_if_token2] = ACTIONS(960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(960),
    [sym_preproc_directive] = ACTIONS(960),
    [anon_sym_LPAREN2] = ACTIONS(962),
    [anon_sym_BANG] = ACTIONS(962),
    [anon_sym_TILDE] = ACTIONS(962),
    [anon_sym_DASH] = ACTIONS(960),
    [anon_sym_PLUS] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_typedef] = ACTIONS(960),
    [anon_sym_extern] = ACTIONS(960),
    [anon_sym___attribute__] = ACTIONS(960),
    [anon_sym___declspec] = ACTIONS(960),
    [anon_sym___cdecl] = ACTIONS(960),
    [anon_sym___clrcall] = ACTIONS(960),
    [anon_sym___stdcall] = ACTIONS(960),
    [anon_sym___fastcall] = ACTIONS(960),
    [anon_sym___thiscall] = ACTIONS(960),
    [anon_sym___vectorcall] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_auto] = ACTIONS(960),
    [anon_sym_register] = ACTIONS(960),
    [anon_sym_inline] = ACTIONS(960),
    [anon_sym_const] = ACTIONS(960),
    [anon_sym_volatile] = ACTIONS(960),
    [anon_sym_restrict] = ACTIONS(960),
    [anon_sym__Atomic] = ACTIONS(960),
    [anon_sym_signed] = ACTIONS(960),
    [anon_sym_unsigned] = ACTIONS(960),
    [anon_sym_long] = ACTIONS(960),
    [anon_sym_short] = ACTIONS(960),
    [sym_primitive_type] = ACTIONS(960),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_struct] = ACTIONS(960),
    [anon_sym_union] = ACTIONS(960),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_else] = ACTIONS(960),
    [anon_sym_switch] = ACTIONS(960),
    [anon_sym_case] = ACTIONS(960),
    [anon_sym_default] = ACTIONS(960),
    [anon_sym_while] = ACTIONS(960),
    [anon_sym_do] = ACTIONS(960),
    [anon_sym_for] = ACTIONS(960),
    [anon_sym_return] = ACTIONS(960),
    [anon_sym_break] = ACTIONS(960),
    [anon_sym_continue] = ACTIONS(960),
    [anon_sym_goto] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(962),
    [anon_sym_PLUS_PLUS] = ACTIONS(962),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_L_SQUOTE] = ACTIONS(962),
    [anon_sym_u_SQUOTE] = ACTIONS(962),
    [anon_sym_U_SQUOTE] = ACTIONS(962),
    [anon_sym_u8_SQUOTE] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(962),
    [anon_sym_L_DQUOTE] = ACTIONS(962),
    [anon_sym_u_DQUOTE] = ACTIONS(962),
    [anon_sym_U_DQUOTE] = ACTIONS(962),
    [anon_sym_u8_DQUOTE] = ACTIONS(962),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [sym_true] = ACTIONS(960),
    [sym_false] = ACTIONS(960),
    [sym_null] = ACTIONS(960),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [sym_identifier] = ACTIONS(992),
    [aux_sym_preproc_include_token1] = ACTIONS(992),
    [aux_sym_preproc_def_token1] = ACTIONS(992),
    [aux_sym_preproc_if_token1] = ACTIONS(992),
    [aux_sym_preproc_if_token2] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(992),
    [sym_preproc_directive] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(994),
    [anon_sym_BANG] = ACTIONS(994),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_AMP] = ACTIONS(994),
    [anon_sym_SEMI] = ACTIONS(994),
    [anon_sym_typedef] = ACTIONS(992),
    [anon_sym_extern] = ACTIONS(992),
    [anon_sym___attribute__] = ACTIONS(992),
    [anon_sym___declspec] = ACTIONS(992),
    [anon_sym___cdecl] = ACTIONS(992),
    [anon_sym___clrcall] = ACTIONS(992),
    [anon_sym___stdcall] = ACTIONS(992),
    [anon_sym___fastcall] = ACTIONS(992),
    [anon_sym___thiscall] = ACTIONS(992),
    [anon_sym___vectorcall] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(994),
    [anon_sym_static] = ACTIONS(992),
    [anon_sym_auto] = ACTIONS(992),
    [anon_sym_register] = ACTIONS(992),
    [anon_sym_inline] = ACTIONS(992),
    [anon_sym_const] = ACTIONS(992),
    [anon_sym_volatile] = ACTIONS(992),
    [anon_sym_restrict] = ACTIONS(992),
    [anon_sym__Atomic] = ACTIONS(992),
    [anon_sym_signed] = ACTIONS(992),
    [anon_sym_unsigned] = ACTIONS(992),
    [anon_sym_long] = ACTIONS(992),
    [anon_sym_short] = ACTIONS(992),
    [sym_primitive_type] = ACTIONS(992),
    [anon_sym_enum] = ACTIONS(992),
    [anon_sym_struct] = ACTIONS(992),
    [anon_sym_union] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_switch] = ACTIONS(992),
    [anon_sym_case] = ACTIONS(992),
    [anon_sym_default] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_goto] = ACTIONS(992),
    [anon_sym_DASH_DASH] = ACTIONS(994),
    [anon_sym_PLUS_PLUS] = ACTIONS(994),
    [anon_sym_sizeof] = ACTIONS(992),
    [sym_number_literal] = ACTIONS(994),
    [anon_sym_L_SQUOTE] = ACTIONS(994),
    [anon_sym_u_SQUOTE] = ACTIONS(994),
    [anon_sym_U_SQUOTE] = ACTIONS(994),
    [anon_sym_u8_SQUOTE] = ACTIONS(994),
    [anon_sym_SQUOTE] = ACTIONS(994),
    [anon_sym_L_DQUOTE] = ACTIONS(994),
    [anon_sym_u_DQUOTE] = ACTIONS(994),
    [anon_sym_U_DQUOTE] = ACTIONS(994),
    [anon_sym_u8_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_true] = ACTIONS(992),
    [sym_false] = ACTIONS(992),
    [sym_null] = ACTIONS(992),
    [sym_comment] = ACTIONS(3),
  },
  [139] = {
    [sym_identifier] = ACTIONS(890),
    [aux_sym_preproc_include_token1] = ACTIONS(890),
    [aux_sym_preproc_def_token1] = ACTIONS(890),
    [aux_sym_preproc_if_token1] = ACTIONS(890),
    [aux_sym_preproc_if_token2] = ACTIONS(890),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(890),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(890),
    [sym_preproc_directive] = ACTIONS(890),
    [anon_sym_LPAREN2] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(892),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(892),
    [anon_sym_typedef] = ACTIONS(890),
    [anon_sym_extern] = ACTIONS(890),
    [anon_sym___attribute__] = ACTIONS(890),
    [anon_sym___declspec] = ACTIONS(890),
    [anon_sym___cdecl] = ACTIONS(890),
    [anon_sym___clrcall] = ACTIONS(890),
    [anon_sym___stdcall] = ACTIONS(890),
    [anon_sym___fastcall] = ACTIONS(890),
    [anon_sym___thiscall] = ACTIONS(890),
    [anon_sym___vectorcall] = ACTIONS(890),
    [anon_sym_LBRACE] = ACTIONS(892),
    [anon_sym_static] = ACTIONS(890),
    [anon_sym_auto] = ACTIONS(890),
    [anon_sym_register] = ACTIONS(890),
    [anon_sym_inline] = ACTIONS(890),
    [anon_sym_const] = ACTIONS(890),
    [anon_sym_volatile] = ACTIONS(890),
    [anon_sym_restrict] = ACTIONS(890),
    [anon_sym__Atomic] = ACTIONS(890),
    [anon_sym_signed] = ACTIONS(890),
    [anon_sym_unsigned] = ACTIONS(890),
    [anon_sym_long] = ACTIONS(890),
    [anon_sym_short] = ACTIONS(890),
    [sym_primitive_type] = ACTIONS(890),
    [anon_sym_enum] = ACTIONS(890),
    [anon_sym_struct] = ACTIONS(890),
    [anon_sym_union] = ACTIONS(890),
    [anon_sym_if] = ACTIONS(890),
    [anon_sym_else] = ACTIONS(890),
    [anon_sym_switch] = ACTIONS(890),
    [anon_sym_case] = ACTIONS(890),
    [anon_sym_default] = ACTIONS(890),
    [anon_sym_while] = ACTIONS(890),
    [anon_sym_do] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(890),
    [anon_sym_return] = ACTIONS(890),
    [anon_sym_break] = ACTIONS(890),
    [anon_sym_continue] = ACTIONS(890),
    [anon_sym_goto] = ACTIONS(890),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_sizeof] = ACTIONS(890),
    [sym_number_literal] = ACTIONS(892),
    [anon_sym_L_SQUOTE] = ACTIONS(892),
    [anon_sym_u_SQUOTE] = ACTIONS(892),
    [anon_sym_U_SQUOTE] = ACTIONS(892),
    [anon_sym_u8_SQUOTE] = ACTIONS(892),
    [anon_sym_SQUOTE] = ACTIONS(892),
    [anon_sym_L_DQUOTE] = ACTIONS(892),
    [anon_sym_u_DQUOTE] = ACTIONS(892),
    [anon_sym_U_DQUOTE] = ACTIONS(892),
    [anon_sym_u8_DQUOTE] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_true] = ACTIONS(890),
    [sym_false] = ACTIONS(890),
    [sym_null] = ACTIONS(890),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(920),
    [sym_identifier] = ACTIONS(918),
    [aux_sym_preproc_include_token1] = ACTIONS(918),
    [aux_sym_preproc_def_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(918),
    [sym_preproc_directive] = ACTIONS(918),
    [anon_sym_LPAREN2] = ACTIONS(920),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_STAR] = ACTIONS(920),
    [anon_sym_AMP] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(920),
    [anon_sym_typedef] = ACTIONS(918),
    [anon_sym_extern] = ACTIONS(918),
    [anon_sym___attribute__] = ACTIONS(918),
    [anon_sym___declspec] = ACTIONS(918),
    [anon_sym___cdecl] = ACTIONS(918),
    [anon_sym___clrcall] = ACTIONS(918),
    [anon_sym___stdcall] = ACTIONS(918),
    [anon_sym___fastcall] = ACTIONS(918),
    [anon_sym___thiscall] = ACTIONS(918),
    [anon_sym___vectorcall] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_static] = ACTIONS(918),
    [anon_sym_auto] = ACTIONS(918),
    [anon_sym_register] = ACTIONS(918),
    [anon_sym_inline] = ACTIONS(918),
    [anon_sym_const] = ACTIONS(918),
    [anon_sym_volatile] = ACTIONS(918),
    [anon_sym_restrict] = ACTIONS(918),
    [anon_sym__Atomic] = ACTIONS(918),
    [anon_sym_signed] = ACTIONS(918),
    [anon_sym_unsigned] = ACTIONS(918),
    [anon_sym_long] = ACTIONS(918),
    [anon_sym_short] = ACTIONS(918),
    [sym_primitive_type] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(918),
    [anon_sym_struct] = ACTIONS(918),
    [anon_sym_union] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(918),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_for] = ACTIONS(918),
    [anon_sym_return] = ACTIONS(918),
    [anon_sym_break] = ACTIONS(918),
    [anon_sym_continue] = ACTIONS(918),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(920),
    [anon_sym_sizeof] = ACTIONS(918),
    [sym_number_literal] = ACTIONS(920),
    [anon_sym_L_SQUOTE] = ACTIONS(920),
    [anon_sym_u_SQUOTE] = ACTIONS(920),
    [anon_sym_U_SQUOTE] = ACTIONS(920),
    [anon_sym_u8_SQUOTE] = ACTIONS(920),
    [anon_sym_SQUOTE] = ACTIONS(920),
    [anon_sym_L_DQUOTE] = ACTIONS(920),
    [anon_sym_u_DQUOTE] = ACTIONS(920),
    [anon_sym_U_DQUOTE] = ACTIONS(920),
    [anon_sym_u8_DQUOTE] = ACTIONS(920),
    [anon_sym_DQUOTE] = ACTIONS(920),
    [sym_true] = ACTIONS(918),
    [sym_false] = ACTIONS(918),
    [sym_null] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [sym_identifier] = ACTIONS(976),
    [aux_sym_preproc_include_token1] = ACTIONS(976),
    [aux_sym_preproc_def_token1] = ACTIONS(976),
    [aux_sym_preproc_if_token1] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(976),
    [sym_preproc_directive] = ACTIONS(976),
    [anon_sym_LPAREN2] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(978),
    [anon_sym_TILDE] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_STAR] = ACTIONS(978),
    [anon_sym_AMP] = ACTIONS(978),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym_typedef] = ACTIONS(976),
    [anon_sym_extern] = ACTIONS(976),
    [anon_sym___attribute__] = ACTIONS(976),
    [anon_sym___declspec] = ACTIONS(976),
    [anon_sym___cdecl] = ACTIONS(976),
    [anon_sym___clrcall] = ACTIONS(976),
    [anon_sym___stdcall] = ACTIONS(976),
    [anon_sym___fastcall] = ACTIONS(976),
    [anon_sym___thiscall] = ACTIONS(976),
    [anon_sym___vectorcall] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_RBRACE] = ACTIONS(978),
    [anon_sym_static] = ACTIONS(976),
    [anon_sym_auto] = ACTIONS(976),
    [anon_sym_register] = ACTIONS(976),
    [anon_sym_inline] = ACTIONS(976),
    [anon_sym_const] = ACTIONS(976),
    [anon_sym_volatile] = ACTIONS(976),
    [anon_sym_restrict] = ACTIONS(976),
    [anon_sym__Atomic] = ACTIONS(976),
    [anon_sym_signed] = ACTIONS(976),
    [anon_sym_unsigned] = ACTIONS(976),
    [anon_sym_long] = ACTIONS(976),
    [anon_sym_short] = ACTIONS(976),
    [sym_primitive_type] = ACTIONS(976),
    [anon_sym_enum] = ACTIONS(976),
    [anon_sym_struct] = ACTIONS(976),
    [anon_sym_union] = ACTIONS(976),
    [anon_sym_if] = ACTIONS(976),
    [anon_sym_else] = ACTIONS(976),
    [anon_sym_switch] = ACTIONS(976),
    [anon_sym_case] = ACTIONS(976),
    [anon_sym_default] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(976),
    [anon_sym_do] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_return] = ACTIONS(976),
    [anon_sym_break] = ACTIONS(976),
    [anon_sym_continue] = ACTIONS(976),
    [anon_sym_goto] = ACTIONS(976),
    [anon_sym_DASH_DASH] = ACTIONS(978),
    [anon_sym_PLUS_PLUS] = ACTIONS(978),
    [anon_sym_sizeof] = ACTIONS(976),
    [sym_number_literal] = ACTIONS(978),
    [anon_sym_L_SQUOTE] = ACTIONS(978),
    [anon_sym_u_SQUOTE] = ACTIONS(978),
    [anon_sym_U_SQUOTE] = ACTIONS(978),
    [anon_sym_u8_SQUOTE] = ACTIONS(978),
    [anon_sym_SQUOTE] = ACTIONS(978),
    [anon_sym_L_DQUOTE] = ACTIONS(978),
    [anon_sym_u_DQUOTE] = ACTIONS(978),
    [anon_sym_U_DQUOTE] = ACTIONS(978),
    [anon_sym_u8_DQUOTE] = ACTIONS(978),
    [anon_sym_DQUOTE] = ACTIONS(978),
    [sym_true] = ACTIONS(976),
    [sym_false] = ACTIONS(976),
    [sym_null] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
  },
  [142] = {
    [sym_identifier] = ACTIONS(984),
    [aux_sym_preproc_include_token1] = ACTIONS(984),
    [aux_sym_preproc_def_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(984),
    [sym_preproc_directive] = ACTIONS(984),
    [anon_sym_LPAREN2] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_AMP] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_typedef] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym___attribute__] = ACTIONS(984),
    [anon_sym___declspec] = ACTIONS(984),
    [anon_sym___cdecl] = ACTIONS(984),
    [anon_sym___clrcall] = ACTIONS(984),
    [anon_sym___stdcall] = ACTIONS(984),
    [anon_sym___fastcall] = ACTIONS(984),
    [anon_sym___thiscall] = ACTIONS(984),
    [anon_sym___vectorcall] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_auto] = ACTIONS(984),
    [anon_sym_register] = ACTIONS(984),
    [anon_sym_inline] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_volatile] = ACTIONS(984),
    [anon_sym_restrict] = ACTIONS(984),
    [anon_sym__Atomic] = ACTIONS(984),
    [anon_sym_signed] = ACTIONS(984),
    [anon_sym_unsigned] = ACTIONS(984),
    [anon_sym_long] = ACTIONS(984),
    [anon_sym_short] = ACTIONS(984),
    [sym_primitive_type] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_struct] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(984),
    [anon_sym_switch] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_do] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_goto] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_sizeof] = ACTIONS(984),
    [sym_number_literal] = ACTIONS(986),
    [anon_sym_L_SQUOTE] = ACTIONS(986),
    [anon_sym_u_SQUOTE] = ACTIONS(986),
    [anon_sym_U_SQUOTE] = ACTIONS(986),
    [anon_sym_u8_SQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [anon_sym_L_DQUOTE] = ACTIONS(986),
    [anon_sym_u_DQUOTE] = ACTIONS(986),
    [anon_sym_U_DQUOTE] = ACTIONS(986),
    [anon_sym_u8_DQUOTE] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [sym_identifier] = ACTIONS(1000),
    [aux_sym_preproc_include_token1] = ACTIONS(1000),
    [aux_sym_preproc_def_token1] = ACTIONS(1000),
    [aux_sym_preproc_if_token1] = ACTIONS(1000),
    [aux_sym_preproc_if_token2] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1000),
    [sym_preproc_directive] = ACTIONS(1000),
    [anon_sym_LPAREN2] = ACTIONS(1002),
    [anon_sym_BANG] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_typedef] = ACTIONS(1000),
    [anon_sym_extern] = ACTIONS(1000),
    [anon_sym___attribute__] = ACTIONS(1000),
    [anon_sym___declspec] = ACTIONS(1000),
    [anon_sym___cdecl] = ACTIONS(1000),
    [anon_sym___clrcall] = ACTIONS(1000),
    [anon_sym___stdcall] = ACTIONS(1000),
    [anon_sym___fastcall] = ACTIONS(1000),
    [anon_sym___thiscall] = ACTIONS(1000),
    [anon_sym___vectorcall] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(1002),
    [anon_sym_static] = ACTIONS(1000),
    [anon_sym_auto] = ACTIONS(1000),
    [anon_sym_register] = ACTIONS(1000),
    [anon_sym_inline] = ACTIONS(1000),
    [anon_sym_const] = ACTIONS(1000),
    [anon_sym_volatile] = ACTIONS(1000),
    [anon_sym_restrict] = ACTIONS(1000),
    [anon_sym__Atomic] = ACTIONS(1000),
    [anon_sym_signed] = ACTIONS(1000),
    [anon_sym_unsigned] = ACTIONS(1000),
    [anon_sym_long] = ACTIONS(1000),
    [anon_sym_short] = ACTIONS(1000),
    [sym_primitive_type] = ACTIONS(1000),
    [anon_sym_enum] = ACTIONS(1000),
    [anon_sym_struct] = ACTIONS(1000),
    [anon_sym_union] = ACTIONS(1000),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_else] = ACTIONS(1000),
    [anon_sym_switch] = ACTIONS(1000),
    [anon_sym_case] = ACTIONS(1000),
    [anon_sym_default] = ACTIONS(1000),
    [anon_sym_while] = ACTIONS(1000),
    [anon_sym_do] = ACTIONS(1000),
    [anon_sym_for] = ACTIONS(1000),
    [anon_sym_return] = ACTIONS(1000),
    [anon_sym_break] = ACTIONS(1000),
    [anon_sym_continue] = ACTIONS(1000),
    [anon_sym_goto] = ACTIONS(1000),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1002),
    [anon_sym_L_SQUOTE] = ACTIONS(1002),
    [anon_sym_u_SQUOTE] = ACTIONS(1002),
    [anon_sym_U_SQUOTE] = ACTIONS(1002),
    [anon_sym_u8_SQUOTE] = ACTIONS(1002),
    [anon_sym_SQUOTE] = ACTIONS(1002),
    [anon_sym_L_DQUOTE] = ACTIONS(1002),
    [anon_sym_u_DQUOTE] = ACTIONS(1002),
    [anon_sym_U_DQUOTE] = ACTIONS(1002),
    [anon_sym_u8_DQUOTE] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1002),
    [sym_true] = ACTIONS(1000),
    [sym_false] = ACTIONS(1000),
    [sym_null] = ACTIONS(1000),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_identifier] = ACTIONS(1016),
    [aux_sym_preproc_include_token1] = ACTIONS(1016),
    [aux_sym_preproc_def_token1] = ACTIONS(1016),
    [aux_sym_preproc_if_token1] = ACTIONS(1016),
    [aux_sym_preproc_if_token2] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1016),
    [sym_preproc_directive] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1018),
    [anon_sym_BANG] = ACTIONS(1018),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1016),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_AMP] = ACTIONS(1018),
    [anon_sym_SEMI] = ACTIONS(1018),
    [anon_sym_typedef] = ACTIONS(1016),
    [anon_sym_extern] = ACTIONS(1016),
    [anon_sym___attribute__] = ACTIONS(1016),
    [anon_sym___declspec] = ACTIONS(1016),
    [anon_sym___cdecl] = ACTIONS(1016),
    [anon_sym___clrcall] = ACTIONS(1016),
    [anon_sym___stdcall] = ACTIONS(1016),
    [anon_sym___fastcall] = ACTIONS(1016),
    [anon_sym___thiscall] = ACTIONS(1016),
    [anon_sym___vectorcall] = ACTIONS(1016),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_static] = ACTIONS(1016),
    [anon_sym_auto] = ACTIONS(1016),
    [anon_sym_register] = ACTIONS(1016),
    [anon_sym_inline] = ACTIONS(1016),
    [anon_sym_const] = ACTIONS(1016),
    [anon_sym_volatile] = ACTIONS(1016),
    [anon_sym_restrict] = ACTIONS(1016),
    [anon_sym__Atomic] = ACTIONS(1016),
    [anon_sym_signed] = ACTIONS(1016),
    [anon_sym_unsigned] = ACTIONS(1016),
    [anon_sym_long] = ACTIONS(1016),
    [anon_sym_short] = ACTIONS(1016),
    [sym_primitive_type] = ACTIONS(1016),
    [anon_sym_enum] = ACTIONS(1016),
    [anon_sym_struct] = ACTIONS(1016),
    [anon_sym_union] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1016),
    [anon_sym_switch] = ACTIONS(1016),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_default] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_goto] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [anon_sym_sizeof] = ACTIONS(1016),
    [sym_number_literal] = ACTIONS(1018),
    [anon_sym_L_SQUOTE] = ACTIONS(1018),
    [anon_sym_u_SQUOTE] = ACTIONS(1018),
    [anon_sym_U_SQUOTE] = ACTIONS(1018),
    [anon_sym_u8_SQUOTE] = ACTIONS(1018),
    [anon_sym_SQUOTE] = ACTIONS(1018),
    [anon_sym_L_DQUOTE] = ACTIONS(1018),
    [anon_sym_u_DQUOTE] = ACTIONS(1018),
    [anon_sym_U_DQUOTE] = ACTIONS(1018),
    [anon_sym_u8_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [sym_true] = ACTIONS(1016),
    [sym_false] = ACTIONS(1016),
    [sym_null] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
  },
  [145] = {
    [sym_identifier] = ACTIONS(984),
    [aux_sym_preproc_include_token1] = ACTIONS(984),
    [aux_sym_preproc_def_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(984),
    [sym_preproc_directive] = ACTIONS(984),
    [anon_sym_LPAREN2] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_AMP] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_typedef] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym___attribute__] = ACTIONS(984),
    [anon_sym___declspec] = ACTIONS(984),
    [anon_sym___cdecl] = ACTIONS(984),
    [anon_sym___clrcall] = ACTIONS(984),
    [anon_sym___stdcall] = ACTIONS(984),
    [anon_sym___fastcall] = ACTIONS(984),
    [anon_sym___thiscall] = ACTIONS(984),
    [anon_sym___vectorcall] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_auto] = ACTIONS(984),
    [anon_sym_register] = ACTIONS(984),
    [anon_sym_inline] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_volatile] = ACTIONS(984),
    [anon_sym_restrict] = ACTIONS(984),
    [anon_sym__Atomic] = ACTIONS(984),
    [anon_sym_signed] = ACTIONS(984),
    [anon_sym_unsigned] = ACTIONS(984),
    [anon_sym_long] = ACTIONS(984),
    [anon_sym_short] = ACTIONS(984),
    [sym_primitive_type] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_struct] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(984),
    [anon_sym_switch] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_do] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_goto] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_sizeof] = ACTIONS(984),
    [sym_number_literal] = ACTIONS(986),
    [anon_sym_L_SQUOTE] = ACTIONS(986),
    [anon_sym_u_SQUOTE] = ACTIONS(986),
    [anon_sym_U_SQUOTE] = ACTIONS(986),
    [anon_sym_u8_SQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [anon_sym_L_DQUOTE] = ACTIONS(986),
    [anon_sym_u_DQUOTE] = ACTIONS(986),
    [anon_sym_U_DQUOTE] = ACTIONS(986),
    [anon_sym_u8_DQUOTE] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
  },
  [146] = {
    [sym_identifier] = ACTIONS(1020),
    [aux_sym_preproc_include_token1] = ACTIONS(1020),
    [aux_sym_preproc_def_token1] = ACTIONS(1020),
    [aux_sym_preproc_if_token1] = ACTIONS(1020),
    [aux_sym_preproc_if_token2] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1020),
    [sym_preproc_directive] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1022),
    [anon_sym_TILDE] = ACTIONS(1022),
    [anon_sym_DASH] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1020),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_AMP] = ACTIONS(1022),
    [anon_sym_SEMI] = ACTIONS(1022),
    [anon_sym_typedef] = ACTIONS(1020),
    [anon_sym_extern] = ACTIONS(1020),
    [anon_sym___attribute__] = ACTIONS(1020),
    [anon_sym___declspec] = ACTIONS(1020),
    [anon_sym___cdecl] = ACTIONS(1020),
    [anon_sym___clrcall] = ACTIONS(1020),
    [anon_sym___stdcall] = ACTIONS(1020),
    [anon_sym___fastcall] = ACTIONS(1020),
    [anon_sym___thiscall] = ACTIONS(1020),
    [anon_sym___vectorcall] = ACTIONS(1020),
    [anon_sym_LBRACE] = ACTIONS(1022),
    [anon_sym_static] = ACTIONS(1020),
    [anon_sym_auto] = ACTIONS(1020),
    [anon_sym_register] = ACTIONS(1020),
    [anon_sym_inline] = ACTIONS(1020),
    [anon_sym_const] = ACTIONS(1020),
    [anon_sym_volatile] = ACTIONS(1020),
    [anon_sym_restrict] = ACTIONS(1020),
    [anon_sym__Atomic] = ACTIONS(1020),
    [anon_sym_signed] = ACTIONS(1020),
    [anon_sym_unsigned] = ACTIONS(1020),
    [anon_sym_long] = ACTIONS(1020),
    [anon_sym_short] = ACTIONS(1020),
    [sym_primitive_type] = ACTIONS(1020),
    [anon_sym_enum] = ACTIONS(1020),
    [anon_sym_struct] = ACTIONS(1020),
    [anon_sym_union] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_switch] = ACTIONS(1020),
    [anon_sym_case] = ACTIONS(1020),
    [anon_sym_default] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_goto] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1022),
    [anon_sym_PLUS_PLUS] = ACTIONS(1022),
    [anon_sym_sizeof] = ACTIONS(1020),
    [sym_number_literal] = ACTIONS(1022),
    [anon_sym_L_SQUOTE] = ACTIONS(1022),
    [anon_sym_u_SQUOTE] = ACTIONS(1022),
    [anon_sym_U_SQUOTE] = ACTIONS(1022),
    [anon_sym_u8_SQUOTE] = ACTIONS(1022),
    [anon_sym_SQUOTE] = ACTIONS(1022),
    [anon_sym_L_DQUOTE] = ACTIONS(1022),
    [anon_sym_u_DQUOTE] = ACTIONS(1022),
    [anon_sym_U_DQUOTE] = ACTIONS(1022),
    [anon_sym_u8_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [sym_true] = ACTIONS(1020),
    [sym_false] = ACTIONS(1020),
    [sym_null] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [ts_builtin_sym_end] = ACTIONS(912),
    [sym_identifier] = ACTIONS(910),
    [aux_sym_preproc_include_token1] = ACTIONS(910),
    [aux_sym_preproc_def_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(910),
    [sym_preproc_directive] = ACTIONS(910),
    [anon_sym_LPAREN2] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_typedef] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym___attribute__] = ACTIONS(910),
    [anon_sym___declspec] = ACTIONS(910),
    [anon_sym___cdecl] = ACTIONS(910),
    [anon_sym___clrcall] = ACTIONS(910),
    [anon_sym___stdcall] = ACTIONS(910),
    [anon_sym___fastcall] = ACTIONS(910),
    [anon_sym___thiscall] = ACTIONS(910),
    [anon_sym___vectorcall] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_auto] = ACTIONS(910),
    [anon_sym_register] = ACTIONS(910),
    [anon_sym_inline] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_restrict] = ACTIONS(910),
    [anon_sym__Atomic] = ACTIONS(910),
    [anon_sym_signed] = ACTIONS(910),
    [anon_sym_unsigned] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [sym_primitive_type] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_goto] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_sizeof] = ACTIONS(910),
    [sym_number_literal] = ACTIONS(912),
    [anon_sym_L_SQUOTE] = ACTIONS(912),
    [anon_sym_u_SQUOTE] = ACTIONS(912),
    [anon_sym_U_SQUOTE] = ACTIONS(912),
    [anon_sym_u8_SQUOTE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(912),
    [anon_sym_L_DQUOTE] = ACTIONS(912),
    [anon_sym_u_DQUOTE] = ACTIONS(912),
    [anon_sym_U_DQUOTE] = ACTIONS(912),
    [anon_sym_u8_DQUOTE] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(912),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
  },
  [148] = {
    [ts_builtin_sym_end] = ACTIONS(912),
    [sym_identifier] = ACTIONS(910),
    [aux_sym_preproc_include_token1] = ACTIONS(910),
    [aux_sym_preproc_def_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(910),
    [sym_preproc_directive] = ACTIONS(910),
    [anon_sym_LPAREN2] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_typedef] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym___attribute__] = ACTIONS(910),
    [anon_sym___declspec] = ACTIONS(910),
    [anon_sym___cdecl] = ACTIONS(910),
    [anon_sym___clrcall] = ACTIONS(910),
    [anon_sym___stdcall] = ACTIONS(910),
    [anon_sym___fastcall] = ACTIONS(910),
    [anon_sym___thiscall] = ACTIONS(910),
    [anon_sym___vectorcall] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_auto] = ACTIONS(910),
    [anon_sym_register] = ACTIONS(910),
    [anon_sym_inline] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_restrict] = ACTIONS(910),
    [anon_sym__Atomic] = ACTIONS(910),
    [anon_sym_signed] = ACTIONS(910),
    [anon_sym_unsigned] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [sym_primitive_type] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_goto] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_sizeof] = ACTIONS(910),
    [sym_number_literal] = ACTIONS(912),
    [anon_sym_L_SQUOTE] = ACTIONS(912),
    [anon_sym_u_SQUOTE] = ACTIONS(912),
    [anon_sym_U_SQUOTE] = ACTIONS(912),
    [anon_sym_u8_SQUOTE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(912),
    [anon_sym_L_DQUOTE] = ACTIONS(912),
    [anon_sym_u_DQUOTE] = ACTIONS(912),
    [anon_sym_U_DQUOTE] = ACTIONS(912),
    [anon_sym_u8_DQUOTE] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(912),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(946),
    [sym_identifier] = ACTIONS(944),
    [aux_sym_preproc_include_token1] = ACTIONS(944),
    [aux_sym_preproc_def_token1] = ACTIONS(944),
    [aux_sym_preproc_if_token1] = ACTIONS(944),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(944),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(944),
    [sym_preproc_directive] = ACTIONS(944),
    [anon_sym_LPAREN2] = ACTIONS(946),
    [anon_sym_BANG] = ACTIONS(946),
    [anon_sym_TILDE] = ACTIONS(946),
    [anon_sym_DASH] = ACTIONS(944),
    [anon_sym_PLUS] = ACTIONS(944),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_AMP] = ACTIONS(946),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_typedef] = ACTIONS(944),
    [anon_sym_extern] = ACTIONS(944),
    [anon_sym___attribute__] = ACTIONS(944),
    [anon_sym___declspec] = ACTIONS(944),
    [anon_sym___cdecl] = ACTIONS(944),
    [anon_sym___clrcall] = ACTIONS(944),
    [anon_sym___stdcall] = ACTIONS(944),
    [anon_sym___fastcall] = ACTIONS(944),
    [anon_sym___thiscall] = ACTIONS(944),
    [anon_sym___vectorcall] = ACTIONS(944),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_auto] = ACTIONS(944),
    [anon_sym_register] = ACTIONS(944),
    [anon_sym_inline] = ACTIONS(944),
    [anon_sym_const] = ACTIONS(944),
    [anon_sym_volatile] = ACTIONS(944),
    [anon_sym_restrict] = ACTIONS(944),
    [anon_sym__Atomic] = ACTIONS(944),
    [anon_sym_signed] = ACTIONS(944),
    [anon_sym_unsigned] = ACTIONS(944),
    [anon_sym_long] = ACTIONS(944),
    [anon_sym_short] = ACTIONS(944),
    [sym_primitive_type] = ACTIONS(944),
    [anon_sym_enum] = ACTIONS(944),
    [anon_sym_struct] = ACTIONS(944),
    [anon_sym_union] = ACTIONS(944),
    [anon_sym_if] = ACTIONS(944),
    [anon_sym_else] = ACTIONS(944),
    [anon_sym_switch] = ACTIONS(944),
    [anon_sym_case] = ACTIONS(944),
    [anon_sym_default] = ACTIONS(944),
    [anon_sym_while] = ACTIONS(944),
    [anon_sym_do] = ACTIONS(944),
    [anon_sym_for] = ACTIONS(944),
    [anon_sym_return] = ACTIONS(944),
    [anon_sym_break] = ACTIONS(944),
    [anon_sym_continue] = ACTIONS(944),
    [anon_sym_goto] = ACTIONS(944),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_sizeof] = ACTIONS(944),
    [sym_number_literal] = ACTIONS(946),
    [anon_sym_L_SQUOTE] = ACTIONS(946),
    [anon_sym_u_SQUOTE] = ACTIONS(946),
    [anon_sym_U_SQUOTE] = ACTIONS(946),
    [anon_sym_u8_SQUOTE] = ACTIONS(946),
    [anon_sym_SQUOTE] = ACTIONS(946),
    [anon_sym_L_DQUOTE] = ACTIONS(946),
    [anon_sym_u_DQUOTE] = ACTIONS(946),
    [anon_sym_U_DQUOTE] = ACTIONS(946),
    [anon_sym_u8_DQUOTE] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(946),
    [sym_true] = ACTIONS(944),
    [sym_false] = ACTIONS(944),
    [sym_null] = ACTIONS(944),
    [sym_comment] = ACTIONS(3),
  },
  [150] = {
    [sym_identifier] = ACTIONS(932),
    [aux_sym_preproc_include_token1] = ACTIONS(932),
    [aux_sym_preproc_def_token1] = ACTIONS(932),
    [aux_sym_preproc_if_token1] = ACTIONS(932),
    [aux_sym_preproc_if_token2] = ACTIONS(932),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(932),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(932),
    [sym_preproc_directive] = ACTIONS(932),
    [anon_sym_LPAREN2] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(934),
    [anon_sym_TILDE] = ACTIONS(934),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_STAR] = ACTIONS(934),
    [anon_sym_AMP] = ACTIONS(934),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_typedef] = ACTIONS(932),
    [anon_sym_extern] = ACTIONS(932),
    [anon_sym___attribute__] = ACTIONS(932),
    [anon_sym___declspec] = ACTIONS(932),
    [anon_sym___cdecl] = ACTIONS(932),
    [anon_sym___clrcall] = ACTIONS(932),
    [anon_sym___stdcall] = ACTIONS(932),
    [anon_sym___fastcall] = ACTIONS(932),
    [anon_sym___thiscall] = ACTIONS(932),
    [anon_sym___vectorcall] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(934),
    [anon_sym_static] = ACTIONS(932),
    [anon_sym_auto] = ACTIONS(932),
    [anon_sym_register] = ACTIONS(932),
    [anon_sym_inline] = ACTIONS(932),
    [anon_sym_const] = ACTIONS(932),
    [anon_sym_volatile] = ACTIONS(932),
    [anon_sym_restrict] = ACTIONS(932),
    [anon_sym__Atomic] = ACTIONS(932),
    [anon_sym_signed] = ACTIONS(932),
    [anon_sym_unsigned] = ACTIONS(932),
    [anon_sym_long] = ACTIONS(932),
    [anon_sym_short] = ACTIONS(932),
    [sym_primitive_type] = ACTIONS(932),
    [anon_sym_enum] = ACTIONS(932),
    [anon_sym_struct] = ACTIONS(932),
    [anon_sym_union] = ACTIONS(932),
    [anon_sym_if] = ACTIONS(932),
    [anon_sym_else] = ACTIONS(932),
    [anon_sym_switch] = ACTIONS(932),
    [anon_sym_case] = ACTIONS(932),
    [anon_sym_default] = ACTIONS(932),
    [anon_sym_while] = ACTIONS(932),
    [anon_sym_do] = ACTIONS(932),
    [anon_sym_for] = ACTIONS(932),
    [anon_sym_return] = ACTIONS(932),
    [anon_sym_break] = ACTIONS(932),
    [anon_sym_continue] = ACTIONS(932),
    [anon_sym_goto] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_sizeof] = ACTIONS(932),
    [sym_number_literal] = ACTIONS(934),
    [anon_sym_L_SQUOTE] = ACTIONS(934),
    [anon_sym_u_SQUOTE] = ACTIONS(934),
    [anon_sym_U_SQUOTE] = ACTIONS(934),
    [anon_sym_u8_SQUOTE] = ACTIONS(934),
    [anon_sym_SQUOTE] = ACTIONS(934),
    [anon_sym_L_DQUOTE] = ACTIONS(934),
    [anon_sym_u_DQUOTE] = ACTIONS(934),
    [anon_sym_U_DQUOTE] = ACTIONS(934),
    [anon_sym_u8_DQUOTE] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(934),
    [sym_true] = ACTIONS(932),
    [sym_false] = ACTIONS(932),
    [sym_null] = ACTIONS(932),
    [sym_comment] = ACTIONS(3),
  },
  [151] = {
    [sym_identifier] = ACTIONS(922),
    [aux_sym_preproc_include_token1] = ACTIONS(922),
    [aux_sym_preproc_def_token1] = ACTIONS(922),
    [aux_sym_preproc_if_token1] = ACTIONS(922),
    [aux_sym_preproc_if_token2] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(922),
    [sym_preproc_directive] = ACTIONS(922),
    [anon_sym_LPAREN2] = ACTIONS(924),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(924),
    [anon_sym_typedef] = ACTIONS(922),
    [anon_sym_extern] = ACTIONS(922),
    [anon_sym___attribute__] = ACTIONS(922),
    [anon_sym___declspec] = ACTIONS(922),
    [anon_sym___cdecl] = ACTIONS(922),
    [anon_sym___clrcall] = ACTIONS(922),
    [anon_sym___stdcall] = ACTIONS(922),
    [anon_sym___fastcall] = ACTIONS(922),
    [anon_sym___thiscall] = ACTIONS(922),
    [anon_sym___vectorcall] = ACTIONS(922),
    [anon_sym_LBRACE] = ACTIONS(924),
    [anon_sym_static] = ACTIONS(922),
    [anon_sym_auto] = ACTIONS(922),
    [anon_sym_register] = ACTIONS(922),
    [anon_sym_inline] = ACTIONS(922),
    [anon_sym_const] = ACTIONS(922),
    [anon_sym_volatile] = ACTIONS(922),
    [anon_sym_restrict] = ACTIONS(922),
    [anon_sym__Atomic] = ACTIONS(922),
    [anon_sym_signed] = ACTIONS(922),
    [anon_sym_unsigned] = ACTIONS(922),
    [anon_sym_long] = ACTIONS(922),
    [anon_sym_short] = ACTIONS(922),
    [sym_primitive_type] = ACTIONS(922),
    [anon_sym_enum] = ACTIONS(922),
    [anon_sym_struct] = ACTIONS(922),
    [anon_sym_union] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(922),
    [anon_sym_else] = ACTIONS(922),
    [anon_sym_switch] = ACTIONS(922),
    [anon_sym_case] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(922),
    [anon_sym_while] = ACTIONS(922),
    [anon_sym_do] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(922),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(922),
    [anon_sym_goto] = ACTIONS(922),
    [anon_sym_DASH_DASH] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(924),
    [anon_sym_sizeof] = ACTIONS(922),
    [sym_number_literal] = ACTIONS(924),
    [anon_sym_L_SQUOTE] = ACTIONS(924),
    [anon_sym_u_SQUOTE] = ACTIONS(924),
    [anon_sym_U_SQUOTE] = ACTIONS(924),
    [anon_sym_u8_SQUOTE] = ACTIONS(924),
    [anon_sym_SQUOTE] = ACTIONS(924),
    [anon_sym_L_DQUOTE] = ACTIONS(924),
    [anon_sym_u_DQUOTE] = ACTIONS(924),
    [anon_sym_U_DQUOTE] = ACTIONS(924),
    [anon_sym_u8_DQUOTE] = ACTIONS(924),
    [anon_sym_DQUOTE] = ACTIONS(924),
    [sym_true] = ACTIONS(922),
    [sym_false] = ACTIONS(922),
    [sym_null] = ACTIONS(922),
    [sym_comment] = ACTIONS(3),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(990),
    [sym_identifier] = ACTIONS(988),
    [aux_sym_preproc_include_token1] = ACTIONS(988),
    [aux_sym_preproc_def_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token1] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(988),
    [sym_preproc_directive] = ACTIONS(988),
    [anon_sym_LPAREN2] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(990),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_SEMI] = ACTIONS(990),
    [anon_sym_typedef] = ACTIONS(988),
    [anon_sym_extern] = ACTIONS(988),
    [anon_sym___attribute__] = ACTIONS(988),
    [anon_sym___declspec] = ACTIONS(988),
    [anon_sym___cdecl] = ACTIONS(988),
    [anon_sym___clrcall] = ACTIONS(988),
    [anon_sym___stdcall] = ACTIONS(988),
    [anon_sym___fastcall] = ACTIONS(988),
    [anon_sym___thiscall] = ACTIONS(988),
    [anon_sym___vectorcall] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(990),
    [anon_sym_static] = ACTIONS(988),
    [anon_sym_auto] = ACTIONS(988),
    [anon_sym_register] = ACTIONS(988),
    [anon_sym_inline] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(988),
    [anon_sym_volatile] = ACTIONS(988),
    [anon_sym_restrict] = ACTIONS(988),
    [anon_sym__Atomic] = ACTIONS(988),
    [anon_sym_signed] = ACTIONS(988),
    [anon_sym_unsigned] = ACTIONS(988),
    [anon_sym_long] = ACTIONS(988),
    [anon_sym_short] = ACTIONS(988),
    [sym_primitive_type] = ACTIONS(988),
    [anon_sym_enum] = ACTIONS(988),
    [anon_sym_struct] = ACTIONS(988),
    [anon_sym_union] = ACTIONS(988),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(988),
    [anon_sym_switch] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(988),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_while] = ACTIONS(988),
    [anon_sym_do] = ACTIONS(988),
    [anon_sym_for] = ACTIONS(988),
    [anon_sym_return] = ACTIONS(988),
    [anon_sym_break] = ACTIONS(988),
    [anon_sym_continue] = ACTIONS(988),
    [anon_sym_goto] = ACTIONS(988),
    [anon_sym_DASH_DASH] = ACTIONS(990),
    [anon_sym_PLUS_PLUS] = ACTIONS(990),
    [anon_sym_sizeof] = ACTIONS(988),
    [sym_number_literal] = ACTIONS(990),
    [anon_sym_L_SQUOTE] = ACTIONS(990),
    [anon_sym_u_SQUOTE] = ACTIONS(990),
    [anon_sym_U_SQUOTE] = ACTIONS(990),
    [anon_sym_u8_SQUOTE] = ACTIONS(990),
    [anon_sym_SQUOTE] = ACTIONS(990),
    [anon_sym_L_DQUOTE] = ACTIONS(990),
    [anon_sym_u_DQUOTE] = ACTIONS(990),
    [anon_sym_U_DQUOTE] = ACTIONS(990),
    [anon_sym_u8_DQUOTE] = ACTIONS(990),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_true] = ACTIONS(988),
    [sym_false] = ACTIONS(988),
    [sym_null] = ACTIONS(988),
    [sym_comment] = ACTIONS(3),
  },
  [153] = {
    [ts_builtin_sym_end] = ACTIONS(958),
    [sym_identifier] = ACTIONS(956),
    [aux_sym_preproc_include_token1] = ACTIONS(956),
    [aux_sym_preproc_def_token1] = ACTIONS(956),
    [aux_sym_preproc_if_token1] = ACTIONS(956),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(956),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(956),
    [sym_preproc_directive] = ACTIONS(956),
    [anon_sym_LPAREN2] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(958),
    [anon_sym_AMP] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(958),
    [anon_sym_typedef] = ACTIONS(956),
    [anon_sym_extern] = ACTIONS(956),
    [anon_sym___attribute__] = ACTIONS(956),
    [anon_sym___declspec] = ACTIONS(956),
    [anon_sym___cdecl] = ACTIONS(956),
    [anon_sym___clrcall] = ACTIONS(956),
    [anon_sym___stdcall] = ACTIONS(956),
    [anon_sym___fastcall] = ACTIONS(956),
    [anon_sym___thiscall] = ACTIONS(956),
    [anon_sym___vectorcall] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_auto] = ACTIONS(956),
    [anon_sym_register] = ACTIONS(956),
    [anon_sym_inline] = ACTIONS(956),
    [anon_sym_const] = ACTIONS(956),
    [anon_sym_volatile] = ACTIONS(956),
    [anon_sym_restrict] = ACTIONS(956),
    [anon_sym__Atomic] = ACTIONS(956),
    [anon_sym_signed] = ACTIONS(956),
    [anon_sym_unsigned] = ACTIONS(956),
    [anon_sym_long] = ACTIONS(956),
    [anon_sym_short] = ACTIONS(956),
    [sym_primitive_type] = ACTIONS(956),
    [anon_sym_enum] = ACTIONS(956),
    [anon_sym_struct] = ACTIONS(956),
    [anon_sym_union] = ACTIONS(956),
    [anon_sym_if] = ACTIONS(956),
    [anon_sym_else] = ACTIONS(956),
    [anon_sym_switch] = ACTIONS(956),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_default] = ACTIONS(956),
    [anon_sym_while] = ACTIONS(956),
    [anon_sym_do] = ACTIONS(956),
    [anon_sym_for] = ACTIONS(956),
    [anon_sym_return] = ACTIONS(956),
    [anon_sym_break] = ACTIONS(956),
    [anon_sym_continue] = ACTIONS(956),
    [anon_sym_goto] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(956),
    [sym_number_literal] = ACTIONS(958),
    [anon_sym_L_SQUOTE] = ACTIONS(958),
    [anon_sym_u_SQUOTE] = ACTIONS(958),
    [anon_sym_U_SQUOTE] = ACTIONS(958),
    [anon_sym_u8_SQUOTE] = ACTIONS(958),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [anon_sym_L_DQUOTE] = ACTIONS(958),
    [anon_sym_u_DQUOTE] = ACTIONS(958),
    [anon_sym_U_DQUOTE] = ACTIONS(958),
    [anon_sym_u8_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [sym_true] = ACTIONS(956),
    [sym_false] = ACTIONS(956),
    [sym_null] = ACTIONS(956),
    [sym_comment] = ACTIONS(3),
  },
  [154] = {
    [sym_identifier] = ACTIONS(952),
    [aux_sym_preproc_include_token1] = ACTIONS(952),
    [aux_sym_preproc_def_token1] = ACTIONS(952),
    [aux_sym_preproc_if_token1] = ACTIONS(952),
    [aux_sym_preproc_if_token2] = ACTIONS(952),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(952),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(952),
    [sym_preproc_directive] = ACTIONS(952),
    [anon_sym_LPAREN2] = ACTIONS(954),
    [anon_sym_BANG] = ACTIONS(954),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_DASH] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(952),
    [anon_sym_STAR] = ACTIONS(954),
    [anon_sym_AMP] = ACTIONS(954),
    [anon_sym_SEMI] = ACTIONS(954),
    [anon_sym_typedef] = ACTIONS(952),
    [anon_sym_extern] = ACTIONS(952),
    [anon_sym___attribute__] = ACTIONS(952),
    [anon_sym___declspec] = ACTIONS(952),
    [anon_sym___cdecl] = ACTIONS(952),
    [anon_sym___clrcall] = ACTIONS(952),
    [anon_sym___stdcall] = ACTIONS(952),
    [anon_sym___fastcall] = ACTIONS(952),
    [anon_sym___thiscall] = ACTIONS(952),
    [anon_sym___vectorcall] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(954),
    [anon_sym_static] = ACTIONS(952),
    [anon_sym_auto] = ACTIONS(952),
    [anon_sym_register] = ACTIONS(952),
    [anon_sym_inline] = ACTIONS(952),
    [anon_sym_const] = ACTIONS(952),
    [anon_sym_volatile] = ACTIONS(952),
    [anon_sym_restrict] = ACTIONS(952),
    [anon_sym__Atomic] = ACTIONS(952),
    [anon_sym_signed] = ACTIONS(952),
    [anon_sym_unsigned] = ACTIONS(952),
    [anon_sym_long] = ACTIONS(952),
    [anon_sym_short] = ACTIONS(952),
    [sym_primitive_type] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(952),
    [anon_sym_struct] = ACTIONS(952),
    [anon_sym_union] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_else] = ACTIONS(952),
    [anon_sym_switch] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_default] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_do] = ACTIONS(952),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_return] = ACTIONS(952),
    [anon_sym_break] = ACTIONS(952),
    [anon_sym_continue] = ACTIONS(952),
    [anon_sym_goto] = ACTIONS(952),
    [anon_sym_DASH_DASH] = ACTIONS(954),
    [anon_sym_PLUS_PLUS] = ACTIONS(954),
    [anon_sym_sizeof] = ACTIONS(952),
    [sym_number_literal] = ACTIONS(954),
    [anon_sym_L_SQUOTE] = ACTIONS(954),
    [anon_sym_u_SQUOTE] = ACTIONS(954),
    [anon_sym_U_SQUOTE] = ACTIONS(954),
    [anon_sym_u8_SQUOTE] = ACTIONS(954),
    [anon_sym_SQUOTE] = ACTIONS(954),
    [anon_sym_L_DQUOTE] = ACTIONS(954),
    [anon_sym_u_DQUOTE] = ACTIONS(954),
    [anon_sym_U_DQUOTE] = ACTIONS(954),
    [anon_sym_u8_DQUOTE] = ACTIONS(954),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [sym_true] = ACTIONS(952),
    [sym_false] = ACTIONS(952),
    [sym_null] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [sym_identifier] = ACTIONS(948),
    [aux_sym_preproc_include_token1] = ACTIONS(948),
    [aux_sym_preproc_def_token1] = ACTIONS(948),
    [aux_sym_preproc_if_token1] = ACTIONS(948),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(948),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(948),
    [sym_preproc_directive] = ACTIONS(948),
    [anon_sym_LPAREN2] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(950),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_DASH] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_SEMI] = ACTIONS(950),
    [anon_sym_typedef] = ACTIONS(948),
    [anon_sym_extern] = ACTIONS(948),
    [anon_sym___attribute__] = ACTIONS(948),
    [anon_sym___declspec] = ACTIONS(948),
    [anon_sym___cdecl] = ACTIONS(948),
    [anon_sym___clrcall] = ACTIONS(948),
    [anon_sym___stdcall] = ACTIONS(948),
    [anon_sym___fastcall] = ACTIONS(948),
    [anon_sym___thiscall] = ACTIONS(948),
    [anon_sym___vectorcall] = ACTIONS(948),
    [anon_sym_LBRACE] = ACTIONS(950),
    [anon_sym_RBRACE] = ACTIONS(950),
    [anon_sym_static] = ACTIONS(948),
    [anon_sym_auto] = ACTIONS(948),
    [anon_sym_register] = ACTIONS(948),
    [anon_sym_inline] = ACTIONS(948),
    [anon_sym_const] = ACTIONS(948),
    [anon_sym_volatile] = ACTIONS(948),
    [anon_sym_restrict] = ACTIONS(948),
    [anon_sym__Atomic] = ACTIONS(948),
    [anon_sym_signed] = ACTIONS(948),
    [anon_sym_unsigned] = ACTIONS(948),
    [anon_sym_long] = ACTIONS(948),
    [anon_sym_short] = ACTIONS(948),
    [sym_primitive_type] = ACTIONS(948),
    [anon_sym_enum] = ACTIONS(948),
    [anon_sym_struct] = ACTIONS(948),
    [anon_sym_union] = ACTIONS(948),
    [anon_sym_if] = ACTIONS(948),
    [anon_sym_else] = ACTIONS(948),
    [anon_sym_switch] = ACTIONS(948),
    [anon_sym_case] = ACTIONS(948),
    [anon_sym_default] = ACTIONS(948),
    [anon_sym_while] = ACTIONS(948),
    [anon_sym_do] = ACTIONS(948),
    [anon_sym_for] = ACTIONS(948),
    [anon_sym_return] = ACTIONS(948),
    [anon_sym_break] = ACTIONS(948),
    [anon_sym_continue] = ACTIONS(948),
    [anon_sym_goto] = ACTIONS(948),
    [anon_sym_DASH_DASH] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(950),
    [anon_sym_sizeof] = ACTIONS(948),
    [sym_number_literal] = ACTIONS(950),
    [anon_sym_L_SQUOTE] = ACTIONS(950),
    [anon_sym_u_SQUOTE] = ACTIONS(950),
    [anon_sym_U_SQUOTE] = ACTIONS(950),
    [anon_sym_u8_SQUOTE] = ACTIONS(950),
    [anon_sym_SQUOTE] = ACTIONS(950),
    [anon_sym_L_DQUOTE] = ACTIONS(950),
    [anon_sym_u_DQUOTE] = ACTIONS(950),
    [anon_sym_U_DQUOTE] = ACTIONS(950),
    [anon_sym_u8_DQUOTE] = ACTIONS(950),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [sym_true] = ACTIONS(948),
    [sym_false] = ACTIONS(948),
    [sym_null] = ACTIONS(948),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [sym_identifier] = ACTIONS(980),
    [aux_sym_preproc_include_token1] = ACTIONS(980),
    [aux_sym_preproc_def_token1] = ACTIONS(980),
    [aux_sym_preproc_if_token1] = ACTIONS(980),
    [aux_sym_preproc_if_token2] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(980),
    [sym_preproc_directive] = ACTIONS(980),
    [anon_sym_LPAREN2] = ACTIONS(982),
    [anon_sym_BANG] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(980),
    [anon_sym_STAR] = ACTIONS(982),
    [anon_sym_AMP] = ACTIONS(982),
    [anon_sym_SEMI] = ACTIONS(982),
    [anon_sym_typedef] = ACTIONS(980),
    [anon_sym_extern] = ACTIONS(980),
    [anon_sym___attribute__] = ACTIONS(980),
    [anon_sym___declspec] = ACTIONS(980),
    [anon_sym___cdecl] = ACTIONS(980),
    [anon_sym___clrcall] = ACTIONS(980),
    [anon_sym___stdcall] = ACTIONS(980),
    [anon_sym___fastcall] = ACTIONS(980),
    [anon_sym___thiscall] = ACTIONS(980),
    [anon_sym___vectorcall] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(982),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_auto] = ACTIONS(980),
    [anon_sym_register] = ACTIONS(980),
    [anon_sym_inline] = ACTIONS(980),
    [anon_sym_const] = ACTIONS(980),
    [anon_sym_volatile] = ACTIONS(980),
    [anon_sym_restrict] = ACTIONS(980),
    [anon_sym__Atomic] = ACTIONS(980),
    [anon_sym_signed] = ACTIONS(980),
    [anon_sym_unsigned] = ACTIONS(980),
    [anon_sym_long] = ACTIONS(980),
    [anon_sym_short] = ACTIONS(980),
    [sym_primitive_type] = ACTIONS(980),
    [anon_sym_enum] = ACTIONS(980),
    [anon_sym_struct] = ACTIONS(980),
    [anon_sym_union] = ACTIONS(980),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_else] = ACTIONS(980),
    [anon_sym_switch] = ACTIONS(980),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_default] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [anon_sym_do] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_goto] = ACTIONS(980),
    [anon_sym_DASH_DASH] = ACTIONS(982),
    [anon_sym_PLUS_PLUS] = ACTIONS(982),
    [anon_sym_sizeof] = ACTIONS(980),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_L_SQUOTE] = ACTIONS(982),
    [anon_sym_u_SQUOTE] = ACTIONS(982),
    [anon_sym_U_SQUOTE] = ACTIONS(982),
    [anon_sym_u8_SQUOTE] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(982),
    [anon_sym_L_DQUOTE] = ACTIONS(982),
    [anon_sym_u_DQUOTE] = ACTIONS(982),
    [anon_sym_U_DQUOTE] = ACTIONS(982),
    [anon_sym_u8_DQUOTE] = ACTIONS(982),
    [anon_sym_DQUOTE] = ACTIONS(982),
    [sym_true] = ACTIONS(980),
    [sym_false] = ACTIONS(980),
    [sym_null] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [sym_identifier] = ACTIONS(1004),
    [aux_sym_preproc_include_token1] = ACTIONS(1004),
    [aux_sym_preproc_def_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token2] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1004),
    [sym_preproc_directive] = ACTIONS(1004),
    [anon_sym_LPAREN2] = ACTIONS(1006),
    [anon_sym_BANG] = ACTIONS(1006),
    [anon_sym_TILDE] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1006),
    [anon_sym_AMP] = ACTIONS(1006),
    [anon_sym_SEMI] = ACTIONS(1006),
    [anon_sym_typedef] = ACTIONS(1004),
    [anon_sym_extern] = ACTIONS(1004),
    [anon_sym___attribute__] = ACTIONS(1004),
    [anon_sym___declspec] = ACTIONS(1004),
    [anon_sym___cdecl] = ACTIONS(1004),
    [anon_sym___clrcall] = ACTIONS(1004),
    [anon_sym___stdcall] = ACTIONS(1004),
    [anon_sym___fastcall] = ACTIONS(1004),
    [anon_sym___thiscall] = ACTIONS(1004),
    [anon_sym___vectorcall] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1006),
    [anon_sym_static] = ACTIONS(1004),
    [anon_sym_auto] = ACTIONS(1004),
    [anon_sym_register] = ACTIONS(1004),
    [anon_sym_inline] = ACTIONS(1004),
    [anon_sym_const] = ACTIONS(1004),
    [anon_sym_volatile] = ACTIONS(1004),
    [anon_sym_restrict] = ACTIONS(1004),
    [anon_sym__Atomic] = ACTIONS(1004),
    [anon_sym_signed] = ACTIONS(1004),
    [anon_sym_unsigned] = ACTIONS(1004),
    [anon_sym_long] = ACTIONS(1004),
    [anon_sym_short] = ACTIONS(1004),
    [sym_primitive_type] = ACTIONS(1004),
    [anon_sym_enum] = ACTIONS(1004),
    [anon_sym_struct] = ACTIONS(1004),
    [anon_sym_union] = ACTIONS(1004),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(1004),
    [anon_sym_do] = ACTIONS(1004),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_return] = ACTIONS(1004),
    [anon_sym_break] = ACTIONS(1004),
    [anon_sym_continue] = ACTIONS(1004),
    [anon_sym_goto] = ACTIONS(1004),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_sizeof] = ACTIONS(1004),
    [sym_number_literal] = ACTIONS(1006),
    [anon_sym_L_SQUOTE] = ACTIONS(1006),
    [anon_sym_u_SQUOTE] = ACTIONS(1006),
    [anon_sym_U_SQUOTE] = ACTIONS(1006),
    [anon_sym_u8_SQUOTE] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1006),
    [anon_sym_L_DQUOTE] = ACTIONS(1006),
    [anon_sym_u_DQUOTE] = ACTIONS(1006),
    [anon_sym_U_DQUOTE] = ACTIONS(1006),
    [anon_sym_u8_DQUOTE] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1006),
    [sym_true] = ACTIONS(1004),
    [sym_false] = ACTIONS(1004),
    [sym_null] = ACTIONS(1004),
    [sym_comment] = ACTIONS(3),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(908),
    [sym_identifier] = ACTIONS(906),
    [aux_sym_preproc_include_token1] = ACTIONS(906),
    [aux_sym_preproc_def_token1] = ACTIONS(906),
    [aux_sym_preproc_if_token1] = ACTIONS(906),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(906),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(906),
    [sym_preproc_directive] = ACTIONS(906),
    [anon_sym_LPAREN2] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(908),
    [anon_sym_TILDE] = ACTIONS(908),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_STAR] = ACTIONS(908),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_SEMI] = ACTIONS(908),
    [anon_sym_typedef] = ACTIONS(906),
    [anon_sym_extern] = ACTIONS(906),
    [anon_sym___attribute__] = ACTIONS(906),
    [anon_sym___declspec] = ACTIONS(906),
    [anon_sym___cdecl] = ACTIONS(906),
    [anon_sym___clrcall] = ACTIONS(906),
    [anon_sym___stdcall] = ACTIONS(906),
    [anon_sym___fastcall] = ACTIONS(906),
    [anon_sym___thiscall] = ACTIONS(906),
    [anon_sym___vectorcall] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_static] = ACTIONS(906),
    [anon_sym_auto] = ACTIONS(906),
    [anon_sym_register] = ACTIONS(906),
    [anon_sym_inline] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(906),
    [anon_sym_volatile] = ACTIONS(906),
    [anon_sym_restrict] = ACTIONS(906),
    [anon_sym__Atomic] = ACTIONS(906),
    [anon_sym_signed] = ACTIONS(906),
    [anon_sym_unsigned] = ACTIONS(906),
    [anon_sym_long] = ACTIONS(906),
    [anon_sym_short] = ACTIONS(906),
    [sym_primitive_type] = ACTIONS(906),
    [anon_sym_enum] = ACTIONS(906),
    [anon_sym_struct] = ACTIONS(906),
    [anon_sym_union] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_else] = ACTIONS(906),
    [anon_sym_switch] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_default] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(906),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_return] = ACTIONS(906),
    [anon_sym_break] = ACTIONS(906),
    [anon_sym_continue] = ACTIONS(906),
    [anon_sym_goto] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_sizeof] = ACTIONS(906),
    [sym_number_literal] = ACTIONS(908),
    [anon_sym_L_SQUOTE] = ACTIONS(908),
    [anon_sym_u_SQUOTE] = ACTIONS(908),
    [anon_sym_U_SQUOTE] = ACTIONS(908),
    [anon_sym_u8_SQUOTE] = ACTIONS(908),
    [anon_sym_SQUOTE] = ACTIONS(908),
    [anon_sym_L_DQUOTE] = ACTIONS(908),
    [anon_sym_u_DQUOTE] = ACTIONS(908),
    [anon_sym_U_DQUOTE] = ACTIONS(908),
    [anon_sym_u8_DQUOTE] = ACTIONS(908),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [sym_true] = ACTIONS(906),
    [sym_false] = ACTIONS(906),
    [sym_null] = ACTIONS(906),
    [sym_comment] = ACTIONS(3),
  },
  [159] = {
    [sym_identifier] = ACTIONS(918),
    [aux_sym_preproc_include_token1] = ACTIONS(918),
    [aux_sym_preproc_def_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(918),
    [sym_preproc_directive] = ACTIONS(918),
    [anon_sym_LPAREN2] = ACTIONS(920),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_STAR] = ACTIONS(920),
    [anon_sym_AMP] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(920),
    [anon_sym_typedef] = ACTIONS(918),
    [anon_sym_extern] = ACTIONS(918),
    [anon_sym___attribute__] = ACTIONS(918),
    [anon_sym___declspec] = ACTIONS(918),
    [anon_sym___cdecl] = ACTIONS(918),
    [anon_sym___clrcall] = ACTIONS(918),
    [anon_sym___stdcall] = ACTIONS(918),
    [anon_sym___fastcall] = ACTIONS(918),
    [anon_sym___thiscall] = ACTIONS(918),
    [anon_sym___vectorcall] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_RBRACE] = ACTIONS(920),
    [anon_sym_static] = ACTIONS(918),
    [anon_sym_auto] = ACTIONS(918),
    [anon_sym_register] = ACTIONS(918),
    [anon_sym_inline] = ACTIONS(918),
    [anon_sym_const] = ACTIONS(918),
    [anon_sym_volatile] = ACTIONS(918),
    [anon_sym_restrict] = ACTIONS(918),
    [anon_sym__Atomic] = ACTIONS(918),
    [anon_sym_signed] = ACTIONS(918),
    [anon_sym_unsigned] = ACTIONS(918),
    [anon_sym_long] = ACTIONS(918),
    [anon_sym_short] = ACTIONS(918),
    [sym_primitive_type] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(918),
    [anon_sym_struct] = ACTIONS(918),
    [anon_sym_union] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(918),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_for] = ACTIONS(918),
    [anon_sym_return] = ACTIONS(918),
    [anon_sym_break] = ACTIONS(918),
    [anon_sym_continue] = ACTIONS(918),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(920),
    [anon_sym_sizeof] = ACTIONS(918),
    [sym_number_literal] = ACTIONS(920),
    [anon_sym_L_SQUOTE] = ACTIONS(920),
    [anon_sym_u_SQUOTE] = ACTIONS(920),
    [anon_sym_U_SQUOTE] = ACTIONS(920),
    [anon_sym_u8_SQUOTE] = ACTIONS(920),
    [anon_sym_SQUOTE] = ACTIONS(920),
    [anon_sym_L_DQUOTE] = ACTIONS(920),
    [anon_sym_u_DQUOTE] = ACTIONS(920),
    [anon_sym_U_DQUOTE] = ACTIONS(920),
    [anon_sym_u8_DQUOTE] = ACTIONS(920),
    [anon_sym_DQUOTE] = ACTIONS(920),
    [sym_true] = ACTIONS(918),
    [sym_false] = ACTIONS(918),
    [sym_null] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [sym_identifier] = ACTIONS(1008),
    [aux_sym_preproc_include_token1] = ACTIONS(1008),
    [aux_sym_preproc_def_token1] = ACTIONS(1008),
    [aux_sym_preproc_if_token1] = ACTIONS(1008),
    [aux_sym_preproc_if_token2] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1008),
    [sym_preproc_directive] = ACTIONS(1008),
    [anon_sym_LPAREN2] = ACTIONS(1010),
    [anon_sym_BANG] = ACTIONS(1010),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1010),
    [anon_sym_typedef] = ACTIONS(1008),
    [anon_sym_extern] = ACTIONS(1008),
    [anon_sym___attribute__] = ACTIONS(1008),
    [anon_sym___declspec] = ACTIONS(1008),
    [anon_sym___cdecl] = ACTIONS(1008),
    [anon_sym___clrcall] = ACTIONS(1008),
    [anon_sym___stdcall] = ACTIONS(1008),
    [anon_sym___fastcall] = ACTIONS(1008),
    [anon_sym___thiscall] = ACTIONS(1008),
    [anon_sym___vectorcall] = ACTIONS(1008),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_auto] = ACTIONS(1008),
    [anon_sym_register] = ACTIONS(1008),
    [anon_sym_inline] = ACTIONS(1008),
    [anon_sym_const] = ACTIONS(1008),
    [anon_sym_volatile] = ACTIONS(1008),
    [anon_sym_restrict] = ACTIONS(1008),
    [anon_sym__Atomic] = ACTIONS(1008),
    [anon_sym_signed] = ACTIONS(1008),
    [anon_sym_unsigned] = ACTIONS(1008),
    [anon_sym_long] = ACTIONS(1008),
    [anon_sym_short] = ACTIONS(1008),
    [sym_primitive_type] = ACTIONS(1008),
    [anon_sym_enum] = ACTIONS(1008),
    [anon_sym_struct] = ACTIONS(1008),
    [anon_sym_union] = ACTIONS(1008),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_else] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1008),
    [anon_sym_case] = ACTIONS(1008),
    [anon_sym_default] = ACTIONS(1008),
    [anon_sym_while] = ACTIONS(1008),
    [anon_sym_do] = ACTIONS(1008),
    [anon_sym_for] = ACTIONS(1008),
    [anon_sym_return] = ACTIONS(1008),
    [anon_sym_break] = ACTIONS(1008),
    [anon_sym_continue] = ACTIONS(1008),
    [anon_sym_goto] = ACTIONS(1008),
    [anon_sym_DASH_DASH] = ACTIONS(1010),
    [anon_sym_PLUS_PLUS] = ACTIONS(1010),
    [anon_sym_sizeof] = ACTIONS(1008),
    [sym_number_literal] = ACTIONS(1010),
    [anon_sym_L_SQUOTE] = ACTIONS(1010),
    [anon_sym_u_SQUOTE] = ACTIONS(1010),
    [anon_sym_U_SQUOTE] = ACTIONS(1010),
    [anon_sym_u8_SQUOTE] = ACTIONS(1010),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [anon_sym_L_DQUOTE] = ACTIONS(1010),
    [anon_sym_u_DQUOTE] = ACTIONS(1010),
    [anon_sym_U_DQUOTE] = ACTIONS(1010),
    [anon_sym_u8_DQUOTE] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [sym_true] = ACTIONS(1008),
    [sym_false] = ACTIONS(1008),
    [sym_null] = ACTIONS(1008),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [sym_identifier] = ACTIONS(1012),
    [aux_sym_preproc_include_token1] = ACTIONS(1012),
    [aux_sym_preproc_def_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token2] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1012),
    [sym_preproc_directive] = ACTIONS(1012),
    [anon_sym_LPAREN2] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_typedef] = ACTIONS(1012),
    [anon_sym_extern] = ACTIONS(1012),
    [anon_sym___attribute__] = ACTIONS(1012),
    [anon_sym___declspec] = ACTIONS(1012),
    [anon_sym___cdecl] = ACTIONS(1012),
    [anon_sym___clrcall] = ACTIONS(1012),
    [anon_sym___stdcall] = ACTIONS(1012),
    [anon_sym___fastcall] = ACTIONS(1012),
    [anon_sym___thiscall] = ACTIONS(1012),
    [anon_sym___vectorcall] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_auto] = ACTIONS(1012),
    [anon_sym_register] = ACTIONS(1012),
    [anon_sym_inline] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_volatile] = ACTIONS(1012),
    [anon_sym_restrict] = ACTIONS(1012),
    [anon_sym__Atomic] = ACTIONS(1012),
    [anon_sym_signed] = ACTIONS(1012),
    [anon_sym_unsigned] = ACTIONS(1012),
    [anon_sym_long] = ACTIONS(1012),
    [anon_sym_short] = ACTIONS(1012),
    [sym_primitive_type] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_goto] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_sizeof] = ACTIONS(1012),
    [sym_number_literal] = ACTIONS(1014),
    [anon_sym_L_SQUOTE] = ACTIONS(1014),
    [anon_sym_u_SQUOTE] = ACTIONS(1014),
    [anon_sym_U_SQUOTE] = ACTIONS(1014),
    [anon_sym_u8_SQUOTE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_L_DQUOTE] = ACTIONS(1014),
    [anon_sym_u_DQUOTE] = ACTIONS(1014),
    [anon_sym_U_DQUOTE] = ACTIONS(1014),
    [anon_sym_u8_DQUOTE] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(904),
    [sym_identifier] = ACTIONS(902),
    [aux_sym_preproc_include_token1] = ACTIONS(902),
    [aux_sym_preproc_def_token1] = ACTIONS(902),
    [aux_sym_preproc_if_token1] = ACTIONS(902),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(902),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(902),
    [sym_preproc_directive] = ACTIONS(902),
    [anon_sym_LPAREN2] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(904),
    [anon_sym_TILDE] = ACTIONS(904),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(904),
    [anon_sym_SEMI] = ACTIONS(904),
    [anon_sym_typedef] = ACTIONS(902),
    [anon_sym_extern] = ACTIONS(902),
    [anon_sym___attribute__] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(902),
    [anon_sym___cdecl] = ACTIONS(902),
    [anon_sym___clrcall] = ACTIONS(902),
    [anon_sym___stdcall] = ACTIONS(902),
    [anon_sym___fastcall] = ACTIONS(902),
    [anon_sym___thiscall] = ACTIONS(902),
    [anon_sym___vectorcall] = ACTIONS(902),
    [anon_sym_LBRACE] = ACTIONS(904),
    [anon_sym_static] = ACTIONS(902),
    [anon_sym_auto] = ACTIONS(902),
    [anon_sym_register] = ACTIONS(902),
    [anon_sym_inline] = ACTIONS(902),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_volatile] = ACTIONS(902),
    [anon_sym_restrict] = ACTIONS(902),
    [anon_sym__Atomic] = ACTIONS(902),
    [anon_sym_signed] = ACTIONS(902),
    [anon_sym_unsigned] = ACTIONS(902),
    [anon_sym_long] = ACTIONS(902),
    [anon_sym_short] = ACTIONS(902),
    [sym_primitive_type] = ACTIONS(902),
    [anon_sym_enum] = ACTIONS(902),
    [anon_sym_struct] = ACTIONS(902),
    [anon_sym_union] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(902),
    [anon_sym_else] = ACTIONS(902),
    [anon_sym_switch] = ACTIONS(902),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(902),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_do] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(902),
    [anon_sym_return] = ACTIONS(902),
    [anon_sym_break] = ACTIONS(902),
    [anon_sym_continue] = ACTIONS(902),
    [anon_sym_goto] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(904),
    [anon_sym_PLUS_PLUS] = ACTIONS(904),
    [anon_sym_sizeof] = ACTIONS(902),
    [sym_number_literal] = ACTIONS(904),
    [anon_sym_L_SQUOTE] = ACTIONS(904),
    [anon_sym_u_SQUOTE] = ACTIONS(904),
    [anon_sym_U_SQUOTE] = ACTIONS(904),
    [anon_sym_u8_SQUOTE] = ACTIONS(904),
    [anon_sym_SQUOTE] = ACTIONS(904),
    [anon_sym_L_DQUOTE] = ACTIONS(904),
    [anon_sym_u_DQUOTE] = ACTIONS(904),
    [anon_sym_U_DQUOTE] = ACTIONS(904),
    [anon_sym_u8_DQUOTE] = ACTIONS(904),
    [anon_sym_DQUOTE] = ACTIONS(904),
    [sym_true] = ACTIONS(902),
    [sym_false] = ACTIONS(902),
    [sym_null] = ACTIONS(902),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [sym_identifier] = ACTIONS(956),
    [aux_sym_preproc_include_token1] = ACTIONS(956),
    [aux_sym_preproc_def_token1] = ACTIONS(956),
    [aux_sym_preproc_if_token1] = ACTIONS(956),
    [aux_sym_preproc_if_token2] = ACTIONS(956),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(956),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(956),
    [sym_preproc_directive] = ACTIONS(956),
    [anon_sym_LPAREN2] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(958),
    [anon_sym_AMP] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(958),
    [anon_sym_typedef] = ACTIONS(956),
    [anon_sym_extern] = ACTIONS(956),
    [anon_sym___attribute__] = ACTIONS(956),
    [anon_sym___declspec] = ACTIONS(956),
    [anon_sym___cdecl] = ACTIONS(956),
    [anon_sym___clrcall] = ACTIONS(956),
    [anon_sym___stdcall] = ACTIONS(956),
    [anon_sym___fastcall] = ACTIONS(956),
    [anon_sym___thiscall] = ACTIONS(956),
    [anon_sym___vectorcall] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_auto] = ACTIONS(956),
    [anon_sym_register] = ACTIONS(956),
    [anon_sym_inline] = ACTIONS(956),
    [anon_sym_const] = ACTIONS(956),
    [anon_sym_volatile] = ACTIONS(956),
    [anon_sym_restrict] = ACTIONS(956),
    [anon_sym__Atomic] = ACTIONS(956),
    [anon_sym_signed] = ACTIONS(956),
    [anon_sym_unsigned] = ACTIONS(956),
    [anon_sym_long] = ACTIONS(956),
    [anon_sym_short] = ACTIONS(956),
    [sym_primitive_type] = ACTIONS(956),
    [anon_sym_enum] = ACTIONS(956),
    [anon_sym_struct] = ACTIONS(956),
    [anon_sym_union] = ACTIONS(956),
    [anon_sym_if] = ACTIONS(956),
    [anon_sym_else] = ACTIONS(956),
    [anon_sym_switch] = ACTIONS(956),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_default] = ACTIONS(956),
    [anon_sym_while] = ACTIONS(956),
    [anon_sym_do] = ACTIONS(956),
    [anon_sym_for] = ACTIONS(956),
    [anon_sym_return] = ACTIONS(956),
    [anon_sym_break] = ACTIONS(956),
    [anon_sym_continue] = ACTIONS(956),
    [anon_sym_goto] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(956),
    [sym_number_literal] = ACTIONS(958),
    [anon_sym_L_SQUOTE] = ACTIONS(958),
    [anon_sym_u_SQUOTE] = ACTIONS(958),
    [anon_sym_U_SQUOTE] = ACTIONS(958),
    [anon_sym_u8_SQUOTE] = ACTIONS(958),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [anon_sym_L_DQUOTE] = ACTIONS(958),
    [anon_sym_u_DQUOTE] = ACTIONS(958),
    [anon_sym_U_DQUOTE] = ACTIONS(958),
    [anon_sym_u8_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [sym_true] = ACTIONS(956),
    [sym_false] = ACTIONS(956),
    [sym_null] = ACTIONS(956),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [sym_identifier] = ACTIONS(944),
    [aux_sym_preproc_include_token1] = ACTIONS(944),
    [aux_sym_preproc_def_token1] = ACTIONS(944),
    [aux_sym_preproc_if_token1] = ACTIONS(944),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(944),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(944),
    [sym_preproc_directive] = ACTIONS(944),
    [anon_sym_LPAREN2] = ACTIONS(946),
    [anon_sym_BANG] = ACTIONS(946),
    [anon_sym_TILDE] = ACTIONS(946),
    [anon_sym_DASH] = ACTIONS(944),
    [anon_sym_PLUS] = ACTIONS(944),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_AMP] = ACTIONS(946),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_typedef] = ACTIONS(944),
    [anon_sym_extern] = ACTIONS(944),
    [anon_sym___attribute__] = ACTIONS(944),
    [anon_sym___declspec] = ACTIONS(944),
    [anon_sym___cdecl] = ACTIONS(944),
    [anon_sym___clrcall] = ACTIONS(944),
    [anon_sym___stdcall] = ACTIONS(944),
    [anon_sym___fastcall] = ACTIONS(944),
    [anon_sym___thiscall] = ACTIONS(944),
    [anon_sym___vectorcall] = ACTIONS(944),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_RBRACE] = ACTIONS(946),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_auto] = ACTIONS(944),
    [anon_sym_register] = ACTIONS(944),
    [anon_sym_inline] = ACTIONS(944),
    [anon_sym_const] = ACTIONS(944),
    [anon_sym_volatile] = ACTIONS(944),
    [anon_sym_restrict] = ACTIONS(944),
    [anon_sym__Atomic] = ACTIONS(944),
    [anon_sym_signed] = ACTIONS(944),
    [anon_sym_unsigned] = ACTIONS(944),
    [anon_sym_long] = ACTIONS(944),
    [anon_sym_short] = ACTIONS(944),
    [sym_primitive_type] = ACTIONS(944),
    [anon_sym_enum] = ACTIONS(944),
    [anon_sym_struct] = ACTIONS(944),
    [anon_sym_union] = ACTIONS(944),
    [anon_sym_if] = ACTIONS(944),
    [anon_sym_else] = ACTIONS(944),
    [anon_sym_switch] = ACTIONS(944),
    [anon_sym_case] = ACTIONS(944),
    [anon_sym_default] = ACTIONS(944),
    [anon_sym_while] = ACTIONS(944),
    [anon_sym_do] = ACTIONS(944),
    [anon_sym_for] = ACTIONS(944),
    [anon_sym_return] = ACTIONS(944),
    [anon_sym_break] = ACTIONS(944),
    [anon_sym_continue] = ACTIONS(944),
    [anon_sym_goto] = ACTIONS(944),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_sizeof] = ACTIONS(944),
    [sym_number_literal] = ACTIONS(946),
    [anon_sym_L_SQUOTE] = ACTIONS(946),
    [anon_sym_u_SQUOTE] = ACTIONS(946),
    [anon_sym_U_SQUOTE] = ACTIONS(946),
    [anon_sym_u8_SQUOTE] = ACTIONS(946),
    [anon_sym_SQUOTE] = ACTIONS(946),
    [anon_sym_L_DQUOTE] = ACTIONS(946),
    [anon_sym_u_DQUOTE] = ACTIONS(946),
    [anon_sym_U_DQUOTE] = ACTIONS(946),
    [anon_sym_u8_DQUOTE] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(946),
    [sym_true] = ACTIONS(944),
    [sym_false] = ACTIONS(944),
    [sym_null] = ACTIONS(944),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [ts_builtin_sym_end] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1012),
    [aux_sym_preproc_include_token1] = ACTIONS(1012),
    [aux_sym_preproc_def_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1012),
    [sym_preproc_directive] = ACTIONS(1012),
    [anon_sym_LPAREN2] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_typedef] = ACTIONS(1012),
    [anon_sym_extern] = ACTIONS(1012),
    [anon_sym___attribute__] = ACTIONS(1012),
    [anon_sym___declspec] = ACTIONS(1012),
    [anon_sym___cdecl] = ACTIONS(1012),
    [anon_sym___clrcall] = ACTIONS(1012),
    [anon_sym___stdcall] = ACTIONS(1012),
    [anon_sym___fastcall] = ACTIONS(1012),
    [anon_sym___thiscall] = ACTIONS(1012),
    [anon_sym___vectorcall] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_auto] = ACTIONS(1012),
    [anon_sym_register] = ACTIONS(1012),
    [anon_sym_inline] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_volatile] = ACTIONS(1012),
    [anon_sym_restrict] = ACTIONS(1012),
    [anon_sym__Atomic] = ACTIONS(1012),
    [anon_sym_signed] = ACTIONS(1012),
    [anon_sym_unsigned] = ACTIONS(1012),
    [anon_sym_long] = ACTIONS(1012),
    [anon_sym_short] = ACTIONS(1012),
    [sym_primitive_type] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_goto] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_sizeof] = ACTIONS(1012),
    [sym_number_literal] = ACTIONS(1014),
    [anon_sym_L_SQUOTE] = ACTIONS(1014),
    [anon_sym_u_SQUOTE] = ACTIONS(1014),
    [anon_sym_U_SQUOTE] = ACTIONS(1014),
    [anon_sym_u8_SQUOTE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_L_DQUOTE] = ACTIONS(1014),
    [anon_sym_u_DQUOTE] = ACTIONS(1014),
    [anon_sym_U_DQUOTE] = ACTIONS(1014),
    [anon_sym_u8_DQUOTE] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [sym_identifier] = ACTIONS(996),
    [aux_sym_preproc_include_token1] = ACTIONS(996),
    [aux_sym_preproc_def_token1] = ACTIONS(996),
    [aux_sym_preproc_if_token1] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(996),
    [sym_preproc_directive] = ACTIONS(996),
    [anon_sym_LPAREN2] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(998),
    [anon_sym_AMP] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(998),
    [anon_sym_typedef] = ACTIONS(996),
    [anon_sym_extern] = ACTIONS(996),
    [anon_sym___attribute__] = ACTIONS(996),
    [anon_sym___declspec] = ACTIONS(996),
    [anon_sym___cdecl] = ACTIONS(996),
    [anon_sym___clrcall] = ACTIONS(996),
    [anon_sym___stdcall] = ACTIONS(996),
    [anon_sym___fastcall] = ACTIONS(996),
    [anon_sym___thiscall] = ACTIONS(996),
    [anon_sym___vectorcall] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_RBRACE] = ACTIONS(998),
    [anon_sym_static] = ACTIONS(996),
    [anon_sym_auto] = ACTIONS(996),
    [anon_sym_register] = ACTIONS(996),
    [anon_sym_inline] = ACTIONS(996),
    [anon_sym_const] = ACTIONS(996),
    [anon_sym_volatile] = ACTIONS(996),
    [anon_sym_restrict] = ACTIONS(996),
    [anon_sym__Atomic] = ACTIONS(996),
    [anon_sym_signed] = ACTIONS(996),
    [anon_sym_unsigned] = ACTIONS(996),
    [anon_sym_long] = ACTIONS(996),
    [anon_sym_short] = ACTIONS(996),
    [sym_primitive_type] = ACTIONS(996),
    [anon_sym_enum] = ACTIONS(996),
    [anon_sym_struct] = ACTIONS(996),
    [anon_sym_union] = ACTIONS(996),
    [anon_sym_if] = ACTIONS(996),
    [anon_sym_else] = ACTIONS(996),
    [anon_sym_switch] = ACTIONS(996),
    [anon_sym_case] = ACTIONS(996),
    [anon_sym_default] = ACTIONS(996),
    [anon_sym_while] = ACTIONS(996),
    [anon_sym_do] = ACTIONS(996),
    [anon_sym_for] = ACTIONS(996),
    [anon_sym_return] = ACTIONS(996),
    [anon_sym_break] = ACTIONS(996),
    [anon_sym_continue] = ACTIONS(996),
    [anon_sym_goto] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(996),
    [sym_number_literal] = ACTIONS(998),
    [anon_sym_L_SQUOTE] = ACTIONS(998),
    [anon_sym_u_SQUOTE] = ACTIONS(998),
    [anon_sym_U_SQUOTE] = ACTIONS(998),
    [anon_sym_u8_SQUOTE] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(998),
    [anon_sym_L_DQUOTE] = ACTIONS(998),
    [anon_sym_u_DQUOTE] = ACTIONS(998),
    [anon_sym_U_DQUOTE] = ACTIONS(998),
    [anon_sym_u8_DQUOTE] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(998),
    [sym_true] = ACTIONS(996),
    [sym_false] = ACTIONS(996),
    [sym_null] = ACTIONS(996),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [sym_identifier] = ACTIONS(906),
    [aux_sym_preproc_include_token1] = ACTIONS(906),
    [aux_sym_preproc_def_token1] = ACTIONS(906),
    [aux_sym_preproc_if_token1] = ACTIONS(906),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(906),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(906),
    [sym_preproc_directive] = ACTIONS(906),
    [anon_sym_LPAREN2] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(908),
    [anon_sym_TILDE] = ACTIONS(908),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_STAR] = ACTIONS(908),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_SEMI] = ACTIONS(908),
    [anon_sym_typedef] = ACTIONS(906),
    [anon_sym_extern] = ACTIONS(906),
    [anon_sym___attribute__] = ACTIONS(906),
    [anon_sym___declspec] = ACTIONS(906),
    [anon_sym___cdecl] = ACTIONS(906),
    [anon_sym___clrcall] = ACTIONS(906),
    [anon_sym___stdcall] = ACTIONS(906),
    [anon_sym___fastcall] = ACTIONS(906),
    [anon_sym___thiscall] = ACTIONS(906),
    [anon_sym___vectorcall] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_RBRACE] = ACTIONS(908),
    [anon_sym_static] = ACTIONS(906),
    [anon_sym_auto] = ACTIONS(906),
    [anon_sym_register] = ACTIONS(906),
    [anon_sym_inline] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(906),
    [anon_sym_volatile] = ACTIONS(906),
    [anon_sym_restrict] = ACTIONS(906),
    [anon_sym__Atomic] = ACTIONS(906),
    [anon_sym_signed] = ACTIONS(906),
    [anon_sym_unsigned] = ACTIONS(906),
    [anon_sym_long] = ACTIONS(906),
    [anon_sym_short] = ACTIONS(906),
    [sym_primitive_type] = ACTIONS(906),
    [anon_sym_enum] = ACTIONS(906),
    [anon_sym_struct] = ACTIONS(906),
    [anon_sym_union] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_else] = ACTIONS(906),
    [anon_sym_switch] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_default] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(906),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_return] = ACTIONS(906),
    [anon_sym_break] = ACTIONS(906),
    [anon_sym_continue] = ACTIONS(906),
    [anon_sym_goto] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_sizeof] = ACTIONS(906),
    [sym_number_literal] = ACTIONS(908),
    [anon_sym_L_SQUOTE] = ACTIONS(908),
    [anon_sym_u_SQUOTE] = ACTIONS(908),
    [anon_sym_U_SQUOTE] = ACTIONS(908),
    [anon_sym_u8_SQUOTE] = ACTIONS(908),
    [anon_sym_SQUOTE] = ACTIONS(908),
    [anon_sym_L_DQUOTE] = ACTIONS(908),
    [anon_sym_u_DQUOTE] = ACTIONS(908),
    [anon_sym_U_DQUOTE] = ACTIONS(908),
    [anon_sym_u8_DQUOTE] = ACTIONS(908),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [sym_true] = ACTIONS(906),
    [sym_false] = ACTIONS(906),
    [sym_null] = ACTIONS(906),
    [sym_comment] = ACTIONS(3),
  },
  [168] = {
    [ts_builtin_sym_end] = ACTIONS(1010),
    [sym_identifier] = ACTIONS(1008),
    [aux_sym_preproc_include_token1] = ACTIONS(1008),
    [aux_sym_preproc_def_token1] = ACTIONS(1008),
    [aux_sym_preproc_if_token1] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1008),
    [sym_preproc_directive] = ACTIONS(1008),
    [anon_sym_LPAREN2] = ACTIONS(1010),
    [anon_sym_BANG] = ACTIONS(1010),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1010),
    [anon_sym_typedef] = ACTIONS(1008),
    [anon_sym_extern] = ACTIONS(1008),
    [anon_sym___attribute__] = ACTIONS(1008),
    [anon_sym___declspec] = ACTIONS(1008),
    [anon_sym___cdecl] = ACTIONS(1008),
    [anon_sym___clrcall] = ACTIONS(1008),
    [anon_sym___stdcall] = ACTIONS(1008),
    [anon_sym___fastcall] = ACTIONS(1008),
    [anon_sym___thiscall] = ACTIONS(1008),
    [anon_sym___vectorcall] = ACTIONS(1008),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_auto] = ACTIONS(1008),
    [anon_sym_register] = ACTIONS(1008),
    [anon_sym_inline] = ACTIONS(1008),
    [anon_sym_const] = ACTIONS(1008),
    [anon_sym_volatile] = ACTIONS(1008),
    [anon_sym_restrict] = ACTIONS(1008),
    [anon_sym__Atomic] = ACTIONS(1008),
    [anon_sym_signed] = ACTIONS(1008),
    [anon_sym_unsigned] = ACTIONS(1008),
    [anon_sym_long] = ACTIONS(1008),
    [anon_sym_short] = ACTIONS(1008),
    [sym_primitive_type] = ACTIONS(1008),
    [anon_sym_enum] = ACTIONS(1008),
    [anon_sym_struct] = ACTIONS(1008),
    [anon_sym_union] = ACTIONS(1008),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_else] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1008),
    [anon_sym_case] = ACTIONS(1008),
    [anon_sym_default] = ACTIONS(1008),
    [anon_sym_while] = ACTIONS(1008),
    [anon_sym_do] = ACTIONS(1008),
    [anon_sym_for] = ACTIONS(1008),
    [anon_sym_return] = ACTIONS(1008),
    [anon_sym_break] = ACTIONS(1008),
    [anon_sym_continue] = ACTIONS(1008),
    [anon_sym_goto] = ACTIONS(1008),
    [anon_sym_DASH_DASH] = ACTIONS(1010),
    [anon_sym_PLUS_PLUS] = ACTIONS(1010),
    [anon_sym_sizeof] = ACTIONS(1008),
    [sym_number_literal] = ACTIONS(1010),
    [anon_sym_L_SQUOTE] = ACTIONS(1010),
    [anon_sym_u_SQUOTE] = ACTIONS(1010),
    [anon_sym_U_SQUOTE] = ACTIONS(1010),
    [anon_sym_u8_SQUOTE] = ACTIONS(1010),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [anon_sym_L_DQUOTE] = ACTIONS(1010),
    [anon_sym_u_DQUOTE] = ACTIONS(1010),
    [anon_sym_U_DQUOTE] = ACTIONS(1010),
    [anon_sym_u8_DQUOTE] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [sym_true] = ACTIONS(1008),
    [sym_false] = ACTIONS(1008),
    [sym_null] = ACTIONS(1008),
    [sym_comment] = ACTIONS(3),
  },
  [169] = {
    [sym_identifier] = ACTIONS(988),
    [aux_sym_preproc_include_token1] = ACTIONS(988),
    [aux_sym_preproc_def_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token2] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(988),
    [sym_preproc_directive] = ACTIONS(988),
    [anon_sym_LPAREN2] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(990),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_SEMI] = ACTIONS(990),
    [anon_sym_typedef] = ACTIONS(988),
    [anon_sym_extern] = ACTIONS(988),
    [anon_sym___attribute__] = ACTIONS(988),
    [anon_sym___declspec] = ACTIONS(988),
    [anon_sym___cdecl] = ACTIONS(988),
    [anon_sym___clrcall] = ACTIONS(988),
    [anon_sym___stdcall] = ACTIONS(988),
    [anon_sym___fastcall] = ACTIONS(988),
    [anon_sym___thiscall] = ACTIONS(988),
    [anon_sym___vectorcall] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(990),
    [anon_sym_static] = ACTIONS(988),
    [anon_sym_auto] = ACTIONS(988),
    [anon_sym_register] = ACTIONS(988),
    [anon_sym_inline] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(988),
    [anon_sym_volatile] = ACTIONS(988),
    [anon_sym_restrict] = ACTIONS(988),
    [anon_sym__Atomic] = ACTIONS(988),
    [anon_sym_signed] = ACTIONS(988),
    [anon_sym_unsigned] = ACTIONS(988),
    [anon_sym_long] = ACTIONS(988),
    [anon_sym_short] = ACTIONS(988),
    [sym_primitive_type] = ACTIONS(988),
    [anon_sym_enum] = ACTIONS(988),
    [anon_sym_struct] = ACTIONS(988),
    [anon_sym_union] = ACTIONS(988),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(988),
    [anon_sym_switch] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(988),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_while] = ACTIONS(988),
    [anon_sym_do] = ACTIONS(988),
    [anon_sym_for] = ACTIONS(988),
    [anon_sym_return] = ACTIONS(988),
    [anon_sym_break] = ACTIONS(988),
    [anon_sym_continue] = ACTIONS(988),
    [anon_sym_goto] = ACTIONS(988),
    [anon_sym_DASH_DASH] = ACTIONS(990),
    [anon_sym_PLUS_PLUS] = ACTIONS(990),
    [anon_sym_sizeof] = ACTIONS(988),
    [sym_number_literal] = ACTIONS(990),
    [anon_sym_L_SQUOTE] = ACTIONS(990),
    [anon_sym_u_SQUOTE] = ACTIONS(990),
    [anon_sym_U_SQUOTE] = ACTIONS(990),
    [anon_sym_u8_SQUOTE] = ACTIONS(990),
    [anon_sym_SQUOTE] = ACTIONS(990),
    [anon_sym_L_DQUOTE] = ACTIONS(990),
    [anon_sym_u_DQUOTE] = ACTIONS(990),
    [anon_sym_U_DQUOTE] = ACTIONS(990),
    [anon_sym_u8_DQUOTE] = ACTIONS(990),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_true] = ACTIONS(988),
    [sym_false] = ACTIONS(988),
    [sym_null] = ACTIONS(988),
    [sym_comment] = ACTIONS(3),
  },
  [170] = {
    [sym_identifier] = ACTIONS(910),
    [aux_sym_preproc_include_token1] = ACTIONS(910),
    [aux_sym_preproc_def_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token2] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(910),
    [sym_preproc_directive] = ACTIONS(910),
    [anon_sym_LPAREN2] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_typedef] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym___attribute__] = ACTIONS(910),
    [anon_sym___declspec] = ACTIONS(910),
    [anon_sym___cdecl] = ACTIONS(910),
    [anon_sym___clrcall] = ACTIONS(910),
    [anon_sym___stdcall] = ACTIONS(910),
    [anon_sym___fastcall] = ACTIONS(910),
    [anon_sym___thiscall] = ACTIONS(910),
    [anon_sym___vectorcall] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_auto] = ACTIONS(910),
    [anon_sym_register] = ACTIONS(910),
    [anon_sym_inline] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_restrict] = ACTIONS(910),
    [anon_sym__Atomic] = ACTIONS(910),
    [anon_sym_signed] = ACTIONS(910),
    [anon_sym_unsigned] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [sym_primitive_type] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_goto] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_sizeof] = ACTIONS(910),
    [sym_number_literal] = ACTIONS(912),
    [anon_sym_L_SQUOTE] = ACTIONS(912),
    [anon_sym_u_SQUOTE] = ACTIONS(912),
    [anon_sym_U_SQUOTE] = ACTIONS(912),
    [anon_sym_u8_SQUOTE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(912),
    [anon_sym_L_DQUOTE] = ACTIONS(912),
    [anon_sym_u_DQUOTE] = ACTIONS(912),
    [anon_sym_U_DQUOTE] = ACTIONS(912),
    [anon_sym_u8_DQUOTE] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(912),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
  },
  [171] = {
    [sym_identifier] = ACTIONS(910),
    [aux_sym_preproc_include_token1] = ACTIONS(910),
    [aux_sym_preproc_def_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token2] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(910),
    [sym_preproc_directive] = ACTIONS(910),
    [anon_sym_LPAREN2] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_typedef] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym___attribute__] = ACTIONS(910),
    [anon_sym___declspec] = ACTIONS(910),
    [anon_sym___cdecl] = ACTIONS(910),
    [anon_sym___clrcall] = ACTIONS(910),
    [anon_sym___stdcall] = ACTIONS(910),
    [anon_sym___fastcall] = ACTIONS(910),
    [anon_sym___thiscall] = ACTIONS(910),
    [anon_sym___vectorcall] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_auto] = ACTIONS(910),
    [anon_sym_register] = ACTIONS(910),
    [anon_sym_inline] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_restrict] = ACTIONS(910),
    [anon_sym__Atomic] = ACTIONS(910),
    [anon_sym_signed] = ACTIONS(910),
    [anon_sym_unsigned] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [sym_primitive_type] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_goto] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_sizeof] = ACTIONS(910),
    [sym_number_literal] = ACTIONS(912),
    [anon_sym_L_SQUOTE] = ACTIONS(912),
    [anon_sym_u_SQUOTE] = ACTIONS(912),
    [anon_sym_U_SQUOTE] = ACTIONS(912),
    [anon_sym_u8_SQUOTE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(912),
    [anon_sym_L_DQUOTE] = ACTIONS(912),
    [anon_sym_u_DQUOTE] = ACTIONS(912),
    [anon_sym_U_DQUOTE] = ACTIONS(912),
    [anon_sym_u8_DQUOTE] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(912),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
  },
  [172] = {
    [sym_identifier] = ACTIONS(1020),
    [aux_sym_preproc_include_token1] = ACTIONS(1020),
    [aux_sym_preproc_def_token1] = ACTIONS(1020),
    [aux_sym_preproc_if_token1] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1020),
    [sym_preproc_directive] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1022),
    [anon_sym_TILDE] = ACTIONS(1022),
    [anon_sym_DASH] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1020),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_AMP] = ACTIONS(1022),
    [anon_sym_SEMI] = ACTIONS(1022),
    [anon_sym_typedef] = ACTIONS(1020),
    [anon_sym_extern] = ACTIONS(1020),
    [anon_sym___attribute__] = ACTIONS(1020),
    [anon_sym___declspec] = ACTIONS(1020),
    [anon_sym___cdecl] = ACTIONS(1020),
    [anon_sym___clrcall] = ACTIONS(1020),
    [anon_sym___stdcall] = ACTIONS(1020),
    [anon_sym___fastcall] = ACTIONS(1020),
    [anon_sym___thiscall] = ACTIONS(1020),
    [anon_sym___vectorcall] = ACTIONS(1020),
    [anon_sym_LBRACE] = ACTIONS(1022),
    [anon_sym_RBRACE] = ACTIONS(1022),
    [anon_sym_static] = ACTIONS(1020),
    [anon_sym_auto] = ACTIONS(1020),
    [anon_sym_register] = ACTIONS(1020),
    [anon_sym_inline] = ACTIONS(1020),
    [anon_sym_const] = ACTIONS(1020),
    [anon_sym_volatile] = ACTIONS(1020),
    [anon_sym_restrict] = ACTIONS(1020),
    [anon_sym__Atomic] = ACTIONS(1020),
    [anon_sym_signed] = ACTIONS(1020),
    [anon_sym_unsigned] = ACTIONS(1020),
    [anon_sym_long] = ACTIONS(1020),
    [anon_sym_short] = ACTIONS(1020),
    [sym_primitive_type] = ACTIONS(1020),
    [anon_sym_enum] = ACTIONS(1020),
    [anon_sym_struct] = ACTIONS(1020),
    [anon_sym_union] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_switch] = ACTIONS(1020),
    [anon_sym_case] = ACTIONS(1020),
    [anon_sym_default] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_goto] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1022),
    [anon_sym_PLUS_PLUS] = ACTIONS(1022),
    [anon_sym_sizeof] = ACTIONS(1020),
    [sym_number_literal] = ACTIONS(1022),
    [anon_sym_L_SQUOTE] = ACTIONS(1022),
    [anon_sym_u_SQUOTE] = ACTIONS(1022),
    [anon_sym_U_SQUOTE] = ACTIONS(1022),
    [anon_sym_u8_SQUOTE] = ACTIONS(1022),
    [anon_sym_SQUOTE] = ACTIONS(1022),
    [anon_sym_L_DQUOTE] = ACTIONS(1022),
    [anon_sym_u_DQUOTE] = ACTIONS(1022),
    [anon_sym_U_DQUOTE] = ACTIONS(1022),
    [anon_sym_u8_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [sym_true] = ACTIONS(1020),
    [sym_false] = ACTIONS(1020),
    [sym_null] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
  },
  [173] = {
    [sym_identifier] = ACTIONS(1016),
    [aux_sym_preproc_include_token1] = ACTIONS(1016),
    [aux_sym_preproc_def_token1] = ACTIONS(1016),
    [aux_sym_preproc_if_token1] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1016),
    [sym_preproc_directive] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1018),
    [anon_sym_BANG] = ACTIONS(1018),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1016),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_AMP] = ACTIONS(1018),
    [anon_sym_SEMI] = ACTIONS(1018),
    [anon_sym_typedef] = ACTIONS(1016),
    [anon_sym_extern] = ACTIONS(1016),
    [anon_sym___attribute__] = ACTIONS(1016),
    [anon_sym___declspec] = ACTIONS(1016),
    [anon_sym___cdecl] = ACTIONS(1016),
    [anon_sym___clrcall] = ACTIONS(1016),
    [anon_sym___stdcall] = ACTIONS(1016),
    [anon_sym___fastcall] = ACTIONS(1016),
    [anon_sym___thiscall] = ACTIONS(1016),
    [anon_sym___vectorcall] = ACTIONS(1016),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_RBRACE] = ACTIONS(1018),
    [anon_sym_static] = ACTIONS(1016),
    [anon_sym_auto] = ACTIONS(1016),
    [anon_sym_register] = ACTIONS(1016),
    [anon_sym_inline] = ACTIONS(1016),
    [anon_sym_const] = ACTIONS(1016),
    [anon_sym_volatile] = ACTIONS(1016),
    [anon_sym_restrict] = ACTIONS(1016),
    [anon_sym__Atomic] = ACTIONS(1016),
    [anon_sym_signed] = ACTIONS(1016),
    [anon_sym_unsigned] = ACTIONS(1016),
    [anon_sym_long] = ACTIONS(1016),
    [anon_sym_short] = ACTIONS(1016),
    [sym_primitive_type] = ACTIONS(1016),
    [anon_sym_enum] = ACTIONS(1016),
    [anon_sym_struct] = ACTIONS(1016),
    [anon_sym_union] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1016),
    [anon_sym_switch] = ACTIONS(1016),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_default] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_goto] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [anon_sym_sizeof] = ACTIONS(1016),
    [sym_number_literal] = ACTIONS(1018),
    [anon_sym_L_SQUOTE] = ACTIONS(1018),
    [anon_sym_u_SQUOTE] = ACTIONS(1018),
    [anon_sym_U_SQUOTE] = ACTIONS(1018),
    [anon_sym_u8_SQUOTE] = ACTIONS(1018),
    [anon_sym_SQUOTE] = ACTIONS(1018),
    [anon_sym_L_DQUOTE] = ACTIONS(1018),
    [anon_sym_u_DQUOTE] = ACTIONS(1018),
    [anon_sym_U_DQUOTE] = ACTIONS(1018),
    [anon_sym_u8_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [sym_true] = ACTIONS(1016),
    [sym_false] = ACTIONS(1016),
    [sym_null] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
  },
  [174] = {
    [sym_identifier] = ACTIONS(894),
    [aux_sym_preproc_include_token1] = ACTIONS(894),
    [aux_sym_preproc_def_token1] = ACTIONS(894),
    [aux_sym_preproc_if_token1] = ACTIONS(894),
    [aux_sym_preproc_if_token2] = ACTIONS(894),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(894),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(894),
    [sym_preproc_directive] = ACTIONS(894),
    [anon_sym_LPAREN2] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(896),
    [anon_sym_SEMI] = ACTIONS(896),
    [anon_sym_typedef] = ACTIONS(894),
    [anon_sym_extern] = ACTIONS(894),
    [anon_sym___attribute__] = ACTIONS(894),
    [anon_sym___declspec] = ACTIONS(894),
    [anon_sym___cdecl] = ACTIONS(894),
    [anon_sym___clrcall] = ACTIONS(894),
    [anon_sym___stdcall] = ACTIONS(894),
    [anon_sym___fastcall] = ACTIONS(894),
    [anon_sym___thiscall] = ACTIONS(894),
    [anon_sym___vectorcall] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(896),
    [anon_sym_static] = ACTIONS(894),
    [anon_sym_auto] = ACTIONS(894),
    [anon_sym_register] = ACTIONS(894),
    [anon_sym_inline] = ACTIONS(894),
    [anon_sym_const] = ACTIONS(894),
    [anon_sym_volatile] = ACTIONS(894),
    [anon_sym_restrict] = ACTIONS(894),
    [anon_sym__Atomic] = ACTIONS(894),
    [anon_sym_signed] = ACTIONS(894),
    [anon_sym_unsigned] = ACTIONS(894),
    [anon_sym_long] = ACTIONS(894),
    [anon_sym_short] = ACTIONS(894),
    [sym_primitive_type] = ACTIONS(894),
    [anon_sym_enum] = ACTIONS(894),
    [anon_sym_struct] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(894),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_switch] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_default] = ACTIONS(894),
    [anon_sym_while] = ACTIONS(894),
    [anon_sym_do] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(894),
    [anon_sym_break] = ACTIONS(894),
    [anon_sym_continue] = ACTIONS(894),
    [anon_sym_goto] = ACTIONS(894),
    [anon_sym_DASH_DASH] = ACTIONS(896),
    [anon_sym_PLUS_PLUS] = ACTIONS(896),
    [anon_sym_sizeof] = ACTIONS(894),
    [sym_number_literal] = ACTIONS(896),
    [anon_sym_L_SQUOTE] = ACTIONS(896),
    [anon_sym_u_SQUOTE] = ACTIONS(896),
    [anon_sym_U_SQUOTE] = ACTIONS(896),
    [anon_sym_u8_SQUOTE] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(896),
    [anon_sym_L_DQUOTE] = ACTIONS(896),
    [anon_sym_u_DQUOTE] = ACTIONS(896),
    [anon_sym_U_DQUOTE] = ACTIONS(896),
    [anon_sym_u8_DQUOTE] = ACTIONS(896),
    [anon_sym_DQUOTE] = ACTIONS(896),
    [sym_true] = ACTIONS(894),
    [sym_false] = ACTIONS(894),
    [sym_null] = ACTIONS(894),
    [sym_comment] = ACTIONS(3),
  },
  [175] = {
    [sym_identifier] = ACTIONS(894),
    [aux_sym_preproc_include_token1] = ACTIONS(894),
    [aux_sym_preproc_def_token1] = ACTIONS(894),
    [aux_sym_preproc_if_token1] = ACTIONS(894),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(894),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(894),
    [sym_preproc_directive] = ACTIONS(894),
    [anon_sym_LPAREN2] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(896),
    [anon_sym_SEMI] = ACTIONS(896),
    [anon_sym_typedef] = ACTIONS(894),
    [anon_sym_extern] = ACTIONS(894),
    [anon_sym___attribute__] = ACTIONS(894),
    [anon_sym___declspec] = ACTIONS(894),
    [anon_sym___cdecl] = ACTIONS(894),
    [anon_sym___clrcall] = ACTIONS(894),
    [anon_sym___stdcall] = ACTIONS(894),
    [anon_sym___fastcall] = ACTIONS(894),
    [anon_sym___thiscall] = ACTIONS(894),
    [anon_sym___vectorcall] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(896),
    [anon_sym_RBRACE] = ACTIONS(896),
    [anon_sym_static] = ACTIONS(894),
    [anon_sym_auto] = ACTIONS(894),
    [anon_sym_register] = ACTIONS(894),
    [anon_sym_inline] = ACTIONS(894),
    [anon_sym_const] = ACTIONS(894),
    [anon_sym_volatile] = ACTIONS(894),
    [anon_sym_restrict] = ACTIONS(894),
    [anon_sym__Atomic] = ACTIONS(894),
    [anon_sym_signed] = ACTIONS(894),
    [anon_sym_unsigned] = ACTIONS(894),
    [anon_sym_long] = ACTIONS(894),
    [anon_sym_short] = ACTIONS(894),
    [sym_primitive_type] = ACTIONS(894),
    [anon_sym_enum] = ACTIONS(894),
    [anon_sym_struct] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(894),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_switch] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_default] = ACTIONS(894),
    [anon_sym_while] = ACTIONS(894),
    [anon_sym_do] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(894),
    [anon_sym_break] = ACTIONS(894),
    [anon_sym_continue] = ACTIONS(894),
    [anon_sym_goto] = ACTIONS(894),
    [anon_sym_DASH_DASH] = ACTIONS(896),
    [anon_sym_PLUS_PLUS] = ACTIONS(896),
    [anon_sym_sizeof] = ACTIONS(894),
    [sym_number_literal] = ACTIONS(896),
    [anon_sym_L_SQUOTE] = ACTIONS(896),
    [anon_sym_u_SQUOTE] = ACTIONS(896),
    [anon_sym_U_SQUOTE] = ACTIONS(896),
    [anon_sym_u8_SQUOTE] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(896),
    [anon_sym_L_DQUOTE] = ACTIONS(896),
    [anon_sym_u_DQUOTE] = ACTIONS(896),
    [anon_sym_U_DQUOTE] = ACTIONS(896),
    [anon_sym_u8_DQUOTE] = ACTIONS(896),
    [anon_sym_DQUOTE] = ACTIONS(896),
    [sym_true] = ACTIONS(894),
    [sym_false] = ACTIONS(894),
    [sym_null] = ACTIONS(894),
    [sym_comment] = ACTIONS(3),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(896),
    [sym_identifier] = ACTIONS(894),
    [aux_sym_preproc_include_token1] = ACTIONS(894),
    [aux_sym_preproc_def_token1] = ACTIONS(894),
    [aux_sym_preproc_if_token1] = ACTIONS(894),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(894),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(894),
    [sym_preproc_directive] = ACTIONS(894),
    [anon_sym_LPAREN2] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(896),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(896),
    [anon_sym_SEMI] = ACTIONS(896),
    [anon_sym_typedef] = ACTIONS(894),
    [anon_sym_extern] = ACTIONS(894),
    [anon_sym___attribute__] = ACTIONS(894),
    [anon_sym___declspec] = ACTIONS(894),
    [anon_sym___cdecl] = ACTIONS(894),
    [anon_sym___clrcall] = ACTIONS(894),
    [anon_sym___stdcall] = ACTIONS(894),
    [anon_sym___fastcall] = ACTIONS(894),
    [anon_sym___thiscall] = ACTIONS(894),
    [anon_sym___vectorcall] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(896),
    [anon_sym_static] = ACTIONS(894),
    [anon_sym_auto] = ACTIONS(894),
    [anon_sym_register] = ACTIONS(894),
    [anon_sym_inline] = ACTIONS(894),
    [anon_sym_const] = ACTIONS(894),
    [anon_sym_volatile] = ACTIONS(894),
    [anon_sym_restrict] = ACTIONS(894),
    [anon_sym__Atomic] = ACTIONS(894),
    [anon_sym_signed] = ACTIONS(894),
    [anon_sym_unsigned] = ACTIONS(894),
    [anon_sym_long] = ACTIONS(894),
    [anon_sym_short] = ACTIONS(894),
    [sym_primitive_type] = ACTIONS(894),
    [anon_sym_enum] = ACTIONS(894),
    [anon_sym_struct] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(894),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_switch] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_default] = ACTIONS(894),
    [anon_sym_while] = ACTIONS(894),
    [anon_sym_do] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(894),
    [anon_sym_break] = ACTIONS(894),
    [anon_sym_continue] = ACTIONS(894),
    [anon_sym_goto] = ACTIONS(894),
    [anon_sym_DASH_DASH] = ACTIONS(896),
    [anon_sym_PLUS_PLUS] = ACTIONS(896),
    [anon_sym_sizeof] = ACTIONS(894),
    [sym_number_literal] = ACTIONS(896),
    [anon_sym_L_SQUOTE] = ACTIONS(896),
    [anon_sym_u_SQUOTE] = ACTIONS(896),
    [anon_sym_U_SQUOTE] = ACTIONS(896),
    [anon_sym_u8_SQUOTE] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(896),
    [anon_sym_L_DQUOTE] = ACTIONS(896),
    [anon_sym_u_DQUOTE] = ACTIONS(896),
    [anon_sym_U_DQUOTE] = ACTIONS(896),
    [anon_sym_u8_DQUOTE] = ACTIONS(896),
    [anon_sym_DQUOTE] = ACTIONS(896),
    [sym_true] = ACTIONS(894),
    [sym_false] = ACTIONS(894),
    [sym_null] = ACTIONS(894),
    [sym_comment] = ACTIONS(3),
  },
  [177] = {
    [ts_builtin_sym_end] = ACTIONS(900),
    [sym_identifier] = ACTIONS(898),
    [aux_sym_preproc_include_token1] = ACTIONS(898),
    [aux_sym_preproc_def_token1] = ACTIONS(898),
    [aux_sym_preproc_if_token1] = ACTIONS(898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(898),
    [sym_preproc_directive] = ACTIONS(898),
    [anon_sym_LPAREN2] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(900),
    [anon_sym_TILDE] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_SEMI] = ACTIONS(900),
    [anon_sym_typedef] = ACTIONS(898),
    [anon_sym_extern] = ACTIONS(898),
    [anon_sym___attribute__] = ACTIONS(898),
    [anon_sym___declspec] = ACTIONS(898),
    [anon_sym___cdecl] = ACTIONS(898),
    [anon_sym___clrcall] = ACTIONS(898),
    [anon_sym___stdcall] = ACTIONS(898),
    [anon_sym___fastcall] = ACTIONS(898),
    [anon_sym___thiscall] = ACTIONS(898),
    [anon_sym___vectorcall] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_static] = ACTIONS(898),
    [anon_sym_auto] = ACTIONS(898),
    [anon_sym_register] = ACTIONS(898),
    [anon_sym_inline] = ACTIONS(898),
    [anon_sym_const] = ACTIONS(898),
    [anon_sym_volatile] = ACTIONS(898),
    [anon_sym_restrict] = ACTIONS(898),
    [anon_sym__Atomic] = ACTIONS(898),
    [anon_sym_signed] = ACTIONS(898),
    [anon_sym_unsigned] = ACTIONS(898),
    [anon_sym_long] = ACTIONS(898),
    [anon_sym_short] = ACTIONS(898),
    [sym_primitive_type] = ACTIONS(898),
    [anon_sym_enum] = ACTIONS(898),
    [anon_sym_struct] = ACTIONS(898),
    [anon_sym_union] = ACTIONS(898),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_else] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(898),
    [anon_sym_case] = ACTIONS(898),
    [anon_sym_default] = ACTIONS(898),
    [anon_sym_while] = ACTIONS(898),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_for] = ACTIONS(898),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_break] = ACTIONS(898),
    [anon_sym_continue] = ACTIONS(898),
    [anon_sym_goto] = ACTIONS(898),
    [anon_sym_DASH_DASH] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(898),
    [sym_number_literal] = ACTIONS(900),
    [anon_sym_L_SQUOTE] = ACTIONS(900),
    [anon_sym_u_SQUOTE] = ACTIONS(900),
    [anon_sym_U_SQUOTE] = ACTIONS(900),
    [anon_sym_u8_SQUOTE] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(900),
    [anon_sym_L_DQUOTE] = ACTIONS(900),
    [anon_sym_u_DQUOTE] = ACTIONS(900),
    [anon_sym_U_DQUOTE] = ACTIONS(900),
    [anon_sym_u8_DQUOTE] = ACTIONS(900),
    [anon_sym_DQUOTE] = ACTIONS(900),
    [sym_true] = ACTIONS(898),
    [sym_false] = ACTIONS(898),
    [sym_null] = ACTIONS(898),
    [sym_comment] = ACTIONS(3),
  },
  [178] = {
    [sym_identifier] = ACTIONS(1000),
    [aux_sym_preproc_include_token1] = ACTIONS(1000),
    [aux_sym_preproc_def_token1] = ACTIONS(1000),
    [aux_sym_preproc_if_token1] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1000),
    [sym_preproc_directive] = ACTIONS(1000),
    [anon_sym_LPAREN2] = ACTIONS(1002),
    [anon_sym_BANG] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_typedef] = ACTIONS(1000),
    [anon_sym_extern] = ACTIONS(1000),
    [anon_sym___attribute__] = ACTIONS(1000),
    [anon_sym___declspec] = ACTIONS(1000),
    [anon_sym___cdecl] = ACTIONS(1000),
    [anon_sym___clrcall] = ACTIONS(1000),
    [anon_sym___stdcall] = ACTIONS(1000),
    [anon_sym___fastcall] = ACTIONS(1000),
    [anon_sym___thiscall] = ACTIONS(1000),
    [anon_sym___vectorcall] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(1002),
    [anon_sym_RBRACE] = ACTIONS(1002),
    [anon_sym_static] = ACTIONS(1000),
    [anon_sym_auto] = ACTIONS(1000),
    [anon_sym_register] = ACTIONS(1000),
    [anon_sym_inline] = ACTIONS(1000),
    [anon_sym_const] = ACTIONS(1000),
    [anon_sym_volatile] = ACTIONS(1000),
    [anon_sym_restrict] = ACTIONS(1000),
    [anon_sym__Atomic] = ACTIONS(1000),
    [anon_sym_signed] = ACTIONS(1000),
    [anon_sym_unsigned] = ACTIONS(1000),
    [anon_sym_long] = ACTIONS(1000),
    [anon_sym_short] = ACTIONS(1000),
    [sym_primitive_type] = ACTIONS(1000),
    [anon_sym_enum] = ACTIONS(1000),
    [anon_sym_struct] = ACTIONS(1000),
    [anon_sym_union] = ACTIONS(1000),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_else] = ACTIONS(1000),
    [anon_sym_switch] = ACTIONS(1000),
    [anon_sym_case] = ACTIONS(1000),
    [anon_sym_default] = ACTIONS(1000),
    [anon_sym_while] = ACTIONS(1000),
    [anon_sym_do] = ACTIONS(1000),
    [anon_sym_for] = ACTIONS(1000),
    [anon_sym_return] = ACTIONS(1000),
    [anon_sym_break] = ACTIONS(1000),
    [anon_sym_continue] = ACTIONS(1000),
    [anon_sym_goto] = ACTIONS(1000),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1002),
    [anon_sym_L_SQUOTE] = ACTIONS(1002),
    [anon_sym_u_SQUOTE] = ACTIONS(1002),
    [anon_sym_U_SQUOTE] = ACTIONS(1002),
    [anon_sym_u8_SQUOTE] = ACTIONS(1002),
    [anon_sym_SQUOTE] = ACTIONS(1002),
    [anon_sym_L_DQUOTE] = ACTIONS(1002),
    [anon_sym_u_DQUOTE] = ACTIONS(1002),
    [anon_sym_U_DQUOTE] = ACTIONS(1002),
    [anon_sym_u8_DQUOTE] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1002),
    [sym_true] = ACTIONS(1000),
    [sym_false] = ACTIONS(1000),
    [sym_null] = ACTIONS(1000),
    [sym_comment] = ACTIONS(3),
  },
  [179] = {
    [sym_identifier] = ACTIONS(910),
    [aux_sym_preproc_include_token1] = ACTIONS(910),
    [aux_sym_preproc_def_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(910),
    [sym_preproc_directive] = ACTIONS(910),
    [anon_sym_LPAREN2] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_typedef] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym___attribute__] = ACTIONS(910),
    [anon_sym___declspec] = ACTIONS(910),
    [anon_sym___cdecl] = ACTIONS(910),
    [anon_sym___clrcall] = ACTIONS(910),
    [anon_sym___stdcall] = ACTIONS(910),
    [anon_sym___fastcall] = ACTIONS(910),
    [anon_sym___thiscall] = ACTIONS(910),
    [anon_sym___vectorcall] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_auto] = ACTIONS(910),
    [anon_sym_register] = ACTIONS(910),
    [anon_sym_inline] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_restrict] = ACTIONS(910),
    [anon_sym__Atomic] = ACTIONS(910),
    [anon_sym_signed] = ACTIONS(910),
    [anon_sym_unsigned] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [sym_primitive_type] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_goto] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_sizeof] = ACTIONS(910),
    [sym_number_literal] = ACTIONS(912),
    [anon_sym_L_SQUOTE] = ACTIONS(912),
    [anon_sym_u_SQUOTE] = ACTIONS(912),
    [anon_sym_U_SQUOTE] = ACTIONS(912),
    [anon_sym_u8_SQUOTE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(912),
    [anon_sym_L_DQUOTE] = ACTIONS(912),
    [anon_sym_u_DQUOTE] = ACTIONS(912),
    [anon_sym_U_DQUOTE] = ACTIONS(912),
    [anon_sym_u8_DQUOTE] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(912),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
  },
  [180] = {
    [sym_identifier] = ACTIONS(890),
    [aux_sym_preproc_include_token1] = ACTIONS(890),
    [aux_sym_preproc_def_token1] = ACTIONS(890),
    [aux_sym_preproc_if_token1] = ACTIONS(890),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(890),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(890),
    [sym_preproc_directive] = ACTIONS(890),
    [anon_sym_LPAREN2] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(892),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(892),
    [anon_sym_typedef] = ACTIONS(890),
    [anon_sym_extern] = ACTIONS(890),
    [anon_sym___attribute__] = ACTIONS(890),
    [anon_sym___declspec] = ACTIONS(890),
    [anon_sym___cdecl] = ACTIONS(890),
    [anon_sym___clrcall] = ACTIONS(890),
    [anon_sym___stdcall] = ACTIONS(890),
    [anon_sym___fastcall] = ACTIONS(890),
    [anon_sym___thiscall] = ACTIONS(890),
    [anon_sym___vectorcall] = ACTIONS(890),
    [anon_sym_LBRACE] = ACTIONS(892),
    [anon_sym_RBRACE] = ACTIONS(892),
    [anon_sym_static] = ACTIONS(890),
    [anon_sym_auto] = ACTIONS(890),
    [anon_sym_register] = ACTIONS(890),
    [anon_sym_inline] = ACTIONS(890),
    [anon_sym_const] = ACTIONS(890),
    [anon_sym_volatile] = ACTIONS(890),
    [anon_sym_restrict] = ACTIONS(890),
    [anon_sym__Atomic] = ACTIONS(890),
    [anon_sym_signed] = ACTIONS(890),
    [anon_sym_unsigned] = ACTIONS(890),
    [anon_sym_long] = ACTIONS(890),
    [anon_sym_short] = ACTIONS(890),
    [sym_primitive_type] = ACTIONS(890),
    [anon_sym_enum] = ACTIONS(890),
    [anon_sym_struct] = ACTIONS(890),
    [anon_sym_union] = ACTIONS(890),
    [anon_sym_if] = ACTIONS(890),
    [anon_sym_else] = ACTIONS(890),
    [anon_sym_switch] = ACTIONS(890),
    [anon_sym_case] = ACTIONS(890),
    [anon_sym_default] = ACTIONS(890),
    [anon_sym_while] = ACTIONS(890),
    [anon_sym_do] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(890),
    [anon_sym_return] = ACTIONS(890),
    [anon_sym_break] = ACTIONS(890),
    [anon_sym_continue] = ACTIONS(890),
    [anon_sym_goto] = ACTIONS(890),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_sizeof] = ACTIONS(890),
    [sym_number_literal] = ACTIONS(892),
    [anon_sym_L_SQUOTE] = ACTIONS(892),
    [anon_sym_u_SQUOTE] = ACTIONS(892),
    [anon_sym_U_SQUOTE] = ACTIONS(892),
    [anon_sym_u8_SQUOTE] = ACTIONS(892),
    [anon_sym_SQUOTE] = ACTIONS(892),
    [anon_sym_L_DQUOTE] = ACTIONS(892),
    [anon_sym_u_DQUOTE] = ACTIONS(892),
    [anon_sym_U_DQUOTE] = ACTIONS(892),
    [anon_sym_u8_DQUOTE] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_true] = ACTIONS(890),
    [sym_false] = ACTIONS(890),
    [sym_null] = ACTIONS(890),
    [sym_comment] = ACTIONS(3),
  },
  [181] = {
    [sym_identifier] = ACTIONS(984),
    [aux_sym_preproc_include_token1] = ACTIONS(984),
    [aux_sym_preproc_def_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token2] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(984),
    [sym_preproc_directive] = ACTIONS(984),
    [anon_sym_LPAREN2] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_AMP] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_typedef] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym___attribute__] = ACTIONS(984),
    [anon_sym___declspec] = ACTIONS(984),
    [anon_sym___cdecl] = ACTIONS(984),
    [anon_sym___clrcall] = ACTIONS(984),
    [anon_sym___stdcall] = ACTIONS(984),
    [anon_sym___fastcall] = ACTIONS(984),
    [anon_sym___thiscall] = ACTIONS(984),
    [anon_sym___vectorcall] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_auto] = ACTIONS(984),
    [anon_sym_register] = ACTIONS(984),
    [anon_sym_inline] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_volatile] = ACTIONS(984),
    [anon_sym_restrict] = ACTIONS(984),
    [anon_sym__Atomic] = ACTIONS(984),
    [anon_sym_signed] = ACTIONS(984),
    [anon_sym_unsigned] = ACTIONS(984),
    [anon_sym_long] = ACTIONS(984),
    [anon_sym_short] = ACTIONS(984),
    [sym_primitive_type] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_struct] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(984),
    [anon_sym_switch] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_do] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_goto] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_sizeof] = ACTIONS(984),
    [sym_number_literal] = ACTIONS(986),
    [anon_sym_L_SQUOTE] = ACTIONS(986),
    [anon_sym_u_SQUOTE] = ACTIONS(986),
    [anon_sym_U_SQUOTE] = ACTIONS(986),
    [anon_sym_u8_SQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [anon_sym_L_DQUOTE] = ACTIONS(986),
    [anon_sym_u_DQUOTE] = ACTIONS(986),
    [anon_sym_U_DQUOTE] = ACTIONS(986),
    [anon_sym_u8_DQUOTE] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
  },
  [182] = {
    [sym_identifier] = ACTIONS(984),
    [aux_sym_preproc_include_token1] = ACTIONS(984),
    [aux_sym_preproc_def_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token2] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(984),
    [sym_preproc_directive] = ACTIONS(984),
    [anon_sym_LPAREN2] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_AMP] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_typedef] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym___attribute__] = ACTIONS(984),
    [anon_sym___declspec] = ACTIONS(984),
    [anon_sym___cdecl] = ACTIONS(984),
    [anon_sym___clrcall] = ACTIONS(984),
    [anon_sym___stdcall] = ACTIONS(984),
    [anon_sym___fastcall] = ACTIONS(984),
    [anon_sym___thiscall] = ACTIONS(984),
    [anon_sym___vectorcall] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_auto] = ACTIONS(984),
    [anon_sym_register] = ACTIONS(984),
    [anon_sym_inline] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_volatile] = ACTIONS(984),
    [anon_sym_restrict] = ACTIONS(984),
    [anon_sym__Atomic] = ACTIONS(984),
    [anon_sym_signed] = ACTIONS(984),
    [anon_sym_unsigned] = ACTIONS(984),
    [anon_sym_long] = ACTIONS(984),
    [anon_sym_short] = ACTIONS(984),
    [sym_primitive_type] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_struct] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(984),
    [anon_sym_switch] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_do] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_goto] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_sizeof] = ACTIONS(984),
    [sym_number_literal] = ACTIONS(986),
    [anon_sym_L_SQUOTE] = ACTIONS(986),
    [anon_sym_u_SQUOTE] = ACTIONS(986),
    [anon_sym_U_SQUOTE] = ACTIONS(986),
    [anon_sym_u8_SQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [anon_sym_L_DQUOTE] = ACTIONS(986),
    [anon_sym_u_DQUOTE] = ACTIONS(986),
    [anon_sym_U_DQUOTE] = ACTIONS(986),
    [anon_sym_u8_DQUOTE] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
  },
  [183] = {
    [sym_identifier] = ACTIONS(910),
    [aux_sym_preproc_include_token1] = ACTIONS(910),
    [aux_sym_preproc_def_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(910),
    [sym_preproc_directive] = ACTIONS(910),
    [anon_sym_LPAREN2] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_typedef] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym___attribute__] = ACTIONS(910),
    [anon_sym___declspec] = ACTIONS(910),
    [anon_sym___cdecl] = ACTIONS(910),
    [anon_sym___clrcall] = ACTIONS(910),
    [anon_sym___stdcall] = ACTIONS(910),
    [anon_sym___fastcall] = ACTIONS(910),
    [anon_sym___thiscall] = ACTIONS(910),
    [anon_sym___vectorcall] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_auto] = ACTIONS(910),
    [anon_sym_register] = ACTIONS(910),
    [anon_sym_inline] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_restrict] = ACTIONS(910),
    [anon_sym__Atomic] = ACTIONS(910),
    [anon_sym_signed] = ACTIONS(910),
    [anon_sym_unsigned] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [sym_primitive_type] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_goto] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_sizeof] = ACTIONS(910),
    [sym_number_literal] = ACTIONS(912),
    [anon_sym_L_SQUOTE] = ACTIONS(912),
    [anon_sym_u_SQUOTE] = ACTIONS(912),
    [anon_sym_U_SQUOTE] = ACTIONS(912),
    [anon_sym_u8_SQUOTE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(912),
    [anon_sym_L_DQUOTE] = ACTIONS(912),
    [anon_sym_u_DQUOTE] = ACTIONS(912),
    [anon_sym_U_DQUOTE] = ACTIONS(912),
    [anon_sym_u8_DQUOTE] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(912),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [sym_identifier] = ACTIONS(992),
    [aux_sym_preproc_include_token1] = ACTIONS(992),
    [aux_sym_preproc_def_token1] = ACTIONS(992),
    [aux_sym_preproc_if_token1] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(992),
    [sym_preproc_directive] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(994),
    [anon_sym_BANG] = ACTIONS(994),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_AMP] = ACTIONS(994),
    [anon_sym_SEMI] = ACTIONS(994),
    [anon_sym_typedef] = ACTIONS(992),
    [anon_sym_extern] = ACTIONS(992),
    [anon_sym___attribute__] = ACTIONS(992),
    [anon_sym___declspec] = ACTIONS(992),
    [anon_sym___cdecl] = ACTIONS(992),
    [anon_sym___clrcall] = ACTIONS(992),
    [anon_sym___stdcall] = ACTIONS(992),
    [anon_sym___fastcall] = ACTIONS(992),
    [anon_sym___thiscall] = ACTIONS(992),
    [anon_sym___vectorcall] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(994),
    [anon_sym_RBRACE] = ACTIONS(994),
    [anon_sym_static] = ACTIONS(992),
    [anon_sym_auto] = ACTIONS(992),
    [anon_sym_register] = ACTIONS(992),
    [anon_sym_inline] = ACTIONS(992),
    [anon_sym_const] = ACTIONS(992),
    [anon_sym_volatile] = ACTIONS(992),
    [anon_sym_restrict] = ACTIONS(992),
    [anon_sym__Atomic] = ACTIONS(992),
    [anon_sym_signed] = ACTIONS(992),
    [anon_sym_unsigned] = ACTIONS(992),
    [anon_sym_long] = ACTIONS(992),
    [anon_sym_short] = ACTIONS(992),
    [sym_primitive_type] = ACTIONS(992),
    [anon_sym_enum] = ACTIONS(992),
    [anon_sym_struct] = ACTIONS(992),
    [anon_sym_union] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_switch] = ACTIONS(992),
    [anon_sym_case] = ACTIONS(992),
    [anon_sym_default] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_goto] = ACTIONS(992),
    [anon_sym_DASH_DASH] = ACTIONS(994),
    [anon_sym_PLUS_PLUS] = ACTIONS(994),
    [anon_sym_sizeof] = ACTIONS(992),
    [sym_number_literal] = ACTIONS(994),
    [anon_sym_L_SQUOTE] = ACTIONS(994),
    [anon_sym_u_SQUOTE] = ACTIONS(994),
    [anon_sym_U_SQUOTE] = ACTIONS(994),
    [anon_sym_u8_SQUOTE] = ACTIONS(994),
    [anon_sym_SQUOTE] = ACTIONS(994),
    [anon_sym_L_DQUOTE] = ACTIONS(994),
    [anon_sym_u_DQUOTE] = ACTIONS(994),
    [anon_sym_U_DQUOTE] = ACTIONS(994),
    [anon_sym_u8_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_true] = ACTIONS(992),
    [sym_false] = ACTIONS(992),
    [sym_null] = ACTIONS(992),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [sym_identifier] = ACTIONS(976),
    [aux_sym_preproc_include_token1] = ACTIONS(976),
    [aux_sym_preproc_def_token1] = ACTIONS(976),
    [aux_sym_preproc_if_token1] = ACTIONS(976),
    [aux_sym_preproc_if_token2] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(976),
    [sym_preproc_directive] = ACTIONS(976),
    [anon_sym_LPAREN2] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(978),
    [anon_sym_TILDE] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_STAR] = ACTIONS(978),
    [anon_sym_AMP] = ACTIONS(978),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym_typedef] = ACTIONS(976),
    [anon_sym_extern] = ACTIONS(976),
    [anon_sym___attribute__] = ACTIONS(976),
    [anon_sym___declspec] = ACTIONS(976),
    [anon_sym___cdecl] = ACTIONS(976),
    [anon_sym___clrcall] = ACTIONS(976),
    [anon_sym___stdcall] = ACTIONS(976),
    [anon_sym___fastcall] = ACTIONS(976),
    [anon_sym___thiscall] = ACTIONS(976),
    [anon_sym___vectorcall] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_static] = ACTIONS(976),
    [anon_sym_auto] = ACTIONS(976),
    [anon_sym_register] = ACTIONS(976),
    [anon_sym_inline] = ACTIONS(976),
    [anon_sym_const] = ACTIONS(976),
    [anon_sym_volatile] = ACTIONS(976),
    [anon_sym_restrict] = ACTIONS(976),
    [anon_sym__Atomic] = ACTIONS(976),
    [anon_sym_signed] = ACTIONS(976),
    [anon_sym_unsigned] = ACTIONS(976),
    [anon_sym_long] = ACTIONS(976),
    [anon_sym_short] = ACTIONS(976),
    [sym_primitive_type] = ACTIONS(976),
    [anon_sym_enum] = ACTIONS(976),
    [anon_sym_struct] = ACTIONS(976),
    [anon_sym_union] = ACTIONS(976),
    [anon_sym_if] = ACTIONS(976),
    [anon_sym_else] = ACTIONS(976),
    [anon_sym_switch] = ACTIONS(976),
    [anon_sym_case] = ACTIONS(976),
    [anon_sym_default] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(976),
    [anon_sym_do] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_return] = ACTIONS(976),
    [anon_sym_break] = ACTIONS(976),
    [anon_sym_continue] = ACTIONS(976),
    [anon_sym_goto] = ACTIONS(976),
    [anon_sym_DASH_DASH] = ACTIONS(978),
    [anon_sym_PLUS_PLUS] = ACTIONS(978),
    [anon_sym_sizeof] = ACTIONS(976),
    [sym_number_literal] = ACTIONS(978),
    [anon_sym_L_SQUOTE] = ACTIONS(978),
    [anon_sym_u_SQUOTE] = ACTIONS(978),
    [anon_sym_U_SQUOTE] = ACTIONS(978),
    [anon_sym_u8_SQUOTE] = ACTIONS(978),
    [anon_sym_SQUOTE] = ACTIONS(978),
    [anon_sym_L_DQUOTE] = ACTIONS(978),
    [anon_sym_u_DQUOTE] = ACTIONS(978),
    [anon_sym_U_DQUOTE] = ACTIONS(978),
    [anon_sym_u8_DQUOTE] = ACTIONS(978),
    [anon_sym_DQUOTE] = ACTIONS(978),
    [sym_true] = ACTIONS(976),
    [sym_false] = ACTIONS(976),
    [sym_null] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
  },
  [186] = {
    [sym_identifier] = ACTIONS(898),
    [aux_sym_preproc_include_token1] = ACTIONS(898),
    [aux_sym_preproc_def_token1] = ACTIONS(898),
    [aux_sym_preproc_if_token1] = ACTIONS(898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(898),
    [sym_preproc_directive] = ACTIONS(898),
    [anon_sym_LPAREN2] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(900),
    [anon_sym_TILDE] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_SEMI] = ACTIONS(900),
    [anon_sym_typedef] = ACTIONS(898),
    [anon_sym_extern] = ACTIONS(898),
    [anon_sym___attribute__] = ACTIONS(898),
    [anon_sym___declspec] = ACTIONS(898),
    [anon_sym___cdecl] = ACTIONS(898),
    [anon_sym___clrcall] = ACTIONS(898),
    [anon_sym___stdcall] = ACTIONS(898),
    [anon_sym___fastcall] = ACTIONS(898),
    [anon_sym___thiscall] = ACTIONS(898),
    [anon_sym___vectorcall] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_RBRACE] = ACTIONS(900),
    [anon_sym_static] = ACTIONS(898),
    [anon_sym_auto] = ACTIONS(898),
    [anon_sym_register] = ACTIONS(898),
    [anon_sym_inline] = ACTIONS(898),
    [anon_sym_const] = ACTIONS(898),
    [anon_sym_volatile] = ACTIONS(898),
    [anon_sym_restrict] = ACTIONS(898),
    [anon_sym__Atomic] = ACTIONS(898),
    [anon_sym_signed] = ACTIONS(898),
    [anon_sym_unsigned] = ACTIONS(898),
    [anon_sym_long] = ACTIONS(898),
    [anon_sym_short] = ACTIONS(898),
    [sym_primitive_type] = ACTIONS(898),
    [anon_sym_enum] = ACTIONS(898),
    [anon_sym_struct] = ACTIONS(898),
    [anon_sym_union] = ACTIONS(898),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_else] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(898),
    [anon_sym_case] = ACTIONS(898),
    [anon_sym_default] = ACTIONS(898),
    [anon_sym_while] = ACTIONS(898),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_for] = ACTIONS(898),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_break] = ACTIONS(898),
    [anon_sym_continue] = ACTIONS(898),
    [anon_sym_goto] = ACTIONS(898),
    [anon_sym_DASH_DASH] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(898),
    [sym_number_literal] = ACTIONS(900),
    [anon_sym_L_SQUOTE] = ACTIONS(900),
    [anon_sym_u_SQUOTE] = ACTIONS(900),
    [anon_sym_U_SQUOTE] = ACTIONS(900),
    [anon_sym_u8_SQUOTE] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(900),
    [anon_sym_L_DQUOTE] = ACTIONS(900),
    [anon_sym_u_DQUOTE] = ACTIONS(900),
    [anon_sym_U_DQUOTE] = ACTIONS(900),
    [anon_sym_u8_DQUOTE] = ACTIONS(900),
    [anon_sym_DQUOTE] = ACTIONS(900),
    [sym_true] = ACTIONS(898),
    [sym_false] = ACTIONS(898),
    [sym_null] = ACTIONS(898),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [sym_identifier] = ACTIONS(972),
    [aux_sym_preproc_include_token1] = ACTIONS(972),
    [aux_sym_preproc_def_token1] = ACTIONS(972),
    [aux_sym_preproc_if_token1] = ACTIONS(972),
    [aux_sym_preproc_if_token2] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(972),
    [sym_preproc_directive] = ACTIONS(972),
    [anon_sym_LPAREN2] = ACTIONS(974),
    [anon_sym_BANG] = ACTIONS(974),
    [anon_sym_TILDE] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_typedef] = ACTIONS(972),
    [anon_sym_extern] = ACTIONS(972),
    [anon_sym___attribute__] = ACTIONS(972),
    [anon_sym___declspec] = ACTIONS(972),
    [anon_sym___cdecl] = ACTIONS(972),
    [anon_sym___clrcall] = ACTIONS(972),
    [anon_sym___stdcall] = ACTIONS(972),
    [anon_sym___fastcall] = ACTIONS(972),
    [anon_sym___thiscall] = ACTIONS(972),
    [anon_sym___vectorcall] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(974),
    [anon_sym_static] = ACTIONS(972),
    [anon_sym_auto] = ACTIONS(972),
    [anon_sym_register] = ACTIONS(972),
    [anon_sym_inline] = ACTIONS(972),
    [anon_sym_const] = ACTIONS(972),
    [anon_sym_volatile] = ACTIONS(972),
    [anon_sym_restrict] = ACTIONS(972),
    [anon_sym__Atomic] = ACTIONS(972),
    [anon_sym_signed] = ACTIONS(972),
    [anon_sym_unsigned] = ACTIONS(972),
    [anon_sym_long] = ACTIONS(972),
    [anon_sym_short] = ACTIONS(972),
    [sym_primitive_type] = ACTIONS(972),
    [anon_sym_enum] = ACTIONS(972),
    [anon_sym_struct] = ACTIONS(972),
    [anon_sym_union] = ACTIONS(972),
    [anon_sym_if] = ACTIONS(972),
    [anon_sym_else] = ACTIONS(972),
    [anon_sym_switch] = ACTIONS(972),
    [anon_sym_case] = ACTIONS(972),
    [anon_sym_default] = ACTIONS(972),
    [anon_sym_while] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(972),
    [anon_sym_for] = ACTIONS(972),
    [anon_sym_return] = ACTIONS(972),
    [anon_sym_break] = ACTIONS(972),
    [anon_sym_continue] = ACTIONS(972),
    [anon_sym_goto] = ACTIONS(972),
    [anon_sym_DASH_DASH] = ACTIONS(974),
    [anon_sym_PLUS_PLUS] = ACTIONS(974),
    [anon_sym_sizeof] = ACTIONS(972),
    [sym_number_literal] = ACTIONS(974),
    [anon_sym_L_SQUOTE] = ACTIONS(974),
    [anon_sym_u_SQUOTE] = ACTIONS(974),
    [anon_sym_U_SQUOTE] = ACTIONS(974),
    [anon_sym_u8_SQUOTE] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(974),
    [anon_sym_L_DQUOTE] = ACTIONS(974),
    [anon_sym_u_DQUOTE] = ACTIONS(974),
    [anon_sym_U_DQUOTE] = ACTIONS(974),
    [anon_sym_u8_DQUOTE] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [sym_true] = ACTIONS(972),
    [sym_false] = ACTIONS(972),
    [sym_null] = ACTIONS(972),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [sym_identifier] = ACTIONS(960),
    [aux_sym_preproc_include_token1] = ACTIONS(960),
    [aux_sym_preproc_def_token1] = ACTIONS(960),
    [aux_sym_preproc_if_token1] = ACTIONS(960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(960),
    [sym_preproc_directive] = ACTIONS(960),
    [anon_sym_LPAREN2] = ACTIONS(962),
    [anon_sym_BANG] = ACTIONS(962),
    [anon_sym_TILDE] = ACTIONS(962),
    [anon_sym_DASH] = ACTIONS(960),
    [anon_sym_PLUS] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_typedef] = ACTIONS(960),
    [anon_sym_extern] = ACTIONS(960),
    [anon_sym___attribute__] = ACTIONS(960),
    [anon_sym___declspec] = ACTIONS(960),
    [anon_sym___cdecl] = ACTIONS(960),
    [anon_sym___clrcall] = ACTIONS(960),
    [anon_sym___stdcall] = ACTIONS(960),
    [anon_sym___fastcall] = ACTIONS(960),
    [anon_sym___thiscall] = ACTIONS(960),
    [anon_sym___vectorcall] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_RBRACE] = ACTIONS(962),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_auto] = ACTIONS(960),
    [anon_sym_register] = ACTIONS(960),
    [anon_sym_inline] = ACTIONS(960),
    [anon_sym_const] = ACTIONS(960),
    [anon_sym_volatile] = ACTIONS(960),
    [anon_sym_restrict] = ACTIONS(960),
    [anon_sym__Atomic] = ACTIONS(960),
    [anon_sym_signed] = ACTIONS(960),
    [anon_sym_unsigned] = ACTIONS(960),
    [anon_sym_long] = ACTIONS(960),
    [anon_sym_short] = ACTIONS(960),
    [sym_primitive_type] = ACTIONS(960),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_struct] = ACTIONS(960),
    [anon_sym_union] = ACTIONS(960),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_else] = ACTIONS(960),
    [anon_sym_switch] = ACTIONS(960),
    [anon_sym_case] = ACTIONS(960),
    [anon_sym_default] = ACTIONS(960),
    [anon_sym_while] = ACTIONS(960),
    [anon_sym_do] = ACTIONS(960),
    [anon_sym_for] = ACTIONS(960),
    [anon_sym_return] = ACTIONS(960),
    [anon_sym_break] = ACTIONS(960),
    [anon_sym_continue] = ACTIONS(960),
    [anon_sym_goto] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(962),
    [anon_sym_PLUS_PLUS] = ACTIONS(962),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_L_SQUOTE] = ACTIONS(962),
    [anon_sym_u_SQUOTE] = ACTIONS(962),
    [anon_sym_U_SQUOTE] = ACTIONS(962),
    [anon_sym_u8_SQUOTE] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(962),
    [anon_sym_L_DQUOTE] = ACTIONS(962),
    [anon_sym_u_DQUOTE] = ACTIONS(962),
    [anon_sym_U_DQUOTE] = ACTIONS(962),
    [anon_sym_u8_DQUOTE] = ACTIONS(962),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [sym_true] = ACTIONS(960),
    [sym_false] = ACTIONS(960),
    [sym_null] = ACTIONS(960),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [sym_identifier] = ACTIONS(968),
    [aux_sym_preproc_include_token1] = ACTIONS(968),
    [aux_sym_preproc_def_token1] = ACTIONS(968),
    [aux_sym_preproc_if_token1] = ACTIONS(968),
    [aux_sym_preproc_if_token2] = ACTIONS(968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(968),
    [sym_preproc_directive] = ACTIONS(968),
    [anon_sym_LPAREN2] = ACTIONS(970),
    [anon_sym_BANG] = ACTIONS(970),
    [anon_sym_TILDE] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(968),
    [anon_sym_PLUS] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(970),
    [anon_sym_AMP] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(970),
    [anon_sym_typedef] = ACTIONS(968),
    [anon_sym_extern] = ACTIONS(968),
    [anon_sym___attribute__] = ACTIONS(968),
    [anon_sym___declspec] = ACTIONS(968),
    [anon_sym___cdecl] = ACTIONS(968),
    [anon_sym___clrcall] = ACTIONS(968),
    [anon_sym___stdcall] = ACTIONS(968),
    [anon_sym___fastcall] = ACTIONS(968),
    [anon_sym___thiscall] = ACTIONS(968),
    [anon_sym___vectorcall] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(970),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_auto] = ACTIONS(968),
    [anon_sym_register] = ACTIONS(968),
    [anon_sym_inline] = ACTIONS(968),
    [anon_sym_const] = ACTIONS(968),
    [anon_sym_volatile] = ACTIONS(968),
    [anon_sym_restrict] = ACTIONS(968),
    [anon_sym__Atomic] = ACTIONS(968),
    [anon_sym_signed] = ACTIONS(968),
    [anon_sym_unsigned] = ACTIONS(968),
    [anon_sym_long] = ACTIONS(968),
    [anon_sym_short] = ACTIONS(968),
    [sym_primitive_type] = ACTIONS(968),
    [anon_sym_enum] = ACTIONS(968),
    [anon_sym_struct] = ACTIONS(968),
    [anon_sym_union] = ACTIONS(968),
    [anon_sym_if] = ACTIONS(968),
    [anon_sym_else] = ACTIONS(968),
    [anon_sym_switch] = ACTIONS(968),
    [anon_sym_case] = ACTIONS(968),
    [anon_sym_default] = ACTIONS(968),
    [anon_sym_while] = ACTIONS(968),
    [anon_sym_do] = ACTIONS(968),
    [anon_sym_for] = ACTIONS(968),
    [anon_sym_return] = ACTIONS(968),
    [anon_sym_break] = ACTIONS(968),
    [anon_sym_continue] = ACTIONS(968),
    [anon_sym_goto] = ACTIONS(968),
    [anon_sym_DASH_DASH] = ACTIONS(970),
    [anon_sym_PLUS_PLUS] = ACTIONS(970),
    [anon_sym_sizeof] = ACTIONS(968),
    [sym_number_literal] = ACTIONS(970),
    [anon_sym_L_SQUOTE] = ACTIONS(970),
    [anon_sym_u_SQUOTE] = ACTIONS(970),
    [anon_sym_U_SQUOTE] = ACTIONS(970),
    [anon_sym_u8_SQUOTE] = ACTIONS(970),
    [anon_sym_SQUOTE] = ACTIONS(970),
    [anon_sym_L_DQUOTE] = ACTIONS(970),
    [anon_sym_u_DQUOTE] = ACTIONS(970),
    [anon_sym_U_DQUOTE] = ACTIONS(970),
    [anon_sym_u8_DQUOTE] = ACTIONS(970),
    [anon_sym_DQUOTE] = ACTIONS(970),
    [sym_true] = ACTIONS(968),
    [sym_false] = ACTIONS(968),
    [sym_null] = ACTIONS(968),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [sym_identifier] = ACTIONS(964),
    [aux_sym_preproc_include_token1] = ACTIONS(964),
    [aux_sym_preproc_def_token1] = ACTIONS(964),
    [aux_sym_preproc_if_token1] = ACTIONS(964),
    [aux_sym_preproc_if_token2] = ACTIONS(964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(964),
    [sym_preproc_directive] = ACTIONS(964),
    [anon_sym_LPAREN2] = ACTIONS(966),
    [anon_sym_BANG] = ACTIONS(966),
    [anon_sym_TILDE] = ACTIONS(966),
    [anon_sym_DASH] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(964),
    [anon_sym_STAR] = ACTIONS(966),
    [anon_sym_AMP] = ACTIONS(966),
    [anon_sym_SEMI] = ACTIONS(966),
    [anon_sym_typedef] = ACTIONS(964),
    [anon_sym_extern] = ACTIONS(964),
    [anon_sym___attribute__] = ACTIONS(964),
    [anon_sym___declspec] = ACTIONS(964),
    [anon_sym___cdecl] = ACTIONS(964),
    [anon_sym___clrcall] = ACTIONS(964),
    [anon_sym___stdcall] = ACTIONS(964),
    [anon_sym___fastcall] = ACTIONS(964),
    [anon_sym___thiscall] = ACTIONS(964),
    [anon_sym___vectorcall] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(966),
    [anon_sym_static] = ACTIONS(964),
    [anon_sym_auto] = ACTIONS(964),
    [anon_sym_register] = ACTIONS(964),
    [anon_sym_inline] = ACTIONS(964),
    [anon_sym_const] = ACTIONS(964),
    [anon_sym_volatile] = ACTIONS(964),
    [anon_sym_restrict] = ACTIONS(964),
    [anon_sym__Atomic] = ACTIONS(964),
    [anon_sym_signed] = ACTIONS(964),
    [anon_sym_unsigned] = ACTIONS(964),
    [anon_sym_long] = ACTIONS(964),
    [anon_sym_short] = ACTIONS(964),
    [sym_primitive_type] = ACTIONS(964),
    [anon_sym_enum] = ACTIONS(964),
    [anon_sym_struct] = ACTIONS(964),
    [anon_sym_union] = ACTIONS(964),
    [anon_sym_if] = ACTIONS(964),
    [anon_sym_else] = ACTIONS(964),
    [anon_sym_switch] = ACTIONS(964),
    [anon_sym_case] = ACTIONS(964),
    [anon_sym_default] = ACTIONS(964),
    [anon_sym_while] = ACTIONS(964),
    [anon_sym_do] = ACTIONS(964),
    [anon_sym_for] = ACTIONS(964),
    [anon_sym_return] = ACTIONS(964),
    [anon_sym_break] = ACTIONS(964),
    [anon_sym_continue] = ACTIONS(964),
    [anon_sym_goto] = ACTIONS(964),
    [anon_sym_DASH_DASH] = ACTIONS(966),
    [anon_sym_PLUS_PLUS] = ACTIONS(966),
    [anon_sym_sizeof] = ACTIONS(964),
    [sym_number_literal] = ACTIONS(966),
    [anon_sym_L_SQUOTE] = ACTIONS(966),
    [anon_sym_u_SQUOTE] = ACTIONS(966),
    [anon_sym_U_SQUOTE] = ACTIONS(966),
    [anon_sym_u8_SQUOTE] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(966),
    [anon_sym_L_DQUOTE] = ACTIONS(966),
    [anon_sym_u_DQUOTE] = ACTIONS(966),
    [anon_sym_U_DQUOTE] = ACTIONS(966),
    [anon_sym_u8_DQUOTE] = ACTIONS(966),
    [anon_sym_DQUOTE] = ACTIONS(966),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_comment] = ACTIONS(3),
  },
  [191] = {
    [sym_identifier] = ACTIONS(940),
    [aux_sym_preproc_include_token1] = ACTIONS(940),
    [aux_sym_preproc_def_token1] = ACTIONS(940),
    [aux_sym_preproc_if_token1] = ACTIONS(940),
    [aux_sym_preproc_if_token2] = ACTIONS(940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(940),
    [sym_preproc_directive] = ACTIONS(940),
    [anon_sym_LPAREN2] = ACTIONS(942),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_STAR] = ACTIONS(942),
    [anon_sym_AMP] = ACTIONS(942),
    [anon_sym_SEMI] = ACTIONS(942),
    [anon_sym_typedef] = ACTIONS(940),
    [anon_sym_extern] = ACTIONS(940),
    [anon_sym___attribute__] = ACTIONS(940),
    [anon_sym___declspec] = ACTIONS(940),
    [anon_sym___cdecl] = ACTIONS(940),
    [anon_sym___clrcall] = ACTIONS(940),
    [anon_sym___stdcall] = ACTIONS(940),
    [anon_sym___fastcall] = ACTIONS(940),
    [anon_sym___thiscall] = ACTIONS(940),
    [anon_sym___vectorcall] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(942),
    [anon_sym_static] = ACTIONS(940),
    [anon_sym_auto] = ACTIONS(940),
    [anon_sym_register] = ACTIONS(940),
    [anon_sym_inline] = ACTIONS(940),
    [anon_sym_const] = ACTIONS(940),
    [anon_sym_volatile] = ACTIONS(940),
    [anon_sym_restrict] = ACTIONS(940),
    [anon_sym__Atomic] = ACTIONS(940),
    [anon_sym_signed] = ACTIONS(940),
    [anon_sym_unsigned] = ACTIONS(940),
    [anon_sym_long] = ACTIONS(940),
    [anon_sym_short] = ACTIONS(940),
    [sym_primitive_type] = ACTIONS(940),
    [anon_sym_enum] = ACTIONS(940),
    [anon_sym_struct] = ACTIONS(940),
    [anon_sym_union] = ACTIONS(940),
    [anon_sym_if] = ACTIONS(940),
    [anon_sym_else] = ACTIONS(940),
    [anon_sym_switch] = ACTIONS(940),
    [anon_sym_case] = ACTIONS(940),
    [anon_sym_default] = ACTIONS(940),
    [anon_sym_while] = ACTIONS(940),
    [anon_sym_do] = ACTIONS(940),
    [anon_sym_for] = ACTIONS(940),
    [anon_sym_return] = ACTIONS(940),
    [anon_sym_break] = ACTIONS(940),
    [anon_sym_continue] = ACTIONS(940),
    [anon_sym_goto] = ACTIONS(940),
    [anon_sym_DASH_DASH] = ACTIONS(942),
    [anon_sym_PLUS_PLUS] = ACTIONS(942),
    [anon_sym_sizeof] = ACTIONS(940),
    [sym_number_literal] = ACTIONS(942),
    [anon_sym_L_SQUOTE] = ACTIONS(942),
    [anon_sym_u_SQUOTE] = ACTIONS(942),
    [anon_sym_U_SQUOTE] = ACTIONS(942),
    [anon_sym_u8_SQUOTE] = ACTIONS(942),
    [anon_sym_SQUOTE] = ACTIONS(942),
    [anon_sym_L_DQUOTE] = ACTIONS(942),
    [anon_sym_u_DQUOTE] = ACTIONS(942),
    [anon_sym_U_DQUOTE] = ACTIONS(942),
    [anon_sym_u8_DQUOTE] = ACTIONS(942),
    [anon_sym_DQUOTE] = ACTIONS(942),
    [sym_true] = ACTIONS(940),
    [sym_false] = ACTIONS(940),
    [sym_null] = ACTIONS(940),
    [sym_comment] = ACTIONS(3),
  },
  [192] = {
    [sym_identifier] = ACTIONS(926),
    [aux_sym_preproc_include_token1] = ACTIONS(926),
    [aux_sym_preproc_def_token1] = ACTIONS(926),
    [aux_sym_preproc_if_token1] = ACTIONS(926),
    [aux_sym_preproc_if_token2] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(926),
    [sym_preproc_directive] = ACTIONS(926),
    [anon_sym_LPAREN2] = ACTIONS(928),
    [anon_sym_BANG] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(928),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_STAR] = ACTIONS(928),
    [anon_sym_AMP] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(928),
    [anon_sym_typedef] = ACTIONS(926),
    [anon_sym_extern] = ACTIONS(926),
    [anon_sym___attribute__] = ACTIONS(926),
    [anon_sym___declspec] = ACTIONS(926),
    [anon_sym___cdecl] = ACTIONS(926),
    [anon_sym___clrcall] = ACTIONS(926),
    [anon_sym___stdcall] = ACTIONS(926),
    [anon_sym___fastcall] = ACTIONS(926),
    [anon_sym___thiscall] = ACTIONS(926),
    [anon_sym___vectorcall] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(926),
    [anon_sym_auto] = ACTIONS(926),
    [anon_sym_register] = ACTIONS(926),
    [anon_sym_inline] = ACTIONS(926),
    [anon_sym_const] = ACTIONS(926),
    [anon_sym_volatile] = ACTIONS(926),
    [anon_sym_restrict] = ACTIONS(926),
    [anon_sym__Atomic] = ACTIONS(926),
    [anon_sym_signed] = ACTIONS(926),
    [anon_sym_unsigned] = ACTIONS(926),
    [anon_sym_long] = ACTIONS(926),
    [anon_sym_short] = ACTIONS(926),
    [sym_primitive_type] = ACTIONS(926),
    [anon_sym_enum] = ACTIONS(926),
    [anon_sym_struct] = ACTIONS(926),
    [anon_sym_union] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(926),
    [anon_sym_else] = ACTIONS(1110),
    [anon_sym_switch] = ACTIONS(926),
    [anon_sym_case] = ACTIONS(926),
    [anon_sym_default] = ACTIONS(926),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_do] = ACTIONS(926),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(926),
    [anon_sym_break] = ACTIONS(926),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_goto] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(928),
    [anon_sym_PLUS_PLUS] = ACTIONS(928),
    [anon_sym_sizeof] = ACTIONS(926),
    [sym_number_literal] = ACTIONS(928),
    [anon_sym_L_SQUOTE] = ACTIONS(928),
    [anon_sym_u_SQUOTE] = ACTIONS(928),
    [anon_sym_U_SQUOTE] = ACTIONS(928),
    [anon_sym_u8_SQUOTE] = ACTIONS(928),
    [anon_sym_SQUOTE] = ACTIONS(928),
    [anon_sym_L_DQUOTE] = ACTIONS(928),
    [anon_sym_u_DQUOTE] = ACTIONS(928),
    [anon_sym_U_DQUOTE] = ACTIONS(928),
    [anon_sym_u8_DQUOTE] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(928),
    [sym_true] = ACTIONS(926),
    [sym_false] = ACTIONS(926),
    [sym_null] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [ts_builtin_sym_end] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1004),
    [aux_sym_preproc_include_token1] = ACTIONS(1004),
    [aux_sym_preproc_def_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1004),
    [sym_preproc_directive] = ACTIONS(1004),
    [anon_sym_LPAREN2] = ACTIONS(1006),
    [anon_sym_BANG] = ACTIONS(1006),
    [anon_sym_TILDE] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1006),
    [anon_sym_AMP] = ACTIONS(1006),
    [anon_sym_SEMI] = ACTIONS(1006),
    [anon_sym_typedef] = ACTIONS(1004),
    [anon_sym_extern] = ACTIONS(1004),
    [anon_sym___attribute__] = ACTIONS(1004),
    [anon_sym___declspec] = ACTIONS(1004),
    [anon_sym___cdecl] = ACTIONS(1004),
    [anon_sym___clrcall] = ACTIONS(1004),
    [anon_sym___stdcall] = ACTIONS(1004),
    [anon_sym___fastcall] = ACTIONS(1004),
    [anon_sym___thiscall] = ACTIONS(1004),
    [anon_sym___vectorcall] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1006),
    [anon_sym_static] = ACTIONS(1004),
    [anon_sym_auto] = ACTIONS(1004),
    [anon_sym_register] = ACTIONS(1004),
    [anon_sym_inline] = ACTIONS(1004),
    [anon_sym_const] = ACTIONS(1004),
    [anon_sym_volatile] = ACTIONS(1004),
    [anon_sym_restrict] = ACTIONS(1004),
    [anon_sym__Atomic] = ACTIONS(1004),
    [anon_sym_signed] = ACTIONS(1004),
    [anon_sym_unsigned] = ACTIONS(1004),
    [anon_sym_long] = ACTIONS(1004),
    [anon_sym_short] = ACTIONS(1004),
    [sym_primitive_type] = ACTIONS(1004),
    [anon_sym_enum] = ACTIONS(1004),
    [anon_sym_struct] = ACTIONS(1004),
    [anon_sym_union] = ACTIONS(1004),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(1004),
    [anon_sym_do] = ACTIONS(1004),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_return] = ACTIONS(1004),
    [anon_sym_break] = ACTIONS(1004),
    [anon_sym_continue] = ACTIONS(1004),
    [anon_sym_goto] = ACTIONS(1004),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_sizeof] = ACTIONS(1004),
    [sym_number_literal] = ACTIONS(1006),
    [anon_sym_L_SQUOTE] = ACTIONS(1006),
    [anon_sym_u_SQUOTE] = ACTIONS(1006),
    [anon_sym_U_SQUOTE] = ACTIONS(1006),
    [anon_sym_u8_SQUOTE] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1006),
    [anon_sym_L_DQUOTE] = ACTIONS(1006),
    [anon_sym_u_DQUOTE] = ACTIONS(1006),
    [anon_sym_U_DQUOTE] = ACTIONS(1006),
    [anon_sym_u8_DQUOTE] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1006),
    [sym_true] = ACTIONS(1004),
    [sym_false] = ACTIONS(1004),
    [sym_null] = ACTIONS(1004),
    [sym_comment] = ACTIONS(3),
  },
  [194] = {
    [sym_identifier] = ACTIONS(902),
    [aux_sym_preproc_include_token1] = ACTIONS(902),
    [aux_sym_preproc_def_token1] = ACTIONS(902),
    [aux_sym_preproc_if_token1] = ACTIONS(902),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(902),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(902),
    [sym_preproc_directive] = ACTIONS(902),
    [anon_sym_LPAREN2] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(904),
    [anon_sym_TILDE] = ACTIONS(904),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(904),
    [anon_sym_SEMI] = ACTIONS(904),
    [anon_sym_typedef] = ACTIONS(902),
    [anon_sym_extern] = ACTIONS(902),
    [anon_sym___attribute__] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(902),
    [anon_sym___cdecl] = ACTIONS(902),
    [anon_sym___clrcall] = ACTIONS(902),
    [anon_sym___stdcall] = ACTIONS(902),
    [anon_sym___fastcall] = ACTIONS(902),
    [anon_sym___thiscall] = ACTIONS(902),
    [anon_sym___vectorcall] = ACTIONS(902),
    [anon_sym_LBRACE] = ACTIONS(904),
    [anon_sym_RBRACE] = ACTIONS(904),
    [anon_sym_static] = ACTIONS(902),
    [anon_sym_auto] = ACTIONS(902),
    [anon_sym_register] = ACTIONS(902),
    [anon_sym_inline] = ACTIONS(902),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_volatile] = ACTIONS(902),
    [anon_sym_restrict] = ACTIONS(902),
    [anon_sym__Atomic] = ACTIONS(902),
    [anon_sym_signed] = ACTIONS(902),
    [anon_sym_unsigned] = ACTIONS(902),
    [anon_sym_long] = ACTIONS(902),
    [anon_sym_short] = ACTIONS(902),
    [sym_primitive_type] = ACTIONS(902),
    [anon_sym_enum] = ACTIONS(902),
    [anon_sym_struct] = ACTIONS(902),
    [anon_sym_union] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(902),
    [anon_sym_else] = ACTIONS(902),
    [anon_sym_switch] = ACTIONS(902),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(902),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_do] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(902),
    [anon_sym_return] = ACTIONS(902),
    [anon_sym_break] = ACTIONS(902),
    [anon_sym_continue] = ACTIONS(902),
    [anon_sym_goto] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(904),
    [anon_sym_PLUS_PLUS] = ACTIONS(904),
    [anon_sym_sizeof] = ACTIONS(902),
    [sym_number_literal] = ACTIONS(904),
    [anon_sym_L_SQUOTE] = ACTIONS(904),
    [anon_sym_u_SQUOTE] = ACTIONS(904),
    [anon_sym_U_SQUOTE] = ACTIONS(904),
    [anon_sym_u8_SQUOTE] = ACTIONS(904),
    [anon_sym_SQUOTE] = ACTIONS(904),
    [anon_sym_L_DQUOTE] = ACTIONS(904),
    [anon_sym_u_DQUOTE] = ACTIONS(904),
    [anon_sym_U_DQUOTE] = ACTIONS(904),
    [anon_sym_u8_DQUOTE] = ACTIONS(904),
    [anon_sym_DQUOTE] = ACTIONS(904),
    [sym_true] = ACTIONS(902),
    [sym_false] = ACTIONS(902),
    [sym_null] = ACTIONS(902),
    [sym_comment] = ACTIONS(3),
  },
  [195] = {
    [sym_identifier] = ACTIONS(914),
    [aux_sym_preproc_include_token1] = ACTIONS(914),
    [aux_sym_preproc_def_token1] = ACTIONS(914),
    [aux_sym_preproc_if_token1] = ACTIONS(914),
    [aux_sym_preproc_if_token2] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(914),
    [sym_preproc_directive] = ACTIONS(914),
    [anon_sym_LPAREN2] = ACTIONS(916),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(914),
    [anon_sym_STAR] = ACTIONS(916),
    [anon_sym_AMP] = ACTIONS(916),
    [anon_sym_SEMI] = ACTIONS(916),
    [anon_sym_typedef] = ACTIONS(914),
    [anon_sym_extern] = ACTIONS(914),
    [anon_sym___attribute__] = ACTIONS(914),
    [anon_sym___declspec] = ACTIONS(914),
    [anon_sym___cdecl] = ACTIONS(914),
    [anon_sym___clrcall] = ACTIONS(914),
    [anon_sym___stdcall] = ACTIONS(914),
    [anon_sym___fastcall] = ACTIONS(914),
    [anon_sym___thiscall] = ACTIONS(914),
    [anon_sym___vectorcall] = ACTIONS(914),
    [anon_sym_LBRACE] = ACTIONS(916),
    [anon_sym_static] = ACTIONS(914),
    [anon_sym_auto] = ACTIONS(914),
    [anon_sym_register] = ACTIONS(914),
    [anon_sym_inline] = ACTIONS(914),
    [anon_sym_const] = ACTIONS(914),
    [anon_sym_volatile] = ACTIONS(914),
    [anon_sym_restrict] = ACTIONS(914),
    [anon_sym__Atomic] = ACTIONS(914),
    [anon_sym_signed] = ACTIONS(914),
    [anon_sym_unsigned] = ACTIONS(914),
    [anon_sym_long] = ACTIONS(914),
    [anon_sym_short] = ACTIONS(914),
    [sym_primitive_type] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(914),
    [anon_sym_struct] = ACTIONS(914),
    [anon_sym_union] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_else] = ACTIONS(914),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_case] = ACTIONS(914),
    [anon_sym_default] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [anon_sym_do] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_goto] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_sizeof] = ACTIONS(914),
    [sym_number_literal] = ACTIONS(916),
    [anon_sym_L_SQUOTE] = ACTIONS(916),
    [anon_sym_u_SQUOTE] = ACTIONS(916),
    [anon_sym_U_SQUOTE] = ACTIONS(916),
    [anon_sym_u8_SQUOTE] = ACTIONS(916),
    [anon_sym_SQUOTE] = ACTIONS(916),
    [anon_sym_L_DQUOTE] = ACTIONS(916),
    [anon_sym_u_DQUOTE] = ACTIONS(916),
    [anon_sym_U_DQUOTE] = ACTIONS(916),
    [anon_sym_u8_DQUOTE] = ACTIONS(916),
    [anon_sym_DQUOTE] = ACTIONS(916),
    [sym_true] = ACTIONS(914),
    [sym_false] = ACTIONS(914),
    [sym_null] = ACTIONS(914),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [ts_builtin_sym_end] = ACTIONS(1022),
    [sym_identifier] = ACTIONS(1020),
    [aux_sym_preproc_include_token1] = ACTIONS(1020),
    [aux_sym_preproc_def_token1] = ACTIONS(1020),
    [aux_sym_preproc_if_token1] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1020),
    [sym_preproc_directive] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1022),
    [anon_sym_TILDE] = ACTIONS(1022),
    [anon_sym_DASH] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1020),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_AMP] = ACTIONS(1022),
    [anon_sym_SEMI] = ACTIONS(1022),
    [anon_sym_typedef] = ACTIONS(1020),
    [anon_sym_extern] = ACTIONS(1020),
    [anon_sym___attribute__] = ACTIONS(1020),
    [anon_sym___declspec] = ACTIONS(1020),
    [anon_sym___cdecl] = ACTIONS(1020),
    [anon_sym___clrcall] = ACTIONS(1020),
    [anon_sym___stdcall] = ACTIONS(1020),
    [anon_sym___fastcall] = ACTIONS(1020),
    [anon_sym___thiscall] = ACTIONS(1020),
    [anon_sym___vectorcall] = ACTIONS(1020),
    [anon_sym_LBRACE] = ACTIONS(1022),
    [anon_sym_static] = ACTIONS(1020),
    [anon_sym_auto] = ACTIONS(1020),
    [anon_sym_register] = ACTIONS(1020),
    [anon_sym_inline] = ACTIONS(1020),
    [anon_sym_const] = ACTIONS(1020),
    [anon_sym_volatile] = ACTIONS(1020),
    [anon_sym_restrict] = ACTIONS(1020),
    [anon_sym__Atomic] = ACTIONS(1020),
    [anon_sym_signed] = ACTIONS(1020),
    [anon_sym_unsigned] = ACTIONS(1020),
    [anon_sym_long] = ACTIONS(1020),
    [anon_sym_short] = ACTIONS(1020),
    [sym_primitive_type] = ACTIONS(1020),
    [anon_sym_enum] = ACTIONS(1020),
    [anon_sym_struct] = ACTIONS(1020),
    [anon_sym_union] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_switch] = ACTIONS(1020),
    [anon_sym_case] = ACTIONS(1020),
    [anon_sym_default] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_goto] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1022),
    [anon_sym_PLUS_PLUS] = ACTIONS(1022),
    [anon_sym_sizeof] = ACTIONS(1020),
    [sym_number_literal] = ACTIONS(1022),
    [anon_sym_L_SQUOTE] = ACTIONS(1022),
    [anon_sym_u_SQUOTE] = ACTIONS(1022),
    [anon_sym_U_SQUOTE] = ACTIONS(1022),
    [anon_sym_u8_SQUOTE] = ACTIONS(1022),
    [anon_sym_SQUOTE] = ACTIONS(1022),
    [anon_sym_L_DQUOTE] = ACTIONS(1022),
    [anon_sym_u_DQUOTE] = ACTIONS(1022),
    [anon_sym_U_DQUOTE] = ACTIONS(1022),
    [anon_sym_u8_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [sym_true] = ACTIONS(1020),
    [sym_false] = ACTIONS(1020),
    [sym_null] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
  },
  [197] = {
    [sym_identifier] = ACTIONS(936),
    [aux_sym_preproc_include_token1] = ACTIONS(936),
    [aux_sym_preproc_def_token1] = ACTIONS(936),
    [aux_sym_preproc_if_token1] = ACTIONS(936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(936),
    [sym_preproc_directive] = ACTIONS(936),
    [anon_sym_LPAREN2] = ACTIONS(938),
    [anon_sym_BANG] = ACTIONS(938),
    [anon_sym_TILDE] = ACTIONS(938),
    [anon_sym_DASH] = ACTIONS(936),
    [anon_sym_PLUS] = ACTIONS(936),
    [anon_sym_STAR] = ACTIONS(938),
    [anon_sym_AMP] = ACTIONS(938),
    [anon_sym_SEMI] = ACTIONS(938),
    [anon_sym_typedef] = ACTIONS(936),
    [anon_sym_extern] = ACTIONS(936),
    [anon_sym___attribute__] = ACTIONS(936),
    [anon_sym___declspec] = ACTIONS(936),
    [anon_sym___cdecl] = ACTIONS(936),
    [anon_sym___clrcall] = ACTIONS(936),
    [anon_sym___stdcall] = ACTIONS(936),
    [anon_sym___fastcall] = ACTIONS(936),
    [anon_sym___thiscall] = ACTIONS(936),
    [anon_sym___vectorcall] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(938),
    [anon_sym_RBRACE] = ACTIONS(938),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_auto] = ACTIONS(936),
    [anon_sym_register] = ACTIONS(936),
    [anon_sym_inline] = ACTIONS(936),
    [anon_sym_const] = ACTIONS(936),
    [anon_sym_volatile] = ACTIONS(936),
    [anon_sym_restrict] = ACTIONS(936),
    [anon_sym__Atomic] = ACTIONS(936),
    [anon_sym_signed] = ACTIONS(936),
    [anon_sym_unsigned] = ACTIONS(936),
    [anon_sym_long] = ACTIONS(936),
    [anon_sym_short] = ACTIONS(936),
    [sym_primitive_type] = ACTIONS(936),
    [anon_sym_enum] = ACTIONS(936),
    [anon_sym_struct] = ACTIONS(936),
    [anon_sym_union] = ACTIONS(936),
    [anon_sym_if] = ACTIONS(936),
    [anon_sym_else] = ACTIONS(936),
    [anon_sym_switch] = ACTIONS(936),
    [anon_sym_case] = ACTIONS(936),
    [anon_sym_default] = ACTIONS(936),
    [anon_sym_while] = ACTIONS(936),
    [anon_sym_do] = ACTIONS(936),
    [anon_sym_for] = ACTIONS(936),
    [anon_sym_return] = ACTIONS(936),
    [anon_sym_break] = ACTIONS(936),
    [anon_sym_continue] = ACTIONS(936),
    [anon_sym_goto] = ACTIONS(936),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_sizeof] = ACTIONS(936),
    [sym_number_literal] = ACTIONS(938),
    [anon_sym_L_SQUOTE] = ACTIONS(938),
    [anon_sym_u_SQUOTE] = ACTIONS(938),
    [anon_sym_U_SQUOTE] = ACTIONS(938),
    [anon_sym_u8_SQUOTE] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(938),
    [anon_sym_L_DQUOTE] = ACTIONS(938),
    [anon_sym_u_DQUOTE] = ACTIONS(938),
    [anon_sym_U_DQUOTE] = ACTIONS(938),
    [anon_sym_u8_DQUOTE] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [sym_true] = ACTIONS(936),
    [sym_false] = ACTIONS(936),
    [sym_null] = ACTIONS(936),
    [sym_comment] = ACTIONS(3),
  },
  [198] = {
    [sym_identifier] = ACTIONS(918),
    [aux_sym_preproc_include_token1] = ACTIONS(918),
    [aux_sym_preproc_def_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token2] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(918),
    [sym_preproc_directive] = ACTIONS(918),
    [anon_sym_LPAREN2] = ACTIONS(920),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_STAR] = ACTIONS(920),
    [anon_sym_AMP] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(920),
    [anon_sym_typedef] = ACTIONS(918),
    [anon_sym_extern] = ACTIONS(918),
    [anon_sym___attribute__] = ACTIONS(918),
    [anon_sym___declspec] = ACTIONS(918),
    [anon_sym___cdecl] = ACTIONS(918),
    [anon_sym___clrcall] = ACTIONS(918),
    [anon_sym___stdcall] = ACTIONS(918),
    [anon_sym___fastcall] = ACTIONS(918),
    [anon_sym___thiscall] = ACTIONS(918),
    [anon_sym___vectorcall] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_static] = ACTIONS(918),
    [anon_sym_auto] = ACTIONS(918),
    [anon_sym_register] = ACTIONS(918),
    [anon_sym_inline] = ACTIONS(918),
    [anon_sym_const] = ACTIONS(918),
    [anon_sym_volatile] = ACTIONS(918),
    [anon_sym_restrict] = ACTIONS(918),
    [anon_sym__Atomic] = ACTIONS(918),
    [anon_sym_signed] = ACTIONS(918),
    [anon_sym_unsigned] = ACTIONS(918),
    [anon_sym_long] = ACTIONS(918),
    [anon_sym_short] = ACTIONS(918),
    [sym_primitive_type] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(918),
    [anon_sym_struct] = ACTIONS(918),
    [anon_sym_union] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(918),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_for] = ACTIONS(918),
    [anon_sym_return] = ACTIONS(918),
    [anon_sym_break] = ACTIONS(918),
    [anon_sym_continue] = ACTIONS(918),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(920),
    [anon_sym_sizeof] = ACTIONS(918),
    [sym_number_literal] = ACTIONS(920),
    [anon_sym_L_SQUOTE] = ACTIONS(920),
    [anon_sym_u_SQUOTE] = ACTIONS(920),
    [anon_sym_U_SQUOTE] = ACTIONS(920),
    [anon_sym_u8_SQUOTE] = ACTIONS(920),
    [anon_sym_SQUOTE] = ACTIONS(920),
    [anon_sym_L_DQUOTE] = ACTIONS(920),
    [anon_sym_u_DQUOTE] = ACTIONS(920),
    [anon_sym_U_DQUOTE] = ACTIONS(920),
    [anon_sym_u8_DQUOTE] = ACTIONS(920),
    [anon_sym_DQUOTE] = ACTIONS(920),
    [sym_true] = ACTIONS(918),
    [sym_false] = ACTIONS(918),
    [sym_null] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
  },
  [199] = {
    [sym_identifier] = ACTIONS(988),
    [aux_sym_preproc_include_token1] = ACTIONS(988),
    [aux_sym_preproc_def_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token1] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(988),
    [sym_preproc_directive] = ACTIONS(988),
    [anon_sym_LPAREN2] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(990),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_SEMI] = ACTIONS(990),
    [anon_sym_typedef] = ACTIONS(988),
    [anon_sym_extern] = ACTIONS(988),
    [anon_sym___attribute__] = ACTIONS(988),
    [anon_sym___declspec] = ACTIONS(988),
    [anon_sym___cdecl] = ACTIONS(988),
    [anon_sym___clrcall] = ACTIONS(988),
    [anon_sym___stdcall] = ACTIONS(988),
    [anon_sym___fastcall] = ACTIONS(988),
    [anon_sym___thiscall] = ACTIONS(988),
    [anon_sym___vectorcall] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(990),
    [anon_sym_RBRACE] = ACTIONS(990),
    [anon_sym_static] = ACTIONS(988),
    [anon_sym_auto] = ACTIONS(988),
    [anon_sym_register] = ACTIONS(988),
    [anon_sym_inline] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(988),
    [anon_sym_volatile] = ACTIONS(988),
    [anon_sym_restrict] = ACTIONS(988),
    [anon_sym__Atomic] = ACTIONS(988),
    [anon_sym_signed] = ACTIONS(988),
    [anon_sym_unsigned] = ACTIONS(988),
    [anon_sym_long] = ACTIONS(988),
    [anon_sym_short] = ACTIONS(988),
    [sym_primitive_type] = ACTIONS(988),
    [anon_sym_enum] = ACTIONS(988),
    [anon_sym_struct] = ACTIONS(988),
    [anon_sym_union] = ACTIONS(988),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(988),
    [anon_sym_switch] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(988),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_while] = ACTIONS(988),
    [anon_sym_do] = ACTIONS(988),
    [anon_sym_for] = ACTIONS(988),
    [anon_sym_return] = ACTIONS(988),
    [anon_sym_break] = ACTIONS(988),
    [anon_sym_continue] = ACTIONS(988),
    [anon_sym_goto] = ACTIONS(988),
    [anon_sym_DASH_DASH] = ACTIONS(990),
    [anon_sym_PLUS_PLUS] = ACTIONS(990),
    [anon_sym_sizeof] = ACTIONS(988),
    [sym_number_literal] = ACTIONS(990),
    [anon_sym_L_SQUOTE] = ACTIONS(990),
    [anon_sym_u_SQUOTE] = ACTIONS(990),
    [anon_sym_U_SQUOTE] = ACTIONS(990),
    [anon_sym_u8_SQUOTE] = ACTIONS(990),
    [anon_sym_SQUOTE] = ACTIONS(990),
    [anon_sym_L_DQUOTE] = ACTIONS(990),
    [anon_sym_u_DQUOTE] = ACTIONS(990),
    [anon_sym_U_DQUOTE] = ACTIONS(990),
    [anon_sym_u8_DQUOTE] = ACTIONS(990),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_true] = ACTIONS(988),
    [sym_false] = ACTIONS(988),
    [sym_null] = ACTIONS(988),
    [sym_comment] = ACTIONS(3),
  },
  [200] = {
    [sym_identifier] = ACTIONS(944),
    [aux_sym_preproc_include_token1] = ACTIONS(944),
    [aux_sym_preproc_def_token1] = ACTIONS(944),
    [aux_sym_preproc_if_token1] = ACTIONS(944),
    [aux_sym_preproc_if_token2] = ACTIONS(944),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(944),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(944),
    [sym_preproc_directive] = ACTIONS(944),
    [anon_sym_LPAREN2] = ACTIONS(946),
    [anon_sym_BANG] = ACTIONS(946),
    [anon_sym_TILDE] = ACTIONS(946),
    [anon_sym_DASH] = ACTIONS(944),
    [anon_sym_PLUS] = ACTIONS(944),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_AMP] = ACTIONS(946),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_typedef] = ACTIONS(944),
    [anon_sym_extern] = ACTIONS(944),
    [anon_sym___attribute__] = ACTIONS(944),
    [anon_sym___declspec] = ACTIONS(944),
    [anon_sym___cdecl] = ACTIONS(944),
    [anon_sym___clrcall] = ACTIONS(944),
    [anon_sym___stdcall] = ACTIONS(944),
    [anon_sym___fastcall] = ACTIONS(944),
    [anon_sym___thiscall] = ACTIONS(944),
    [anon_sym___vectorcall] = ACTIONS(944),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_auto] = ACTIONS(944),
    [anon_sym_register] = ACTIONS(944),
    [anon_sym_inline] = ACTIONS(944),
    [anon_sym_const] = ACTIONS(944),
    [anon_sym_volatile] = ACTIONS(944),
    [anon_sym_restrict] = ACTIONS(944),
    [anon_sym__Atomic] = ACTIONS(944),
    [anon_sym_signed] = ACTIONS(944),
    [anon_sym_unsigned] = ACTIONS(944),
    [anon_sym_long] = ACTIONS(944),
    [anon_sym_short] = ACTIONS(944),
    [sym_primitive_type] = ACTIONS(944),
    [anon_sym_enum] = ACTIONS(944),
    [anon_sym_struct] = ACTIONS(944),
    [anon_sym_union] = ACTIONS(944),
    [anon_sym_if] = ACTIONS(944),
    [anon_sym_else] = ACTIONS(944),
    [anon_sym_switch] = ACTIONS(944),
    [anon_sym_case] = ACTIONS(944),
    [anon_sym_default] = ACTIONS(944),
    [anon_sym_while] = ACTIONS(944),
    [anon_sym_do] = ACTIONS(944),
    [anon_sym_for] = ACTIONS(944),
    [anon_sym_return] = ACTIONS(944),
    [anon_sym_break] = ACTIONS(944),
    [anon_sym_continue] = ACTIONS(944),
    [anon_sym_goto] = ACTIONS(944),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_sizeof] = ACTIONS(944),
    [sym_number_literal] = ACTIONS(946),
    [anon_sym_L_SQUOTE] = ACTIONS(946),
    [anon_sym_u_SQUOTE] = ACTIONS(946),
    [anon_sym_U_SQUOTE] = ACTIONS(946),
    [anon_sym_u8_SQUOTE] = ACTIONS(946),
    [anon_sym_SQUOTE] = ACTIONS(946),
    [anon_sym_L_DQUOTE] = ACTIONS(946),
    [anon_sym_u_DQUOTE] = ACTIONS(946),
    [anon_sym_U_DQUOTE] = ACTIONS(946),
    [anon_sym_u8_DQUOTE] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(946),
    [sym_true] = ACTIONS(944),
    [sym_false] = ACTIONS(944),
    [sym_null] = ACTIONS(944),
    [sym_comment] = ACTIONS(3),
  },
  [201] = {
    [sym_identifier] = ACTIONS(996),
    [aux_sym_preproc_include_token1] = ACTIONS(996),
    [aux_sym_preproc_def_token1] = ACTIONS(996),
    [aux_sym_preproc_if_token1] = ACTIONS(996),
    [aux_sym_preproc_if_token2] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(996),
    [sym_preproc_directive] = ACTIONS(996),
    [anon_sym_LPAREN2] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(998),
    [anon_sym_AMP] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(998),
    [anon_sym_typedef] = ACTIONS(996),
    [anon_sym_extern] = ACTIONS(996),
    [anon_sym___attribute__] = ACTIONS(996),
    [anon_sym___declspec] = ACTIONS(996),
    [anon_sym___cdecl] = ACTIONS(996),
    [anon_sym___clrcall] = ACTIONS(996),
    [anon_sym___stdcall] = ACTIONS(996),
    [anon_sym___fastcall] = ACTIONS(996),
    [anon_sym___thiscall] = ACTIONS(996),
    [anon_sym___vectorcall] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_static] = ACTIONS(996),
    [anon_sym_auto] = ACTIONS(996),
    [anon_sym_register] = ACTIONS(996),
    [anon_sym_inline] = ACTIONS(996),
    [anon_sym_const] = ACTIONS(996),
    [anon_sym_volatile] = ACTIONS(996),
    [anon_sym_restrict] = ACTIONS(996),
    [anon_sym__Atomic] = ACTIONS(996),
    [anon_sym_signed] = ACTIONS(996),
    [anon_sym_unsigned] = ACTIONS(996),
    [anon_sym_long] = ACTIONS(996),
    [anon_sym_short] = ACTIONS(996),
    [sym_primitive_type] = ACTIONS(996),
    [anon_sym_enum] = ACTIONS(996),
    [anon_sym_struct] = ACTIONS(996),
    [anon_sym_union] = ACTIONS(996),
    [anon_sym_if] = ACTIONS(996),
    [anon_sym_else] = ACTIONS(996),
    [anon_sym_switch] = ACTIONS(996),
    [anon_sym_case] = ACTIONS(996),
    [anon_sym_default] = ACTIONS(996),
    [anon_sym_while] = ACTIONS(996),
    [anon_sym_do] = ACTIONS(996),
    [anon_sym_for] = ACTIONS(996),
    [anon_sym_return] = ACTIONS(996),
    [anon_sym_break] = ACTIONS(996),
    [anon_sym_continue] = ACTIONS(996),
    [anon_sym_goto] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(996),
    [sym_number_literal] = ACTIONS(998),
    [anon_sym_L_SQUOTE] = ACTIONS(998),
    [anon_sym_u_SQUOTE] = ACTIONS(998),
    [anon_sym_U_SQUOTE] = ACTIONS(998),
    [anon_sym_u8_SQUOTE] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(998),
    [anon_sym_L_DQUOTE] = ACTIONS(998),
    [anon_sym_u_DQUOTE] = ACTIONS(998),
    [anon_sym_U_DQUOTE] = ACTIONS(998),
    [anon_sym_u8_DQUOTE] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(998),
    [sym_true] = ACTIONS(996),
    [sym_false] = ACTIONS(996),
    [sym_null] = ACTIONS(996),
    [sym_comment] = ACTIONS(3),
  },
  [202] = {
    [ts_builtin_sym_end] = ACTIONS(1018),
    [sym_identifier] = ACTIONS(1016),
    [aux_sym_preproc_include_token1] = ACTIONS(1016),
    [aux_sym_preproc_def_token1] = ACTIONS(1016),
    [aux_sym_preproc_if_token1] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1016),
    [sym_preproc_directive] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1018),
    [anon_sym_BANG] = ACTIONS(1018),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1016),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_AMP] = ACTIONS(1018),
    [anon_sym_SEMI] = ACTIONS(1018),
    [anon_sym_typedef] = ACTIONS(1016),
    [anon_sym_extern] = ACTIONS(1016),
    [anon_sym___attribute__] = ACTIONS(1016),
    [anon_sym___declspec] = ACTIONS(1016),
    [anon_sym___cdecl] = ACTIONS(1016),
    [anon_sym___clrcall] = ACTIONS(1016),
    [anon_sym___stdcall] = ACTIONS(1016),
    [anon_sym___fastcall] = ACTIONS(1016),
    [anon_sym___thiscall] = ACTIONS(1016),
    [anon_sym___vectorcall] = ACTIONS(1016),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_static] = ACTIONS(1016),
    [anon_sym_auto] = ACTIONS(1016),
    [anon_sym_register] = ACTIONS(1016),
    [anon_sym_inline] = ACTIONS(1016),
    [anon_sym_const] = ACTIONS(1016),
    [anon_sym_volatile] = ACTIONS(1016),
    [anon_sym_restrict] = ACTIONS(1016),
    [anon_sym__Atomic] = ACTIONS(1016),
    [anon_sym_signed] = ACTIONS(1016),
    [anon_sym_unsigned] = ACTIONS(1016),
    [anon_sym_long] = ACTIONS(1016),
    [anon_sym_short] = ACTIONS(1016),
    [sym_primitive_type] = ACTIONS(1016),
    [anon_sym_enum] = ACTIONS(1016),
    [anon_sym_struct] = ACTIONS(1016),
    [anon_sym_union] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1016),
    [anon_sym_switch] = ACTIONS(1016),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_default] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_goto] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [anon_sym_sizeof] = ACTIONS(1016),
    [sym_number_literal] = ACTIONS(1018),
    [anon_sym_L_SQUOTE] = ACTIONS(1018),
    [anon_sym_u_SQUOTE] = ACTIONS(1018),
    [anon_sym_U_SQUOTE] = ACTIONS(1018),
    [anon_sym_u8_SQUOTE] = ACTIONS(1018),
    [anon_sym_SQUOTE] = ACTIONS(1018),
    [anon_sym_L_DQUOTE] = ACTIONS(1018),
    [anon_sym_u_DQUOTE] = ACTIONS(1018),
    [anon_sym_U_DQUOTE] = ACTIONS(1018),
    [anon_sym_u8_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [sym_true] = ACTIONS(1016),
    [sym_false] = ACTIONS(1016),
    [sym_null] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [ts_builtin_sym_end] = ACTIONS(916),
    [sym_identifier] = ACTIONS(914),
    [aux_sym_preproc_include_token1] = ACTIONS(914),
    [aux_sym_preproc_def_token1] = ACTIONS(914),
    [aux_sym_preproc_if_token1] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(914),
    [sym_preproc_directive] = ACTIONS(914),
    [anon_sym_LPAREN2] = ACTIONS(916),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(914),
    [anon_sym_STAR] = ACTIONS(916),
    [anon_sym_AMP] = ACTIONS(916),
    [anon_sym_SEMI] = ACTIONS(916),
    [anon_sym_typedef] = ACTIONS(914),
    [anon_sym_extern] = ACTIONS(914),
    [anon_sym___attribute__] = ACTIONS(914),
    [anon_sym___declspec] = ACTIONS(914),
    [anon_sym___cdecl] = ACTIONS(914),
    [anon_sym___clrcall] = ACTIONS(914),
    [anon_sym___stdcall] = ACTIONS(914),
    [anon_sym___fastcall] = ACTIONS(914),
    [anon_sym___thiscall] = ACTIONS(914),
    [anon_sym___vectorcall] = ACTIONS(914),
    [anon_sym_LBRACE] = ACTIONS(916),
    [anon_sym_static] = ACTIONS(914),
    [anon_sym_auto] = ACTIONS(914),
    [anon_sym_register] = ACTIONS(914),
    [anon_sym_inline] = ACTIONS(914),
    [anon_sym_const] = ACTIONS(914),
    [anon_sym_volatile] = ACTIONS(914),
    [anon_sym_restrict] = ACTIONS(914),
    [anon_sym__Atomic] = ACTIONS(914),
    [anon_sym_signed] = ACTIONS(914),
    [anon_sym_unsigned] = ACTIONS(914),
    [anon_sym_long] = ACTIONS(914),
    [anon_sym_short] = ACTIONS(914),
    [sym_primitive_type] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(914),
    [anon_sym_struct] = ACTIONS(914),
    [anon_sym_union] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_else] = ACTIONS(914),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_case] = ACTIONS(914),
    [anon_sym_default] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [anon_sym_do] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_goto] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_sizeof] = ACTIONS(914),
    [sym_number_literal] = ACTIONS(916),
    [anon_sym_L_SQUOTE] = ACTIONS(916),
    [anon_sym_u_SQUOTE] = ACTIONS(916),
    [anon_sym_U_SQUOTE] = ACTIONS(916),
    [anon_sym_u8_SQUOTE] = ACTIONS(916),
    [anon_sym_SQUOTE] = ACTIONS(916),
    [anon_sym_L_DQUOTE] = ACTIONS(916),
    [anon_sym_u_DQUOTE] = ACTIONS(916),
    [anon_sym_U_DQUOTE] = ACTIONS(916),
    [anon_sym_u8_DQUOTE] = ACTIONS(916),
    [anon_sym_DQUOTE] = ACTIONS(916),
    [sym_true] = ACTIONS(914),
    [sym_false] = ACTIONS(914),
    [sym_null] = ACTIONS(914),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [ts_builtin_sym_end] = ACTIONS(1002),
    [sym_identifier] = ACTIONS(1000),
    [aux_sym_preproc_include_token1] = ACTIONS(1000),
    [aux_sym_preproc_def_token1] = ACTIONS(1000),
    [aux_sym_preproc_if_token1] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1000),
    [sym_preproc_directive] = ACTIONS(1000),
    [anon_sym_LPAREN2] = ACTIONS(1002),
    [anon_sym_BANG] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_typedef] = ACTIONS(1000),
    [anon_sym_extern] = ACTIONS(1000),
    [anon_sym___attribute__] = ACTIONS(1000),
    [anon_sym___declspec] = ACTIONS(1000),
    [anon_sym___cdecl] = ACTIONS(1000),
    [anon_sym___clrcall] = ACTIONS(1000),
    [anon_sym___stdcall] = ACTIONS(1000),
    [anon_sym___fastcall] = ACTIONS(1000),
    [anon_sym___thiscall] = ACTIONS(1000),
    [anon_sym___vectorcall] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(1002),
    [anon_sym_static] = ACTIONS(1000),
    [anon_sym_auto] = ACTIONS(1000),
    [anon_sym_register] = ACTIONS(1000),
    [anon_sym_inline] = ACTIONS(1000),
    [anon_sym_const] = ACTIONS(1000),
    [anon_sym_volatile] = ACTIONS(1000),
    [anon_sym_restrict] = ACTIONS(1000),
    [anon_sym__Atomic] = ACTIONS(1000),
    [anon_sym_signed] = ACTIONS(1000),
    [anon_sym_unsigned] = ACTIONS(1000),
    [anon_sym_long] = ACTIONS(1000),
    [anon_sym_short] = ACTIONS(1000),
    [sym_primitive_type] = ACTIONS(1000),
    [anon_sym_enum] = ACTIONS(1000),
    [anon_sym_struct] = ACTIONS(1000),
    [anon_sym_union] = ACTIONS(1000),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_else] = ACTIONS(1000),
    [anon_sym_switch] = ACTIONS(1000),
    [anon_sym_case] = ACTIONS(1000),
    [anon_sym_default] = ACTIONS(1000),
    [anon_sym_while] = ACTIONS(1000),
    [anon_sym_do] = ACTIONS(1000),
    [anon_sym_for] = ACTIONS(1000),
    [anon_sym_return] = ACTIONS(1000),
    [anon_sym_break] = ACTIONS(1000),
    [anon_sym_continue] = ACTIONS(1000),
    [anon_sym_goto] = ACTIONS(1000),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1002),
    [anon_sym_L_SQUOTE] = ACTIONS(1002),
    [anon_sym_u_SQUOTE] = ACTIONS(1002),
    [anon_sym_U_SQUOTE] = ACTIONS(1002),
    [anon_sym_u8_SQUOTE] = ACTIONS(1002),
    [anon_sym_SQUOTE] = ACTIONS(1002),
    [anon_sym_L_DQUOTE] = ACTIONS(1002),
    [anon_sym_u_DQUOTE] = ACTIONS(1002),
    [anon_sym_U_DQUOTE] = ACTIONS(1002),
    [anon_sym_u8_DQUOTE] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1002),
    [sym_true] = ACTIONS(1000),
    [sym_false] = ACTIONS(1000),
    [sym_null] = ACTIONS(1000),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [ts_builtin_sym_end] = ACTIONS(892),
    [sym_identifier] = ACTIONS(890),
    [aux_sym_preproc_include_token1] = ACTIONS(890),
    [aux_sym_preproc_def_token1] = ACTIONS(890),
    [aux_sym_preproc_if_token1] = ACTIONS(890),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(890),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(890),
    [sym_preproc_directive] = ACTIONS(890),
    [anon_sym_LPAREN2] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(892),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(892),
    [anon_sym_typedef] = ACTIONS(890),
    [anon_sym_extern] = ACTIONS(890),
    [anon_sym___attribute__] = ACTIONS(890),
    [anon_sym___declspec] = ACTIONS(890),
    [anon_sym___cdecl] = ACTIONS(890),
    [anon_sym___clrcall] = ACTIONS(890),
    [anon_sym___stdcall] = ACTIONS(890),
    [anon_sym___fastcall] = ACTIONS(890),
    [anon_sym___thiscall] = ACTIONS(890),
    [anon_sym___vectorcall] = ACTIONS(890),
    [anon_sym_LBRACE] = ACTIONS(892),
    [anon_sym_static] = ACTIONS(890),
    [anon_sym_auto] = ACTIONS(890),
    [anon_sym_register] = ACTIONS(890),
    [anon_sym_inline] = ACTIONS(890),
    [anon_sym_const] = ACTIONS(890),
    [anon_sym_volatile] = ACTIONS(890),
    [anon_sym_restrict] = ACTIONS(890),
    [anon_sym__Atomic] = ACTIONS(890),
    [anon_sym_signed] = ACTIONS(890),
    [anon_sym_unsigned] = ACTIONS(890),
    [anon_sym_long] = ACTIONS(890),
    [anon_sym_short] = ACTIONS(890),
    [sym_primitive_type] = ACTIONS(890),
    [anon_sym_enum] = ACTIONS(890),
    [anon_sym_struct] = ACTIONS(890),
    [anon_sym_union] = ACTIONS(890),
    [anon_sym_if] = ACTIONS(890),
    [anon_sym_else] = ACTIONS(890),
    [anon_sym_switch] = ACTIONS(890),
    [anon_sym_case] = ACTIONS(890),
    [anon_sym_default] = ACTIONS(890),
    [anon_sym_while] = ACTIONS(890),
    [anon_sym_do] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(890),
    [anon_sym_return] = ACTIONS(890),
    [anon_sym_break] = ACTIONS(890),
    [anon_sym_continue] = ACTIONS(890),
    [anon_sym_goto] = ACTIONS(890),
    [anon_sym_DASH_DASH] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(892),
    [anon_sym_sizeof] = ACTIONS(890),
    [sym_number_literal] = ACTIONS(892),
    [anon_sym_L_SQUOTE] = ACTIONS(892),
    [anon_sym_u_SQUOTE] = ACTIONS(892),
    [anon_sym_U_SQUOTE] = ACTIONS(892),
    [anon_sym_u8_SQUOTE] = ACTIONS(892),
    [anon_sym_SQUOTE] = ACTIONS(892),
    [anon_sym_L_DQUOTE] = ACTIONS(892),
    [anon_sym_u_DQUOTE] = ACTIONS(892),
    [anon_sym_U_DQUOTE] = ACTIONS(892),
    [anon_sym_u8_DQUOTE] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_true] = ACTIONS(890),
    [sym_false] = ACTIONS(890),
    [sym_null] = ACTIONS(890),
    [sym_comment] = ACTIONS(3),
  },
  [206] = {
    [ts_builtin_sym_end] = ACTIONS(982),
    [sym_identifier] = ACTIONS(980),
    [aux_sym_preproc_include_token1] = ACTIONS(980),
    [aux_sym_preproc_def_token1] = ACTIONS(980),
    [aux_sym_preproc_if_token1] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(980),
    [sym_preproc_directive] = ACTIONS(980),
    [anon_sym_LPAREN2] = ACTIONS(982),
    [anon_sym_BANG] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(980),
    [anon_sym_STAR] = ACTIONS(982),
    [anon_sym_AMP] = ACTIONS(982),
    [anon_sym_SEMI] = ACTIONS(982),
    [anon_sym_typedef] = ACTIONS(980),
    [anon_sym_extern] = ACTIONS(980),
    [anon_sym___attribute__] = ACTIONS(980),
    [anon_sym___declspec] = ACTIONS(980),
    [anon_sym___cdecl] = ACTIONS(980),
    [anon_sym___clrcall] = ACTIONS(980),
    [anon_sym___stdcall] = ACTIONS(980),
    [anon_sym___fastcall] = ACTIONS(980),
    [anon_sym___thiscall] = ACTIONS(980),
    [anon_sym___vectorcall] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(982),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_auto] = ACTIONS(980),
    [anon_sym_register] = ACTIONS(980),
    [anon_sym_inline] = ACTIONS(980),
    [anon_sym_const] = ACTIONS(980),
    [anon_sym_volatile] = ACTIONS(980),
    [anon_sym_restrict] = ACTIONS(980),
    [anon_sym__Atomic] = ACTIONS(980),
    [anon_sym_signed] = ACTIONS(980),
    [anon_sym_unsigned] = ACTIONS(980),
    [anon_sym_long] = ACTIONS(980),
    [anon_sym_short] = ACTIONS(980),
    [sym_primitive_type] = ACTIONS(980),
    [anon_sym_enum] = ACTIONS(980),
    [anon_sym_struct] = ACTIONS(980),
    [anon_sym_union] = ACTIONS(980),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_else] = ACTIONS(980),
    [anon_sym_switch] = ACTIONS(980),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_default] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [anon_sym_do] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_goto] = ACTIONS(980),
    [anon_sym_DASH_DASH] = ACTIONS(982),
    [anon_sym_PLUS_PLUS] = ACTIONS(982),
    [anon_sym_sizeof] = ACTIONS(980),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_L_SQUOTE] = ACTIONS(982),
    [anon_sym_u_SQUOTE] = ACTIONS(982),
    [anon_sym_U_SQUOTE] = ACTIONS(982),
    [anon_sym_u8_SQUOTE] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(982),
    [anon_sym_L_DQUOTE] = ACTIONS(982),
    [anon_sym_u_DQUOTE] = ACTIONS(982),
    [anon_sym_U_DQUOTE] = ACTIONS(982),
    [anon_sym_u8_DQUOTE] = ACTIONS(982),
    [anon_sym_DQUOTE] = ACTIONS(982),
    [sym_true] = ACTIONS(980),
    [sym_false] = ACTIONS(980),
    [sym_null] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
  },
  [207] = {
    [sym_identifier] = ACTIONS(936),
    [aux_sym_preproc_include_token1] = ACTIONS(936),
    [aux_sym_preproc_def_token1] = ACTIONS(936),
    [aux_sym_preproc_if_token1] = ACTIONS(936),
    [aux_sym_preproc_if_token2] = ACTIONS(936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(936),
    [sym_preproc_directive] = ACTIONS(936),
    [anon_sym_LPAREN2] = ACTIONS(938),
    [anon_sym_BANG] = ACTIONS(938),
    [anon_sym_TILDE] = ACTIONS(938),
    [anon_sym_DASH] = ACTIONS(936),
    [anon_sym_PLUS] = ACTIONS(936),
    [anon_sym_STAR] = ACTIONS(938),
    [anon_sym_AMP] = ACTIONS(938),
    [anon_sym_SEMI] = ACTIONS(938),
    [anon_sym_typedef] = ACTIONS(936),
    [anon_sym_extern] = ACTIONS(936),
    [anon_sym___attribute__] = ACTIONS(936),
    [anon_sym___declspec] = ACTIONS(936),
    [anon_sym___cdecl] = ACTIONS(936),
    [anon_sym___clrcall] = ACTIONS(936),
    [anon_sym___stdcall] = ACTIONS(936),
    [anon_sym___fastcall] = ACTIONS(936),
    [anon_sym___thiscall] = ACTIONS(936),
    [anon_sym___vectorcall] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(938),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_auto] = ACTIONS(936),
    [anon_sym_register] = ACTIONS(936),
    [anon_sym_inline] = ACTIONS(936),
    [anon_sym_const] = ACTIONS(936),
    [anon_sym_volatile] = ACTIONS(936),
    [anon_sym_restrict] = ACTIONS(936),
    [anon_sym__Atomic] = ACTIONS(936),
    [anon_sym_signed] = ACTIONS(936),
    [anon_sym_unsigned] = ACTIONS(936),
    [anon_sym_long] = ACTIONS(936),
    [anon_sym_short] = ACTIONS(936),
    [sym_primitive_type] = ACTIONS(936),
    [anon_sym_enum] = ACTIONS(936),
    [anon_sym_struct] = ACTIONS(936),
    [anon_sym_union] = ACTIONS(936),
    [anon_sym_if] = ACTIONS(936),
    [anon_sym_else] = ACTIONS(936),
    [anon_sym_switch] = ACTIONS(936),
    [anon_sym_case] = ACTIONS(936),
    [anon_sym_default] = ACTIONS(936),
    [anon_sym_while] = ACTIONS(936),
    [anon_sym_do] = ACTIONS(936),
    [anon_sym_for] = ACTIONS(936),
    [anon_sym_return] = ACTIONS(936),
    [anon_sym_break] = ACTIONS(936),
    [anon_sym_continue] = ACTIONS(936),
    [anon_sym_goto] = ACTIONS(936),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_sizeof] = ACTIONS(936),
    [sym_number_literal] = ACTIONS(938),
    [anon_sym_L_SQUOTE] = ACTIONS(938),
    [anon_sym_u_SQUOTE] = ACTIONS(938),
    [anon_sym_U_SQUOTE] = ACTIONS(938),
    [anon_sym_u8_SQUOTE] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(938),
    [anon_sym_L_DQUOTE] = ACTIONS(938),
    [anon_sym_u_DQUOTE] = ACTIONS(938),
    [anon_sym_U_DQUOTE] = ACTIONS(938),
    [anon_sym_u8_DQUOTE] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [sym_true] = ACTIONS(936),
    [sym_false] = ACTIONS(936),
    [sym_null] = ACTIONS(936),
    [sym_comment] = ACTIONS(3),
  },
  [208] = {
    [sym_identifier] = ACTIONS(906),
    [aux_sym_preproc_include_token1] = ACTIONS(906),
    [aux_sym_preproc_def_token1] = ACTIONS(906),
    [aux_sym_preproc_if_token1] = ACTIONS(906),
    [aux_sym_preproc_if_token2] = ACTIONS(906),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(906),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(906),
    [sym_preproc_directive] = ACTIONS(906),
    [anon_sym_LPAREN2] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(908),
    [anon_sym_TILDE] = ACTIONS(908),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_STAR] = ACTIONS(908),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_SEMI] = ACTIONS(908),
    [anon_sym_typedef] = ACTIONS(906),
    [anon_sym_extern] = ACTIONS(906),
    [anon_sym___attribute__] = ACTIONS(906),
    [anon_sym___declspec] = ACTIONS(906),
    [anon_sym___cdecl] = ACTIONS(906),
    [anon_sym___clrcall] = ACTIONS(906),
    [anon_sym___stdcall] = ACTIONS(906),
    [anon_sym___fastcall] = ACTIONS(906),
    [anon_sym___thiscall] = ACTIONS(906),
    [anon_sym___vectorcall] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_static] = ACTIONS(906),
    [anon_sym_auto] = ACTIONS(906),
    [anon_sym_register] = ACTIONS(906),
    [anon_sym_inline] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(906),
    [anon_sym_volatile] = ACTIONS(906),
    [anon_sym_restrict] = ACTIONS(906),
    [anon_sym__Atomic] = ACTIONS(906),
    [anon_sym_signed] = ACTIONS(906),
    [anon_sym_unsigned] = ACTIONS(906),
    [anon_sym_long] = ACTIONS(906),
    [anon_sym_short] = ACTIONS(906),
    [sym_primitive_type] = ACTIONS(906),
    [anon_sym_enum] = ACTIONS(906),
    [anon_sym_struct] = ACTIONS(906),
    [anon_sym_union] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_else] = ACTIONS(906),
    [anon_sym_switch] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_default] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_do] = ACTIONS(906),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_return] = ACTIONS(906),
    [anon_sym_break] = ACTIONS(906),
    [anon_sym_continue] = ACTIONS(906),
    [anon_sym_goto] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_sizeof] = ACTIONS(906),
    [sym_number_literal] = ACTIONS(908),
    [anon_sym_L_SQUOTE] = ACTIONS(908),
    [anon_sym_u_SQUOTE] = ACTIONS(908),
    [anon_sym_U_SQUOTE] = ACTIONS(908),
    [anon_sym_u8_SQUOTE] = ACTIONS(908),
    [anon_sym_SQUOTE] = ACTIONS(908),
    [anon_sym_L_DQUOTE] = ACTIONS(908),
    [anon_sym_u_DQUOTE] = ACTIONS(908),
    [anon_sym_U_DQUOTE] = ACTIONS(908),
    [anon_sym_u8_DQUOTE] = ACTIONS(908),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [sym_true] = ACTIONS(906),
    [sym_false] = ACTIONS(906),
    [sym_null] = ACTIONS(906),
    [sym_comment] = ACTIONS(3),
  },
  [209] = {
    [sym_identifier] = ACTIONS(956),
    [aux_sym_preproc_include_token1] = ACTIONS(956),
    [aux_sym_preproc_def_token1] = ACTIONS(956),
    [aux_sym_preproc_if_token1] = ACTIONS(956),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(956),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(956),
    [sym_preproc_directive] = ACTIONS(956),
    [anon_sym_LPAREN2] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(958),
    [anon_sym_AMP] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(958),
    [anon_sym_typedef] = ACTIONS(956),
    [anon_sym_extern] = ACTIONS(956),
    [anon_sym___attribute__] = ACTIONS(956),
    [anon_sym___declspec] = ACTIONS(956),
    [anon_sym___cdecl] = ACTIONS(956),
    [anon_sym___clrcall] = ACTIONS(956),
    [anon_sym___stdcall] = ACTIONS(956),
    [anon_sym___fastcall] = ACTIONS(956),
    [anon_sym___thiscall] = ACTIONS(956),
    [anon_sym___vectorcall] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_RBRACE] = ACTIONS(958),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_auto] = ACTIONS(956),
    [anon_sym_register] = ACTIONS(956),
    [anon_sym_inline] = ACTIONS(956),
    [anon_sym_const] = ACTIONS(956),
    [anon_sym_volatile] = ACTIONS(956),
    [anon_sym_restrict] = ACTIONS(956),
    [anon_sym__Atomic] = ACTIONS(956),
    [anon_sym_signed] = ACTIONS(956),
    [anon_sym_unsigned] = ACTIONS(956),
    [anon_sym_long] = ACTIONS(956),
    [anon_sym_short] = ACTIONS(956),
    [sym_primitive_type] = ACTIONS(956),
    [anon_sym_enum] = ACTIONS(956),
    [anon_sym_struct] = ACTIONS(956),
    [anon_sym_union] = ACTIONS(956),
    [anon_sym_if] = ACTIONS(956),
    [anon_sym_else] = ACTIONS(956),
    [anon_sym_switch] = ACTIONS(956),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_default] = ACTIONS(956),
    [anon_sym_while] = ACTIONS(956),
    [anon_sym_do] = ACTIONS(956),
    [anon_sym_for] = ACTIONS(956),
    [anon_sym_return] = ACTIONS(956),
    [anon_sym_break] = ACTIONS(956),
    [anon_sym_continue] = ACTIONS(956),
    [anon_sym_goto] = ACTIONS(956),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_sizeof] = ACTIONS(956),
    [sym_number_literal] = ACTIONS(958),
    [anon_sym_L_SQUOTE] = ACTIONS(958),
    [anon_sym_u_SQUOTE] = ACTIONS(958),
    [anon_sym_U_SQUOTE] = ACTIONS(958),
    [anon_sym_u8_SQUOTE] = ACTIONS(958),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [anon_sym_L_DQUOTE] = ACTIONS(958),
    [anon_sym_u_DQUOTE] = ACTIONS(958),
    [anon_sym_U_DQUOTE] = ACTIONS(958),
    [anon_sym_u8_DQUOTE] = ACTIONS(958),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [sym_true] = ACTIONS(956),
    [sym_false] = ACTIONS(956),
    [sym_null] = ACTIONS(956),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [ts_builtin_sym_end] = ACTIONS(954),
    [sym_identifier] = ACTIONS(952),
    [aux_sym_preproc_include_token1] = ACTIONS(952),
    [aux_sym_preproc_def_token1] = ACTIONS(952),
    [aux_sym_preproc_if_token1] = ACTIONS(952),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(952),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(952),
    [sym_preproc_directive] = ACTIONS(952),
    [anon_sym_LPAREN2] = ACTIONS(954),
    [anon_sym_BANG] = ACTIONS(954),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_DASH] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(952),
    [anon_sym_STAR] = ACTIONS(954),
    [anon_sym_AMP] = ACTIONS(954),
    [anon_sym_SEMI] = ACTIONS(954),
    [anon_sym_typedef] = ACTIONS(952),
    [anon_sym_extern] = ACTIONS(952),
    [anon_sym___attribute__] = ACTIONS(952),
    [anon_sym___declspec] = ACTIONS(952),
    [anon_sym___cdecl] = ACTIONS(952),
    [anon_sym___clrcall] = ACTIONS(952),
    [anon_sym___stdcall] = ACTIONS(952),
    [anon_sym___fastcall] = ACTIONS(952),
    [anon_sym___thiscall] = ACTIONS(952),
    [anon_sym___vectorcall] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(954),
    [anon_sym_static] = ACTIONS(952),
    [anon_sym_auto] = ACTIONS(952),
    [anon_sym_register] = ACTIONS(952),
    [anon_sym_inline] = ACTIONS(952),
    [anon_sym_const] = ACTIONS(952),
    [anon_sym_volatile] = ACTIONS(952),
    [anon_sym_restrict] = ACTIONS(952),
    [anon_sym__Atomic] = ACTIONS(952),
    [anon_sym_signed] = ACTIONS(952),
    [anon_sym_unsigned] = ACTIONS(952),
    [anon_sym_long] = ACTIONS(952),
    [anon_sym_short] = ACTIONS(952),
    [sym_primitive_type] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(952),
    [anon_sym_struct] = ACTIONS(952),
    [anon_sym_union] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_else] = ACTIONS(952),
    [anon_sym_switch] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_default] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_do] = ACTIONS(952),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_return] = ACTIONS(952),
    [anon_sym_break] = ACTIONS(952),
    [anon_sym_continue] = ACTIONS(952),
    [anon_sym_goto] = ACTIONS(952),
    [anon_sym_DASH_DASH] = ACTIONS(954),
    [anon_sym_PLUS_PLUS] = ACTIONS(954),
    [anon_sym_sizeof] = ACTIONS(952),
    [sym_number_literal] = ACTIONS(954),
    [anon_sym_L_SQUOTE] = ACTIONS(954),
    [anon_sym_u_SQUOTE] = ACTIONS(954),
    [anon_sym_U_SQUOTE] = ACTIONS(954),
    [anon_sym_u8_SQUOTE] = ACTIONS(954),
    [anon_sym_SQUOTE] = ACTIONS(954),
    [anon_sym_L_DQUOTE] = ACTIONS(954),
    [anon_sym_u_DQUOTE] = ACTIONS(954),
    [anon_sym_U_DQUOTE] = ACTIONS(954),
    [anon_sym_u8_DQUOTE] = ACTIONS(954),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [sym_true] = ACTIONS(952),
    [sym_false] = ACTIONS(952),
    [sym_null] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [sym_identifier] = ACTIONS(898),
    [aux_sym_preproc_include_token1] = ACTIONS(898),
    [aux_sym_preproc_def_token1] = ACTIONS(898),
    [aux_sym_preproc_if_token1] = ACTIONS(898),
    [aux_sym_preproc_if_token2] = ACTIONS(898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(898),
    [sym_preproc_directive] = ACTIONS(898),
    [anon_sym_LPAREN2] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(900),
    [anon_sym_TILDE] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_SEMI] = ACTIONS(900),
    [anon_sym_typedef] = ACTIONS(898),
    [anon_sym_extern] = ACTIONS(898),
    [anon_sym___attribute__] = ACTIONS(898),
    [anon_sym___declspec] = ACTIONS(898),
    [anon_sym___cdecl] = ACTIONS(898),
    [anon_sym___clrcall] = ACTIONS(898),
    [anon_sym___stdcall] = ACTIONS(898),
    [anon_sym___fastcall] = ACTIONS(898),
    [anon_sym___thiscall] = ACTIONS(898),
    [anon_sym___vectorcall] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_static] = ACTIONS(898),
    [anon_sym_auto] = ACTIONS(898),
    [anon_sym_register] = ACTIONS(898),
    [anon_sym_inline] = ACTIONS(898),
    [anon_sym_const] = ACTIONS(898),
    [anon_sym_volatile] = ACTIONS(898),
    [anon_sym_restrict] = ACTIONS(898),
    [anon_sym__Atomic] = ACTIONS(898),
    [anon_sym_signed] = ACTIONS(898),
    [anon_sym_unsigned] = ACTIONS(898),
    [anon_sym_long] = ACTIONS(898),
    [anon_sym_short] = ACTIONS(898),
    [sym_primitive_type] = ACTIONS(898),
    [anon_sym_enum] = ACTIONS(898),
    [anon_sym_struct] = ACTIONS(898),
    [anon_sym_union] = ACTIONS(898),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_else] = ACTIONS(898),
    [anon_sym_switch] = ACTIONS(898),
    [anon_sym_case] = ACTIONS(898),
    [anon_sym_default] = ACTIONS(898),
    [anon_sym_while] = ACTIONS(898),
    [anon_sym_do] = ACTIONS(898),
    [anon_sym_for] = ACTIONS(898),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_break] = ACTIONS(898),
    [anon_sym_continue] = ACTIONS(898),
    [anon_sym_goto] = ACTIONS(898),
    [anon_sym_DASH_DASH] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(898),
    [sym_number_literal] = ACTIONS(900),
    [anon_sym_L_SQUOTE] = ACTIONS(900),
    [anon_sym_u_SQUOTE] = ACTIONS(900),
    [anon_sym_U_SQUOTE] = ACTIONS(900),
    [anon_sym_u8_SQUOTE] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(900),
    [anon_sym_L_DQUOTE] = ACTIONS(900),
    [anon_sym_u_DQUOTE] = ACTIONS(900),
    [anon_sym_U_DQUOTE] = ACTIONS(900),
    [anon_sym_u8_DQUOTE] = ACTIONS(900),
    [anon_sym_DQUOTE] = ACTIONS(900),
    [sym_true] = ACTIONS(898),
    [sym_false] = ACTIONS(898),
    [sym_null] = ACTIONS(898),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_identifier] = ACTIONS(1004),
    [aux_sym_preproc_include_token1] = ACTIONS(1004),
    [aux_sym_preproc_def_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1004),
    [sym_preproc_directive] = ACTIONS(1004),
    [anon_sym_LPAREN2] = ACTIONS(1006),
    [anon_sym_BANG] = ACTIONS(1006),
    [anon_sym_TILDE] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1006),
    [anon_sym_AMP] = ACTIONS(1006),
    [anon_sym_SEMI] = ACTIONS(1006),
    [anon_sym_typedef] = ACTIONS(1004),
    [anon_sym_extern] = ACTIONS(1004),
    [anon_sym___attribute__] = ACTIONS(1004),
    [anon_sym___declspec] = ACTIONS(1004),
    [anon_sym___cdecl] = ACTIONS(1004),
    [anon_sym___clrcall] = ACTIONS(1004),
    [anon_sym___stdcall] = ACTIONS(1004),
    [anon_sym___fastcall] = ACTIONS(1004),
    [anon_sym___thiscall] = ACTIONS(1004),
    [anon_sym___vectorcall] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(1006),
    [anon_sym_static] = ACTIONS(1004),
    [anon_sym_auto] = ACTIONS(1004),
    [anon_sym_register] = ACTIONS(1004),
    [anon_sym_inline] = ACTIONS(1004),
    [anon_sym_const] = ACTIONS(1004),
    [anon_sym_volatile] = ACTIONS(1004),
    [anon_sym_restrict] = ACTIONS(1004),
    [anon_sym__Atomic] = ACTIONS(1004),
    [anon_sym_signed] = ACTIONS(1004),
    [anon_sym_unsigned] = ACTIONS(1004),
    [anon_sym_long] = ACTIONS(1004),
    [anon_sym_short] = ACTIONS(1004),
    [sym_primitive_type] = ACTIONS(1004),
    [anon_sym_enum] = ACTIONS(1004),
    [anon_sym_struct] = ACTIONS(1004),
    [anon_sym_union] = ACTIONS(1004),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(1004),
    [anon_sym_do] = ACTIONS(1004),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_return] = ACTIONS(1004),
    [anon_sym_break] = ACTIONS(1004),
    [anon_sym_continue] = ACTIONS(1004),
    [anon_sym_goto] = ACTIONS(1004),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_sizeof] = ACTIONS(1004),
    [sym_number_literal] = ACTIONS(1006),
    [anon_sym_L_SQUOTE] = ACTIONS(1006),
    [anon_sym_u_SQUOTE] = ACTIONS(1006),
    [anon_sym_U_SQUOTE] = ACTIONS(1006),
    [anon_sym_u8_SQUOTE] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1006),
    [anon_sym_L_DQUOTE] = ACTIONS(1006),
    [anon_sym_u_DQUOTE] = ACTIONS(1006),
    [anon_sym_U_DQUOTE] = ACTIONS(1006),
    [anon_sym_u8_DQUOTE] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1006),
    [sym_true] = ACTIONS(1004),
    [sym_false] = ACTIONS(1004),
    [sym_null] = ACTIONS(1004),
    [sym_comment] = ACTIONS(3),
  },
  [213] = {
    [sym_identifier] = ACTIONS(952),
    [aux_sym_preproc_include_token1] = ACTIONS(952),
    [aux_sym_preproc_def_token1] = ACTIONS(952),
    [aux_sym_preproc_if_token1] = ACTIONS(952),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(952),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(952),
    [sym_preproc_directive] = ACTIONS(952),
    [anon_sym_LPAREN2] = ACTIONS(954),
    [anon_sym_BANG] = ACTIONS(954),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_DASH] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(952),
    [anon_sym_STAR] = ACTIONS(954),
    [anon_sym_AMP] = ACTIONS(954),
    [anon_sym_SEMI] = ACTIONS(954),
    [anon_sym_typedef] = ACTIONS(952),
    [anon_sym_extern] = ACTIONS(952),
    [anon_sym___attribute__] = ACTIONS(952),
    [anon_sym___declspec] = ACTIONS(952),
    [anon_sym___cdecl] = ACTIONS(952),
    [anon_sym___clrcall] = ACTIONS(952),
    [anon_sym___stdcall] = ACTIONS(952),
    [anon_sym___fastcall] = ACTIONS(952),
    [anon_sym___thiscall] = ACTIONS(952),
    [anon_sym___vectorcall] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE] = ACTIONS(954),
    [anon_sym_static] = ACTIONS(952),
    [anon_sym_auto] = ACTIONS(952),
    [anon_sym_register] = ACTIONS(952),
    [anon_sym_inline] = ACTIONS(952),
    [anon_sym_const] = ACTIONS(952),
    [anon_sym_volatile] = ACTIONS(952),
    [anon_sym_restrict] = ACTIONS(952),
    [anon_sym__Atomic] = ACTIONS(952),
    [anon_sym_signed] = ACTIONS(952),
    [anon_sym_unsigned] = ACTIONS(952),
    [anon_sym_long] = ACTIONS(952),
    [anon_sym_short] = ACTIONS(952),
    [sym_primitive_type] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(952),
    [anon_sym_struct] = ACTIONS(952),
    [anon_sym_union] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_else] = ACTIONS(952),
    [anon_sym_switch] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_default] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [anon_sym_do] = ACTIONS(952),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_return] = ACTIONS(952),
    [anon_sym_break] = ACTIONS(952),
    [anon_sym_continue] = ACTIONS(952),
    [anon_sym_goto] = ACTIONS(952),
    [anon_sym_DASH_DASH] = ACTIONS(954),
    [anon_sym_PLUS_PLUS] = ACTIONS(954),
    [anon_sym_sizeof] = ACTIONS(952),
    [sym_number_literal] = ACTIONS(954),
    [anon_sym_L_SQUOTE] = ACTIONS(954),
    [anon_sym_u_SQUOTE] = ACTIONS(954),
    [anon_sym_U_SQUOTE] = ACTIONS(954),
    [anon_sym_u8_SQUOTE] = ACTIONS(954),
    [anon_sym_SQUOTE] = ACTIONS(954),
    [anon_sym_L_DQUOTE] = ACTIONS(954),
    [anon_sym_u_DQUOTE] = ACTIONS(954),
    [anon_sym_U_DQUOTE] = ACTIONS(954),
    [anon_sym_u8_DQUOTE] = ACTIONS(954),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [sym_true] = ACTIONS(952),
    [sym_false] = ACTIONS(952),
    [sym_null] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [ts_builtin_sym_end] = ACTIONS(934),
    [sym_identifier] = ACTIONS(932),
    [aux_sym_preproc_include_token1] = ACTIONS(932),
    [aux_sym_preproc_def_token1] = ACTIONS(932),
    [aux_sym_preproc_if_token1] = ACTIONS(932),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(932),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(932),
    [sym_preproc_directive] = ACTIONS(932),
    [anon_sym_LPAREN2] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(934),
    [anon_sym_TILDE] = ACTIONS(934),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_STAR] = ACTIONS(934),
    [anon_sym_AMP] = ACTIONS(934),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_typedef] = ACTIONS(932),
    [anon_sym_extern] = ACTIONS(932),
    [anon_sym___attribute__] = ACTIONS(932),
    [anon_sym___declspec] = ACTIONS(932),
    [anon_sym___cdecl] = ACTIONS(932),
    [anon_sym___clrcall] = ACTIONS(932),
    [anon_sym___stdcall] = ACTIONS(932),
    [anon_sym___fastcall] = ACTIONS(932),
    [anon_sym___thiscall] = ACTIONS(932),
    [anon_sym___vectorcall] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(934),
    [anon_sym_static] = ACTIONS(932),
    [anon_sym_auto] = ACTIONS(932),
    [anon_sym_register] = ACTIONS(932),
    [anon_sym_inline] = ACTIONS(932),
    [anon_sym_const] = ACTIONS(932),
    [anon_sym_volatile] = ACTIONS(932),
    [anon_sym_restrict] = ACTIONS(932),
    [anon_sym__Atomic] = ACTIONS(932),
    [anon_sym_signed] = ACTIONS(932),
    [anon_sym_unsigned] = ACTIONS(932),
    [anon_sym_long] = ACTIONS(932),
    [anon_sym_short] = ACTIONS(932),
    [sym_primitive_type] = ACTIONS(932),
    [anon_sym_enum] = ACTIONS(932),
    [anon_sym_struct] = ACTIONS(932),
    [anon_sym_union] = ACTIONS(932),
    [anon_sym_if] = ACTIONS(932),
    [anon_sym_else] = ACTIONS(932),
    [anon_sym_switch] = ACTIONS(932),
    [anon_sym_case] = ACTIONS(932),
    [anon_sym_default] = ACTIONS(932),
    [anon_sym_while] = ACTIONS(932),
    [anon_sym_do] = ACTIONS(932),
    [anon_sym_for] = ACTIONS(932),
    [anon_sym_return] = ACTIONS(932),
    [anon_sym_break] = ACTIONS(932),
    [anon_sym_continue] = ACTIONS(932),
    [anon_sym_goto] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_sizeof] = ACTIONS(932),
    [sym_number_literal] = ACTIONS(934),
    [anon_sym_L_SQUOTE] = ACTIONS(934),
    [anon_sym_u_SQUOTE] = ACTIONS(934),
    [anon_sym_U_SQUOTE] = ACTIONS(934),
    [anon_sym_u8_SQUOTE] = ACTIONS(934),
    [anon_sym_SQUOTE] = ACTIONS(934),
    [anon_sym_L_DQUOTE] = ACTIONS(934),
    [anon_sym_u_DQUOTE] = ACTIONS(934),
    [anon_sym_U_DQUOTE] = ACTIONS(934),
    [anon_sym_u8_DQUOTE] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(934),
    [sym_true] = ACTIONS(932),
    [sym_false] = ACTIONS(932),
    [sym_null] = ACTIONS(932),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [sym_identifier] = ACTIONS(980),
    [aux_sym_preproc_include_token1] = ACTIONS(980),
    [aux_sym_preproc_def_token1] = ACTIONS(980),
    [aux_sym_preproc_if_token1] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(980),
    [sym_preproc_directive] = ACTIONS(980),
    [anon_sym_LPAREN2] = ACTIONS(982),
    [anon_sym_BANG] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(980),
    [anon_sym_STAR] = ACTIONS(982),
    [anon_sym_AMP] = ACTIONS(982),
    [anon_sym_SEMI] = ACTIONS(982),
    [anon_sym_typedef] = ACTIONS(980),
    [anon_sym_extern] = ACTIONS(980),
    [anon_sym___attribute__] = ACTIONS(980),
    [anon_sym___declspec] = ACTIONS(980),
    [anon_sym___cdecl] = ACTIONS(980),
    [anon_sym___clrcall] = ACTIONS(980),
    [anon_sym___stdcall] = ACTIONS(980),
    [anon_sym___fastcall] = ACTIONS(980),
    [anon_sym___thiscall] = ACTIONS(980),
    [anon_sym___vectorcall] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(982),
    [anon_sym_RBRACE] = ACTIONS(982),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_auto] = ACTIONS(980),
    [anon_sym_register] = ACTIONS(980),
    [anon_sym_inline] = ACTIONS(980),
    [anon_sym_const] = ACTIONS(980),
    [anon_sym_volatile] = ACTIONS(980),
    [anon_sym_restrict] = ACTIONS(980),
    [anon_sym__Atomic] = ACTIONS(980),
    [anon_sym_signed] = ACTIONS(980),
    [anon_sym_unsigned] = ACTIONS(980),
    [anon_sym_long] = ACTIONS(980),
    [anon_sym_short] = ACTIONS(980),
    [sym_primitive_type] = ACTIONS(980),
    [anon_sym_enum] = ACTIONS(980),
    [anon_sym_struct] = ACTIONS(980),
    [anon_sym_union] = ACTIONS(980),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_else] = ACTIONS(980),
    [anon_sym_switch] = ACTIONS(980),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_default] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [anon_sym_do] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_goto] = ACTIONS(980),
    [anon_sym_DASH_DASH] = ACTIONS(982),
    [anon_sym_PLUS_PLUS] = ACTIONS(982),
    [anon_sym_sizeof] = ACTIONS(980),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_L_SQUOTE] = ACTIONS(982),
    [anon_sym_u_SQUOTE] = ACTIONS(982),
    [anon_sym_U_SQUOTE] = ACTIONS(982),
    [anon_sym_u8_SQUOTE] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(982),
    [anon_sym_L_DQUOTE] = ACTIONS(982),
    [anon_sym_u_DQUOTE] = ACTIONS(982),
    [anon_sym_U_DQUOTE] = ACTIONS(982),
    [anon_sym_u8_DQUOTE] = ACTIONS(982),
    [anon_sym_DQUOTE] = ACTIONS(982),
    [sym_true] = ACTIONS(980),
    [sym_false] = ACTIONS(980),
    [sym_null] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [ts_builtin_sym_end] = ACTIONS(924),
    [sym_identifier] = ACTIONS(922),
    [aux_sym_preproc_include_token1] = ACTIONS(922),
    [aux_sym_preproc_def_token1] = ACTIONS(922),
    [aux_sym_preproc_if_token1] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(922),
    [sym_preproc_directive] = ACTIONS(922),
    [anon_sym_LPAREN2] = ACTIONS(924),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(924),
    [anon_sym_typedef] = ACTIONS(922),
    [anon_sym_extern] = ACTIONS(922),
    [anon_sym___attribute__] = ACTIONS(922),
    [anon_sym___declspec] = ACTIONS(922),
    [anon_sym___cdecl] = ACTIONS(922),
    [anon_sym___clrcall] = ACTIONS(922),
    [anon_sym___stdcall] = ACTIONS(922),
    [anon_sym___fastcall] = ACTIONS(922),
    [anon_sym___thiscall] = ACTIONS(922),
    [anon_sym___vectorcall] = ACTIONS(922),
    [anon_sym_LBRACE] = ACTIONS(924),
    [anon_sym_static] = ACTIONS(922),
    [anon_sym_auto] = ACTIONS(922),
    [anon_sym_register] = ACTIONS(922),
    [anon_sym_inline] = ACTIONS(922),
    [anon_sym_const] = ACTIONS(922),
    [anon_sym_volatile] = ACTIONS(922),
    [anon_sym_restrict] = ACTIONS(922),
    [anon_sym__Atomic] = ACTIONS(922),
    [anon_sym_signed] = ACTIONS(922),
    [anon_sym_unsigned] = ACTIONS(922),
    [anon_sym_long] = ACTIONS(922),
    [anon_sym_short] = ACTIONS(922),
    [sym_primitive_type] = ACTIONS(922),
    [anon_sym_enum] = ACTIONS(922),
    [anon_sym_struct] = ACTIONS(922),
    [anon_sym_union] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(922),
    [anon_sym_else] = ACTIONS(922),
    [anon_sym_switch] = ACTIONS(922),
    [anon_sym_case] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(922),
    [anon_sym_while] = ACTIONS(922),
    [anon_sym_do] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(922),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(922),
    [anon_sym_goto] = ACTIONS(922),
    [anon_sym_DASH_DASH] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(924),
    [anon_sym_sizeof] = ACTIONS(922),
    [sym_number_literal] = ACTIONS(924),
    [anon_sym_L_SQUOTE] = ACTIONS(924),
    [anon_sym_u_SQUOTE] = ACTIONS(924),
    [anon_sym_U_SQUOTE] = ACTIONS(924),
    [anon_sym_u8_SQUOTE] = ACTIONS(924),
    [anon_sym_SQUOTE] = ACTIONS(924),
    [anon_sym_L_DQUOTE] = ACTIONS(924),
    [anon_sym_u_DQUOTE] = ACTIONS(924),
    [anon_sym_U_DQUOTE] = ACTIONS(924),
    [anon_sym_u8_DQUOTE] = ACTIONS(924),
    [anon_sym_DQUOTE] = ACTIONS(924),
    [sym_true] = ACTIONS(922),
    [sym_false] = ACTIONS(922),
    [sym_null] = ACTIONS(922),
    [sym_comment] = ACTIONS(3),
  },
  [217] = {
    [ts_builtin_sym_end] = ACTIONS(986),
    [sym_identifier] = ACTIONS(984),
    [aux_sym_preproc_include_token1] = ACTIONS(984),
    [aux_sym_preproc_def_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(984),
    [sym_preproc_directive] = ACTIONS(984),
    [anon_sym_LPAREN2] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_AMP] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_typedef] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym___attribute__] = ACTIONS(984),
    [anon_sym___declspec] = ACTIONS(984),
    [anon_sym___cdecl] = ACTIONS(984),
    [anon_sym___clrcall] = ACTIONS(984),
    [anon_sym___stdcall] = ACTIONS(984),
    [anon_sym___fastcall] = ACTIONS(984),
    [anon_sym___thiscall] = ACTIONS(984),
    [anon_sym___vectorcall] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_auto] = ACTIONS(984),
    [anon_sym_register] = ACTIONS(984),
    [anon_sym_inline] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_volatile] = ACTIONS(984),
    [anon_sym_restrict] = ACTIONS(984),
    [anon_sym__Atomic] = ACTIONS(984),
    [anon_sym_signed] = ACTIONS(984),
    [anon_sym_unsigned] = ACTIONS(984),
    [anon_sym_long] = ACTIONS(984),
    [anon_sym_short] = ACTIONS(984),
    [sym_primitive_type] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_struct] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(984),
    [anon_sym_switch] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_do] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_goto] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_sizeof] = ACTIONS(984),
    [sym_number_literal] = ACTIONS(986),
    [anon_sym_L_SQUOTE] = ACTIONS(986),
    [anon_sym_u_SQUOTE] = ACTIONS(986),
    [anon_sym_U_SQUOTE] = ACTIONS(986),
    [anon_sym_u8_SQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [anon_sym_L_DQUOTE] = ACTIONS(986),
    [anon_sym_u_DQUOTE] = ACTIONS(986),
    [anon_sym_U_DQUOTE] = ACTIONS(986),
    [anon_sym_u8_DQUOTE] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
  },
  [218] = {
    [ts_builtin_sym_end] = ACTIONS(962),
    [sym_identifier] = ACTIONS(960),
    [aux_sym_preproc_include_token1] = ACTIONS(960),
    [aux_sym_preproc_def_token1] = ACTIONS(960),
    [aux_sym_preproc_if_token1] = ACTIONS(960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(960),
    [sym_preproc_directive] = ACTIONS(960),
    [anon_sym_LPAREN2] = ACTIONS(962),
    [anon_sym_BANG] = ACTIONS(962),
    [anon_sym_TILDE] = ACTIONS(962),
    [anon_sym_DASH] = ACTIONS(960),
    [anon_sym_PLUS] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_typedef] = ACTIONS(960),
    [anon_sym_extern] = ACTIONS(960),
    [anon_sym___attribute__] = ACTIONS(960),
    [anon_sym___declspec] = ACTIONS(960),
    [anon_sym___cdecl] = ACTIONS(960),
    [anon_sym___clrcall] = ACTIONS(960),
    [anon_sym___stdcall] = ACTIONS(960),
    [anon_sym___fastcall] = ACTIONS(960),
    [anon_sym___thiscall] = ACTIONS(960),
    [anon_sym___vectorcall] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_auto] = ACTIONS(960),
    [anon_sym_register] = ACTIONS(960),
    [anon_sym_inline] = ACTIONS(960),
    [anon_sym_const] = ACTIONS(960),
    [anon_sym_volatile] = ACTIONS(960),
    [anon_sym_restrict] = ACTIONS(960),
    [anon_sym__Atomic] = ACTIONS(960),
    [anon_sym_signed] = ACTIONS(960),
    [anon_sym_unsigned] = ACTIONS(960),
    [anon_sym_long] = ACTIONS(960),
    [anon_sym_short] = ACTIONS(960),
    [sym_primitive_type] = ACTIONS(960),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_struct] = ACTIONS(960),
    [anon_sym_union] = ACTIONS(960),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_else] = ACTIONS(960),
    [anon_sym_switch] = ACTIONS(960),
    [anon_sym_case] = ACTIONS(960),
    [anon_sym_default] = ACTIONS(960),
    [anon_sym_while] = ACTIONS(960),
    [anon_sym_do] = ACTIONS(960),
    [anon_sym_for] = ACTIONS(960),
    [anon_sym_return] = ACTIONS(960),
    [anon_sym_break] = ACTIONS(960),
    [anon_sym_continue] = ACTIONS(960),
    [anon_sym_goto] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(962),
    [anon_sym_PLUS_PLUS] = ACTIONS(962),
    [anon_sym_sizeof] = ACTIONS(960),
    [sym_number_literal] = ACTIONS(962),
    [anon_sym_L_SQUOTE] = ACTIONS(962),
    [anon_sym_u_SQUOTE] = ACTIONS(962),
    [anon_sym_U_SQUOTE] = ACTIONS(962),
    [anon_sym_u8_SQUOTE] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(962),
    [anon_sym_L_DQUOTE] = ACTIONS(962),
    [anon_sym_u_DQUOTE] = ACTIONS(962),
    [anon_sym_U_DQUOTE] = ACTIONS(962),
    [anon_sym_u8_DQUOTE] = ACTIONS(962),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [sym_true] = ACTIONS(960),
    [sym_false] = ACTIONS(960),
    [sym_null] = ACTIONS(960),
    [sym_comment] = ACTIONS(3),
  },
  [219] = {
    [ts_builtin_sym_end] = ACTIONS(978),
    [sym_identifier] = ACTIONS(976),
    [aux_sym_preproc_include_token1] = ACTIONS(976),
    [aux_sym_preproc_def_token1] = ACTIONS(976),
    [aux_sym_preproc_if_token1] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(976),
    [sym_preproc_directive] = ACTIONS(976),
    [anon_sym_LPAREN2] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(978),
    [anon_sym_TILDE] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_STAR] = ACTIONS(978),
    [anon_sym_AMP] = ACTIONS(978),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym_typedef] = ACTIONS(976),
    [anon_sym_extern] = ACTIONS(976),
    [anon_sym___attribute__] = ACTIONS(976),
    [anon_sym___declspec] = ACTIONS(976),
    [anon_sym___cdecl] = ACTIONS(976),
    [anon_sym___clrcall] = ACTIONS(976),
    [anon_sym___stdcall] = ACTIONS(976),
    [anon_sym___fastcall] = ACTIONS(976),
    [anon_sym___thiscall] = ACTIONS(976),
    [anon_sym___vectorcall] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_static] = ACTIONS(976),
    [anon_sym_auto] = ACTIONS(976),
    [anon_sym_register] = ACTIONS(976),
    [anon_sym_inline] = ACTIONS(976),
    [anon_sym_const] = ACTIONS(976),
    [anon_sym_volatile] = ACTIONS(976),
    [anon_sym_restrict] = ACTIONS(976),
    [anon_sym__Atomic] = ACTIONS(976),
    [anon_sym_signed] = ACTIONS(976),
    [anon_sym_unsigned] = ACTIONS(976),
    [anon_sym_long] = ACTIONS(976),
    [anon_sym_short] = ACTIONS(976),
    [sym_primitive_type] = ACTIONS(976),
    [anon_sym_enum] = ACTIONS(976),
    [anon_sym_struct] = ACTIONS(976),
    [anon_sym_union] = ACTIONS(976),
    [anon_sym_if] = ACTIONS(976),
    [anon_sym_else] = ACTIONS(976),
    [anon_sym_switch] = ACTIONS(976),
    [anon_sym_case] = ACTIONS(976),
    [anon_sym_default] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(976),
    [anon_sym_do] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_return] = ACTIONS(976),
    [anon_sym_break] = ACTIONS(976),
    [anon_sym_continue] = ACTIONS(976),
    [anon_sym_goto] = ACTIONS(976),
    [anon_sym_DASH_DASH] = ACTIONS(978),
    [anon_sym_PLUS_PLUS] = ACTIONS(978),
    [anon_sym_sizeof] = ACTIONS(976),
    [sym_number_literal] = ACTIONS(978),
    [anon_sym_L_SQUOTE] = ACTIONS(978),
    [anon_sym_u_SQUOTE] = ACTIONS(978),
    [anon_sym_U_SQUOTE] = ACTIONS(978),
    [anon_sym_u8_SQUOTE] = ACTIONS(978),
    [anon_sym_SQUOTE] = ACTIONS(978),
    [anon_sym_L_DQUOTE] = ACTIONS(978),
    [anon_sym_u_DQUOTE] = ACTIONS(978),
    [anon_sym_U_DQUOTE] = ACTIONS(978),
    [anon_sym_u8_DQUOTE] = ACTIONS(978),
    [anon_sym_DQUOTE] = ACTIONS(978),
    [sym_true] = ACTIONS(976),
    [sym_false] = ACTIONS(976),
    [sym_null] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
  },
  [220] = {
    [ts_builtin_sym_end] = ACTIONS(928),
    [sym_identifier] = ACTIONS(926),
    [aux_sym_preproc_include_token1] = ACTIONS(926),
    [aux_sym_preproc_def_token1] = ACTIONS(926),
    [aux_sym_preproc_if_token1] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(926),
    [sym_preproc_directive] = ACTIONS(926),
    [anon_sym_LPAREN2] = ACTIONS(928),
    [anon_sym_BANG] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(928),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_STAR] = ACTIONS(928),
    [anon_sym_AMP] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(928),
    [anon_sym_typedef] = ACTIONS(926),
    [anon_sym_extern] = ACTIONS(926),
    [anon_sym___attribute__] = ACTIONS(926),
    [anon_sym___declspec] = ACTIONS(926),
    [anon_sym___cdecl] = ACTIONS(926),
    [anon_sym___clrcall] = ACTIONS(926),
    [anon_sym___stdcall] = ACTIONS(926),
    [anon_sym___fastcall] = ACTIONS(926),
    [anon_sym___thiscall] = ACTIONS(926),
    [anon_sym___vectorcall] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(926),
    [anon_sym_auto] = ACTIONS(926),
    [anon_sym_register] = ACTIONS(926),
    [anon_sym_inline] = ACTIONS(926),
    [anon_sym_const] = ACTIONS(926),
    [anon_sym_volatile] = ACTIONS(926),
    [anon_sym_restrict] = ACTIONS(926),
    [anon_sym__Atomic] = ACTIONS(926),
    [anon_sym_signed] = ACTIONS(926),
    [anon_sym_unsigned] = ACTIONS(926),
    [anon_sym_long] = ACTIONS(926),
    [anon_sym_short] = ACTIONS(926),
    [sym_primitive_type] = ACTIONS(926),
    [anon_sym_enum] = ACTIONS(926),
    [anon_sym_struct] = ACTIONS(926),
    [anon_sym_union] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(926),
    [anon_sym_else] = ACTIONS(1112),
    [anon_sym_switch] = ACTIONS(926),
    [anon_sym_case] = ACTIONS(926),
    [anon_sym_default] = ACTIONS(926),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_do] = ACTIONS(926),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(926),
    [anon_sym_break] = ACTIONS(926),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_goto] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(928),
    [anon_sym_PLUS_PLUS] = ACTIONS(928),
    [anon_sym_sizeof] = ACTIONS(926),
    [sym_number_literal] = ACTIONS(928),
    [anon_sym_L_SQUOTE] = ACTIONS(928),
    [anon_sym_u_SQUOTE] = ACTIONS(928),
    [anon_sym_U_SQUOTE] = ACTIONS(928),
    [anon_sym_u8_SQUOTE] = ACTIONS(928),
    [anon_sym_SQUOTE] = ACTIONS(928),
    [anon_sym_L_DQUOTE] = ACTIONS(928),
    [anon_sym_u_DQUOTE] = ACTIONS(928),
    [anon_sym_U_DQUOTE] = ACTIONS(928),
    [anon_sym_u8_DQUOTE] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(928),
    [sym_true] = ACTIONS(926),
    [sym_false] = ACTIONS(926),
    [sym_null] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
  },
  [221] = {
    [ts_builtin_sym_end] = ACTIONS(942),
    [sym_identifier] = ACTIONS(940),
    [aux_sym_preproc_include_token1] = ACTIONS(940),
    [aux_sym_preproc_def_token1] = ACTIONS(940),
    [aux_sym_preproc_if_token1] = ACTIONS(940),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(940),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(940),
    [sym_preproc_directive] = ACTIONS(940),
    [anon_sym_LPAREN2] = ACTIONS(942),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_STAR] = ACTIONS(942),
    [anon_sym_AMP] = ACTIONS(942),
    [anon_sym_SEMI] = ACTIONS(942),
    [anon_sym_typedef] = ACTIONS(940),
    [anon_sym_extern] = ACTIONS(940),
    [anon_sym___attribute__] = ACTIONS(940),
    [anon_sym___declspec] = ACTIONS(940),
    [anon_sym___cdecl] = ACTIONS(940),
    [anon_sym___clrcall] = ACTIONS(940),
    [anon_sym___stdcall] = ACTIONS(940),
    [anon_sym___fastcall] = ACTIONS(940),
    [anon_sym___thiscall] = ACTIONS(940),
    [anon_sym___vectorcall] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(942),
    [anon_sym_static] = ACTIONS(940),
    [anon_sym_auto] = ACTIONS(940),
    [anon_sym_register] = ACTIONS(940),
    [anon_sym_inline] = ACTIONS(940),
    [anon_sym_const] = ACTIONS(940),
    [anon_sym_volatile] = ACTIONS(940),
    [anon_sym_restrict] = ACTIONS(940),
    [anon_sym__Atomic] = ACTIONS(940),
    [anon_sym_signed] = ACTIONS(940),
    [anon_sym_unsigned] = ACTIONS(940),
    [anon_sym_long] = ACTIONS(940),
    [anon_sym_short] = ACTIONS(940),
    [sym_primitive_type] = ACTIONS(940),
    [anon_sym_enum] = ACTIONS(940),
    [anon_sym_struct] = ACTIONS(940),
    [anon_sym_union] = ACTIONS(940),
    [anon_sym_if] = ACTIONS(940),
    [anon_sym_else] = ACTIONS(940),
    [anon_sym_switch] = ACTIONS(940),
    [anon_sym_case] = ACTIONS(940),
    [anon_sym_default] = ACTIONS(940),
    [anon_sym_while] = ACTIONS(940),
    [anon_sym_do] = ACTIONS(940),
    [anon_sym_for] = ACTIONS(940),
    [anon_sym_return] = ACTIONS(940),
    [anon_sym_break] = ACTIONS(940),
    [anon_sym_continue] = ACTIONS(940),
    [anon_sym_goto] = ACTIONS(940),
    [anon_sym_DASH_DASH] = ACTIONS(942),
    [anon_sym_PLUS_PLUS] = ACTIONS(942),
    [anon_sym_sizeof] = ACTIONS(940),
    [sym_number_literal] = ACTIONS(942),
    [anon_sym_L_SQUOTE] = ACTIONS(942),
    [anon_sym_u_SQUOTE] = ACTIONS(942),
    [anon_sym_U_SQUOTE] = ACTIONS(942),
    [anon_sym_u8_SQUOTE] = ACTIONS(942),
    [anon_sym_SQUOTE] = ACTIONS(942),
    [anon_sym_L_DQUOTE] = ACTIONS(942),
    [anon_sym_u_DQUOTE] = ACTIONS(942),
    [anon_sym_U_DQUOTE] = ACTIONS(942),
    [anon_sym_u8_DQUOTE] = ACTIONS(942),
    [anon_sym_DQUOTE] = ACTIONS(942),
    [sym_true] = ACTIONS(940),
    [sym_false] = ACTIONS(940),
    [sym_null] = ACTIONS(940),
    [sym_comment] = ACTIONS(3),
  },
  [222] = {
    [sym_identifier] = ACTIONS(1012),
    [aux_sym_preproc_include_token1] = ACTIONS(1012),
    [aux_sym_preproc_def_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1012),
    [sym_preproc_directive] = ACTIONS(1012),
    [anon_sym_LPAREN2] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_typedef] = ACTIONS(1012),
    [anon_sym_extern] = ACTIONS(1012),
    [anon_sym___attribute__] = ACTIONS(1012),
    [anon_sym___declspec] = ACTIONS(1012),
    [anon_sym___cdecl] = ACTIONS(1012),
    [anon_sym___clrcall] = ACTIONS(1012),
    [anon_sym___stdcall] = ACTIONS(1012),
    [anon_sym___fastcall] = ACTIONS(1012),
    [anon_sym___thiscall] = ACTIONS(1012),
    [anon_sym___vectorcall] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_RBRACE] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_auto] = ACTIONS(1012),
    [anon_sym_register] = ACTIONS(1012),
    [anon_sym_inline] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_volatile] = ACTIONS(1012),
    [anon_sym_restrict] = ACTIONS(1012),
    [anon_sym__Atomic] = ACTIONS(1012),
    [anon_sym_signed] = ACTIONS(1012),
    [anon_sym_unsigned] = ACTIONS(1012),
    [anon_sym_long] = ACTIONS(1012),
    [anon_sym_short] = ACTIONS(1012),
    [sym_primitive_type] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_goto] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_sizeof] = ACTIONS(1012),
    [sym_number_literal] = ACTIONS(1014),
    [anon_sym_L_SQUOTE] = ACTIONS(1014),
    [anon_sym_u_SQUOTE] = ACTIONS(1014),
    [anon_sym_U_SQUOTE] = ACTIONS(1014),
    [anon_sym_u8_SQUOTE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_L_DQUOTE] = ACTIONS(1014),
    [anon_sym_u_DQUOTE] = ACTIONS(1014),
    [anon_sym_U_DQUOTE] = ACTIONS(1014),
    [anon_sym_u8_DQUOTE] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [223] = {
    [sym_identifier] = ACTIONS(1008),
    [aux_sym_preproc_include_token1] = ACTIONS(1008),
    [aux_sym_preproc_def_token1] = ACTIONS(1008),
    [aux_sym_preproc_if_token1] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1008),
    [sym_preproc_directive] = ACTIONS(1008),
    [anon_sym_LPAREN2] = ACTIONS(1010),
    [anon_sym_BANG] = ACTIONS(1010),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1010),
    [anon_sym_typedef] = ACTIONS(1008),
    [anon_sym_extern] = ACTIONS(1008),
    [anon_sym___attribute__] = ACTIONS(1008),
    [anon_sym___declspec] = ACTIONS(1008),
    [anon_sym___cdecl] = ACTIONS(1008),
    [anon_sym___clrcall] = ACTIONS(1008),
    [anon_sym___stdcall] = ACTIONS(1008),
    [anon_sym___fastcall] = ACTIONS(1008),
    [anon_sym___thiscall] = ACTIONS(1008),
    [anon_sym___vectorcall] = ACTIONS(1008),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_RBRACE] = ACTIONS(1010),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_auto] = ACTIONS(1008),
    [anon_sym_register] = ACTIONS(1008),
    [anon_sym_inline] = ACTIONS(1008),
    [anon_sym_const] = ACTIONS(1008),
    [anon_sym_volatile] = ACTIONS(1008),
    [anon_sym_restrict] = ACTIONS(1008),
    [anon_sym__Atomic] = ACTIONS(1008),
    [anon_sym_signed] = ACTIONS(1008),
    [anon_sym_unsigned] = ACTIONS(1008),
    [anon_sym_long] = ACTIONS(1008),
    [anon_sym_short] = ACTIONS(1008),
    [sym_primitive_type] = ACTIONS(1008),
    [anon_sym_enum] = ACTIONS(1008),
    [anon_sym_struct] = ACTIONS(1008),
    [anon_sym_union] = ACTIONS(1008),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_else] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1008),
    [anon_sym_case] = ACTIONS(1008),
    [anon_sym_default] = ACTIONS(1008),
    [anon_sym_while] = ACTIONS(1008),
    [anon_sym_do] = ACTIONS(1008),
    [anon_sym_for] = ACTIONS(1008),
    [anon_sym_return] = ACTIONS(1008),
    [anon_sym_break] = ACTIONS(1008),
    [anon_sym_continue] = ACTIONS(1008),
    [anon_sym_goto] = ACTIONS(1008),
    [anon_sym_DASH_DASH] = ACTIONS(1010),
    [anon_sym_PLUS_PLUS] = ACTIONS(1010),
    [anon_sym_sizeof] = ACTIONS(1008),
    [sym_number_literal] = ACTIONS(1010),
    [anon_sym_L_SQUOTE] = ACTIONS(1010),
    [anon_sym_u_SQUOTE] = ACTIONS(1010),
    [anon_sym_U_SQUOTE] = ACTIONS(1010),
    [anon_sym_u8_SQUOTE] = ACTIONS(1010),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [anon_sym_L_DQUOTE] = ACTIONS(1010),
    [anon_sym_u_DQUOTE] = ACTIONS(1010),
    [anon_sym_U_DQUOTE] = ACTIONS(1010),
    [anon_sym_u8_DQUOTE] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [sym_true] = ACTIONS(1008),
    [sym_false] = ACTIONS(1008),
    [sym_null] = ACTIONS(1008),
    [sym_comment] = ACTIONS(3),
  },
  [224] = {
    [sym_identifier] = ACTIONS(902),
    [aux_sym_preproc_include_token1] = ACTIONS(902),
    [aux_sym_preproc_def_token1] = ACTIONS(902),
    [aux_sym_preproc_if_token1] = ACTIONS(902),
    [aux_sym_preproc_if_token2] = ACTIONS(902),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(902),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(902),
    [sym_preproc_directive] = ACTIONS(902),
    [anon_sym_LPAREN2] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(904),
    [anon_sym_TILDE] = ACTIONS(904),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(904),
    [anon_sym_SEMI] = ACTIONS(904),
    [anon_sym_typedef] = ACTIONS(902),
    [anon_sym_extern] = ACTIONS(902),
    [anon_sym___attribute__] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(902),
    [anon_sym___cdecl] = ACTIONS(902),
    [anon_sym___clrcall] = ACTIONS(902),
    [anon_sym___stdcall] = ACTIONS(902),
    [anon_sym___fastcall] = ACTIONS(902),
    [anon_sym___thiscall] = ACTIONS(902),
    [anon_sym___vectorcall] = ACTIONS(902),
    [anon_sym_LBRACE] = ACTIONS(904),
    [anon_sym_static] = ACTIONS(902),
    [anon_sym_auto] = ACTIONS(902),
    [anon_sym_register] = ACTIONS(902),
    [anon_sym_inline] = ACTIONS(902),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_volatile] = ACTIONS(902),
    [anon_sym_restrict] = ACTIONS(902),
    [anon_sym__Atomic] = ACTIONS(902),
    [anon_sym_signed] = ACTIONS(902),
    [anon_sym_unsigned] = ACTIONS(902),
    [anon_sym_long] = ACTIONS(902),
    [anon_sym_short] = ACTIONS(902),
    [sym_primitive_type] = ACTIONS(902),
    [anon_sym_enum] = ACTIONS(902),
    [anon_sym_struct] = ACTIONS(902),
    [anon_sym_union] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(902),
    [anon_sym_else] = ACTIONS(902),
    [anon_sym_switch] = ACTIONS(902),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_default] = ACTIONS(902),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_do] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(902),
    [anon_sym_return] = ACTIONS(902),
    [anon_sym_break] = ACTIONS(902),
    [anon_sym_continue] = ACTIONS(902),
    [anon_sym_goto] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(904),
    [anon_sym_PLUS_PLUS] = ACTIONS(904),
    [anon_sym_sizeof] = ACTIONS(902),
    [sym_number_literal] = ACTIONS(904),
    [anon_sym_L_SQUOTE] = ACTIONS(904),
    [anon_sym_u_SQUOTE] = ACTIONS(904),
    [anon_sym_U_SQUOTE] = ACTIONS(904),
    [anon_sym_u8_SQUOTE] = ACTIONS(904),
    [anon_sym_SQUOTE] = ACTIONS(904),
    [anon_sym_L_DQUOTE] = ACTIONS(904),
    [anon_sym_u_DQUOTE] = ACTIONS(904),
    [anon_sym_U_DQUOTE] = ACTIONS(904),
    [anon_sym_u8_DQUOTE] = ACTIONS(904),
    [anon_sym_DQUOTE] = ACTIONS(904),
    [sym_true] = ACTIONS(902),
    [sym_false] = ACTIONS(902),
    [sym_null] = ACTIONS(902),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [ts_builtin_sym_end] = ACTIONS(966),
    [sym_identifier] = ACTIONS(964),
    [aux_sym_preproc_include_token1] = ACTIONS(964),
    [aux_sym_preproc_def_token1] = ACTIONS(964),
    [aux_sym_preproc_if_token1] = ACTIONS(964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(964),
    [sym_preproc_directive] = ACTIONS(964),
    [anon_sym_LPAREN2] = ACTIONS(966),
    [anon_sym_BANG] = ACTIONS(966),
    [anon_sym_TILDE] = ACTIONS(966),
    [anon_sym_DASH] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(964),
    [anon_sym_STAR] = ACTIONS(966),
    [anon_sym_AMP] = ACTIONS(966),
    [anon_sym_SEMI] = ACTIONS(966),
    [anon_sym_typedef] = ACTIONS(964),
    [anon_sym_extern] = ACTIONS(964),
    [anon_sym___attribute__] = ACTIONS(964),
    [anon_sym___declspec] = ACTIONS(964),
    [anon_sym___cdecl] = ACTIONS(964),
    [anon_sym___clrcall] = ACTIONS(964),
    [anon_sym___stdcall] = ACTIONS(964),
    [anon_sym___fastcall] = ACTIONS(964),
    [anon_sym___thiscall] = ACTIONS(964),
    [anon_sym___vectorcall] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(966),
    [anon_sym_static] = ACTIONS(964),
    [anon_sym_auto] = ACTIONS(964),
    [anon_sym_register] = ACTIONS(964),
    [anon_sym_inline] = ACTIONS(964),
    [anon_sym_const] = ACTIONS(964),
    [anon_sym_volatile] = ACTIONS(964),
    [anon_sym_restrict] = ACTIONS(964),
    [anon_sym__Atomic] = ACTIONS(964),
    [anon_sym_signed] = ACTIONS(964),
    [anon_sym_unsigned] = ACTIONS(964),
    [anon_sym_long] = ACTIONS(964),
    [anon_sym_short] = ACTIONS(964),
    [sym_primitive_type] = ACTIONS(964),
    [anon_sym_enum] = ACTIONS(964),
    [anon_sym_struct] = ACTIONS(964),
    [anon_sym_union] = ACTIONS(964),
    [anon_sym_if] = ACTIONS(964),
    [anon_sym_else] = ACTIONS(964),
    [anon_sym_switch] = ACTIONS(964),
    [anon_sym_case] = ACTIONS(964),
    [anon_sym_default] = ACTIONS(964),
    [anon_sym_while] = ACTIONS(964),
    [anon_sym_do] = ACTIONS(964),
    [anon_sym_for] = ACTIONS(964),
    [anon_sym_return] = ACTIONS(964),
    [anon_sym_break] = ACTIONS(964),
    [anon_sym_continue] = ACTIONS(964),
    [anon_sym_goto] = ACTIONS(964),
    [anon_sym_DASH_DASH] = ACTIONS(966),
    [anon_sym_PLUS_PLUS] = ACTIONS(966),
    [anon_sym_sizeof] = ACTIONS(964),
    [sym_number_literal] = ACTIONS(966),
    [anon_sym_L_SQUOTE] = ACTIONS(966),
    [anon_sym_u_SQUOTE] = ACTIONS(966),
    [anon_sym_U_SQUOTE] = ACTIONS(966),
    [anon_sym_u8_SQUOTE] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(966),
    [anon_sym_L_DQUOTE] = ACTIONS(966),
    [anon_sym_u_DQUOTE] = ACTIONS(966),
    [anon_sym_U_DQUOTE] = ACTIONS(966),
    [anon_sym_u8_DQUOTE] = ACTIONS(966),
    [anon_sym_DQUOTE] = ACTIONS(966),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_comment] = ACTIONS(3),
  },
  [226] = {
    [sym_identifier] = ACTIONS(922),
    [aux_sym_preproc_include_token1] = ACTIONS(922),
    [aux_sym_preproc_def_token1] = ACTIONS(922),
    [aux_sym_preproc_if_token1] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(922),
    [sym_preproc_directive] = ACTIONS(922),
    [anon_sym_LPAREN2] = ACTIONS(924),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(924),
    [anon_sym_typedef] = ACTIONS(922),
    [anon_sym_extern] = ACTIONS(922),
    [anon_sym___attribute__] = ACTIONS(922),
    [anon_sym___declspec] = ACTIONS(922),
    [anon_sym___cdecl] = ACTIONS(922),
    [anon_sym___clrcall] = ACTIONS(922),
    [anon_sym___stdcall] = ACTIONS(922),
    [anon_sym___fastcall] = ACTIONS(922),
    [anon_sym___thiscall] = ACTIONS(922),
    [anon_sym___vectorcall] = ACTIONS(922),
    [anon_sym_LBRACE] = ACTIONS(924),
    [anon_sym_RBRACE] = ACTIONS(924),
    [anon_sym_static] = ACTIONS(922),
    [anon_sym_auto] = ACTIONS(922),
    [anon_sym_register] = ACTIONS(922),
    [anon_sym_inline] = ACTIONS(922),
    [anon_sym_const] = ACTIONS(922),
    [anon_sym_volatile] = ACTIONS(922),
    [anon_sym_restrict] = ACTIONS(922),
    [anon_sym__Atomic] = ACTIONS(922),
    [anon_sym_signed] = ACTIONS(922),
    [anon_sym_unsigned] = ACTIONS(922),
    [anon_sym_long] = ACTIONS(922),
    [anon_sym_short] = ACTIONS(922),
    [sym_primitive_type] = ACTIONS(922),
    [anon_sym_enum] = ACTIONS(922),
    [anon_sym_struct] = ACTIONS(922),
    [anon_sym_union] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(922),
    [anon_sym_else] = ACTIONS(922),
    [anon_sym_switch] = ACTIONS(922),
    [anon_sym_case] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(922),
    [anon_sym_while] = ACTIONS(922),
    [anon_sym_do] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(922),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(922),
    [anon_sym_goto] = ACTIONS(922),
    [anon_sym_DASH_DASH] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(924),
    [anon_sym_sizeof] = ACTIONS(922),
    [sym_number_literal] = ACTIONS(924),
    [anon_sym_L_SQUOTE] = ACTIONS(924),
    [anon_sym_u_SQUOTE] = ACTIONS(924),
    [anon_sym_U_SQUOTE] = ACTIONS(924),
    [anon_sym_u8_SQUOTE] = ACTIONS(924),
    [anon_sym_SQUOTE] = ACTIONS(924),
    [anon_sym_L_DQUOTE] = ACTIONS(924),
    [anon_sym_u_DQUOTE] = ACTIONS(924),
    [anon_sym_U_DQUOTE] = ACTIONS(924),
    [anon_sym_u8_DQUOTE] = ACTIONS(924),
    [anon_sym_DQUOTE] = ACTIONS(924),
    [sym_true] = ACTIONS(922),
    [sym_false] = ACTIONS(922),
    [sym_null] = ACTIONS(922),
    [sym_comment] = ACTIONS(3),
  },
  [227] = {
    [ts_builtin_sym_end] = ACTIONS(986),
    [sym_identifier] = ACTIONS(984),
    [aux_sym_preproc_include_token1] = ACTIONS(984),
    [aux_sym_preproc_def_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(984),
    [sym_preproc_directive] = ACTIONS(984),
    [anon_sym_LPAREN2] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_AMP] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_typedef] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym___attribute__] = ACTIONS(984),
    [anon_sym___declspec] = ACTIONS(984),
    [anon_sym___cdecl] = ACTIONS(984),
    [anon_sym___clrcall] = ACTIONS(984),
    [anon_sym___stdcall] = ACTIONS(984),
    [anon_sym___fastcall] = ACTIONS(984),
    [anon_sym___thiscall] = ACTIONS(984),
    [anon_sym___vectorcall] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_auto] = ACTIONS(984),
    [anon_sym_register] = ACTIONS(984),
    [anon_sym_inline] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_volatile] = ACTIONS(984),
    [anon_sym_restrict] = ACTIONS(984),
    [anon_sym__Atomic] = ACTIONS(984),
    [anon_sym_signed] = ACTIONS(984),
    [anon_sym_unsigned] = ACTIONS(984),
    [anon_sym_long] = ACTIONS(984),
    [anon_sym_short] = ACTIONS(984),
    [sym_primitive_type] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_struct] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(984),
    [anon_sym_switch] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_do] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_goto] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_sizeof] = ACTIONS(984),
    [sym_number_literal] = ACTIONS(986),
    [anon_sym_L_SQUOTE] = ACTIONS(986),
    [anon_sym_u_SQUOTE] = ACTIONS(986),
    [anon_sym_U_SQUOTE] = ACTIONS(986),
    [anon_sym_u8_SQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [anon_sym_L_DQUOTE] = ACTIONS(986),
    [anon_sym_u_DQUOTE] = ACTIONS(986),
    [anon_sym_U_DQUOTE] = ACTIONS(986),
    [anon_sym_u8_DQUOTE] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
  },
  [228] = {
    [ts_builtin_sym_end] = ACTIONS(950),
    [sym_identifier] = ACTIONS(948),
    [aux_sym_preproc_include_token1] = ACTIONS(948),
    [aux_sym_preproc_def_token1] = ACTIONS(948),
    [aux_sym_preproc_if_token1] = ACTIONS(948),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(948),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(948),
    [sym_preproc_directive] = ACTIONS(948),
    [anon_sym_LPAREN2] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(950),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_DASH] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_SEMI] = ACTIONS(950),
    [anon_sym_typedef] = ACTIONS(948),
    [anon_sym_extern] = ACTIONS(948),
    [anon_sym___attribute__] = ACTIONS(948),
    [anon_sym___declspec] = ACTIONS(948),
    [anon_sym___cdecl] = ACTIONS(948),
    [anon_sym___clrcall] = ACTIONS(948),
    [anon_sym___stdcall] = ACTIONS(948),
    [anon_sym___fastcall] = ACTIONS(948),
    [anon_sym___thiscall] = ACTIONS(948),
    [anon_sym___vectorcall] = ACTIONS(948),
    [anon_sym_LBRACE] = ACTIONS(950),
    [anon_sym_static] = ACTIONS(948),
    [anon_sym_auto] = ACTIONS(948),
    [anon_sym_register] = ACTIONS(948),
    [anon_sym_inline] = ACTIONS(948),
    [anon_sym_const] = ACTIONS(948),
    [anon_sym_volatile] = ACTIONS(948),
    [anon_sym_restrict] = ACTIONS(948),
    [anon_sym__Atomic] = ACTIONS(948),
    [anon_sym_signed] = ACTIONS(948),
    [anon_sym_unsigned] = ACTIONS(948),
    [anon_sym_long] = ACTIONS(948),
    [anon_sym_short] = ACTIONS(948),
    [sym_primitive_type] = ACTIONS(948),
    [anon_sym_enum] = ACTIONS(948),
    [anon_sym_struct] = ACTIONS(948),
    [anon_sym_union] = ACTIONS(948),
    [anon_sym_if] = ACTIONS(948),
    [anon_sym_else] = ACTIONS(948),
    [anon_sym_switch] = ACTIONS(948),
    [anon_sym_case] = ACTIONS(948),
    [anon_sym_default] = ACTIONS(948),
    [anon_sym_while] = ACTIONS(948),
    [anon_sym_do] = ACTIONS(948),
    [anon_sym_for] = ACTIONS(948),
    [anon_sym_return] = ACTIONS(948),
    [anon_sym_break] = ACTIONS(948),
    [anon_sym_continue] = ACTIONS(948),
    [anon_sym_goto] = ACTIONS(948),
    [anon_sym_DASH_DASH] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(950),
    [anon_sym_sizeof] = ACTIONS(948),
    [sym_number_literal] = ACTIONS(950),
    [anon_sym_L_SQUOTE] = ACTIONS(950),
    [anon_sym_u_SQUOTE] = ACTIONS(950),
    [anon_sym_U_SQUOTE] = ACTIONS(950),
    [anon_sym_u8_SQUOTE] = ACTIONS(950),
    [anon_sym_SQUOTE] = ACTIONS(950),
    [anon_sym_L_DQUOTE] = ACTIONS(950),
    [anon_sym_u_DQUOTE] = ACTIONS(950),
    [anon_sym_U_DQUOTE] = ACTIONS(950),
    [anon_sym_u8_DQUOTE] = ACTIONS(950),
    [anon_sym_DQUOTE] = ACTIONS(950),
    [sym_true] = ACTIONS(948),
    [sym_false] = ACTIONS(948),
    [sym_null] = ACTIONS(948),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [ts_builtin_sym_end] = ACTIONS(938),
    [sym_identifier] = ACTIONS(936),
    [aux_sym_preproc_include_token1] = ACTIONS(936),
    [aux_sym_preproc_def_token1] = ACTIONS(936),
    [aux_sym_preproc_if_token1] = ACTIONS(936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(936),
    [sym_preproc_directive] = ACTIONS(936),
    [anon_sym_LPAREN2] = ACTIONS(938),
    [anon_sym_BANG] = ACTIONS(938),
    [anon_sym_TILDE] = ACTIONS(938),
    [anon_sym_DASH] = ACTIONS(936),
    [anon_sym_PLUS] = ACTIONS(936),
    [anon_sym_STAR] = ACTIONS(938),
    [anon_sym_AMP] = ACTIONS(938),
    [anon_sym_SEMI] = ACTIONS(938),
    [anon_sym_typedef] = ACTIONS(936),
    [anon_sym_extern] = ACTIONS(936),
    [anon_sym___attribute__] = ACTIONS(936),
    [anon_sym___declspec] = ACTIONS(936),
    [anon_sym___cdecl] = ACTIONS(936),
    [anon_sym___clrcall] = ACTIONS(936),
    [anon_sym___stdcall] = ACTIONS(936),
    [anon_sym___fastcall] = ACTIONS(936),
    [anon_sym___thiscall] = ACTIONS(936),
    [anon_sym___vectorcall] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(938),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_auto] = ACTIONS(936),
    [anon_sym_register] = ACTIONS(936),
    [anon_sym_inline] = ACTIONS(936),
    [anon_sym_const] = ACTIONS(936),
    [anon_sym_volatile] = ACTIONS(936),
    [anon_sym_restrict] = ACTIONS(936),
    [anon_sym__Atomic] = ACTIONS(936),
    [anon_sym_signed] = ACTIONS(936),
    [anon_sym_unsigned] = ACTIONS(936),
    [anon_sym_long] = ACTIONS(936),
    [anon_sym_short] = ACTIONS(936),
    [sym_primitive_type] = ACTIONS(936),
    [anon_sym_enum] = ACTIONS(936),
    [anon_sym_struct] = ACTIONS(936),
    [anon_sym_union] = ACTIONS(936),
    [anon_sym_if] = ACTIONS(936),
    [anon_sym_else] = ACTIONS(936),
    [anon_sym_switch] = ACTIONS(936),
    [anon_sym_case] = ACTIONS(936),
    [anon_sym_default] = ACTIONS(936),
    [anon_sym_while] = ACTIONS(936),
    [anon_sym_do] = ACTIONS(936),
    [anon_sym_for] = ACTIONS(936),
    [anon_sym_return] = ACTIONS(936),
    [anon_sym_break] = ACTIONS(936),
    [anon_sym_continue] = ACTIONS(936),
    [anon_sym_goto] = ACTIONS(936),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_sizeof] = ACTIONS(936),
    [sym_number_literal] = ACTIONS(938),
    [anon_sym_L_SQUOTE] = ACTIONS(938),
    [anon_sym_u_SQUOTE] = ACTIONS(938),
    [anon_sym_U_SQUOTE] = ACTIONS(938),
    [anon_sym_u8_SQUOTE] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(938),
    [anon_sym_L_DQUOTE] = ACTIONS(938),
    [anon_sym_u_DQUOTE] = ACTIONS(938),
    [anon_sym_U_DQUOTE] = ACTIONS(938),
    [anon_sym_u8_DQUOTE] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [sym_true] = ACTIONS(936),
    [sym_false] = ACTIONS(936),
    [sym_null] = ACTIONS(936),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [sym_identifier] = ACTIONS(932),
    [aux_sym_preproc_include_token1] = ACTIONS(932),
    [aux_sym_preproc_def_token1] = ACTIONS(932),
    [aux_sym_preproc_if_token1] = ACTIONS(932),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(932),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(932),
    [sym_preproc_directive] = ACTIONS(932),
    [anon_sym_LPAREN2] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(934),
    [anon_sym_TILDE] = ACTIONS(934),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_STAR] = ACTIONS(934),
    [anon_sym_AMP] = ACTIONS(934),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_typedef] = ACTIONS(932),
    [anon_sym_extern] = ACTIONS(932),
    [anon_sym___attribute__] = ACTIONS(932),
    [anon_sym___declspec] = ACTIONS(932),
    [anon_sym___cdecl] = ACTIONS(932),
    [anon_sym___clrcall] = ACTIONS(932),
    [anon_sym___stdcall] = ACTIONS(932),
    [anon_sym___fastcall] = ACTIONS(932),
    [anon_sym___thiscall] = ACTIONS(932),
    [anon_sym___vectorcall] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(934),
    [anon_sym_RBRACE] = ACTIONS(934),
    [anon_sym_static] = ACTIONS(932),
    [anon_sym_auto] = ACTIONS(932),
    [anon_sym_register] = ACTIONS(932),
    [anon_sym_inline] = ACTIONS(932),
    [anon_sym_const] = ACTIONS(932),
    [anon_sym_volatile] = ACTIONS(932),
    [anon_sym_restrict] = ACTIONS(932),
    [anon_sym__Atomic] = ACTIONS(932),
    [anon_sym_signed] = ACTIONS(932),
    [anon_sym_unsigned] = ACTIONS(932),
    [anon_sym_long] = ACTIONS(932),
    [anon_sym_short] = ACTIONS(932),
    [sym_primitive_type] = ACTIONS(932),
    [anon_sym_enum] = ACTIONS(932),
    [anon_sym_struct] = ACTIONS(932),
    [anon_sym_union] = ACTIONS(932),
    [anon_sym_if] = ACTIONS(932),
    [anon_sym_else] = ACTIONS(932),
    [anon_sym_switch] = ACTIONS(932),
    [anon_sym_case] = ACTIONS(932),
    [anon_sym_default] = ACTIONS(932),
    [anon_sym_while] = ACTIONS(932),
    [anon_sym_do] = ACTIONS(932),
    [anon_sym_for] = ACTIONS(932),
    [anon_sym_return] = ACTIONS(932),
    [anon_sym_break] = ACTIONS(932),
    [anon_sym_continue] = ACTIONS(932),
    [anon_sym_goto] = ACTIONS(932),
    [anon_sym_DASH_DASH] = ACTIONS(934),
    [anon_sym_PLUS_PLUS] = ACTIONS(934),
    [anon_sym_sizeof] = ACTIONS(932),
    [sym_number_literal] = ACTIONS(934),
    [anon_sym_L_SQUOTE] = ACTIONS(934),
    [anon_sym_u_SQUOTE] = ACTIONS(934),
    [anon_sym_U_SQUOTE] = ACTIONS(934),
    [anon_sym_u8_SQUOTE] = ACTIONS(934),
    [anon_sym_SQUOTE] = ACTIONS(934),
    [anon_sym_L_DQUOTE] = ACTIONS(934),
    [anon_sym_u_DQUOTE] = ACTIONS(934),
    [anon_sym_U_DQUOTE] = ACTIONS(934),
    [anon_sym_u8_DQUOTE] = ACTIONS(934),
    [anon_sym_DQUOTE] = ACTIONS(934),
    [sym_true] = ACTIONS(932),
    [sym_false] = ACTIONS(932),
    [sym_null] = ACTIONS(932),
    [sym_comment] = ACTIONS(3),
  },
  [231] = {
    [ts_builtin_sym_end] = ACTIONS(970),
    [sym_identifier] = ACTIONS(968),
    [aux_sym_preproc_include_token1] = ACTIONS(968),
    [aux_sym_preproc_def_token1] = ACTIONS(968),
    [aux_sym_preproc_if_token1] = ACTIONS(968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(968),
    [sym_preproc_directive] = ACTIONS(968),
    [anon_sym_LPAREN2] = ACTIONS(970),
    [anon_sym_BANG] = ACTIONS(970),
    [anon_sym_TILDE] = ACTIONS(970),
    [anon_sym_DASH] = ACTIONS(968),
    [anon_sym_PLUS] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(970),
    [anon_sym_AMP] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(970),
    [anon_sym_typedef] = ACTIONS(968),
    [anon_sym_extern] = ACTIONS(968),
    [anon_sym___attribute__] = ACTIONS(968),
    [anon_sym___declspec] = ACTIONS(968),
    [anon_sym___cdecl] = ACTIONS(968),
    [anon_sym___clrcall] = ACTIONS(968),
    [anon_sym___stdcall] = ACTIONS(968),
    [anon_sym___fastcall] = ACTIONS(968),
    [anon_sym___thiscall] = ACTIONS(968),
    [anon_sym___vectorcall] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(970),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_auto] = ACTIONS(968),
    [anon_sym_register] = ACTIONS(968),
    [anon_sym_inline] = ACTIONS(968),
    [anon_sym_const] = ACTIONS(968),
    [anon_sym_volatile] = ACTIONS(968),
    [anon_sym_restrict] = ACTIONS(968),
    [anon_sym__Atomic] = ACTIONS(968),
    [anon_sym_signed] = ACTIONS(968),
    [anon_sym_unsigned] = ACTIONS(968),
    [anon_sym_long] = ACTIONS(968),
    [anon_sym_short] = ACTIONS(968),
    [sym_primitive_type] = ACTIONS(968),
    [anon_sym_enum] = ACTIONS(968),
    [anon_sym_struct] = ACTIONS(968),
    [anon_sym_union] = ACTIONS(968),
    [anon_sym_if] = ACTIONS(968),
    [anon_sym_else] = ACTIONS(968),
    [anon_sym_switch] = ACTIONS(968),
    [anon_sym_case] = ACTIONS(968),
    [anon_sym_default] = ACTIONS(968),
    [anon_sym_while] = ACTIONS(968),
    [anon_sym_do] = ACTIONS(968),
    [anon_sym_for] = ACTIONS(968),
    [anon_sym_return] = ACTIONS(968),
    [anon_sym_break] = ACTIONS(968),
    [anon_sym_continue] = ACTIONS(968),
    [anon_sym_goto] = ACTIONS(968),
    [anon_sym_DASH_DASH] = ACTIONS(970),
    [anon_sym_PLUS_PLUS] = ACTIONS(970),
    [anon_sym_sizeof] = ACTIONS(968),
    [sym_number_literal] = ACTIONS(970),
    [anon_sym_L_SQUOTE] = ACTIONS(970),
    [anon_sym_u_SQUOTE] = ACTIONS(970),
    [anon_sym_U_SQUOTE] = ACTIONS(970),
    [anon_sym_u8_SQUOTE] = ACTIONS(970),
    [anon_sym_SQUOTE] = ACTIONS(970),
    [anon_sym_L_DQUOTE] = ACTIONS(970),
    [anon_sym_u_DQUOTE] = ACTIONS(970),
    [anon_sym_U_DQUOTE] = ACTIONS(970),
    [anon_sym_u8_DQUOTE] = ACTIONS(970),
    [anon_sym_DQUOTE] = ACTIONS(970),
    [sym_true] = ACTIONS(968),
    [sym_false] = ACTIONS(968),
    [sym_null] = ACTIONS(968),
    [sym_comment] = ACTIONS(3),
  },
  [232] = {
    [sym_identifier] = ACTIONS(1084),
    [aux_sym_preproc_include_token1] = ACTIONS(1084),
    [aux_sym_preproc_def_token1] = ACTIONS(1084),
    [aux_sym_preproc_if_token1] = ACTIONS(1084),
    [aux_sym_preproc_if_token2] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1084),
    [sym_preproc_directive] = ACTIONS(1084),
    [anon_sym_LPAREN2] = ACTIONS(1086),
    [anon_sym_BANG] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_STAR] = ACTIONS(1086),
    [anon_sym_AMP] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_typedef] = ACTIONS(1084),
    [anon_sym_extern] = ACTIONS(1084),
    [anon_sym___attribute__] = ACTIONS(1084),
    [anon_sym___declspec] = ACTIONS(1084),
    [anon_sym___cdecl] = ACTIONS(1084),
    [anon_sym___clrcall] = ACTIONS(1084),
    [anon_sym___stdcall] = ACTIONS(1084),
    [anon_sym___fastcall] = ACTIONS(1084),
    [anon_sym___thiscall] = ACTIONS(1084),
    [anon_sym___vectorcall] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_static] = ACTIONS(1084),
    [anon_sym_auto] = ACTIONS(1084),
    [anon_sym_register] = ACTIONS(1084),
    [anon_sym_inline] = ACTIONS(1084),
    [anon_sym_const] = ACTIONS(1084),
    [anon_sym_volatile] = ACTIONS(1084),
    [anon_sym_restrict] = ACTIONS(1084),
    [anon_sym__Atomic] = ACTIONS(1084),
    [anon_sym_signed] = ACTIONS(1084),
    [anon_sym_unsigned] = ACTIONS(1084),
    [anon_sym_long] = ACTIONS(1084),
    [anon_sym_short] = ACTIONS(1084),
    [sym_primitive_type] = ACTIONS(1084),
    [anon_sym_enum] = ACTIONS(1084),
    [anon_sym_struct] = ACTIONS(1084),
    [anon_sym_union] = ACTIONS(1084),
    [anon_sym_if] = ACTIONS(1084),
    [anon_sym_switch] = ACTIONS(1084),
    [anon_sym_case] = ACTIONS(1084),
    [anon_sym_default] = ACTIONS(1084),
    [anon_sym_while] = ACTIONS(1084),
    [anon_sym_do] = ACTIONS(1084),
    [anon_sym_for] = ACTIONS(1084),
    [anon_sym_return] = ACTIONS(1084),
    [anon_sym_break] = ACTIONS(1084),
    [anon_sym_continue] = ACTIONS(1084),
    [anon_sym_goto] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1084),
    [sym_number_literal] = ACTIONS(1086),
    [anon_sym_L_SQUOTE] = ACTIONS(1086),
    [anon_sym_u_SQUOTE] = ACTIONS(1086),
    [anon_sym_U_SQUOTE] = ACTIONS(1086),
    [anon_sym_u8_SQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1086),
    [anon_sym_L_DQUOTE] = ACTIONS(1086),
    [anon_sym_u_DQUOTE] = ACTIONS(1086),
    [anon_sym_U_DQUOTE] = ACTIONS(1086),
    [anon_sym_u8_DQUOTE] = ACTIONS(1086),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [sym_true] = ACTIONS(1084),
    [sym_false] = ACTIONS(1084),
    [sym_null] = ACTIONS(1084),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_identifier] = ACTIONS(1076),
    [aux_sym_preproc_include_token1] = ACTIONS(1076),
    [aux_sym_preproc_def_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token2] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1076),
    [sym_preproc_directive] = ACTIONS(1076),
    [anon_sym_LPAREN2] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1078),
    [anon_sym_typedef] = ACTIONS(1076),
    [anon_sym_extern] = ACTIONS(1076),
    [anon_sym___attribute__] = ACTIONS(1076),
    [anon_sym___declspec] = ACTIONS(1076),
    [anon_sym___cdecl] = ACTIONS(1076),
    [anon_sym___clrcall] = ACTIONS(1076),
    [anon_sym___stdcall] = ACTIONS(1076),
    [anon_sym___fastcall] = ACTIONS(1076),
    [anon_sym___thiscall] = ACTIONS(1076),
    [anon_sym___vectorcall] = ACTIONS(1076),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_auto] = ACTIONS(1076),
    [anon_sym_register] = ACTIONS(1076),
    [anon_sym_inline] = ACTIONS(1076),
    [anon_sym_const] = ACTIONS(1076),
    [anon_sym_volatile] = ACTIONS(1076),
    [anon_sym_restrict] = ACTIONS(1076),
    [anon_sym__Atomic] = ACTIONS(1076),
    [anon_sym_signed] = ACTIONS(1076),
    [anon_sym_unsigned] = ACTIONS(1076),
    [anon_sym_long] = ACTIONS(1076),
    [anon_sym_short] = ACTIONS(1076),
    [sym_primitive_type] = ACTIONS(1076),
    [anon_sym_enum] = ACTIONS(1076),
    [anon_sym_struct] = ACTIONS(1076),
    [anon_sym_union] = ACTIONS(1076),
    [anon_sym_if] = ACTIONS(1076),
    [anon_sym_switch] = ACTIONS(1076),
    [anon_sym_case] = ACTIONS(1076),
    [anon_sym_default] = ACTIONS(1076),
    [anon_sym_while] = ACTIONS(1076),
    [anon_sym_do] = ACTIONS(1076),
    [anon_sym_for] = ACTIONS(1076),
    [anon_sym_return] = ACTIONS(1076),
    [anon_sym_break] = ACTIONS(1076),
    [anon_sym_continue] = ACTIONS(1076),
    [anon_sym_goto] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1078),
    [anon_sym_sizeof] = ACTIONS(1076),
    [sym_number_literal] = ACTIONS(1078),
    [anon_sym_L_SQUOTE] = ACTIONS(1078),
    [anon_sym_u_SQUOTE] = ACTIONS(1078),
    [anon_sym_U_SQUOTE] = ACTIONS(1078),
    [anon_sym_u8_SQUOTE] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [anon_sym_L_DQUOTE] = ACTIONS(1078),
    [anon_sym_u_DQUOTE] = ACTIONS(1078),
    [anon_sym_U_DQUOTE] = ACTIONS(1078),
    [anon_sym_u8_DQUOTE] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [sym_true] = ACTIONS(1076),
    [sym_false] = ACTIONS(1076),
    [sym_null] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym_identifier] = ACTIONS(1104),
    [aux_sym_preproc_include_token1] = ACTIONS(1104),
    [aux_sym_preproc_def_token1] = ACTIONS(1104),
    [aux_sym_preproc_if_token1] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1104),
    [sym_preproc_directive] = ACTIONS(1104),
    [anon_sym_LPAREN2] = ACTIONS(1106),
    [anon_sym_BANG] = ACTIONS(1106),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_AMP] = ACTIONS(1106),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_typedef] = ACTIONS(1104),
    [anon_sym_extern] = ACTIONS(1104),
    [anon_sym___attribute__] = ACTIONS(1104),
    [anon_sym___declspec] = ACTIONS(1104),
    [anon_sym___cdecl] = ACTIONS(1104),
    [anon_sym___clrcall] = ACTIONS(1104),
    [anon_sym___stdcall] = ACTIONS(1104),
    [anon_sym___fastcall] = ACTIONS(1104),
    [anon_sym___thiscall] = ACTIONS(1104),
    [anon_sym___vectorcall] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_RBRACE] = ACTIONS(1106),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_auto] = ACTIONS(1104),
    [anon_sym_register] = ACTIONS(1104),
    [anon_sym_inline] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_volatile] = ACTIONS(1104),
    [anon_sym_restrict] = ACTIONS(1104),
    [anon_sym__Atomic] = ACTIONS(1104),
    [anon_sym_signed] = ACTIONS(1104),
    [anon_sym_unsigned] = ACTIONS(1104),
    [anon_sym_long] = ACTIONS(1104),
    [anon_sym_short] = ACTIONS(1104),
    [sym_primitive_type] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [anon_sym_struct] = ACTIONS(1104),
    [anon_sym_union] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_goto] = ACTIONS(1104),
    [anon_sym_DASH_DASH] = ACTIONS(1106),
    [anon_sym_PLUS_PLUS] = ACTIONS(1106),
    [anon_sym_sizeof] = ACTIONS(1104),
    [sym_number_literal] = ACTIONS(1106),
    [anon_sym_L_SQUOTE] = ACTIONS(1106),
    [anon_sym_u_SQUOTE] = ACTIONS(1106),
    [anon_sym_U_SQUOTE] = ACTIONS(1106),
    [anon_sym_u8_SQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [anon_sym_L_DQUOTE] = ACTIONS(1106),
    [anon_sym_u_DQUOTE] = ACTIONS(1106),
    [anon_sym_U_DQUOTE] = ACTIONS(1106),
    [anon_sym_u8_DQUOTE] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_comment] = ACTIONS(3),
  },
  [235] = {
    [sym_identifier] = ACTIONS(1056),
    [aux_sym_preproc_include_token1] = ACTIONS(1056),
    [aux_sym_preproc_def_token1] = ACTIONS(1056),
    [aux_sym_preproc_if_token1] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1056),
    [sym_preproc_directive] = ACTIONS(1056),
    [anon_sym_LPAREN2] = ACTIONS(1058),
    [anon_sym_BANG] = ACTIONS(1058),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1056),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_AMP] = ACTIONS(1058),
    [anon_sym_SEMI] = ACTIONS(1058),
    [anon_sym_typedef] = ACTIONS(1056),
    [anon_sym_extern] = ACTIONS(1056),
    [anon_sym___attribute__] = ACTIONS(1056),
    [anon_sym___declspec] = ACTIONS(1056),
    [anon_sym___cdecl] = ACTIONS(1056),
    [anon_sym___clrcall] = ACTIONS(1056),
    [anon_sym___stdcall] = ACTIONS(1056),
    [anon_sym___fastcall] = ACTIONS(1056),
    [anon_sym___thiscall] = ACTIONS(1056),
    [anon_sym___vectorcall] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_RBRACE] = ACTIONS(1058),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_auto] = ACTIONS(1056),
    [anon_sym_register] = ACTIONS(1056),
    [anon_sym_inline] = ACTIONS(1056),
    [anon_sym_const] = ACTIONS(1056),
    [anon_sym_volatile] = ACTIONS(1056),
    [anon_sym_restrict] = ACTIONS(1056),
    [anon_sym__Atomic] = ACTIONS(1056),
    [anon_sym_signed] = ACTIONS(1056),
    [anon_sym_unsigned] = ACTIONS(1056),
    [anon_sym_long] = ACTIONS(1056),
    [anon_sym_short] = ACTIONS(1056),
    [sym_primitive_type] = ACTIONS(1056),
    [anon_sym_enum] = ACTIONS(1056),
    [anon_sym_struct] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_switch] = ACTIONS(1056),
    [anon_sym_case] = ACTIONS(1056),
    [anon_sym_default] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_do] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_goto] = ACTIONS(1056),
    [anon_sym_DASH_DASH] = ACTIONS(1058),
    [anon_sym_PLUS_PLUS] = ACTIONS(1058),
    [anon_sym_sizeof] = ACTIONS(1056),
    [sym_number_literal] = ACTIONS(1058),
    [anon_sym_L_SQUOTE] = ACTIONS(1058),
    [anon_sym_u_SQUOTE] = ACTIONS(1058),
    [anon_sym_U_SQUOTE] = ACTIONS(1058),
    [anon_sym_u8_SQUOTE] = ACTIONS(1058),
    [anon_sym_SQUOTE] = ACTIONS(1058),
    [anon_sym_L_DQUOTE] = ACTIONS(1058),
    [anon_sym_u_DQUOTE] = ACTIONS(1058),
    [anon_sym_U_DQUOTE] = ACTIONS(1058),
    [anon_sym_u8_DQUOTE] = ACTIONS(1058),
    [anon_sym_DQUOTE] = ACTIONS(1058),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_null] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_identifier] = ACTIONS(1060),
    [aux_sym_preproc_include_token1] = ACTIONS(1060),
    [aux_sym_preproc_def_token1] = ACTIONS(1060),
    [aux_sym_preproc_if_token1] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1060),
    [sym_preproc_directive] = ACTIONS(1060),
    [anon_sym_LPAREN2] = ACTIONS(1062),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_AMP] = ACTIONS(1062),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_typedef] = ACTIONS(1060),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym___attribute__] = ACTIONS(1060),
    [anon_sym___declspec] = ACTIONS(1060),
    [anon_sym___cdecl] = ACTIONS(1060),
    [anon_sym___clrcall] = ACTIONS(1060),
    [anon_sym___stdcall] = ACTIONS(1060),
    [anon_sym___fastcall] = ACTIONS(1060),
    [anon_sym___thiscall] = ACTIONS(1060),
    [anon_sym___vectorcall] = ACTIONS(1060),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1060),
    [anon_sym_auto] = ACTIONS(1060),
    [anon_sym_register] = ACTIONS(1060),
    [anon_sym_inline] = ACTIONS(1060),
    [anon_sym_const] = ACTIONS(1060),
    [anon_sym_volatile] = ACTIONS(1060),
    [anon_sym_restrict] = ACTIONS(1060),
    [anon_sym__Atomic] = ACTIONS(1060),
    [anon_sym_signed] = ACTIONS(1060),
    [anon_sym_unsigned] = ACTIONS(1060),
    [anon_sym_long] = ACTIONS(1060),
    [anon_sym_short] = ACTIONS(1060),
    [sym_primitive_type] = ACTIONS(1060),
    [anon_sym_enum] = ACTIONS(1060),
    [anon_sym_struct] = ACTIONS(1060),
    [anon_sym_union] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_switch] = ACTIONS(1060),
    [anon_sym_case] = ACTIONS(1060),
    [anon_sym_default] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_do] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_goto] = ACTIONS(1060),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_sizeof] = ACTIONS(1060),
    [sym_number_literal] = ACTIONS(1062),
    [anon_sym_L_SQUOTE] = ACTIONS(1062),
    [anon_sym_u_SQUOTE] = ACTIONS(1062),
    [anon_sym_U_SQUOTE] = ACTIONS(1062),
    [anon_sym_u8_SQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [anon_sym_L_DQUOTE] = ACTIONS(1062),
    [anon_sym_u_DQUOTE] = ACTIONS(1062),
    [anon_sym_U_DQUOTE] = ACTIONS(1062),
    [anon_sym_u8_DQUOTE] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_null] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
  },
  [237] = {
    [sym_identifier] = ACTIONS(1096),
    [aux_sym_preproc_include_token1] = ACTIONS(1096),
    [aux_sym_preproc_def_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1096),
    [sym_preproc_directive] = ACTIONS(1096),
    [anon_sym_LPAREN2] = ACTIONS(1098),
    [anon_sym_BANG] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1096),
    [anon_sym_PLUS] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1098),
    [anon_sym_AMP] = ACTIONS(1098),
    [anon_sym_SEMI] = ACTIONS(1098),
    [anon_sym_typedef] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(1096),
    [anon_sym___attribute__] = ACTIONS(1096),
    [anon_sym___declspec] = ACTIONS(1096),
    [anon_sym___cdecl] = ACTIONS(1096),
    [anon_sym___clrcall] = ACTIONS(1096),
    [anon_sym___stdcall] = ACTIONS(1096),
    [anon_sym___fastcall] = ACTIONS(1096),
    [anon_sym___thiscall] = ACTIONS(1096),
    [anon_sym___vectorcall] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1098),
    [anon_sym_RBRACE] = ACTIONS(1098),
    [anon_sym_static] = ACTIONS(1096),
    [anon_sym_auto] = ACTIONS(1096),
    [anon_sym_register] = ACTIONS(1096),
    [anon_sym_inline] = ACTIONS(1096),
    [anon_sym_const] = ACTIONS(1096),
    [anon_sym_volatile] = ACTIONS(1096),
    [anon_sym_restrict] = ACTIONS(1096),
    [anon_sym__Atomic] = ACTIONS(1096),
    [anon_sym_signed] = ACTIONS(1096),
    [anon_sym_unsigned] = ACTIONS(1096),
    [anon_sym_long] = ACTIONS(1096),
    [anon_sym_short] = ACTIONS(1096),
    [sym_primitive_type] = ACTIONS(1096),
    [anon_sym_enum] = ACTIONS(1096),
    [anon_sym_struct] = ACTIONS(1096),
    [anon_sym_union] = ACTIONS(1096),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_switch] = ACTIONS(1096),
    [anon_sym_case] = ACTIONS(1096),
    [anon_sym_default] = ACTIONS(1096),
    [anon_sym_while] = ACTIONS(1096),
    [anon_sym_do] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1096),
    [anon_sym_return] = ACTIONS(1096),
    [anon_sym_break] = ACTIONS(1096),
    [anon_sym_continue] = ACTIONS(1096),
    [anon_sym_goto] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1098),
    [anon_sym_sizeof] = ACTIONS(1096),
    [sym_number_literal] = ACTIONS(1098),
    [anon_sym_L_SQUOTE] = ACTIONS(1098),
    [anon_sym_u_SQUOTE] = ACTIONS(1098),
    [anon_sym_U_SQUOTE] = ACTIONS(1098),
    [anon_sym_u8_SQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [anon_sym_L_DQUOTE] = ACTIONS(1098),
    [anon_sym_u_DQUOTE] = ACTIONS(1098),
    [anon_sym_U_DQUOTE] = ACTIONS(1098),
    [anon_sym_u8_DQUOTE] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
  },
  [238] = {
    [ts_builtin_sym_end] = ACTIONS(1066),
    [sym_identifier] = ACTIONS(1064),
    [aux_sym_preproc_include_token1] = ACTIONS(1064),
    [aux_sym_preproc_def_token1] = ACTIONS(1064),
    [aux_sym_preproc_if_token1] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1064),
    [sym_preproc_directive] = ACTIONS(1064),
    [anon_sym_LPAREN2] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_AMP] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1066),
    [anon_sym_typedef] = ACTIONS(1064),
    [anon_sym_extern] = ACTIONS(1064),
    [anon_sym___attribute__] = ACTIONS(1064),
    [anon_sym___declspec] = ACTIONS(1064),
    [anon_sym___cdecl] = ACTIONS(1064),
    [anon_sym___clrcall] = ACTIONS(1064),
    [anon_sym___stdcall] = ACTIONS(1064),
    [anon_sym___fastcall] = ACTIONS(1064),
    [anon_sym___thiscall] = ACTIONS(1064),
    [anon_sym___vectorcall] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_auto] = ACTIONS(1064),
    [anon_sym_register] = ACTIONS(1064),
    [anon_sym_inline] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_volatile] = ACTIONS(1064),
    [anon_sym_restrict] = ACTIONS(1064),
    [anon_sym__Atomic] = ACTIONS(1064),
    [anon_sym_signed] = ACTIONS(1064),
    [anon_sym_unsigned] = ACTIONS(1064),
    [anon_sym_long] = ACTIONS(1064),
    [anon_sym_short] = ACTIONS(1064),
    [sym_primitive_type] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [anon_sym_struct] = ACTIONS(1064),
    [anon_sym_union] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_goto] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1064),
    [sym_number_literal] = ACTIONS(1066),
    [anon_sym_L_SQUOTE] = ACTIONS(1066),
    [anon_sym_u_SQUOTE] = ACTIONS(1066),
    [anon_sym_U_SQUOTE] = ACTIONS(1066),
    [anon_sym_u8_SQUOTE] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [anon_sym_L_DQUOTE] = ACTIONS(1066),
    [anon_sym_u_DQUOTE] = ACTIONS(1066),
    [anon_sym_U_DQUOTE] = ACTIONS(1066),
    [anon_sym_u8_DQUOTE] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
  },
  [239] = {
    [ts_builtin_sym_end] = ACTIONS(1070),
    [sym_identifier] = ACTIONS(1068),
    [aux_sym_preproc_include_token1] = ACTIONS(1068),
    [aux_sym_preproc_def_token1] = ACTIONS(1068),
    [aux_sym_preproc_if_token1] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1068),
    [sym_preproc_directive] = ACTIONS(1068),
    [anon_sym_LPAREN2] = ACTIONS(1070),
    [anon_sym_BANG] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_typedef] = ACTIONS(1068),
    [anon_sym_extern] = ACTIONS(1068),
    [anon_sym___attribute__] = ACTIONS(1068),
    [anon_sym___declspec] = ACTIONS(1068),
    [anon_sym___cdecl] = ACTIONS(1068),
    [anon_sym___clrcall] = ACTIONS(1068),
    [anon_sym___stdcall] = ACTIONS(1068),
    [anon_sym___fastcall] = ACTIONS(1068),
    [anon_sym___thiscall] = ACTIONS(1068),
    [anon_sym___vectorcall] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_static] = ACTIONS(1068),
    [anon_sym_auto] = ACTIONS(1068),
    [anon_sym_register] = ACTIONS(1068),
    [anon_sym_inline] = ACTIONS(1068),
    [anon_sym_const] = ACTIONS(1068),
    [anon_sym_volatile] = ACTIONS(1068),
    [anon_sym_restrict] = ACTIONS(1068),
    [anon_sym__Atomic] = ACTIONS(1068),
    [anon_sym_signed] = ACTIONS(1068),
    [anon_sym_unsigned] = ACTIONS(1068),
    [anon_sym_long] = ACTIONS(1068),
    [anon_sym_short] = ACTIONS(1068),
    [sym_primitive_type] = ACTIONS(1068),
    [anon_sym_enum] = ACTIONS(1068),
    [anon_sym_struct] = ACTIONS(1068),
    [anon_sym_union] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_switch] = ACTIONS(1068),
    [anon_sym_case] = ACTIONS(1068),
    [anon_sym_default] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_do] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_goto] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1070),
    [anon_sym_PLUS_PLUS] = ACTIONS(1070),
    [anon_sym_sizeof] = ACTIONS(1068),
    [sym_number_literal] = ACTIONS(1070),
    [anon_sym_L_SQUOTE] = ACTIONS(1070),
    [anon_sym_u_SQUOTE] = ACTIONS(1070),
    [anon_sym_U_SQUOTE] = ACTIONS(1070),
    [anon_sym_u8_SQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [anon_sym_L_DQUOTE] = ACTIONS(1070),
    [anon_sym_u_DQUOTE] = ACTIONS(1070),
    [anon_sym_U_DQUOTE] = ACTIONS(1070),
    [anon_sym_u8_DQUOTE] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_null] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [ts_builtin_sym_end] = ACTIONS(1074),
    [sym_identifier] = ACTIONS(1072),
    [aux_sym_preproc_include_token1] = ACTIONS(1072),
    [aux_sym_preproc_def_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1072),
    [sym_preproc_directive] = ACTIONS(1072),
    [anon_sym_LPAREN2] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_typedef] = ACTIONS(1072),
    [anon_sym_extern] = ACTIONS(1072),
    [anon_sym___attribute__] = ACTIONS(1072),
    [anon_sym___declspec] = ACTIONS(1072),
    [anon_sym___cdecl] = ACTIONS(1072),
    [anon_sym___clrcall] = ACTIONS(1072),
    [anon_sym___stdcall] = ACTIONS(1072),
    [anon_sym___fastcall] = ACTIONS(1072),
    [anon_sym___thiscall] = ACTIONS(1072),
    [anon_sym___vectorcall] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_auto] = ACTIONS(1072),
    [anon_sym_register] = ACTIONS(1072),
    [anon_sym_inline] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_volatile] = ACTIONS(1072),
    [anon_sym_restrict] = ACTIONS(1072),
    [anon_sym__Atomic] = ACTIONS(1072),
    [anon_sym_signed] = ACTIONS(1072),
    [anon_sym_unsigned] = ACTIONS(1072),
    [anon_sym_long] = ACTIONS(1072),
    [anon_sym_short] = ACTIONS(1072),
    [sym_primitive_type] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1072),
    [anon_sym_union] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1072),
    [anon_sym_default] = ACTIONS(1072),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_do] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_goto] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_sizeof] = ACTIONS(1072),
    [sym_number_literal] = ACTIONS(1074),
    [anon_sym_L_SQUOTE] = ACTIONS(1074),
    [anon_sym_u_SQUOTE] = ACTIONS(1074),
    [anon_sym_U_SQUOTE] = ACTIONS(1074),
    [anon_sym_u8_SQUOTE] = ACTIONS(1074),
    [anon_sym_SQUOTE] = ACTIONS(1074),
    [anon_sym_L_DQUOTE] = ACTIONS(1074),
    [anon_sym_u_DQUOTE] = ACTIONS(1074),
    [anon_sym_U_DQUOTE] = ACTIONS(1074),
    [anon_sym_u8_DQUOTE] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_null] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [sym_identifier] = ACTIONS(1076),
    [aux_sym_preproc_include_token1] = ACTIONS(1076),
    [aux_sym_preproc_def_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1076),
    [sym_preproc_directive] = ACTIONS(1076),
    [anon_sym_LPAREN2] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1078),
    [anon_sym_typedef] = ACTIONS(1076),
    [anon_sym_extern] = ACTIONS(1076),
    [anon_sym___attribute__] = ACTIONS(1076),
    [anon_sym___declspec] = ACTIONS(1076),
    [anon_sym___cdecl] = ACTIONS(1076),
    [anon_sym___clrcall] = ACTIONS(1076),
    [anon_sym___stdcall] = ACTIONS(1076),
    [anon_sym___fastcall] = ACTIONS(1076),
    [anon_sym___thiscall] = ACTIONS(1076),
    [anon_sym___vectorcall] = ACTIONS(1076),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_auto] = ACTIONS(1076),
    [anon_sym_register] = ACTIONS(1076),
    [anon_sym_inline] = ACTIONS(1076),
    [anon_sym_const] = ACTIONS(1076),
    [anon_sym_volatile] = ACTIONS(1076),
    [anon_sym_restrict] = ACTIONS(1076),
    [anon_sym__Atomic] = ACTIONS(1076),
    [anon_sym_signed] = ACTIONS(1076),
    [anon_sym_unsigned] = ACTIONS(1076),
    [anon_sym_long] = ACTIONS(1076),
    [anon_sym_short] = ACTIONS(1076),
    [sym_primitive_type] = ACTIONS(1076),
    [anon_sym_enum] = ACTIONS(1076),
    [anon_sym_struct] = ACTIONS(1076),
    [anon_sym_union] = ACTIONS(1076),
    [anon_sym_if] = ACTIONS(1076),
    [anon_sym_switch] = ACTIONS(1076),
    [anon_sym_case] = ACTIONS(1076),
    [anon_sym_default] = ACTIONS(1076),
    [anon_sym_while] = ACTIONS(1076),
    [anon_sym_do] = ACTIONS(1076),
    [anon_sym_for] = ACTIONS(1076),
    [anon_sym_return] = ACTIONS(1076),
    [anon_sym_break] = ACTIONS(1076),
    [anon_sym_continue] = ACTIONS(1076),
    [anon_sym_goto] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1078),
    [anon_sym_sizeof] = ACTIONS(1076),
    [sym_number_literal] = ACTIONS(1078),
    [anon_sym_L_SQUOTE] = ACTIONS(1078),
    [anon_sym_u_SQUOTE] = ACTIONS(1078),
    [anon_sym_U_SQUOTE] = ACTIONS(1078),
    [anon_sym_u8_SQUOTE] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [anon_sym_L_DQUOTE] = ACTIONS(1078),
    [anon_sym_u_DQUOTE] = ACTIONS(1078),
    [anon_sym_U_DQUOTE] = ACTIONS(1078),
    [anon_sym_u8_DQUOTE] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [sym_true] = ACTIONS(1076),
    [sym_false] = ACTIONS(1076),
    [sym_null] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [sym_identifier] = ACTIONS(1032),
    [aux_sym_preproc_include_token1] = ACTIONS(1032),
    [aux_sym_preproc_def_token1] = ACTIONS(1032),
    [aux_sym_preproc_if_token1] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1032),
    [sym_preproc_directive] = ACTIONS(1032),
    [anon_sym_LPAREN2] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_STAR] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1034),
    [anon_sym_typedef] = ACTIONS(1032),
    [anon_sym_extern] = ACTIONS(1032),
    [anon_sym___attribute__] = ACTIONS(1032),
    [anon_sym___declspec] = ACTIONS(1032),
    [anon_sym___cdecl] = ACTIONS(1032),
    [anon_sym___clrcall] = ACTIONS(1032),
    [anon_sym___stdcall] = ACTIONS(1032),
    [anon_sym___fastcall] = ACTIONS(1032),
    [anon_sym___thiscall] = ACTIONS(1032),
    [anon_sym___vectorcall] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_RBRACE] = ACTIONS(1034),
    [anon_sym_static] = ACTIONS(1032),
    [anon_sym_auto] = ACTIONS(1032),
    [anon_sym_register] = ACTIONS(1032),
    [anon_sym_inline] = ACTIONS(1032),
    [anon_sym_const] = ACTIONS(1032),
    [anon_sym_volatile] = ACTIONS(1032),
    [anon_sym_restrict] = ACTIONS(1032),
    [anon_sym__Atomic] = ACTIONS(1032),
    [anon_sym_signed] = ACTIONS(1032),
    [anon_sym_unsigned] = ACTIONS(1032),
    [anon_sym_long] = ACTIONS(1032),
    [anon_sym_short] = ACTIONS(1032),
    [sym_primitive_type] = ACTIONS(1032),
    [anon_sym_enum] = ACTIONS(1032),
    [anon_sym_struct] = ACTIONS(1032),
    [anon_sym_union] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(1032),
    [anon_sym_default] = ACTIONS(1032),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_do] = ACTIONS(1032),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_goto] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1034),
    [anon_sym_PLUS_PLUS] = ACTIONS(1034),
    [anon_sym_sizeof] = ACTIONS(1032),
    [sym_number_literal] = ACTIONS(1034),
    [anon_sym_L_SQUOTE] = ACTIONS(1034),
    [anon_sym_u_SQUOTE] = ACTIONS(1034),
    [anon_sym_U_SQUOTE] = ACTIONS(1034),
    [anon_sym_u8_SQUOTE] = ACTIONS(1034),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [anon_sym_L_DQUOTE] = ACTIONS(1034),
    [anon_sym_u_DQUOTE] = ACTIONS(1034),
    [anon_sym_U_DQUOTE] = ACTIONS(1034),
    [anon_sym_u8_DQUOTE] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [sym_true] = ACTIONS(1032),
    [sym_false] = ACTIONS(1032),
    [sym_null] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [sym_identifier] = ACTIONS(1028),
    [aux_sym_preproc_include_token1] = ACTIONS(1028),
    [aux_sym_preproc_def_token1] = ACTIONS(1028),
    [aux_sym_preproc_if_token1] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1028),
    [sym_preproc_directive] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1030),
    [anon_sym_BANG] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1028),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_AMP] = ACTIONS(1030),
    [anon_sym_SEMI] = ACTIONS(1030),
    [anon_sym_typedef] = ACTIONS(1028),
    [anon_sym_extern] = ACTIONS(1028),
    [anon_sym___attribute__] = ACTIONS(1028),
    [anon_sym___declspec] = ACTIONS(1028),
    [anon_sym___cdecl] = ACTIONS(1028),
    [anon_sym___clrcall] = ACTIONS(1028),
    [anon_sym___stdcall] = ACTIONS(1028),
    [anon_sym___fastcall] = ACTIONS(1028),
    [anon_sym___thiscall] = ACTIONS(1028),
    [anon_sym___vectorcall] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1030),
    [anon_sym_RBRACE] = ACTIONS(1030),
    [anon_sym_static] = ACTIONS(1028),
    [anon_sym_auto] = ACTIONS(1028),
    [anon_sym_register] = ACTIONS(1028),
    [anon_sym_inline] = ACTIONS(1028),
    [anon_sym_const] = ACTIONS(1028),
    [anon_sym_volatile] = ACTIONS(1028),
    [anon_sym_restrict] = ACTIONS(1028),
    [anon_sym__Atomic] = ACTIONS(1028),
    [anon_sym_signed] = ACTIONS(1028),
    [anon_sym_unsigned] = ACTIONS(1028),
    [anon_sym_long] = ACTIONS(1028),
    [anon_sym_short] = ACTIONS(1028),
    [sym_primitive_type] = ACTIONS(1028),
    [anon_sym_enum] = ACTIONS(1028),
    [anon_sym_struct] = ACTIONS(1028),
    [anon_sym_union] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1028),
    [anon_sym_switch] = ACTIONS(1028),
    [anon_sym_case] = ACTIONS(1028),
    [anon_sym_default] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_goto] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1030),
    [anon_sym_sizeof] = ACTIONS(1028),
    [sym_number_literal] = ACTIONS(1030),
    [anon_sym_L_SQUOTE] = ACTIONS(1030),
    [anon_sym_u_SQUOTE] = ACTIONS(1030),
    [anon_sym_U_SQUOTE] = ACTIONS(1030),
    [anon_sym_u8_SQUOTE] = ACTIONS(1030),
    [anon_sym_SQUOTE] = ACTIONS(1030),
    [anon_sym_L_DQUOTE] = ACTIONS(1030),
    [anon_sym_u_DQUOTE] = ACTIONS(1030),
    [anon_sym_U_DQUOTE] = ACTIONS(1030),
    [anon_sym_u8_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [sym_true] = ACTIONS(1028),
    [sym_false] = ACTIONS(1028),
    [sym_null] = ACTIONS(1028),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [sym_identifier] = ACTIONS(1100),
    [aux_sym_preproc_include_token1] = ACTIONS(1100),
    [aux_sym_preproc_def_token1] = ACTIONS(1100),
    [aux_sym_preproc_if_token1] = ACTIONS(1100),
    [aux_sym_preproc_if_token2] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1100),
    [sym_preproc_directive] = ACTIONS(1100),
    [anon_sym_LPAREN2] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_AMP] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_typedef] = ACTIONS(1100),
    [anon_sym_extern] = ACTIONS(1100),
    [anon_sym___attribute__] = ACTIONS(1100),
    [anon_sym___declspec] = ACTIONS(1100),
    [anon_sym___cdecl] = ACTIONS(1100),
    [anon_sym___clrcall] = ACTIONS(1100),
    [anon_sym___stdcall] = ACTIONS(1100),
    [anon_sym___fastcall] = ACTIONS(1100),
    [anon_sym___thiscall] = ACTIONS(1100),
    [anon_sym___vectorcall] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1100),
    [anon_sym_auto] = ACTIONS(1100),
    [anon_sym_register] = ACTIONS(1100),
    [anon_sym_inline] = ACTIONS(1100),
    [anon_sym_const] = ACTIONS(1100),
    [anon_sym_volatile] = ACTIONS(1100),
    [anon_sym_restrict] = ACTIONS(1100),
    [anon_sym__Atomic] = ACTIONS(1100),
    [anon_sym_signed] = ACTIONS(1100),
    [anon_sym_unsigned] = ACTIONS(1100),
    [anon_sym_long] = ACTIONS(1100),
    [anon_sym_short] = ACTIONS(1100),
    [sym_primitive_type] = ACTIONS(1100),
    [anon_sym_enum] = ACTIONS(1100),
    [anon_sym_struct] = ACTIONS(1100),
    [anon_sym_union] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_switch] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_do] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_goto] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_sizeof] = ACTIONS(1100),
    [sym_number_literal] = ACTIONS(1102),
    [anon_sym_L_SQUOTE] = ACTIONS(1102),
    [anon_sym_u_SQUOTE] = ACTIONS(1102),
    [anon_sym_U_SQUOTE] = ACTIONS(1102),
    [anon_sym_u8_SQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [anon_sym_L_DQUOTE] = ACTIONS(1102),
    [anon_sym_u_DQUOTE] = ACTIONS(1102),
    [anon_sym_U_DQUOTE] = ACTIONS(1102),
    [anon_sym_u8_DQUOTE] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_null] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym_identifier] = ACTIONS(1024),
    [aux_sym_preproc_include_token1] = ACTIONS(1024),
    [aux_sym_preproc_def_token1] = ACTIONS(1024),
    [aux_sym_preproc_if_token1] = ACTIONS(1024),
    [aux_sym_preproc_if_token2] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1024),
    [sym_preproc_directive] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1026),
    [anon_sym_TILDE] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_AMP] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1026),
    [anon_sym_typedef] = ACTIONS(1024),
    [anon_sym_extern] = ACTIONS(1024),
    [anon_sym___attribute__] = ACTIONS(1024),
    [anon_sym___declspec] = ACTIONS(1024),
    [anon_sym___cdecl] = ACTIONS(1024),
    [anon_sym___clrcall] = ACTIONS(1024),
    [anon_sym___stdcall] = ACTIONS(1024),
    [anon_sym___fastcall] = ACTIONS(1024),
    [anon_sym___thiscall] = ACTIONS(1024),
    [anon_sym___vectorcall] = ACTIONS(1024),
    [anon_sym_LBRACE] = ACTIONS(1026),
    [anon_sym_static] = ACTIONS(1024),
    [anon_sym_auto] = ACTIONS(1024),
    [anon_sym_register] = ACTIONS(1024),
    [anon_sym_inline] = ACTIONS(1024),
    [anon_sym_const] = ACTIONS(1024),
    [anon_sym_volatile] = ACTIONS(1024),
    [anon_sym_restrict] = ACTIONS(1024),
    [anon_sym__Atomic] = ACTIONS(1024),
    [anon_sym_signed] = ACTIONS(1024),
    [anon_sym_unsigned] = ACTIONS(1024),
    [anon_sym_long] = ACTIONS(1024),
    [anon_sym_short] = ACTIONS(1024),
    [sym_primitive_type] = ACTIONS(1024),
    [anon_sym_enum] = ACTIONS(1024),
    [anon_sym_struct] = ACTIONS(1024),
    [anon_sym_union] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1024),
    [anon_sym_switch] = ACTIONS(1024),
    [anon_sym_case] = ACTIONS(1024),
    [anon_sym_default] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_do] = ACTIONS(1024),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_goto] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_sizeof] = ACTIONS(1024),
    [sym_number_literal] = ACTIONS(1026),
    [anon_sym_L_SQUOTE] = ACTIONS(1026),
    [anon_sym_u_SQUOTE] = ACTIONS(1026),
    [anon_sym_U_SQUOTE] = ACTIONS(1026),
    [anon_sym_u8_SQUOTE] = ACTIONS(1026),
    [anon_sym_SQUOTE] = ACTIONS(1026),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1024),
    [sym_false] = ACTIONS(1024),
    [sym_null] = ACTIONS(1024),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [sym_identifier] = ACTIONS(1056),
    [aux_sym_preproc_include_token1] = ACTIONS(1056),
    [aux_sym_preproc_def_token1] = ACTIONS(1056),
    [aux_sym_preproc_if_token1] = ACTIONS(1056),
    [aux_sym_preproc_if_token2] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1056),
    [sym_preproc_directive] = ACTIONS(1056),
    [anon_sym_LPAREN2] = ACTIONS(1058),
    [anon_sym_BANG] = ACTIONS(1058),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1056),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_AMP] = ACTIONS(1058),
    [anon_sym_SEMI] = ACTIONS(1058),
    [anon_sym_typedef] = ACTIONS(1056),
    [anon_sym_extern] = ACTIONS(1056),
    [anon_sym___attribute__] = ACTIONS(1056),
    [anon_sym___declspec] = ACTIONS(1056),
    [anon_sym___cdecl] = ACTIONS(1056),
    [anon_sym___clrcall] = ACTIONS(1056),
    [anon_sym___stdcall] = ACTIONS(1056),
    [anon_sym___fastcall] = ACTIONS(1056),
    [anon_sym___thiscall] = ACTIONS(1056),
    [anon_sym___vectorcall] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_auto] = ACTIONS(1056),
    [anon_sym_register] = ACTIONS(1056),
    [anon_sym_inline] = ACTIONS(1056),
    [anon_sym_const] = ACTIONS(1056),
    [anon_sym_volatile] = ACTIONS(1056),
    [anon_sym_restrict] = ACTIONS(1056),
    [anon_sym__Atomic] = ACTIONS(1056),
    [anon_sym_signed] = ACTIONS(1056),
    [anon_sym_unsigned] = ACTIONS(1056),
    [anon_sym_long] = ACTIONS(1056),
    [anon_sym_short] = ACTIONS(1056),
    [sym_primitive_type] = ACTIONS(1056),
    [anon_sym_enum] = ACTIONS(1056),
    [anon_sym_struct] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_switch] = ACTIONS(1056),
    [anon_sym_case] = ACTIONS(1056),
    [anon_sym_default] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_do] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_goto] = ACTIONS(1056),
    [anon_sym_DASH_DASH] = ACTIONS(1058),
    [anon_sym_PLUS_PLUS] = ACTIONS(1058),
    [anon_sym_sizeof] = ACTIONS(1056),
    [sym_number_literal] = ACTIONS(1058),
    [anon_sym_L_SQUOTE] = ACTIONS(1058),
    [anon_sym_u_SQUOTE] = ACTIONS(1058),
    [anon_sym_U_SQUOTE] = ACTIONS(1058),
    [anon_sym_u8_SQUOTE] = ACTIONS(1058),
    [anon_sym_SQUOTE] = ACTIONS(1058),
    [anon_sym_L_DQUOTE] = ACTIONS(1058),
    [anon_sym_u_DQUOTE] = ACTIONS(1058),
    [anon_sym_U_DQUOTE] = ACTIONS(1058),
    [anon_sym_u8_DQUOTE] = ACTIONS(1058),
    [anon_sym_DQUOTE] = ACTIONS(1058),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_null] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
  },
  [247] = {
    [sym_identifier] = ACTIONS(1032),
    [aux_sym_preproc_include_token1] = ACTIONS(1032),
    [aux_sym_preproc_def_token1] = ACTIONS(1032),
    [aux_sym_preproc_if_token1] = ACTIONS(1032),
    [aux_sym_preproc_if_token2] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1032),
    [sym_preproc_directive] = ACTIONS(1032),
    [anon_sym_LPAREN2] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_STAR] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1034),
    [anon_sym_typedef] = ACTIONS(1032),
    [anon_sym_extern] = ACTIONS(1032),
    [anon_sym___attribute__] = ACTIONS(1032),
    [anon_sym___declspec] = ACTIONS(1032),
    [anon_sym___cdecl] = ACTIONS(1032),
    [anon_sym___clrcall] = ACTIONS(1032),
    [anon_sym___stdcall] = ACTIONS(1032),
    [anon_sym___fastcall] = ACTIONS(1032),
    [anon_sym___thiscall] = ACTIONS(1032),
    [anon_sym___vectorcall] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_static] = ACTIONS(1032),
    [anon_sym_auto] = ACTIONS(1032),
    [anon_sym_register] = ACTIONS(1032),
    [anon_sym_inline] = ACTIONS(1032),
    [anon_sym_const] = ACTIONS(1032),
    [anon_sym_volatile] = ACTIONS(1032),
    [anon_sym_restrict] = ACTIONS(1032),
    [anon_sym__Atomic] = ACTIONS(1032),
    [anon_sym_signed] = ACTIONS(1032),
    [anon_sym_unsigned] = ACTIONS(1032),
    [anon_sym_long] = ACTIONS(1032),
    [anon_sym_short] = ACTIONS(1032),
    [sym_primitive_type] = ACTIONS(1032),
    [anon_sym_enum] = ACTIONS(1032),
    [anon_sym_struct] = ACTIONS(1032),
    [anon_sym_union] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(1032),
    [anon_sym_default] = ACTIONS(1032),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_do] = ACTIONS(1032),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_goto] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1034),
    [anon_sym_PLUS_PLUS] = ACTIONS(1034),
    [anon_sym_sizeof] = ACTIONS(1032),
    [sym_number_literal] = ACTIONS(1034),
    [anon_sym_L_SQUOTE] = ACTIONS(1034),
    [anon_sym_u_SQUOTE] = ACTIONS(1034),
    [anon_sym_U_SQUOTE] = ACTIONS(1034),
    [anon_sym_u8_SQUOTE] = ACTIONS(1034),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [anon_sym_L_DQUOTE] = ACTIONS(1034),
    [anon_sym_u_DQUOTE] = ACTIONS(1034),
    [anon_sym_U_DQUOTE] = ACTIONS(1034),
    [anon_sym_u8_DQUOTE] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [sym_true] = ACTIONS(1032),
    [sym_false] = ACTIONS(1032),
    [sym_null] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [248] = {
    [sym_identifier] = ACTIONS(1040),
    [aux_sym_preproc_include_token1] = ACTIONS(1040),
    [aux_sym_preproc_def_token1] = ACTIONS(1040),
    [aux_sym_preproc_if_token1] = ACTIONS(1040),
    [aux_sym_preproc_if_token2] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1040),
    [sym_preproc_directive] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_typedef] = ACTIONS(1040),
    [anon_sym_extern] = ACTIONS(1040),
    [anon_sym___attribute__] = ACTIONS(1040),
    [anon_sym___declspec] = ACTIONS(1040),
    [anon_sym___cdecl] = ACTIONS(1040),
    [anon_sym___clrcall] = ACTIONS(1040),
    [anon_sym___stdcall] = ACTIONS(1040),
    [anon_sym___fastcall] = ACTIONS(1040),
    [anon_sym___thiscall] = ACTIONS(1040),
    [anon_sym___vectorcall] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1040),
    [anon_sym_auto] = ACTIONS(1040),
    [anon_sym_register] = ACTIONS(1040),
    [anon_sym_inline] = ACTIONS(1040),
    [anon_sym_const] = ACTIONS(1040),
    [anon_sym_volatile] = ACTIONS(1040),
    [anon_sym_restrict] = ACTIONS(1040),
    [anon_sym__Atomic] = ACTIONS(1040),
    [anon_sym_signed] = ACTIONS(1040),
    [anon_sym_unsigned] = ACTIONS(1040),
    [anon_sym_long] = ACTIONS(1040),
    [anon_sym_short] = ACTIONS(1040),
    [sym_primitive_type] = ACTIONS(1040),
    [anon_sym_enum] = ACTIONS(1040),
    [anon_sym_struct] = ACTIONS(1040),
    [anon_sym_union] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1040),
    [anon_sym_case] = ACTIONS(1040),
    [anon_sym_default] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_goto] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1042),
    [anon_sym_sizeof] = ACTIONS(1040),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_L_SQUOTE] = ACTIONS(1042),
    [anon_sym_u_SQUOTE] = ACTIONS(1042),
    [anon_sym_U_SQUOTE] = ACTIONS(1042),
    [anon_sym_u8_SQUOTE] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(1042),
    [anon_sym_L_DQUOTE] = ACTIONS(1042),
    [anon_sym_u_DQUOTE] = ACTIONS(1042),
    [anon_sym_U_DQUOTE] = ACTIONS(1042),
    [anon_sym_u8_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [sym_identifier] = ACTIONS(1072),
    [aux_sym_preproc_include_token1] = ACTIONS(1072),
    [aux_sym_preproc_def_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token2] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1072),
    [sym_preproc_directive] = ACTIONS(1072),
    [anon_sym_LPAREN2] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_typedef] = ACTIONS(1072),
    [anon_sym_extern] = ACTIONS(1072),
    [anon_sym___attribute__] = ACTIONS(1072),
    [anon_sym___declspec] = ACTIONS(1072),
    [anon_sym___cdecl] = ACTIONS(1072),
    [anon_sym___clrcall] = ACTIONS(1072),
    [anon_sym___stdcall] = ACTIONS(1072),
    [anon_sym___fastcall] = ACTIONS(1072),
    [anon_sym___thiscall] = ACTIONS(1072),
    [anon_sym___vectorcall] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_auto] = ACTIONS(1072),
    [anon_sym_register] = ACTIONS(1072),
    [anon_sym_inline] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_volatile] = ACTIONS(1072),
    [anon_sym_restrict] = ACTIONS(1072),
    [anon_sym__Atomic] = ACTIONS(1072),
    [anon_sym_signed] = ACTIONS(1072),
    [anon_sym_unsigned] = ACTIONS(1072),
    [anon_sym_long] = ACTIONS(1072),
    [anon_sym_short] = ACTIONS(1072),
    [sym_primitive_type] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1072),
    [anon_sym_union] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1072),
    [anon_sym_default] = ACTIONS(1072),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_do] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_goto] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_sizeof] = ACTIONS(1072),
    [sym_number_literal] = ACTIONS(1074),
    [anon_sym_L_SQUOTE] = ACTIONS(1074),
    [anon_sym_u_SQUOTE] = ACTIONS(1074),
    [anon_sym_U_SQUOTE] = ACTIONS(1074),
    [anon_sym_u8_SQUOTE] = ACTIONS(1074),
    [anon_sym_SQUOTE] = ACTIONS(1074),
    [anon_sym_L_DQUOTE] = ACTIONS(1074),
    [anon_sym_u_DQUOTE] = ACTIONS(1074),
    [anon_sym_U_DQUOTE] = ACTIONS(1074),
    [anon_sym_u8_DQUOTE] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_null] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
  },
  [250] = {
    [ts_builtin_sym_end] = ACTIONS(1086),
    [sym_identifier] = ACTIONS(1084),
    [aux_sym_preproc_include_token1] = ACTIONS(1084),
    [aux_sym_preproc_def_token1] = ACTIONS(1084),
    [aux_sym_preproc_if_token1] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1084),
    [sym_preproc_directive] = ACTIONS(1084),
    [anon_sym_LPAREN2] = ACTIONS(1086),
    [anon_sym_BANG] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_STAR] = ACTIONS(1086),
    [anon_sym_AMP] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_typedef] = ACTIONS(1084),
    [anon_sym_extern] = ACTIONS(1084),
    [anon_sym___attribute__] = ACTIONS(1084),
    [anon_sym___declspec] = ACTIONS(1084),
    [anon_sym___cdecl] = ACTIONS(1084),
    [anon_sym___clrcall] = ACTIONS(1084),
    [anon_sym___stdcall] = ACTIONS(1084),
    [anon_sym___fastcall] = ACTIONS(1084),
    [anon_sym___thiscall] = ACTIONS(1084),
    [anon_sym___vectorcall] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_static] = ACTIONS(1084),
    [anon_sym_auto] = ACTIONS(1084),
    [anon_sym_register] = ACTIONS(1084),
    [anon_sym_inline] = ACTIONS(1084),
    [anon_sym_const] = ACTIONS(1084),
    [anon_sym_volatile] = ACTIONS(1084),
    [anon_sym_restrict] = ACTIONS(1084),
    [anon_sym__Atomic] = ACTIONS(1084),
    [anon_sym_signed] = ACTIONS(1084),
    [anon_sym_unsigned] = ACTIONS(1084),
    [anon_sym_long] = ACTIONS(1084),
    [anon_sym_short] = ACTIONS(1084),
    [sym_primitive_type] = ACTIONS(1084),
    [anon_sym_enum] = ACTIONS(1084),
    [anon_sym_struct] = ACTIONS(1084),
    [anon_sym_union] = ACTIONS(1084),
    [anon_sym_if] = ACTIONS(1084),
    [anon_sym_switch] = ACTIONS(1084),
    [anon_sym_case] = ACTIONS(1084),
    [anon_sym_default] = ACTIONS(1084),
    [anon_sym_while] = ACTIONS(1084),
    [anon_sym_do] = ACTIONS(1084),
    [anon_sym_for] = ACTIONS(1084),
    [anon_sym_return] = ACTIONS(1084),
    [anon_sym_break] = ACTIONS(1084),
    [anon_sym_continue] = ACTIONS(1084),
    [anon_sym_goto] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1084),
    [sym_number_literal] = ACTIONS(1086),
    [anon_sym_L_SQUOTE] = ACTIONS(1086),
    [anon_sym_u_SQUOTE] = ACTIONS(1086),
    [anon_sym_U_SQUOTE] = ACTIONS(1086),
    [anon_sym_u8_SQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1086),
    [anon_sym_L_DQUOTE] = ACTIONS(1086),
    [anon_sym_u_DQUOTE] = ACTIONS(1086),
    [anon_sym_U_DQUOTE] = ACTIONS(1086),
    [anon_sym_u8_DQUOTE] = ACTIONS(1086),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [sym_true] = ACTIONS(1084),
    [sym_false] = ACTIONS(1084),
    [sym_null] = ACTIONS(1084),
    [sym_comment] = ACTIONS(3),
  },
  [251] = {
    [sym_identifier] = ACTIONS(1040),
    [aux_sym_preproc_include_token1] = ACTIONS(1040),
    [aux_sym_preproc_def_token1] = ACTIONS(1040),
    [aux_sym_preproc_if_token1] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1040),
    [sym_preproc_directive] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_typedef] = ACTIONS(1040),
    [anon_sym_extern] = ACTIONS(1040),
    [anon_sym___attribute__] = ACTIONS(1040),
    [anon_sym___declspec] = ACTIONS(1040),
    [anon_sym___cdecl] = ACTIONS(1040),
    [anon_sym___clrcall] = ACTIONS(1040),
    [anon_sym___stdcall] = ACTIONS(1040),
    [anon_sym___fastcall] = ACTIONS(1040),
    [anon_sym___thiscall] = ACTIONS(1040),
    [anon_sym___vectorcall] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_RBRACE] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1040),
    [anon_sym_auto] = ACTIONS(1040),
    [anon_sym_register] = ACTIONS(1040),
    [anon_sym_inline] = ACTIONS(1040),
    [anon_sym_const] = ACTIONS(1040),
    [anon_sym_volatile] = ACTIONS(1040),
    [anon_sym_restrict] = ACTIONS(1040),
    [anon_sym__Atomic] = ACTIONS(1040),
    [anon_sym_signed] = ACTIONS(1040),
    [anon_sym_unsigned] = ACTIONS(1040),
    [anon_sym_long] = ACTIONS(1040),
    [anon_sym_short] = ACTIONS(1040),
    [sym_primitive_type] = ACTIONS(1040),
    [anon_sym_enum] = ACTIONS(1040),
    [anon_sym_struct] = ACTIONS(1040),
    [anon_sym_union] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1040),
    [anon_sym_case] = ACTIONS(1040),
    [anon_sym_default] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_goto] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1042),
    [anon_sym_sizeof] = ACTIONS(1040),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_L_SQUOTE] = ACTIONS(1042),
    [anon_sym_u_SQUOTE] = ACTIONS(1042),
    [anon_sym_U_SQUOTE] = ACTIONS(1042),
    [anon_sym_u8_SQUOTE] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(1042),
    [anon_sym_L_DQUOTE] = ACTIONS(1042),
    [anon_sym_u_DQUOTE] = ACTIONS(1042),
    [anon_sym_U_DQUOTE] = ACTIONS(1042),
    [anon_sym_u8_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
  },
  [252] = {
    [sym_identifier] = ACTIONS(1024),
    [aux_sym_preproc_include_token1] = ACTIONS(1024),
    [aux_sym_preproc_def_token1] = ACTIONS(1024),
    [aux_sym_preproc_if_token1] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1024),
    [sym_preproc_directive] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1026),
    [anon_sym_TILDE] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_AMP] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1026),
    [anon_sym_typedef] = ACTIONS(1024),
    [anon_sym_extern] = ACTIONS(1024),
    [anon_sym___attribute__] = ACTIONS(1024),
    [anon_sym___declspec] = ACTIONS(1024),
    [anon_sym___cdecl] = ACTIONS(1024),
    [anon_sym___clrcall] = ACTIONS(1024),
    [anon_sym___stdcall] = ACTIONS(1024),
    [anon_sym___fastcall] = ACTIONS(1024),
    [anon_sym___thiscall] = ACTIONS(1024),
    [anon_sym___vectorcall] = ACTIONS(1024),
    [anon_sym_LBRACE] = ACTIONS(1026),
    [anon_sym_RBRACE] = ACTIONS(1026),
    [anon_sym_static] = ACTIONS(1024),
    [anon_sym_auto] = ACTIONS(1024),
    [anon_sym_register] = ACTIONS(1024),
    [anon_sym_inline] = ACTIONS(1024),
    [anon_sym_const] = ACTIONS(1024),
    [anon_sym_volatile] = ACTIONS(1024),
    [anon_sym_restrict] = ACTIONS(1024),
    [anon_sym__Atomic] = ACTIONS(1024),
    [anon_sym_signed] = ACTIONS(1024),
    [anon_sym_unsigned] = ACTIONS(1024),
    [anon_sym_long] = ACTIONS(1024),
    [anon_sym_short] = ACTIONS(1024),
    [sym_primitive_type] = ACTIONS(1024),
    [anon_sym_enum] = ACTIONS(1024),
    [anon_sym_struct] = ACTIONS(1024),
    [anon_sym_union] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1024),
    [anon_sym_switch] = ACTIONS(1024),
    [anon_sym_case] = ACTIONS(1024),
    [anon_sym_default] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_do] = ACTIONS(1024),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_goto] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_sizeof] = ACTIONS(1024),
    [sym_number_literal] = ACTIONS(1026),
    [anon_sym_L_SQUOTE] = ACTIONS(1026),
    [anon_sym_u_SQUOTE] = ACTIONS(1026),
    [anon_sym_U_SQUOTE] = ACTIONS(1026),
    [anon_sym_u8_SQUOTE] = ACTIONS(1026),
    [anon_sym_SQUOTE] = ACTIONS(1026),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1024),
    [sym_false] = ACTIONS(1024),
    [sym_null] = ACTIONS(1024),
    [sym_comment] = ACTIONS(3),
  },
  [253] = {
    [sym_identifier] = ACTIONS(1092),
    [aux_sym_preproc_include_token1] = ACTIONS(1092),
    [aux_sym_preproc_def_token1] = ACTIONS(1092),
    [aux_sym_preproc_if_token1] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1092),
    [sym_preproc_directive] = ACTIONS(1092),
    [anon_sym_LPAREN2] = ACTIONS(1094),
    [anon_sym_BANG] = ACTIONS(1094),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1094),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_SEMI] = ACTIONS(1094),
    [anon_sym_typedef] = ACTIONS(1092),
    [anon_sym_extern] = ACTIONS(1092),
    [anon_sym___attribute__] = ACTIONS(1092),
    [anon_sym___declspec] = ACTIONS(1092),
    [anon_sym___cdecl] = ACTIONS(1092),
    [anon_sym___clrcall] = ACTIONS(1092),
    [anon_sym___stdcall] = ACTIONS(1092),
    [anon_sym___fastcall] = ACTIONS(1092),
    [anon_sym___thiscall] = ACTIONS(1092),
    [anon_sym___vectorcall] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_RBRACE] = ACTIONS(1094),
    [anon_sym_static] = ACTIONS(1092),
    [anon_sym_auto] = ACTIONS(1092),
    [anon_sym_register] = ACTIONS(1092),
    [anon_sym_inline] = ACTIONS(1092),
    [anon_sym_const] = ACTIONS(1092),
    [anon_sym_volatile] = ACTIONS(1092),
    [anon_sym_restrict] = ACTIONS(1092),
    [anon_sym__Atomic] = ACTIONS(1092),
    [anon_sym_signed] = ACTIONS(1092),
    [anon_sym_unsigned] = ACTIONS(1092),
    [anon_sym_long] = ACTIONS(1092),
    [anon_sym_short] = ACTIONS(1092),
    [sym_primitive_type] = ACTIONS(1092),
    [anon_sym_enum] = ACTIONS(1092),
    [anon_sym_struct] = ACTIONS(1092),
    [anon_sym_union] = ACTIONS(1092),
    [anon_sym_if] = ACTIONS(1092),
    [anon_sym_switch] = ACTIONS(1092),
    [anon_sym_case] = ACTIONS(1092),
    [anon_sym_default] = ACTIONS(1092),
    [anon_sym_while] = ACTIONS(1092),
    [anon_sym_do] = ACTIONS(1092),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(1092),
    [anon_sym_break] = ACTIONS(1092),
    [anon_sym_continue] = ACTIONS(1092),
    [anon_sym_goto] = ACTIONS(1092),
    [anon_sym_DASH_DASH] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1094),
    [anon_sym_sizeof] = ACTIONS(1092),
    [sym_number_literal] = ACTIONS(1094),
    [anon_sym_L_SQUOTE] = ACTIONS(1094),
    [anon_sym_u_SQUOTE] = ACTIONS(1094),
    [anon_sym_U_SQUOTE] = ACTIONS(1094),
    [anon_sym_u8_SQUOTE] = ACTIONS(1094),
    [anon_sym_SQUOTE] = ACTIONS(1094),
    [anon_sym_L_DQUOTE] = ACTIONS(1094),
    [anon_sym_u_DQUOTE] = ACTIONS(1094),
    [anon_sym_U_DQUOTE] = ACTIONS(1094),
    [anon_sym_u8_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE] = ACTIONS(1094),
    [sym_true] = ACTIONS(1092),
    [sym_false] = ACTIONS(1092),
    [sym_null] = ACTIONS(1092),
    [sym_comment] = ACTIONS(3),
  },
  [254] = {
    [ts_builtin_sym_end] = ACTIONS(1038),
    [sym_identifier] = ACTIONS(1036),
    [aux_sym_preproc_include_token1] = ACTIONS(1036),
    [aux_sym_preproc_def_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1036),
    [sym_preproc_directive] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_typedef] = ACTIONS(1036),
    [anon_sym_extern] = ACTIONS(1036),
    [anon_sym___attribute__] = ACTIONS(1036),
    [anon_sym___declspec] = ACTIONS(1036),
    [anon_sym___cdecl] = ACTIONS(1036),
    [anon_sym___clrcall] = ACTIONS(1036),
    [anon_sym___stdcall] = ACTIONS(1036),
    [anon_sym___fastcall] = ACTIONS(1036),
    [anon_sym___thiscall] = ACTIONS(1036),
    [anon_sym___vectorcall] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_auto] = ACTIONS(1036),
    [anon_sym_register] = ACTIONS(1036),
    [anon_sym_inline] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_restrict] = ACTIONS(1036),
    [anon_sym__Atomic] = ACTIONS(1036),
    [anon_sym_signed] = ACTIONS(1036),
    [anon_sym_unsigned] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [sym_primitive_type] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_union] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_goto] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_sizeof] = ACTIONS(1036),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_L_SQUOTE] = ACTIONS(1038),
    [anon_sym_u_SQUOTE] = ACTIONS(1038),
    [anon_sym_U_SQUOTE] = ACTIONS(1038),
    [anon_sym_u8_SQUOTE] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_L_DQUOTE] = ACTIONS(1038),
    [anon_sym_u_DQUOTE] = ACTIONS(1038),
    [anon_sym_U_DQUOTE] = ACTIONS(1038),
    [anon_sym_u8_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
  },
  [255] = {
    [sym_identifier] = ACTIONS(1044),
    [aux_sym_preproc_include_token1] = ACTIONS(1044),
    [aux_sym_preproc_def_token1] = ACTIONS(1044),
    [aux_sym_preproc_if_token1] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1044),
    [sym_preproc_directive] = ACTIONS(1044),
    [anon_sym_LPAREN2] = ACTIONS(1046),
    [anon_sym_BANG] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1044),
    [anon_sym_STAR] = ACTIONS(1046),
    [anon_sym_AMP] = ACTIONS(1046),
    [anon_sym_SEMI] = ACTIONS(1046),
    [anon_sym_typedef] = ACTIONS(1044),
    [anon_sym_extern] = ACTIONS(1044),
    [anon_sym___attribute__] = ACTIONS(1044),
    [anon_sym___declspec] = ACTIONS(1044),
    [anon_sym___cdecl] = ACTIONS(1044),
    [anon_sym___clrcall] = ACTIONS(1044),
    [anon_sym___stdcall] = ACTIONS(1044),
    [anon_sym___fastcall] = ACTIONS(1044),
    [anon_sym___thiscall] = ACTIONS(1044),
    [anon_sym___vectorcall] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [anon_sym_RBRACE] = ACTIONS(1046),
    [anon_sym_static] = ACTIONS(1044),
    [anon_sym_auto] = ACTIONS(1044),
    [anon_sym_register] = ACTIONS(1044),
    [anon_sym_inline] = ACTIONS(1044),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym_signed] = ACTIONS(1044),
    [anon_sym_unsigned] = ACTIONS(1044),
    [anon_sym_long] = ACTIONS(1044),
    [anon_sym_short] = ACTIONS(1044),
    [sym_primitive_type] = ACTIONS(1044),
    [anon_sym_enum] = ACTIONS(1044),
    [anon_sym_struct] = ACTIONS(1044),
    [anon_sym_union] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1044),
    [anon_sym_switch] = ACTIONS(1044),
    [anon_sym_case] = ACTIONS(1044),
    [anon_sym_default] = ACTIONS(1044),
    [anon_sym_while] = ACTIONS(1044),
    [anon_sym_do] = ACTIONS(1044),
    [anon_sym_for] = ACTIONS(1044),
    [anon_sym_return] = ACTIONS(1044),
    [anon_sym_break] = ACTIONS(1044),
    [anon_sym_continue] = ACTIONS(1044),
    [anon_sym_goto] = ACTIONS(1044),
    [anon_sym_DASH_DASH] = ACTIONS(1046),
    [anon_sym_PLUS_PLUS] = ACTIONS(1046),
    [anon_sym_sizeof] = ACTIONS(1044),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_L_SQUOTE] = ACTIONS(1046),
    [anon_sym_u_SQUOTE] = ACTIONS(1046),
    [anon_sym_U_SQUOTE] = ACTIONS(1046),
    [anon_sym_u8_SQUOTE] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(1046),
    [anon_sym_L_DQUOTE] = ACTIONS(1046),
    [anon_sym_u_DQUOTE] = ACTIONS(1046),
    [anon_sym_U_DQUOTE] = ACTIONS(1046),
    [anon_sym_u8_DQUOTE] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_comment] = ACTIONS(3),
  },
  [256] = {
    [ts_builtin_sym_end] = ACTIONS(1078),
    [sym_identifier] = ACTIONS(1076),
    [aux_sym_preproc_include_token1] = ACTIONS(1076),
    [aux_sym_preproc_def_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1076),
    [sym_preproc_directive] = ACTIONS(1076),
    [anon_sym_LPAREN2] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1078),
    [anon_sym_typedef] = ACTIONS(1076),
    [anon_sym_extern] = ACTIONS(1076),
    [anon_sym___attribute__] = ACTIONS(1076),
    [anon_sym___declspec] = ACTIONS(1076),
    [anon_sym___cdecl] = ACTIONS(1076),
    [anon_sym___clrcall] = ACTIONS(1076),
    [anon_sym___stdcall] = ACTIONS(1076),
    [anon_sym___fastcall] = ACTIONS(1076),
    [anon_sym___thiscall] = ACTIONS(1076),
    [anon_sym___vectorcall] = ACTIONS(1076),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_auto] = ACTIONS(1076),
    [anon_sym_register] = ACTIONS(1076),
    [anon_sym_inline] = ACTIONS(1076),
    [anon_sym_const] = ACTIONS(1076),
    [anon_sym_volatile] = ACTIONS(1076),
    [anon_sym_restrict] = ACTIONS(1076),
    [anon_sym__Atomic] = ACTIONS(1076),
    [anon_sym_signed] = ACTIONS(1076),
    [anon_sym_unsigned] = ACTIONS(1076),
    [anon_sym_long] = ACTIONS(1076),
    [anon_sym_short] = ACTIONS(1076),
    [sym_primitive_type] = ACTIONS(1076),
    [anon_sym_enum] = ACTIONS(1076),
    [anon_sym_struct] = ACTIONS(1076),
    [anon_sym_union] = ACTIONS(1076),
    [anon_sym_if] = ACTIONS(1076),
    [anon_sym_switch] = ACTIONS(1076),
    [anon_sym_case] = ACTIONS(1076),
    [anon_sym_default] = ACTIONS(1076),
    [anon_sym_while] = ACTIONS(1076),
    [anon_sym_do] = ACTIONS(1076),
    [anon_sym_for] = ACTIONS(1076),
    [anon_sym_return] = ACTIONS(1076),
    [anon_sym_break] = ACTIONS(1076),
    [anon_sym_continue] = ACTIONS(1076),
    [anon_sym_goto] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1078),
    [anon_sym_sizeof] = ACTIONS(1076),
    [sym_number_literal] = ACTIONS(1078),
    [anon_sym_L_SQUOTE] = ACTIONS(1078),
    [anon_sym_u_SQUOTE] = ACTIONS(1078),
    [anon_sym_U_SQUOTE] = ACTIONS(1078),
    [anon_sym_u8_SQUOTE] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [anon_sym_L_DQUOTE] = ACTIONS(1078),
    [anon_sym_u_DQUOTE] = ACTIONS(1078),
    [anon_sym_U_DQUOTE] = ACTIONS(1078),
    [anon_sym_u8_DQUOTE] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [sym_true] = ACTIONS(1076),
    [sym_false] = ACTIONS(1076),
    [sym_null] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym_identifier] = ACTIONS(1088),
    [aux_sym_preproc_include_token1] = ACTIONS(1088),
    [aux_sym_preproc_def_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1088),
    [sym_preproc_directive] = ACTIONS(1088),
    [anon_sym_LPAREN2] = ACTIONS(1090),
    [anon_sym_BANG] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_STAR] = ACTIONS(1090),
    [anon_sym_AMP] = ACTIONS(1090),
    [anon_sym_SEMI] = ACTIONS(1090),
    [anon_sym_typedef] = ACTIONS(1088),
    [anon_sym_extern] = ACTIONS(1088),
    [anon_sym___attribute__] = ACTIONS(1088),
    [anon_sym___declspec] = ACTIONS(1088),
    [anon_sym___cdecl] = ACTIONS(1088),
    [anon_sym___clrcall] = ACTIONS(1088),
    [anon_sym___stdcall] = ACTIONS(1088),
    [anon_sym___fastcall] = ACTIONS(1088),
    [anon_sym___thiscall] = ACTIONS(1088),
    [anon_sym___vectorcall] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_RBRACE] = ACTIONS(1090),
    [anon_sym_static] = ACTIONS(1088),
    [anon_sym_auto] = ACTIONS(1088),
    [anon_sym_register] = ACTIONS(1088),
    [anon_sym_inline] = ACTIONS(1088),
    [anon_sym_const] = ACTIONS(1088),
    [anon_sym_volatile] = ACTIONS(1088),
    [anon_sym_restrict] = ACTIONS(1088),
    [anon_sym__Atomic] = ACTIONS(1088),
    [anon_sym_signed] = ACTIONS(1088),
    [anon_sym_unsigned] = ACTIONS(1088),
    [anon_sym_long] = ACTIONS(1088),
    [anon_sym_short] = ACTIONS(1088),
    [sym_primitive_type] = ACTIONS(1088),
    [anon_sym_enum] = ACTIONS(1088),
    [anon_sym_struct] = ACTIONS(1088),
    [anon_sym_union] = ACTIONS(1088),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(1088),
    [anon_sym_case] = ACTIONS(1088),
    [anon_sym_default] = ACTIONS(1088),
    [anon_sym_while] = ACTIONS(1088),
    [anon_sym_do] = ACTIONS(1088),
    [anon_sym_for] = ACTIONS(1088),
    [anon_sym_return] = ACTIONS(1088),
    [anon_sym_break] = ACTIONS(1088),
    [anon_sym_continue] = ACTIONS(1088),
    [anon_sym_goto] = ACTIONS(1088),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_sizeof] = ACTIONS(1088),
    [sym_number_literal] = ACTIONS(1090),
    [anon_sym_L_SQUOTE] = ACTIONS(1090),
    [anon_sym_u_SQUOTE] = ACTIONS(1090),
    [anon_sym_U_SQUOTE] = ACTIONS(1090),
    [anon_sym_u8_SQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [anon_sym_L_DQUOTE] = ACTIONS(1090),
    [anon_sym_u_DQUOTE] = ACTIONS(1090),
    [anon_sym_U_DQUOTE] = ACTIONS(1090),
    [anon_sym_u8_DQUOTE] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [sym_true] = ACTIONS(1088),
    [sym_false] = ACTIONS(1088),
    [sym_null] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [sym_identifier] = ACTIONS(1028),
    [aux_sym_preproc_include_token1] = ACTIONS(1028),
    [aux_sym_preproc_def_token1] = ACTIONS(1028),
    [aux_sym_preproc_if_token1] = ACTIONS(1028),
    [aux_sym_preproc_if_token2] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1028),
    [sym_preproc_directive] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1030),
    [anon_sym_BANG] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1028),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_AMP] = ACTIONS(1030),
    [anon_sym_SEMI] = ACTIONS(1030),
    [anon_sym_typedef] = ACTIONS(1028),
    [anon_sym_extern] = ACTIONS(1028),
    [anon_sym___attribute__] = ACTIONS(1028),
    [anon_sym___declspec] = ACTIONS(1028),
    [anon_sym___cdecl] = ACTIONS(1028),
    [anon_sym___clrcall] = ACTIONS(1028),
    [anon_sym___stdcall] = ACTIONS(1028),
    [anon_sym___fastcall] = ACTIONS(1028),
    [anon_sym___thiscall] = ACTIONS(1028),
    [anon_sym___vectorcall] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1030),
    [anon_sym_static] = ACTIONS(1028),
    [anon_sym_auto] = ACTIONS(1028),
    [anon_sym_register] = ACTIONS(1028),
    [anon_sym_inline] = ACTIONS(1028),
    [anon_sym_const] = ACTIONS(1028),
    [anon_sym_volatile] = ACTIONS(1028),
    [anon_sym_restrict] = ACTIONS(1028),
    [anon_sym__Atomic] = ACTIONS(1028),
    [anon_sym_signed] = ACTIONS(1028),
    [anon_sym_unsigned] = ACTIONS(1028),
    [anon_sym_long] = ACTIONS(1028),
    [anon_sym_short] = ACTIONS(1028),
    [sym_primitive_type] = ACTIONS(1028),
    [anon_sym_enum] = ACTIONS(1028),
    [anon_sym_struct] = ACTIONS(1028),
    [anon_sym_union] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1028),
    [anon_sym_switch] = ACTIONS(1028),
    [anon_sym_case] = ACTIONS(1028),
    [anon_sym_default] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_goto] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1030),
    [anon_sym_sizeof] = ACTIONS(1028),
    [sym_number_literal] = ACTIONS(1030),
    [anon_sym_L_SQUOTE] = ACTIONS(1030),
    [anon_sym_u_SQUOTE] = ACTIONS(1030),
    [anon_sym_U_SQUOTE] = ACTIONS(1030),
    [anon_sym_u8_SQUOTE] = ACTIONS(1030),
    [anon_sym_SQUOTE] = ACTIONS(1030),
    [anon_sym_L_DQUOTE] = ACTIONS(1030),
    [anon_sym_u_DQUOTE] = ACTIONS(1030),
    [anon_sym_U_DQUOTE] = ACTIONS(1030),
    [anon_sym_u8_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [sym_true] = ACTIONS(1028),
    [sym_false] = ACTIONS(1028),
    [sym_null] = ACTIONS(1028),
    [sym_comment] = ACTIONS(3),
  },
  [259] = {
    [ts_builtin_sym_end] = ACTIONS(1094),
    [sym_identifier] = ACTIONS(1092),
    [aux_sym_preproc_include_token1] = ACTIONS(1092),
    [aux_sym_preproc_def_token1] = ACTIONS(1092),
    [aux_sym_preproc_if_token1] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1092),
    [sym_preproc_directive] = ACTIONS(1092),
    [anon_sym_LPAREN2] = ACTIONS(1094),
    [anon_sym_BANG] = ACTIONS(1094),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1094),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_SEMI] = ACTIONS(1094),
    [anon_sym_typedef] = ACTIONS(1092),
    [anon_sym_extern] = ACTIONS(1092),
    [anon_sym___attribute__] = ACTIONS(1092),
    [anon_sym___declspec] = ACTIONS(1092),
    [anon_sym___cdecl] = ACTIONS(1092),
    [anon_sym___clrcall] = ACTIONS(1092),
    [anon_sym___stdcall] = ACTIONS(1092),
    [anon_sym___fastcall] = ACTIONS(1092),
    [anon_sym___thiscall] = ACTIONS(1092),
    [anon_sym___vectorcall] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_static] = ACTIONS(1092),
    [anon_sym_auto] = ACTIONS(1092),
    [anon_sym_register] = ACTIONS(1092),
    [anon_sym_inline] = ACTIONS(1092),
    [anon_sym_const] = ACTIONS(1092),
    [anon_sym_volatile] = ACTIONS(1092),
    [anon_sym_restrict] = ACTIONS(1092),
    [anon_sym__Atomic] = ACTIONS(1092),
    [anon_sym_signed] = ACTIONS(1092),
    [anon_sym_unsigned] = ACTIONS(1092),
    [anon_sym_long] = ACTIONS(1092),
    [anon_sym_short] = ACTIONS(1092),
    [sym_primitive_type] = ACTIONS(1092),
    [anon_sym_enum] = ACTIONS(1092),
    [anon_sym_struct] = ACTIONS(1092),
    [anon_sym_union] = ACTIONS(1092),
    [anon_sym_if] = ACTIONS(1092),
    [anon_sym_switch] = ACTIONS(1092),
    [anon_sym_case] = ACTIONS(1092),
    [anon_sym_default] = ACTIONS(1092),
    [anon_sym_while] = ACTIONS(1092),
    [anon_sym_do] = ACTIONS(1092),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(1092),
    [anon_sym_break] = ACTIONS(1092),
    [anon_sym_continue] = ACTIONS(1092),
    [anon_sym_goto] = ACTIONS(1092),
    [anon_sym_DASH_DASH] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1094),
    [anon_sym_sizeof] = ACTIONS(1092),
    [sym_number_literal] = ACTIONS(1094),
    [anon_sym_L_SQUOTE] = ACTIONS(1094),
    [anon_sym_u_SQUOTE] = ACTIONS(1094),
    [anon_sym_U_SQUOTE] = ACTIONS(1094),
    [anon_sym_u8_SQUOTE] = ACTIONS(1094),
    [anon_sym_SQUOTE] = ACTIONS(1094),
    [anon_sym_L_DQUOTE] = ACTIONS(1094),
    [anon_sym_u_DQUOTE] = ACTIONS(1094),
    [anon_sym_U_DQUOTE] = ACTIONS(1094),
    [anon_sym_u8_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE] = ACTIONS(1094),
    [sym_true] = ACTIONS(1092),
    [sym_false] = ACTIONS(1092),
    [sym_null] = ACTIONS(1092),
    [sym_comment] = ACTIONS(3),
  },
  [260] = {
    [sym_identifier] = ACTIONS(1064),
    [aux_sym_preproc_include_token1] = ACTIONS(1064),
    [aux_sym_preproc_def_token1] = ACTIONS(1064),
    [aux_sym_preproc_if_token1] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1064),
    [sym_preproc_directive] = ACTIONS(1064),
    [anon_sym_LPAREN2] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_AMP] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1066),
    [anon_sym_typedef] = ACTIONS(1064),
    [anon_sym_extern] = ACTIONS(1064),
    [anon_sym___attribute__] = ACTIONS(1064),
    [anon_sym___declspec] = ACTIONS(1064),
    [anon_sym___cdecl] = ACTIONS(1064),
    [anon_sym___clrcall] = ACTIONS(1064),
    [anon_sym___stdcall] = ACTIONS(1064),
    [anon_sym___fastcall] = ACTIONS(1064),
    [anon_sym___thiscall] = ACTIONS(1064),
    [anon_sym___vectorcall] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_RBRACE] = ACTIONS(1066),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_auto] = ACTIONS(1064),
    [anon_sym_register] = ACTIONS(1064),
    [anon_sym_inline] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_volatile] = ACTIONS(1064),
    [anon_sym_restrict] = ACTIONS(1064),
    [anon_sym__Atomic] = ACTIONS(1064),
    [anon_sym_signed] = ACTIONS(1064),
    [anon_sym_unsigned] = ACTIONS(1064),
    [anon_sym_long] = ACTIONS(1064),
    [anon_sym_short] = ACTIONS(1064),
    [sym_primitive_type] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [anon_sym_struct] = ACTIONS(1064),
    [anon_sym_union] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_goto] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1064),
    [sym_number_literal] = ACTIONS(1066),
    [anon_sym_L_SQUOTE] = ACTIONS(1066),
    [anon_sym_u_SQUOTE] = ACTIONS(1066),
    [anon_sym_U_SQUOTE] = ACTIONS(1066),
    [anon_sym_u8_SQUOTE] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [anon_sym_L_DQUOTE] = ACTIONS(1066),
    [anon_sym_u_DQUOTE] = ACTIONS(1066),
    [anon_sym_U_DQUOTE] = ACTIONS(1066),
    [anon_sym_u8_DQUOTE] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
  },
  [261] = {
    [sym_identifier] = ACTIONS(1036),
    [aux_sym_preproc_include_token1] = ACTIONS(1036),
    [aux_sym_preproc_def_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token2] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1036),
    [sym_preproc_directive] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_typedef] = ACTIONS(1036),
    [anon_sym_extern] = ACTIONS(1036),
    [anon_sym___attribute__] = ACTIONS(1036),
    [anon_sym___declspec] = ACTIONS(1036),
    [anon_sym___cdecl] = ACTIONS(1036),
    [anon_sym___clrcall] = ACTIONS(1036),
    [anon_sym___stdcall] = ACTIONS(1036),
    [anon_sym___fastcall] = ACTIONS(1036),
    [anon_sym___thiscall] = ACTIONS(1036),
    [anon_sym___vectorcall] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_auto] = ACTIONS(1036),
    [anon_sym_register] = ACTIONS(1036),
    [anon_sym_inline] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_restrict] = ACTIONS(1036),
    [anon_sym__Atomic] = ACTIONS(1036),
    [anon_sym_signed] = ACTIONS(1036),
    [anon_sym_unsigned] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [sym_primitive_type] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_union] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_goto] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_sizeof] = ACTIONS(1036),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_L_SQUOTE] = ACTIONS(1038),
    [anon_sym_u_SQUOTE] = ACTIONS(1038),
    [anon_sym_U_SQUOTE] = ACTIONS(1038),
    [anon_sym_u8_SQUOTE] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_L_DQUOTE] = ACTIONS(1038),
    [anon_sym_u_DQUOTE] = ACTIONS(1038),
    [anon_sym_U_DQUOTE] = ACTIONS(1038),
    [anon_sym_u8_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
  },
  [262] = {
    [ts_builtin_sym_end] = ACTIONS(1026),
    [sym_identifier] = ACTIONS(1024),
    [aux_sym_preproc_include_token1] = ACTIONS(1024),
    [aux_sym_preproc_def_token1] = ACTIONS(1024),
    [aux_sym_preproc_if_token1] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1024),
    [sym_preproc_directive] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1026),
    [anon_sym_TILDE] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_AMP] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1026),
    [anon_sym_typedef] = ACTIONS(1024),
    [anon_sym_extern] = ACTIONS(1024),
    [anon_sym___attribute__] = ACTIONS(1024),
    [anon_sym___declspec] = ACTIONS(1024),
    [anon_sym___cdecl] = ACTIONS(1024),
    [anon_sym___clrcall] = ACTIONS(1024),
    [anon_sym___stdcall] = ACTIONS(1024),
    [anon_sym___fastcall] = ACTIONS(1024),
    [anon_sym___thiscall] = ACTIONS(1024),
    [anon_sym___vectorcall] = ACTIONS(1024),
    [anon_sym_LBRACE] = ACTIONS(1026),
    [anon_sym_static] = ACTIONS(1024),
    [anon_sym_auto] = ACTIONS(1024),
    [anon_sym_register] = ACTIONS(1024),
    [anon_sym_inline] = ACTIONS(1024),
    [anon_sym_const] = ACTIONS(1024),
    [anon_sym_volatile] = ACTIONS(1024),
    [anon_sym_restrict] = ACTIONS(1024),
    [anon_sym__Atomic] = ACTIONS(1024),
    [anon_sym_signed] = ACTIONS(1024),
    [anon_sym_unsigned] = ACTIONS(1024),
    [anon_sym_long] = ACTIONS(1024),
    [anon_sym_short] = ACTIONS(1024),
    [sym_primitive_type] = ACTIONS(1024),
    [anon_sym_enum] = ACTIONS(1024),
    [anon_sym_struct] = ACTIONS(1024),
    [anon_sym_union] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1024),
    [anon_sym_switch] = ACTIONS(1024),
    [anon_sym_case] = ACTIONS(1024),
    [anon_sym_default] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_do] = ACTIONS(1024),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_goto] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_sizeof] = ACTIONS(1024),
    [sym_number_literal] = ACTIONS(1026),
    [anon_sym_L_SQUOTE] = ACTIONS(1026),
    [anon_sym_u_SQUOTE] = ACTIONS(1026),
    [anon_sym_U_SQUOTE] = ACTIONS(1026),
    [anon_sym_u8_SQUOTE] = ACTIONS(1026),
    [anon_sym_SQUOTE] = ACTIONS(1026),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1024),
    [sym_false] = ACTIONS(1024),
    [sym_null] = ACTIONS(1024),
    [sym_comment] = ACTIONS(3),
  },
  [263] = {
    [sym_identifier] = ACTIONS(1060),
    [aux_sym_preproc_include_token1] = ACTIONS(1060),
    [aux_sym_preproc_def_token1] = ACTIONS(1060),
    [aux_sym_preproc_if_token1] = ACTIONS(1060),
    [aux_sym_preproc_if_token2] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1060),
    [sym_preproc_directive] = ACTIONS(1060),
    [anon_sym_LPAREN2] = ACTIONS(1062),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_AMP] = ACTIONS(1062),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_typedef] = ACTIONS(1060),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym___attribute__] = ACTIONS(1060),
    [anon_sym___declspec] = ACTIONS(1060),
    [anon_sym___cdecl] = ACTIONS(1060),
    [anon_sym___clrcall] = ACTIONS(1060),
    [anon_sym___stdcall] = ACTIONS(1060),
    [anon_sym___fastcall] = ACTIONS(1060),
    [anon_sym___thiscall] = ACTIONS(1060),
    [anon_sym___vectorcall] = ACTIONS(1060),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1060),
    [anon_sym_auto] = ACTIONS(1060),
    [anon_sym_register] = ACTIONS(1060),
    [anon_sym_inline] = ACTIONS(1060),
    [anon_sym_const] = ACTIONS(1060),
    [anon_sym_volatile] = ACTIONS(1060),
    [anon_sym_restrict] = ACTIONS(1060),
    [anon_sym__Atomic] = ACTIONS(1060),
    [anon_sym_signed] = ACTIONS(1060),
    [anon_sym_unsigned] = ACTIONS(1060),
    [anon_sym_long] = ACTIONS(1060),
    [anon_sym_short] = ACTIONS(1060),
    [sym_primitive_type] = ACTIONS(1060),
    [anon_sym_enum] = ACTIONS(1060),
    [anon_sym_struct] = ACTIONS(1060),
    [anon_sym_union] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_switch] = ACTIONS(1060),
    [anon_sym_case] = ACTIONS(1060),
    [anon_sym_default] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_do] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_goto] = ACTIONS(1060),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_sizeof] = ACTIONS(1060),
    [sym_number_literal] = ACTIONS(1062),
    [anon_sym_L_SQUOTE] = ACTIONS(1062),
    [anon_sym_u_SQUOTE] = ACTIONS(1062),
    [anon_sym_U_SQUOTE] = ACTIONS(1062),
    [anon_sym_u8_SQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [anon_sym_L_DQUOTE] = ACTIONS(1062),
    [anon_sym_u_DQUOTE] = ACTIONS(1062),
    [anon_sym_U_DQUOTE] = ACTIONS(1062),
    [anon_sym_u8_DQUOTE] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_null] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
  },
  [264] = {
    [sym_identifier] = ACTIONS(1064),
    [aux_sym_preproc_include_token1] = ACTIONS(1064),
    [aux_sym_preproc_def_token1] = ACTIONS(1064),
    [aux_sym_preproc_if_token1] = ACTIONS(1064),
    [aux_sym_preproc_if_token2] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1064),
    [sym_preproc_directive] = ACTIONS(1064),
    [anon_sym_LPAREN2] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_AMP] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1066),
    [anon_sym_typedef] = ACTIONS(1064),
    [anon_sym_extern] = ACTIONS(1064),
    [anon_sym___attribute__] = ACTIONS(1064),
    [anon_sym___declspec] = ACTIONS(1064),
    [anon_sym___cdecl] = ACTIONS(1064),
    [anon_sym___clrcall] = ACTIONS(1064),
    [anon_sym___stdcall] = ACTIONS(1064),
    [anon_sym___fastcall] = ACTIONS(1064),
    [anon_sym___thiscall] = ACTIONS(1064),
    [anon_sym___vectorcall] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_auto] = ACTIONS(1064),
    [anon_sym_register] = ACTIONS(1064),
    [anon_sym_inline] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_volatile] = ACTIONS(1064),
    [anon_sym_restrict] = ACTIONS(1064),
    [anon_sym__Atomic] = ACTIONS(1064),
    [anon_sym_signed] = ACTIONS(1064),
    [anon_sym_unsigned] = ACTIONS(1064),
    [anon_sym_long] = ACTIONS(1064),
    [anon_sym_short] = ACTIONS(1064),
    [sym_primitive_type] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [anon_sym_struct] = ACTIONS(1064),
    [anon_sym_union] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_goto] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1064),
    [sym_number_literal] = ACTIONS(1066),
    [anon_sym_L_SQUOTE] = ACTIONS(1066),
    [anon_sym_u_SQUOTE] = ACTIONS(1066),
    [anon_sym_U_SQUOTE] = ACTIONS(1066),
    [anon_sym_u8_SQUOTE] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [anon_sym_L_DQUOTE] = ACTIONS(1066),
    [anon_sym_u_DQUOTE] = ACTIONS(1066),
    [anon_sym_U_DQUOTE] = ACTIONS(1066),
    [anon_sym_u8_DQUOTE] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
  },
  [265] = {
    [sym_identifier] = ACTIONS(1068),
    [aux_sym_preproc_include_token1] = ACTIONS(1068),
    [aux_sym_preproc_def_token1] = ACTIONS(1068),
    [aux_sym_preproc_if_token1] = ACTIONS(1068),
    [aux_sym_preproc_if_token2] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1068),
    [sym_preproc_directive] = ACTIONS(1068),
    [anon_sym_LPAREN2] = ACTIONS(1070),
    [anon_sym_BANG] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_typedef] = ACTIONS(1068),
    [anon_sym_extern] = ACTIONS(1068),
    [anon_sym___attribute__] = ACTIONS(1068),
    [anon_sym___declspec] = ACTIONS(1068),
    [anon_sym___cdecl] = ACTIONS(1068),
    [anon_sym___clrcall] = ACTIONS(1068),
    [anon_sym___stdcall] = ACTIONS(1068),
    [anon_sym___fastcall] = ACTIONS(1068),
    [anon_sym___thiscall] = ACTIONS(1068),
    [anon_sym___vectorcall] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_static] = ACTIONS(1068),
    [anon_sym_auto] = ACTIONS(1068),
    [anon_sym_register] = ACTIONS(1068),
    [anon_sym_inline] = ACTIONS(1068),
    [anon_sym_const] = ACTIONS(1068),
    [anon_sym_volatile] = ACTIONS(1068),
    [anon_sym_restrict] = ACTIONS(1068),
    [anon_sym__Atomic] = ACTIONS(1068),
    [anon_sym_signed] = ACTIONS(1068),
    [anon_sym_unsigned] = ACTIONS(1068),
    [anon_sym_long] = ACTIONS(1068),
    [anon_sym_short] = ACTIONS(1068),
    [sym_primitive_type] = ACTIONS(1068),
    [anon_sym_enum] = ACTIONS(1068),
    [anon_sym_struct] = ACTIONS(1068),
    [anon_sym_union] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_switch] = ACTIONS(1068),
    [anon_sym_case] = ACTIONS(1068),
    [anon_sym_default] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_do] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_goto] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1070),
    [anon_sym_PLUS_PLUS] = ACTIONS(1070),
    [anon_sym_sizeof] = ACTIONS(1068),
    [sym_number_literal] = ACTIONS(1070),
    [anon_sym_L_SQUOTE] = ACTIONS(1070),
    [anon_sym_u_SQUOTE] = ACTIONS(1070),
    [anon_sym_U_SQUOTE] = ACTIONS(1070),
    [anon_sym_u8_SQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [anon_sym_L_DQUOTE] = ACTIONS(1070),
    [anon_sym_u_DQUOTE] = ACTIONS(1070),
    [anon_sym_U_DQUOTE] = ACTIONS(1070),
    [anon_sym_u8_DQUOTE] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_null] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
  },
  [266] = {
    [ts_builtin_sym_end] = ACTIONS(1090),
    [sym_identifier] = ACTIONS(1088),
    [aux_sym_preproc_include_token1] = ACTIONS(1088),
    [aux_sym_preproc_def_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1088),
    [sym_preproc_directive] = ACTIONS(1088),
    [anon_sym_LPAREN2] = ACTIONS(1090),
    [anon_sym_BANG] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_STAR] = ACTIONS(1090),
    [anon_sym_AMP] = ACTIONS(1090),
    [anon_sym_SEMI] = ACTIONS(1090),
    [anon_sym_typedef] = ACTIONS(1088),
    [anon_sym_extern] = ACTIONS(1088),
    [anon_sym___attribute__] = ACTIONS(1088),
    [anon_sym___declspec] = ACTIONS(1088),
    [anon_sym___cdecl] = ACTIONS(1088),
    [anon_sym___clrcall] = ACTIONS(1088),
    [anon_sym___stdcall] = ACTIONS(1088),
    [anon_sym___fastcall] = ACTIONS(1088),
    [anon_sym___thiscall] = ACTIONS(1088),
    [anon_sym___vectorcall] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_static] = ACTIONS(1088),
    [anon_sym_auto] = ACTIONS(1088),
    [anon_sym_register] = ACTIONS(1088),
    [anon_sym_inline] = ACTIONS(1088),
    [anon_sym_const] = ACTIONS(1088),
    [anon_sym_volatile] = ACTIONS(1088),
    [anon_sym_restrict] = ACTIONS(1088),
    [anon_sym__Atomic] = ACTIONS(1088),
    [anon_sym_signed] = ACTIONS(1088),
    [anon_sym_unsigned] = ACTIONS(1088),
    [anon_sym_long] = ACTIONS(1088),
    [anon_sym_short] = ACTIONS(1088),
    [sym_primitive_type] = ACTIONS(1088),
    [anon_sym_enum] = ACTIONS(1088),
    [anon_sym_struct] = ACTIONS(1088),
    [anon_sym_union] = ACTIONS(1088),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(1088),
    [anon_sym_case] = ACTIONS(1088),
    [anon_sym_default] = ACTIONS(1088),
    [anon_sym_while] = ACTIONS(1088),
    [anon_sym_do] = ACTIONS(1088),
    [anon_sym_for] = ACTIONS(1088),
    [anon_sym_return] = ACTIONS(1088),
    [anon_sym_break] = ACTIONS(1088),
    [anon_sym_continue] = ACTIONS(1088),
    [anon_sym_goto] = ACTIONS(1088),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_sizeof] = ACTIONS(1088),
    [sym_number_literal] = ACTIONS(1090),
    [anon_sym_L_SQUOTE] = ACTIONS(1090),
    [anon_sym_u_SQUOTE] = ACTIONS(1090),
    [anon_sym_U_SQUOTE] = ACTIONS(1090),
    [anon_sym_u8_SQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [anon_sym_L_DQUOTE] = ACTIONS(1090),
    [anon_sym_u_DQUOTE] = ACTIONS(1090),
    [anon_sym_U_DQUOTE] = ACTIONS(1090),
    [anon_sym_u8_DQUOTE] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [sym_true] = ACTIONS(1088),
    [sym_false] = ACTIONS(1088),
    [sym_null] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
  },
  [267] = {
    [sym_identifier] = ACTIONS(1036),
    [aux_sym_preproc_include_token1] = ACTIONS(1036),
    [aux_sym_preproc_def_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1036),
    [sym_preproc_directive] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_typedef] = ACTIONS(1036),
    [anon_sym_extern] = ACTIONS(1036),
    [anon_sym___attribute__] = ACTIONS(1036),
    [anon_sym___declspec] = ACTIONS(1036),
    [anon_sym___cdecl] = ACTIONS(1036),
    [anon_sym___clrcall] = ACTIONS(1036),
    [anon_sym___stdcall] = ACTIONS(1036),
    [anon_sym___fastcall] = ACTIONS(1036),
    [anon_sym___thiscall] = ACTIONS(1036),
    [anon_sym___vectorcall] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_RBRACE] = ACTIONS(1038),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_auto] = ACTIONS(1036),
    [anon_sym_register] = ACTIONS(1036),
    [anon_sym_inline] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_restrict] = ACTIONS(1036),
    [anon_sym__Atomic] = ACTIONS(1036),
    [anon_sym_signed] = ACTIONS(1036),
    [anon_sym_unsigned] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [sym_primitive_type] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_union] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_goto] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_sizeof] = ACTIONS(1036),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_L_SQUOTE] = ACTIONS(1038),
    [anon_sym_u_SQUOTE] = ACTIONS(1038),
    [anon_sym_U_SQUOTE] = ACTIONS(1038),
    [anon_sym_u8_SQUOTE] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_L_DQUOTE] = ACTIONS(1038),
    [anon_sym_u_DQUOTE] = ACTIONS(1038),
    [anon_sym_U_DQUOTE] = ACTIONS(1038),
    [anon_sym_u8_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
  },
  [268] = {
    [sym_identifier] = ACTIONS(1048),
    [aux_sym_preproc_include_token1] = ACTIONS(1048),
    [aux_sym_preproc_def_token1] = ACTIONS(1048),
    [aux_sym_preproc_if_token1] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1048),
    [sym_preproc_directive] = ACTIONS(1048),
    [anon_sym_LPAREN2] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1048),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(1050),
    [anon_sym_SEMI] = ACTIONS(1050),
    [anon_sym_typedef] = ACTIONS(1048),
    [anon_sym_extern] = ACTIONS(1048),
    [anon_sym___attribute__] = ACTIONS(1048),
    [anon_sym___declspec] = ACTIONS(1048),
    [anon_sym___cdecl] = ACTIONS(1048),
    [anon_sym___clrcall] = ACTIONS(1048),
    [anon_sym___stdcall] = ACTIONS(1048),
    [anon_sym___fastcall] = ACTIONS(1048),
    [anon_sym___thiscall] = ACTIONS(1048),
    [anon_sym___vectorcall] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_RBRACE] = ACTIONS(1050),
    [anon_sym_static] = ACTIONS(1048),
    [anon_sym_auto] = ACTIONS(1048),
    [anon_sym_register] = ACTIONS(1048),
    [anon_sym_inline] = ACTIONS(1048),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_volatile] = ACTIONS(1048),
    [anon_sym_restrict] = ACTIONS(1048),
    [anon_sym__Atomic] = ACTIONS(1048),
    [anon_sym_signed] = ACTIONS(1048),
    [anon_sym_unsigned] = ACTIONS(1048),
    [anon_sym_long] = ACTIONS(1048),
    [anon_sym_short] = ACTIONS(1048),
    [sym_primitive_type] = ACTIONS(1048),
    [anon_sym_enum] = ACTIONS(1048),
    [anon_sym_struct] = ACTIONS(1048),
    [anon_sym_union] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1048),
    [anon_sym_switch] = ACTIONS(1048),
    [anon_sym_case] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1048),
    [anon_sym_while] = ACTIONS(1048),
    [anon_sym_do] = ACTIONS(1048),
    [anon_sym_for] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [anon_sym_goto] = ACTIONS(1048),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [anon_sym_sizeof] = ACTIONS(1048),
    [sym_number_literal] = ACTIONS(1050),
    [anon_sym_L_SQUOTE] = ACTIONS(1050),
    [anon_sym_u_SQUOTE] = ACTIONS(1050),
    [anon_sym_U_SQUOTE] = ACTIONS(1050),
    [anon_sym_u8_SQUOTE] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [anon_sym_L_DQUOTE] = ACTIONS(1050),
    [anon_sym_u_DQUOTE] = ACTIONS(1050),
    [anon_sym_U_DQUOTE] = ACTIONS(1050),
    [anon_sym_u8_DQUOTE] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_comment] = ACTIONS(3),
  },
  [269] = {
    [ts_builtin_sym_end] = ACTIONS(1082),
    [sym_identifier] = ACTIONS(1080),
    [aux_sym_preproc_include_token1] = ACTIONS(1080),
    [aux_sym_preproc_def_token1] = ACTIONS(1080),
    [aux_sym_preproc_if_token1] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1080),
    [sym_preproc_directive] = ACTIONS(1080),
    [anon_sym_LPAREN2] = ACTIONS(1082),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1082),
    [anon_sym_AMP] = ACTIONS(1082),
    [anon_sym_SEMI] = ACTIONS(1082),
    [anon_sym_typedef] = ACTIONS(1080),
    [anon_sym_extern] = ACTIONS(1080),
    [anon_sym___attribute__] = ACTIONS(1080),
    [anon_sym___declspec] = ACTIONS(1080),
    [anon_sym___cdecl] = ACTIONS(1080),
    [anon_sym___clrcall] = ACTIONS(1080),
    [anon_sym___stdcall] = ACTIONS(1080),
    [anon_sym___fastcall] = ACTIONS(1080),
    [anon_sym___thiscall] = ACTIONS(1080),
    [anon_sym___vectorcall] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1082),
    [anon_sym_static] = ACTIONS(1080),
    [anon_sym_auto] = ACTIONS(1080),
    [anon_sym_register] = ACTIONS(1080),
    [anon_sym_inline] = ACTIONS(1080),
    [anon_sym_const] = ACTIONS(1080),
    [anon_sym_volatile] = ACTIONS(1080),
    [anon_sym_restrict] = ACTIONS(1080),
    [anon_sym__Atomic] = ACTIONS(1080),
    [anon_sym_signed] = ACTIONS(1080),
    [anon_sym_unsigned] = ACTIONS(1080),
    [anon_sym_long] = ACTIONS(1080),
    [anon_sym_short] = ACTIONS(1080),
    [sym_primitive_type] = ACTIONS(1080),
    [anon_sym_enum] = ACTIONS(1080),
    [anon_sym_struct] = ACTIONS(1080),
    [anon_sym_union] = ACTIONS(1080),
    [anon_sym_if] = ACTIONS(1080),
    [anon_sym_switch] = ACTIONS(1080),
    [anon_sym_case] = ACTIONS(1080),
    [anon_sym_default] = ACTIONS(1080),
    [anon_sym_while] = ACTIONS(1080),
    [anon_sym_do] = ACTIONS(1080),
    [anon_sym_for] = ACTIONS(1080),
    [anon_sym_return] = ACTIONS(1080),
    [anon_sym_break] = ACTIONS(1080),
    [anon_sym_continue] = ACTIONS(1080),
    [anon_sym_goto] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1082),
    [anon_sym_PLUS_PLUS] = ACTIONS(1082),
    [anon_sym_sizeof] = ACTIONS(1080),
    [sym_number_literal] = ACTIONS(1082),
    [anon_sym_L_SQUOTE] = ACTIONS(1082),
    [anon_sym_u_SQUOTE] = ACTIONS(1082),
    [anon_sym_U_SQUOTE] = ACTIONS(1082),
    [anon_sym_u8_SQUOTE] = ACTIONS(1082),
    [anon_sym_SQUOTE] = ACTIONS(1082),
    [anon_sym_L_DQUOTE] = ACTIONS(1082),
    [anon_sym_u_DQUOTE] = ACTIONS(1082),
    [anon_sym_U_DQUOTE] = ACTIONS(1082),
    [anon_sym_u8_DQUOTE] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1082),
    [sym_true] = ACTIONS(1080),
    [sym_false] = ACTIONS(1080),
    [sym_null] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
  },
  [270] = {
    [sym_identifier] = ACTIONS(1080),
    [aux_sym_preproc_include_token1] = ACTIONS(1080),
    [aux_sym_preproc_def_token1] = ACTIONS(1080),
    [aux_sym_preproc_if_token1] = ACTIONS(1080),
    [aux_sym_preproc_if_token2] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1080),
    [sym_preproc_directive] = ACTIONS(1080),
    [anon_sym_LPAREN2] = ACTIONS(1082),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1082),
    [anon_sym_AMP] = ACTIONS(1082),
    [anon_sym_SEMI] = ACTIONS(1082),
    [anon_sym_typedef] = ACTIONS(1080),
    [anon_sym_extern] = ACTIONS(1080),
    [anon_sym___attribute__] = ACTIONS(1080),
    [anon_sym___declspec] = ACTIONS(1080),
    [anon_sym___cdecl] = ACTIONS(1080),
    [anon_sym___clrcall] = ACTIONS(1080),
    [anon_sym___stdcall] = ACTIONS(1080),
    [anon_sym___fastcall] = ACTIONS(1080),
    [anon_sym___thiscall] = ACTIONS(1080),
    [anon_sym___vectorcall] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1082),
    [anon_sym_static] = ACTIONS(1080),
    [anon_sym_auto] = ACTIONS(1080),
    [anon_sym_register] = ACTIONS(1080),
    [anon_sym_inline] = ACTIONS(1080),
    [anon_sym_const] = ACTIONS(1080),
    [anon_sym_volatile] = ACTIONS(1080),
    [anon_sym_restrict] = ACTIONS(1080),
    [anon_sym__Atomic] = ACTIONS(1080),
    [anon_sym_signed] = ACTIONS(1080),
    [anon_sym_unsigned] = ACTIONS(1080),
    [anon_sym_long] = ACTIONS(1080),
    [anon_sym_short] = ACTIONS(1080),
    [sym_primitive_type] = ACTIONS(1080),
    [anon_sym_enum] = ACTIONS(1080),
    [anon_sym_struct] = ACTIONS(1080),
    [anon_sym_union] = ACTIONS(1080),
    [anon_sym_if] = ACTIONS(1080),
    [anon_sym_switch] = ACTIONS(1080),
    [anon_sym_case] = ACTIONS(1080),
    [anon_sym_default] = ACTIONS(1080),
    [anon_sym_while] = ACTIONS(1080),
    [anon_sym_do] = ACTIONS(1080),
    [anon_sym_for] = ACTIONS(1080),
    [anon_sym_return] = ACTIONS(1080),
    [anon_sym_break] = ACTIONS(1080),
    [anon_sym_continue] = ACTIONS(1080),
    [anon_sym_goto] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1082),
    [anon_sym_PLUS_PLUS] = ACTIONS(1082),
    [anon_sym_sizeof] = ACTIONS(1080),
    [sym_number_literal] = ACTIONS(1082),
    [anon_sym_L_SQUOTE] = ACTIONS(1082),
    [anon_sym_u_SQUOTE] = ACTIONS(1082),
    [anon_sym_U_SQUOTE] = ACTIONS(1082),
    [anon_sym_u8_SQUOTE] = ACTIONS(1082),
    [anon_sym_SQUOTE] = ACTIONS(1082),
    [anon_sym_L_DQUOTE] = ACTIONS(1082),
    [anon_sym_u_DQUOTE] = ACTIONS(1082),
    [anon_sym_U_DQUOTE] = ACTIONS(1082),
    [anon_sym_u8_DQUOTE] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1082),
    [sym_true] = ACTIONS(1080),
    [sym_false] = ACTIONS(1080),
    [sym_null] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
  },
  [271] = {
    [sym_identifier] = ACTIONS(1052),
    [aux_sym_preproc_include_token1] = ACTIONS(1052),
    [aux_sym_preproc_def_token1] = ACTIONS(1052),
    [aux_sym_preproc_if_token1] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1052),
    [sym_preproc_directive] = ACTIONS(1052),
    [anon_sym_LPAREN2] = ACTIONS(1054),
    [anon_sym_BANG] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(1054),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_STAR] = ACTIONS(1054),
    [anon_sym_AMP] = ACTIONS(1054),
    [anon_sym_SEMI] = ACTIONS(1054),
    [anon_sym_typedef] = ACTIONS(1052),
    [anon_sym_extern] = ACTIONS(1052),
    [anon_sym___attribute__] = ACTIONS(1052),
    [anon_sym___declspec] = ACTIONS(1052),
    [anon_sym___cdecl] = ACTIONS(1052),
    [anon_sym___clrcall] = ACTIONS(1052),
    [anon_sym___stdcall] = ACTIONS(1052),
    [anon_sym___fastcall] = ACTIONS(1052),
    [anon_sym___thiscall] = ACTIONS(1052),
    [anon_sym___vectorcall] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_RBRACE] = ACTIONS(1054),
    [anon_sym_static] = ACTIONS(1052),
    [anon_sym_auto] = ACTIONS(1052),
    [anon_sym_register] = ACTIONS(1052),
    [anon_sym_inline] = ACTIONS(1052),
    [anon_sym_const] = ACTIONS(1052),
    [anon_sym_volatile] = ACTIONS(1052),
    [anon_sym_restrict] = ACTIONS(1052),
    [anon_sym__Atomic] = ACTIONS(1052),
    [anon_sym_signed] = ACTIONS(1052),
    [anon_sym_unsigned] = ACTIONS(1052),
    [anon_sym_long] = ACTIONS(1052),
    [anon_sym_short] = ACTIONS(1052),
    [sym_primitive_type] = ACTIONS(1052),
    [anon_sym_enum] = ACTIONS(1052),
    [anon_sym_struct] = ACTIONS(1052),
    [anon_sym_union] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1052),
    [anon_sym_switch] = ACTIONS(1052),
    [anon_sym_case] = ACTIONS(1052),
    [anon_sym_default] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_do] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_goto] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_PLUS_PLUS] = ACTIONS(1054),
    [anon_sym_sizeof] = ACTIONS(1052),
    [sym_number_literal] = ACTIONS(1054),
    [anon_sym_L_SQUOTE] = ACTIONS(1054),
    [anon_sym_u_SQUOTE] = ACTIONS(1054),
    [anon_sym_U_SQUOTE] = ACTIONS(1054),
    [anon_sym_u8_SQUOTE] = ACTIONS(1054),
    [anon_sym_SQUOTE] = ACTIONS(1054),
    [anon_sym_L_DQUOTE] = ACTIONS(1054),
    [anon_sym_u_DQUOTE] = ACTIONS(1054),
    [anon_sym_U_DQUOTE] = ACTIONS(1054),
    [anon_sym_u8_DQUOTE] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [sym_true] = ACTIONS(1052),
    [sym_false] = ACTIONS(1052),
    [sym_null] = ACTIONS(1052),
    [sym_comment] = ACTIONS(3),
  },
  [272] = {
    [sym_identifier] = ACTIONS(1080),
    [aux_sym_preproc_include_token1] = ACTIONS(1080),
    [aux_sym_preproc_def_token1] = ACTIONS(1080),
    [aux_sym_preproc_if_token1] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1080),
    [sym_preproc_directive] = ACTIONS(1080),
    [anon_sym_LPAREN2] = ACTIONS(1082),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1082),
    [anon_sym_AMP] = ACTIONS(1082),
    [anon_sym_SEMI] = ACTIONS(1082),
    [anon_sym_typedef] = ACTIONS(1080),
    [anon_sym_extern] = ACTIONS(1080),
    [anon_sym___attribute__] = ACTIONS(1080),
    [anon_sym___declspec] = ACTIONS(1080),
    [anon_sym___cdecl] = ACTIONS(1080),
    [anon_sym___clrcall] = ACTIONS(1080),
    [anon_sym___stdcall] = ACTIONS(1080),
    [anon_sym___fastcall] = ACTIONS(1080),
    [anon_sym___thiscall] = ACTIONS(1080),
    [anon_sym___vectorcall] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1082),
    [anon_sym_RBRACE] = ACTIONS(1082),
    [anon_sym_static] = ACTIONS(1080),
    [anon_sym_auto] = ACTIONS(1080),
    [anon_sym_register] = ACTIONS(1080),
    [anon_sym_inline] = ACTIONS(1080),
    [anon_sym_const] = ACTIONS(1080),
    [anon_sym_volatile] = ACTIONS(1080),
    [anon_sym_restrict] = ACTIONS(1080),
    [anon_sym__Atomic] = ACTIONS(1080),
    [anon_sym_signed] = ACTIONS(1080),
    [anon_sym_unsigned] = ACTIONS(1080),
    [anon_sym_long] = ACTIONS(1080),
    [anon_sym_short] = ACTIONS(1080),
    [sym_primitive_type] = ACTIONS(1080),
    [anon_sym_enum] = ACTIONS(1080),
    [anon_sym_struct] = ACTIONS(1080),
    [anon_sym_union] = ACTIONS(1080),
    [anon_sym_if] = ACTIONS(1080),
    [anon_sym_switch] = ACTIONS(1080),
    [anon_sym_case] = ACTIONS(1080),
    [anon_sym_default] = ACTIONS(1080),
    [anon_sym_while] = ACTIONS(1080),
    [anon_sym_do] = ACTIONS(1080),
    [anon_sym_for] = ACTIONS(1080),
    [anon_sym_return] = ACTIONS(1080),
    [anon_sym_break] = ACTIONS(1080),
    [anon_sym_continue] = ACTIONS(1080),
    [anon_sym_goto] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1082),
    [anon_sym_PLUS_PLUS] = ACTIONS(1082),
    [anon_sym_sizeof] = ACTIONS(1080),
    [sym_number_literal] = ACTIONS(1082),
    [anon_sym_L_SQUOTE] = ACTIONS(1082),
    [anon_sym_u_SQUOTE] = ACTIONS(1082),
    [anon_sym_U_SQUOTE] = ACTIONS(1082),
    [anon_sym_u8_SQUOTE] = ACTIONS(1082),
    [anon_sym_SQUOTE] = ACTIONS(1082),
    [anon_sym_L_DQUOTE] = ACTIONS(1082),
    [anon_sym_u_DQUOTE] = ACTIONS(1082),
    [anon_sym_U_DQUOTE] = ACTIONS(1082),
    [anon_sym_u8_DQUOTE] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1082),
    [sym_true] = ACTIONS(1080),
    [sym_false] = ACTIONS(1080),
    [sym_null] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
  },
  [273] = {
    [sym_identifier] = ACTIONS(1052),
    [aux_sym_preproc_include_token1] = ACTIONS(1052),
    [aux_sym_preproc_def_token1] = ACTIONS(1052),
    [aux_sym_preproc_if_token1] = ACTIONS(1052),
    [aux_sym_preproc_if_token2] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1052),
    [sym_preproc_directive] = ACTIONS(1052),
    [anon_sym_LPAREN2] = ACTIONS(1054),
    [anon_sym_BANG] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(1054),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_STAR] = ACTIONS(1054),
    [anon_sym_AMP] = ACTIONS(1054),
    [anon_sym_SEMI] = ACTIONS(1054),
    [anon_sym_typedef] = ACTIONS(1052),
    [anon_sym_extern] = ACTIONS(1052),
    [anon_sym___attribute__] = ACTIONS(1052),
    [anon_sym___declspec] = ACTIONS(1052),
    [anon_sym___cdecl] = ACTIONS(1052),
    [anon_sym___clrcall] = ACTIONS(1052),
    [anon_sym___stdcall] = ACTIONS(1052),
    [anon_sym___fastcall] = ACTIONS(1052),
    [anon_sym___thiscall] = ACTIONS(1052),
    [anon_sym___vectorcall] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_static] = ACTIONS(1052),
    [anon_sym_auto] = ACTIONS(1052),
    [anon_sym_register] = ACTIONS(1052),
    [anon_sym_inline] = ACTIONS(1052),
    [anon_sym_const] = ACTIONS(1052),
    [anon_sym_volatile] = ACTIONS(1052),
    [anon_sym_restrict] = ACTIONS(1052),
    [anon_sym__Atomic] = ACTIONS(1052),
    [anon_sym_signed] = ACTIONS(1052),
    [anon_sym_unsigned] = ACTIONS(1052),
    [anon_sym_long] = ACTIONS(1052),
    [anon_sym_short] = ACTIONS(1052),
    [sym_primitive_type] = ACTIONS(1052),
    [anon_sym_enum] = ACTIONS(1052),
    [anon_sym_struct] = ACTIONS(1052),
    [anon_sym_union] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1052),
    [anon_sym_switch] = ACTIONS(1052),
    [anon_sym_case] = ACTIONS(1052),
    [anon_sym_default] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_do] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_goto] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_PLUS_PLUS] = ACTIONS(1054),
    [anon_sym_sizeof] = ACTIONS(1052),
    [sym_number_literal] = ACTIONS(1054),
    [anon_sym_L_SQUOTE] = ACTIONS(1054),
    [anon_sym_u_SQUOTE] = ACTIONS(1054),
    [anon_sym_U_SQUOTE] = ACTIONS(1054),
    [anon_sym_u8_SQUOTE] = ACTIONS(1054),
    [anon_sym_SQUOTE] = ACTIONS(1054),
    [anon_sym_L_DQUOTE] = ACTIONS(1054),
    [anon_sym_u_DQUOTE] = ACTIONS(1054),
    [anon_sym_U_DQUOTE] = ACTIONS(1054),
    [anon_sym_u8_DQUOTE] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [sym_true] = ACTIONS(1052),
    [sym_false] = ACTIONS(1052),
    [sym_null] = ACTIONS(1052),
    [sym_comment] = ACTIONS(3),
  },
  [274] = {
    [sym_identifier] = ACTIONS(1048),
    [aux_sym_preproc_include_token1] = ACTIONS(1048),
    [aux_sym_preproc_def_token1] = ACTIONS(1048),
    [aux_sym_preproc_if_token1] = ACTIONS(1048),
    [aux_sym_preproc_if_token2] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1048),
    [sym_preproc_directive] = ACTIONS(1048),
    [anon_sym_LPAREN2] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1048),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(1050),
    [anon_sym_SEMI] = ACTIONS(1050),
    [anon_sym_typedef] = ACTIONS(1048),
    [anon_sym_extern] = ACTIONS(1048),
    [anon_sym___attribute__] = ACTIONS(1048),
    [anon_sym___declspec] = ACTIONS(1048),
    [anon_sym___cdecl] = ACTIONS(1048),
    [anon_sym___clrcall] = ACTIONS(1048),
    [anon_sym___stdcall] = ACTIONS(1048),
    [anon_sym___fastcall] = ACTIONS(1048),
    [anon_sym___thiscall] = ACTIONS(1048),
    [anon_sym___vectorcall] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_static] = ACTIONS(1048),
    [anon_sym_auto] = ACTIONS(1048),
    [anon_sym_register] = ACTIONS(1048),
    [anon_sym_inline] = ACTIONS(1048),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_volatile] = ACTIONS(1048),
    [anon_sym_restrict] = ACTIONS(1048),
    [anon_sym__Atomic] = ACTIONS(1048),
    [anon_sym_signed] = ACTIONS(1048),
    [anon_sym_unsigned] = ACTIONS(1048),
    [anon_sym_long] = ACTIONS(1048),
    [anon_sym_short] = ACTIONS(1048),
    [sym_primitive_type] = ACTIONS(1048),
    [anon_sym_enum] = ACTIONS(1048),
    [anon_sym_struct] = ACTIONS(1048),
    [anon_sym_union] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1048),
    [anon_sym_switch] = ACTIONS(1048),
    [anon_sym_case] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1048),
    [anon_sym_while] = ACTIONS(1048),
    [anon_sym_do] = ACTIONS(1048),
    [anon_sym_for] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [anon_sym_goto] = ACTIONS(1048),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [anon_sym_sizeof] = ACTIONS(1048),
    [sym_number_literal] = ACTIONS(1050),
    [anon_sym_L_SQUOTE] = ACTIONS(1050),
    [anon_sym_u_SQUOTE] = ACTIONS(1050),
    [anon_sym_U_SQUOTE] = ACTIONS(1050),
    [anon_sym_u8_SQUOTE] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [anon_sym_L_DQUOTE] = ACTIONS(1050),
    [anon_sym_u_DQUOTE] = ACTIONS(1050),
    [anon_sym_U_DQUOTE] = ACTIONS(1050),
    [anon_sym_u8_DQUOTE] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_comment] = ACTIONS(3),
  },
  [275] = {
    [sym_identifier] = ACTIONS(1088),
    [aux_sym_preproc_include_token1] = ACTIONS(1088),
    [aux_sym_preproc_def_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token2] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1088),
    [sym_preproc_directive] = ACTIONS(1088),
    [anon_sym_LPAREN2] = ACTIONS(1090),
    [anon_sym_BANG] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_STAR] = ACTIONS(1090),
    [anon_sym_AMP] = ACTIONS(1090),
    [anon_sym_SEMI] = ACTIONS(1090),
    [anon_sym_typedef] = ACTIONS(1088),
    [anon_sym_extern] = ACTIONS(1088),
    [anon_sym___attribute__] = ACTIONS(1088),
    [anon_sym___declspec] = ACTIONS(1088),
    [anon_sym___cdecl] = ACTIONS(1088),
    [anon_sym___clrcall] = ACTIONS(1088),
    [anon_sym___stdcall] = ACTIONS(1088),
    [anon_sym___fastcall] = ACTIONS(1088),
    [anon_sym___thiscall] = ACTIONS(1088),
    [anon_sym___vectorcall] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_static] = ACTIONS(1088),
    [anon_sym_auto] = ACTIONS(1088),
    [anon_sym_register] = ACTIONS(1088),
    [anon_sym_inline] = ACTIONS(1088),
    [anon_sym_const] = ACTIONS(1088),
    [anon_sym_volatile] = ACTIONS(1088),
    [anon_sym_restrict] = ACTIONS(1088),
    [anon_sym__Atomic] = ACTIONS(1088),
    [anon_sym_signed] = ACTIONS(1088),
    [anon_sym_unsigned] = ACTIONS(1088),
    [anon_sym_long] = ACTIONS(1088),
    [anon_sym_short] = ACTIONS(1088),
    [sym_primitive_type] = ACTIONS(1088),
    [anon_sym_enum] = ACTIONS(1088),
    [anon_sym_struct] = ACTIONS(1088),
    [anon_sym_union] = ACTIONS(1088),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(1088),
    [anon_sym_case] = ACTIONS(1088),
    [anon_sym_default] = ACTIONS(1088),
    [anon_sym_while] = ACTIONS(1088),
    [anon_sym_do] = ACTIONS(1088),
    [anon_sym_for] = ACTIONS(1088),
    [anon_sym_return] = ACTIONS(1088),
    [anon_sym_break] = ACTIONS(1088),
    [anon_sym_continue] = ACTIONS(1088),
    [anon_sym_goto] = ACTIONS(1088),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_sizeof] = ACTIONS(1088),
    [sym_number_literal] = ACTIONS(1090),
    [anon_sym_L_SQUOTE] = ACTIONS(1090),
    [anon_sym_u_SQUOTE] = ACTIONS(1090),
    [anon_sym_U_SQUOTE] = ACTIONS(1090),
    [anon_sym_u8_SQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [anon_sym_L_DQUOTE] = ACTIONS(1090),
    [anon_sym_u_DQUOTE] = ACTIONS(1090),
    [anon_sym_U_DQUOTE] = ACTIONS(1090),
    [anon_sym_u8_DQUOTE] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [sym_true] = ACTIONS(1088),
    [sym_false] = ACTIONS(1088),
    [sym_null] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
  },
  [276] = {
    [ts_builtin_sym_end] = ACTIONS(1106),
    [sym_identifier] = ACTIONS(1104),
    [aux_sym_preproc_include_token1] = ACTIONS(1104),
    [aux_sym_preproc_def_token1] = ACTIONS(1104),
    [aux_sym_preproc_if_token1] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1104),
    [sym_preproc_directive] = ACTIONS(1104),
    [anon_sym_LPAREN2] = ACTIONS(1106),
    [anon_sym_BANG] = ACTIONS(1106),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_AMP] = ACTIONS(1106),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_typedef] = ACTIONS(1104),
    [anon_sym_extern] = ACTIONS(1104),
    [anon_sym___attribute__] = ACTIONS(1104),
    [anon_sym___declspec] = ACTIONS(1104),
    [anon_sym___cdecl] = ACTIONS(1104),
    [anon_sym___clrcall] = ACTIONS(1104),
    [anon_sym___stdcall] = ACTIONS(1104),
    [anon_sym___fastcall] = ACTIONS(1104),
    [anon_sym___thiscall] = ACTIONS(1104),
    [anon_sym___vectorcall] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_auto] = ACTIONS(1104),
    [anon_sym_register] = ACTIONS(1104),
    [anon_sym_inline] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_volatile] = ACTIONS(1104),
    [anon_sym_restrict] = ACTIONS(1104),
    [anon_sym__Atomic] = ACTIONS(1104),
    [anon_sym_signed] = ACTIONS(1104),
    [anon_sym_unsigned] = ACTIONS(1104),
    [anon_sym_long] = ACTIONS(1104),
    [anon_sym_short] = ACTIONS(1104),
    [sym_primitive_type] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [anon_sym_struct] = ACTIONS(1104),
    [anon_sym_union] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_goto] = ACTIONS(1104),
    [anon_sym_DASH_DASH] = ACTIONS(1106),
    [anon_sym_PLUS_PLUS] = ACTIONS(1106),
    [anon_sym_sizeof] = ACTIONS(1104),
    [sym_number_literal] = ACTIONS(1106),
    [anon_sym_L_SQUOTE] = ACTIONS(1106),
    [anon_sym_u_SQUOTE] = ACTIONS(1106),
    [anon_sym_U_SQUOTE] = ACTIONS(1106),
    [anon_sym_u8_SQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [anon_sym_L_DQUOTE] = ACTIONS(1106),
    [anon_sym_u_DQUOTE] = ACTIONS(1106),
    [anon_sym_U_DQUOTE] = ACTIONS(1106),
    [anon_sym_u8_DQUOTE] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_comment] = ACTIONS(3),
  },
  [277] = {
    [sym_identifier] = ACTIONS(1060),
    [aux_sym_preproc_include_token1] = ACTIONS(1060),
    [aux_sym_preproc_def_token1] = ACTIONS(1060),
    [aux_sym_preproc_if_token1] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1060),
    [sym_preproc_directive] = ACTIONS(1060),
    [anon_sym_LPAREN2] = ACTIONS(1062),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_AMP] = ACTIONS(1062),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_typedef] = ACTIONS(1060),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym___attribute__] = ACTIONS(1060),
    [anon_sym___declspec] = ACTIONS(1060),
    [anon_sym___cdecl] = ACTIONS(1060),
    [anon_sym___clrcall] = ACTIONS(1060),
    [anon_sym___stdcall] = ACTIONS(1060),
    [anon_sym___fastcall] = ACTIONS(1060),
    [anon_sym___thiscall] = ACTIONS(1060),
    [anon_sym___vectorcall] = ACTIONS(1060),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_RBRACE] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1060),
    [anon_sym_auto] = ACTIONS(1060),
    [anon_sym_register] = ACTIONS(1060),
    [anon_sym_inline] = ACTIONS(1060),
    [anon_sym_const] = ACTIONS(1060),
    [anon_sym_volatile] = ACTIONS(1060),
    [anon_sym_restrict] = ACTIONS(1060),
    [anon_sym__Atomic] = ACTIONS(1060),
    [anon_sym_signed] = ACTIONS(1060),
    [anon_sym_unsigned] = ACTIONS(1060),
    [anon_sym_long] = ACTIONS(1060),
    [anon_sym_short] = ACTIONS(1060),
    [sym_primitive_type] = ACTIONS(1060),
    [anon_sym_enum] = ACTIONS(1060),
    [anon_sym_struct] = ACTIONS(1060),
    [anon_sym_union] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_switch] = ACTIONS(1060),
    [anon_sym_case] = ACTIONS(1060),
    [anon_sym_default] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_do] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_goto] = ACTIONS(1060),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_sizeof] = ACTIONS(1060),
    [sym_number_literal] = ACTIONS(1062),
    [anon_sym_L_SQUOTE] = ACTIONS(1062),
    [anon_sym_u_SQUOTE] = ACTIONS(1062),
    [anon_sym_U_SQUOTE] = ACTIONS(1062),
    [anon_sym_u8_SQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [anon_sym_L_DQUOTE] = ACTIONS(1062),
    [anon_sym_u_DQUOTE] = ACTIONS(1062),
    [anon_sym_U_DQUOTE] = ACTIONS(1062),
    [anon_sym_u8_DQUOTE] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_null] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
  },
  [278] = {
    [sym_identifier] = ACTIONS(1044),
    [aux_sym_preproc_include_token1] = ACTIONS(1044),
    [aux_sym_preproc_def_token1] = ACTIONS(1044),
    [aux_sym_preproc_if_token1] = ACTIONS(1044),
    [aux_sym_preproc_if_token2] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1044),
    [sym_preproc_directive] = ACTIONS(1044),
    [anon_sym_LPAREN2] = ACTIONS(1046),
    [anon_sym_BANG] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1044),
    [anon_sym_STAR] = ACTIONS(1046),
    [anon_sym_AMP] = ACTIONS(1046),
    [anon_sym_SEMI] = ACTIONS(1046),
    [anon_sym_typedef] = ACTIONS(1044),
    [anon_sym_extern] = ACTIONS(1044),
    [anon_sym___attribute__] = ACTIONS(1044),
    [anon_sym___declspec] = ACTIONS(1044),
    [anon_sym___cdecl] = ACTIONS(1044),
    [anon_sym___clrcall] = ACTIONS(1044),
    [anon_sym___stdcall] = ACTIONS(1044),
    [anon_sym___fastcall] = ACTIONS(1044),
    [anon_sym___thiscall] = ACTIONS(1044),
    [anon_sym___vectorcall] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [anon_sym_static] = ACTIONS(1044),
    [anon_sym_auto] = ACTIONS(1044),
    [anon_sym_register] = ACTIONS(1044),
    [anon_sym_inline] = ACTIONS(1044),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym_signed] = ACTIONS(1044),
    [anon_sym_unsigned] = ACTIONS(1044),
    [anon_sym_long] = ACTIONS(1044),
    [anon_sym_short] = ACTIONS(1044),
    [sym_primitive_type] = ACTIONS(1044),
    [anon_sym_enum] = ACTIONS(1044),
    [anon_sym_struct] = ACTIONS(1044),
    [anon_sym_union] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1044),
    [anon_sym_switch] = ACTIONS(1044),
    [anon_sym_case] = ACTIONS(1044),
    [anon_sym_default] = ACTIONS(1044),
    [anon_sym_while] = ACTIONS(1044),
    [anon_sym_do] = ACTIONS(1044),
    [anon_sym_for] = ACTIONS(1044),
    [anon_sym_return] = ACTIONS(1044),
    [anon_sym_break] = ACTIONS(1044),
    [anon_sym_continue] = ACTIONS(1044),
    [anon_sym_goto] = ACTIONS(1044),
    [anon_sym_DASH_DASH] = ACTIONS(1046),
    [anon_sym_PLUS_PLUS] = ACTIONS(1046),
    [anon_sym_sizeof] = ACTIONS(1044),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_L_SQUOTE] = ACTIONS(1046),
    [anon_sym_u_SQUOTE] = ACTIONS(1046),
    [anon_sym_U_SQUOTE] = ACTIONS(1046),
    [anon_sym_u8_SQUOTE] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(1046),
    [anon_sym_L_DQUOTE] = ACTIONS(1046),
    [anon_sym_u_DQUOTE] = ACTIONS(1046),
    [anon_sym_U_DQUOTE] = ACTIONS(1046),
    [anon_sym_u8_DQUOTE] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_comment] = ACTIONS(3),
  },
  [279] = {
    [ts_builtin_sym_end] = ACTIONS(1098),
    [sym_identifier] = ACTIONS(1096),
    [aux_sym_preproc_include_token1] = ACTIONS(1096),
    [aux_sym_preproc_def_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1096),
    [sym_preproc_directive] = ACTIONS(1096),
    [anon_sym_LPAREN2] = ACTIONS(1098),
    [anon_sym_BANG] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1096),
    [anon_sym_PLUS] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1098),
    [anon_sym_AMP] = ACTIONS(1098),
    [anon_sym_SEMI] = ACTIONS(1098),
    [anon_sym_typedef] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(1096),
    [anon_sym___attribute__] = ACTIONS(1096),
    [anon_sym___declspec] = ACTIONS(1096),
    [anon_sym___cdecl] = ACTIONS(1096),
    [anon_sym___clrcall] = ACTIONS(1096),
    [anon_sym___stdcall] = ACTIONS(1096),
    [anon_sym___fastcall] = ACTIONS(1096),
    [anon_sym___thiscall] = ACTIONS(1096),
    [anon_sym___vectorcall] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1098),
    [anon_sym_static] = ACTIONS(1096),
    [anon_sym_auto] = ACTIONS(1096),
    [anon_sym_register] = ACTIONS(1096),
    [anon_sym_inline] = ACTIONS(1096),
    [anon_sym_const] = ACTIONS(1096),
    [anon_sym_volatile] = ACTIONS(1096),
    [anon_sym_restrict] = ACTIONS(1096),
    [anon_sym__Atomic] = ACTIONS(1096),
    [anon_sym_signed] = ACTIONS(1096),
    [anon_sym_unsigned] = ACTIONS(1096),
    [anon_sym_long] = ACTIONS(1096),
    [anon_sym_short] = ACTIONS(1096),
    [sym_primitive_type] = ACTIONS(1096),
    [anon_sym_enum] = ACTIONS(1096),
    [anon_sym_struct] = ACTIONS(1096),
    [anon_sym_union] = ACTIONS(1096),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_switch] = ACTIONS(1096),
    [anon_sym_case] = ACTIONS(1096),
    [anon_sym_default] = ACTIONS(1096),
    [anon_sym_while] = ACTIONS(1096),
    [anon_sym_do] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1096),
    [anon_sym_return] = ACTIONS(1096),
    [anon_sym_break] = ACTIONS(1096),
    [anon_sym_continue] = ACTIONS(1096),
    [anon_sym_goto] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1098),
    [anon_sym_sizeof] = ACTIONS(1096),
    [sym_number_literal] = ACTIONS(1098),
    [anon_sym_L_SQUOTE] = ACTIONS(1098),
    [anon_sym_u_SQUOTE] = ACTIONS(1098),
    [anon_sym_U_SQUOTE] = ACTIONS(1098),
    [anon_sym_u8_SQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [anon_sym_L_DQUOTE] = ACTIONS(1098),
    [anon_sym_u_DQUOTE] = ACTIONS(1098),
    [anon_sym_U_DQUOTE] = ACTIONS(1098),
    [anon_sym_u8_DQUOTE] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
  },
  [280] = {
    [ts_builtin_sym_end] = ACTIONS(1030),
    [sym_identifier] = ACTIONS(1028),
    [aux_sym_preproc_include_token1] = ACTIONS(1028),
    [aux_sym_preproc_def_token1] = ACTIONS(1028),
    [aux_sym_preproc_if_token1] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1028),
    [sym_preproc_directive] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1030),
    [anon_sym_BANG] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1028),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_AMP] = ACTIONS(1030),
    [anon_sym_SEMI] = ACTIONS(1030),
    [anon_sym_typedef] = ACTIONS(1028),
    [anon_sym_extern] = ACTIONS(1028),
    [anon_sym___attribute__] = ACTIONS(1028),
    [anon_sym___declspec] = ACTIONS(1028),
    [anon_sym___cdecl] = ACTIONS(1028),
    [anon_sym___clrcall] = ACTIONS(1028),
    [anon_sym___stdcall] = ACTIONS(1028),
    [anon_sym___fastcall] = ACTIONS(1028),
    [anon_sym___thiscall] = ACTIONS(1028),
    [anon_sym___vectorcall] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1030),
    [anon_sym_static] = ACTIONS(1028),
    [anon_sym_auto] = ACTIONS(1028),
    [anon_sym_register] = ACTIONS(1028),
    [anon_sym_inline] = ACTIONS(1028),
    [anon_sym_const] = ACTIONS(1028),
    [anon_sym_volatile] = ACTIONS(1028),
    [anon_sym_restrict] = ACTIONS(1028),
    [anon_sym__Atomic] = ACTIONS(1028),
    [anon_sym_signed] = ACTIONS(1028),
    [anon_sym_unsigned] = ACTIONS(1028),
    [anon_sym_long] = ACTIONS(1028),
    [anon_sym_short] = ACTIONS(1028),
    [sym_primitive_type] = ACTIONS(1028),
    [anon_sym_enum] = ACTIONS(1028),
    [anon_sym_struct] = ACTIONS(1028),
    [anon_sym_union] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1028),
    [anon_sym_switch] = ACTIONS(1028),
    [anon_sym_case] = ACTIONS(1028),
    [anon_sym_default] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_goto] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1030),
    [anon_sym_sizeof] = ACTIONS(1028),
    [sym_number_literal] = ACTIONS(1030),
    [anon_sym_L_SQUOTE] = ACTIONS(1030),
    [anon_sym_u_SQUOTE] = ACTIONS(1030),
    [anon_sym_U_SQUOTE] = ACTIONS(1030),
    [anon_sym_u8_SQUOTE] = ACTIONS(1030),
    [anon_sym_SQUOTE] = ACTIONS(1030),
    [anon_sym_L_DQUOTE] = ACTIONS(1030),
    [anon_sym_u_DQUOTE] = ACTIONS(1030),
    [anon_sym_U_DQUOTE] = ACTIONS(1030),
    [anon_sym_u8_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [sym_true] = ACTIONS(1028),
    [sym_false] = ACTIONS(1028),
    [sym_null] = ACTIONS(1028),
    [sym_comment] = ACTIONS(3),
  },
  [281] = {
    [ts_builtin_sym_end] = ACTIONS(1054),
    [sym_identifier] = ACTIONS(1052),
    [aux_sym_preproc_include_token1] = ACTIONS(1052),
    [aux_sym_preproc_def_token1] = ACTIONS(1052),
    [aux_sym_preproc_if_token1] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1052),
    [sym_preproc_directive] = ACTIONS(1052),
    [anon_sym_LPAREN2] = ACTIONS(1054),
    [anon_sym_BANG] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(1054),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_STAR] = ACTIONS(1054),
    [anon_sym_AMP] = ACTIONS(1054),
    [anon_sym_SEMI] = ACTIONS(1054),
    [anon_sym_typedef] = ACTIONS(1052),
    [anon_sym_extern] = ACTIONS(1052),
    [anon_sym___attribute__] = ACTIONS(1052),
    [anon_sym___declspec] = ACTIONS(1052),
    [anon_sym___cdecl] = ACTIONS(1052),
    [anon_sym___clrcall] = ACTIONS(1052),
    [anon_sym___stdcall] = ACTIONS(1052),
    [anon_sym___fastcall] = ACTIONS(1052),
    [anon_sym___thiscall] = ACTIONS(1052),
    [anon_sym___vectorcall] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_static] = ACTIONS(1052),
    [anon_sym_auto] = ACTIONS(1052),
    [anon_sym_register] = ACTIONS(1052),
    [anon_sym_inline] = ACTIONS(1052),
    [anon_sym_const] = ACTIONS(1052),
    [anon_sym_volatile] = ACTIONS(1052),
    [anon_sym_restrict] = ACTIONS(1052),
    [anon_sym__Atomic] = ACTIONS(1052),
    [anon_sym_signed] = ACTIONS(1052),
    [anon_sym_unsigned] = ACTIONS(1052),
    [anon_sym_long] = ACTIONS(1052),
    [anon_sym_short] = ACTIONS(1052),
    [sym_primitive_type] = ACTIONS(1052),
    [anon_sym_enum] = ACTIONS(1052),
    [anon_sym_struct] = ACTIONS(1052),
    [anon_sym_union] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1052),
    [anon_sym_switch] = ACTIONS(1052),
    [anon_sym_case] = ACTIONS(1052),
    [anon_sym_default] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_do] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_goto] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_PLUS_PLUS] = ACTIONS(1054),
    [anon_sym_sizeof] = ACTIONS(1052),
    [sym_number_literal] = ACTIONS(1054),
    [anon_sym_L_SQUOTE] = ACTIONS(1054),
    [anon_sym_u_SQUOTE] = ACTIONS(1054),
    [anon_sym_U_SQUOTE] = ACTIONS(1054),
    [anon_sym_u8_SQUOTE] = ACTIONS(1054),
    [anon_sym_SQUOTE] = ACTIONS(1054),
    [anon_sym_L_DQUOTE] = ACTIONS(1054),
    [anon_sym_u_DQUOTE] = ACTIONS(1054),
    [anon_sym_U_DQUOTE] = ACTIONS(1054),
    [anon_sym_u8_DQUOTE] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [sym_true] = ACTIONS(1052),
    [sym_false] = ACTIONS(1052),
    [sym_null] = ACTIONS(1052),
    [sym_comment] = ACTIONS(3),
  },
  [282] = {
    [sym_identifier] = ACTIONS(1092),
    [aux_sym_preproc_include_token1] = ACTIONS(1092),
    [aux_sym_preproc_def_token1] = ACTIONS(1092),
    [aux_sym_preproc_if_token1] = ACTIONS(1092),
    [aux_sym_preproc_if_token2] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1092),
    [sym_preproc_directive] = ACTIONS(1092),
    [anon_sym_LPAREN2] = ACTIONS(1094),
    [anon_sym_BANG] = ACTIONS(1094),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1094),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_SEMI] = ACTIONS(1094),
    [anon_sym_typedef] = ACTIONS(1092),
    [anon_sym_extern] = ACTIONS(1092),
    [anon_sym___attribute__] = ACTIONS(1092),
    [anon_sym___declspec] = ACTIONS(1092),
    [anon_sym___cdecl] = ACTIONS(1092),
    [anon_sym___clrcall] = ACTIONS(1092),
    [anon_sym___stdcall] = ACTIONS(1092),
    [anon_sym___fastcall] = ACTIONS(1092),
    [anon_sym___thiscall] = ACTIONS(1092),
    [anon_sym___vectorcall] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_static] = ACTIONS(1092),
    [anon_sym_auto] = ACTIONS(1092),
    [anon_sym_register] = ACTIONS(1092),
    [anon_sym_inline] = ACTIONS(1092),
    [anon_sym_const] = ACTIONS(1092),
    [anon_sym_volatile] = ACTIONS(1092),
    [anon_sym_restrict] = ACTIONS(1092),
    [anon_sym__Atomic] = ACTIONS(1092),
    [anon_sym_signed] = ACTIONS(1092),
    [anon_sym_unsigned] = ACTIONS(1092),
    [anon_sym_long] = ACTIONS(1092),
    [anon_sym_short] = ACTIONS(1092),
    [sym_primitive_type] = ACTIONS(1092),
    [anon_sym_enum] = ACTIONS(1092),
    [anon_sym_struct] = ACTIONS(1092),
    [anon_sym_union] = ACTIONS(1092),
    [anon_sym_if] = ACTIONS(1092),
    [anon_sym_switch] = ACTIONS(1092),
    [anon_sym_case] = ACTIONS(1092),
    [anon_sym_default] = ACTIONS(1092),
    [anon_sym_while] = ACTIONS(1092),
    [anon_sym_do] = ACTIONS(1092),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(1092),
    [anon_sym_break] = ACTIONS(1092),
    [anon_sym_continue] = ACTIONS(1092),
    [anon_sym_goto] = ACTIONS(1092),
    [anon_sym_DASH_DASH] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1094),
    [anon_sym_sizeof] = ACTIONS(1092),
    [sym_number_literal] = ACTIONS(1094),
    [anon_sym_L_SQUOTE] = ACTIONS(1094),
    [anon_sym_u_SQUOTE] = ACTIONS(1094),
    [anon_sym_U_SQUOTE] = ACTIONS(1094),
    [anon_sym_u8_SQUOTE] = ACTIONS(1094),
    [anon_sym_SQUOTE] = ACTIONS(1094),
    [anon_sym_L_DQUOTE] = ACTIONS(1094),
    [anon_sym_u_DQUOTE] = ACTIONS(1094),
    [anon_sym_U_DQUOTE] = ACTIONS(1094),
    [anon_sym_u8_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE] = ACTIONS(1094),
    [sym_true] = ACTIONS(1092),
    [sym_false] = ACTIONS(1092),
    [sym_null] = ACTIONS(1092),
    [sym_comment] = ACTIONS(3),
  },
  [283] = {
    [sym_identifier] = ACTIONS(1096),
    [aux_sym_preproc_include_token1] = ACTIONS(1096),
    [aux_sym_preproc_def_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token2] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1096),
    [sym_preproc_directive] = ACTIONS(1096),
    [anon_sym_LPAREN2] = ACTIONS(1098),
    [anon_sym_BANG] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1096),
    [anon_sym_PLUS] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1098),
    [anon_sym_AMP] = ACTIONS(1098),
    [anon_sym_SEMI] = ACTIONS(1098),
    [anon_sym_typedef] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(1096),
    [anon_sym___attribute__] = ACTIONS(1096),
    [anon_sym___declspec] = ACTIONS(1096),
    [anon_sym___cdecl] = ACTIONS(1096),
    [anon_sym___clrcall] = ACTIONS(1096),
    [anon_sym___stdcall] = ACTIONS(1096),
    [anon_sym___fastcall] = ACTIONS(1096),
    [anon_sym___thiscall] = ACTIONS(1096),
    [anon_sym___vectorcall] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1098),
    [anon_sym_static] = ACTIONS(1096),
    [anon_sym_auto] = ACTIONS(1096),
    [anon_sym_register] = ACTIONS(1096),
    [anon_sym_inline] = ACTIONS(1096),
    [anon_sym_const] = ACTIONS(1096),
    [anon_sym_volatile] = ACTIONS(1096),
    [anon_sym_restrict] = ACTIONS(1096),
    [anon_sym__Atomic] = ACTIONS(1096),
    [anon_sym_signed] = ACTIONS(1096),
    [anon_sym_unsigned] = ACTIONS(1096),
    [anon_sym_long] = ACTIONS(1096),
    [anon_sym_short] = ACTIONS(1096),
    [sym_primitive_type] = ACTIONS(1096),
    [anon_sym_enum] = ACTIONS(1096),
    [anon_sym_struct] = ACTIONS(1096),
    [anon_sym_union] = ACTIONS(1096),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_switch] = ACTIONS(1096),
    [anon_sym_case] = ACTIONS(1096),
    [anon_sym_default] = ACTIONS(1096),
    [anon_sym_while] = ACTIONS(1096),
    [anon_sym_do] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1096),
    [anon_sym_return] = ACTIONS(1096),
    [anon_sym_break] = ACTIONS(1096),
    [anon_sym_continue] = ACTIONS(1096),
    [anon_sym_goto] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1098),
    [anon_sym_sizeof] = ACTIONS(1096),
    [sym_number_literal] = ACTIONS(1098),
    [anon_sym_L_SQUOTE] = ACTIONS(1098),
    [anon_sym_u_SQUOTE] = ACTIONS(1098),
    [anon_sym_U_SQUOTE] = ACTIONS(1098),
    [anon_sym_u8_SQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [anon_sym_L_DQUOTE] = ACTIONS(1098),
    [anon_sym_u_DQUOTE] = ACTIONS(1098),
    [anon_sym_U_DQUOTE] = ACTIONS(1098),
    [anon_sym_u8_DQUOTE] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
  },
  [284] = {
    [ts_builtin_sym_end] = ACTIONS(1050),
    [sym_identifier] = ACTIONS(1048),
    [aux_sym_preproc_include_token1] = ACTIONS(1048),
    [aux_sym_preproc_def_token1] = ACTIONS(1048),
    [aux_sym_preproc_if_token1] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1048),
    [sym_preproc_directive] = ACTIONS(1048),
    [anon_sym_LPAREN2] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1048),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(1050),
    [anon_sym_SEMI] = ACTIONS(1050),
    [anon_sym_typedef] = ACTIONS(1048),
    [anon_sym_extern] = ACTIONS(1048),
    [anon_sym___attribute__] = ACTIONS(1048),
    [anon_sym___declspec] = ACTIONS(1048),
    [anon_sym___cdecl] = ACTIONS(1048),
    [anon_sym___clrcall] = ACTIONS(1048),
    [anon_sym___stdcall] = ACTIONS(1048),
    [anon_sym___fastcall] = ACTIONS(1048),
    [anon_sym___thiscall] = ACTIONS(1048),
    [anon_sym___vectorcall] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_static] = ACTIONS(1048),
    [anon_sym_auto] = ACTIONS(1048),
    [anon_sym_register] = ACTIONS(1048),
    [anon_sym_inline] = ACTIONS(1048),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_volatile] = ACTIONS(1048),
    [anon_sym_restrict] = ACTIONS(1048),
    [anon_sym__Atomic] = ACTIONS(1048),
    [anon_sym_signed] = ACTIONS(1048),
    [anon_sym_unsigned] = ACTIONS(1048),
    [anon_sym_long] = ACTIONS(1048),
    [anon_sym_short] = ACTIONS(1048),
    [sym_primitive_type] = ACTIONS(1048),
    [anon_sym_enum] = ACTIONS(1048),
    [anon_sym_struct] = ACTIONS(1048),
    [anon_sym_union] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1048),
    [anon_sym_switch] = ACTIONS(1048),
    [anon_sym_case] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1048),
    [anon_sym_while] = ACTIONS(1048),
    [anon_sym_do] = ACTIONS(1048),
    [anon_sym_for] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [anon_sym_goto] = ACTIONS(1048),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [anon_sym_sizeof] = ACTIONS(1048),
    [sym_number_literal] = ACTIONS(1050),
    [anon_sym_L_SQUOTE] = ACTIONS(1050),
    [anon_sym_u_SQUOTE] = ACTIONS(1050),
    [anon_sym_U_SQUOTE] = ACTIONS(1050),
    [anon_sym_u8_SQUOTE] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [anon_sym_L_DQUOTE] = ACTIONS(1050),
    [anon_sym_u_DQUOTE] = ACTIONS(1050),
    [anon_sym_U_DQUOTE] = ACTIONS(1050),
    [anon_sym_u8_DQUOTE] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_comment] = ACTIONS(3),
  },
  [285] = {
    [sym_identifier] = ACTIONS(1084),
    [aux_sym_preproc_include_token1] = ACTIONS(1084),
    [aux_sym_preproc_def_token1] = ACTIONS(1084),
    [aux_sym_preproc_if_token1] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1084),
    [sym_preproc_directive] = ACTIONS(1084),
    [anon_sym_LPAREN2] = ACTIONS(1086),
    [anon_sym_BANG] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_STAR] = ACTIONS(1086),
    [anon_sym_AMP] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_typedef] = ACTIONS(1084),
    [anon_sym_extern] = ACTIONS(1084),
    [anon_sym___attribute__] = ACTIONS(1084),
    [anon_sym___declspec] = ACTIONS(1084),
    [anon_sym___cdecl] = ACTIONS(1084),
    [anon_sym___clrcall] = ACTIONS(1084),
    [anon_sym___stdcall] = ACTIONS(1084),
    [anon_sym___fastcall] = ACTIONS(1084),
    [anon_sym___thiscall] = ACTIONS(1084),
    [anon_sym___vectorcall] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_RBRACE] = ACTIONS(1086),
    [anon_sym_static] = ACTIONS(1084),
    [anon_sym_auto] = ACTIONS(1084),
    [anon_sym_register] = ACTIONS(1084),
    [anon_sym_inline] = ACTIONS(1084),
    [anon_sym_const] = ACTIONS(1084),
    [anon_sym_volatile] = ACTIONS(1084),
    [anon_sym_restrict] = ACTIONS(1084),
    [anon_sym__Atomic] = ACTIONS(1084),
    [anon_sym_signed] = ACTIONS(1084),
    [anon_sym_unsigned] = ACTIONS(1084),
    [anon_sym_long] = ACTIONS(1084),
    [anon_sym_short] = ACTIONS(1084),
    [sym_primitive_type] = ACTIONS(1084),
    [anon_sym_enum] = ACTIONS(1084),
    [anon_sym_struct] = ACTIONS(1084),
    [anon_sym_union] = ACTIONS(1084),
    [anon_sym_if] = ACTIONS(1084),
    [anon_sym_switch] = ACTIONS(1084),
    [anon_sym_case] = ACTIONS(1084),
    [anon_sym_default] = ACTIONS(1084),
    [anon_sym_while] = ACTIONS(1084),
    [anon_sym_do] = ACTIONS(1084),
    [anon_sym_for] = ACTIONS(1084),
    [anon_sym_return] = ACTIONS(1084),
    [anon_sym_break] = ACTIONS(1084),
    [anon_sym_continue] = ACTIONS(1084),
    [anon_sym_goto] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1084),
    [sym_number_literal] = ACTIONS(1086),
    [anon_sym_L_SQUOTE] = ACTIONS(1086),
    [anon_sym_u_SQUOTE] = ACTIONS(1086),
    [anon_sym_U_SQUOTE] = ACTIONS(1086),
    [anon_sym_u8_SQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1086),
    [anon_sym_L_DQUOTE] = ACTIONS(1086),
    [anon_sym_u_DQUOTE] = ACTIONS(1086),
    [anon_sym_U_DQUOTE] = ACTIONS(1086),
    [anon_sym_u8_DQUOTE] = ACTIONS(1086),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [sym_true] = ACTIONS(1084),
    [sym_false] = ACTIONS(1084),
    [sym_null] = ACTIONS(1084),
    [sym_comment] = ACTIONS(3),
  },
  [286] = {
    [sym_identifier] = ACTIONS(1104),
    [aux_sym_preproc_include_token1] = ACTIONS(1104),
    [aux_sym_preproc_def_token1] = ACTIONS(1104),
    [aux_sym_preproc_if_token1] = ACTIONS(1104),
    [aux_sym_preproc_if_token2] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1104),
    [sym_preproc_directive] = ACTIONS(1104),
    [anon_sym_LPAREN2] = ACTIONS(1106),
    [anon_sym_BANG] = ACTIONS(1106),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_AMP] = ACTIONS(1106),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_typedef] = ACTIONS(1104),
    [anon_sym_extern] = ACTIONS(1104),
    [anon_sym___attribute__] = ACTIONS(1104),
    [anon_sym___declspec] = ACTIONS(1104),
    [anon_sym___cdecl] = ACTIONS(1104),
    [anon_sym___clrcall] = ACTIONS(1104),
    [anon_sym___stdcall] = ACTIONS(1104),
    [anon_sym___fastcall] = ACTIONS(1104),
    [anon_sym___thiscall] = ACTIONS(1104),
    [anon_sym___vectorcall] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_auto] = ACTIONS(1104),
    [anon_sym_register] = ACTIONS(1104),
    [anon_sym_inline] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_volatile] = ACTIONS(1104),
    [anon_sym_restrict] = ACTIONS(1104),
    [anon_sym__Atomic] = ACTIONS(1104),
    [anon_sym_signed] = ACTIONS(1104),
    [anon_sym_unsigned] = ACTIONS(1104),
    [anon_sym_long] = ACTIONS(1104),
    [anon_sym_short] = ACTIONS(1104),
    [sym_primitive_type] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [anon_sym_struct] = ACTIONS(1104),
    [anon_sym_union] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_goto] = ACTIONS(1104),
    [anon_sym_DASH_DASH] = ACTIONS(1106),
    [anon_sym_PLUS_PLUS] = ACTIONS(1106),
    [anon_sym_sizeof] = ACTIONS(1104),
    [sym_number_literal] = ACTIONS(1106),
    [anon_sym_L_SQUOTE] = ACTIONS(1106),
    [anon_sym_u_SQUOTE] = ACTIONS(1106),
    [anon_sym_U_SQUOTE] = ACTIONS(1106),
    [anon_sym_u8_SQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [anon_sym_L_DQUOTE] = ACTIONS(1106),
    [anon_sym_u_DQUOTE] = ACTIONS(1106),
    [anon_sym_U_DQUOTE] = ACTIONS(1106),
    [anon_sym_u8_DQUOTE] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_comment] = ACTIONS(3),
  },
  [287] = {
    [sym_identifier] = ACTIONS(1072),
    [aux_sym_preproc_include_token1] = ACTIONS(1072),
    [aux_sym_preproc_def_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1072),
    [sym_preproc_directive] = ACTIONS(1072),
    [anon_sym_LPAREN2] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_typedef] = ACTIONS(1072),
    [anon_sym_extern] = ACTIONS(1072),
    [anon_sym___attribute__] = ACTIONS(1072),
    [anon_sym___declspec] = ACTIONS(1072),
    [anon_sym___cdecl] = ACTIONS(1072),
    [anon_sym___clrcall] = ACTIONS(1072),
    [anon_sym___stdcall] = ACTIONS(1072),
    [anon_sym___fastcall] = ACTIONS(1072),
    [anon_sym___thiscall] = ACTIONS(1072),
    [anon_sym___vectorcall] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1074),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_auto] = ACTIONS(1072),
    [anon_sym_register] = ACTIONS(1072),
    [anon_sym_inline] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_volatile] = ACTIONS(1072),
    [anon_sym_restrict] = ACTIONS(1072),
    [anon_sym__Atomic] = ACTIONS(1072),
    [anon_sym_signed] = ACTIONS(1072),
    [anon_sym_unsigned] = ACTIONS(1072),
    [anon_sym_long] = ACTIONS(1072),
    [anon_sym_short] = ACTIONS(1072),
    [sym_primitive_type] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1072),
    [anon_sym_union] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1072),
    [anon_sym_default] = ACTIONS(1072),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_do] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_goto] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_sizeof] = ACTIONS(1072),
    [sym_number_literal] = ACTIONS(1074),
    [anon_sym_L_SQUOTE] = ACTIONS(1074),
    [anon_sym_u_SQUOTE] = ACTIONS(1074),
    [anon_sym_U_SQUOTE] = ACTIONS(1074),
    [anon_sym_u8_SQUOTE] = ACTIONS(1074),
    [anon_sym_SQUOTE] = ACTIONS(1074),
    [anon_sym_L_DQUOTE] = ACTIONS(1074),
    [anon_sym_u_DQUOTE] = ACTIONS(1074),
    [anon_sym_U_DQUOTE] = ACTIONS(1074),
    [anon_sym_u8_DQUOTE] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_null] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
  },
  [288] = {
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1100),
    [aux_sym_preproc_include_token1] = ACTIONS(1100),
    [aux_sym_preproc_def_token1] = ACTIONS(1100),
    [aux_sym_preproc_if_token1] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1100),
    [sym_preproc_directive] = ACTIONS(1100),
    [anon_sym_LPAREN2] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_AMP] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_typedef] = ACTIONS(1100),
    [anon_sym_extern] = ACTIONS(1100),
    [anon_sym___attribute__] = ACTIONS(1100),
    [anon_sym___declspec] = ACTIONS(1100),
    [anon_sym___cdecl] = ACTIONS(1100),
    [anon_sym___clrcall] = ACTIONS(1100),
    [anon_sym___stdcall] = ACTIONS(1100),
    [anon_sym___fastcall] = ACTIONS(1100),
    [anon_sym___thiscall] = ACTIONS(1100),
    [anon_sym___vectorcall] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1100),
    [anon_sym_auto] = ACTIONS(1100),
    [anon_sym_register] = ACTIONS(1100),
    [anon_sym_inline] = ACTIONS(1100),
    [anon_sym_const] = ACTIONS(1100),
    [anon_sym_volatile] = ACTIONS(1100),
    [anon_sym_restrict] = ACTIONS(1100),
    [anon_sym__Atomic] = ACTIONS(1100),
    [anon_sym_signed] = ACTIONS(1100),
    [anon_sym_unsigned] = ACTIONS(1100),
    [anon_sym_long] = ACTIONS(1100),
    [anon_sym_short] = ACTIONS(1100),
    [sym_primitive_type] = ACTIONS(1100),
    [anon_sym_enum] = ACTIONS(1100),
    [anon_sym_struct] = ACTIONS(1100),
    [anon_sym_union] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_switch] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_do] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_goto] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_sizeof] = ACTIONS(1100),
    [sym_number_literal] = ACTIONS(1102),
    [anon_sym_L_SQUOTE] = ACTIONS(1102),
    [anon_sym_u_SQUOTE] = ACTIONS(1102),
    [anon_sym_U_SQUOTE] = ACTIONS(1102),
    [anon_sym_u8_SQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [anon_sym_L_DQUOTE] = ACTIONS(1102),
    [anon_sym_u_DQUOTE] = ACTIONS(1102),
    [anon_sym_U_DQUOTE] = ACTIONS(1102),
    [anon_sym_u8_DQUOTE] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_null] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
  },
  [289] = {
    [sym_identifier] = ACTIONS(1068),
    [aux_sym_preproc_include_token1] = ACTIONS(1068),
    [aux_sym_preproc_def_token1] = ACTIONS(1068),
    [aux_sym_preproc_if_token1] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1068),
    [sym_preproc_directive] = ACTIONS(1068),
    [anon_sym_LPAREN2] = ACTIONS(1070),
    [anon_sym_BANG] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_typedef] = ACTIONS(1068),
    [anon_sym_extern] = ACTIONS(1068),
    [anon_sym___attribute__] = ACTIONS(1068),
    [anon_sym___declspec] = ACTIONS(1068),
    [anon_sym___cdecl] = ACTIONS(1068),
    [anon_sym___clrcall] = ACTIONS(1068),
    [anon_sym___stdcall] = ACTIONS(1068),
    [anon_sym___fastcall] = ACTIONS(1068),
    [anon_sym___thiscall] = ACTIONS(1068),
    [anon_sym___vectorcall] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_RBRACE] = ACTIONS(1070),
    [anon_sym_static] = ACTIONS(1068),
    [anon_sym_auto] = ACTIONS(1068),
    [anon_sym_register] = ACTIONS(1068),
    [anon_sym_inline] = ACTIONS(1068),
    [anon_sym_const] = ACTIONS(1068),
    [anon_sym_volatile] = ACTIONS(1068),
    [anon_sym_restrict] = ACTIONS(1068),
    [anon_sym__Atomic] = ACTIONS(1068),
    [anon_sym_signed] = ACTIONS(1068),
    [anon_sym_unsigned] = ACTIONS(1068),
    [anon_sym_long] = ACTIONS(1068),
    [anon_sym_short] = ACTIONS(1068),
    [sym_primitive_type] = ACTIONS(1068),
    [anon_sym_enum] = ACTIONS(1068),
    [anon_sym_struct] = ACTIONS(1068),
    [anon_sym_union] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_switch] = ACTIONS(1068),
    [anon_sym_case] = ACTIONS(1068),
    [anon_sym_default] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_do] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_goto] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1070),
    [anon_sym_PLUS_PLUS] = ACTIONS(1070),
    [anon_sym_sizeof] = ACTIONS(1068),
    [sym_number_literal] = ACTIONS(1070),
    [anon_sym_L_SQUOTE] = ACTIONS(1070),
    [anon_sym_u_SQUOTE] = ACTIONS(1070),
    [anon_sym_U_SQUOTE] = ACTIONS(1070),
    [anon_sym_u8_SQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [anon_sym_L_DQUOTE] = ACTIONS(1070),
    [anon_sym_u_DQUOTE] = ACTIONS(1070),
    [anon_sym_U_DQUOTE] = ACTIONS(1070),
    [anon_sym_u8_DQUOTE] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_null] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
  },
  [290] = {
    [ts_builtin_sym_end] = ACTIONS(1058),
    [sym_identifier] = ACTIONS(1056),
    [aux_sym_preproc_include_token1] = ACTIONS(1056),
    [aux_sym_preproc_def_token1] = ACTIONS(1056),
    [aux_sym_preproc_if_token1] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1056),
    [sym_preproc_directive] = ACTIONS(1056),
    [anon_sym_LPAREN2] = ACTIONS(1058),
    [anon_sym_BANG] = ACTIONS(1058),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1056),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_AMP] = ACTIONS(1058),
    [anon_sym_SEMI] = ACTIONS(1058),
    [anon_sym_typedef] = ACTIONS(1056),
    [anon_sym_extern] = ACTIONS(1056),
    [anon_sym___attribute__] = ACTIONS(1056),
    [anon_sym___declspec] = ACTIONS(1056),
    [anon_sym___cdecl] = ACTIONS(1056),
    [anon_sym___clrcall] = ACTIONS(1056),
    [anon_sym___stdcall] = ACTIONS(1056),
    [anon_sym___fastcall] = ACTIONS(1056),
    [anon_sym___thiscall] = ACTIONS(1056),
    [anon_sym___vectorcall] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_auto] = ACTIONS(1056),
    [anon_sym_register] = ACTIONS(1056),
    [anon_sym_inline] = ACTIONS(1056),
    [anon_sym_const] = ACTIONS(1056),
    [anon_sym_volatile] = ACTIONS(1056),
    [anon_sym_restrict] = ACTIONS(1056),
    [anon_sym__Atomic] = ACTIONS(1056),
    [anon_sym_signed] = ACTIONS(1056),
    [anon_sym_unsigned] = ACTIONS(1056),
    [anon_sym_long] = ACTIONS(1056),
    [anon_sym_short] = ACTIONS(1056),
    [sym_primitive_type] = ACTIONS(1056),
    [anon_sym_enum] = ACTIONS(1056),
    [anon_sym_struct] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_switch] = ACTIONS(1056),
    [anon_sym_case] = ACTIONS(1056),
    [anon_sym_default] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_do] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_goto] = ACTIONS(1056),
    [anon_sym_DASH_DASH] = ACTIONS(1058),
    [anon_sym_PLUS_PLUS] = ACTIONS(1058),
    [anon_sym_sizeof] = ACTIONS(1056),
    [sym_number_literal] = ACTIONS(1058),
    [anon_sym_L_SQUOTE] = ACTIONS(1058),
    [anon_sym_u_SQUOTE] = ACTIONS(1058),
    [anon_sym_U_SQUOTE] = ACTIONS(1058),
    [anon_sym_u8_SQUOTE] = ACTIONS(1058),
    [anon_sym_SQUOTE] = ACTIONS(1058),
    [anon_sym_L_DQUOTE] = ACTIONS(1058),
    [anon_sym_u_DQUOTE] = ACTIONS(1058),
    [anon_sym_U_DQUOTE] = ACTIONS(1058),
    [anon_sym_u8_DQUOTE] = ACTIONS(1058),
    [anon_sym_DQUOTE] = ACTIONS(1058),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_null] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
  },
  [291] = {
    [ts_builtin_sym_end] = ACTIONS(1046),
    [sym_identifier] = ACTIONS(1044),
    [aux_sym_preproc_include_token1] = ACTIONS(1044),
    [aux_sym_preproc_def_token1] = ACTIONS(1044),
    [aux_sym_preproc_if_token1] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1044),
    [sym_preproc_directive] = ACTIONS(1044),
    [anon_sym_LPAREN2] = ACTIONS(1046),
    [anon_sym_BANG] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1044),
    [anon_sym_STAR] = ACTIONS(1046),
    [anon_sym_AMP] = ACTIONS(1046),
    [anon_sym_SEMI] = ACTIONS(1046),
    [anon_sym_typedef] = ACTIONS(1044),
    [anon_sym_extern] = ACTIONS(1044),
    [anon_sym___attribute__] = ACTIONS(1044),
    [anon_sym___declspec] = ACTIONS(1044),
    [anon_sym___cdecl] = ACTIONS(1044),
    [anon_sym___clrcall] = ACTIONS(1044),
    [anon_sym___stdcall] = ACTIONS(1044),
    [anon_sym___fastcall] = ACTIONS(1044),
    [anon_sym___thiscall] = ACTIONS(1044),
    [anon_sym___vectorcall] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [anon_sym_static] = ACTIONS(1044),
    [anon_sym_auto] = ACTIONS(1044),
    [anon_sym_register] = ACTIONS(1044),
    [anon_sym_inline] = ACTIONS(1044),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym_signed] = ACTIONS(1044),
    [anon_sym_unsigned] = ACTIONS(1044),
    [anon_sym_long] = ACTIONS(1044),
    [anon_sym_short] = ACTIONS(1044),
    [sym_primitive_type] = ACTIONS(1044),
    [anon_sym_enum] = ACTIONS(1044),
    [anon_sym_struct] = ACTIONS(1044),
    [anon_sym_union] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1044),
    [anon_sym_switch] = ACTIONS(1044),
    [anon_sym_case] = ACTIONS(1044),
    [anon_sym_default] = ACTIONS(1044),
    [anon_sym_while] = ACTIONS(1044),
    [anon_sym_do] = ACTIONS(1044),
    [anon_sym_for] = ACTIONS(1044),
    [anon_sym_return] = ACTIONS(1044),
    [anon_sym_break] = ACTIONS(1044),
    [anon_sym_continue] = ACTIONS(1044),
    [anon_sym_goto] = ACTIONS(1044),
    [anon_sym_DASH_DASH] = ACTIONS(1046),
    [anon_sym_PLUS_PLUS] = ACTIONS(1046),
    [anon_sym_sizeof] = ACTIONS(1044),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_L_SQUOTE] = ACTIONS(1046),
    [anon_sym_u_SQUOTE] = ACTIONS(1046),
    [anon_sym_U_SQUOTE] = ACTIONS(1046),
    [anon_sym_u8_SQUOTE] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(1046),
    [anon_sym_L_DQUOTE] = ACTIONS(1046),
    [anon_sym_u_DQUOTE] = ACTIONS(1046),
    [anon_sym_U_DQUOTE] = ACTIONS(1046),
    [anon_sym_u8_DQUOTE] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_comment] = ACTIONS(3),
  },
  [292] = {
    [sym_identifier] = ACTIONS(1100),
    [aux_sym_preproc_include_token1] = ACTIONS(1100),
    [aux_sym_preproc_def_token1] = ACTIONS(1100),
    [aux_sym_preproc_if_token1] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1100),
    [sym_preproc_directive] = ACTIONS(1100),
    [anon_sym_LPAREN2] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_AMP] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_typedef] = ACTIONS(1100),
    [anon_sym_extern] = ACTIONS(1100),
    [anon_sym___attribute__] = ACTIONS(1100),
    [anon_sym___declspec] = ACTIONS(1100),
    [anon_sym___cdecl] = ACTIONS(1100),
    [anon_sym___clrcall] = ACTIONS(1100),
    [anon_sym___stdcall] = ACTIONS(1100),
    [anon_sym___fastcall] = ACTIONS(1100),
    [anon_sym___thiscall] = ACTIONS(1100),
    [anon_sym___vectorcall] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1100),
    [anon_sym_auto] = ACTIONS(1100),
    [anon_sym_register] = ACTIONS(1100),
    [anon_sym_inline] = ACTIONS(1100),
    [anon_sym_const] = ACTIONS(1100),
    [anon_sym_volatile] = ACTIONS(1100),
    [anon_sym_restrict] = ACTIONS(1100),
    [anon_sym__Atomic] = ACTIONS(1100),
    [anon_sym_signed] = ACTIONS(1100),
    [anon_sym_unsigned] = ACTIONS(1100),
    [anon_sym_long] = ACTIONS(1100),
    [anon_sym_short] = ACTIONS(1100),
    [sym_primitive_type] = ACTIONS(1100),
    [anon_sym_enum] = ACTIONS(1100),
    [anon_sym_struct] = ACTIONS(1100),
    [anon_sym_union] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_switch] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_do] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_goto] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_sizeof] = ACTIONS(1100),
    [sym_number_literal] = ACTIONS(1102),
    [anon_sym_L_SQUOTE] = ACTIONS(1102),
    [anon_sym_u_SQUOTE] = ACTIONS(1102),
    [anon_sym_U_SQUOTE] = ACTIONS(1102),
    [anon_sym_u8_SQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [anon_sym_L_DQUOTE] = ACTIONS(1102),
    [anon_sym_u_DQUOTE] = ACTIONS(1102),
    [anon_sym_U_DQUOTE] = ACTIONS(1102),
    [anon_sym_u8_DQUOTE] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_null] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
  },
  [293] = {
    [ts_builtin_sym_end] = ACTIONS(1042),
    [sym_identifier] = ACTIONS(1040),
    [aux_sym_preproc_include_token1] = ACTIONS(1040),
    [aux_sym_preproc_def_token1] = ACTIONS(1040),
    [aux_sym_preproc_if_token1] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1040),
    [sym_preproc_directive] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_typedef] = ACTIONS(1040),
    [anon_sym_extern] = ACTIONS(1040),
    [anon_sym___attribute__] = ACTIONS(1040),
    [anon_sym___declspec] = ACTIONS(1040),
    [anon_sym___cdecl] = ACTIONS(1040),
    [anon_sym___clrcall] = ACTIONS(1040),
    [anon_sym___stdcall] = ACTIONS(1040),
    [anon_sym___fastcall] = ACTIONS(1040),
    [anon_sym___thiscall] = ACTIONS(1040),
    [anon_sym___vectorcall] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1040),
    [anon_sym_auto] = ACTIONS(1040),
    [anon_sym_register] = ACTIONS(1040),
    [anon_sym_inline] = ACTIONS(1040),
    [anon_sym_const] = ACTIONS(1040),
    [anon_sym_volatile] = ACTIONS(1040),
    [anon_sym_restrict] = ACTIONS(1040),
    [anon_sym__Atomic] = ACTIONS(1040),
    [anon_sym_signed] = ACTIONS(1040),
    [anon_sym_unsigned] = ACTIONS(1040),
    [anon_sym_long] = ACTIONS(1040),
    [anon_sym_short] = ACTIONS(1040),
    [sym_primitive_type] = ACTIONS(1040),
    [anon_sym_enum] = ACTIONS(1040),
    [anon_sym_struct] = ACTIONS(1040),
    [anon_sym_union] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1040),
    [anon_sym_case] = ACTIONS(1040),
    [anon_sym_default] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_goto] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1042),
    [anon_sym_sizeof] = ACTIONS(1040),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_L_SQUOTE] = ACTIONS(1042),
    [anon_sym_u_SQUOTE] = ACTIONS(1042),
    [anon_sym_U_SQUOTE] = ACTIONS(1042),
    [anon_sym_u8_SQUOTE] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(1042),
    [anon_sym_L_DQUOTE] = ACTIONS(1042),
    [anon_sym_u_DQUOTE] = ACTIONS(1042),
    [anon_sym_U_DQUOTE] = ACTIONS(1042),
    [anon_sym_u8_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
  },
  [294] = {
    [ts_builtin_sym_end] = ACTIONS(1034),
    [sym_identifier] = ACTIONS(1032),
    [aux_sym_preproc_include_token1] = ACTIONS(1032),
    [aux_sym_preproc_def_token1] = ACTIONS(1032),
    [aux_sym_preproc_if_token1] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1032),
    [sym_preproc_directive] = ACTIONS(1032),
    [anon_sym_LPAREN2] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_STAR] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1034),
    [anon_sym_typedef] = ACTIONS(1032),
    [anon_sym_extern] = ACTIONS(1032),
    [anon_sym___attribute__] = ACTIONS(1032),
    [anon_sym___declspec] = ACTIONS(1032),
    [anon_sym___cdecl] = ACTIONS(1032),
    [anon_sym___clrcall] = ACTIONS(1032),
    [anon_sym___stdcall] = ACTIONS(1032),
    [anon_sym___fastcall] = ACTIONS(1032),
    [anon_sym___thiscall] = ACTIONS(1032),
    [anon_sym___vectorcall] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_static] = ACTIONS(1032),
    [anon_sym_auto] = ACTIONS(1032),
    [anon_sym_register] = ACTIONS(1032),
    [anon_sym_inline] = ACTIONS(1032),
    [anon_sym_const] = ACTIONS(1032),
    [anon_sym_volatile] = ACTIONS(1032),
    [anon_sym_restrict] = ACTIONS(1032),
    [anon_sym__Atomic] = ACTIONS(1032),
    [anon_sym_signed] = ACTIONS(1032),
    [anon_sym_unsigned] = ACTIONS(1032),
    [anon_sym_long] = ACTIONS(1032),
    [anon_sym_short] = ACTIONS(1032),
    [sym_primitive_type] = ACTIONS(1032),
    [anon_sym_enum] = ACTIONS(1032),
    [anon_sym_struct] = ACTIONS(1032),
    [anon_sym_union] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(1032),
    [anon_sym_default] = ACTIONS(1032),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_do] = ACTIONS(1032),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_goto] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1034),
    [anon_sym_PLUS_PLUS] = ACTIONS(1034),
    [anon_sym_sizeof] = ACTIONS(1032),
    [sym_number_literal] = ACTIONS(1034),
    [anon_sym_L_SQUOTE] = ACTIONS(1034),
    [anon_sym_u_SQUOTE] = ACTIONS(1034),
    [anon_sym_U_SQUOTE] = ACTIONS(1034),
    [anon_sym_u8_SQUOTE] = ACTIONS(1034),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [anon_sym_L_DQUOTE] = ACTIONS(1034),
    [anon_sym_u_DQUOTE] = ACTIONS(1034),
    [anon_sym_U_DQUOTE] = ACTIONS(1034),
    [anon_sym_u8_DQUOTE] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [sym_true] = ACTIONS(1032),
    [sym_false] = ACTIONS(1032),
    [sym_null] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [295] = {
    [sym_compound_statement] = STATE(133),
    [sym_labeled_statement] = STATE(133),
    [sym_expression_statement] = STATE(133),
    [sym_if_statement] = STATE(133),
    [sym_switch_statement] = STATE(133),
    [sym_case_statement] = STATE(133),
    [sym_while_statement] = STATE(133),
    [sym_do_statement] = STATE(133),
    [sym_for_statement] = STATE(133),
    [sym_return_statement] = STATE(133),
    [sym_break_statement] = STATE(133),
    [sym_continue_statement] = STATE(133),
    [sym_goto_statement] = STATE(133),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [296] = {
    [sym_compound_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_case_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [297] = {
    [sym_compound_statement] = STATE(1423),
    [sym_labeled_statement] = STATE(1423),
    [sym_expression_statement] = STATE(1423),
    [sym_if_statement] = STATE(1423),
    [sym_switch_statement] = STATE(1423),
    [sym_case_statement] = STATE(1423),
    [sym_while_statement] = STATE(1423),
    [sym_do_statement] = STATE(1423),
    [sym_for_statement] = STATE(1423),
    [sym_return_statement] = STATE(1423),
    [sym_break_statement] = STATE(1423),
    [sym_continue_statement] = STATE(1423),
    [sym_goto_statement] = STATE(1423),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [298] = {
    [sym_compound_statement] = STATE(214),
    [sym_labeled_statement] = STATE(214),
    [sym_expression_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_switch_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_do_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_return_statement] = STATE(214),
    [sym_break_statement] = STATE(214),
    [sym_continue_statement] = STATE(214),
    [sym_goto_statement] = STATE(214),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [299] = {
    [sym_compound_statement] = STATE(180),
    [sym_labeled_statement] = STATE(180),
    [sym_expression_statement] = STATE(180),
    [sym_if_statement] = STATE(180),
    [sym_switch_statement] = STATE(180),
    [sym_case_statement] = STATE(180),
    [sym_while_statement] = STATE(180),
    [sym_do_statement] = STATE(180),
    [sym_for_statement] = STATE(180),
    [sym_return_statement] = STATE(180),
    [sym_break_statement] = STATE(180),
    [sym_continue_statement] = STATE(180),
    [sym_goto_statement] = STATE(180),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [300] = {
    [sym_compound_statement] = STATE(139),
    [sym_labeled_statement] = STATE(139),
    [sym_expression_statement] = STATE(139),
    [sym_if_statement] = STATE(139),
    [sym_switch_statement] = STATE(139),
    [sym_case_statement] = STATE(139),
    [sym_while_statement] = STATE(139),
    [sym_do_statement] = STATE(139),
    [sym_for_statement] = STATE(139),
    [sym_return_statement] = STATE(139),
    [sym_break_statement] = STATE(139),
    [sym_continue_statement] = STATE(139),
    [sym_goto_statement] = STATE(139),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [301] = {
    [sym_compound_statement] = STATE(143),
    [sym_labeled_statement] = STATE(143),
    [sym_expression_statement] = STATE(143),
    [sym_if_statement] = STATE(143),
    [sym_switch_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_do_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_return_statement] = STATE(143),
    [sym_break_statement] = STATE(143),
    [sym_continue_statement] = STATE(143),
    [sym_goto_statement] = STATE(143),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [302] = {
    [sym_compound_statement] = STATE(229),
    [sym_labeled_statement] = STATE(229),
    [sym_expression_statement] = STATE(229),
    [sym_if_statement] = STATE(229),
    [sym_switch_statement] = STATE(229),
    [sym_case_statement] = STATE(229),
    [sym_while_statement] = STATE(229),
    [sym_do_statement] = STATE(229),
    [sym_for_statement] = STATE(229),
    [sym_return_statement] = STATE(229),
    [sym_break_statement] = STATE(229),
    [sym_continue_statement] = STATE(229),
    [sym_goto_statement] = STATE(229),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [303] = {
    [sym_compound_statement] = STATE(210),
    [sym_labeled_statement] = STATE(210),
    [sym_expression_statement] = STATE(210),
    [sym_if_statement] = STATE(210),
    [sym_switch_statement] = STATE(210),
    [sym_case_statement] = STATE(210),
    [sym_while_statement] = STATE(210),
    [sym_do_statement] = STATE(210),
    [sym_for_statement] = STATE(210),
    [sym_return_statement] = STATE(210),
    [sym_break_statement] = STATE(210),
    [sym_continue_statement] = STATE(210),
    [sym_goto_statement] = STATE(210),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [304] = {
    [sym_compound_statement] = STATE(228),
    [sym_labeled_statement] = STATE(228),
    [sym_expression_statement] = STATE(228),
    [sym_if_statement] = STATE(228),
    [sym_switch_statement] = STATE(228),
    [sym_case_statement] = STATE(228),
    [sym_while_statement] = STATE(228),
    [sym_do_statement] = STATE(228),
    [sym_for_statement] = STATE(228),
    [sym_return_statement] = STATE(228),
    [sym_break_statement] = STATE(228),
    [sym_continue_statement] = STATE(228),
    [sym_goto_statement] = STATE(228),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [305] = {
    [sym_compound_statement] = STATE(144),
    [sym_labeled_statement] = STATE(144),
    [sym_expression_statement] = STATE(144),
    [sym_if_statement] = STATE(144),
    [sym_switch_statement] = STATE(144),
    [sym_case_statement] = STATE(144),
    [sym_while_statement] = STATE(144),
    [sym_do_statement] = STATE(144),
    [sym_for_statement] = STATE(144),
    [sym_return_statement] = STATE(144),
    [sym_break_statement] = STATE(144),
    [sym_continue_statement] = STATE(144),
    [sym_goto_statement] = STATE(144),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [sym_compound_statement] = STATE(71),
    [sym_labeled_statement] = STATE(71),
    [sym_expression_statement] = STATE(71),
    [sym_if_statement] = STATE(71),
    [sym_switch_statement] = STATE(71),
    [sym_case_statement] = STATE(71),
    [sym_while_statement] = STATE(71),
    [sym_do_statement] = STATE(71),
    [sym_for_statement] = STATE(71),
    [sym_return_statement] = STATE(71),
    [sym_break_statement] = STATE(71),
    [sym_continue_statement] = STATE(71),
    [sym_goto_statement] = STATE(71),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [307] = {
    [sym_compound_statement] = STATE(206),
    [sym_labeled_statement] = STATE(206),
    [sym_expression_statement] = STATE(206),
    [sym_if_statement] = STATE(206),
    [sym_switch_statement] = STATE(206),
    [sym_case_statement] = STATE(206),
    [sym_while_statement] = STATE(206),
    [sym_do_statement] = STATE(206),
    [sym_for_statement] = STATE(206),
    [sym_return_statement] = STATE(206),
    [sym_break_statement] = STATE(206),
    [sym_continue_statement] = STATE(206),
    [sym_goto_statement] = STATE(206),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [308] = {
    [sym_compound_statement] = STATE(1414),
    [sym_labeled_statement] = STATE(1414),
    [sym_expression_statement] = STATE(1414),
    [sym_if_statement] = STATE(1414),
    [sym_switch_statement] = STATE(1414),
    [sym_case_statement] = STATE(1414),
    [sym_while_statement] = STATE(1414),
    [sym_do_statement] = STATE(1414),
    [sym_for_statement] = STATE(1414),
    [sym_return_statement] = STATE(1414),
    [sym_break_statement] = STATE(1414),
    [sym_continue_statement] = STATE(1414),
    [sym_goto_statement] = STATE(1414),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [sym_compound_statement] = STATE(202),
    [sym_labeled_statement] = STATE(202),
    [sym_expression_statement] = STATE(202),
    [sym_if_statement] = STATE(202),
    [sym_switch_statement] = STATE(202),
    [sym_case_statement] = STATE(202),
    [sym_while_statement] = STATE(202),
    [sym_do_statement] = STATE(202),
    [sym_for_statement] = STATE(202),
    [sym_return_statement] = STATE(202),
    [sym_break_statement] = STATE(202),
    [sym_continue_statement] = STATE(202),
    [sym_goto_statement] = STATE(202),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [310] = {
    [sym_compound_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_switch_statement] = STATE(178),
    [sym_case_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_goto_statement] = STATE(178),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [sym_compound_statement] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [312] = {
    [sym_compound_statement] = STATE(165),
    [sym_labeled_statement] = STATE(165),
    [sym_expression_statement] = STATE(165),
    [sym_if_statement] = STATE(165),
    [sym_switch_statement] = STATE(165),
    [sym_case_statement] = STATE(165),
    [sym_while_statement] = STATE(165),
    [sym_do_statement] = STATE(165),
    [sym_for_statement] = STATE(165),
    [sym_return_statement] = STATE(165),
    [sym_break_statement] = STATE(165),
    [sym_continue_statement] = STATE(165),
    [sym_goto_statement] = STATE(165),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [313] = {
    [sym_compound_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [sym_compound_statement] = STATE(173),
    [sym_labeled_statement] = STATE(173),
    [sym_expression_statement] = STATE(173),
    [sym_if_statement] = STATE(173),
    [sym_switch_statement] = STATE(173),
    [sym_case_statement] = STATE(173),
    [sym_while_statement] = STATE(173),
    [sym_do_statement] = STATE(173),
    [sym_for_statement] = STATE(173),
    [sym_return_statement] = STATE(173),
    [sym_break_statement] = STATE(173),
    [sym_continue_statement] = STATE(173),
    [sym_goto_statement] = STATE(173),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [315] = {
    [sym_compound_statement] = STATE(218),
    [sym_labeled_statement] = STATE(218),
    [sym_expression_statement] = STATE(218),
    [sym_if_statement] = STATE(218),
    [sym_switch_statement] = STATE(218),
    [sym_case_statement] = STATE(218),
    [sym_while_statement] = STATE(218),
    [sym_do_statement] = STATE(218),
    [sym_for_statement] = STATE(218),
    [sym_return_statement] = STATE(218),
    [sym_break_statement] = STATE(218),
    [sym_continue_statement] = STATE(218),
    [sym_goto_statement] = STATE(218),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [316] = {
    [sym_compound_statement] = STATE(1339),
    [sym_labeled_statement] = STATE(1339),
    [sym_expression_statement] = STATE(1339),
    [sym_if_statement] = STATE(1339),
    [sym_switch_statement] = STATE(1339),
    [sym_case_statement] = STATE(1339),
    [sym_while_statement] = STATE(1339),
    [sym_do_statement] = STATE(1339),
    [sym_for_statement] = STATE(1339),
    [sym_return_statement] = STATE(1339),
    [sym_break_statement] = STATE(1339),
    [sym_continue_statement] = STATE(1339),
    [sym_goto_statement] = STATE(1339),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [317] = {
    [sym_compound_statement] = STATE(219),
    [sym_labeled_statement] = STATE(219),
    [sym_expression_statement] = STATE(219),
    [sym_if_statement] = STATE(219),
    [sym_switch_statement] = STATE(219),
    [sym_case_statement] = STATE(219),
    [sym_while_statement] = STATE(219),
    [sym_do_statement] = STATE(219),
    [sym_for_statement] = STATE(219),
    [sym_return_statement] = STATE(219),
    [sym_break_statement] = STATE(219),
    [sym_continue_statement] = STATE(219),
    [sym_goto_statement] = STATE(219),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [318] = {
    [sym_compound_statement] = STATE(127),
    [sym_labeled_statement] = STATE(127),
    [sym_expression_statement] = STATE(127),
    [sym_if_statement] = STATE(127),
    [sym_switch_statement] = STATE(127),
    [sym_case_statement] = STATE(127),
    [sym_while_statement] = STATE(127),
    [sym_do_statement] = STATE(127),
    [sym_for_statement] = STATE(127),
    [sym_return_statement] = STATE(127),
    [sym_break_statement] = STATE(127),
    [sym_continue_statement] = STATE(127),
    [sym_goto_statement] = STATE(127),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [319] = {
    [sym_compound_statement] = STATE(205),
    [sym_labeled_statement] = STATE(205),
    [sym_expression_statement] = STATE(205),
    [sym_if_statement] = STATE(205),
    [sym_switch_statement] = STATE(205),
    [sym_case_statement] = STATE(205),
    [sym_while_statement] = STATE(205),
    [sym_do_statement] = STATE(205),
    [sym_for_statement] = STATE(205),
    [sym_return_statement] = STATE(205),
    [sym_break_statement] = STATE(205),
    [sym_continue_statement] = STATE(205),
    [sym_goto_statement] = STATE(205),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [320] = {
    [sym_compound_statement] = STATE(215),
    [sym_labeled_statement] = STATE(215),
    [sym_expression_statement] = STATE(215),
    [sym_if_statement] = STATE(215),
    [sym_switch_statement] = STATE(215),
    [sym_case_statement] = STATE(215),
    [sym_while_statement] = STATE(215),
    [sym_do_statement] = STATE(215),
    [sym_for_statement] = STATE(215),
    [sym_return_statement] = STATE(215),
    [sym_break_statement] = STATE(215),
    [sym_continue_statement] = STATE(215),
    [sym_goto_statement] = STATE(215),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [321] = {
    [sym_compound_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [322] = {
    [sym_compound_statement] = STATE(213),
    [sym_labeled_statement] = STATE(213),
    [sym_expression_statement] = STATE(213),
    [sym_if_statement] = STATE(213),
    [sym_switch_statement] = STATE(213),
    [sym_case_statement] = STATE(213),
    [sym_while_statement] = STATE(213),
    [sym_do_statement] = STATE(213),
    [sym_for_statement] = STATE(213),
    [sym_return_statement] = STATE(213),
    [sym_break_statement] = STATE(213),
    [sym_continue_statement] = STATE(213),
    [sym_goto_statement] = STATE(213),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [323] = {
    [sym_compound_statement] = STATE(89),
    [sym_labeled_statement] = STATE(89),
    [sym_expression_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_switch_statement] = STATE(89),
    [sym_case_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_do_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_return_statement] = STATE(89),
    [sym_break_statement] = STATE(89),
    [sym_continue_statement] = STATE(89),
    [sym_goto_statement] = STATE(89),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [324] = {
    [sym_compound_statement] = STATE(202),
    [sym_labeled_statement] = STATE(202),
    [sym_expression_statement] = STATE(202),
    [sym_if_statement] = STATE(202),
    [sym_switch_statement] = STATE(202),
    [sym_case_statement] = STATE(202),
    [sym_while_statement] = STATE(202),
    [sym_do_statement] = STATE(202),
    [sym_for_statement] = STATE(202),
    [sym_return_statement] = STATE(202),
    [sym_break_statement] = STATE(202),
    [sym_continue_statement] = STATE(202),
    [sym_goto_statement] = STATE(202),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [325] = {
    [sym_compound_statement] = STATE(85),
    [sym_labeled_statement] = STATE(85),
    [sym_expression_statement] = STATE(85),
    [sym_if_statement] = STATE(85),
    [sym_switch_statement] = STATE(85),
    [sym_case_statement] = STATE(85),
    [sym_while_statement] = STATE(85),
    [sym_do_statement] = STATE(85),
    [sym_for_statement] = STATE(85),
    [sym_return_statement] = STATE(85),
    [sym_break_statement] = STATE(85),
    [sym_continue_statement] = STATE(85),
    [sym_goto_statement] = STATE(85),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [326] = {
    [sym_compound_statement] = STATE(185),
    [sym_labeled_statement] = STATE(185),
    [sym_expression_statement] = STATE(185),
    [sym_if_statement] = STATE(185),
    [sym_switch_statement] = STATE(185),
    [sym_case_statement] = STATE(185),
    [sym_while_statement] = STATE(185),
    [sym_do_statement] = STATE(185),
    [sym_for_statement] = STATE(185),
    [sym_return_statement] = STATE(185),
    [sym_break_statement] = STATE(185),
    [sym_continue_statement] = STATE(185),
    [sym_goto_statement] = STATE(185),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [327] = {
    [sym_compound_statement] = STATE(196),
    [sym_labeled_statement] = STATE(196),
    [sym_expression_statement] = STATE(196),
    [sym_if_statement] = STATE(196),
    [sym_switch_statement] = STATE(196),
    [sym_case_statement] = STATE(196),
    [sym_while_statement] = STATE(196),
    [sym_do_statement] = STATE(196),
    [sym_for_statement] = STATE(196),
    [sym_return_statement] = STATE(196),
    [sym_break_statement] = STATE(196),
    [sym_continue_statement] = STATE(196),
    [sym_goto_statement] = STATE(196),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [328] = {
    [sym_compound_statement] = STATE(82),
    [sym_labeled_statement] = STATE(82),
    [sym_expression_statement] = STATE(82),
    [sym_if_statement] = STATE(82),
    [sym_switch_statement] = STATE(82),
    [sym_case_statement] = STATE(82),
    [sym_while_statement] = STATE(82),
    [sym_do_statement] = STATE(82),
    [sym_for_statement] = STATE(82),
    [sym_return_statement] = STATE(82),
    [sym_break_statement] = STATE(82),
    [sym_continue_statement] = STATE(82),
    [sym_goto_statement] = STATE(82),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [329] = {
    [sym_compound_statement] = STATE(222),
    [sym_labeled_statement] = STATE(222),
    [sym_expression_statement] = STATE(222),
    [sym_if_statement] = STATE(222),
    [sym_switch_statement] = STATE(222),
    [sym_case_statement] = STATE(222),
    [sym_while_statement] = STATE(222),
    [sym_do_statement] = STATE(222),
    [sym_for_statement] = STATE(222),
    [sym_return_statement] = STATE(222),
    [sym_break_statement] = STATE(222),
    [sym_continue_statement] = STATE(222),
    [sym_goto_statement] = STATE(222),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [330] = {
    [sym_compound_statement] = STATE(205),
    [sym_labeled_statement] = STATE(205),
    [sym_expression_statement] = STATE(205),
    [sym_if_statement] = STATE(205),
    [sym_switch_statement] = STATE(205),
    [sym_case_statement] = STATE(205),
    [sym_while_statement] = STATE(205),
    [sym_do_statement] = STATE(205),
    [sym_for_statement] = STATE(205),
    [sym_return_statement] = STATE(205),
    [sym_break_statement] = STATE(205),
    [sym_continue_statement] = STATE(205),
    [sym_goto_statement] = STATE(205),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [331] = {
    [sym_compound_statement] = STATE(184),
    [sym_labeled_statement] = STATE(184),
    [sym_expression_statement] = STATE(184),
    [sym_if_statement] = STATE(184),
    [sym_switch_statement] = STATE(184),
    [sym_case_statement] = STATE(184),
    [sym_while_statement] = STATE(184),
    [sym_do_statement] = STATE(184),
    [sym_for_statement] = STATE(184),
    [sym_return_statement] = STATE(184),
    [sym_break_statement] = STATE(184),
    [sym_continue_statement] = STATE(184),
    [sym_goto_statement] = STATE(184),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [332] = {
    [sym_compound_statement] = STATE(216),
    [sym_labeled_statement] = STATE(216),
    [sym_expression_statement] = STATE(216),
    [sym_if_statement] = STATE(216),
    [sym_switch_statement] = STATE(216),
    [sym_case_statement] = STATE(216),
    [sym_while_statement] = STATE(216),
    [sym_do_statement] = STATE(216),
    [sym_for_statement] = STATE(216),
    [sym_return_statement] = STATE(216),
    [sym_break_statement] = STATE(216),
    [sym_continue_statement] = STATE(216),
    [sym_goto_statement] = STATE(216),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [333] = {
    [sym_compound_statement] = STATE(219),
    [sym_labeled_statement] = STATE(219),
    [sym_expression_statement] = STATE(219),
    [sym_if_statement] = STATE(219),
    [sym_switch_statement] = STATE(219),
    [sym_case_statement] = STATE(219),
    [sym_while_statement] = STATE(219),
    [sym_do_statement] = STATE(219),
    [sym_for_statement] = STATE(219),
    [sym_return_statement] = STATE(219),
    [sym_break_statement] = STATE(219),
    [sym_continue_statement] = STATE(219),
    [sym_goto_statement] = STATE(219),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [334] = {
    [sym_compound_statement] = STATE(214),
    [sym_labeled_statement] = STATE(214),
    [sym_expression_statement] = STATE(214),
    [sym_if_statement] = STATE(214),
    [sym_switch_statement] = STATE(214),
    [sym_case_statement] = STATE(214),
    [sym_while_statement] = STATE(214),
    [sym_do_statement] = STATE(214),
    [sym_for_statement] = STATE(214),
    [sym_return_statement] = STATE(214),
    [sym_break_statement] = STATE(214),
    [sym_continue_statement] = STATE(214),
    [sym_goto_statement] = STATE(214),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [335] = {
    [sym_compound_statement] = STATE(172),
    [sym_labeled_statement] = STATE(172),
    [sym_expression_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_switch_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_while_statement] = STATE(172),
    [sym_do_statement] = STATE(172),
    [sym_for_statement] = STATE(172),
    [sym_return_statement] = STATE(172),
    [sym_break_statement] = STATE(172),
    [sym_continue_statement] = STATE(172),
    [sym_goto_statement] = STATE(172),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [336] = {
    [sym_compound_statement] = STATE(161),
    [sym_labeled_statement] = STATE(161),
    [sym_expression_statement] = STATE(161),
    [sym_if_statement] = STATE(161),
    [sym_switch_statement] = STATE(161),
    [sym_case_statement] = STATE(161),
    [sym_while_statement] = STATE(161),
    [sym_do_statement] = STATE(161),
    [sym_for_statement] = STATE(161),
    [sym_return_statement] = STATE(161),
    [sym_break_statement] = STATE(161),
    [sym_continue_statement] = STATE(161),
    [sym_goto_statement] = STATE(161),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [337] = {
    [sym_compound_statement] = STATE(146),
    [sym_labeled_statement] = STATE(146),
    [sym_expression_statement] = STATE(146),
    [sym_if_statement] = STATE(146),
    [sym_switch_statement] = STATE(146),
    [sym_case_statement] = STATE(146),
    [sym_while_statement] = STATE(146),
    [sym_do_statement] = STATE(146),
    [sym_for_statement] = STATE(146),
    [sym_return_statement] = STATE(146),
    [sym_break_statement] = STATE(146),
    [sym_continue_statement] = STATE(146),
    [sym_goto_statement] = STATE(146),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [338] = {
    [sym_compound_statement] = STATE(127),
    [sym_labeled_statement] = STATE(127),
    [sym_expression_statement] = STATE(127),
    [sym_if_statement] = STATE(127),
    [sym_switch_statement] = STATE(127),
    [sym_case_statement] = STATE(127),
    [sym_while_statement] = STATE(127),
    [sym_do_statement] = STATE(127),
    [sym_for_statement] = STATE(127),
    [sym_return_statement] = STATE(127),
    [sym_break_statement] = STATE(127),
    [sym_continue_statement] = STATE(127),
    [sym_goto_statement] = STATE(127),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [339] = {
    [sym_compound_statement] = STATE(81),
    [sym_labeled_statement] = STATE(81),
    [sym_expression_statement] = STATE(81),
    [sym_if_statement] = STATE(81),
    [sym_switch_statement] = STATE(81),
    [sym_case_statement] = STATE(81),
    [sym_while_statement] = STATE(81),
    [sym_do_statement] = STATE(81),
    [sym_for_statement] = STATE(81),
    [sym_return_statement] = STATE(81),
    [sym_break_statement] = STATE(81),
    [sym_continue_statement] = STATE(81),
    [sym_goto_statement] = STATE(81),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [340] = {
    [sym_compound_statement] = STATE(79),
    [sym_labeled_statement] = STATE(79),
    [sym_expression_statement] = STATE(79),
    [sym_if_statement] = STATE(79),
    [sym_switch_statement] = STATE(79),
    [sym_case_statement] = STATE(79),
    [sym_while_statement] = STATE(79),
    [sym_do_statement] = STATE(79),
    [sym_for_statement] = STATE(79),
    [sym_return_statement] = STATE(79),
    [sym_break_statement] = STATE(79),
    [sym_continue_statement] = STATE(79),
    [sym_goto_statement] = STATE(79),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [341] = {
    [sym_compound_statement] = STATE(229),
    [sym_labeled_statement] = STATE(229),
    [sym_expression_statement] = STATE(229),
    [sym_if_statement] = STATE(229),
    [sym_switch_statement] = STATE(229),
    [sym_case_statement] = STATE(229),
    [sym_while_statement] = STATE(229),
    [sym_do_statement] = STATE(229),
    [sym_for_statement] = STATE(229),
    [sym_return_statement] = STATE(229),
    [sym_break_statement] = STATE(229),
    [sym_continue_statement] = STATE(229),
    [sym_goto_statement] = STATE(229),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [342] = {
    [sym_compound_statement] = STATE(225),
    [sym_labeled_statement] = STATE(225),
    [sym_expression_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_switch_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_do_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_return_statement] = STATE(225),
    [sym_break_statement] = STATE(225),
    [sym_continue_statement] = STATE(225),
    [sym_goto_statement] = STATE(225),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [343] = {
    [sym_compound_statement] = STATE(226),
    [sym_labeled_statement] = STATE(226),
    [sym_expression_statement] = STATE(226),
    [sym_if_statement] = STATE(226),
    [sym_switch_statement] = STATE(226),
    [sym_case_statement] = STATE(226),
    [sym_while_statement] = STATE(226),
    [sym_do_statement] = STATE(226),
    [sym_for_statement] = STATE(226),
    [sym_return_statement] = STATE(226),
    [sym_break_statement] = STATE(226),
    [sym_continue_statement] = STATE(226),
    [sym_goto_statement] = STATE(226),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [344] = {
    [sym_compound_statement] = STATE(228),
    [sym_labeled_statement] = STATE(228),
    [sym_expression_statement] = STATE(228),
    [sym_if_statement] = STATE(228),
    [sym_switch_statement] = STATE(228),
    [sym_case_statement] = STATE(228),
    [sym_while_statement] = STATE(228),
    [sym_do_statement] = STATE(228),
    [sym_for_statement] = STATE(228),
    [sym_return_statement] = STATE(228),
    [sym_break_statement] = STATE(228),
    [sym_continue_statement] = STATE(228),
    [sym_goto_statement] = STATE(228),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [345] = {
    [sym_compound_statement] = STATE(190),
    [sym_labeled_statement] = STATE(190),
    [sym_expression_statement] = STATE(190),
    [sym_if_statement] = STATE(190),
    [sym_switch_statement] = STATE(190),
    [sym_case_statement] = STATE(190),
    [sym_while_statement] = STATE(190),
    [sym_do_statement] = STATE(190),
    [sym_for_statement] = STATE(190),
    [sym_return_statement] = STATE(190),
    [sym_break_statement] = STATE(190),
    [sym_continue_statement] = STATE(190),
    [sym_goto_statement] = STATE(190),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [346] = {
    [sym_compound_statement] = STATE(218),
    [sym_labeled_statement] = STATE(218),
    [sym_expression_statement] = STATE(218),
    [sym_if_statement] = STATE(218),
    [sym_switch_statement] = STATE(218),
    [sym_case_statement] = STATE(218),
    [sym_while_statement] = STATE(218),
    [sym_do_statement] = STATE(218),
    [sym_for_statement] = STATE(218),
    [sym_return_statement] = STATE(218),
    [sym_break_statement] = STATE(218),
    [sym_continue_statement] = STATE(218),
    [sym_goto_statement] = STATE(218),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [347] = {
    [sym_compound_statement] = STATE(210),
    [sym_labeled_statement] = STATE(210),
    [sym_expression_statement] = STATE(210),
    [sym_if_statement] = STATE(210),
    [sym_switch_statement] = STATE(210),
    [sym_case_statement] = STATE(210),
    [sym_while_statement] = STATE(210),
    [sym_do_statement] = STATE(210),
    [sym_for_statement] = STATE(210),
    [sym_return_statement] = STATE(210),
    [sym_break_statement] = STATE(210),
    [sym_continue_statement] = STATE(210),
    [sym_goto_statement] = STATE(210),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [348] = {
    [sym_compound_statement] = STATE(1215),
    [sym_labeled_statement] = STATE(1215),
    [sym_expression_statement] = STATE(1215),
    [sym_if_statement] = STATE(1215),
    [sym_switch_statement] = STATE(1215),
    [sym_case_statement] = STATE(1215),
    [sym_while_statement] = STATE(1215),
    [sym_do_statement] = STATE(1215),
    [sym_for_statement] = STATE(1215),
    [sym_return_statement] = STATE(1215),
    [sym_break_statement] = STATE(1215),
    [sym_continue_statement] = STATE(1215),
    [sym_goto_statement] = STATE(1215),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [349] = {
    [sym_compound_statement] = STATE(130),
    [sym_labeled_statement] = STATE(130),
    [sym_expression_statement] = STATE(130),
    [sym_if_statement] = STATE(130),
    [sym_switch_statement] = STATE(130),
    [sym_case_statement] = STATE(130),
    [sym_while_statement] = STATE(130),
    [sym_do_statement] = STATE(130),
    [sym_for_statement] = STATE(130),
    [sym_return_statement] = STATE(130),
    [sym_break_statement] = STATE(130),
    [sym_continue_statement] = STATE(130),
    [sym_goto_statement] = STATE(130),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [350] = {
    [sym_compound_statement] = STATE(206),
    [sym_labeled_statement] = STATE(206),
    [sym_expression_statement] = STATE(206),
    [sym_if_statement] = STATE(206),
    [sym_switch_statement] = STATE(206),
    [sym_case_statement] = STATE(206),
    [sym_while_statement] = STATE(206),
    [sym_do_statement] = STATE(206),
    [sym_for_statement] = STATE(206),
    [sym_return_statement] = STATE(206),
    [sym_break_statement] = STATE(206),
    [sym_continue_statement] = STATE(206),
    [sym_goto_statement] = STATE(206),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [351] = {
    [sym_compound_statement] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_case_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [352] = {
    [sym_compound_statement] = STATE(220),
    [sym_labeled_statement] = STATE(220),
    [sym_expression_statement] = STATE(220),
    [sym_if_statement] = STATE(220),
    [sym_switch_statement] = STATE(220),
    [sym_case_statement] = STATE(220),
    [sym_while_statement] = STATE(220),
    [sym_do_statement] = STATE(220),
    [sym_for_statement] = STATE(220),
    [sym_return_statement] = STATE(220),
    [sym_break_statement] = STATE(220),
    [sym_continue_statement] = STATE(220),
    [sym_goto_statement] = STATE(220),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [353] = {
    [sym_compound_statement] = STATE(165),
    [sym_labeled_statement] = STATE(165),
    [sym_expression_statement] = STATE(165),
    [sym_if_statement] = STATE(165),
    [sym_switch_statement] = STATE(165),
    [sym_case_statement] = STATE(165),
    [sym_while_statement] = STATE(165),
    [sym_do_statement] = STATE(165),
    [sym_for_statement] = STATE(165),
    [sym_return_statement] = STATE(165),
    [sym_break_statement] = STATE(165),
    [sym_continue_statement] = STATE(165),
    [sym_goto_statement] = STATE(165),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [354] = {
    [sym_compound_statement] = STATE(1399),
    [sym_labeled_statement] = STATE(1399),
    [sym_expression_statement] = STATE(1399),
    [sym_if_statement] = STATE(1399),
    [sym_switch_statement] = STATE(1399),
    [sym_case_statement] = STATE(1399),
    [sym_while_statement] = STATE(1399),
    [sym_do_statement] = STATE(1399),
    [sym_for_statement] = STATE(1399),
    [sym_return_statement] = STATE(1399),
    [sym_break_statement] = STATE(1399),
    [sym_continue_statement] = STATE(1399),
    [sym_goto_statement] = STATE(1399),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [355] = {
    [sym_compound_statement] = STATE(225),
    [sym_labeled_statement] = STATE(225),
    [sym_expression_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_switch_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_do_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_return_statement] = STATE(225),
    [sym_break_statement] = STATE(225),
    [sym_continue_statement] = STATE(225),
    [sym_goto_statement] = STATE(225),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [356] = {
    [sym_compound_statement] = STATE(192),
    [sym_labeled_statement] = STATE(192),
    [sym_expression_statement] = STATE(192),
    [sym_if_statement] = STATE(192),
    [sym_switch_statement] = STATE(192),
    [sym_case_statement] = STATE(192),
    [sym_while_statement] = STATE(192),
    [sym_do_statement] = STATE(192),
    [sym_for_statement] = STATE(192),
    [sym_return_statement] = STATE(192),
    [sym_break_statement] = STATE(192),
    [sym_continue_statement] = STATE(192),
    [sym_goto_statement] = STATE(192),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [357] = {
    [sym_compound_statement] = STATE(216),
    [sym_labeled_statement] = STATE(216),
    [sym_expression_statement] = STATE(216),
    [sym_if_statement] = STATE(216),
    [sym_switch_statement] = STATE(216),
    [sym_case_statement] = STATE(216),
    [sym_while_statement] = STATE(216),
    [sym_do_statement] = STATE(216),
    [sym_for_statement] = STATE(216),
    [sym_return_statement] = STATE(216),
    [sym_break_statement] = STATE(216),
    [sym_continue_statement] = STATE(216),
    [sym_goto_statement] = STATE(216),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [358] = {
    [sym_compound_statement] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_case_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [359] = {
    [sym_compound_statement] = STATE(100),
    [sym_labeled_statement] = STATE(100),
    [sym_expression_statement] = STATE(100),
    [sym_if_statement] = STATE(100),
    [sym_switch_statement] = STATE(100),
    [sym_case_statement] = STATE(100),
    [sym_while_statement] = STATE(100),
    [sym_do_statement] = STATE(100),
    [sym_for_statement] = STATE(100),
    [sym_return_statement] = STATE(100),
    [sym_break_statement] = STATE(100),
    [sym_continue_statement] = STATE(100),
    [sym_goto_statement] = STATE(100),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [360] = {
    [sym_compound_statement] = STATE(93),
    [sym_labeled_statement] = STATE(93),
    [sym_expression_statement] = STATE(93),
    [sym_if_statement] = STATE(93),
    [sym_switch_statement] = STATE(93),
    [sym_case_statement] = STATE(93),
    [sym_while_statement] = STATE(93),
    [sym_do_statement] = STATE(93),
    [sym_for_statement] = STATE(93),
    [sym_return_statement] = STATE(93),
    [sym_break_statement] = STATE(93),
    [sym_continue_statement] = STATE(93),
    [sym_goto_statement] = STATE(93),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [361] = {
    [sym_compound_statement] = STATE(104),
    [sym_labeled_statement] = STATE(104),
    [sym_expression_statement] = STATE(104),
    [sym_if_statement] = STATE(104),
    [sym_switch_statement] = STATE(104),
    [sym_case_statement] = STATE(104),
    [sym_while_statement] = STATE(104),
    [sym_do_statement] = STATE(104),
    [sym_for_statement] = STATE(104),
    [sym_return_statement] = STATE(104),
    [sym_break_statement] = STATE(104),
    [sym_continue_statement] = STATE(104),
    [sym_goto_statement] = STATE(104),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [362] = {
    [sym_compound_statement] = STATE(141),
    [sym_labeled_statement] = STATE(141),
    [sym_expression_statement] = STATE(141),
    [sym_if_statement] = STATE(141),
    [sym_switch_statement] = STATE(141),
    [sym_case_statement] = STATE(141),
    [sym_while_statement] = STATE(141),
    [sym_do_statement] = STATE(141),
    [sym_for_statement] = STATE(141),
    [sym_return_statement] = STATE(141),
    [sym_break_statement] = STATE(141),
    [sym_continue_statement] = STATE(141),
    [sym_goto_statement] = STATE(141),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [363] = {
    [sym_compound_statement] = STATE(156),
    [sym_labeled_statement] = STATE(156),
    [sym_expression_statement] = STATE(156),
    [sym_if_statement] = STATE(156),
    [sym_switch_statement] = STATE(156),
    [sym_case_statement] = STATE(156),
    [sym_while_statement] = STATE(156),
    [sym_do_statement] = STATE(156),
    [sym_for_statement] = STATE(156),
    [sym_return_statement] = STATE(156),
    [sym_break_statement] = STATE(156),
    [sym_continue_statement] = STATE(156),
    [sym_goto_statement] = STATE(156),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [364] = {
    [sym_compound_statement] = STATE(154),
    [sym_labeled_statement] = STATE(154),
    [sym_expression_statement] = STATE(154),
    [sym_if_statement] = STATE(154),
    [sym_switch_statement] = STATE(154),
    [sym_case_statement] = STATE(154),
    [sym_while_statement] = STATE(154),
    [sym_do_statement] = STATE(154),
    [sym_for_statement] = STATE(154),
    [sym_return_statement] = STATE(154),
    [sym_break_statement] = STATE(154),
    [sym_continue_statement] = STATE(154),
    [sym_goto_statement] = STATE(154),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [365] = {
    [sym_compound_statement] = STATE(196),
    [sym_labeled_statement] = STATE(196),
    [sym_expression_statement] = STATE(196),
    [sym_if_statement] = STATE(196),
    [sym_switch_statement] = STATE(196),
    [sym_case_statement] = STATE(196),
    [sym_while_statement] = STATE(196),
    [sym_do_statement] = STATE(196),
    [sym_for_statement] = STATE(196),
    [sym_return_statement] = STATE(196),
    [sym_break_statement] = STATE(196),
    [sym_continue_statement] = STATE(196),
    [sym_goto_statement] = STATE(196),
    [sym__expression] = STATE(656),
    [sym_comma_expression] = STATE(1396),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [366] = {
    [sym_compound_statement] = STATE(230),
    [sym_labeled_statement] = STATE(230),
    [sym_expression_statement] = STATE(230),
    [sym_if_statement] = STATE(230),
    [sym_switch_statement] = STATE(230),
    [sym_case_statement] = STATE(230),
    [sym_while_statement] = STATE(230),
    [sym_do_statement] = STATE(230),
    [sym_for_statement] = STATE(230),
    [sym_return_statement] = STATE(230),
    [sym_break_statement] = STATE(230),
    [sym_continue_statement] = STATE(230),
    [sym_goto_statement] = STATE(230),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [367] = {
    [sym_compound_statement] = STATE(197),
    [sym_labeled_statement] = STATE(197),
    [sym_expression_statement] = STATE(197),
    [sym_if_statement] = STATE(197),
    [sym_switch_statement] = STATE(197),
    [sym_case_statement] = STATE(197),
    [sym_while_statement] = STATE(197),
    [sym_do_statement] = STATE(197),
    [sym_for_statement] = STATE(197),
    [sym_return_statement] = STATE(197),
    [sym_break_statement] = STATE(197),
    [sym_continue_statement] = STATE(197),
    [sym_goto_statement] = STATE(197),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [368] = {
    [sym_compound_statement] = STATE(155),
    [sym_labeled_statement] = STATE(155),
    [sym_expression_statement] = STATE(155),
    [sym_if_statement] = STATE(155),
    [sym_switch_statement] = STATE(155),
    [sym_case_statement] = STATE(155),
    [sym_while_statement] = STATE(155),
    [sym_do_statement] = STATE(155),
    [sym_for_statement] = STATE(155),
    [sym_return_statement] = STATE(155),
    [sym_break_statement] = STATE(155),
    [sym_continue_statement] = STATE(155),
    [sym_goto_statement] = STATE(155),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [369] = {
    [sym_compound_statement] = STATE(138),
    [sym_labeled_statement] = STATE(138),
    [sym_expression_statement] = STATE(138),
    [sym_if_statement] = STATE(138),
    [sym_switch_statement] = STATE(138),
    [sym_case_statement] = STATE(138),
    [sym_while_statement] = STATE(138),
    [sym_do_statement] = STATE(138),
    [sym_for_statement] = STATE(138),
    [sym_return_statement] = STATE(138),
    [sym_break_statement] = STATE(138),
    [sym_continue_statement] = STATE(138),
    [sym_goto_statement] = STATE(138),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [370] = {
    [sym_compound_statement] = STATE(94),
    [sym_labeled_statement] = STATE(94),
    [sym_expression_statement] = STATE(94),
    [sym_if_statement] = STATE(94),
    [sym_switch_statement] = STATE(94),
    [sym_case_statement] = STATE(94),
    [sym_while_statement] = STATE(94),
    [sym_do_statement] = STATE(94),
    [sym_for_statement] = STATE(94),
    [sym_return_statement] = STATE(94),
    [sym_break_statement] = STATE(94),
    [sym_continue_statement] = STATE(94),
    [sym_goto_statement] = STATE(94),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [371] = {
    [sym_compound_statement] = STATE(188),
    [sym_labeled_statement] = STATE(188),
    [sym_expression_statement] = STATE(188),
    [sym_if_statement] = STATE(188),
    [sym_switch_statement] = STATE(188),
    [sym_case_statement] = STATE(188),
    [sym_while_statement] = STATE(188),
    [sym_do_statement] = STATE(188),
    [sym_for_statement] = STATE(188),
    [sym_return_statement] = STATE(188),
    [sym_break_statement] = STATE(188),
    [sym_continue_statement] = STATE(188),
    [sym_goto_statement] = STATE(188),
    [sym__expression] = STATE(679),
    [sym_comma_expression] = STATE(1319),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(318),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_switch] = ACTIONS(324),
    [anon_sym_case] = ACTIONS(326),
    [anon_sym_default] = ACTIONS(328),
    [anon_sym_while] = ACTIONS(330),
    [anon_sym_do] = ACTIONS(332),
    [anon_sym_for] = ACTIONS(334),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(340),
    [anon_sym_goto] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [372] = {
    [sym_compound_statement] = STATE(151),
    [sym_labeled_statement] = STATE(151),
    [sym_expression_statement] = STATE(151),
    [sym_if_statement] = STATE(151),
    [sym_switch_statement] = STATE(151),
    [sym_case_statement] = STATE(151),
    [sym_while_statement] = STATE(151),
    [sym_do_statement] = STATE(151),
    [sym_for_statement] = STATE(151),
    [sym_return_statement] = STATE(151),
    [sym_break_statement] = STATE(151),
    [sym_continue_statement] = STATE(151),
    [sym_goto_statement] = STATE(151),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [373] = {
    [sym_compound_statement] = STATE(150),
    [sym_labeled_statement] = STATE(150),
    [sym_expression_statement] = STATE(150),
    [sym_if_statement] = STATE(150),
    [sym_switch_statement] = STATE(150),
    [sym_case_statement] = STATE(150),
    [sym_while_statement] = STATE(150),
    [sym_do_statement] = STATE(150),
    [sym_for_statement] = STATE(150),
    [sym_return_statement] = STATE(150),
    [sym_break_statement] = STATE(150),
    [sym_continue_statement] = STATE(150),
    [sym_goto_statement] = STATE(150),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [374] = {
    [sym_compound_statement] = STATE(87),
    [sym_labeled_statement] = STATE(87),
    [sym_expression_statement] = STATE(87),
    [sym_if_statement] = STATE(87),
    [sym_switch_statement] = STATE(87),
    [sym_case_statement] = STATE(87),
    [sym_while_statement] = STATE(87),
    [sym_do_statement] = STATE(87),
    [sym_for_statement] = STATE(87),
    [sym_return_statement] = STATE(87),
    [sym_break_statement] = STATE(87),
    [sym_continue_statement] = STATE(87),
    [sym_goto_statement] = STATE(87),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [375] = {
    [sym_compound_statement] = STATE(207),
    [sym_labeled_statement] = STATE(207),
    [sym_expression_statement] = STATE(207),
    [sym_if_statement] = STATE(207),
    [sym_switch_statement] = STATE(207),
    [sym_case_statement] = STATE(207),
    [sym_while_statement] = STATE(207),
    [sym_do_statement] = STATE(207),
    [sym_for_statement] = STATE(207),
    [sym_return_statement] = STATE(207),
    [sym_break_statement] = STATE(207),
    [sym_continue_statement] = STATE(207),
    [sym_goto_statement] = STATE(207),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [376] = {
    [sym_compound_statement] = STATE(105),
    [sym_labeled_statement] = STATE(105),
    [sym_expression_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_switch_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_do_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_return_statement] = STATE(105),
    [sym_break_statement] = STATE(105),
    [sym_continue_statement] = STATE(105),
    [sym_goto_statement] = STATE(105),
    [sym__expression] = STATE(655),
    [sym_comma_expression] = STATE(1271),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_switch] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(125),
    [anon_sym_while] = ACTIONS(127),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_return] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [377] = {
    [sym_compound_statement] = STATE(131),
    [sym_labeled_statement] = STATE(131),
    [sym_expression_statement] = STATE(131),
    [sym_if_statement] = STATE(131),
    [sym_switch_statement] = STATE(131),
    [sym_case_statement] = STATE(131),
    [sym_while_statement] = STATE(131),
    [sym_do_statement] = STATE(131),
    [sym_for_statement] = STATE(131),
    [sym_return_statement] = STATE(131),
    [sym_break_statement] = STATE(131),
    [sym_continue_statement] = STATE(131),
    [sym_goto_statement] = STATE(131),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [378] = {
    [sym_compound_statement] = STATE(137),
    [sym_labeled_statement] = STATE(137),
    [sym_expression_statement] = STATE(137),
    [sym_if_statement] = STATE(137),
    [sym_switch_statement] = STATE(137),
    [sym_case_statement] = STATE(137),
    [sym_while_statement] = STATE(137),
    [sym_do_statement] = STATE(137),
    [sym_for_statement] = STATE(137),
    [sym_return_statement] = STATE(137),
    [sym_break_statement] = STATE(137),
    [sym_continue_statement] = STATE(137),
    [sym_goto_statement] = STATE(137),
    [sym__expression] = STATE(627),
    [sym_comma_expression] = STATE(1252),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_switch] = ACTIONS(374),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(380),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(384),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(388),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_goto] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [379] = {
    [sym__expression] = STATE(505),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_initializer_list] = STATE(537),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_identifier] = ACTIONS(1130),
    [anon_sym_COMMA] = ACTIONS(860),
    [anon_sym_RPAREN] = ACTIONS(860),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_SLASH] = ACTIONS(870),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(870),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(868),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_GT] = ACTIONS(870),
    [anon_sym_GT_EQ] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(860),
    [anon_sym_LT] = ACTIONS(870),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(872),
    [anon_sym_RBRACE] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(860),
    [anon_sym_RBRACK] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(860),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym_DOT] = ACTIONS(870),
    [anon_sym_DASH_GT] = ACTIONS(860),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [380] = {
    [sym_type_qualifier] = STATE(802),
    [sym__type_specifier] = STATE(943),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym__expression] = STATE(688),
    [sym_comma_expression] = STATE(1369),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_type_descriptor] = STATE(1368),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_type_definition_repeat1] = STATE(802),
    [aux_sym_sized_type_specifier_repeat1] = STATE(949),
    [sym_identifier] = ACTIONS(1132),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1134),
    [anon_sym_unsigned] = ACTIONS(1134),
    [anon_sym_long] = ACTIONS(1134),
    [anon_sym_short] = ACTIONS(1134),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [381] = {
    [sym_type_qualifier] = STATE(802),
    [sym__type_specifier] = STATE(943),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym__expression] = STATE(688),
    [sym_comma_expression] = STATE(1369),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_type_descriptor] = STATE(1371),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_type_definition_repeat1] = STATE(802),
    [aux_sym_sized_type_specifier_repeat1] = STATE(949),
    [sym_identifier] = ACTIONS(1132),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1134),
    [anon_sym_unsigned] = ACTIONS(1134),
    [anon_sym_long] = ACTIONS(1134),
    [anon_sym_short] = ACTIONS(1134),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [382] = {
    [sym_type_qualifier] = STATE(802),
    [sym__type_specifier] = STATE(943),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym__expression] = STATE(688),
    [sym_comma_expression] = STATE(1369),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_type_descriptor] = STATE(1419),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_type_definition_repeat1] = STATE(802),
    [aux_sym_sized_type_specifier_repeat1] = STATE(949),
    [sym_identifier] = ACTIONS(1132),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1134),
    [anon_sym_unsigned] = ACTIONS(1134),
    [anon_sym_long] = ACTIONS(1134),
    [anon_sym_short] = ACTIONS(1134),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
  [383] = {
    [sym_type_qualifier] = STATE(802),
    [sym__type_specifier] = STATE(943),
    [sym_sized_type_specifier] = STATE(878),
    [sym_enum_specifier] = STATE(878),
    [sym_struct_specifier] = STATE(878),
    [sym_union_specifier] = STATE(878),
    [sym__expression] = STATE(688),
    [sym_comma_expression] = STATE(1369),
    [sym_conditional_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_pointer_expression] = STATE(570),
    [sym_unary_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_update_expression] = STATE(575),
    [sym_cast_expression] = STATE(575),
    [sym_type_descriptor] = STATE(1321),
    [sym_sizeof_expression] = STATE(575),
    [sym_subscript_expression] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_field_expression] = STATE(570),
    [sym_compound_literal_expression] = STATE(575),
    [sym_parenthesized_expression] = STATE(570),
    [sym_char_literal] = STATE(575),
    [sym_concatenated_string] = STATE(575),
    [sym_string_literal] = STATE(424),
    [sym_macro_type_specifier] = STATE(878),
    [aux_sym_type_definition_repeat1] = STATE(802),
    [aux_sym_sized_type_specifier_repeat1] = STATE(949),
    [sym_identifier] = ACTIONS(1132),
    [anon_sym_LPAREN2] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_STAR] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1134),
    [anon_sym_unsigned] = ACTIONS(1134),
    [anon_sym_long] = ACTIONS(1134),
    [anon_sym_short] = ACTIONS(1134),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [sym_number_literal] = ACTIONS(85),
    [anon_sym_L_SQUOTE] = ACTIONS(87),
    [anon_sym_u_SQUOTE] = ACTIONS(87),
    [anon_sym_U_SQUOTE] = ACTIONS(87),
    [anon_sym_u8_SQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_L_DQUOTE] = ACTIONS(89),
    [anon_sym_u_DQUOTE] = ACTIONS(89),
    [anon_sym_U_DQUOTE] = ACTIONS(89),
    [anon_sym_u8_DQUOTE] = ACTIONS(89),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 1,
      anon_sym_LPAREN2,
    ACTIONS(1146), 1,
      anon_sym_STAR,
    ACTIONS(1149), 1,
      anon_sym_SEMI,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1154), 1,
      anon_sym_COLON,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1136), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
    ACTIONS(1138), 13,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [74] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 1,
      anon_sym_LPAREN2,
    ACTIONS(1146), 1,
      anon_sym_STAR,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1158), 1,
      anon_sym_COLON,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1136), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
    ACTIONS(1138), 14,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [146] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 1,
      anon_sym_LPAREN2,
    ACTIONS(1146), 1,
      anon_sym_STAR,
    ACTIONS(1149), 1,
      anon_sym_SEMI,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1160), 1,
      anon_sym_COLON,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1136), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
    ACTIONS(1138), 13,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [220] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 1,
      anon_sym_LPAREN2,
    ACTIONS(1146), 1,
      anon_sym_STAR,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1162), 1,
      anon_sym_COLON,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1136), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
    ACTIONS(1138), 14,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [292] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1164), 1,
      sym_identifier,
    ACTIONS(1166), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1168), 1,
      anon_sym_RPAREN,
    ACTIONS(1170), 1,
      anon_sym_LPAREN2,
    ACTIONS(1172), 1,
      anon_sym_STAR,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(898), 1,
      sym__declaration_specifiers,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(1127), 1,
      sym__abstract_declarator,
    STATE(1128), 1,
      sym__declarator,
    STATE(1131), 1,
      sym_parameter_declaration,
    STATE(1329), 1,
      sym_ms_based_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [404] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(872), 1,
      anon_sym_LBRACE,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1178), 1,
      anon_sym_COMMA,
    ACTIONS(1180), 1,
      anon_sym_RBRACE,
    ACTIONS(1182), 1,
      anon_sym_LBRACK,
    ACTIONS(1184), 1,
      anon_sym_DOT,
    STATE(424), 1,
      sym_string_literal,
    STATE(616), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(1158), 2,
      sym_initializer_list,
      sym_initializer_pair,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    STATE(1053), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [504] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 1,
      anon_sym_LPAREN2,
    ACTIONS(1146), 1,
      anon_sym_STAR,
    ACTIONS(1149), 1,
      anon_sym_SEMI,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1162), 1,
      anon_sym_COLON,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1136), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
    ACTIONS(1138), 13,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [578] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 1,
      anon_sym_LPAREN2,
    ACTIONS(1146), 1,
      anon_sym_STAR,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1154), 1,
      anon_sym_COLON,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1136), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
    ACTIONS(1138), 14,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [650] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 1,
      anon_sym_LPAREN2,
    ACTIONS(1146), 1,
      anon_sym_STAR,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1160), 1,
      anon_sym_COLON,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1136), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
    ACTIONS(1138), 14,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [722] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 1,
      anon_sym_LPAREN2,
    ACTIONS(1146), 1,
      anon_sym_STAR,
    ACTIONS(1149), 1,
      anon_sym_SEMI,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1158), 1,
      anon_sym_COLON,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1136), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
    ACTIONS(1138), 13,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [796] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1192), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1422), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(420), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [899] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(872), 1,
      anon_sym_LBRACE,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1182), 1,
      anon_sym_LBRACK,
    ACTIONS(1184), 1,
      anon_sym_DOT,
    ACTIONS(1202), 1,
      anon_sym_RBRACE,
    STATE(424), 1,
      sym_string_literal,
    STATE(661), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(1203), 2,
      sym_initializer_list,
      sym_initializer_pair,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    STATE(1053), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [996] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    ACTIONS(1204), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1416), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(394), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [1099] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    ACTIONS(1206), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1284), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(406), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [1202] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    ACTIONS(1208), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1331), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(420), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [1305] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    ACTIONS(1210), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1383), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(420), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [1408] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    ACTIONS(1212), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1293), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(420), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [1511] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    ACTIONS(1214), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1397), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(420), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [1614] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    ACTIONS(1216), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1270), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(399), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [1717] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    ACTIONS(1218), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1343), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(405), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [1820] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    ACTIONS(1220), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1318), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(400), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [1923] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    ACTIONS(1222), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1316), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(420), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [2026] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    ACTIONS(1224), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1360), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(420), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [2129] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(872), 1,
      anon_sym_LBRACE,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1182), 1,
      anon_sym_LBRACK,
    ACTIONS(1184), 1,
      anon_sym_DOT,
    ACTIONS(1226), 1,
      anon_sym_RBRACE,
    STATE(424), 1,
      sym_string_literal,
    STATE(661), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(1203), 2,
      sym_initializer_list,
      sym_initializer_pair,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    STATE(1053), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2226] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 1,
      anon_sym_LPAREN2,
    ACTIONS(1146), 1,
      anon_sym_STAR,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1136), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
    ACTIONS(1138), 14,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [2295] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    ACTIONS(1228), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1385), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(398), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [2398] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1188), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1190), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1196), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(1198), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1200), 1,
      sym_preproc_directive,
    ACTIONS(1230), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1194), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1359), 2,
      sym_preproc_else_in_field_declaration_list,
      sym_preproc_elif_in_field_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(401), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [2501] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(872), 1,
      anon_sym_LBRACE,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1182), 1,
      anon_sym_LBRACK,
    ACTIONS(1184), 1,
      anon_sym_DOT,
    STATE(424), 1,
      sym_string_literal,
    STATE(661), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(1203), 2,
      sym_initializer_list,
      sym_initializer_pair,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    STATE(1053), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2595] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(29), 1,
      anon_sym_AMP,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1232), 1,
      anon_sym_STAR,
    ACTIONS(1234), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(693), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(602), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(1236), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2686] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(29), 1,
      anon_sym_AMP,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1238), 1,
      anon_sym_STAR,
    ACTIONS(1240), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(716), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(602), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(1236), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2777] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(29), 1,
      anon_sym_AMP,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_STAR,
    ACTIONS(1244), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(725), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(602), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(1236), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2868] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(29), 1,
      anon_sym_AMP,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    ACTIONS(1248), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(724), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(412), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(1236), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2959] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(29), 1,
      anon_sym_AMP,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1250), 1,
      anon_sym_STAR,
    ACTIONS(1252), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(712), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(423), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(1236), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [3050] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(29), 1,
      anon_sym_AMP,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    ACTIONS(1256), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(718), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(602), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(1236), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [3141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(421), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1260), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1258), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [3202] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(29), 1,
      anon_sym_AMP,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    ACTIONS(1264), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(695), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(414), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(1236), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [3293] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1269), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1272), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1280), 1,
      sym_preproc_directive,
    ACTIONS(1286), 1,
      anon_sym___attribute__,
    ACTIONS(1289), 1,
      anon_sym___declspec,
    ACTIONS(1298), 1,
      sym_primitive_type,
    ACTIONS(1301), 1,
      anon_sym_enum,
    ACTIONS(1304), 1,
      anon_sym_struct,
    ACTIONS(1307), 1,
      anon_sym_union,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(951), 1,
      sym__declaration_specifiers,
    ACTIONS(1277), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(1275), 3,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    ACTIONS(1292), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(1295), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1283), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(420), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [3388] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(421), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1314), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1312), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1310), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [3449] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(29), 1,
      anon_sym_AMP,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1317), 1,
      anon_sym_STAR,
    ACTIONS(1319), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(704), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(417), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(1236), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [3540] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(29), 1,
      anon_sym_AMP,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1321), 1,
      anon_sym_STAR,
    ACTIONS(1323), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(705), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(602), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(1236), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [3631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(418), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1144), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1138), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [3692] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(29), 1,
      anon_sym_AMP,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_STAR,
    ACTIONS(1327), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(711), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(413), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(1236), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [3783] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1286), 1,
      anon_sym___attribute__,
    ACTIONS(1289), 1,
      anon_sym___declspec,
    ACTIONS(1298), 1,
      sym_primitive_type,
    ACTIONS(1301), 1,
      anon_sym_enum,
    ACTIONS(1304), 1,
      anon_sym_struct,
    ACTIONS(1307), 1,
      anon_sym_union,
    ACTIONS(1329), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1332), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1338), 1,
      sym_preproc_directive,
    ACTIONS(1341), 1,
      anon_sym_RBRACE,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(955), 1,
      sym__declaration_specifiers,
    ACTIONS(1335), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(1292), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(1295), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1283), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(426), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [3876] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1343), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1345), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1347), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(1351), 1,
      sym_preproc_directive,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(954), 1,
      sym__declaration_specifiers,
    ACTIONS(1349), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(428), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [3969] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1343), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1345), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1351), 1,
      sym_preproc_directive,
    ACTIONS(1353), 1,
      aux_sym_preproc_if_token2,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(954), 1,
      sym__declaration_specifiers,
    ACTIONS(1349), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(429), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [4062] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1275), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(1286), 1,
      anon_sym___attribute__,
    ACTIONS(1289), 1,
      anon_sym___declspec,
    ACTIONS(1298), 1,
      sym_primitive_type,
    ACTIONS(1301), 1,
      anon_sym_enum,
    ACTIONS(1304), 1,
      anon_sym_struct,
    ACTIONS(1307), 1,
      anon_sym_union,
    ACTIONS(1355), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1358), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1364), 1,
      sym_preproc_directive,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(954), 1,
      sym__declaration_specifiers,
    ACTIONS(1361), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(1292), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(1295), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1283), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(429), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [4155] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1367), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1369), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1373), 1,
      sym_preproc_directive,
    ACTIONS(1375), 1,
      anon_sym_RBRACE,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(955), 1,
      sym__declaration_specifiers,
    ACTIONS(1371), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(426), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [4248] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1367), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1369), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1373), 1,
      sym_preproc_directive,
    ACTIONS(1377), 1,
      anon_sym_RBRACE,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(955), 1,
      sym__declaration_specifiers,
    ACTIONS(1371), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(435), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [4341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1381), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1379), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [4396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1383), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [4451] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1367), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1369), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1373), 1,
      sym_preproc_directive,
    ACTIONS(1387), 1,
      anon_sym_RBRACE,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(955), 1,
      sym__declaration_specifiers,
    ACTIONS(1371), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(430), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [4544] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1367), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(1369), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(1373), 1,
      sym_preproc_directive,
    ACTIONS(1389), 1,
      anon_sym_RBRACE,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(955), 1,
      sym__declaration_specifiers,
    ACTIONS(1371), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(426), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [4637] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1166), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1168), 1,
      anon_sym_RPAREN,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1391), 1,
      anon_sym_LPAREN2,
    ACTIONS(1393), 1,
      anon_sym_STAR,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(898), 1,
      sym__declaration_specifiers,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(1127), 1,
      sym__abstract_declarator,
    STATE(1131), 1,
      sym_parameter_declaration,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [4734] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1395), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(629), 1,
      sym__expression,
    STATE(1338), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4816] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(687), 1,
      sym__expression,
    STATE(1304), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4898] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1399), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(670), 1,
      sym__expression,
    STATE(1365), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4980] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(675), 1,
      sym__expression,
    STATE(1401), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5062] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1403), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(671), 1,
      sym__expression,
    STATE(1413), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5144] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(872), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(505), 1,
      sym__expression,
    STATE(537), 1,
      sym_initializer_list,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5226] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(628), 1,
      sym__expression,
    STATE(1281), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5308] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1407), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(632), 1,
      sym__expression,
    STATE(1260), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5390] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1409), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(639), 1,
      sym__expression,
    STATE(1288), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5472] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1411), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(638), 1,
      sym__expression,
    STATE(1286), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5554] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1413), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(660), 1,
      sym__expression,
    STATE(1324), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5636] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1415), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(680), 1,
      sym__expression,
    STATE(1387), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5718] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(872), 1,
      anon_sym_LBRACE,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(635), 1,
      sym__expression,
    STATE(1199), 1,
      sym_initializer_list,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5800] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1417), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(686), 1,
      sym__expression,
    STATE(1307), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5882] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(684), 1,
      sym__expression,
    STATE(1327), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5964] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1421), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(643), 1,
      sym__expression,
    STATE(1334), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6046] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1423), 1,
      anon_sym_LBRACE,
    STATE(594), 1,
      sym_ms_call_modifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(963), 1,
      sym__declaration_specifiers,
    STATE(126), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(41), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [6132] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1425), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(646), 1,
      sym__expression,
    STATE(1398), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6214] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1427), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(625), 1,
      sym__expression,
    STATE(1344), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6296] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1429), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(618), 1,
      sym__expression,
    STATE(1265), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6378] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1431), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(681), 1,
      sym__expression,
    STATE(1333), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6460] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(631), 1,
      sym__expression,
    STATE(1337), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6542] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1435), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(674), 1,
      sym__expression,
    STATE(1312), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6624] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1437), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(645), 1,
      sym__expression,
    STATE(1410), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6706] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1439), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(663), 1,
      sym__expression,
    STATE(1354), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6788] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1441), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(636), 1,
      sym__expression,
    STATE(1283), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6870] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1443), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(634), 1,
      sym__expression,
    STATE(1280), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6952] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1445), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(626), 1,
      sym__expression,
    STATE(1248), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7034] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1447), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(676), 1,
      sym__expression,
    STATE(1267), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7116] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1449), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(669), 1,
      sym__expression,
    STATE(1364), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7198] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1451), 1,
      anon_sym_LBRACE,
    STATE(595), 1,
      sym_ms_call_modifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(962), 1,
      sym__declaration_specifiers,
    STATE(276), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(41), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [7284] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1453), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(657), 1,
      sym__expression,
    STATE(1292), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7366] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1455), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(650), 1,
      sym__expression,
    STATE(1289), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7448] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(872), 1,
      anon_sym_LBRACE,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(654), 1,
      sym__expression,
    STATE(1208), 1,
      sym_initializer_list,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7530] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1457), 1,
      anon_sym_LBRACE,
    STATE(593), 1,
      sym_ms_call_modifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(958), 1,
      sym__declaration_specifiers,
    STATE(234), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(41), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [7616] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(677), 1,
      sym__expression,
    STATE(1349), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7698] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1461), 1,
      anon_sym_LBRACE,
    STATE(596), 1,
      sym_ms_call_modifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(956), 1,
      sym__declaration_specifiers,
    STATE(286), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(41), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [7784] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1463), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(623), 1,
      sym__expression,
    STATE(1346), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7866] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(872), 1,
      anon_sym_LBRACE,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(505), 1,
      sym__expression,
    STATE(537), 1,
      sym_initializer_list,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7948] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1465), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(664), 1,
      sym__expression,
    STATE(1372), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8030] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1467), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(651), 1,
      sym__expression,
    STATE(1375), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8112] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1469), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(649), 1,
      sym__expression,
    STATE(1379), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8194] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    ACTIONS(1471), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(484), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8273] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1477), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1481), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(1473), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8340] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1493), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1491), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8401] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_EQ,
    ACTIONS(1495), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1497), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_CARET,
    ACTIONS(1501), 1,
      anon_sym_AMP,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1477), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1503), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1505), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1507), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1491), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8482] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1509), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(694), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8561] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1513), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1511), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8622] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1517), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1515), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8683] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1521), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1519), 25,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [8742] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1523), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(723), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8821] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    ACTIONS(1525), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(484), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8900] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(722), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8979] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1477), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1493), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1491), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [9044] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    ACTIONS(1529), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(484), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1531), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [9174] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1477), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1493), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(1491), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [9241] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1477), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1505), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1507), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1493), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(1491), 21,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [9312] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1477), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1503), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1505), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1507), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1493), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(1491), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [9385] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1501), 1,
      anon_sym_AMP,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1477), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1503), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1505), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1507), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1493), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(1491), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [9460] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(688), 1,
      sym__expression,
    STATE(1369), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9539] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    ACTIONS(1535), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(484), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9618] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_CARET,
    ACTIONS(1501), 1,
      anon_sym_AMP,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1477), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1493), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(1503), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1505), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1507), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1491), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [9695] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1537), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(706), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9774] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_EQ,
    ACTIONS(1497), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_CARET,
    ACTIONS(1501), 1,
      anon_sym_AMP,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1477), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1503), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1505), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1507), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1491), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [9853] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1493), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1491), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [9916] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1539), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(698), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9995] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1541), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(692), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10074] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1545), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1543), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [10135] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1497), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_CARET,
    ACTIONS(1501), 1,
      anon_sym_AMP,
    ACTIONS(1549), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1551), 1,
      anon_sym_EQ,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1477), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1503), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1505), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1507), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1547), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [10218] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1553), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(715), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10297] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1555), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(696), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10376] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(700), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10455] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1559), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(701), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10534] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1561), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(703), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10613] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    ACTIONS(1563), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(484), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10692] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1565), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(697), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10771] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    ACTIONS(1567), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(484), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10850] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1497), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_CARET,
    ACTIONS(1501), 1,
      anon_sym_AMP,
    ACTIONS(1549), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1571), 1,
      anon_sym_EQ,
    ACTIONS(1573), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1477), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1483), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1503), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1505), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1507), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1479), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1569), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [10935] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    ACTIONS(1575), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(484), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11014] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1577), 1,
      anon_sym_RPAREN,
    STATE(424), 1,
      sym_string_literal,
    STATE(615), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11093] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    ACTIONS(1579), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(484), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11172] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(617), 1,
      sym__expression,
    STATE(1200), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11251] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(678), 1,
      sym__expression,
    STATE(1420), 1,
      sym_comma_expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11330] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1581), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(713), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11409] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1583), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(714), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11488] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    ACTIONS(1585), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(484), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11567] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    ACTIONS(1587), 1,
      anon_sym_RBRACK,
    STATE(424), 1,
      sym_string_literal,
    STATE(484), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11646] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1589), 1,
      anon_sym_SEMI,
    STATE(424), 1,
      sym_string_literal,
    STATE(699), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11725] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 1,
      anon_sym_LPAREN2,
    ACTIONS(1146), 1,
      anon_sym_STAR,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1149), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(1591), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1138), 12,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [11787] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(609), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11863] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(608), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11939] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(610), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12015] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(702), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12091] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(607), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12167] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(606), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12243] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(605), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12319] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(604), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1593), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [12445] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(603), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1597), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [12571] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(481), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12647] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(486), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1603), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1601), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [12773] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(499), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12849] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(658), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12925] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(601), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13001] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(690), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13077] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(709), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1605), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [13203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1611), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1609), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [13253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1615), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1613), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [13303] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(501), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13379] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(482), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13455] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(481), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13531] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(719), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13607] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(502), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13683] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(707), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13759] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(490), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13835] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(493), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13911] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(691), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13987] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(494), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14063] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(495), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14139] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(515), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14215] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(611), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1619), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1617), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [14341] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(496), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14417] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    ACTIONS(1621), 1,
      anon_sym_LPAREN2,
    STATE(424), 1,
      sym_string_literal,
    STATE(480), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14493] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(485), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14569] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(484), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14645] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(717), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14721] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(858), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN2,
    ACTIONS(876), 1,
      anon_sym_sizeof,
    STATE(424), 1,
      sym_string_literal,
    STATE(486), 1,
      sym__expression,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(864), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(866), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(874), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(583), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1625), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1623), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [14847] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1138), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [14901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1629), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1627), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [14951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1631), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [15001] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(599), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1637), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1635), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [15127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1144), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1138), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [15177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1641), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1639), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [15227] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    ACTIONS(1643), 1,
      anon_sym_LPAREN2,
    STATE(424), 1,
      sym_string_literal,
    STATE(598), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15303] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(720), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15379] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(633), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15455] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(485), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1645), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [15581] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      sym_number_literal,
    ACTIONS(1130), 1,
      sym_identifier,
    STATE(424), 1,
      sym_string_literal,
    STATE(708), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(27), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(29), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(87), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(89), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(570), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(575), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1144), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1138), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [15707] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1160), 1,
      anon_sym_COLON,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1138), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [15760] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1154), 1,
      anon_sym_COLON,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1138), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [15813] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1649), 1,
      anon_sym_COLON,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1138), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [15866] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1162), 1,
      anon_sym_COLON,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1138), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [15919] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 1,
      anon_sym_EQ,
    ACTIONS(1158), 1,
      anon_sym_COLON,
    ACTIONS(1156), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1144), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1138), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [15972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_sizeof,
      sym_true,
      sym_false,
      sym_null,
      sym_identifier,
    ACTIONS(1531), 20,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [16018] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1166), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1168), 1,
      anon_sym_RPAREN,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(898), 1,
      sym__declaration_specifiers,
    STATE(1131), 1,
      sym_parameter_declaration,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [16094] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1651), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(898), 1,
      sym__declaration_specifiers,
    STATE(1221), 1,
      sym_parameter_declaration,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [16167] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN2,
    ACTIONS(1172), 1,
      anon_sym_STAR,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1653), 1,
      sym_identifier,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1005), 1,
      sym__declarator,
    STATE(1046), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(1329), 1,
      sym_ms_based_modifier,
    ACTIONS(1655), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1659), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(774), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(779), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(1657), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [16240] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(990), 1,
      sym__declaration_specifiers,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [16307] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(974), 1,
      sym__declaration_specifiers,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [16374] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(973), 1,
      sym__declaration_specifiers,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [16441] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(776), 1,
      sym__type_specifier,
    STATE(984), 1,
      sym__declaration_specifiers,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(600), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [16508] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym___attribute__,
    ACTIONS(1671), 1,
      anon_sym___declspec,
    ACTIONS(1674), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(1665), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(597), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(1663), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(1661), 10,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [16559] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1481), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1473), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
  [16617] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1569), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [16691] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(772), 1,
      sym__type_specifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(597), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [16755] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1493), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1491), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
  [16811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(602), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1707), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(1703), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      sym_true,
      sym_false,
      sym_null,
      sym_identifier,
    ACTIONS(1705), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [16855] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1493), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1491), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
  [16913] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1493), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1491), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
  [16975] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1493), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1491), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
  [17039] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_PIPE,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1491), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
  [17105] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_PIPE,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1491), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
  [17173] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1491), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
  [17241] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1493), 6,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1491), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
  [17295] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1547), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
  [17367] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1491), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
  [17437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1710), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_sizeof,
      sym_true,
      sym_false,
      sym_null,
      sym_identifier,
    ACTIONS(1712), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [17475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1716), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1714), 21,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [17513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(1718), 21,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [17550] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1722), 1,
      anon_sym_COMMA,
    ACTIONS(1724), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    STATE(1160), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [17625] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1726), 1,
      anon_sym_COMMA,
    ACTIONS(1728), 1,
      anon_sym_RBRACE,
    STATE(547), 1,
      sym_argument_list,
    STATE(1155), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [17700] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1732), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [17773] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1734), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [17845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1072), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [17879] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1736), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [17951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1740), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(1738), 21,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [17987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1712), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(1710), 21,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [18023] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1742), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18095] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1744), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18167] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1746), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18239] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1748), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18311] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1750), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18383] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1752), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18455] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1754), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1040), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [18561] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1756), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18633] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1758), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18705] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1760), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [18775] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1762), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18847] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1764), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [18917] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1766), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18989] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1768), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [19061] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1770), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [19133] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1772), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [19205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [19239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1774), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [19273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1056), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [19307] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1776), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [19379] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1778), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [19451] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1780), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [19523] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1782), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [19595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1784), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [19629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1786), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [19663] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1788), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [19735] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1790), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [19807] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1792), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [19879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1794), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [19913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [19947] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1798), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [20017] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1800), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20089] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1802), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20161] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1804), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20233] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1806), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [20303] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1808), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20375] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1810), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20447] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1812), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [20517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [20551] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1816), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20623] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1818), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1820), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [20729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1822), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [20763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1824), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [20797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [20831] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1828), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20903] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1830), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20975] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1832), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1100), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [21081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1834), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [21115] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1836), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21187] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1838), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21259] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1840), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21331] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1842), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21403] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1844), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21475] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1846), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21547] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1848), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21619] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1850), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [21725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [21759] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1856), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1858), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [21865] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1860), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21937] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1862), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22009] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1730), 1,
      anon_sym_COMMA,
    ACTIONS(1864), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 28,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [22115] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1866), 1,
      anon_sym_RBRACK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22184] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1868), 1,
      anon_sym_COLON,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22253] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1870), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22322] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1535), 1,
      anon_sym_RBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22391] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1872), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22460] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1585), 1,
      anon_sym_RBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22529] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1874), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22598] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1876), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22667] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1878), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22736] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1880), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22805] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1882), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22874] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1884), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22943] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1886), 1,
      anon_sym_COLON,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23012] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1888), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23081] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1529), 1,
      anon_sym_RBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23150] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1575), 1,
      anon_sym_RBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23219] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1890), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23288] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1892), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23357] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1894), 1,
      anon_sym_RBRACK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23426] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1896), 1,
      anon_sym_COLON,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1379), 1,
      anon_sym_LBRACE,
    ACTIONS(1381), 26,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23530] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1563), 1,
      anon_sym_RBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23599] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1587), 1,
      anon_sym_RBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23668] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1898), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23737] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1900), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23806] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1902), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23875] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1567), 1,
      anon_sym_RBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [23944] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1904), 1,
      anon_sym_COLON,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [24013] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1579), 1,
      anon_sym_RBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [24082] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1906), 1,
      anon_sym_COLON,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [24151] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1908), 1,
      anon_sym_COLON,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [24220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 1,
      anon_sym_LBRACE,
    ACTIONS(1385), 26,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24255] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1910), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [24324] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    ACTIONS(1912), 1,
      anon_sym_SEMI,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [24393] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      anon_sym_RBRACK,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [24462] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(1525), 1,
      anon_sym_RBRACK,
    ACTIONS(1681), 1,
      anon_sym_SLASH,
    ACTIONS(1685), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1687), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1689), 1,
      anon_sym_PIPE,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_AMP,
    ACTIONS(1701), 1,
      anon_sym_QMARK,
    STATE(547), 1,
      sym_argument_list,
    ACTIONS(1487), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1489), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1677), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1679), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1683), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1695), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1697), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1699), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [24531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1820), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1914), 1,
      anon_sym_RBRACE,
    ACTIONS(1820), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1916), 1,
      anon_sym_RBRACE,
    ACTIONS(1786), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1774), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(467), 1,
      sym_string_literal,
    ACTIONS(1918), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1738), 20,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1784), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1102), 1,
      anon_sym_RBRACE,
    ACTIONS(1100), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1920), 1,
      anon_sym_RBRACE,
    ACTIONS(1834), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 1,
      anon_sym_RBRACE,
    ACTIONS(1774), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1786), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1794), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1924), 1,
      anon_sym_RBRACE,
    ACTIONS(1784), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(453), 1,
      sym_string_literal,
    ACTIONS(1918), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1738), 20,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1042), 1,
      anon_sym_RBRACE,
    ACTIONS(1040), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1926), 1,
      anon_sym_RBRACE,
    ACTIONS(1852), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1928), 1,
      anon_sym_RBRACE,
    ACTIONS(1796), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1034), 1,
      anon_sym_RBRACE,
    ACTIONS(1032), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1100), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1930), 1,
      anon_sym_RBRACE,
    ACTIONS(1854), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1932), 1,
      anon_sym_RBRACE,
    ACTIONS(1794), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1056), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 1,
      anon_sym_RBRACE,
    ACTIONS(1072), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1822), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1824), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(471), 1,
      sym_string_literal,
    ACTIONS(1918), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1738), 20,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(473), 1,
      sym_string_literal,
    ACTIONS(1918), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1738), 20,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1834), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1934), 1,
      anon_sym_RBRACE,
    ACTIONS(1858), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_RBRACE,
    ACTIONS(1826), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1058), 1,
      anon_sym_RBRACE,
    ACTIONS(1056), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1938), 1,
      anon_sym_RBRACE,
    ACTIONS(1824), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_RBRACE,
    ACTIONS(1822), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25767] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(763), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1946), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1944), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(1942), 14,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_primitive_type,
      sym_identifier,
  [25805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 1,
      anon_sym_RBRACE,
    ACTIONS(1024), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1072), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1040), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [25935] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1949), 1,
      sym_identifier,
    ACTIONS(1958), 1,
      sym_primitive_type,
    STATE(763), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1956), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1952), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(1954), 12,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [25977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1960), 1,
      anon_sym_RBRACE,
    ACTIONS(1814), 25,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1858), 26,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [26075] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(1962), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(773), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(1964), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [26118] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(1966), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(597), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(1968), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [26161] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN2,
    ACTIONS(1172), 1,
      anon_sym_STAR,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1653), 1,
      sym_identifier,
    STATE(1015), 1,
      sym__declarator,
    STATE(1048), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(1329), 1,
      sym_ms_based_modifier,
    ACTIONS(1970), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [26218] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(1972), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(597), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(1974), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [26261] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(1976), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(775), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(1978), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [26304] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1005), 1,
      sym__declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    ACTIONS(1659), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(779), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(931), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1657), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [26358] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_LPAREN2,
    ACTIONS(1988), 1,
      anon_sym_STAR,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1032), 1,
      sym__field_declarator,
    STATE(1403), 1,
      sym_ms_based_modifier,
    ACTIONS(1659), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(938), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(947), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1657), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1055), 4,
      sym_parenthesized_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [26412] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1015), 1,
      sym__declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    ACTIONS(1659), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(938), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(946), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1657), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [26466] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_LPAREN2,
    ACTIONS(1988), 1,
      anon_sym_STAR,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1036), 1,
      sym__field_declarator,
    STATE(1403), 1,
      sym_ms_based_modifier,
    ACTIONS(1659), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(783), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(945), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1657), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1055), 4,
      sym_parenthesized_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [26520] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1023), 1,
      sym__declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    ACTIONS(1659), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(938), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(941), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1657), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [26574] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1064), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    ACTIONS(1659), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(785), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(933), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1657), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [26628] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_LPAREN2,
    ACTIONS(1988), 1,
      anon_sym_STAR,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1033), 1,
      sym__field_declarator,
    STATE(1403), 1,
      sym_ms_based_modifier,
    ACTIONS(1659), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(934), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(938), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(1657), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1055), 4,
      sym_parenthesized_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [26682] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1057), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    ACTIONS(1659), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(788), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(935), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1657), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [26736] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1057), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    ACTIONS(1659), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(935), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(938), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(1657), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [26790] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_LPAREN2,
    ACTIONS(1988), 1,
      anon_sym_STAR,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1033), 1,
      sym__field_declarator,
    STATE(1403), 1,
      sym_ms_based_modifier,
    ACTIONS(1659), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(778), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(934), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1657), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1055), 4,
      sym_parenthesized_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [26844] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1015), 1,
      sym__declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    ACTIONS(1659), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(781), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(946), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1657), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [26898] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1071), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    ACTIONS(1659), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(927), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(938), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(1657), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [26952] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1996), 1,
      sym_identifier,
    STATE(943), 1,
      sym__type_specifier,
    STATE(949), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1366), 1,
      sym_type_descriptor,
    STATE(802), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(1134), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [27003] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1998), 1,
      sym_identifier,
    ACTIONS(2002), 1,
      sym_primitive_type,
    ACTIONS(2004), 1,
      anon_sym_enum,
    ACTIONS(2006), 1,
      anon_sym_struct,
    ACTIONS(2008), 1,
      anon_sym_union,
    STATE(944), 1,
      sym__type_specifier,
    STATE(950), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1389), 1,
      sym_type_descriptor,
    STATE(804), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(2000), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1012), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [27054] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1996), 1,
      sym_identifier,
    STATE(943), 1,
      sym__type_specifier,
    STATE(949), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1251), 1,
      sym_type_descriptor,
    STATE(802), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(1134), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [27105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    STATE(852), 1,
      sym_field_declaration_list,
    ACTIONS(2012), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2010), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [27139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(879), 1,
      sym_enumerator_list,
    ACTIONS(2018), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2016), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [27173] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(988), 1,
      sym__type_specifier,
    STATE(807), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [27221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    STATE(888), 1,
      sym_field_declaration_list,
    ACTIONS(2024), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2022), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [27255] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(977), 1,
      sym__type_specifier,
    STATE(799), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [27303] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    STATE(892), 1,
      sym_field_declaration_list,
    ACTIONS(2028), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2026), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [27337] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(985), 1,
      sym__type_specifier,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [27385] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(982), 1,
      sym__type_specifier,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [27433] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(972), 1,
      sym__type_specifier,
    STATE(803), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [27481] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2032), 1,
      anon_sym_LPAREN2,
    STATE(870), 1,
      sym_preproc_argument_list,
    ACTIONS(2034), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2030), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [27515] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1996), 1,
      sym_identifier,
    STATE(936), 1,
      sym__type_specifier,
    STATE(949), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(1134), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [27563] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(965), 1,
      sym__type_specifier,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [27611] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1998), 1,
      sym_identifier,
    ACTIONS(2002), 1,
      sym_primitive_type,
    ACTIONS(2004), 1,
      anon_sym_enum,
    ACTIONS(2006), 1,
      anon_sym_struct,
    ACTIONS(2008), 1,
      anon_sym_union,
    STATE(932), 1,
      sym__type_specifier,
    STATE(950), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(2000), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1012), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [27659] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    STATE(850), 1,
      sym_field_declaration_list,
    ACTIONS(2038), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2036), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [27693] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(983), 1,
      sym__type_specifier,
    STATE(798), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [27741] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1186), 1,
      sym_identifier,
    STATE(768), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(986), 1,
      sym__type_specifier,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(878), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
  [27789] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2042), 1,
      anon_sym_RPAREN,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2052), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(817), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [27832] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2056), 1,
      anon_sym_COMMA,
    ACTIONS(2058), 1,
      anon_sym_RPAREN,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2068), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(1169), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(2060), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2076), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2078), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2080), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2082), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [27887] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2084), 1,
      anon_sym_RPAREN,
    ACTIONS(2086), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(809), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [27930] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2088), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(1705), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
    ACTIONS(1703), 10,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27963] = 5,
    ACTIONS(2030), 1,
      anon_sym_LF,
    ACTIONS(2091), 1,
      anon_sym_LPAREN2,
    ACTIONS(2093), 1,
      sym_comment,
    STATE(900), 1,
      sym_preproc_argument_list,
    ACTIONS(2034), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [27996] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(2095), 1,
      anon_sym_SEMI,
    ACTIONS(1976), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(1978), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(775), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
  [28037] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(2097), 1,
      anon_sym_SEMI,
    ACTIONS(1976), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(1978), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(775), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
  [28078] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(2099), 1,
      anon_sym_SEMI,
    ACTIONS(1976), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(1978), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(775), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
  [28119] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___attribute__,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(2101), 1,
      anon_sym_SEMI,
    ACTIONS(1976), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(1978), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(45), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    STATE(775), 5,
      sym_attribute_specifier,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
  [28160] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2056), 1,
      anon_sym_COMMA,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2068), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    ACTIONS(2103), 1,
      anon_sym_RPAREN,
    STATE(1145), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(2060), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2076), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2078), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2080), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2082), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [28215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2107), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2105), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [28243] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2119), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(916), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28283] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2123), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(903), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2127), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2125), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [28351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2131), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2129), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [28379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2133), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [28407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2137), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [28435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2143), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2141), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [28463] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2068), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    ACTIONS(2060), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2076), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2078), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2080), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2082), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2145), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [28513] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2147), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(914), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28553] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2149), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(915), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2151), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [28621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2157), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2155), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [28649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2161), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2159), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [28677] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2060), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2165), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2163), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [28711] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2060), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2082), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2165), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2163), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1629), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1627), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [28775] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2060), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2078), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2080), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2082), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2165), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2163), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [28815] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2060), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2076), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2078), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2080), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2082), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2165), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2163), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [28857] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    ACTIONS(2165), 1,
      anon_sym_PIPE,
    ACTIONS(2060), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2076), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2078), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2080), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2082), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2163), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [28901] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    ACTIONS(2165), 1,
      anon_sym_PIPE,
    ACTIONS(2060), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2076), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2078), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2080), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2082), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2163), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [28947] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    ACTIONS(2060), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2076), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2078), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2080), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2082), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2163), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [28993] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2068), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    ACTIONS(2060), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2076), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2078), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2080), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2082), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2163), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [29041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2163), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29069] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2165), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2163), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2169), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2167), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2171), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [29157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2177), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2175), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [29185] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2179), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(912), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29225] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2181), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(910), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2183), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [29293] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2187), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(922), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2189), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [29361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2193), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [29389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2199), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2197), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [29417] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2201), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(868), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29457] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2203), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(907), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29497] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2205), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(918), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29537] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2207), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(924), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29577] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2209), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(923), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29617] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2211), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(832), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29657] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2213), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(833), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29697] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2215), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(835), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29737] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2217), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(836), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29777] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2219), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(837), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29817] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2221), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(838), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29857] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2223), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(839), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29897] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2225), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(840), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29937] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2227), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(841), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29977] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2229), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(842), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [30017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2233), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2231), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [30045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2237), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2235), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [30073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2239), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [30101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2245), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2243), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [30129] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2247), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(920), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [30169] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2249), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(919), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [30209] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2251), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(895), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [30249] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2253), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(909), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [30289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2257), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2255), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [30317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 20,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2263), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2261), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [30371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2265), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [30399] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2269), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(897), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [30439] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2271), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(902), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [30479] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      sym_identifier,
    ACTIONS(2044), 1,
      anon_sym_LPAREN2,
    ACTIONS(2046), 1,
      anon_sym_defined,
    ACTIONS(2273), 1,
      sym_number_literal,
    ACTIONS(2048), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2054), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(826), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [30519] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2275), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(901), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [30559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2277), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [30587] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2281), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(921), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [30627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_LPAREN2,
    ACTIONS(1591), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(1136), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [30657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2286), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [30685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2292), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2290), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [30713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2294), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [30741] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2298), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(906), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [30781] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2300), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(913), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [30821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2302), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [30849] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_LPAREN2,
    ACTIONS(2113), 1,
      anon_sym_defined,
    ACTIONS(2306), 1,
      sym_number_literal,
    ACTIONS(2115), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2121), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(894), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [30889] = 12,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2308), 1,
      anon_sym_LF,
    ACTIONS(2314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2316), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2318), 1,
      anon_sym_PIPE,
    ACTIONS(2320), 1,
      anon_sym_CARET,
    ACTIONS(2322), 1,
      anon_sym_AMP,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30934] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2163), 1,
      anon_sym_LF,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2165), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [30965] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2235), 1,
      anon_sym_LF,
    ACTIONS(2237), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [30992] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2068), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    ACTIONS(2330), 1,
      anon_sym_RPAREN,
    ACTIONS(2060), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2076), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2078), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2080), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2082), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [31041] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN2,
    ACTIONS(1172), 1,
      anon_sym_STAR,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1653), 1,
      sym_identifier,
    STATE(1078), 1,
      sym__abstract_declarator,
    STATE(1079), 1,
      sym__declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(1329), 1,
      sym_ms_based_modifier,
    ACTIONS(2332), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [31088] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2141), 1,
      anon_sym_LF,
    ACTIONS(2143), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [31115] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2239), 1,
      anon_sym_LF,
    ACTIONS(2241), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [31142] = 12,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2316), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2318), 1,
      anon_sym_PIPE,
    ACTIONS(2320), 1,
      anon_sym_CARET,
    ACTIONS(2322), 1,
      anon_sym_AMP,
    ACTIONS(2334), 1,
      anon_sym_LF,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [31187] = 12,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2316), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2318), 1,
      anon_sym_PIPE,
    ACTIONS(2320), 1,
      anon_sym_CARET,
    ACTIONS(2322), 1,
      anon_sym_AMP,
    ACTIONS(2336), 1,
      anon_sym_LF,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [31232] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_SLASH,
    ACTIONS(2066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2068), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    ACTIONS(2338), 1,
      anon_sym_RPAREN,
    ACTIONS(2060), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2062), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2076), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2078), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2080), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2082), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [31281] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2167), 1,
      anon_sym_LF,
    ACTIONS(2169), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [31308] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2137), 1,
      anon_sym_LF,
    ACTIONS(2139), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [31335] = 12,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2316), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2318), 1,
      anon_sym_PIPE,
    ACTIONS(2320), 1,
      anon_sym_CARET,
    ACTIONS(2322), 1,
      anon_sym_AMP,
    ACTIONS(2340), 1,
      anon_sym_LF,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [31380] = 10,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2163), 1,
      anon_sym_LF,
    ACTIONS(2320), 1,
      anon_sym_CARET,
    ACTIONS(2322), 1,
      anon_sym_AMP,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2165), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [31421] = 3,
    ACTIONS(1627), 1,
      anon_sym_LF,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(1629), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [31448] = 12,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2316), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2318), 1,
      anon_sym_PIPE,
    ACTIONS(2320), 1,
      anon_sym_CARET,
    ACTIONS(2322), 1,
      anon_sym_AMP,
    ACTIONS(2342), 1,
      anon_sym_LF,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [31493] = 12,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2163), 1,
      anon_sym_LF,
    ACTIONS(2165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2316), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2318), 1,
      anon_sym_PIPE,
    ACTIONS(2320), 1,
      anon_sym_CARET,
    ACTIONS(2322), 1,
      anon_sym_AMP,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [31538] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2105), 1,
      anon_sym_LF,
    ACTIONS(2107), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [31565] = 12,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2316), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2318), 1,
      anon_sym_PIPE,
    ACTIONS(2320), 1,
      anon_sym_CARET,
    ACTIONS(2322), 1,
      anon_sym_AMP,
    ACTIONS(2344), 1,
      anon_sym_LF,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [31610] = 12,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2316), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2318), 1,
      anon_sym_PIPE,
    ACTIONS(2320), 1,
      anon_sym_CARET,
    ACTIONS(2322), 1,
      anon_sym_AMP,
    ACTIONS(2346), 1,
      anon_sym_LF,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [31655] = 4,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2163), 1,
      anon_sym_LF,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2165), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [31684] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2163), 1,
      anon_sym_LF,
    ACTIONS(2165), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [31711] = 9,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2163), 1,
      anon_sym_LF,
    ACTIONS(2322), 1,
      anon_sym_AMP,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2165), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [31750] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2129), 1,
      anon_sym_LF,
    ACTIONS(2131), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [31777] = 12,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2316), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2318), 1,
      anon_sym_PIPE,
    ACTIONS(2320), 1,
      anon_sym_CARET,
    ACTIONS(2322), 1,
      anon_sym_AMP,
    ACTIONS(2348), 1,
      anon_sym_LF,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [31822] = 6,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2163), 1,
      anon_sym_LF,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2165), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [31855] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LF,
    ACTIONS(2233), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [31882] = 12,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2316), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2318), 1,
      anon_sym_PIPE,
    ACTIONS(2320), 1,
      anon_sym_CARET,
    ACTIONS(2322), 1,
      anon_sym_AMP,
    ACTIONS(2350), 1,
      anon_sym_LF,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [31927] = 11,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2163), 1,
      anon_sym_LF,
    ACTIONS(2318), 1,
      anon_sym_PIPE,
    ACTIONS(2320), 1,
      anon_sym_CARET,
    ACTIONS(2322), 1,
      anon_sym_AMP,
    ACTIONS(2165), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [31970] = 7,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2163), 1,
      anon_sym_LF,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(2165), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [32005] = 8,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2163), 1,
      anon_sym_LF,
    ACTIONS(2310), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2324), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2328), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2326), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(2165), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [32042] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_LPAREN2,
    ACTIONS(1591), 2,
      anon_sym_COMMA,
      anon_sym_STAR,
    ACTIONS(2352), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(1136), 13,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [32072] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_LPAREN2,
    ACTIONS(1393), 1,
      anon_sym_STAR,
    ACTIONS(1655), 1,
      anon_sym_RPAREN,
    STATE(1046), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(930), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2359), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [32110] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(1063), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [32148] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_LPAREN2,
    ACTIONS(1393), 1,
      anon_sym_STAR,
    ACTIONS(2361), 1,
      anon_sym_RPAREN,
    STATE(1085), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2359), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [32186] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_LPAREN2,
    ACTIONS(1655), 1,
      ts_builtin_sym_end,
    ACTIONS(2363), 1,
      anon_sym_STAR,
    STATE(1046), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(940), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2365), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [32224] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_LPAREN2,
    ACTIONS(1393), 1,
      anon_sym_STAR,
    ACTIONS(1970), 1,
      anon_sym_RPAREN,
    STATE(1048), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2359), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [32262] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1015), 1,
      sym__declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [32300] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_LPAREN2,
    ACTIONS(2363), 1,
      anon_sym_STAR,
    ACTIONS(2367), 1,
      ts_builtin_sym_end,
    STATE(1072), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(939), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2365), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [32338] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(1057), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [32376] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_LPAREN2,
    ACTIONS(1988), 1,
      anon_sym_STAR,
    STATE(1032), 1,
      sym__field_declarator,
    STATE(1403), 1,
      sym_ms_based_modifier,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1055), 4,
      sym_parenthesized_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [32414] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(1071), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [32452] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_LPAREN2,
    ACTIONS(1393), 1,
      anon_sym_STAR,
    ACTIONS(2367), 1,
      anon_sym_RPAREN,
    STATE(1072), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(928), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2359), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [32490] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_LPAREN2,
    ACTIONS(1393), 1,
      anon_sym_STAR,
    ACTIONS(2369), 1,
      anon_sym_RPAREN,
    STATE(1101), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2359), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [32528] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(953), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(2373), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(2378), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(938), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2375), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(2371), 6,
      anon_sym___based,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [32560] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_LPAREN2,
    ACTIONS(2361), 1,
      ts_builtin_sym_end,
    ACTIONS(2363), 1,
      anon_sym_STAR,
    STATE(1085), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2365), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [32598] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_LPAREN2,
    ACTIONS(1970), 1,
      ts_builtin_sym_end,
    ACTIONS(2363), 1,
      anon_sym_STAR,
    STATE(1048), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2365), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [32636] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1010), 1,
      sym__declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [32674] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_LPAREN2,
    ACTIONS(2363), 1,
      anon_sym_STAR,
    ACTIONS(2369), 1,
      ts_builtin_sym_end,
    STATE(1101), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2365), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [32712] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_LPAREN2,
    ACTIONS(1393), 1,
      anon_sym_STAR,
    ACTIONS(2381), 1,
      anon_sym_RPAREN,
    STATE(1083), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(937), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2359), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [32750] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1176), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_LPAREN2,
    ACTIONS(2363), 1,
      anon_sym_STAR,
    ACTIONS(2381), 1,
      ts_builtin_sym_end,
    STATE(1083), 1,
      sym__abstract_declarator,
    STATE(1105), 1,
      sym_parameter_list,
    STATE(942), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2365), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1103), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [32788] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_LPAREN2,
    ACTIONS(1988), 1,
      anon_sym_STAR,
    STATE(1033), 1,
      sym__field_declarator,
    STATE(1403), 1,
      sym_ms_based_modifier,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1055), 4,
      sym_parenthesized_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [32826] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1023), 1,
      sym__declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [32864] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_LPAREN2,
    ACTIONS(1988), 1,
      anon_sym_STAR,
    STATE(1045), 1,
      sym__field_declarator,
    STATE(1403), 1,
      sym_ms_based_modifier,
    STATE(811), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(47), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    STATE(1055), 4,
      sym_parenthesized_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [32902] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(948), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1944), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
    ACTIONS(2383), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1942), 6,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_primitive_type,
      sym_identifier,
  [32929] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1958), 1,
      sym_primitive_type,
    ACTIONS(2386), 1,
      sym_identifier,
    STATE(763), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1952), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
    ACTIONS(1954), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(1956), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [32960] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2388), 1,
      sym_identifier,
    ACTIONS(2392), 1,
      sym_primitive_type,
    STATE(948), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1952), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
    ACTIONS(1954), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
    ACTIONS(2390), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [32991] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_LPAREN2,
    ACTIONS(1988), 1,
      anon_sym_STAR,
    ACTIONS(2394), 1,
      anon_sym_SEMI,
    ACTIONS(2396), 1,
      anon_sym_COLON,
    STATE(1028), 1,
      sym__field_declarator,
    STATE(1348), 1,
      sym_bitfield_clause,
    STATE(1403), 1,
      sym_ms_based_modifier,
    STATE(1055), 4,
      sym_parenthesized_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [33028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(2398), 11,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [33049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(2402), 11,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      sym_identifier,
  [33070] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_LPAREN2,
    ACTIONS(1988), 1,
      anon_sym_STAR,
    ACTIONS(2396), 1,
      anon_sym_COLON,
    ACTIONS(2406), 1,
      anon_sym_SEMI,
    STATE(1007), 1,
      sym__field_declarator,
    STATE(1403), 1,
      sym_ms_based_modifier,
    STATE(1411), 1,
      sym_bitfield_clause,
    STATE(1055), 4,
      sym_parenthesized_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [33107] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_LPAREN2,
    ACTIONS(1988), 1,
      anon_sym_STAR,
    ACTIONS(2396), 1,
      anon_sym_COLON,
    ACTIONS(2408), 1,
      anon_sym_SEMI,
    STATE(1016), 1,
      sym__field_declarator,
    STATE(1403), 1,
      sym_ms_based_modifier,
    STATE(1417), 1,
      sym_bitfield_clause,
    STATE(1055), 4,
      sym_parenthesized_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [33144] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(998), 1,
      sym__declarator,
    STATE(1157), 1,
      sym_init_declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [33175] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1039), 1,
      sym__declarator,
    STATE(1188), 1,
      sym_init_declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [33206] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(996), 1,
      sym__declarator,
    STATE(1188), 1,
      sym_init_declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [33237] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1054), 1,
      sym__declarator,
    STATE(1234), 1,
      sym_init_declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [33268] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1034), 1,
      sym__declarator,
    STATE(1162), 1,
      sym_init_declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [33299] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1037), 1,
      sym__declarator,
    STATE(1180), 1,
      sym_init_declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [33330] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(994), 1,
      sym__declarator,
    STATE(1180), 1,
      sym_init_declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [33361] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1000), 1,
      sym__declarator,
    STATE(1162), 1,
      sym_init_declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [33392] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1042), 1,
      sym__declarator,
    STATE(1157), 1,
      sym_init_declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [33423] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(1049), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [33451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_LBRACE,
    STATE(1020), 1,
      sym_field_declaration_list,
    ACTIONS(2038), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [33471] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(1094), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [33499] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_LPAREN2,
    ACTIONS(1988), 1,
      anon_sym_STAR,
    STATE(1126), 1,
      sym__field_declarator,
    STATE(1403), 1,
      sym_ms_based_modifier,
    STATE(1055), 4,
      sym_parenthesized_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [33527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_LBRACE,
    STATE(1019), 1,
      sym_field_declaration_list,
    ACTIONS(2012), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [33547] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1128), 1,
      sym__declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [33575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 1,
      anon_sym___attribute__,
    STATE(971), 2,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(2412), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [33595] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(1050), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [33623] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1099), 1,
      sym__declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [33651] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1086), 1,
      sym__declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [33679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1705), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
    ACTIONS(2417), 4,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [33699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_LBRACE,
    STATE(1029), 1,
      sym_field_declaration_list,
    ACTIONS(2024), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [33719] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(1052), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [33747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_LBRACE,
    STATE(1025), 1,
      sym_field_declaration_list,
    ACTIONS(2028), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [33767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 10,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
  [33783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym___attribute__,
    STATE(991), 2,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(2422), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [33803] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(1116), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [33831] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(1066), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [33859] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(1056), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [33887] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1096), 1,
      sym__declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [33915] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(1061), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [33943] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(1047), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [33971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    STATE(1022), 1,
      sym_enumerator_list,
    ACTIONS(2018), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [33991] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1990), 1,
      sym_identifier,
    ACTIONS(1992), 1,
      anon_sym_LPAREN2,
    ACTIONS(1994), 1,
      anon_sym_STAR,
    STATE(1065), 1,
      sym__type_declarator,
    STATE(1250), 1,
      sym_ms_based_modifier,
    STATE(1089), 4,
      sym_parenthesized_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [34019] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_LPAREN2,
    ACTIONS(1988), 1,
      anon_sym_STAR,
    STATE(1069), 1,
      sym__field_declarator,
    STATE(1403), 1,
      sym_ms_based_modifier,
    STATE(1055), 4,
      sym_parenthesized_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [34047] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 1,
      anon_sym___based,
    ACTIONS(1653), 1,
      sym_identifier,
    ACTIONS(1980), 1,
      anon_sym_LPAREN2,
    ACTIONS(1982), 1,
      anon_sym_STAR,
    STATE(1087), 1,
      sym__declarator,
    STATE(1329), 1,
      sym_ms_based_modifier,
    STATE(1035), 4,
      sym_parenthesized_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [34075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym___attribute__,
    STATE(971), 2,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(2428), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [34095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2430), 10,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
  [34111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2432), 10,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
  [34127] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2438), 1,
      anon_sym_SEMI,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    ACTIONS(2442), 1,
      anon_sym_EQ,
    STATE(256), 1,
      sym_compound_statement,
    STATE(980), 1,
      sym_parameter_list,
    STATE(1143), 1,
      aux_sym_declaration_repeat1,
  [34158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 1,
      sym_identifier,
    ACTIONS(2448), 1,
      sym_system_lib_string,
    STATE(1388), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(2446), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [34179] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(318), 1,
      anon_sym_LBRACE,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    ACTIONS(2442), 1,
      anon_sym_EQ,
    ACTIONS(2450), 1,
      anon_sym_SEMI,
    STATE(241), 1,
      sym_compound_statement,
    STATE(980), 1,
      sym_parameter_list,
    STATE(1178), 1,
      aux_sym_declaration_repeat1,
  [34210] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      sym_identifier,
    ACTIONS(2454), 1,
      sym_system_lib_string,
    STATE(1247), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(2446), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [34231] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(370), 1,
      anon_sym_LBRACE,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    ACTIONS(2442), 1,
      anon_sym_EQ,
    ACTIONS(2456), 1,
      anon_sym_SEMI,
    STATE(233), 1,
      sym_compound_statement,
    STATE(980), 1,
      sym_parameter_list,
    STATE(1147), 1,
      aux_sym_declaration_repeat1,
  [34262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2458), 1,
      sym_identifier,
    ACTIONS(2460), 1,
      sym_system_lib_string,
    STATE(1253), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(2446), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [34283] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_LBRACE,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    ACTIONS(2442), 1,
      anon_sym_EQ,
    ACTIONS(2462), 1,
      anon_sym_SEMI,
    STATE(119), 1,
      sym_compound_statement,
    STATE(980), 1,
      sym_parameter_list,
    STATE(1172), 1,
      aux_sym_declaration_repeat1,
  [34314] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2464), 1,
      sym_identifier,
    ACTIONS(2466), 1,
      sym_system_lib_string,
    STATE(1332), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(2446), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [34335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2177), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    STATE(980), 1,
      sym_parameter_list,
    ACTIONS(2468), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [34397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_LPAREN2,
    ACTIONS(1591), 7,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34413] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2396), 1,
      anon_sym_COLON,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2470), 1,
      anon_sym_COMMA,
    ACTIONS(2472), 1,
      anon_sym_SEMI,
    ACTIONS(2474), 1,
      anon_sym_LBRACK,
    STATE(1062), 1,
      sym_parameter_list,
    STATE(1076), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1432), 1,
      sym_bitfield_clause,
  [34441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2476), 1,
      anon_sym_LPAREN2,
    ACTIONS(1591), 7,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2245), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    STATE(980), 1,
      sym_parameter_list,
    ACTIONS(2479), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [34491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2161), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2263), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2157), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    STATE(980), 1,
      sym_parameter_list,
    ACTIONS(2481), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [34567] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2396), 1,
      anon_sym_COLON,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2470), 1,
      anon_sym_COMMA,
    ACTIONS(2474), 1,
      anon_sym_LBRACK,
    ACTIONS(2483), 1,
      anon_sym_SEMI,
    STATE(1062), 1,
      sym_parameter_list,
    STATE(1106), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1290), 1,
      sym_bitfield_clause,
  [34595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2127), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2199), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2257), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34679] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    STATE(980), 1,
      sym_parameter_list,
    ACTIONS(2485), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [34699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1712), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34755] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2396), 1,
      anon_sym_COLON,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2470), 1,
      anon_sym_COMMA,
    ACTIONS(2474), 1,
      anon_sym_LBRACK,
    ACTIONS(2487), 1,
      anon_sym_SEMI,
    STATE(1062), 1,
      sym_parameter_list,
    STATE(1102), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1341), 1,
      sym_bitfield_clause,
  [34783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2292), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 8,
      ts_builtin_sym_end,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
  [34825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2474), 1,
      anon_sym_LBRACK,
    STATE(1062), 1,
      sym_parameter_list,
    ACTIONS(2489), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [34844] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2474), 1,
      anon_sym_LBRACK,
    STATE(1062), 1,
      sym_parameter_list,
    ACTIONS(2491), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [34863] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    ACTIONS(2442), 1,
      anon_sym_EQ,
    ACTIONS(2462), 1,
      anon_sym_SEMI,
    STATE(980), 1,
      sym_parameter_list,
    STATE(1172), 1,
      aux_sym_declaration_repeat1,
  [34888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2493), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [34901] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2474), 1,
      anon_sym_LBRACK,
    STATE(1062), 1,
      sym_parameter_list,
    ACTIONS(2495), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [34920] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2438), 1,
      anon_sym_SEMI,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    ACTIONS(2442), 1,
      anon_sym_EQ,
    STATE(980), 1,
      sym_parameter_list,
    STATE(1143), 1,
      aux_sym_declaration_repeat1,
  [34945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2497), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [34958] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    ACTIONS(2442), 1,
      anon_sym_EQ,
    ACTIONS(2450), 1,
      anon_sym_SEMI,
    STATE(980), 1,
      sym_parameter_list,
    STATE(1178), 1,
      aux_sym_declaration_repeat1,
  [34983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [34996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2501), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [35009] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    ACTIONS(2442), 1,
      anon_sym_EQ,
    ACTIONS(2456), 1,
      anon_sym_SEMI,
    STATE(980), 1,
      sym_parameter_list,
    STATE(1147), 1,
      aux_sym_declaration_repeat1,
  [35034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [35047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2505), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [35060] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2474), 1,
      anon_sym_LBRACK,
    STATE(1062), 1,
      sym_parameter_list,
    ACTIONS(2507), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [35079] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2511), 1,
      anon_sym_LBRACK,
    STATE(1107), 1,
      sym_parameter_list,
    ACTIONS(2509), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [35097] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2515), 1,
      anon_sym_SEMI,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    STATE(1082), 1,
      sym_parameter_list,
    STATE(1141), 1,
      aux_sym_type_definition_repeat2,
  [35119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2511), 1,
      anon_sym_LBRACK,
    STATE(1107), 1,
      sym_parameter_list,
    ACTIONS(2519), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [35137] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    ACTIONS(2521), 1,
      anon_sym_SEMI,
    STATE(1082), 1,
      sym_parameter_list,
    STATE(1184), 1,
      aux_sym_type_definition_repeat2,
  [35159] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    ACTIONS(2523), 1,
      anon_sym_SEMI,
    STATE(1082), 1,
      sym_parameter_list,
    STATE(1177), 1,
      aux_sym_type_definition_repeat2,
  [35181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2525), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [35193] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    ACTIONS(2527), 1,
      anon_sym_SEMI,
    STATE(1082), 1,
      sym_parameter_list,
    STATE(1182), 1,
      aux_sym_type_definition_repeat2,
  [35215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 1,
      anon_sym_LBRACK,
    ACTIONS(2529), 1,
      anon_sym_EQ,
    ACTIONS(2531), 1,
      anon_sym_DOT,
    STATE(1070), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [35233] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    ACTIONS(2442), 1,
      anon_sym_EQ,
    STATE(980), 1,
      sym_parameter_list,
    ACTIONS(2533), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [35253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2535), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [35265] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    ACTIONS(2537), 1,
      anon_sym_SEMI,
    STATE(1082), 1,
      sym_parameter_list,
    STATE(1139), 1,
      aux_sym_type_definition_repeat2,
  [35287] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    STATE(1082), 1,
      sym_parameter_list,
    ACTIONS(2539), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2541), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [35317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [35329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2545), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [35341] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    ACTIONS(2547), 1,
      anon_sym_SEMI,
    STATE(1082), 1,
      sym_parameter_list,
    STATE(1134), 1,
      aux_sym_type_definition_repeat2,
  [35363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2549), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [35375] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    STATE(1082), 1,
      sym_parameter_list,
    ACTIONS(2551), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35393] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    STATE(1082), 1,
      sym_parameter_list,
    ACTIONS(2553), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35411] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    ACTIONS(2555), 1,
      anon_sym_SEMI,
    STATE(1082), 1,
      sym_parameter_list,
    STATE(1166), 1,
      aux_sym_type_definition_repeat2,
  [35433] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    ACTIONS(2557), 1,
      anon_sym_SEMI,
    STATE(1082), 1,
      sym_parameter_list,
    STATE(1135), 1,
      aux_sym_type_definition_repeat2,
  [35455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2559), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [35467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [35479] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2474), 1,
      anon_sym_LBRACK,
    STATE(1062), 1,
      sym_parameter_list,
    ACTIONS(2563), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [35497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2565), 1,
      anon_sym_LBRACK,
    ACTIONS(2568), 1,
      anon_sym_EQ,
    ACTIONS(2570), 1,
      anon_sym_DOT,
    STATE(1070), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [35515] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    STATE(1082), 1,
      sym_parameter_list,
    ACTIONS(2573), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [35533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2511), 1,
      anon_sym_LBRACK,
    STATE(1107), 1,
      sym_parameter_list,
    ACTIONS(2575), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [35550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [35561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2579), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [35572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [35583] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2396), 1,
      anon_sym_COLON,
    ACTIONS(2470), 1,
      anon_sym_COMMA,
    ACTIONS(2583), 1,
      anon_sym_SEMI,
    STATE(1115), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1377), 1,
      sym_bitfield_clause,
  [35602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [35613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2511), 1,
      anon_sym_LBRACK,
    STATE(1107), 1,
      sym_parameter_list,
    ACTIONS(2587), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [35630] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    STATE(980), 1,
      sym_parameter_list,
    ACTIONS(2587), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [35647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2589), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [35658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2591), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [35669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2593), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [35680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2511), 1,
      anon_sym_LBRACK,
    STATE(1107), 1,
      sym_parameter_list,
    ACTIONS(2595), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [35697] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2597), 1,
      sym_identifier,
    STATE(830), 1,
      sym_field_declaration_list,
    STATE(1149), 1,
      sym_ms_declspec_modifier,
  [35716] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2511), 1,
      anon_sym_LBRACK,
    STATE(1107), 1,
      sym_parameter_list,
    ACTIONS(2599), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [35733] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_LBRACE,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    STATE(121), 1,
      sym_compound_statement,
    STATE(980), 1,
      sym_parameter_list,
  [35752] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(318), 1,
      anon_sym_LBRACE,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    STATE(285), 1,
      sym_compound_statement,
    STATE(980), 1,
      sym_parameter_list,
  [35771] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2601), 1,
      sym_identifier,
    STATE(829), 1,
      sym_field_declaration_list,
    STATE(1142), 1,
      sym_ms_declspec_modifier,
  [35790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2603), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [35801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2605), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [35812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2607), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [35823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [35834] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(2410), 1,
      anon_sym_LBRACE,
    ACTIONS(2611), 1,
      sym_identifier,
    STATE(1013), 1,
      sym_field_declaration_list,
    STATE(1154), 1,
      sym_ms_declspec_modifier,
  [35853] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    STATE(1082), 1,
      sym_parameter_list,
    ACTIONS(2613), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [35870] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___declspec,
    ACTIONS(2410), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_identifier,
    STATE(1003), 1,
      sym_field_declaration_list,
    STATE(1153), 1,
      sym_ms_declspec_modifier,
  [35889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(370), 1,
      anon_sym_LBRACE,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    STATE(232), 1,
      sym_compound_statement,
    STATE(980), 1,
      sym_parameter_list,
  [35908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2617), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [35919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2619), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [35930] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    STATE(250), 1,
      sym_compound_statement,
    STATE(980), 1,
      sym_parameter_list,
  [35949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [35960] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2511), 1,
      anon_sym_LBRACK,
    STATE(1107), 1,
      sym_parameter_list,
    ACTIONS(2623), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [35977] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2396), 1,
      anon_sym_COLON,
    ACTIONS(2470), 1,
      anon_sym_COMMA,
    ACTIONS(2625), 1,
      anon_sym_SEMI,
    STATE(1115), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1315), 1,
      sym_bitfield_clause,
  [35996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2627), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [36007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2629), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [36018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [36029] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2396), 1,
      anon_sym_COLON,
    ACTIONS(2470), 1,
      anon_sym_COMMA,
    ACTIONS(2633), 1,
      anon_sym_SEMI,
    STATE(1115), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1367), 1,
      sym_bitfield_clause,
  [36048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2635), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [36059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2637), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [36070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2639), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [36081] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2641), 1,
      anon_sym_LF,
    ACTIONS(2643), 1,
      anon_sym_LPAREN,
    ACTIONS(2645), 1,
      sym_preproc_arg,
    STATE(1244), 1,
      sym_preproc_params,
  [36097] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2647), 1,
      anon_sym_DQUOTE,
    ACTIONS(2649), 1,
      aux_sym_string_literal_token1,
    ACTIONS(2651), 1,
      sym_escape_sequence,
    STATE(1120), 1,
      aux_sym_string_literal_repeat1,
  [36113] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2653), 1,
      anon_sym_DQUOTE,
    ACTIONS(2655), 1,
      aux_sym_string_literal_token1,
    ACTIONS(2657), 1,
      sym_escape_sequence,
    STATE(1118), 1,
      aux_sym_string_literal_repeat1,
  [36129] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2655), 1,
      aux_sym_string_literal_token1,
    ACTIONS(2657), 1,
      sym_escape_sequence,
    ACTIONS(2659), 1,
      anon_sym_DQUOTE,
    STATE(1118), 1,
      aux_sym_string_literal_repeat1,
  [36145] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2643), 1,
      anon_sym_LPAREN,
    ACTIONS(2661), 1,
      anon_sym_LF,
    ACTIONS(2663), 1,
      sym_preproc_arg,
    STATE(1230), 1,
      sym_preproc_params,
  [36161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2665), 1,
      anon_sym_COMMA,
    STATE(1115), 1,
      aux_sym_field_declaration_repeat1,
    ACTIONS(2668), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
  [36175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2517), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_RPAREN,
    STATE(1082), 1,
      sym_parameter_list,
  [36191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 1,
      sym_identifier,
    ACTIONS(2674), 1,
      anon_sym_COMMA,
    ACTIONS(2676), 1,
      anon_sym_RBRACE,
    STATE(1175), 1,
      sym_enumerator,
  [36207] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_DQUOTE,
    ACTIONS(2680), 1,
      aux_sym_string_literal_token1,
    ACTIONS(2683), 1,
      sym_escape_sequence,
    STATE(1118), 1,
      aux_sym_string_literal_repeat1,
  [36223] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2686), 1,
      anon_sym_DQUOTE,
    ACTIONS(2688), 1,
      aux_sym_string_literal_token1,
    ACTIONS(2690), 1,
      sym_escape_sequence,
    STATE(1112), 1,
      aux_sym_string_literal_repeat1,
  [36239] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2655), 1,
      aux_sym_string_literal_token1,
    ACTIONS(2657), 1,
      sym_escape_sequence,
    ACTIONS(2692), 1,
      anon_sym_DQUOTE,
    STATE(1118), 1,
      aux_sym_string_literal_repeat1,
  [36255] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2694), 1,
      anon_sym_DQUOTE,
    ACTIONS(2696), 1,
      aux_sym_string_literal_token1,
    ACTIONS(2698), 1,
      sym_escape_sequence,
    STATE(1113), 1,
      aux_sym_string_literal_repeat1,
  [36271] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2643), 1,
      anon_sym_LPAREN,
    ACTIONS(2700), 1,
      anon_sym_LF,
    ACTIONS(2702), 1,
      sym_preproc_arg,
    STATE(1243), 1,
      sym_preproc_params,
  [36287] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2643), 1,
      anon_sym_LPAREN,
    ACTIONS(2704), 1,
      anon_sym_LF,
    ACTIONS(2706), 1,
      sym_preproc_arg,
    STATE(1225), 1,
      sym_preproc_params,
  [36303] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2643), 1,
      anon_sym_LPAREN,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(2710), 1,
      sym_preproc_arg,
    STATE(1233), 1,
      sym_preproc_params,
  [36319] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2643), 1,
      anon_sym_LPAREN,
    ACTIONS(2712), 1,
      anon_sym_LF,
    ACTIONS(2714), 1,
      sym_preproc_arg,
    STATE(1201), 1,
      sym_preproc_params,
  [36335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2474), 1,
      anon_sym_LBRACK,
    ACTIONS(2716), 1,
      anon_sym_RPAREN,
    STATE(1062), 1,
      sym_parameter_list,
  [36351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2511), 1,
      anon_sym_LBRACK,
    ACTIONS(2718), 1,
      anon_sym_RPAREN,
    STATE(1107), 1,
      sym_parameter_list,
  [36367] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_LPAREN2,
    ACTIONS(2440), 1,
      anon_sym_LBRACK,
    ACTIONS(2720), 1,
      anon_sym_RPAREN,
    STATE(980), 1,
      sym_parameter_list,
  [36383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 1,
      sym_identifier,
    ACTIONS(2722), 1,
      anon_sym_COMMA,
    ACTIONS(2724), 1,
      anon_sym_RBRACE,
    STATE(1179), 1,
      sym_enumerator,
  [36399] = 5,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2643), 1,
      anon_sym_LPAREN,
    ACTIONS(2726), 1,
      anon_sym_LF,
    ACTIONS(2728), 1,
      sym_preproc_arg,
    STATE(1229), 1,
      sym_preproc_params,
  [36415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 1,
      anon_sym_COMMA,
    ACTIONS(2732), 1,
      anon_sym_RPAREN,
    STATE(1181), 1,
      aux_sym_parameter_list_repeat1,
  [36428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_RPAREN,
    ACTIONS(2734), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [36439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 1,
      sym_identifier,
    ACTIONS(2738), 1,
      anon_sym_RBRACE,
    STATE(1242), 1,
      sym_enumerator,
  [36452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_SEMI,
    STATE(1137), 1,
      aux_sym_type_definition_repeat2,
  [36465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2742), 1,
      anon_sym_SEMI,
    STATE(1137), 1,
      aux_sym_type_definition_repeat2,
  [36478] = 4,
    ACTIONS(2091), 1,
      anon_sym_LPAREN2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LF,
    STATE(900), 1,
      sym_preproc_argument_list,
  [36491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2746), 1,
      anon_sym_COMMA,
    ACTIONS(2749), 1,
      anon_sym_SEMI,
    STATE(1137), 1,
      aux_sym_type_definition_repeat2,
  [36504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 1,
      sym_identifier,
    ACTIONS(2751), 1,
      anon_sym_RBRACE,
    STATE(1242), 1,
      sym_enumerator,
  [36517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2753), 1,
      anon_sym_SEMI,
    STATE(1137), 1,
      aux_sym_type_definition_repeat2,
  [36530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2755), 1,
      anon_sym_SEMI,
    STATE(1171), 1,
      aux_sym_declaration_repeat1,
  [36543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2757), 1,
      anon_sym_SEMI,
    STATE(1137), 1,
      aux_sym_type_definition_repeat2,
  [36556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2759), 1,
      sym_identifier,
    STATE(887), 1,
      sym_field_declaration_list,
  [36569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2761), 1,
      anon_sym_SEMI,
    STATE(1171), 1,
      aux_sym_declaration_repeat1,
  [36582] = 4,
    ACTIONS(2091), 1,
      anon_sym_LPAREN2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2763), 1,
      anon_sym_LF,
    STATE(900), 1,
      sym_preproc_argument_list,
  [36595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2056), 1,
      anon_sym_COMMA,
    ACTIONS(2765), 1,
      anon_sym_RPAREN,
    STATE(1174), 1,
      aux_sym_preproc_argument_list_repeat1,
  [36608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2767), 1,
      anon_sym_SEMI,
    STATE(1171), 1,
      aux_sym_declaration_repeat1,
  [36621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2769), 1,
      anon_sym_SEMI,
    STATE(1171), 1,
      aux_sym_declaration_repeat1,
  [36634] = 4,
    ACTIONS(2091), 1,
      anon_sym_LPAREN2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_LF,
    STATE(900), 1,
      sym_preproc_argument_list,
  [36647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2773), 1,
      sym_identifier,
    STATE(889), 1,
      sym_field_declaration_list,
  [36660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2775), 1,
      anon_sym_COMMA,
    ACTIONS(2777), 1,
      anon_sym_RBRACE,
    STATE(1156), 1,
      aux_sym_enumerator_list_repeat1,
  [36673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 1,
      anon_sym_COMMA,
    ACTIONS(2781), 1,
      anon_sym_RBRACE,
    STATE(1156), 1,
      aux_sym_enumerator_list_repeat1,
  [36686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2783), 1,
      sym_identifier,
    STATE(1011), 1,
      sym_enumerator_list,
  [36699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      sym_identifier,
    STATE(1030), 1,
      sym_field_declaration_list,
  [36712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_LBRACE,
    ACTIONS(2787), 1,
      sym_identifier,
    STATE(1027), 1,
      sym_field_declaration_list,
  [36725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1226), 1,
      anon_sym_RBRACE,
    ACTIONS(2789), 1,
      anon_sym_COMMA,
    STATE(1185), 1,
      aux_sym_initializer_list_repeat1,
  [36738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_COMMA,
    ACTIONS(2794), 1,
      anon_sym_RBRACE,
    STATE(1156), 1,
      aux_sym_enumerator_list_repeat1,
  [36751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2796), 1,
      anon_sym_SEMI,
    STATE(1146), 1,
      aux_sym_declaration_repeat1,
  [36764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_COMMA,
    ACTIONS(1728), 1,
      anon_sym_RBRACE,
    STATE(1155), 1,
      aux_sym_initializer_list_repeat1,
  [36777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2800), 1,
      anon_sym_RPAREN,
    STATE(1187), 1,
      aux_sym_preproc_params_repeat1,
  [36790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1722), 1,
      anon_sym_COMMA,
    ACTIONS(2802), 1,
      anon_sym_RPAREN,
    STATE(1167), 1,
      aux_sym_argument_list_repeat1,
  [36803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 1,
      sym_identifier,
    ACTIONS(2777), 1,
      anon_sym_RBRACE,
    STATE(1242), 1,
      sym_enumerator,
  [36816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2804), 1,
      anon_sym_SEMI,
    STATE(1173), 1,
      aux_sym_declaration_repeat1,
  [36829] = 4,
    ACTIONS(2091), 1,
      anon_sym_LPAREN2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2806), 1,
      anon_sym_LF,
    STATE(900), 1,
      sym_preproc_argument_list,
  [36842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 1,
      sym_identifier,
    ACTIONS(2781), 1,
      anon_sym_RBRACE,
    STATE(1242), 1,
      sym_enumerator,
  [36855] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2808), 1,
      anon_sym_RPAREN,
    STATE(1159), 1,
      aux_sym_preproc_params_repeat1,
  [36868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2810), 1,
      anon_sym_SEMI,
    STATE(1137), 1,
      aux_sym_type_definition_repeat2,
  [36881] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1760), 1,
      anon_sym_RPAREN,
    ACTIONS(2812), 1,
      anon_sym_COMMA,
    STATE(1167), 1,
      aux_sym_argument_list_repeat1,
  [36894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2815), 1,
      anon_sym_COMMA,
    ACTIONS(2818), 1,
      anon_sym_RPAREN,
    STATE(1168), 1,
      aux_sym_parameter_list_repeat1,
  [36907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2056), 1,
      anon_sym_COMMA,
    ACTIONS(2820), 1,
      anon_sym_RPAREN,
    STATE(1174), 1,
      aux_sym_preproc_argument_list_repeat1,
  [36920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2824), 1,
      anon_sym_EQ,
    ACTIONS(2822), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [36931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      anon_sym_COMMA,
    ACTIONS(2829), 1,
      anon_sym_SEMI,
    STATE(1171), 1,
      aux_sym_declaration_repeat1,
  [36944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2831), 1,
      anon_sym_SEMI,
    STATE(1171), 1,
      aux_sym_declaration_repeat1,
  [36957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2833), 1,
      anon_sym_SEMI,
    STATE(1171), 1,
      aux_sym_declaration_repeat1,
  [36970] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 1,
      anon_sym_RPAREN,
    ACTIONS(2835), 1,
      anon_sym_COMMA,
    STATE(1174), 1,
      aux_sym_preproc_argument_list_repeat1,
  [36983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_COMMA,
    ACTIONS(2840), 1,
      anon_sym_RBRACE,
    STATE(1150), 1,
      aux_sym_enumerator_list_repeat1,
  [36996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2842), 1,
      anon_sym_SEMI,
    STATE(1171), 1,
      aux_sym_declaration_repeat1,
  [37009] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2844), 1,
      anon_sym_SEMI,
    STATE(1137), 1,
      aux_sym_type_definition_repeat2,
  [37022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2846), 1,
      anon_sym_SEMI,
    STATE(1171), 1,
      aux_sym_declaration_repeat1,
  [37035] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2848), 1,
      anon_sym_COMMA,
    ACTIONS(2850), 1,
      anon_sym_RBRACE,
    STATE(1151), 1,
      aux_sym_enumerator_list_repeat1,
  [37048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2852), 1,
      anon_sym_SEMI,
    STATE(1140), 1,
      aux_sym_declaration_repeat1,
  [37061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 1,
      anon_sym_COMMA,
    ACTIONS(2854), 1,
      anon_sym_RPAREN,
    STATE(1168), 1,
      aux_sym_parameter_list_repeat1,
  [37074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2856), 1,
      anon_sym_SEMI,
    STATE(1137), 1,
      aux_sym_type_definition_repeat2,
  [37087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [37096] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    ACTIONS(2860), 1,
      anon_sym_SEMI,
    STATE(1137), 1,
      aux_sym_type_definition_repeat2,
  [37109] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1812), 1,
      anon_sym_RBRACE,
    ACTIONS(2862), 1,
      anon_sym_COMMA,
    STATE(1185), 1,
      aux_sym_initializer_list_repeat1,
  [37122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    ACTIONS(2865), 1,
      sym_identifier,
    STATE(831), 1,
      sym_enumerator_list,
  [37135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2867), 1,
      anon_sym_COMMA,
    ACTIONS(2870), 1,
      anon_sym_RPAREN,
    STATE(1187), 1,
      aux_sym_preproc_params_repeat1,
  [37148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    ACTIONS(2872), 1,
      anon_sym_SEMI,
    STATE(1176), 1,
      aux_sym_declaration_repeat1,
  [37161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [37170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(349), 1,
      sym_parenthesized_expression,
  [37180] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2878), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [37188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 1,
      sym_identifier,
    STATE(1242), 1,
      sym_enumerator,
  [37198] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2880), 1,
      anon_sym_LF,
    ACTIONS(2882), 1,
      sym_preproc_arg,
  [37208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(352), 1,
      sym_parenthesized_expression,
  [37218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 1,
      anon_sym_LPAREN2,
    STATE(1211), 1,
      sym_parenthesized_expression,
  [37228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(355), 1,
      sym_parenthesized_expression,
  [37238] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2886), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [37246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(318), 1,
      anon_sym_LBRACE,
    STATE(129), 1,
      sym_compound_statement,
  [37256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [37264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1732), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [37272] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2888), 1,
      anon_sym_LF,
    ACTIONS(2890), 1,
      sym_preproc_arg,
  [37282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 1,
      anon_sym_LPAREN2,
    STATE(1278), 1,
      sym_parenthesized_expression,
  [37292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1812), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [37300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2892), 1,
      sym_identifier,
    ACTIONS(2894), 1,
      anon_sym_LPAREN2,
  [37310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 1,
      anon_sym_LPAREN2,
    STATE(1235), 1,
      sym_parenthesized_expression,
  [37320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    STATE(1325), 1,
      sym_argument_list,
  [37330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 1,
      anon_sym_LPAREN2,
    STATE(1390), 1,
      sym_parenthesized_expression,
  [37340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1798), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [37348] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2896), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [37356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 1,
      anon_sym_LPAREN2,
    STATE(1224), 1,
      sym_parenthesized_expression,
  [37366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    STATE(221), 1,
      sym_compound_statement,
  [37376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_LPAREN2,
    STATE(1269), 1,
      sym_argument_list,
  [37386] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2898), 2,
      anon_sym_LF,
      sym_preproc_arg,
  [37394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 1,
      anon_sym_LPAREN2,
    STATE(1347), 1,
      sym_parenthesized_expression,
  [37404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(928), 1,
      anon_sym_while,
    ACTIONS(2900), 1,
      anon_sym_else,
  [37414] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2902), 1,
      anon_sym_LF,
    ACTIONS(2904), 1,
      sym_preproc_arg,
  [37424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2906), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [37432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(356), 1,
      sym_parenthesized_expression,
  [37442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(345), 1,
      sym_parenthesized_expression,
  [37460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2818), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37468] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2908), 2,
      anon_sym_LF,
      sym_preproc_arg,
  [37476] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_LF,
    ACTIONS(2912), 1,
      sym_preproc_arg,
  [37486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_LBRACE,
    STATE(83), 1,
      sym_compound_statement,
  [37496] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2914), 1,
      anon_sym_LF,
    ACTIONS(2916), 1,
      sym_preproc_arg,
  [37506] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2918), 1,
      anon_sym_LF,
    ACTIONS(2920), 1,
      sym_preproc_arg,
  [37516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(342), 1,
      sym_parenthesized_expression,
  [37526] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2922), 1,
      anon_sym_LF,
    ACTIONS(2924), 1,
      sym_preproc_arg,
  [37536] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2926), 1,
      anon_sym_LF,
    ACTIONS(2928), 1,
      sym_preproc_arg,
  [37546] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2930), 1,
      anon_sym_LF,
    ACTIONS(2932), 1,
      sym_preproc_arg,
  [37556] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2934), 2,
      anon_sym_LF,
      sym_preproc_arg,
  [37564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      sym_identifier,
    ACTIONS(2938), 1,
      anon_sym_LPAREN2,
  [37574] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2940), 1,
      anon_sym_LF,
    ACTIONS(2942), 1,
      sym_preproc_arg,
  [37584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [37592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(370), 1,
      anon_sym_LBRACE,
    STATE(191), 1,
      sym_compound_statement,
  [37602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(348), 1,
      sym_parenthesized_expression,
  [37612] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LF,
    ACTIONS(2946), 1,
      sym_preproc_arg,
  [37622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(358), 1,
      sym_parenthesized_expression,
  [37632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(295), 1,
      sym_parenthesized_expression,
  [37642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 1,
      anon_sym_LPAREN2,
    STATE(1198), 1,
      sym_parenthesized_expression,
  [37652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(351), 1,
      sym_parenthesized_expression,
  [37662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [37670] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2948), 1,
      anon_sym_LF,
    ACTIONS(2950), 1,
      sym_preproc_arg,
  [37680] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LF,
    ACTIONS(2954), 1,
      sym_preproc_arg,
  [37690] = 3,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2956), 1,
      anon_sym_LF,
    ACTIONS(2958), 1,
      sym_preproc_arg,
  [37700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 1,
      anon_sym_LPAREN2,
    STATE(1308), 1,
      sym_parenthesized_expression,
  [37710] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2771), 1,
      anon_sym_LF,
  [37717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1748), 1,
      anon_sym_RPAREN,
  [37724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2960), 1,
      aux_sym_preproc_if_token2,
  [37731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2962), 1,
      anon_sym_STAR,
  [37738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 1,
      anon_sym_RPAREN,
  [37745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1750), 1,
      anon_sym_SEMI,
  [37752] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2806), 1,
      anon_sym_LF,
  [37759] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2966), 1,
      anon_sym_LF,
  [37766] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2968), 1,
      anon_sym_LF,
  [37773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2970), 1,
      aux_sym_preproc_if_token2,
  [37780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2972), 1,
      aux_sym_preproc_if_token2,
  [37787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_RBRACE,
  [37794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2974), 1,
      sym_identifier,
  [37801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1758), 1,
      anon_sym_SEMI,
  [37808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2976), 1,
      anon_sym_SEMI,
  [37815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 1,
      anon_sym_SQUOTE,
  [37822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2980), 1,
      anon_sym_SEMI,
  [37829] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2982), 1,
      anon_sym_LF,
  [37836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1734), 1,
      anon_sym_SEMI,
  [37843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2984), 1,
      aux_sym_preproc_if_token2,
  [37850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1840), 1,
      anon_sym_RPAREN,
  [37857] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2986), 1,
      anon_sym_LF,
  [37864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2988), 1,
      anon_sym_STAR,
  [37871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2990), 1,
      aux_sym_preproc_if_token2,
  [37878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 1,
      anon_sym_SEMI,
  [37885] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_LF,
  [37892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      aux_sym_preproc_if_token2,
  [37899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 1,
      anon_sym_SEMI,
  [37906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 1,
      aux_sym_preproc_if_token2,
  [37913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_SEMI,
  [37920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3002), 1,
      anon_sym_COLON,
  [37927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3004), 1,
      anon_sym_SEMI,
  [37934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3006), 1,
      aux_sym_preproc_if_token2,
  [37941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1762), 1,
      anon_sym_RPAREN,
  [37948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 1,
      anon_sym_RPAREN,
  [37955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      sym_identifier,
  [37962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1766), 1,
      anon_sym_RPAREN,
  [37969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3010), 1,
      aux_sym_preproc_if_token2,
  [37976] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3012), 1,
      anon_sym_LF,
  [37983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1770), 1,
      anon_sym_RPAREN,
  [37990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_COLON,
  [37997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1772), 1,
      anon_sym_RPAREN,
  [38004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1790), 1,
      anon_sym_RPAREN,
  [38011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3016), 1,
      anon_sym_SEMI,
  [38018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 1,
      anon_sym_SEMI,
  [38025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_RPAREN,
  [38032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3020), 1,
      aux_sym_preproc_if_token2,
  [38039] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3022), 1,
      anon_sym_LF,
  [38046] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_LF,
  [38053] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3026), 1,
      anon_sym_LF,
  [38060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3028), 1,
      anon_sym_SEMI,
  [38067] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3030), 1,
      anon_sym_LF,
  [38074] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_LF,
  [38081] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym_LF,
  [38088] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_LF,
  [38095] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3038), 1,
      anon_sym_LF,
  [38102] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3040), 1,
      anon_sym_LF,
  [38109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1862), 1,
      anon_sym_RPAREN,
  [38116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 1,
      sym_identifier,
  [38123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      sym_identifier,
  [38130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1860), 1,
      anon_sym_RPAREN,
  [38137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 1,
      anon_sym_SEMI,
  [38144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 1,
      sym_identifier,
  [38151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 1,
      sym_identifier,
  [38158] = 2,
    ACTIONS(1383), 1,
      anon_sym_LF,
    ACTIONS(2093), 1,
      sym_comment,
  [38165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1836), 1,
      anon_sym_RPAREN,
  [38172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3052), 1,
      aux_sym_preproc_if_token2,
  [38179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 1,
      anon_sym_SEMI,
  [38186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_SEMI,
  [38193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      aux_sym_preproc_if_token2,
  [38200] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3060), 1,
      anon_sym_LF,
  [38207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      aux_sym_preproc_if_token2,
  [38214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_SEMI,
  [38221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3064), 1,
      sym_identifier,
  [38228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3066), 1,
      anon_sym_RPAREN,
  [38235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3068), 1,
      sym_identifier,
  [38242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_COLON,
  [38249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1810), 1,
      anon_sym_RPAREN,
  [38256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym_RPAREN,
  [38263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_RPAREN,
  [38270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_RPAREN,
  [38277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      aux_sym_preproc_if_token2,
  [38284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_STAR,
  [38291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 1,
      aux_sym_preproc_if_token2,
  [38298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 1,
      aux_sym_preproc_if_token2,
  [38305] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2763), 1,
      anon_sym_LF,
  [38312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1850), 1,
      anon_sym_RPAREN,
  [38319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1776), 1,
      anon_sym_RPAREN,
  [38326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3084), 1,
      anon_sym_SQUOTE,
  [38333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3086), 1,
      anon_sym_SEMI,
  [38340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1756), 1,
      anon_sym_RPAREN,
  [38347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym_SEMI,
  [38354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3088), 1,
      anon_sym_while,
  [38361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 1,
      anon_sym_RPAREN,
  [38368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_SEMI,
  [38375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_SEMI,
  [38382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      aux_sym_preproc_if_token2,
  [38389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_RPAREN,
  [38396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 1,
      aux_sym_preproc_if_token2,
  [38403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1742), 1,
      anon_sym_RPAREN,
  [38410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_SEMI,
  [38417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 1,
      anon_sym_SEMI,
  [38424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1842), 1,
      anon_sym_RPAREN,
  [38431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 1,
      aux_sym_preproc_if_token2,
  [38438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3106), 1,
      sym_identifier,
  [38445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3108), 1,
      sym_identifier,
  [38452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3110), 1,
      aux_sym_preproc_if_token2,
  [38459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_RPAREN,
  [38466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3112), 1,
      sym_identifier,
  [38473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3114), 1,
      sym_identifier,
  [38480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_RBRACE,
  [38487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3116), 1,
      aux_sym_preproc_if_token2,
  [38494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3118), 1,
      aux_sym_preproc_if_token2,
  [38501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      aux_sym_preproc_if_token2,
  [38508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3122), 1,
      anon_sym_RPAREN,
  [38515] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3124), 1,
      anon_sym_LF,
  [38522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3126), 1,
      sym_identifier,
  [38529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_RPAREN,
  [38536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_RPAREN,
  [38543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3128), 1,
      anon_sym_RPAREN,
  [38550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3130), 1,
      anon_sym_SEMI,
  [38557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3132), 1,
      anon_sym_RPAREN,
  [38564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1864), 1,
      anon_sym_RPAREN,
  [38571] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3134), 1,
      anon_sym_LF,
  [38578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3136), 1,
      anon_sym_RPAREN,
  [38585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym_RPAREN,
  [38592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3138), 1,
      sym_identifier,
  [38599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3140), 1,
      sym_identifier,
  [38606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1792), 1,
      anon_sym_RPAREN,
  [38613] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_LF,
  [38620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3144), 1,
      anon_sym_SEMI,
  [38627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3146), 1,
      sym_identifier,
  [38634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 1,
      anon_sym_RPAREN,
  [38641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_RBRACE,
  [38648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 1,
      aux_sym_preproc_if_token2,
  [38655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3150), 1,
      aux_sym_preproc_if_token2,
  [38662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 1,
      aux_sym_preproc_if_token2,
  [38669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3154), 1,
      aux_sym_preproc_if_token2,
  [38676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 1,
      aux_sym_preproc_if_token2,
  [38683] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3158), 1,
      anon_sym_LF,
  [38690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1848), 1,
      anon_sym_RPAREN,
  [38697] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LF,
  [38704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3160), 1,
      ts_builtin_sym_end,
  [38711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3162), 1,
      anon_sym_SEMI,
  [38718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      sym_identifier,
  [38725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3166), 1,
      sym_identifier,
  [38732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3168), 1,
      sym_identifier,
  [38739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3170), 1,
      anon_sym_SQUOTE,
  [38746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3172), 1,
      anon_sym_SEMI,
  [38753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1802), 1,
      anon_sym_SEMI,
  [38760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 1,
      aux_sym_preproc_if_token2,
  [38767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_SEMI,
  [38774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 1,
      anon_sym_while,
  [38781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      ts_builtin_sym_end,
  [38788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1838), 1,
      anon_sym_RPAREN,
  [38795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3178), 1,
      ts_builtin_sym_end,
  [38802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3180), 1,
      anon_sym_STAR,
  [38809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3182), 1,
      sym_identifier,
  [38816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1778), 1,
      anon_sym_SEMI,
  [38823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3184), 1,
      sym_identifier,
  [38830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3186), 1,
      anon_sym_SEMI,
  [38837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3188), 1,
      anon_sym_SEMI,
  [38844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 1,
      anon_sym_LPAREN2,
  [38851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_RPAREN,
  [38858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_SEMI,
  [38865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_COLON,
  [38872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_RPAREN,
  [38879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3196), 1,
      anon_sym_while,
  [38886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3198), 1,
      aux_sym_preproc_if_token2,
  [38893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      aux_sym_preproc_if_token2,
  [38900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 1,
      anon_sym_SEMI,
  [38907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1744), 1,
      anon_sym_SEMI,
  [38914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3204), 1,
      anon_sym_RPAREN,
  [38921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1844), 1,
      anon_sym_RPAREN,
  [38928] = 2,
    ACTIONS(2093), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_LF,
  [38935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3208), 1,
      aux_sym_preproc_if_token2,
  [38942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3210), 1,
      anon_sym_while,
  [38949] = 2,
    ACTIONS(1379), 1,
      anon_sym_LF,
    ACTIONS(2093), 1,
      sym_comment,
  [38956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_LPAREN2,
  [38963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1736), 1,
      anon_sym_SEMI,
  [38970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 1,
      anon_sym_LPAREN2,
  [38977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_LPAREN2,
  [38984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1768), 1,
      anon_sym_SEMI,
  [38991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3218), 1,
      sym_identifier,
  [38998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1808), 1,
      anon_sym_SEMI,
  [39005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3220), 1,
      anon_sym_SEMI,
  [39012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3222), 1,
      anon_sym_LPAREN2,
  [39019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3224), 1,
      sym_identifier,
  [39026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3226), 1,
      anon_sym_LPAREN2,
  [39033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN2,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(384)] = 0,
  [SMALL_STATE(385)] = 74,
  [SMALL_STATE(386)] = 146,
  [SMALL_STATE(387)] = 220,
  [SMALL_STATE(388)] = 292,
  [SMALL_STATE(389)] = 404,
  [SMALL_STATE(390)] = 504,
  [SMALL_STATE(391)] = 578,
  [SMALL_STATE(392)] = 650,
  [SMALL_STATE(393)] = 722,
  [SMALL_STATE(394)] = 796,
  [SMALL_STATE(395)] = 899,
  [SMALL_STATE(396)] = 996,
  [SMALL_STATE(397)] = 1099,
  [SMALL_STATE(398)] = 1202,
  [SMALL_STATE(399)] = 1305,
  [SMALL_STATE(400)] = 1408,
  [SMALL_STATE(401)] = 1511,
  [SMALL_STATE(402)] = 1614,
  [SMALL_STATE(403)] = 1717,
  [SMALL_STATE(404)] = 1820,
  [SMALL_STATE(405)] = 1923,
  [SMALL_STATE(406)] = 2026,
  [SMALL_STATE(407)] = 2129,
  [SMALL_STATE(408)] = 2226,
  [SMALL_STATE(409)] = 2295,
  [SMALL_STATE(410)] = 2398,
  [SMALL_STATE(411)] = 2501,
  [SMALL_STATE(412)] = 2595,
  [SMALL_STATE(413)] = 2686,
  [SMALL_STATE(414)] = 2777,
  [SMALL_STATE(415)] = 2868,
  [SMALL_STATE(416)] = 2959,
  [SMALL_STATE(417)] = 3050,
  [SMALL_STATE(418)] = 3141,
  [SMALL_STATE(419)] = 3202,
  [SMALL_STATE(420)] = 3293,
  [SMALL_STATE(421)] = 3388,
  [SMALL_STATE(422)] = 3449,
  [SMALL_STATE(423)] = 3540,
  [SMALL_STATE(424)] = 3631,
  [SMALL_STATE(425)] = 3692,
  [SMALL_STATE(426)] = 3783,
  [SMALL_STATE(427)] = 3876,
  [SMALL_STATE(428)] = 3969,
  [SMALL_STATE(429)] = 4062,
  [SMALL_STATE(430)] = 4155,
  [SMALL_STATE(431)] = 4248,
  [SMALL_STATE(432)] = 4341,
  [SMALL_STATE(433)] = 4396,
  [SMALL_STATE(434)] = 4451,
  [SMALL_STATE(435)] = 4544,
  [SMALL_STATE(436)] = 4637,
  [SMALL_STATE(437)] = 4734,
  [SMALL_STATE(438)] = 4816,
  [SMALL_STATE(439)] = 4898,
  [SMALL_STATE(440)] = 4980,
  [SMALL_STATE(441)] = 5062,
  [SMALL_STATE(442)] = 5144,
  [SMALL_STATE(443)] = 5226,
  [SMALL_STATE(444)] = 5308,
  [SMALL_STATE(445)] = 5390,
  [SMALL_STATE(446)] = 5472,
  [SMALL_STATE(447)] = 5554,
  [SMALL_STATE(448)] = 5636,
  [SMALL_STATE(449)] = 5718,
  [SMALL_STATE(450)] = 5800,
  [SMALL_STATE(451)] = 5882,
  [SMALL_STATE(452)] = 5964,
  [SMALL_STATE(453)] = 6046,
  [SMALL_STATE(454)] = 6132,
  [SMALL_STATE(455)] = 6214,
  [SMALL_STATE(456)] = 6296,
  [SMALL_STATE(457)] = 6378,
  [SMALL_STATE(458)] = 6460,
  [SMALL_STATE(459)] = 6542,
  [SMALL_STATE(460)] = 6624,
  [SMALL_STATE(461)] = 6706,
  [SMALL_STATE(462)] = 6788,
  [SMALL_STATE(463)] = 6870,
  [SMALL_STATE(464)] = 6952,
  [SMALL_STATE(465)] = 7034,
  [SMALL_STATE(466)] = 7116,
  [SMALL_STATE(467)] = 7198,
  [SMALL_STATE(468)] = 7284,
  [SMALL_STATE(469)] = 7366,
  [SMALL_STATE(470)] = 7448,
  [SMALL_STATE(471)] = 7530,
  [SMALL_STATE(472)] = 7616,
  [SMALL_STATE(473)] = 7698,
  [SMALL_STATE(474)] = 7784,
  [SMALL_STATE(475)] = 7866,
  [SMALL_STATE(476)] = 7948,
  [SMALL_STATE(477)] = 8030,
  [SMALL_STATE(478)] = 8112,
  [SMALL_STATE(479)] = 8194,
  [SMALL_STATE(480)] = 8273,
  [SMALL_STATE(481)] = 8340,
  [SMALL_STATE(482)] = 8401,
  [SMALL_STATE(483)] = 8482,
  [SMALL_STATE(484)] = 8561,
  [SMALL_STATE(485)] = 8622,
  [SMALL_STATE(486)] = 8683,
  [SMALL_STATE(487)] = 8742,
  [SMALL_STATE(488)] = 8821,
  [SMALL_STATE(489)] = 8900,
  [SMALL_STATE(490)] = 8979,
  [SMALL_STATE(491)] = 9044,
  [SMALL_STATE(492)] = 9123,
  [SMALL_STATE(493)] = 9174,
  [SMALL_STATE(494)] = 9241,
  [SMALL_STATE(495)] = 9312,
  [SMALL_STATE(496)] = 9385,
  [SMALL_STATE(497)] = 9460,
  [SMALL_STATE(498)] = 9539,
  [SMALL_STATE(499)] = 9618,
  [SMALL_STATE(500)] = 9695,
  [SMALL_STATE(501)] = 9774,
  [SMALL_STATE(502)] = 9853,
  [SMALL_STATE(503)] = 9916,
  [SMALL_STATE(504)] = 9995,
  [SMALL_STATE(505)] = 10074,
  [SMALL_STATE(506)] = 10135,
  [SMALL_STATE(507)] = 10218,
  [SMALL_STATE(508)] = 10297,
  [SMALL_STATE(509)] = 10376,
  [SMALL_STATE(510)] = 10455,
  [SMALL_STATE(511)] = 10534,
  [SMALL_STATE(512)] = 10613,
  [SMALL_STATE(513)] = 10692,
  [SMALL_STATE(514)] = 10771,
  [SMALL_STATE(515)] = 10850,
  [SMALL_STATE(516)] = 10935,
  [SMALL_STATE(517)] = 11014,
  [SMALL_STATE(518)] = 11093,
  [SMALL_STATE(519)] = 11172,
  [SMALL_STATE(520)] = 11251,
  [SMALL_STATE(521)] = 11330,
  [SMALL_STATE(522)] = 11409,
  [SMALL_STATE(523)] = 11488,
  [SMALL_STATE(524)] = 11567,
  [SMALL_STATE(525)] = 11646,
  [SMALL_STATE(526)] = 11725,
  [SMALL_STATE(527)] = 11787,
  [SMALL_STATE(528)] = 11863,
  [SMALL_STATE(529)] = 11939,
  [SMALL_STATE(530)] = 12015,
  [SMALL_STATE(531)] = 12091,
  [SMALL_STATE(532)] = 12167,
  [SMALL_STATE(533)] = 12243,
  [SMALL_STATE(534)] = 12319,
  [SMALL_STATE(535)] = 12395,
  [SMALL_STATE(536)] = 12445,
  [SMALL_STATE(537)] = 12521,
  [SMALL_STATE(538)] = 12571,
  [SMALL_STATE(539)] = 12647,
  [SMALL_STATE(540)] = 12723,
  [SMALL_STATE(541)] = 12773,
  [SMALL_STATE(542)] = 12849,
  [SMALL_STATE(543)] = 12925,
  [SMALL_STATE(544)] = 13001,
  [SMALL_STATE(545)] = 13077,
  [SMALL_STATE(546)] = 13153,
  [SMALL_STATE(547)] = 13203,
  [SMALL_STATE(548)] = 13253,
  [SMALL_STATE(549)] = 13303,
  [SMALL_STATE(550)] = 13379,
  [SMALL_STATE(551)] = 13455,
  [SMALL_STATE(552)] = 13531,
  [SMALL_STATE(553)] = 13607,
  [SMALL_STATE(554)] = 13683,
  [SMALL_STATE(555)] = 13759,
  [SMALL_STATE(556)] = 13835,
  [SMALL_STATE(557)] = 13911,
  [SMALL_STATE(558)] = 13987,
  [SMALL_STATE(559)] = 14063,
  [SMALL_STATE(560)] = 14139,
  [SMALL_STATE(561)] = 14215,
  [SMALL_STATE(562)] = 14291,
  [SMALL_STATE(563)] = 14341,
  [SMALL_STATE(564)] = 14417,
  [SMALL_STATE(565)] = 14493,
  [SMALL_STATE(566)] = 14569,
  [SMALL_STATE(567)] = 14645,
  [SMALL_STATE(568)] = 14721,
  [SMALL_STATE(569)] = 14797,
  [SMALL_STATE(570)] = 14847,
  [SMALL_STATE(571)] = 14901,
  [SMALL_STATE(572)] = 14951,
  [SMALL_STATE(573)] = 15001,
  [SMALL_STATE(574)] = 15077,
  [SMALL_STATE(575)] = 15127,
  [SMALL_STATE(576)] = 15177,
  [SMALL_STATE(577)] = 15227,
  [SMALL_STATE(578)] = 15303,
  [SMALL_STATE(579)] = 15379,
  [SMALL_STATE(580)] = 15455,
  [SMALL_STATE(581)] = 15531,
  [SMALL_STATE(582)] = 15581,
  [SMALL_STATE(583)] = 15657,
  [SMALL_STATE(584)] = 15707,
  [SMALL_STATE(585)] = 15760,
  [SMALL_STATE(586)] = 15813,
  [SMALL_STATE(587)] = 15866,
  [SMALL_STATE(588)] = 15919,
  [SMALL_STATE(589)] = 15972,
  [SMALL_STATE(590)] = 16018,
  [SMALL_STATE(591)] = 16094,
  [SMALL_STATE(592)] = 16167,
  [SMALL_STATE(593)] = 16240,
  [SMALL_STATE(594)] = 16307,
  [SMALL_STATE(595)] = 16374,
  [SMALL_STATE(596)] = 16441,
  [SMALL_STATE(597)] = 16508,
  [SMALL_STATE(598)] = 16559,
  [SMALL_STATE(599)] = 16617,
  [SMALL_STATE(600)] = 16691,
  [SMALL_STATE(601)] = 16755,
  [SMALL_STATE(602)] = 16811,
  [SMALL_STATE(603)] = 16855,
  [SMALL_STATE(604)] = 16913,
  [SMALL_STATE(605)] = 16975,
  [SMALL_STATE(606)] = 17039,
  [SMALL_STATE(607)] = 17105,
  [SMALL_STATE(608)] = 17173,
  [SMALL_STATE(609)] = 17241,
  [SMALL_STATE(610)] = 17295,
  [SMALL_STATE(611)] = 17367,
  [SMALL_STATE(612)] = 17437,
  [SMALL_STATE(613)] = 17475,
  [SMALL_STATE(614)] = 17513,
  [SMALL_STATE(615)] = 17550,
  [SMALL_STATE(616)] = 17625,
  [SMALL_STATE(617)] = 17700,
  [SMALL_STATE(618)] = 17773,
  [SMALL_STATE(619)] = 17845,
  [SMALL_STATE(620)] = 17879,
  [SMALL_STATE(621)] = 17951,
  [SMALL_STATE(622)] = 17987,
  [SMALL_STATE(623)] = 18023,
  [SMALL_STATE(624)] = 18095,
  [SMALL_STATE(625)] = 18167,
  [SMALL_STATE(626)] = 18239,
  [SMALL_STATE(627)] = 18311,
  [SMALL_STATE(628)] = 18383,
  [SMALL_STATE(629)] = 18455,
  [SMALL_STATE(630)] = 18527,
  [SMALL_STATE(631)] = 18561,
  [SMALL_STATE(632)] = 18633,
  [SMALL_STATE(633)] = 18705,
  [SMALL_STATE(634)] = 18775,
  [SMALL_STATE(635)] = 18847,
  [SMALL_STATE(636)] = 18917,
  [SMALL_STATE(637)] = 18989,
  [SMALL_STATE(638)] = 19061,
  [SMALL_STATE(639)] = 19133,
  [SMALL_STATE(640)] = 19205,
  [SMALL_STATE(641)] = 19239,
  [SMALL_STATE(642)] = 19273,
  [SMALL_STATE(643)] = 19307,
  [SMALL_STATE(644)] = 19379,
  [SMALL_STATE(645)] = 19451,
  [SMALL_STATE(646)] = 19523,
  [SMALL_STATE(647)] = 19595,
  [SMALL_STATE(648)] = 19629,
  [SMALL_STATE(649)] = 19663,
  [SMALL_STATE(650)] = 19735,
  [SMALL_STATE(651)] = 19807,
  [SMALL_STATE(652)] = 19879,
  [SMALL_STATE(653)] = 19913,
  [SMALL_STATE(654)] = 19947,
  [SMALL_STATE(655)] = 20017,
  [SMALL_STATE(656)] = 20089,
  [SMALL_STATE(657)] = 20161,
  [SMALL_STATE(658)] = 20233,
  [SMALL_STATE(659)] = 20303,
  [SMALL_STATE(660)] = 20375,
  [SMALL_STATE(661)] = 20447,
  [SMALL_STATE(662)] = 20517,
  [SMALL_STATE(663)] = 20551,
  [SMALL_STATE(664)] = 20623,
  [SMALL_STATE(665)] = 20695,
  [SMALL_STATE(666)] = 20729,
  [SMALL_STATE(667)] = 20763,
  [SMALL_STATE(668)] = 20797,
  [SMALL_STATE(669)] = 20831,
  [SMALL_STATE(670)] = 20903,
  [SMALL_STATE(671)] = 20975,
  [SMALL_STATE(672)] = 21047,
  [SMALL_STATE(673)] = 21081,
  [SMALL_STATE(674)] = 21115,
  [SMALL_STATE(675)] = 21187,
  [SMALL_STATE(676)] = 21259,
  [SMALL_STATE(677)] = 21331,
  [SMALL_STATE(678)] = 21403,
  [SMALL_STATE(679)] = 21475,
  [SMALL_STATE(680)] = 21547,
  [SMALL_STATE(681)] = 21619,
  [SMALL_STATE(682)] = 21691,
  [SMALL_STATE(683)] = 21725,
  [SMALL_STATE(684)] = 21759,
  [SMALL_STATE(685)] = 21831,
  [SMALL_STATE(686)] = 21865,
  [SMALL_STATE(687)] = 21937,
  [SMALL_STATE(688)] = 22009,
  [SMALL_STATE(689)] = 22081,
  [SMALL_STATE(690)] = 22115,
  [SMALL_STATE(691)] = 22184,
  [SMALL_STATE(692)] = 22253,
  [SMALL_STATE(693)] = 22322,
  [SMALL_STATE(694)] = 22391,
  [SMALL_STATE(695)] = 22460,
  [SMALL_STATE(696)] = 22529,
  [SMALL_STATE(697)] = 22598,
  [SMALL_STATE(698)] = 22667,
  [SMALL_STATE(699)] = 22736,
  [SMALL_STATE(700)] = 22805,
  [SMALL_STATE(701)] = 22874,
  [SMALL_STATE(702)] = 22943,
  [SMALL_STATE(703)] = 23012,
  [SMALL_STATE(704)] = 23081,
  [SMALL_STATE(705)] = 23150,
  [SMALL_STATE(706)] = 23219,
  [SMALL_STATE(707)] = 23288,
  [SMALL_STATE(708)] = 23357,
  [SMALL_STATE(709)] = 23426,
  [SMALL_STATE(710)] = 23495,
  [SMALL_STATE(711)] = 23530,
  [SMALL_STATE(712)] = 23599,
  [SMALL_STATE(713)] = 23668,
  [SMALL_STATE(714)] = 23737,
  [SMALL_STATE(715)] = 23806,
  [SMALL_STATE(716)] = 23875,
  [SMALL_STATE(717)] = 23944,
  [SMALL_STATE(718)] = 24013,
  [SMALL_STATE(719)] = 24082,
  [SMALL_STATE(720)] = 24151,
  [SMALL_STATE(721)] = 24220,
  [SMALL_STATE(722)] = 24255,
  [SMALL_STATE(723)] = 24324,
  [SMALL_STATE(724)] = 24393,
  [SMALL_STATE(725)] = 24462,
  [SMALL_STATE(726)] = 24531,
  [SMALL_STATE(727)] = 24563,
  [SMALL_STATE(728)] = 24597,
  [SMALL_STATE(729)] = 24631,
  [SMALL_STATE(730)] = 24663,
  [SMALL_STATE(731)] = 24699,
  [SMALL_STATE(732)] = 24731,
  [SMALL_STATE(733)] = 24765,
  [SMALL_STATE(734)] = 24799,
  [SMALL_STATE(735)] = 24833,
  [SMALL_STATE(736)] = 24865,
  [SMALL_STATE(737)] = 24897,
  [SMALL_STATE(738)] = 24929,
  [SMALL_STATE(739)] = 24963,
  [SMALL_STATE(740)] = 24999,
  [SMALL_STATE(741)] = 25033,
  [SMALL_STATE(742)] = 25067,
  [SMALL_STATE(743)] = 25101,
  [SMALL_STATE(744)] = 25135,
  [SMALL_STATE(745)] = 25167,
  [SMALL_STATE(746)] = 25201,
  [SMALL_STATE(747)] = 25233,
  [SMALL_STATE(748)] = 25267,
  [SMALL_STATE(749)] = 25299,
  [SMALL_STATE(750)] = 25333,
  [SMALL_STATE(751)] = 25365,
  [SMALL_STATE(752)] = 25397,
  [SMALL_STATE(753)] = 25429,
  [SMALL_STATE(754)] = 25461,
  [SMALL_STATE(755)] = 25497,
  [SMALL_STATE(756)] = 25533,
  [SMALL_STATE(757)] = 25565,
  [SMALL_STATE(758)] = 25599,
  [SMALL_STATE(759)] = 25631,
  [SMALL_STATE(760)] = 25665,
  [SMALL_STATE(761)] = 25699,
  [SMALL_STATE(762)] = 25733,
  [SMALL_STATE(763)] = 25767,
  [SMALL_STATE(764)] = 25805,
  [SMALL_STATE(765)] = 25839,
  [SMALL_STATE(766)] = 25871,
  [SMALL_STATE(767)] = 25903,
  [SMALL_STATE(768)] = 25935,
  [SMALL_STATE(769)] = 25977,
  [SMALL_STATE(770)] = 26009,
  [SMALL_STATE(771)] = 26043,
  [SMALL_STATE(772)] = 26075,
  [SMALL_STATE(773)] = 26118,
  [SMALL_STATE(774)] = 26161,
  [SMALL_STATE(775)] = 26218,
  [SMALL_STATE(776)] = 26261,
  [SMALL_STATE(777)] = 26304,
  [SMALL_STATE(778)] = 26358,
  [SMALL_STATE(779)] = 26412,
  [SMALL_STATE(780)] = 26466,
  [SMALL_STATE(781)] = 26520,
  [SMALL_STATE(782)] = 26574,
  [SMALL_STATE(783)] = 26628,
  [SMALL_STATE(784)] = 26682,
  [SMALL_STATE(785)] = 26736,
  [SMALL_STATE(786)] = 26790,
  [SMALL_STATE(787)] = 26844,
  [SMALL_STATE(788)] = 26898,
  [SMALL_STATE(789)] = 26952,
  [SMALL_STATE(790)] = 27003,
  [SMALL_STATE(791)] = 27054,
  [SMALL_STATE(792)] = 27105,
  [SMALL_STATE(793)] = 27139,
  [SMALL_STATE(794)] = 27173,
  [SMALL_STATE(795)] = 27221,
  [SMALL_STATE(796)] = 27255,
  [SMALL_STATE(797)] = 27303,
  [SMALL_STATE(798)] = 27337,
  [SMALL_STATE(799)] = 27385,
  [SMALL_STATE(800)] = 27433,
  [SMALL_STATE(801)] = 27481,
  [SMALL_STATE(802)] = 27515,
  [SMALL_STATE(803)] = 27563,
  [SMALL_STATE(804)] = 27611,
  [SMALL_STATE(805)] = 27659,
  [SMALL_STATE(806)] = 27693,
  [SMALL_STATE(807)] = 27741,
  [SMALL_STATE(808)] = 27789,
  [SMALL_STATE(809)] = 27832,
  [SMALL_STATE(810)] = 27887,
  [SMALL_STATE(811)] = 27930,
  [SMALL_STATE(812)] = 27963,
  [SMALL_STATE(813)] = 27996,
  [SMALL_STATE(814)] = 28037,
  [SMALL_STATE(815)] = 28078,
  [SMALL_STATE(816)] = 28119,
  [SMALL_STATE(817)] = 28160,
  [SMALL_STATE(818)] = 28215,
  [SMALL_STATE(819)] = 28243,
  [SMALL_STATE(820)] = 28283,
  [SMALL_STATE(821)] = 28323,
  [SMALL_STATE(822)] = 28351,
  [SMALL_STATE(823)] = 28379,
  [SMALL_STATE(824)] = 28407,
  [SMALL_STATE(825)] = 28435,
  [SMALL_STATE(826)] = 28463,
  [SMALL_STATE(827)] = 28513,
  [SMALL_STATE(828)] = 28553,
  [SMALL_STATE(829)] = 28593,
  [SMALL_STATE(830)] = 28621,
  [SMALL_STATE(831)] = 28649,
  [SMALL_STATE(832)] = 28677,
  [SMALL_STATE(833)] = 28711,
  [SMALL_STATE(834)] = 28747,
  [SMALL_STATE(835)] = 28775,
  [SMALL_STATE(836)] = 28815,
  [SMALL_STATE(837)] = 28857,
  [SMALL_STATE(838)] = 28901,
  [SMALL_STATE(839)] = 28947,
  [SMALL_STATE(840)] = 28993,
  [SMALL_STATE(841)] = 29041,
  [SMALL_STATE(842)] = 29069,
  [SMALL_STATE(843)] = 29101,
  [SMALL_STATE(844)] = 29129,
  [SMALL_STATE(845)] = 29157,
  [SMALL_STATE(846)] = 29185,
  [SMALL_STATE(847)] = 29225,
  [SMALL_STATE(848)] = 29265,
  [SMALL_STATE(849)] = 29293,
  [SMALL_STATE(850)] = 29333,
  [SMALL_STATE(851)] = 29361,
  [SMALL_STATE(852)] = 29389,
  [SMALL_STATE(853)] = 29417,
  [SMALL_STATE(854)] = 29457,
  [SMALL_STATE(855)] = 29497,
  [SMALL_STATE(856)] = 29537,
  [SMALL_STATE(857)] = 29577,
  [SMALL_STATE(858)] = 29617,
  [SMALL_STATE(859)] = 29657,
  [SMALL_STATE(860)] = 29697,
  [SMALL_STATE(861)] = 29737,
  [SMALL_STATE(862)] = 29777,
  [SMALL_STATE(863)] = 29817,
  [SMALL_STATE(864)] = 29857,
  [SMALL_STATE(865)] = 29897,
  [SMALL_STATE(866)] = 29937,
  [SMALL_STATE(867)] = 29977,
  [SMALL_STATE(868)] = 30017,
  [SMALL_STATE(869)] = 30045,
  [SMALL_STATE(870)] = 30073,
  [SMALL_STATE(871)] = 30101,
  [SMALL_STATE(872)] = 30129,
  [SMALL_STATE(873)] = 30169,
  [SMALL_STATE(874)] = 30209,
  [SMALL_STATE(875)] = 30249,
  [SMALL_STATE(876)] = 30289,
  [SMALL_STATE(877)] = 30317,
  [SMALL_STATE(878)] = 30343,
  [SMALL_STATE(879)] = 30371,
  [SMALL_STATE(880)] = 30399,
  [SMALL_STATE(881)] = 30439,
  [SMALL_STATE(882)] = 30479,
  [SMALL_STATE(883)] = 30519,
  [SMALL_STATE(884)] = 30559,
  [SMALL_STATE(885)] = 30587,
  [SMALL_STATE(886)] = 30627,
  [SMALL_STATE(887)] = 30657,
  [SMALL_STATE(888)] = 30685,
  [SMALL_STATE(889)] = 30713,
  [SMALL_STATE(890)] = 30741,
  [SMALL_STATE(891)] = 30781,
  [SMALL_STATE(892)] = 30821,
  [SMALL_STATE(893)] = 30849,
  [SMALL_STATE(894)] = 30889,
  [SMALL_STATE(895)] = 30934,
  [SMALL_STATE(896)] = 30965,
  [SMALL_STATE(897)] = 30992,
  [SMALL_STATE(898)] = 31041,
  [SMALL_STATE(899)] = 31088,
  [SMALL_STATE(900)] = 31115,
  [SMALL_STATE(901)] = 31142,
  [SMALL_STATE(902)] = 31187,
  [SMALL_STATE(903)] = 31232,
  [SMALL_STATE(904)] = 31281,
  [SMALL_STATE(905)] = 31308,
  [SMALL_STATE(906)] = 31335,
  [SMALL_STATE(907)] = 31380,
  [SMALL_STATE(908)] = 31421,
  [SMALL_STATE(909)] = 31448,
  [SMALL_STATE(910)] = 31493,
  [SMALL_STATE(911)] = 31538,
  [SMALL_STATE(912)] = 31565,
  [SMALL_STATE(913)] = 31610,
  [SMALL_STATE(914)] = 31655,
  [SMALL_STATE(915)] = 31684,
  [SMALL_STATE(916)] = 31711,
  [SMALL_STATE(917)] = 31750,
  [SMALL_STATE(918)] = 31777,
  [SMALL_STATE(919)] = 31822,
  [SMALL_STATE(920)] = 31855,
  [SMALL_STATE(921)] = 31882,
  [SMALL_STATE(922)] = 31927,
  [SMALL_STATE(923)] = 31970,
  [SMALL_STATE(924)] = 32005,
  [SMALL_STATE(925)] = 32042,
  [SMALL_STATE(926)] = 32072,
  [SMALL_STATE(927)] = 32110,
  [SMALL_STATE(928)] = 32148,
  [SMALL_STATE(929)] = 32186,
  [SMALL_STATE(930)] = 32224,
  [SMALL_STATE(931)] = 32262,
  [SMALL_STATE(932)] = 32300,
  [SMALL_STATE(933)] = 32338,
  [SMALL_STATE(934)] = 32376,
  [SMALL_STATE(935)] = 32414,
  [SMALL_STATE(936)] = 32452,
  [SMALL_STATE(937)] = 32490,
  [SMALL_STATE(938)] = 32528,
  [SMALL_STATE(939)] = 32560,
  [SMALL_STATE(940)] = 32598,
  [SMALL_STATE(941)] = 32636,
  [SMALL_STATE(942)] = 32674,
  [SMALL_STATE(943)] = 32712,
  [SMALL_STATE(944)] = 32750,
  [SMALL_STATE(945)] = 32788,
  [SMALL_STATE(946)] = 32826,
  [SMALL_STATE(947)] = 32864,
  [SMALL_STATE(948)] = 32902,
  [SMALL_STATE(949)] = 32929,
  [SMALL_STATE(950)] = 32960,
  [SMALL_STATE(951)] = 32991,
  [SMALL_STATE(952)] = 33028,
  [SMALL_STATE(953)] = 33049,
  [SMALL_STATE(954)] = 33070,
  [SMALL_STATE(955)] = 33107,
  [SMALL_STATE(956)] = 33144,
  [SMALL_STATE(957)] = 33175,
  [SMALL_STATE(958)] = 33206,
  [SMALL_STATE(959)] = 33237,
  [SMALL_STATE(960)] = 33268,
  [SMALL_STATE(961)] = 33299,
  [SMALL_STATE(962)] = 33330,
  [SMALL_STATE(963)] = 33361,
  [SMALL_STATE(964)] = 33392,
  [SMALL_STATE(965)] = 33423,
  [SMALL_STATE(966)] = 33451,
  [SMALL_STATE(967)] = 33471,
  [SMALL_STATE(968)] = 33499,
  [SMALL_STATE(969)] = 33527,
  [SMALL_STATE(970)] = 33547,
  [SMALL_STATE(971)] = 33575,
  [SMALL_STATE(972)] = 33595,
  [SMALL_STATE(973)] = 33623,
  [SMALL_STATE(974)] = 33651,
  [SMALL_STATE(975)] = 33679,
  [SMALL_STATE(976)] = 33699,
  [SMALL_STATE(977)] = 33719,
  [SMALL_STATE(978)] = 33747,
  [SMALL_STATE(979)] = 33767,
  [SMALL_STATE(980)] = 33783,
  [SMALL_STATE(981)] = 33803,
  [SMALL_STATE(982)] = 33831,
  [SMALL_STATE(983)] = 33859,
  [SMALL_STATE(984)] = 33887,
  [SMALL_STATE(985)] = 33915,
  [SMALL_STATE(986)] = 33943,
  [SMALL_STATE(987)] = 33971,
  [SMALL_STATE(988)] = 33991,
  [SMALL_STATE(989)] = 34019,
  [SMALL_STATE(990)] = 34047,
  [SMALL_STATE(991)] = 34075,
  [SMALL_STATE(992)] = 34095,
  [SMALL_STATE(993)] = 34111,
  [SMALL_STATE(994)] = 34127,
  [SMALL_STATE(995)] = 34158,
  [SMALL_STATE(996)] = 34179,
  [SMALL_STATE(997)] = 34210,
  [SMALL_STATE(998)] = 34231,
  [SMALL_STATE(999)] = 34262,
  [SMALL_STATE(1000)] = 34283,
  [SMALL_STATE(1001)] = 34314,
  [SMALL_STATE(1002)] = 34335,
  [SMALL_STATE(1003)] = 34349,
  [SMALL_STATE(1004)] = 34363,
  [SMALL_STATE(1005)] = 34377,
  [SMALL_STATE(1006)] = 34397,
  [SMALL_STATE(1007)] = 34413,
  [SMALL_STATE(1008)] = 34441,
  [SMALL_STATE(1009)] = 34457,
  [SMALL_STATE(1010)] = 34471,
  [SMALL_STATE(1011)] = 34491,
  [SMALL_STATE(1012)] = 34505,
  [SMALL_STATE(1013)] = 34519,
  [SMALL_STATE(1014)] = 34533,
  [SMALL_STATE(1015)] = 34547,
  [SMALL_STATE(1016)] = 34567,
  [SMALL_STATE(1017)] = 34595,
  [SMALL_STATE(1018)] = 34609,
  [SMALL_STATE(1019)] = 34623,
  [SMALL_STATE(1020)] = 34637,
  [SMALL_STATE(1021)] = 34651,
  [SMALL_STATE(1022)] = 34665,
  [SMALL_STATE(1023)] = 34679,
  [SMALL_STATE(1024)] = 34699,
  [SMALL_STATE(1025)] = 34713,
  [SMALL_STATE(1026)] = 34727,
  [SMALL_STATE(1027)] = 34741,
  [SMALL_STATE(1028)] = 34755,
  [SMALL_STATE(1029)] = 34783,
  [SMALL_STATE(1030)] = 34797,
  [SMALL_STATE(1031)] = 34811,
  [SMALL_STATE(1032)] = 34825,
  [SMALL_STATE(1033)] = 34844,
  [SMALL_STATE(1034)] = 34863,
  [SMALL_STATE(1035)] = 34888,
  [SMALL_STATE(1036)] = 34901,
  [SMALL_STATE(1037)] = 34920,
  [SMALL_STATE(1038)] = 34945,
  [SMALL_STATE(1039)] = 34958,
  [SMALL_STATE(1040)] = 34983,
  [SMALL_STATE(1041)] = 34996,
  [SMALL_STATE(1042)] = 35009,
  [SMALL_STATE(1043)] = 35034,
  [SMALL_STATE(1044)] = 35047,
  [SMALL_STATE(1045)] = 35060,
  [SMALL_STATE(1046)] = 35079,
  [SMALL_STATE(1047)] = 35097,
  [SMALL_STATE(1048)] = 35119,
  [SMALL_STATE(1049)] = 35137,
  [SMALL_STATE(1050)] = 35159,
  [SMALL_STATE(1051)] = 35181,
  [SMALL_STATE(1052)] = 35193,
  [SMALL_STATE(1053)] = 35215,
  [SMALL_STATE(1054)] = 35233,
  [SMALL_STATE(1055)] = 35253,
  [SMALL_STATE(1056)] = 35265,
  [SMALL_STATE(1057)] = 35287,
  [SMALL_STATE(1058)] = 35305,
  [SMALL_STATE(1059)] = 35317,
  [SMALL_STATE(1060)] = 35329,
  [SMALL_STATE(1061)] = 35341,
  [SMALL_STATE(1062)] = 35363,
  [SMALL_STATE(1063)] = 35375,
  [SMALL_STATE(1064)] = 35393,
  [SMALL_STATE(1065)] = 35411,
  [SMALL_STATE(1066)] = 35433,
  [SMALL_STATE(1067)] = 35455,
  [SMALL_STATE(1068)] = 35467,
  [SMALL_STATE(1069)] = 35479,
  [SMALL_STATE(1070)] = 35497,
  [SMALL_STATE(1071)] = 35515,
  [SMALL_STATE(1072)] = 35533,
  [SMALL_STATE(1073)] = 35550,
  [SMALL_STATE(1074)] = 35561,
  [SMALL_STATE(1075)] = 35572,
  [SMALL_STATE(1076)] = 35583,
  [SMALL_STATE(1077)] = 35602,
  [SMALL_STATE(1078)] = 35613,
  [SMALL_STATE(1079)] = 35630,
  [SMALL_STATE(1080)] = 35647,
  [SMALL_STATE(1081)] = 35658,
  [SMALL_STATE(1082)] = 35669,
  [SMALL_STATE(1083)] = 35680,
  [SMALL_STATE(1084)] = 35697,
  [SMALL_STATE(1085)] = 35716,
  [SMALL_STATE(1086)] = 35733,
  [SMALL_STATE(1087)] = 35752,
  [SMALL_STATE(1088)] = 35771,
  [SMALL_STATE(1089)] = 35790,
  [SMALL_STATE(1090)] = 35801,
  [SMALL_STATE(1091)] = 35812,
  [SMALL_STATE(1092)] = 35823,
  [SMALL_STATE(1093)] = 35834,
  [SMALL_STATE(1094)] = 35853,
  [SMALL_STATE(1095)] = 35870,
  [SMALL_STATE(1096)] = 35889,
  [SMALL_STATE(1097)] = 35908,
  [SMALL_STATE(1098)] = 35919,
  [SMALL_STATE(1099)] = 35930,
  [SMALL_STATE(1100)] = 35949,
  [SMALL_STATE(1101)] = 35960,
  [SMALL_STATE(1102)] = 35977,
  [SMALL_STATE(1103)] = 35996,
  [SMALL_STATE(1104)] = 36007,
  [SMALL_STATE(1105)] = 36018,
  [SMALL_STATE(1106)] = 36029,
  [SMALL_STATE(1107)] = 36048,
  [SMALL_STATE(1108)] = 36059,
  [SMALL_STATE(1109)] = 36070,
  [SMALL_STATE(1110)] = 36081,
  [SMALL_STATE(1111)] = 36097,
  [SMALL_STATE(1112)] = 36113,
  [SMALL_STATE(1113)] = 36129,
  [SMALL_STATE(1114)] = 36145,
  [SMALL_STATE(1115)] = 36161,
  [SMALL_STATE(1116)] = 36175,
  [SMALL_STATE(1117)] = 36191,
  [SMALL_STATE(1118)] = 36207,
  [SMALL_STATE(1119)] = 36223,
  [SMALL_STATE(1120)] = 36239,
  [SMALL_STATE(1121)] = 36255,
  [SMALL_STATE(1122)] = 36271,
  [SMALL_STATE(1123)] = 36287,
  [SMALL_STATE(1124)] = 36303,
  [SMALL_STATE(1125)] = 36319,
  [SMALL_STATE(1126)] = 36335,
  [SMALL_STATE(1127)] = 36351,
  [SMALL_STATE(1128)] = 36367,
  [SMALL_STATE(1129)] = 36383,
  [SMALL_STATE(1130)] = 36399,
  [SMALL_STATE(1131)] = 36415,
  [SMALL_STATE(1132)] = 36428,
  [SMALL_STATE(1133)] = 36439,
  [SMALL_STATE(1134)] = 36452,
  [SMALL_STATE(1135)] = 36465,
  [SMALL_STATE(1136)] = 36478,
  [SMALL_STATE(1137)] = 36491,
  [SMALL_STATE(1138)] = 36504,
  [SMALL_STATE(1139)] = 36517,
  [SMALL_STATE(1140)] = 36530,
  [SMALL_STATE(1141)] = 36543,
  [SMALL_STATE(1142)] = 36556,
  [SMALL_STATE(1143)] = 36569,
  [SMALL_STATE(1144)] = 36582,
  [SMALL_STATE(1145)] = 36595,
  [SMALL_STATE(1146)] = 36608,
  [SMALL_STATE(1147)] = 36621,
  [SMALL_STATE(1148)] = 36634,
  [SMALL_STATE(1149)] = 36647,
  [SMALL_STATE(1150)] = 36660,
  [SMALL_STATE(1151)] = 36673,
  [SMALL_STATE(1152)] = 36686,
  [SMALL_STATE(1153)] = 36699,
  [SMALL_STATE(1154)] = 36712,
  [SMALL_STATE(1155)] = 36725,
  [SMALL_STATE(1156)] = 36738,
  [SMALL_STATE(1157)] = 36751,
  [SMALL_STATE(1158)] = 36764,
  [SMALL_STATE(1159)] = 36777,
  [SMALL_STATE(1160)] = 36790,
  [SMALL_STATE(1161)] = 36803,
  [SMALL_STATE(1162)] = 36816,
  [SMALL_STATE(1163)] = 36829,
  [SMALL_STATE(1164)] = 36842,
  [SMALL_STATE(1165)] = 36855,
  [SMALL_STATE(1166)] = 36868,
  [SMALL_STATE(1167)] = 36881,
  [SMALL_STATE(1168)] = 36894,
  [SMALL_STATE(1169)] = 36907,
  [SMALL_STATE(1170)] = 36920,
  [SMALL_STATE(1171)] = 36931,
  [SMALL_STATE(1172)] = 36944,
  [SMALL_STATE(1173)] = 36957,
  [SMALL_STATE(1174)] = 36970,
  [SMALL_STATE(1175)] = 36983,
  [SMALL_STATE(1176)] = 36996,
  [SMALL_STATE(1177)] = 37009,
  [SMALL_STATE(1178)] = 37022,
  [SMALL_STATE(1179)] = 37035,
  [SMALL_STATE(1180)] = 37048,
  [SMALL_STATE(1181)] = 37061,
  [SMALL_STATE(1182)] = 37074,
  [SMALL_STATE(1183)] = 37087,
  [SMALL_STATE(1184)] = 37096,
  [SMALL_STATE(1185)] = 37109,
  [SMALL_STATE(1186)] = 37122,
  [SMALL_STATE(1187)] = 37135,
  [SMALL_STATE(1188)] = 37148,
  [SMALL_STATE(1189)] = 37161,
  [SMALL_STATE(1190)] = 37170,
  [SMALL_STATE(1191)] = 37180,
  [SMALL_STATE(1192)] = 37188,
  [SMALL_STATE(1193)] = 37198,
  [SMALL_STATE(1194)] = 37208,
  [SMALL_STATE(1195)] = 37218,
  [SMALL_STATE(1196)] = 37228,
  [SMALL_STATE(1197)] = 37238,
  [SMALL_STATE(1198)] = 37246,
  [SMALL_STATE(1199)] = 37256,
  [SMALL_STATE(1200)] = 37264,
  [SMALL_STATE(1201)] = 37272,
  [SMALL_STATE(1202)] = 37282,
  [SMALL_STATE(1203)] = 37292,
  [SMALL_STATE(1204)] = 37300,
  [SMALL_STATE(1205)] = 37310,
  [SMALL_STATE(1206)] = 37320,
  [SMALL_STATE(1207)] = 37330,
  [SMALL_STATE(1208)] = 37340,
  [SMALL_STATE(1209)] = 37348,
  [SMALL_STATE(1210)] = 37356,
  [SMALL_STATE(1211)] = 37366,
  [SMALL_STATE(1212)] = 37376,
  [SMALL_STATE(1213)] = 37386,
  [SMALL_STATE(1214)] = 37394,
  [SMALL_STATE(1215)] = 37404,
  [SMALL_STATE(1216)] = 37414,
  [SMALL_STATE(1217)] = 37424,
  [SMALL_STATE(1218)] = 37432,
  [SMALL_STATE(1219)] = 37442,
  [SMALL_STATE(1220)] = 37450,
  [SMALL_STATE(1221)] = 37460,
  [SMALL_STATE(1222)] = 37468,
  [SMALL_STATE(1223)] = 37476,
  [SMALL_STATE(1224)] = 37486,
  [SMALL_STATE(1225)] = 37496,
  [SMALL_STATE(1226)] = 37506,
  [SMALL_STATE(1227)] = 37516,
  [SMALL_STATE(1228)] = 37526,
  [SMALL_STATE(1229)] = 37536,
  [SMALL_STATE(1230)] = 37546,
  [SMALL_STATE(1231)] = 37556,
  [SMALL_STATE(1232)] = 37564,
  [SMALL_STATE(1233)] = 37574,
  [SMALL_STATE(1234)] = 37584,
  [SMALL_STATE(1235)] = 37592,
  [SMALL_STATE(1236)] = 37602,
  [SMALL_STATE(1237)] = 37612,
  [SMALL_STATE(1238)] = 37622,
  [SMALL_STATE(1239)] = 37632,
  [SMALL_STATE(1240)] = 37642,
  [SMALL_STATE(1241)] = 37652,
  [SMALL_STATE(1242)] = 37662,
  [SMALL_STATE(1243)] = 37670,
  [SMALL_STATE(1244)] = 37680,
  [SMALL_STATE(1245)] = 37690,
  [SMALL_STATE(1246)] = 37700,
  [SMALL_STATE(1247)] = 37710,
  [SMALL_STATE(1248)] = 37717,
  [SMALL_STATE(1249)] = 37724,
  [SMALL_STATE(1250)] = 37731,
  [SMALL_STATE(1251)] = 37738,
  [SMALL_STATE(1252)] = 37745,
  [SMALL_STATE(1253)] = 37752,
  [SMALL_STATE(1254)] = 37759,
  [SMALL_STATE(1255)] = 37766,
  [SMALL_STATE(1256)] = 37773,
  [SMALL_STATE(1257)] = 37780,
  [SMALL_STATE(1258)] = 37787,
  [SMALL_STATE(1259)] = 37794,
  [SMALL_STATE(1260)] = 37801,
  [SMALL_STATE(1261)] = 37808,
  [SMALL_STATE(1262)] = 37815,
  [SMALL_STATE(1263)] = 37822,
  [SMALL_STATE(1264)] = 37829,
  [SMALL_STATE(1265)] = 37836,
  [SMALL_STATE(1266)] = 37843,
  [SMALL_STATE(1267)] = 37850,
  [SMALL_STATE(1268)] = 37857,
  [SMALL_STATE(1269)] = 37864,
  [SMALL_STATE(1270)] = 37871,
  [SMALL_STATE(1271)] = 37878,
  [SMALL_STATE(1272)] = 37885,
  [SMALL_STATE(1273)] = 37892,
  [SMALL_STATE(1274)] = 37899,
  [SMALL_STATE(1275)] = 37906,
  [SMALL_STATE(1276)] = 37913,
  [SMALL_STATE(1277)] = 37920,
  [SMALL_STATE(1278)] = 37927,
  [SMALL_STATE(1279)] = 37934,
  [SMALL_STATE(1280)] = 37941,
  [SMALL_STATE(1281)] = 37948,
  [SMALL_STATE(1282)] = 37955,
  [SMALL_STATE(1283)] = 37962,
  [SMALL_STATE(1284)] = 37969,
  [SMALL_STATE(1285)] = 37976,
  [SMALL_STATE(1286)] = 37983,
  [SMALL_STATE(1287)] = 37990,
  [SMALL_STATE(1288)] = 37997,
  [SMALL_STATE(1289)] = 38004,
  [SMALL_STATE(1290)] = 38011,
  [SMALL_STATE(1291)] = 38018,
  [SMALL_STATE(1292)] = 38025,
  [SMALL_STATE(1293)] = 38032,
  [SMALL_STATE(1294)] = 38039,
  [SMALL_STATE(1295)] = 38046,
  [SMALL_STATE(1296)] = 38053,
  [SMALL_STATE(1297)] = 38060,
  [SMALL_STATE(1298)] = 38067,
  [SMALL_STATE(1299)] = 38074,
  [SMALL_STATE(1300)] = 38081,
  [SMALL_STATE(1301)] = 38088,
  [SMALL_STATE(1302)] = 38095,
  [SMALL_STATE(1303)] = 38102,
  [SMALL_STATE(1304)] = 38109,
  [SMALL_STATE(1305)] = 38116,
  [SMALL_STATE(1306)] = 38123,
  [SMALL_STATE(1307)] = 38130,
  [SMALL_STATE(1308)] = 38137,
  [SMALL_STATE(1309)] = 38144,
  [SMALL_STATE(1310)] = 38151,
  [SMALL_STATE(1311)] = 38158,
  [SMALL_STATE(1312)] = 38165,
  [SMALL_STATE(1313)] = 38172,
  [SMALL_STATE(1314)] = 38179,
  [SMALL_STATE(1315)] = 38186,
  [SMALL_STATE(1316)] = 38193,
  [SMALL_STATE(1317)] = 38200,
  [SMALL_STATE(1318)] = 38207,
  [SMALL_STATE(1319)] = 38214,
  [SMALL_STATE(1320)] = 38221,
  [SMALL_STATE(1321)] = 38228,
  [SMALL_STATE(1322)] = 38235,
  [SMALL_STATE(1323)] = 38242,
  [SMALL_STATE(1324)] = 38249,
  [SMALL_STATE(1325)] = 38256,
  [SMALL_STATE(1326)] = 38263,
  [SMALL_STATE(1327)] = 38270,
  [SMALL_STATE(1328)] = 38277,
  [SMALL_STATE(1329)] = 38284,
  [SMALL_STATE(1330)] = 38291,
  [SMALL_STATE(1331)] = 38298,
  [SMALL_STATE(1332)] = 38305,
  [SMALL_STATE(1333)] = 38312,
  [SMALL_STATE(1334)] = 38319,
  [SMALL_STATE(1335)] = 38326,
  [SMALL_STATE(1336)] = 38333,
  [SMALL_STATE(1337)] = 38340,
  [SMALL_STATE(1338)] = 38347,
  [SMALL_STATE(1339)] = 38354,
  [SMALL_STATE(1340)] = 38361,
  [SMALL_STATE(1341)] = 38368,
  [SMALL_STATE(1342)] = 38375,
  [SMALL_STATE(1343)] = 38382,
  [SMALL_STATE(1344)] = 38389,
  [SMALL_STATE(1345)] = 38396,
  [SMALL_STATE(1346)] = 38403,
  [SMALL_STATE(1347)] = 38410,
  [SMALL_STATE(1348)] = 38417,
  [SMALL_STATE(1349)] = 38424,
  [SMALL_STATE(1350)] = 38431,
  [SMALL_STATE(1351)] = 38438,
  [SMALL_STATE(1352)] = 38445,
  [SMALL_STATE(1353)] = 38452,
  [SMALL_STATE(1354)] = 38459,
  [SMALL_STATE(1355)] = 38466,
  [SMALL_STATE(1356)] = 38473,
  [SMALL_STATE(1357)] = 38480,
  [SMALL_STATE(1358)] = 38487,
  [SMALL_STATE(1359)] = 38494,
  [SMALL_STATE(1360)] = 38501,
  [SMALL_STATE(1361)] = 38508,
  [SMALL_STATE(1362)] = 38515,
  [SMALL_STATE(1363)] = 38522,
  [SMALL_STATE(1364)] = 38529,
  [SMALL_STATE(1365)] = 38536,
  [SMALL_STATE(1366)] = 38543,
  [SMALL_STATE(1367)] = 38550,
  [SMALL_STATE(1368)] = 38557,
  [SMALL_STATE(1369)] = 38564,
  [SMALL_STATE(1370)] = 38571,
  [SMALL_STATE(1371)] = 38578,
  [SMALL_STATE(1372)] = 38585,
  [SMALL_STATE(1373)] = 38592,
  [SMALL_STATE(1374)] = 38599,
  [SMALL_STATE(1375)] = 38606,
  [SMALL_STATE(1376)] = 38613,
  [SMALL_STATE(1377)] = 38620,
  [SMALL_STATE(1378)] = 38627,
  [SMALL_STATE(1379)] = 38634,
  [SMALL_STATE(1380)] = 38641,
  [SMALL_STATE(1381)] = 38648,
  [SMALL_STATE(1382)] = 38655,
  [SMALL_STATE(1383)] = 38662,
  [SMALL_STATE(1384)] = 38669,
  [SMALL_STATE(1385)] = 38676,
  [SMALL_STATE(1386)] = 38683,
  [SMALL_STATE(1387)] = 38690,
  [SMALL_STATE(1388)] = 38697,
  [SMALL_STATE(1389)] = 38704,
  [SMALL_STATE(1390)] = 38711,
  [SMALL_STATE(1391)] = 38718,
  [SMALL_STATE(1392)] = 38725,
  [SMALL_STATE(1393)] = 38732,
  [SMALL_STATE(1394)] = 38739,
  [SMALL_STATE(1395)] = 38746,
  [SMALL_STATE(1396)] = 38753,
  [SMALL_STATE(1397)] = 38760,
  [SMALL_STATE(1398)] = 38767,
  [SMALL_STATE(1399)] = 38774,
  [SMALL_STATE(1400)] = 38781,
  [SMALL_STATE(1401)] = 38788,
  [SMALL_STATE(1402)] = 38795,
  [SMALL_STATE(1403)] = 38802,
  [SMALL_STATE(1404)] = 38809,
  [SMALL_STATE(1405)] = 38816,
  [SMALL_STATE(1406)] = 38823,
  [SMALL_STATE(1407)] = 38830,
  [SMALL_STATE(1408)] = 38837,
  [SMALL_STATE(1409)] = 38844,
  [SMALL_STATE(1410)] = 38851,
  [SMALL_STATE(1411)] = 38858,
  [SMALL_STATE(1412)] = 38865,
  [SMALL_STATE(1413)] = 38872,
  [SMALL_STATE(1414)] = 38879,
  [SMALL_STATE(1415)] = 38886,
  [SMALL_STATE(1416)] = 38893,
  [SMALL_STATE(1417)] = 38900,
  [SMALL_STATE(1418)] = 38907,
  [SMALL_STATE(1419)] = 38914,
  [SMALL_STATE(1420)] = 38921,
  [SMALL_STATE(1421)] = 38928,
  [SMALL_STATE(1422)] = 38935,
  [SMALL_STATE(1423)] = 38942,
  [SMALL_STATE(1424)] = 38949,
  [SMALL_STATE(1425)] = 38956,
  [SMALL_STATE(1426)] = 38963,
  [SMALL_STATE(1427)] = 38970,
  [SMALL_STATE(1428)] = 38977,
  [SMALL_STATE(1429)] = 38984,
  [SMALL_STATE(1430)] = 38991,
  [SMALL_STATE(1431)] = 38998,
  [SMALL_STATE(1432)] = 39005,
  [SMALL_STATE(1433)] = 39012,
  [SMALL_STATE(1434)] = 39019,
  [SMALL_STATE(1435)] = 39026,
  [SMALL_STATE(1436)] = 39033,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, .production_id = 38),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, .production_id = 38),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(384),
  [178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(997),
  [181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1351),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(893),
  [187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1352),
  [192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1245),
  [195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(380),
  [198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(539),
  [201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(539),
  [204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(566),
  [207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(74),
  [210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(800),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(739),
  [216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1427),
  [219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1425),
  [222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(877),
  [225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(42),
  [228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(621),
  [231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(622),
  [234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(768),
  [237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(878),
  [240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1186),
  [243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1084),
  [246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1088),
  [249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1241),
  [252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1210),
  [255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(557),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1277),
  [261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1238),
  [264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(308),
  [267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1433),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(456),
  [273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1276),
  [276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1274),
  [279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1356),
  [282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(580),
  [285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(577),
  [288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(575),
  [291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1197),
  [294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1119),
  [297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(575),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vanilla_expression, 2),
  [346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1),
  [360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(393),
  [411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(995),
  [414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1434),
  [417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(846),
  [420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1430),
  [423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1193),
  [426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(162),
  [429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(796),
  [432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(730),
  [435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(27),
  [438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1194),
  [441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1195),
  [444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(578),
  [447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1412),
  [450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1196),
  [453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(316),
  [456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1409),
  [459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(437),
  [462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1408),
  [465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1407),
  [468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1406),
  [471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(386),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(999),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1391),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(890),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1374),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1226),
  [503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(224),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(806),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(755),
  [512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(21),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1218),
  [518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1205),
  [521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(567),
  [524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1323),
  [527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1220),
  [530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(297),
  [533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1435),
  [536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(444),
  [539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1314),
  [542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1342),
  [545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1378),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vanilla_expression, 1),
  [554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(390),
  [557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1001),
  [560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1305),
  [563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(881),
  [566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1306),
  [569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1223),
  [572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(194),
  [575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(794),
  [578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(754),
  [581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(23),
  [584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1190),
  [587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1240),
  [590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(552),
  [593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1287),
  [596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1239),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(354),
  [602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1428),
  [605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(454),
  [608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1291),
  [611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1297),
  [614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1310),
  [617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(391),
  [620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(380),
  [625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(539),
  [628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(539),
  [631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(566),
  [634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(74),
  [637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(800),
  [640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(621),
  [643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1427),
  [646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1425),
  [649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(42),
  [652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(622),
  [655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(768),
  [658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(878),
  [661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1186),
  [664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1084),
  [667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1088),
  [670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1241),
  [673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1210),
  [676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1238),
  [679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(308),
  [682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1433),
  [685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(456),
  [688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1276),
  [691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1274),
  [694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1356),
  [697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(580),
  [700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(577),
  [703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(575),
  [706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1197),
  [709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1119),
  [712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(575),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3),
  [719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, .production_id = 7),
  [721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2),
  [723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, .production_id = 7),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, .production_id = 7),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, .production_id = 7),
  [737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2),
  [739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(392),
  [742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(224),
  [745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(806),
  [748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(21),
  [751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1218),
  [754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1205),
  [757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1220),
  [760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(297),
  [763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1435),
  [766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(444),
  [769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1314),
  [772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1342),
  [775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1378),
  [778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(387),
  [781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(194),
  [784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(794),
  [787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(23),
  [790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1190),
  [795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1240),
  [798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1239),
  [801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(354),
  [804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1428),
  [807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(454),
  [810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1291),
  [813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1297),
  [816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1310),
  [819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(385),
  [822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(162),
  [825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(796),
  [828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(27),
  [831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1194),
  [834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1195),
  [837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1196),
  [840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(316),
  [843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1409),
  [846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(437),
  [849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1408),
  [852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1407),
  [855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1406),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, .production_id = 43),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, .production_id = 43),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 78),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 78),
  [894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, .production_id = 35),
  [896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, .production_id = 35),
  [898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2),
  [902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1),
  [904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, .production_id = 48),
  [912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, .production_id = 48),
  [914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3),
  [916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3),
  [918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 73),
  [924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 73),
  [926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 22),
  [928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 22),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 74),
  [934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 74),
  [936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 75),
  [938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 75),
  [940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 23),
  [942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 23),
  [944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 76),
  [950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 76),
  [952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 69),
  [954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 69),
  [956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, .production_id = 58),
  [958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, .production_id = 58),
  [960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 69),
  [962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 69),
  [964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 23),
  [966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 23),
  [968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, .production_id = 24),
  [974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, .production_id = 24),
  [976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .production_id = 26),
  [978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .production_id = 26),
  [980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6),
  [982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6),
  [984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, .production_id = 28),
  [986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, .production_id = 28),
  [988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, .production_id = 57),
  [990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, .production_id = 57),
  [992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 77),
  [994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 77),
  [996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [1000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 79),
  [1002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 79),
  [1004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, .production_id = 68),
  [1006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, .production_id = 68),
  [1008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 61),
  [1010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 61),
  [1012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 60),
  [1014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 60),
  [1016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 80),
  [1018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 80),
  [1020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 81),
  [1022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 81),
  [1024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, .production_id = 15),
  [1026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, .production_id = 15),
  [1028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, .production_id = 66),
  [1030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, .production_id = 66),
  [1032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, .production_id = 36),
  [1034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, .production_id = 36),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, .production_id = 37),
  [1042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, .production_id = 37),
  [1044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, .production_id = 38),
  [1046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, .production_id = 38),
  [1048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 39),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 39),
  [1052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 15),
  [1054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 15),
  [1056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, .production_id = 16),
  [1058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, .production_id = 16),
  [1060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, .production_id = 56),
  [1062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, .production_id = 56),
  [1064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, .production_id = 38),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, .production_id = 38),
  [1068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, .production_id = 55),
  [1070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, .production_id = 55),
  [1072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, .production_id = 54),
  [1074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, .production_id = 54),
  [1076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, .production_id = 29),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, .production_id = 29),
  [1080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2),
  [1082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2),
  [1084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, .production_id = 50),
  [1086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, .production_id = 50),
  [1088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2),
  [1092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, .production_id = 14),
  [1094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, .production_id = 14),
  [1096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, .production_id = 15),
  [1098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, .production_id = 15),
  [1100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, .production_id = 3),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, .production_id = 3),
  [1104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, .production_id = 17),
  [1106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, .production_id = 17),
  [1108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [1110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [1112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [1116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [1118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [1124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [1130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [1136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_specifier, 1, .production_id = 1),
  [1138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [1140] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression, 1), SHIFT(791),
  [1144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [1146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression, 1),
  [1149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression, 1),
  [1152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [1174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [1184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [1186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [1188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [1190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [1192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .production_id = 38),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [1196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [1200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .production_id = 38),
  [1206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [1208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [1210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [1222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2),
  [1260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [1266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(886),
  [1269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1392),
  [1272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(885),
  [1275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [1277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1322),
  [1280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1237),
  [1283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(621),
  [1286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1427),
  [1289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1425),
  [1292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(622),
  [1295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(768),
  [1298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(878),
  [1301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1186),
  [1304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1084),
  [1307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1088),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [1314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1119),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [1329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1373),
  [1332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(883),
  [1335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1404),
  [1338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1216),
  [1341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [1347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [1353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2),
  [1355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1393),
  [1358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(891),
  [1361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1363),
  [1364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1228),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [1379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2),
  [1381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2),
  [1383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3),
  [1385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [1473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, .production_id = 7),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [1481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, .production_id = 7),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [1491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 31),
  [1493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 31),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [1511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, .production_id = 4),
  [1513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, .production_id = 4),
  [1515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 4),
  [1517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 4),
  [1519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [1521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 40),
  [1545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 40),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 25),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 25),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [1569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, .production_id = 64),
  [1571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, .production_id = 64),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [1591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1),
  [1593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3),
  [1595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3),
  [1597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, .production_id = 40),
  [1599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, .production_id = 40),
  [1601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, .production_id = 32),
  [1603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, .production_id = 32),
  [1605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [1607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [1609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 9),
  [1611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 9),
  [1613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [1615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [1617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4),
  [1619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [1623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [1625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [1627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3),
  [1629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3),
  [1631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 51),
  [1633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 51),
  [1635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [1637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [1639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5),
  [1641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2),
  [1647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [1655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, .dynamic_precedence = 1),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [1661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [1663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [1665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(621),
  [1668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(1427),
  [1671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(1425),
  [1674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(622),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [1705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [1707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(612),
  [1710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1),
  [1712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1),
  [1714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4),
  [1716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4),
  [1718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4),
  [1720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, .production_id = 25),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1),
  [1740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [1764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, .production_id = 72),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, .production_id = 66),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, .production_id = 48),
  [1786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .production_id = 56),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 38),
  [1796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 55),
  [1798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, .production_id = 47),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, .production_id = 59),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2),
  [1814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 48),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 28),
  [1822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 15),
  [1824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 39),
  [1826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .production_id = 38),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [1834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 33),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [1852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 33),
  [1854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 28),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .production_id = 15),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [1862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [1896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [1910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 28),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .production_id = 56),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [1920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 33),
  [1922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, .production_id = 66),
  [1924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, .production_id = 48),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 33),
  [1928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 55),
  [1930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 28),
  [1932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 38),
  [1934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .production_id = 15),
  [1936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .production_id = 38),
  [1938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 39),
  [1940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 15),
  [1942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [1944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [1946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(763),
  [1949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(821),
  [1952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1),
  [1954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [1958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [1960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 48),
  [1962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 10),
  [1964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 10),
  [1966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, .production_id = 10),
  [1968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, .production_id = 10),
  [1970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, .dynamic_precedence = 1),
  [1972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 2),
  [1974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 2),
  [1976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, .production_id = 2),
  [1978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, .production_id = 2),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [1984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [1986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [1990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [1996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [1998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [2000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [2002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [2004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [2006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [2010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 20),
  [2012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 20),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [2016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 5),
  [2018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, .production_id = 5),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [2022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, .production_id = 5),
  [2024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, .production_id = 5),
  [2026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, .production_id = 5),
  [2028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, .production_id = 5),
  [2030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [2034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1),
  [2036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 20),
  [2038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 20),
  [2040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [2088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(622),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [2105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3),
  [2107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3),
  [2109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [2125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 11),
  [2127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 11),
  [2129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4),
  [2131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4),
  [2133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 10),
  [2135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 10),
  [2137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4),
  [2139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3),
  [2143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [2151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, .production_id = 6),
  [2153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, .production_id = 6),
  [2155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, .production_id = 6),
  [2157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, .production_id = 6),
  [2159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 6),
  [2161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, .production_id = 6),
  [2163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, .production_id = 31),
  [2165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, .production_id = 31),
  [2167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2),
  [2169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2),
  [2171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 5),
  [2173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 5),
  [2175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4),
  [2177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 42),
  [2191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 42),
  [2193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3),
  [2195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3),
  [2197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, .production_id = 42),
  [2199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, .production_id = 42),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [2231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, .production_id = 4),
  [2233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, .production_id = 4),
  [2235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2),
  [2237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2),
  [2239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, .production_id = 9),
  [2241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, .production_id = 9),
  [2243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_type_specifier, 4, .dynamic_precedence = -1, .production_id = 44),
  [2245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_type_specifier, 4, .dynamic_precedence = -1, .production_id = 44),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [2255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2),
  [2257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2),
  [2259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1),
  [2261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_specifier, 1),
  [2263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_specifier, 1),
  [2265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 19),
  [2267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 19),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2),
  [2279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(791),
  [2286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 21),
  [2288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 21),
  [2290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 19),
  [2292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 19),
  [2294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 21),
  [2296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 21),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 19),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 19),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [2324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [2328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [2332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, .production_id = 33),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [2352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1),
  [2355] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(791),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 10),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [2367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 10),
  [2369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 2),
  [2371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2),
  [2373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2),
  [2375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(953),
  [2378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(952),
  [2381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, .production_id = 2),
  [2383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(948),
  [2386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [2388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [2390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [2392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [2398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1),
  [2402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1),
  [2404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_declarator_repeat1, 2),
  [2414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1427),
  [2417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(1026),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2),
  [2422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, .production_id = 30),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 3, .production_id = 30),
  [2430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4),
  [2432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, .dynamic_precedence = 1, .production_id = 27),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [2476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(789),
  [2479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, .dynamic_precedence = 1, .production_id = 70),
  [2481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, .dynamic_precedence = 1, .production_id = 45),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [2485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, .dynamic_precedence = 1, .production_id = 62),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, .dynamic_precedence = 1, .production_id = 62),
  [2491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, .dynamic_precedence = 1, .production_id = 45),
  [2493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1),
  [2495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, .dynamic_precedence = 1, .production_id = 27),
  [2497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, .production_id = 46),
  [2499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, .dynamic_precedence = -10),
  [2501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, .production_id = 71),
  [2503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, .production_id = 63),
  [2505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, .production_id = 46),
  [2507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, .dynamic_precedence = 1, .production_id = 70),
  [2509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, .dynamic_precedence = 1, .production_id = 27),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [2519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, .dynamic_precedence = 1, .production_id = 45),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [2525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, .production_id = 71),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [2533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, .production_id = 27),
  [2535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, .dynamic_precedence = 1, .production_id = 45),
  [2541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, .production_id = 46),
  [2543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, .production_id = 63),
  [2545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, .production_id = 41),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, .production_id = 30),
  [2551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, .dynamic_precedence = 1, .production_id = 70),
  [2553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, .dynamic_precedence = 1, .production_id = 27),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [2559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, .dynamic_precedence = -10),
  [2561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, .production_id = 46),
  [2563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 27),
  [2565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(582),
  [2568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2),
  [2570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(1259),
  [2573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, .dynamic_precedence = 1, .production_id = 62),
  [2575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 35),
  [2577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 65),
  [2579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3),
  [2581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, .production_id = 52),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3),
  [2587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, .production_id = 28),
  [2589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, .dynamic_precedence = -10),
  [2591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, .production_id = 71),
  [2593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, .production_id = 30),
  [2595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 12),
  [2597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [2599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, .production_id = 53),
  [2601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [2603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1),
  [2605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, .production_id = 46),
  [2607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, .production_id = 63),
  [2609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, .production_id = 1),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [2613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat2, 2, .production_id = 27),
  [2615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [2617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, .production_id = 46),
  [2619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, .production_id = 71),
  [2621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, .production_id = 46),
  [2623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 34),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [2627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1),
  [2629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2),
  [2631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, .production_id = 13),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [2635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, .production_id = 30),
  [2637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 46),
  [2639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 63),
  [2641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [2645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [2647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [2653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [2657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [2661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [2663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [2665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 49), SHIFT_REPEAT(989),
  [2668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 49),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [2680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1118),
  [2683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1118),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [2694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [2700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [2726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [2728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat2, 2, .production_id = 49), SHIFT_REPEAT(967),
  [2749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat2, 2, .production_id = 49),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [2791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(1192),
  [2794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(579),
  [2815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(591),
  [2818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [2822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, .production_id = 18),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [2826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, .production_id = 49), SHIFT_REPEAT(959),
  [2829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, .production_id = 49),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2), SHIFT_REPEAT(882),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [2858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT_REPEAT(411),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [2867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2), SHIFT_REPEAT(1217),
  [2870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, .production_id = 67),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [2880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [2882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [2886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [2888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [2890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [2896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [2898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [2902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [2904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [2908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2),
  [2910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [2912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [2914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [2918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [2920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [2922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [2924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [2926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [2928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [2930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [2932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [2934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [2940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [2942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [2944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [2946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [2948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [2950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [2952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [2954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [2956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [2958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [2964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [2970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [2972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [2974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [2986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [2996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [2998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [3000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [3002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [3004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [3016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [3018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [3022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [3024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [3026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [3028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [3030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [3032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [3036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [3040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [3042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [3048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [3054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [3068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [3070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [3074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [3076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, .production_id = 55),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [3082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [3084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [3090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [3092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [3136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [3148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, .production_id = 66),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [3160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 2),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [3178] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [3200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .production_id = 55),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [3208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, .production_id = 66),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_c(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = (const uint16_t *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
